--[[
-- Desc: 游戏内所有的基础定义
-- Date: 2016
--]]
--------------------------------------------------------- Just for mono class
Object =  UnityEngine.Object
PlayerPrefs = UnityEngine.PlayerPrefs
GameObject = UnityEngine.GameObject
Animator = UnityEngine.Animator 
Quaternion = UnityEngine.Quaternion
Mathf = UnityEngine.Mathf
EventDelegate = UnityEngine.EventDelegate
WWW = UnityEngine.WWW
Resources = UnityEngine.Resources
SpriteRenderer = UnityEngine.SpriteRenderer
LayerMask = UnityEngine.LayerMask
JSON = SimpleJSON.JSON
JSONNode = SimpleJSON.JSONNode  
JSONClass = SimpleJSON.JSONClass
Notification = pureMVC.Notification
Debug = UnityEngine.Debug

Path = System.IO.Path
String = System.String
int = System.int
float = System.float
Regex = System.Text.RegularExpressions.Regex
DateTime = System.DateTime
ArrayList = System.Collections.ArrayList

LuaBehaviour = GameFramework.LuaBehaviour
Util = GameFramework.Util
Const = GameFramework.Const
LuaHelper = GameFramework.LuaHelper
ByteBuffer = GameFramework.ByteBuffer
SortingLayer = AidSortingLayer.SortingLayer
SortRendererOrder = AidSortingLayer.SortRendererOrder
SortUIPanelDepth = AidSortingLayer.SortUIPanelDepth
SortUIWidgetDepth = AidSortingLayer.SortUIWidgetDepth
GetMaxPanelOrder = AidSortingLayer.GetMaxPanelOrder
GetMaxPanelDepth = AidSortingLayer.GetMaxPanelDepth
GetMaxWidgetDepth = AidSortingLayer.GetMaxWidgetDepth

GameDefine = gamespace.GameDefine
GameSpaceTimer = gamespace.Timer
ViewData = gamespace.ViewData
ConfigObject = gamespace.ConfigObject
AssetGetType = gamespace.AssetGetType
Logger = gamespace.Logger
AssetConst = gamespace.AssetConst
BaseModule = gamespace.BaseModule
BaseMediator = gamespace.BaseMediator
AidJson = gamespace.AidJson
ReadContentFromFile = gamespace.AidJson.readContentFromFile
WriteContentToFile = gamespace.AidJson.writeContentToFile
Facade = gamespace.ApplicationFacade.GetInstance()
GetParticleTime = AidPlayDuration.GetParticleTime
FileTool = gamespace.FileTool
MangoSdk = Ftx.MangoSdk.MangoSdk
MangoGameData = Ftx.MangoSdk.MangoGameData
PayParams = Ftx.MangoSdk.PayParams
GA = Umeng.GA
BitUtil = gamespace.BitUtil

------------------------------------------------------------LuaClass
NetManager = LuaHelper.GetNetManager();
PanelManager = LuaHelper.GetPanelManager();
LuaCallManager = LuaHelper.GetLuaCallManager();
VersionManager = LuaHelper.GetVersionManager();
AssetManager = LuaHelper.GetAssetManager();
SoundManager = LuaHelper.GetSoundManager();
LoadManager = LuaHelper.GetLoadManager();
SDKManager = LuaHelper.GetSDKManager()


------------------------------------------------------------Include
require "Third/pbc/protobuf"
require "Define/functions"

require "Game/Common/Const/AssetBundleInfo"
require "Game/Common/Const/ModuleName"
require "Game/Common/Const/Language"
require "Game/Common/Const/LoginState"
require "Game/Common/Const/LoginConst"
require "Game/Common/Const/SystemType"
require "Game/Common/Const/MVCConst"
require "Game/Common/Const/EventConst"
require "Game/Common/Const/Constants"
require "Game/Common/Const/LoadState"
require "Game/Common/Const/LayerOrder"
require "Game/Common/Const/AnimationConst"
require "Game/Common/Const/GUIState"
require "Game/Common/Const/DataPath"
require "Game/Common/Const/GlobalDefine"
require "Game/Common/Const/ConstantNames"
require "Game/Common/Const/AudioConst"
require "Game/Common/Const/DaojianConst"

require "Game/Common/BaseObject"
require "Game/Common/List"
require "Game/Common/Map"
require "Game/Common/BaseAction"
require "Game/Common/BaseView"
require "Game/Common/Bit"--ios平台，可注释该行代码id001
require "Game/Common/UILang"
require "Game/Common/StringBuffer"
require "Game/Common/Config"
require "Game/Common/Global"
require "Game/Common/Network"
require "Game/Common/Network/Service"
require "Game/Common/Network/NetListener"
require "Game/Common/UpdateHelper"
require "Game/Common/ModuleManager"
require "Game/Common/Tools/AnmtUtil"
require "Game/Common/ViewManager"
require "Game/Common/ViewUtil"
require "Game/Common/Access"

require "Game/Common/Data/ActDataProxy"
require "Game/Common/Data/AchievementDataProxy"
require "Game/Common/Data/DataManager"
require "Game/Common/Data/ExploreMapDataProxy"
require "Game/Common/Data/FBData"
require "Game/Common/Data/WordData"
require "Game/Common/Data/GameCfgDataProxy"
require "Game/Common/Data/HeroDataProxy"
require "Game/Common/Data/HeroStoryProxy"
require "Game/Common/Data/PlayerData"
require "Game/Common/Data/PropDataProxy"
require "Game/Common/Data/ProtoRegister"
require "Game/Common/Data/SignInDataProxy"
require "Game/Common/Data/SkillDataProxy"
require "Game/Common/Data/TeamData"
require "Game/Common/Data/LeagueData"
require "Game/Common/Data/RoleEquipProxy"

require "Game/Common/BaseHero"
require "Game/Common/Tools/LogicUtil"
require "Game/Common/Tools/SimpleCache"
require "Game/Common/Tools/SimpleAudio"
require "Game/Common/UI/ComCfmPanel"
require "Game/Common/UI/ComPlayerRankListPane"
require "Game/Common/UI/ComPlayerRankRow"
require "Game/Common/UI/ComShopHeroRow"
require "Game/Common/UI/ComShopPane"
require "Game/Common/UI/NumChgePanel"
require "Game/Common/UI/CfmNumChgePanel"
require "Game/Common/UI/PropShowItem"
require "Game/Common/UI/TipsClass"
require "Game/Common/UI/ActPropShow"
require "Game/Common/UI/ComAnnouncePanel"

require "Game/Fight/Logic/FightControler"
require "Game/Main/Logic/MainControler"
require "Game/FB/Logic/FBControler"
require "Game/Hero/Logic/HeroControler"
require "Game/Space/Logic/SpaceControler"
require "Game/Com/Logic/ComControler"
require "Game/FightCamp/Logic/FightCampControler"
require "Game/MyHero/Logic/MyHeroControler"
require "Game/HeroGuide/Logic/HeroGuideControler"
require "Game/BatFire/Logic/BatFireControler"
require "Game/HeroUpgrade/Logic/HeroUpgradeControler"
require "Game/HeroInherit/Logic/HeroInheritControler"
require "Game/HeroProp/Logic/HeroPropControler"
require "Game/HeroChange/Logic/HeroChangeControler"
require "Game/SortCond/Logic/SortCondControler"
require "Game/Loading/Logic/LoadingControler"
require "Game/FightFailure/Logic/FightFailureControler"
require "Game/FightVictory/Logic/FightVictoryControler"
require "Game/GM/Logic/GMControler"
require "Game/Treasure/Logic/TreasureControler"
require "Game/Lucky/Logic/LuckyControler"
require "Game/Login/Logic/LoginControler"
require "Game/Login/Logic/RegisterControler"
require "Game/Login/Logic/EnterControler"
require "Game/Login/Logic/SelectRoleControler"
require "Game/PVP/Logic/PVPControler"
require "Game/Arena/Logic/ArenaControler"
require "Game/WorldBattle/Logic/WorldBattleControler"
require "Game/SignIn/Logic/SignInControler"
require "Game/Prop/Logic/PropControler"
require "Game/Mail/Logic/MailControler"
require "Game/HeroStory/Logic/HeroStoryControler"
require "Game/Friend/Logic/FriendControler"
require "Game/Friend/Logic/FriendNoticeControler"
require "Game/League/Logic/LeagueApplyControler"
require "Game/League/Logic/LeagueJoinedControler"
require "Game/League/Logic/LeagueBadgeControler"
require "Game/League/Logic/LeagueMemberControler"
require "Game/League/Logic/LeagueNoticeControler"
require "Game/League/Logic/LeagueManagerControler"
require "Game/League/Logic/LeagueLeaderTransferControler"
require "Game/League/Logic/LeagueWealControler"
require "Game/League/Logic/LeaguePVPControler"
-- require "Game/League/Logic/LeagueRankingControler"
require "Game/League/Logic/LeaguePVPPreControler"
require "Game/League/Logic/LeaguePVPFinalControler"
require "Game/League/Logic/LeaguePVPReadyFightControler"
require "Game/League/Logic/LeaguePVPFightingControler"
require "Game/League/Logic/LeaguePVPFightOverControler"
require "Game/League/Logic/LeaguePVEControler"
require "Game/League/Logic/LeaguePVEMapControler"
require "Game/Explore/Logic/ExploreControler"
require "Game/Setting/Logic/SettingControler"
require "Game/Role/Logic/RoleControler"
require "Game/Role/Logic/RoleEquipControler"
require "Game/Shop/Logic/ShopControler"
require "Game/Guide/Logic/GuideControler"
require "Game/Achievement/Logic/AchievementControler"
require "Game/Activity/Logic/ActivityControler"
require "Game/Friend/Logic/FriendHeroInfoControler"
require "Game/MonthCard/Logic/MonthCardControler"
require "Game/Pay/Logic/PayControler"