
--单条成就
--2016-9-29 16:43:43 library

local const_getRwdWord = "领 取";
local const_curProgress = "当前进度";
local const_rwdWord = "奖励：";
local const_getSuccess = "领取成功";

local const_diamond = 1003;
local const_diamondSpriteName = "diamand";

AchievementRow = class();

--[[

]]
function AchievementRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;
    self.ctl = nil;
end

--[[

]]
function AchievementRow:Awake (_go, _ctl)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.ctl = _ctl;

    self.honorData = nil;--成就数据：HonorData,{honorId = honorId, curTarget = 0, honorSource = "", status = self.ctl.achivState.NOTCOMPLETE},etc.
    self.rowCfg = nil;--成就配置

    self:initPanel();
    self:initListener();
end

--[[

]]
function AchievementRow:initPanel ()
    self.desc = GetGameObject(self.transform, "RowInfoPanel/desc");
    self.progress = GetGameObject(self.transform, "RowInfoPanel/progress");
    self.reward = GetGameObject(self.transform, "RowInfoPanel/reward");
    self.complete = GetGameObject(self.transform, "RowInfoPanel/complete");
    self.unComplete = GetGameObject(self.transform, "RowInfoPanel/unComplete");
    self.rowBtn = GetGameObject(self.transform, "RowBtn");
    self.btnLabel = GetGameObject(self.rowBtn.transform, "Label");

    self.doneBG = GetGameObject(self.transform, "RowInfoPanel/DoneBG");
    self.undoneBG = GetGameObject(self.transform, "RowInfoPanel/UndoneBG");
    self.commonItem = GetGameObject(self.transform, "RowInfoPanel/CommonItem");
    self.propItem = GetGameObject(self.transform, "RowInfoPanel/PropItem");

    GetComponent(self.btnLabel, "UILabel").text = const_getRwdWord;
end

--[[

]]
function AchievementRow:initListener ()
    ViewUtil.AddClickEvent(self.rowBtn, function () self:getRwdFunc(); end)
end

--[[

]]
function AchievementRow:initData (_honorData)
    self.honorData = _honorData;
    self.rowCfg = AchievementDataProxy.getAchivCfgById(self.honorData.honorId);
    
    self:setPanelInfo();
    self:setRowState();
end

--[[

]]
function AchievementRow:getRwdFunc ()
    local mapData, buffer = Map.new(), nil;

    mapData:put("honorId", self.honorData.honorId);
    buffer = Network.reqParamEncode(mapData);
    NetManager:SendData(self, buffer, ServerID.Achievement_Get, nil, function (sd) self:getRwdHandle(sd, self.rowCfg); end, "", doNthFunc);
end

--[[

]]
function AchievementRow:getRwdHandle (sd, honorId)
    local defData = GetProtoTable("DefaultData", sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end
    ViewUtil.showMsg(const_getSuccess);

    self:showNextRwdInfo();

    if (PlayerData.guideNotEnd()) then
        Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
    end
end

--[[

]]
function AchievementRow:setPanelInfo ()
    local propInfo, equInfo = nil, nil;
    local layer, tab, rwdTab = 0, nil, {};

    self.gameObject.name = "AchivRow_" .. self.honorData.honorId;
    GetComponent(self.desc, "UILabel").text = AchievementDataProxy.getAchivDesc(self.rowCfg);
    GetComponent(self.progress, "UILabel").text = self:getAchivShowProgress();

    propInfo = AchievementDataProxy.getAchivProps(self.rowCfg);
    equInfo = AchievementDataProxy.getAchivEqus(self.rowCfg);
    
    self.commonItem:SetActive(false);
    self.propItem:SetActive(false);
    
    if ("0" == propInfo) then
        --奖励为解锁装备
        self.propItem:SetActive(true);
        GetPathComponent(self.propItem.transform, "Sprite", "UISprite").spriteName = equInfo;
        GetComponent(self.reward, "UILabel").text = AchievementDataProxy.getAchivReward(self.rowCfg);
    else
        --奖励为道具
        tab, layer = LogicUtil.splitStrCfgs(propInfo);
        GetComponent(self.reward, "UILabel").text = "";
        
        if (const_diamond ~= tonumber(tab[1])) then
            --非钻石
            self.propItem:SetActive(true);
            propShowItem = PropShowItem.new();
            PanelManager:BindPanelScript(propShowItem, good, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
            
            propShowItem:Awake(self.propItem, tab[1], tab[2]);
            propShowItem:Start(false);
        else
            self.commonItem:SetActive(true);
            GetPathComponent(self.commonItem.transform, "Sprite", "UISprite").spriteName = const_diamondSpriteName;
            GetPathComponent(self.commonItem.transform, "Num", "UILabel").text = tab[2] .. "";
        end
    end
end

--[[

]]
function AchievementRow:setRowState ()
    local curTar, tar = 0, 0;
    
    curTar = self.honorData.curTarget;
    tar = AchievementDataProxy.getAchivTarget(self.rowCfg);
    
    if (self.ctl.achivState.NOTCOMPLETE == self.honorData.status) then
        self.unComplete:SetActive(true);
        self.complete:SetActive(false);
        self.rowBtn:SetActive(false);
        self.doneBG:SetActive(false);
        self.undoneBG:SetActive(true);
    elseif (self.ctl.achivState.NOTGET == self.honorData.status) then
        self.unComplete:SetActive(false);
        self.complete:SetActive(false);
        self.rowBtn:SetActive(true);
        self.doneBG:SetActive(false);
        self.undoneBG:SetActive(true);
    else
        self.unComplete:SetActive(false);
        self.complete:SetActive(true);
        self.rowBtn:SetActive(false);
        self.doneBG:SetActive(true);
        self.undoneBG:SetActive(false);
    end
end

--[[

]]
function AchievementRow:getAchivShowProgress ()
    local str, curTar, showTp, target = "", 0, 0, 0;
    
    curTar = self.honorData.curTarget;
    showTp = AchievementDataProxy.getAchivShowTp(self.rowCfg);
    target = AchievementDataProxy.getAchivTarget(self.rowCfg);
    
    if (7 == showTp) then
        if (0 ~= curTar) then
            str = const_curProgress .. FBData.GetGateTitle(FBData.GetChapterId(curTar), FBData.GetHouseId(curTar));
        else
            str = const_curProgress .. "1-1";
        end
    else
        str = const_curProgress .. self.honorData.curTarget .. "/" .. target;
    end
    
    return str;
end

--[[
    显示同类型的下一条成就
]]
function AchievementRow:showNextRwdInfo ()
    local nextCfgTab = AchievementDataProxy.getShowAchivCfg(self.honorData.honorId);
    
    if (self.honorData.honorId == nextCfgTab[1]) then
        --当前成就是本类型的最高成就
        self.honorData.status = self.ctl.achivState.GOT;
        self:setRowState();
    else
        --存在更高类型的成就
        self.honorData.honorId = nextCfgTab[1];
        self.rowCfg = AchievementDataProxy.getAchivCfgById(self.honorData.honorId);
        if (self.honorData.curTarget < AchievementDataProxy.getAchivTarget(nextCfgTab[2])) then
            self.honorData.status = self.ctl.achivState.NOTCOMPLETE;
        else
            self.honorData.status = self.ctl.achivState.NOTGET;
        end
        
        self:setPanelInfo();
        self:setRowState();
    end
    LuaCallManager:invokeCall(function () 
        self:setRowState();
    end, 0.5);
    self.ctl.view:checkRedIcons();
end