--成就的View
--2016-9-29 16:37:19 library

AchievementView = class();

--[[

]]
function AchievementView:ctor ()
    self.gameObject = nil;
    self.transform = nil;
    self.ctl = nil;
end

--[[

]]
function AchievementView:Awake (_go, _name, _ctl)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.name = _name;
    self.ctl = _ctl;

    self.hmData = nil;
    self.hmDataTpMap = Map.new();--<key, value><tp, HonorData>后台传来的成就数据的map表
    self.showDataMap = Map.new();--<key, value><tp, data>需要显示的成就的map表
    self.achivList = List.new();--显示的成就

    self.baseRowGO = nil;
    self.scrollView = nil;
    self.grid = nil;

    self:initPanel();
    self:initListener();
end

--[[

]]
function AchievementView:initPanel ()
    local centerPath = "Mode/Center/Panel";
    local bottomPath = "Mode/Bottom/Panel";

    self.scrollView = GetGameObject(self.transform, centerPath .. "/AchivsPanel/ScrollView");
    self.grid = GetGameObject(self.scrollView.transform, "Panel/Grid");
    self.baseRowGO = GetGameObject(self.transform, centerPath .. "/AchivRow");
    self.baseRowGO:SetActive(false);
    self.backBtn = GetGameObject(self.transform, bottomPath .. "/backBtn");
end

--[[

]]
function AchievementView:initListener ()
    --UIEventListener.Get(self.backBtn).onClick = function () ViewUtil.openView(ModuleName.MAIN, false); end;
    ViewUtil.AddClickEvent(self.backBtn, function () ViewUtil.openView(ModuleName.MAIN, false,  function () 
                if (PlayerData.getMyGuideStep() < GuideStep.getFinalGuideStep()) then
                    Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
                end
            end); end)
end

--[[
    _hmData HonorMainData
]]
function AchievementView:initData (_hmData)
    self.hmData = _hmData;
    
    self:initHMDataTpMap();
    self:initShowDataMap();
    self:addMyRows();
end

--[[

]]
function AchievementView:initHMDataTpMap ()
    local hmDataTmp, cfg = nil, nil;
    
    self.hmDataTpMap:clear();
    
    if (self.hmData and self.hmData.honorList) then
        for i = 1, #self.hmData.honorList do
            cfg = AchievementDataProxy.getAchivCfgById(self.hmData.honorList[i].honorId);
            if (self.ctl.achivState.NOTCOMPLETE == self.hmData.honorList[i].status and self.hmData.honorList[i].curTarget >= AchievementDataProxy.getAchivTarget(cfg)) then
                self.hmData.honorList[i].status = self.ctl.achivState.NOTGET;
            end
            hmDataTmp = {honorId = self.hmData.honorList[i].honorId, showTp = AchievementDataProxy.getAchivShowTp(cfg), data = self.hmData.honorList[i]};
            self.hmDataTpMap:put(hmDataTmp.honorId, hmDataTmp);
        end
    end
end

--[[

]]
function AchievementView:initShowDataMap ()
    local hmDataTmp, sDataTmp, sDataInMap, isPut = nil, nil, nil, false;
    local fileData = Config.getAchievementData();
    local isFind = false;--isFind(是否在self.hmData.honorList中找到同ID数据)

    self.showDataMap:clear();

    for k, v in pairs(fileData) do
        isPut = false;
        isFind = false
        sDataTmp = {honorId = tonumber(k), cfg = v, status = self.ctl.achivState.NOTCOMPLETE};
        hmDataTmp = self.hmDataTpMap:value(tonumber(k));
        if (hmDataTmp) then
            isFind = true;
            sDataTmp.status = hmDataTmp.data.status;
        end
        sDataInMap = self.showDataMap:value(AchievementDataProxy.getAchivShowTp(v));
        if (sDataInMap) then
            --self.showDataMap中有同类型数据
            if (isFind) then
                --self.hmDataTpMap中有同ID数据
                if (self.ctl.achivState.NOTGET >= hmDataTmp.data.status and self.ctl.achivState.GOT == sDataInMap.status) then
                    --待存数据未领取，已存数据已领取，直接存入
                    isPut = true;
                elseif (self.ctl.achivState.NOTGET >= hmDataTmp.data.status and self.ctl.achivState.NOTGET >= sDataInMap.status and AchievementDataProxy.getAchivTarget(sDataTmp.cfg) < AchievementDataProxy.getAchivTarget(sDataInMap.cfg)) then
                    --待存数据未领取，已存数据未领取，存入target较小者
                    isPut = true;
                elseif (self.ctl.achivState.GOT == hmDataTmp.data.status and self.ctl.achivState.GOT == sDataInMap.status and AchievementDataProxy.getAchivTarget(sDataTmp.cfg) > AchievementDataProxy.getAchivTarget(sDataInMap.cfg)) then
                    --待存数据未领取，已存数据未领取，存入target较大者
                    isPut = true;
                end
            else
                --self.hmDataTpMap中没有同ID数据
                if (AchievementDataProxy.getAchivTarget(sDataTmp.cfg) < AchievementDataProxy.getAchivTarget(sDataInMap.cfg)) then
                    --将target较小的成就数据存入self.showDataMap中
                    isPut = true;
                end
            end
        else
            --self.showDataMap中没有同类型数据，直接存入self.showDataMap
            isPut = true;
        end
        if (isPut) then
            self.showDataMap:put(AchievementDataProxy.getAchivShowTp(v), sDataTmp);
        end
    end
end

--[[

]]
function AchievementView:addMyRows ()
    local sData, rowGO, aRow, hData = nil, nil, nil, nil;
    local firHonorId = 22;--新手引导用到的ID

    for i = 1, #self.achivList do
        DestroyObject(self.achivList[i].gameObject);
    end
    self.achivList:clear();
    
    for i = 1, self.showDataMap:size() do
        sData = self.showDataMap:value(self.showDataMap:key(i));
        
        rowGO = CreateObject(self.baseRowGO);
        aRow = AchievementRow.new();
        aRow:Awake(rowGO, self.ctl);
        PanelManager:BindPanelScript(aRow, rowGO, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        hData = self.hmDataTpMap:value(sData.honorId);
        
        if (nil == hData) then
            hData = {honorId = sData.honorId, curTarget = 0, honorSource = "", status = self.ctl.achivState.NOTCOMPLETE};
        else
            hData = hData.data;
            hData.honorId = sData.honorId;
        end
        
        aRow:initData(hData);
        rowGO:SetActive(true);
        self.achivList:add(aRow);
    end
    
    local rowFir, rowSec = nil, nil;
    for i = 1, #self.achivList do
        rowFir = self.achivList[i];
        for j = i + 1, #self.achivList do
            rowSec = self.achivList[j];
            if (firHonorId == tonumber(rowSec.honorData.honorId) or 
            (firHonorId ~= rowFir.honorData.honorId and rowFir.honorData.honorId > rowSec.honorData.honorId)) then
                self.achivList[i] = rowSec;
                self.achivList[j] = rowFir;
                rowFir = self.achivList[i];
            end
        end
    end
    for i = 1, #self.achivList do
        HangObject(self.achivList[i].gameObject, self.grid);
    end
    
    ResetGrid(self.grid);
    ResetScrollView(self.scrollView);
end

--[[
    检查设置小红点的显示状态
]]
function AchievementView:checkRedIcons ()
    local showIcon, aRow = false, nil;

    for i = 1, #self.achivList do
        aRow = self.achivList[i];
        if (aRow.honorData.status == self.ctl.achivState.NOTGET) then
            showIcon = true;
            break ;
        end
    end

    PlayerData.playerData.status.honor = showIcon;
    Facade:sendNotification(MVCConst.SHOWREDICON, {});
end