--2016-11-01 15:39:05 library

require "Game/Activity/View/ActTab"
require "Game/Activity/View/ActivityView"
require "Game/Activity/View/ActContentBaseBar"
require "Game/Activity/View/ActLoginRwdPane"
require "Game/Activity/View/ActArenaRwdPane"
require "Game/Activity/View/ActDiamondRwdPane"
require "Game/Activity/View/ActRedPacketRwdPane"
require "Game/Activity/View/ActExploreRwdPane"
require "Game/Activity/View/ActExchangeRwdPane"
require "Game/Activity/View/ActExchangeContentBaseBar"
require "Game/Activity/View/ActHangUpRwdPane"
require "Game/Activity/View/ActCollectRwdPane"
require "Game/Activity/View/ActFriendGiftRwdPane"
require "Game/Activity/View/ActExploreFightBossRwdPane"
require "Game/Activity/View/ActCDKeyRwdPane"

ActivityControler = {}

local this = ActivityControler;

function ActivityControler.New()
	return this
end

function ActivityControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = ActivityView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
	UpdateHelper.addUpdate(this.Update)
end

function ActivityControler.Update()
	this.view:Update()
end

function ActivityControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function ActivityControler.listNotificationInterests()
    local list = {MVCConst.ACT_CHANGE};

    return unpack(list);
end

function ActivityControler.handleNotification(note)
	local nName = note:getName();
    local nType = note:getType();
    local nBody = note:getBody();

    if (MVCConst.ACT_CHANGE == nName) then
        this.view:setActData();
        this.view:drawActTabs();
        this.view:flushCurActPane();
    end
end