--礼上加礼活动
--2016-11-22 00:00:00 iorinie

local const_rule = [[活动期间集齐“房玄龄、杜如晦、秦琼、尉迟恭”(英雄召回不会计入活动)可以领取 薛仁贵*1]]
local const_oprateSuccess = "领取成功！"

ActCollectRwdPane = class();

function ActCollectRwdPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.actId = ConstantNames.Act_CollectRwd;
end

function ActCollectRwdPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    
    self.btnObtain = nil
    self.buttonStat = 0

    self.caMain = nil; --CollectActiveMain
    self.gift = nil
    self.source = {}
    self.sourceId = {}
    self.sourceNum = {}
    self.situationObj = {}
    self.conditionId = {}
    self.conditionSpr = {}

    self.scrollView = nil
    self.grid = nil

    self:initPanel();
    self:initListener();
    self:setPropsInfo();
end

function ActCollectRwdPane:initPanel ()
    self.btnRule = GetGameObject(self.transform, "BtnRule");

    self.scrollView = GetGameObject(self.transform, "ScrollViewBG/ScrollView");
    self.grid = GetGameObject(self.scrollView.transform, "Panel/Grid");

    self.situation = GetGameObject(self.grid.transform, "Situation")
    self.rewardSprite = GetPathComponent(self.transform, "Reward", "UISprite")
    self.btnObtain = GetGameObject(self.transform, "BtnObtain")
    self.complete = GetGameObject(self.transform, "complete")
end

function ActCollectRwdPane:initListener ()
    UIEventListener.Get(self.btnRule).onPress = function (_go, _isPress) 
        if (_isPress) then
            ViewUtil.showCommonTips(self.btnRule, const_rule);
        else
            ViewUtil.removeTips();
        end
    end

    ViewUtil.AddClickEvent(self.btnObtain, function () self:getRwd() end)
end

function ActCollectRwdPane:setPropsInfo()
    local propBase = GetGameObject(self.grid.transform, "PropItemNPBase")

    local cfg = "";
    local layer, cfgTab = 0, nil;

    cfg = ActDataProxy.getActCfgById(ConstantNames.Act_CollectRwd);
    cfgTab, layer = LogicUtil.nSplitStrCfgs(cfg);
    for i = 1, #cfgTab[1][3] do
        local propTab = cfgTab[1][3][i];
        local propTmp = CreateObject(propBase);
        propTmp:SetActive(true);
        local propShowItem = ActPropShow.new();
        propShowItem:Awake(propTmp, propTab[1], propTab[2]);
        propShowItem:Start();
        HangObject(propTmp, self.grid);
        propTmp.transform.localScale = Vector3.New(1.8, 1.8, 1)
        self.conditionSpr[i] = GetPathComponent(self.grid.transform, "Situation", "UISprite")

        local pCfg = HeroDataProxy.getHeroCfgById(propTab[1])
        GetPathComponent(propTmp.transform, "BG", "UISprite").spriteName = "class"..HeroDataProxy.getHeroQuality(pCfg)
        -- local condition = ViewUtil.CreateFriendHeroes(cfgTab[1][3][i][1], self.grid)
        -- GetPathComponent(condition.transform, "", "BoxCollider2D").enabled = false
        self.situationObj[i] = CreateObject(self.situation)
        self.situationObj[i]:SetActive(true)

        HangObject(self.situationObj[i], propTmp)
        self.situationObj[i].transform.localPosition = Vector3.New(0, -57, 0)
    end

    ResetScrollView(self.scrollView);
    ResetGrid(self.grid);

    
    local cfg = HeroDataProxy.getHeroCfgById(cfgTab[1][4][1][1])
    self.rewardSprite.spriteName = HeroDataProxy.getHeroAtlasName(cfg)
end

function ActCollectRwdPane:request ()
    local mapData, buf = nil, nil;

    mapData = Map.new();
    mapData:put("id", ConstantNames.Act_CollectRwd);
    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.Act_Collect_Ety, nil, function (sd) self:setData(sd); end, nil, doNthFunc);
end

function ActCollectRwdPane:setData (_sd)
    self.conditionId = {"14042", "14043", "14045", "14046"}

    self.caMain = GetProtoTable("CollectActiveMain", _sd);

    self.buttonStat = self.caMain.gifts
    self:setButton(self.buttonStat)

    local tempData = StrSplit(self.caMain.source, ";");

    for i = 1, #tempData do
        if  tempData[i]~="" then  
            self.source[StrSplit(tempData[i], "=")[1]] = tonumber(StrSplit(tempData[i], "=")[2]);
        end
    end

    for i = 1, #self.conditionId do
        if self.source[self.conditionId[i]] ~= nil then
            GetComponent(self.situationObj[i].transform, "UISprite").spriteName = "act_CollectYes"
        end
    end
end

function ActCollectRwdPane:getRwd ()
    local mapData, buf = Map.new(), nil;
    
    mapData:put("id", ConstantNames.Act_CollectRwd);
    mapData:put("step", 0)

    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.Act_Collect_Get, nil, function (sd) self:getRwdHandle(sd); end, nil ,doNthFunc)
end

function ActCollectRwdPane:getRwdHandle (_sd)
    local defData = nil;
    defData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end

    ViewUtil.showMsg(const_oprateSuccess);

    self.buttonStat = 1
    self:setButton(self.buttonStat)
end

function ActCollectRwdPane:setButton(_val)
    if tonumber(_val) == 0 then
        return
    else
        self.btnObtain:SetActive(false)
        self.complete:SetActive(true)
    end
end