--神将相送活动
--2016-11-22 00:00:00 iorinie

local const_exchangeStr = "消耗     *1可兑换：";
local const_progressStr = "拥有道具个数：";
local const_oprateSuccess = "操作成功";
local const_rule = [[活动期间，在“兄弟不多怎么赢？”活动中可以获得“贤士令”和“英雄令”，可兑换以下奖励；每个英雄只能兑换一次，请挑选自己心仪的英雄兑换吧！（活动结束后兑换道具将清零，请及时兑换）]]

ActExchangeRwdPane = class();

--[[
    
]]
function ActExchangeRwdPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.actId = ConstantNames.Act_ExchangeRwd;
end

--[[

]]
function ActExchangeRwdPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.btnRule = nil;
    self.grid = nil;
    self.contentBase = nil;
    self.scrollBG = nil;
    self.scrollView = nil;

    self.rowLuaList = List.new();
    self.eaMain = nil; --ExchangeActiveMain
    self.obtainCount = {}
    self:initPanel();
    self.curCallIdx = -1

    self:initListener();
    self:setPropsInfo();
end

--[[

]]
function ActExchangeRwdPane:initPanel ()
    self.scrollBG = GetGameObject(self.transform, "ScrollViewBG");
    self.btnRule = GetGameObject(self.transform, "BtnRule");
    self.scrollView = GetGameObject(self.scrollBG.transform, "Scroll View");
    self.grid = GetGameObject(self.scrollBG.transform, "Scroll View/Panel/Grid");
    self.contentBase = GetGameObject(self.grid.transform, "ContentBase");
end

--[[

]]
function ActExchangeRwdPane:initListener ()
    UIEventListener.Get(self.btnRule).onPress = function (_go, _isPress) 
        if (_isPress) then
            ViewUtil.showCommonTips(self.btnRule, const_rule);
        else
            ViewUtil.removeTips();
        end
    end
end

function ActExchangeRwdPane:setPropsInfo ()
    local cfg = "";
    local layer, cfgTab = 0, nil;
    local contentTmp, acbBar = nil, nil;

    cfg = ActDataProxy.getActCfgById(ConstantNames.Act_ExchangeRwd);
    cfgTab, layer = LogicUtil.nSplitStrCfgs(cfg);

    for i = 1, #cfgTab do
        contentTmp = CreateObject(self.contentBase);
        contentTmp:SetActive(true);
        acbBar = ActExchangeContentBaseBar.new();
        acbBar:Awake(contentTmp);
        PanelManager:BindPanelScript(acbBar, contentTmp, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        acbBar:setData(cfgTab[i], function (_data) self:getRwd(_data); end);
        self.rowLuaList:add(acbBar);
        HangObject(contentTmp, self.grid);
    end
    ResetScrollView(self.scrollView);
    ResetGrid(self.grid);
end

function ActExchangeRwdPane:request ()
    local mapData, buf = nil, nil;

    mapData = Map.new();
    mapData:put("id", ConstantNames.Act_ExchangeRwd);
    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.Act_Exchange_Ety, nil, function (sd) self:setData(sd); end, nil, doNthFunc);
end

--[[

]]
function ActExchangeRwdPane:setData (_sd) 
    self.eaMain = GetProtoTable("ExchangeActiveMain", _sd);
    self.obtainCount = StrSplit(self.eaMain.source, ",")

    for i = 1, #self.rowLuaList do
        rowLua = self.rowLuaList[i];
        rowLua.state = tonumber(self.obtainCount[i]);
        rowLua:setCondition(rowLua.data[2][1][1]);
        local num = PropDataProxy.getPropNumByPropId(rowLua.data[2][1][1])
        rowLua:setProgress(const_progressStr .. num);
        rowLua:setBtn();
    end
end

function ActExchangeRwdPane:getRwd (_data)
    local mapData, buf = Map.new(), nil;
    
    mapData:put("id", ConstantNames.Act_ExchangeRwd);
    mapData:put("step", _data[1][1][1])
    buf = Network.reqParamEncode(mapData);
    self.curCallIdx = _data[1][1][1] + 1

    NetManager:SendData(self, buf, ServerID.Act_Exchange_Get, nil, function (sd) self:getRwdHandle(sd); end, nil ,doNthFunc)
end

--[[

]]
function ActExchangeRwdPane:getRwdHandle (_sd)
    local defData = nil;

    defData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return;
    end

    ViewUtil.showMsg(const_oprateSuccess);

    if (-1 ~= self.curCallIdx) then
        rowLua = self.rowLuaList[self.curCallIdx];
        rowLua.state = 1;
        rowLua:setBtn();
        error(self.curCallIdx)
        local num = PropDataProxy.getPropNumByPropId(rowLua.data[2][1][1])
        if self.curCallIdx <= 3 then
            for i = 1, 3 do                   
                self.rowLuaList[i]:setProgress(const_progressStr .. num)
            end
        elseif self.curCallIdx <= 6 then
            for i = 1, 3 do  
                self.rowLuaList[i + 3]:setProgress(const_progressStr .. num)
            end
        end
        self.curCallIdx = -1;
    end
end