--好友送礼领奖
--2016-10-27 16:38:01 library

local const_loginStr = "好友送礼 {1} 次";
local const_progressStr = "进度：";
local const_oprateSuccess = "操作成功";
local const_rule = "在活动期间，好友送礼次数满足需求，可获得我们献上的奖励";

ActFriendGiftRwdPane = class();

--[[

]]
function ActFriendGiftRwdPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;
    self.scrollBGBase = nil;
    self.scrollBG = nil;

    self.actId = ConstantNames.Act_FriendGiftRwd;
end

--[[

]]
function ActFriendGiftRwdPane:Awake (_go, _scrollBG)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.scrollBGBase = _scrollBG;

    self.btnRule = nil;
    self.grid = nil;
    self.contentBase = nil;
    self.rowLuaList = List.new();--领取条Lua列表
    self.scrollView = nil;

    self.aaMain = nil;--ArenaActiveMain
    self.curCallIdx = -1;
    self:initPanel();
    self:initListener();
    self:setPropsInfo();
end


--[[

]]
function ActFriendGiftRwdPane:initPanel ()
    self.scrollBG = CreateObject(self.scrollBGBase);
    self.scrollBG:SetActive(true);
    HangObject(self.scrollBG, self.gameObject);
    self.scrollBG.transform.localPosition = Vector3.New(0, 28, 0);
    self.btnRule = GetGameObject(self.transform, "BtnRule");
    self.scrollView = GetGameObject(self.scrollBG.transform, "Scroll View");
    self.grid = GetGameObject(self.scrollBG.transform, "Scroll View/Panel/Grid");
    self.contentBase = GetGameObject(self.grid.transform, "ContentBase");
end

--[[

]]
function ActFriendGiftRwdPane:initListener ()
    UIEventListener.Get(self.btnRule).onPress = function (_go, _isPress) 
        if (_isPress) then
            ViewUtil.showCommonTips(self.btnRule, const_rule);
        else
            ViewUtil.removeTips();
        end
    end;
end

--[[

]]
function ActFriendGiftRwdPane:setPropsInfo ()
    local cfg = "";
    local layer, cfgTab = 0, nil;
    local contentTmp, acbBar = nil, nil;

    cfg = ActDataProxy.getActCfgById(ConstantNames.Act_FriendGiftRwd);
    cfgTab, layer = LogicUtil.nSplitStrCfgs(cfg);

    for i = 1, #cfgTab do
        contentTmp = CreateObject(self.contentBase);
        contentTmp:SetActive(true);
        acbBar = ActContentBaseBar.new();
        acbBar:Awake(contentTmp);
        PanelManager:BindPanelScript(acbBar, contentTmp, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        acbBar:setData(cfgTab[i], function (_data) self:getRwd(_data); end);
        self.rowLuaList:add(acbBar);
        HangObject(contentTmp, self.grid);
    end
    ResetScrollView(self.scrollView);
    ResetGrid(self.grid);
end

--[[

]]
function ActFriendGiftRwdPane:request ()
    local mapData, buf = nil, nil;

    mapData = Map.new();
    mapData:put("id", ConstantNames.Act_FriendGiftRwd);
    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.Act_FriendGift_Ety, nil, function (sd) self:setData(sd); end, nil, doNthFunc);
end

--[[

]]
function ActFriendGiftRwdPane:setData (_sd)
    local gifts = nil;
    local rowLua = nil;
    
    self.aaMain = GetProtoTable("ArcFightActiveMain", _sd);
    gifts = StrSplit(self.aaMain.gifts, ",");
    for i = 1, #self.rowLuaList do
        rowLua = self.rowLuaList[i];
        rowLua.curDay = self.aaMain.count;
        rowLua.state = tonumber(gifts[i]);
        rowLua:setCondition(string.gsub(const_loginStr, "{1}", rowLua.data[2][1][1]));
        rowLua:setProgress(const_progressStr .. rowLua.curDay .. "/" .. rowLua.data[2][1][1]);
        rowLua:setBtn();
    end
end

--[[

]]
function ActFriendGiftRwdPane:getRwd (_data)
    local mapData, buf = Map.new(), nil;
    
    mapData:put("id", ConstantNames.Act_FriendGiftRwd);
    mapData:put("step", _data[1][1][1]);
    buf = Network.reqParamEncode(mapData);
    self.curCallIdx = _data[1][1][1] + 1;

    NetManager:SendData(self, buf, ServerID.Act_FriendGift_Get, nil, function (sd) self:getRwdHandle(sd); end, nil ,doNthFunc)
end

--[[

]]
function ActFriendGiftRwdPane:getRwdHandle (_sd)
    local defData = nil;
    local rowLua = nil;

    defData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end

    ViewUtil.showMsg(const_oprateSuccess);

    if (-1 ~= self.curCallIdx) then
        rowLua = self.rowLuaList[self.curCallIdx];
        self.curCallIdx = -1;
        rowLua.state = 1;
        rowLua:setBtn();
    end
end