--挂机有礼活动
--2016-11-22 00:00:00 iorinie

local const_oprateSuccess = "领取成功！"

local const_rule = [[1. 活动期间在每大关的第一、二关卡中挂机会获得古代字帖，打开后随机获得 “群、英、荟、萃”四个字中的一个……
2. 每天集齐一套<群英荟萃>可以兑换一个“大唐英雄包”(一天只能兑换一次)，英雄包打开随机可以获得“秦琼、尉迟恭、房玄龄、杜如晦、魏征”中的一个。
3. 每天24点系统会进行重置，将当日的活动道具清零。
]]

ActHangUpRwdPane = class();

function ActHangUpRwdPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.actId = ConstantNames.Act_HangUpRwd;
end

function ActHangUpRwdPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    
    self.propItemNPBaseNum = {}
    self.propItemId = {}
    self.btnObtain = nil
    self.complete = nil
    self.eaMain = nil; --ExchangeActiveMain
    self.buttonStat = 0
    self.num = {}

    self:initPanel();
    self:initListener();
    self:setPropsInfo();
end

function ActHangUpRwdPane:initPanel ()
	self.btnRule = GetGameObject(self.transform, "BtnRule");

    self.scrollView = GetGameObject(self.transform, "ScrollViewBG/ScrollView");
    self.grid = GetGameObject(self.scrollView.transform, "Panel/Grid");
    for i = 1, 4 do
        self.propItemNPBaseNum[i] = GetPathComponent(self.grid.transform, "PropItemNPBase_"..i.."/Label", "UILabel")
    end
    self.propItemId[1] = 2066
    self.propItemId[2] = 2067
    self.propItemId[3] = 2068
    self.propItemId[4] = 2069

    self.reward = GetGameObject(self.transform, "Reward")
    self.btnObtain = GetGameObject(self.transform, "BtnObtain")
    self.complete = GetGameObject(self.transform, "complete")
end

function ActHangUpRwdPane:initListener ()
    UIEventListener.Get(self.btnRule).onPress = function (_go, _isPress) 
        if (_isPress) then
            ViewUtil.showCommonTips(self.btnRule, const_rule);
        else
            ViewUtil.removeTips();
        end
    end

    ViewUtil.AddClickEvent(self.btnObtain, function () self:getRwd() end)
end

function ActHangUpRwdPane:setPropsInfo()
    for i = 1, 4 do
        local const_num = "{1}/1"
        self.num[i] = PropDataProxy.getPropNumByPropId(self.propItemId[i])
        const_num = string.gsub(const_num, "{1}", self.num[i])
        self.propItemNPBaseNum[i].text = const_num
    end

    local propShowItem = PropShowItem.new();
    propShowItem:Awake(self.reward, 2070, 1);
    propShowItem:Start();
end

function ActHangUpRwdPane:request ()
    local mapData, buf = nil, nil;

    mapData = Map.new();
    mapData:put("id", ConstantNames.Act_HangUpRwd); --本活动id传给后台，使用神将相送ServerID的规则

    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.Act_Exchange_Ety, nil, function (sd) self:setData(sd); end, nil, doNthFunc);
end

function ActHangUpRwdPane:setData (_sd)
    self.eaMain = GetProtoTable("ExchangeActiveMain", _sd);
    self.buttonStat = tonumber((string.gsub(self.eaMain.source, ",", "", 1)))
    self:setButton(self.buttonStat)
end

function ActHangUpRwdPane:getRwd ()
    local mapData, buf = Map.new(), nil;
    
    mapData:put("id", ConstantNames.Act_HangUpRwd);
    mapData:put("step", 0)
    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.Act_Exchange_Get, nil, function (sd) self:getRwdHandle(sd); end, nil ,doNthFunc)
end

function ActHangUpRwdPane:getRwdHandle (_sd)
    local defData = nil;
    defData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end

    ViewUtil.showMsg(const_oprateSuccess);

    self.buttonStat = 1
    self:setButton(self.buttonStat)
    
    for i = 1, 4 do
        local const_num = "{1}/1"
        self.num[i] = self.num[i] - 1
        const_num = string.gsub(const_num, "{1}", self.num[i])
        self.propItemNPBaseNum[i].text = const_num
    end
end

function ActHangUpRwdPane:setButton(_val)
    if _val == 0 then
        return
    else
        self.btnObtain:SetActive(false)
        self.complete:SetActive(true)
    end
end