require "Game/Arena/View/ArenaView"
 
ArenaControler = {}

local this = ArenaControler

function ArenaControler.New()
	return this
end

function ArenaControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = ArenaView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	UpdateHelper.addUpdate(this.Update)

	this.request()
end

function ArenaControler.Awake()
end

function ArenaControler.Start()
end

function ArenaControler.Update()
	this.view:Update()
end

function ArenaControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function ArenaControler.initListener()
end

function ArenaControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function ArenaControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function ArenaControler.request()
	Network.SendMoData(ServerID.Arena, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("ArenaMainData", session)
		this.accept(mo)
	end, {})
end

function ArenaControler.accept(data)
	ViewUtil.initData(this, data)
end
