
local const_comPlayerRankListPaneStr = "UI/ComPlayerRankListPane";
local const_comShopPane = "UI/ComShopPane";

ArenaView = class(BaseView)

 function ArenaView:ctor()
end  

function ArenaView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.lastChallengeTimes = PVPControler.getMaxChallengeTimesAR()
	self.arTime = 0

    self.rankMask = nil;

	self:initPanel()
end

function ArenaView:Start(data)
	self:initData(data)
end

function ArenaView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)

	local topPath = "Mode/Top/Panel"
	self.scvBG = GetGameObject(self.transform, topPath.."/ScrollBG")
	self.scvObj = GetGameObject(self.transform, topPath.."/ScrollBG/ScrollView")
	self.scvBGSpr = GetComponent(self.scvBG.transform, "UISprite")
	self.gridObj = GetGameObject(self.scvObj.transform, "Panel/Grid")
	self.uiGrid = GetComponent(self.gridObj.transform, "UIGrid")
	self.challengeTimes = GetPathComponent(self.transform, topPath.."/InfoBG/ChallengeTimes", "UILabel")
	self.challengeCD = GetPathComponent(self.transform, topPath.."/InfoBG/ChallengeCD", "UILabel")
	self.rankReward = GetPathComponent(self.transform, topPath.."/InfoBG/RankReward", "UILabel")
	self.rankNum = GetPathComponent(self.transform, topPath.."/InfoBG/RankingNum", "MeshWord")
	self.btnInfo = GetGameObject(self.transform, topPath.."/InfoBG/BtnInfo")
	self.sprInfo = GetGameObject(self.transform, topPath.."/InfoBG/BtnInfo/Normal")
	self.fightValue = GetPathComponent(self.transform, topPath.."/InfoBG/FightValue", "MeshWord")
    self.btnRanking = GetGameObject(self.transform, "Mode/Bottom/Panel/BtnRanking");
    self.btnExchange = GetGameObject(self.transform, "Mode/Bottom/Panel/BtnExchange");

	ViewUtil.adaptUISize(self.scvBG, true, 126, 96, 20, 20)
	ViewUtil.adaptUISize(self.scvObj, false, 126, 96, 20, 20)
		
	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")
	
	self.drawer = CreateObjectByPath("UI/DrawerAR", AssetBundleInfo.assetBundles)
	self.animDrawer = GetComponent(self.drawer.transform, "UIPlayAnimation")
	HangObject(self.drawer, self.sprInfo)
	self.drawer.transform.localPosition = Vector3.New(20, -40, 0)
	ViewUtil.sortLayerOrder(self.drawer, LayerName.UI)

    local function doClick(obj)
		if obj == self.btnBack then
			ViewUtil.openView(ModuleName.PVP)
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
		elseif obj == self.btnInfo then
			self.showTips = (not self.showTips) and true or false
			self.animDrawer:Play(self.showTips)

			if (not (GuideControler and GuideControler.isGuideShowing())) then
				self.fullScreenPane = ViewUtil.showScreenMask()
				GetPathComponent(self.fullScreenPane.transform, "BG", "UISprite").spriteName = "alpha"
				ViewUtil.AddClickEvent(self.fullScreenPane, function () 
					self.showTips = (not self.showTips) and true or false
	                self.animDrawer:Play(self.showTips)
	                DestroyObject(self.fullScreenPane);

	                if (PlayerData.guideNotEnd()) then
	                    Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
	                end
	            end)
			end

			if (PlayerData.guideNotEnd()) then
                if (GuideControler and GuideControler.isGuideShowing()) then
			        self.animDrawer:Play(not self.showTips);
                end
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
        elseif obj == self.btnRanking then
        	self:getRank();
        elseif obj == self.btnExchange then
        	self:getShop();

	        if (PlayerData.guideNotEnd()) then
	        	Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
	        end
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnInfo).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnInfo, doClick)
	ViewUtil.AddClickEvent(self.btnRanking, doClick)
	ViewUtil.AddClickEvent(self.btnExchange, doClick)

    -- UIEventListener.Get(self.btnRanking).onClick = function () 
    --     self:getRank();
    -- end
    -- UIEventListener.Get(self.btnExchange).onClick = function ()
    --     self:getShop();

    --     if (PlayerData.guideNotEnd()) then
    --     	Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
    --     end
    -- end
	
--    local function doDrawer(tbl)
--		if tbl.eType == EventConst.onPress then
--			self.animDrawer:Play(true)
--		elseif tbl.eType == EventConst.onRelease then
--			self.animDrawer:Play(false)
--		end
--	end
--	ViewUtil.AddEventTrigger(self.btnInfo, EventConst.onPress, doDrawer, {eType = EventConst.onPress})
--	ViewUtil.AddEventTrigger(self.btnInfo, EventConst.onRelease, doDrawer, {eType = EventConst.onRelease})

end

--[[

]]
function ArenaView:getRank ()
    local mapData, buf = Map.new(), nil;

    buf = Network.reqParamEncode(mapData);
    NetManager:SendData(self, buf, ServerID.ArenaRank, nil, function (sd) self:showRank(sd); end, nil, doNthFunc);
end

--[[

]]
function ArenaView:showRank (_sd)
    local arMain = nil;--ArenaRankMain
    local comRankPane = CreateObject(Util.LoadPrefab(const_comPlayerRankListPaneStr, AssetBundleInfo.assetBundles));
    local cprlPane = ComPlayerRankListPane.new();

    arMain = GetProtoTable("ArenaRankMain", _sd);
    self.rankMask = ViewUtil.showScreenMask(nil, nil, doNthFunc, 1, "ArenaRank");
    ViewUtil.sortLayerOrder(self.rankMask, LayerName.Top);
    HangObject(comRankPane, ViewUtil.getRootView());
    cprlPane:Awake(comRankPane);
    cprlPane:setData(arMain.ranks, function () self:clearRankPane(); end);
    ViewUtil.sortLayerOrder(comRankPane, LayerName.Top);
end

--[[

]]
function ArenaView:clearRankPane ()
    if (nil ~= self.rankMask) then
        DestroyObject(self.rankMask);
        self.rankMask = nil;
    end
end

--[[

]]
function ArenaView:getShop ()
    local mapData, buf = Map.new(), nil;

    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.ShopPkEty, nil, function (sd) self:shopHandle(sd);end, nil, doNthFunc);
end

--[[

]]
function ArenaView:shopHandle (sd)
    local mData = nil;--PVPShopMainData
    local csPane = CreateObject(Util.LoadPrefab(const_comShopPane, AssetBundleInfo.assetBundles));
    local csPaneLua = nil;
    
    mData = GetProtoTable("PVPShopMainData", sd);
	HangObject(ViewUtil.CreateShadeView(function(args)end), csPane)
    HangObject(csPane, self.gameObject);
    csPaneLua = ComShopPane.new();
    csPaneLua:Awake(csPane);
    csPaneLua:setData(mData.propList, doNthFunc, doNthFunc);
    PanelManager:BindPanelScript(csPaneLua, csPane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    ViewUtil.sortLayerOrder(csPane, LayerName.Dialog);
end

function ArenaView:Update()
	self.sumTime = Time.timeSinceLevelLoad
	if not self.preTime or self.preTime <= 0 then
		self.preTime = self.sumTime
	end
	local deltaTime = self.sumTime - self.preTime
	self.preTime = self.sumTime

	self.arTime = self.arTime - deltaTime
	self.challengeCD.text = Time2String(self.arTime)
end

function ArenaView:initData(data)
	if IsEmpty(data) then return end
	self.fightValue.text = tostring(LogicUtil.getShowNum(TeamData.GetPower()))
	
	self.ownData = data.myArena
	self.rivalList = data.fightList
	if IsEmpty(self.rivalList) then return end
	
	self.lastChallengeTimes = self.lastChallengeTimes - (tonumber(self.ownData.count) or 0)
	if self.lastChallengeTimes < 0 then self.lastChallengeTimes = 0 end
	self.arTime = tonumber(self.ownData.lockTime) or 0

	self.challengeTimes.text = self.lastChallengeTimes
	self.challengeCD.text = Time2String(self.arTime)
	self.rankReward.text = data.rankHonorCount
	self.rankNum.text = self.ownData.rank
	
	local size = CountTable(self.rivalList)
	self.btns = {}
    local function doClick2(obj)
		if self.arTime <= 0 then
			Network.SendMoData(ServerID.Arena, {}, function(session, params)
				local serviceId = tonumber(session.serviceId)
				local mo = GetProtoTable("ArenaMainData", session)
				self.arTime = tonumber(self.ownData.lockTime) or 0
			end, {})
		else
			ViewUtil.showMsg("挑战冷却时间未结束")
		end
		for i, btn in pairs(self.btns) do
			if obj == btn then
				if self.lastChallengeTimes <= 0 then
					ViewUtil.showMsg("挑战次数不足")
					return
				end
				local infoRival = self.rivalList[i]
				if not IsEmpty(infoRival) then
					Network.ReqArenaPK(infoRival.rank, infoRival.teamId, self.ownData.rank)
                    if (PlayerData.guideNotEnd()) then
                        Facade:sendNotification(MVCConst.GUIDE_SAVEGUIDE, {});
                    end
				end
			end
		end
	end
	for i = 1, size do
		local teamId = self.rivalList[i].teamId
		if teamId ~= PlayerData.GetRoleTeamId() then
			local obj = CreateObject(Util.LoadPrefab("UI/BarHeroFight", AssetBundleInfo.assetBundles))
			HangObject(obj, self.gridObj)
			ViewUtil.addDragScrollView(obj)
			ViewUtil.sortLayerOrder(obj, LayerName.UI)
			local heroName = GetPathComponent(obj.transform, "HeroName", "UILabel")
			heroName.text = self.rivalList[i].teamName
			local fightValue = GetPathComponent(obj.transform, "FightValue", "UILabel")
			fightValue.text = self.rivalList[i].ability.power
			local rankNum = GetPathComponent(obj.transform, "RankNum", "UILabel")
			rankNum.text = self.rivalList[i].rank
		
			self.uiGrid:AddChild(obj.transform)
			self.btns[i] = GetGameObject(obj.transform, "Btn")
			--UIEventListener.Get(self.btns[i]).onClick = doClick2
			ViewUtil.AddClickEvent(self.btns[i], doClick2)
		end
	end
	ResetGrid(self.gridObj)
	ResetScrollView(self.scvObj)
end
