require "Game/BatFire/Logic/BatFirePerHero"
require "Game/BatFire/Logic/BFPerSkill"
require "Game/BatFire/View/BatFireView"
require "Game/BatFire/View/BatFireHerosRow"
 
BatFireControler = {}

local const_heroPieces = "解雇将获得 {1} 时空碎片";
local const_noHeroSlted = "未选中英雄";

local this = BatFireControler

function BatFireControler.New()
	return this
end

function BatFireControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = BatFireView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject, this)
    this.initListener()
end

function BatFireControler.Awake()
end

function BatFireControler.Start()
	this.view:Start(this.data)
end

function BatFireControler.Update()
    
end

function BatFireControler.OnDestroy()
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function BatFireControler.initListener()
    UIEventListener.Get(this.view.btnFire).onClick = this.fireHeros;
    UIEventListener.Get(this.view.batBtnFire).onClick = this.fireAllHeros;
end

--[[
    解雇英雄
    return nil
]]
function BatFireControler.fireHeros ()
    if (this.view.fireHeroIdsList:getSize() <= 0) then
        ViewUtil.showMsg(const_noHeroSlted);
        return ;
    end

    local function fireOKFun()
        local fireStr, sendMap, len, bufData = "", Map.new(), this.view.fireHeroIdsList:getSize(), nil;
    
        for i = 1, len do
            fireStr = fireStr .. this.view.fireHeroIdsList[i];
            if (i ~= len) then
                fireStr = fireStr .. ",";
            end
        end
    
        sendMap:add(1, fireStr);
        if (len > 0) then
            bufData = Network.reqParamEncode(sendMap);
            NetManager:SendData(this, bufData, ServerID.BatFire_FireHero, nil, function (sd) this.fireHandle(sd); end, "", doNthFunc);
        end
    end

    ViewUtil.comCfmPanel(string.gsub(const_heroPieces, "{1}", this.view:getFirePropsNum()), function () fireOKFun(); end);
end

--[[

]]
function BatFireControler.fireAllHeros ()
    if (this.view.batFireBtnStatus) then
        this.view:cancelAllHerosFire();
    else
        this.view:fireAllHeros();
    end
    this.view.batFireBtnStatus = not this.view.batFireBtnStatus;
    this.view:setBatFireBtnWord();
end

--[[
    解雇英雄回调
    sd 
    return nil
]]
function BatFireControler.fireHandle (sd)
    local defData = nil;
    
    defData = GetProtoTable("DefaultData", sd);

    if (0 ~= defData.code) then
         ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end

    this.view:fireSuc();
end

function BatFireControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function BatFireControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function BatFireControler.accept(data)
	ViewUtil.initData(this, data)
end