
local const_fireWord = "解 雇";
local const_batFireWord = "英雄解雇";
local const_cancelWord = "取消全部";
local const_myPieceWord = "我的时空碎片:";
local const_pieceWord = "时空碎片：{1}";
local COLNUM = 5;
local ROWNUM = 5;

BatFireView = class(BaseView)

function BatFireView:ctor()
    
end  

function BatFireView:Awake(obj, _ctl)
	self.gameObject = obj
	self.transform = obj.transform
    self.ctl = _ctl;

    self.moduleTitle = nil;
    self.scvBasePos = nil;--Vector3，ScrollView第一次初始化后的localPosition
    self.panelClipOffset = nil;--Vector2，ScrollView的UIPanel第一次初始化后的clipOffset

    self.btnFire = nil;--解雇按钮
    self.batBtnFire = nil;--批量解雇按钮

    self.myHeros = nil;--我的所有英雄数据
    self.herosGOList = List.new();--存在的英雄GO列表
    self.curSltHeroId = 0;--当前选择的英雄的唯一ID
    self.fireHeroIdsList = List.new();--缓存解雇英雄Id列表
    self.skillList = List.new();--技能列表
    self.skillSlt = nil;--技能选中框
    self.fireSlt = nil;--选中解雇图标
    self.wrapContent = nil;
    self.uiWrapContent = nil;
    self.grid = nil;

    self.batFireBtnStatus = false;--批量解雇按钮的状态，false，批量解雇，true，全部取消

    self:initMyHeroData();
    self:sortMyHeros();
    self:initPanel();
--    self:addMyHeros();
    self:addHerosToSclView();
    self:showCurInfo();
    self:showHeroNum();
end

function BatFireView:Start(data)
	self:initData(data)
end

--[[
    初始化我的英雄数据
    return nil
]]
function BatFireView:initMyHeroData ()
    local myHerosTmp, heroTmp, hCfgTmp = nil, nil, nil;

    if (nil == self.myHeros) then
        self.myHeros = List.new();
    end

    self.myHeros:clear();
    myHerosTmp = TeamData.getMyHeros();
    
    for k, v in pairs(myHerosTmp) do
        --主角英雄不能解雇，也不显示
        if (
            1 ~= tonumber(v.heroId) and 
            2 ~= tonumber(v.heroId) and 
            0 == self:heroFireState(v.id)
        ) then
            hCfgTmp = HeroDataProxy.getHeroCfgById(v.heroId);
            heroTmp = {v, hCfgTmp};
            self.myHeros:add(heroTmp);
        end
    end
end

--[[
    对我的英雄数据排序
    return nil
]]
function BatFireView:sortMyHeros ()
    local hDataFir, hCfgFir, hDataSec, hCfgSec = nil, nil;
    local tmp = 0;

    for i = 1, self.myHeros:getSize() do
        hDataFir = self.myHeros[i][1];
        hCfgFir = self.myHeros[i][2];
        for j = i + 1, self.myHeros:getSize() do
            hDataSec = self.myHeros[j][1];
            hCfgSec = self.myHeros[j][2];
            
            if (HeroDataProxy.getHeroQuality(hCfgFir) < HeroDataProxy.getHeroQuality(hCfgSec) or
                (HeroDataProxy.getHeroQuality(hCfgFir) == HeroDataProxy.getHeroQuality(hCfgSec) and hDataFir.heroId > hDataSec.heroId)) then
                self.myHeros[i] = self.myHeros[j];
                self.myHeros[j] = {hDataFir, hCfgFir};
                hDataFir = self.myHeros[i][1];
                hCfgFir = self.myHeros[i][2];
            end
        end
    end
end

function BatFireView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)

	local topPath = "Mode/Top/Panel"
    self.moduleTitle = GetGameObject(self.transform, topPath.."/Head/Title");
	self.scvBG = GetGameObject(self.transform, topPath.."/HeroListBG")
	self.scvObj = GetGameObject(self.transform, topPath.."/HeroListBG/ScrollView")
	self.fireSlt = GetGameObject(self.transform, topPath .. "/HeroListBG/HeroFireSlt");
    self.wrapContent = GetGameObject(self.scvObj.transform, "WrapContent");
    self.uiWrapContent = GetComponent(self.wrapContent, "UIWrapContent");
    self.grid = GetComponent(self.wrapContent, "UIGrid");
    self.heroNum = GetPathComponent(self.transform, topPath.."/HeroAmount", "UILabel")
    
    GetComponent(self.moduleTitle, "UILabel").text = const_batFireWord;

	ViewUtil.adaptUISize(self.scvBG, true, 40, 320, 20, 20)
	ViewUtil.adaptUISize(self.scvObj, false, 140, 320, 20, 20)
	
	local bottomPath = "Mode/Bottom/Panel"

    self.btnFire = GetGameObject(self.transform, bottomPath .. "/BtnFire");
    self.heroName = GetGameObject(self.transform, bottomPath .. "/HeroInfo/HeroName");
    self.heroLvl = GetGameObject(self.transform, bottomPath .. "/HeroInfo/HeroLvl");
    self.perHeroPiece = GetGameObject(self.transform, bottomPath .. "/perHeroPiece");
    self.myPieceInfo = GetGameObject(self.transform, bottomPath.."/myPieceInfo");
    self.myPieceLabel = GetGameObject(self.myPieceInfo.transform, "Label");

    GetComponent(self.myPieceLabel, "UILabel").text = const_myPieceWord;

    for i = 1, ROWNUM do 
        self.herosGOList:add(GetGameObject(self.wrapContent.transform, "HerosRow_" .. (i - 1)));
    end

    --四维
    self.descProp1 = GetGameObject(self.transform, bottomPath .. "/Description/Prop1");
    self.descProp2 = GetGameObject(self.transform, bottomPath .. "/Description/Prop2");
    self.descProp3 = GetGameObject(self.transform, bottomPath .. "/Description/Prop3");
    self.descProp4 = GetGameObject(self.transform, bottomPath .. "/Description/Prop4");

    --技能
    self.skillSlt = GetGameObject(self.transform, bottomPath .. "/SkillBoardBG/skillSlt");
    self.skill1 = GetGameObject(self.transform, bottomPath .. "/SkillBoardBG/Skill1");
    self.skill2 = GetGameObject(self.transform, bottomPath .. "/SkillBoardBG/Skill2");
    self.skill3 = GetGameObject(self.transform, bottomPath .. "/SkillBoardBG/Skill3");
    self.skill4 = GetGameObject(self.transform, bottomPath .. "/SkillBoardBG/Skill4");
    self.skill5 = GetGameObject(self.transform, bottomPath .. "/SkillBoardBG/Skill5");
    self.skillList:add(self.skill1);
    self.skillList:add(self.skill2);
    self.skillList:add(self.skill3);
    self.skillList:add(self.skill4);
    self.skillList:add(self.skill5);

 	self.btnBack = GetGameObject(self.transform, bottomPath .. "/BtnBack");
    self.batBtnFire = GetGameObject(self.transform, bottomPath .. "/BtnAllUP");
    self.batBtnFire:SetActive(false);--根据需求，该按钮屏蔽 2016-10-15 10:13:49 library

    --技能名称、等级、强化、觉醒
    self.heroSkill = GetGameObject(self.transform, bottomPath .. "/HeroInfo/HeroSkill");
    self.heroIntensify = GetGameObject(self.transform, bottomPath .. "/HeroInfo/HeroIntensify");
    self.heroWiseup = GetGameObject(self.transform, bottomPath .. "/HeroInfo/HeroWiseup");
    self.heroFightValue = GetGameObject(self.transform, bottomPath.."/HeroInfo/HeroFightValue")
    self.skillContent = GetGameObject(self.transform, bottomPath .. "/Description/Content");

    local function doClick(obj)
		if obj == self.btnBack then
			self:closeView(true)
		end
    end
    ViewUtil.AddClickEvent(self.btnBack, doClick)
    GetPathComponent(self.btnFire.transform, "Label", "UILabel").text = const_fireWord;

    self:setBatFireBtnWord();
    self:refreshMyPieceNum();
end

--[[

]]
function BatFireView:setBatFireBtnWord ()
    if (self.batFireBtnStatus) then
        GetPathComponent(self.batBtnFire.transform, "Label", "UILabel").text = const_cancelWord;
    else
        GetPathComponent(self.batBtnFire.transform, "Label", "UILabel").text = const_batFireWord;
    end
end

--[[

]]
function BatFireView:addHerosToSclView (_tp)
    local useCnt = math.ceil(self.myHeros.size / COLNUM);
    
    _tp = _tp or 0;

    if (self.uiWrapContent) then
        self.uiWrapContent.maxIndex = 0;
        self.uiWrapContent.minIndex = 1 - useCnt;
    end
    
    if (useCnt >= ROWNUM) then
        self.uiWrapContent.enabled = true;

        self.uiWrapContent.onInitializeItem = function (_go, _index, _realIndex)
            self:showMyHeros(_go, _realIndex);
        end
    else
        if (self.uiWrapContent) then
            self.uiWrapContent.enabled = false;
        end
        DestroyObject(self.uiWrapContent);
        self.uiWrapContent = nil;
        for i = 1, useCnt do
            self:showMyHeros(self.herosGOList[i], 1 - i);
        end
    end
    useCnt = useCnt + 1;
    for i = useCnt, ROWNUM do
        for j = 0, self.herosGOList[i].transform.childCount - 1 do
            self.herosGOList[i].transform:GetChild(j).gameObject:SetActive(false);
        end
    end
    if (0 == _tp) then
        local lPos = self.scvObj.transform.localPosition;
        local coSet = GetComponent(self.scvObj, "UIPanel").clipOffset;
        self.scvBasePos = Vector3.New(0, lPos.y, lPos.z);
        self.panelClipOffset = Vector2.New(coSet.x, coSet.y);
    end
--    ResetGrid(self.wrapContent);
    ResetScrollView(self.scvObj);
end

--[[

]]
function BatFireView:showMyHeros (_go, _realIndex)
    local luaBhvi, hRows, idx, len, hIdx = nil, nil, 0, 0, 0;
    local listTmp = List.new();
    
    luaBhvi = GetComponent(_go.transform, "LuaBehaviour");
    
    if (luaBhvi) then
        hRows = luaBhvi.sourceLuaObj;--BatFireHerosRow
    end

    if (null == hRows) then
        hRows = BatFireHerosRow.new();
        hRows:Awake(_go, self.fireSlt, function (idTmp, isFire) 
            self:fireListCtl(idTmp, isFire); 
            self.curSltHeroId = idTmp;
            self:showHeroDetail();
            self:showPerHeroPieces(self.curSltHeroId);
        end, self.ctl);
        PanelManager:BindPanelScript(hRows, _go, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end

    len = self.myHeros.size;
    idx = - _realIndex + 1;
    for i = 1, COLNUM do
        hIdx = (idx - 1) * COLNUM + i;
        if (0 < hIdx and hIdx <= len) then
            listTmp:add({self.fireHeroIdsList:contains(self.myHeros[hIdx][1].id), self.myHeros[hIdx][1], self.myHeros[hIdx][2]});
        else
            break ;
        end
    end
    hRows:setData(listTmp);
end

--[[
    计算并显示当前英雄信息：
    第一次显示时，显示第一个英雄
    删除后显示时，显示当前选中的英雄位置（删除前）及之后第一个未被删除的英雄信息
    return nil
]]
function BatFireView:showCurInfo ()
    local curSltHeroIdx, nextIdx = 0, 0;
    local showHeros = List.new();
    
    for i = 1, self.myHeros:getSize() do
        if (0 == self:heroFireState(self.myHeros[i][1].id)) then
            showHeros:add(self.myHeros[i]);
        end
    end
    
    for i = 1, showHeros:getSize() do
        --当前英雄的索引
        if (0 == curSltHeroIdx and self.curSltHeroId == showHeros[i][1].id) then
            curSltHeroIdx = i;
        end;
        --当前英雄位置及以后第一个未被删除的英雄索引
        if (0 ~= curSltHeroIdx and not self.fireHeroIdsList:contains(showHeros[i][1].id)) then
            nextIdx = i;
            break ;
        end
    end
    
    if (0 == curSltHeroIdx) then
        --首次进入页面显示第一个英雄的信息
        if (showHeros:getSize() > 0) then
            self.curSltHeroId = showHeros[1][1].id;
        else
            self.curSltHeroId = 0;
        end
    elseif (0 == nextIdx) then
        --当前位置及以后的英雄都被删除
        self.curSltHeroId = 0;
        for i = curSltHeroIdx, 1, -1 do
            if (not self.fireHeroIdsList:contains(showHeros[i][1].heroId)) then
                self.curSltHeroId = showHeros[i][1].id;
                break ;
            end
        end
    elseif (self.fireHeroIdsList:contains(self.curSltHeroId)) then
        self.curSltHeroId = showHeros[nextIdx][1].id;
    end
    
    self:showHeroDetail();
end

--[[
    显示英雄的详细信息
    return nil
]]
function BatFireView:showHeroDetail ()
    local curHCfg, curHData, perSkill, luaBhvr = nil, nil, nil, nil;
    local skillCnt, skillsLen = 0, 0;
    local skills = nil;
    
    if (0 ~= self.curSltHeroId) then
        curHData = TeamData.getMyHeroDataById(self.curSltHeroId);
        curHCfg = HeroDataProxy.getHeroCfgById(curHData.heroId);
        GetComponent(self.heroName, "UILabel").text = HeroDataProxy.getHeroName(curHCfg);
        GetComponent(self.heroLvl, "UILabel").text = "" .. HeroDataProxy.getHeroShowLvl(curHData.level, curHData.wiseup);
        GetComponent(self.heroIntensify, "UILabel").text = tostring(curHData.strengthen);
        GetComponent(self.heroWiseup, "UILabel").text = tostring(curHData.wiseup);
        GetComponent(self.heroFightValue, "UILabel").text = HeroDataProxy.getHeroAbility(curHData.heroId, curHData.level, curHData.wiseup, curHData.strengthen)
        GetComponent(self.descProp1, "UILabel").text = HeroDataProxy.getHeroXG(curHCfg);
        GetComponent(self.descProp2, "UILabel").text = HeroDataProxy.getHeroFY(curHCfg);
        GetComponent(self.descProp3, "UILabel").text = HeroDataProxy.getHeroSB(curHCfg);
        GetComponent(self.descProp4, "UILabel").text = HeroDataProxy.getHeroWZ(curHCfg);

        skills = SkillDataProxy.getHeroSkills(curHCfg);
        skillsLen = #skills;
        
        if (skillsLen > 0) then
            self.skillSlt:SetActive(true);
        else
            self.skillSlt:SetActive(false);
        end

        for i = 1, self.skillList:getSize() do
            luaBhvr = GetComponent(self.skillList[i], "LuaBehaviour");
            if (nil ~= luaBhvr) then
                DestroyObject(luaBhvr);
            end
            if (skillsLen >= i) then
                perSkill = BFPerSkill.new();
                perSkill:Awake(self.skillList[i], skills[i], function (_sId, _sCfg, _pos) 
                    self:setSkillSltPos(_pos);
                    self:showSkillInfo(_sId, _sCfg); 
                end);
                PanelManager:BindPanelScript(perSkill, self.skillList[i], doNthFunc, doNthFunc, doNthFunc, doNthFunc);
                GetPathComponent(self.skillList[i].transform, "Sprite", "UISprite").spriteName = SkillDataProxy.getSkillIcon(perSkill.skillCfg);
                GetComponent(self.skillList[i].transform, "UIButton").normalSprite = SkillDataProxy.getSkillIcon(perSkill.skillCfg);
                if (1 == i) then
                    self:setSkillSltPos(self.skillList[i].transform.localPosition);
                    self:showSkillInfo(perSkill.skillId, perSkill.skillCfg);
                end
            else 
                GetPathComponent(self.skillList[i].transform, "Sprite", "UISprite").spriteName = "";
                GetComponent(self.skillList[i].transform, "UIButton").normalSprite = "";
            end
        end
    else
        GetComponent(self.heroName, "UILabel").text = "";
        GetComponent(self.heroLvl, "UILabel").text = "";
        GetComponent(self.heroIntensify, "UILabel").text = "";
        GetComponent(self.heroWiseup, "UILabel").text = "";
        GetComponent(self.heroFightValue, "UILabel").text = "";
        GetComponent(self.descProp1, "UILabel").text = "";
        GetComponent(self.descProp2, "UILabel").text = "";
        GetComponent(self.descProp3, "UILabel").text = "";
        GetComponent(self.descProp4, "UILabel").text = "";
        self.skillSlt:SetActive(false);
        GetComponent(self.heroSkill, "UILabel").text = "";
        GetComponent(self.skillContent, "UILabel").text = "";
        for i = 1, self.skillList:getSize() do
            GetPathComponent(self.skillList[i].transform, "Sprite", "UISprite").spriteName = "";
            GetComponent(self.skillList[i].transform, "UIButton").normalSprite = "";
        end
    end
end

--[[

]]
function BatFireView:setSkillSltPos (_pos)
    self.skillSlt.transform.localPosition = _pos;
end

--[[
    技能信息显示
]]
function BatFireView:showSkillInfo (sId, sCfg)
    GetComponent(self.heroSkill, "UILabel").text = SkillDataProxy.getSkillName(sCfg);
    GetComponent(self.skillContent, "UILabel").text = SkillDataProxy.getSkillDesc(sCfg);
end

--[[
    同步解雇列表
    _id number
    _isFire number
    return nil
]]
function BatFireView:fireListCtl (_id, _isFire)
    if (1 == _isFire) then
        if (not self.fireHeroIdsList:contains(_id)) then
            self.fireHeroIdsList:add(_id);
        end
    else
        if (self.fireHeroIdsList:contains(_id)) then
            self.fireHeroIdsList:remove(_id);
        end
    end
end

--[[
    解雇成功之后的数据、视图处理
    return nil
]]
function BatFireView:fireSuc ()
    local fireLen, allHeroLen = self.fireHeroIdsList:getSize(), self.myHeros:getSize();
    local fireIdTmp, heroTmp, heroGOTmp = 0, nil, nil;
    local luaBhvr, bfPerHero = nil, nil;
    
    for i = fireLen, 1, -1  do
        fireIdTmp = self.fireHeroIdsList[i];
        
        for j = allHeroLen, 1, -1 do
            heroTmp = self.myHeros[j];

            if (heroTmp[1].id == fireIdTmp) then
                self.myHeros:removeAt(j);
                HeroDataProxy.removeMyHero(heroTmp[1].id);
                allHeroLen = self.myHeros:getSize();
                break ;
            end
        end
    end
    
    self:showCurInfo();
    self.fireHeroIdsList:clear();
    self:showHeroNum();
    self:refreshMyPieceNum();
    self:resetWrapContent();
end

--[[

]]
function BatFireView:resetWrapContent ()
    ResetScrollView(self.scvObj);
    LuaCallManager:invokeCall(function () 
        local pane = nil;

        self:addHerosToSclView(1);
        if (self.uiWrapContent) then
            self.uiWrapContent:SortBasedOnScrollMovement();
        end

        pane = GetComponent(self.scvObj, "UIPanel");
        self.scvObj.transform.localPosition = self.scvBasePos;
        pane.clipOffset = self.panelClipOffset;

        LuaCallManager:invokeCall(function () 
            pane.clipOffset = Vector2.New(0, pane.clipOffset.y - 0.005);
        end, 0.03);
        LuaCallManager:invokeCall(function () 
            pane.clipOffset = Vector2.New(0, pane.clipOffset.y + 0.005);
            ResetScrollView(self.scvObj);
        end, 0.06);
    end, 0.1);
end

--[[
    解雇所有英雄
    return nil
]]
function BatFireView:fireAllHeros ()
    local heroTmp, luaBhvr, bfPerHero = nil, nil, nil;
    
    self.fireHeroIdsList:clear();

    for i = 1, #self.myHeroGOList do
        heroTmp = self.myHeroGOList[i];
        luaBhvr = GetComponent(heroTmp, "LuaBehaviour");
        if (nil ~= luaBhvr) then
            bfPerHero = luaBhvr.sourceLuaObj;
            if (0 == self:heroFireState(bfPerHero.heroData.id)) then
                --非阵容的英雄可以解雇
                bfPerHero:showSlt(true);
                self.fireHeroIdsList:add(bfPerHero.heroData.id);
            end
        end
    end
end

--[[
    取消所有的解雇英雄
]]
function BatFireView:cancelAllHerosFire ()
    local heroTmp, luaBhvr, bfPerHero = nil, nil, nil;
    
    self.fireHeroIdsList:clear();

    for i = 1, #self.myHeroGOList do
        heroTmp = self.myHeroGOList[i];
        luaBhvr = GetComponent(heroTmp, "LuaBehaviour");
        if (nil ~= luaBhvr) then
            bfPerHero = luaBhvr.sourceLuaObj;
            if (bfPerHero) then
                bfPerHero:showSlt(false);
            end
        end
    end
end

--[[
    是否可以解雇英雄
    _id number 英雄的唯一ID
    return number 0，可以；1，不可以--阵容中
]]
function BatFireView:heroFireState (_id)
    local fireState, curHeros, heroIds = 0, nil, "";
    
    for i = 1, #PlayerData.playerData.team.heroIndexs do
        curHeros = PlayerData.playerData.team.heroIndexs[i];
        heroIds = curHeros.heroIds;
        heroIds = "," .. heroIds .. ",";
        if (nil ~= string.find(heroIds, "," .. _id .. ",")) then
            fireState = 1;
            break ;
        end
    end

    return fireState;
end

--[[

]]
function BatFireView:showHeroNum ()
    local herosInfo = CopyTable(PlayerData.getHeroList());
    local curNum, totalNum = CountTable(herosInfo), GameCfgDataProxy.getMaxHeroNumPerTeam();

    self.heroNum.text = "" .. curNum .. "/" .. totalNum;
end

--[[
    计算解雇可获得的碎片数量
    return number 
]]
function BatFireView:getFirePropsNum ()
    local num = 0;
    local id, heroId = 0, 0;
    local hCfg = nil;

    for i = 1, #self.fireHeroIdsList do
        id = self.fireHeroIdsList[i];
        heroId = TeamData.getMyHeroDataById(id).heroId;
        num = num + GameCfgDataProxy.getPieceNumByFireHero(heroId);
    end

    return num;
end

--[[
    刷新显示我的碎片数量
]]
function BatFireView:refreshMyPieceNum ()
    GetComponent(self.myPieceInfo, "UILabel").text = PropDataProxy.getPropNumByPropId(1061);
end

--[[
    显示单个英雄被解雇时可以获得的碎片数量
    _id number onlyId
]]
function BatFireView:showPerHeroPieces (_id)
    local heroId = TeamData.getMyHeroDataById(_id).heroId;
    local num = GameCfgDataProxy.getPieceNumByFireHero(heroId);
    
    GetComponent(self.perHeroPiece, "UILabel").text = string.gsub(const_pieceWord, "{1}", num);
end

function BatFireView:initData(data)
	if IsEmpty(data) then return end
end