require "Game/Com/Logic/ComNotiHandle"
require "Game/Com/View/ComView"
 
ComControler = {}

local this = ComControler

function ComControler.New()
	return this
end

function ComControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = ComView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	UpdateHelper.addUpdate(this.Update)
	
	ViewUtil.sortLayerOrder(this.gameObject, LayerName.Broadcast)
end

function ComControler.Awake()
end

function ComControler.Start()
	this.view:Start(this.data)
--    this.goGuide();
end

-- ñӰ
function ComControler.SetShadow(show)
	if this.view ~= nil then
		this.view:SetShadow(show)
	end
end

function ComControler.Update()
	this.view:Update()
end

function ComControler:OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function ComControler.initListener()
end

function ComControler.listNotificationInterests()
    local list = {
        MVCConst.ON_RECV_DATA,
        MVCConst.UPDATE_MNY,
        MVCConst.SHOWREDICON
    }
    return unpack(list)
end

function ComControler.handleNotification(notification)
    local notiName = notification:getName();
    local notiBody = notification:getBody();
    local notyType = notification:getType();

    ComNotiHandle.setComCtl(this);
    ComNotiHandle.receiveNoti(notification);
end

function ComControler.getComView()
    return this.view
end

--[[
    _callBack Function
]]
--function ComControler.ShadowEvt(_callBack)
--	if this.view ~= nil then
--		this.view:ScreenShadowEvt(_callBack);
--	end
--end

function ComControler.accept(data)
	ViewUtil.initData(this, data)
end


--[[

]]
function ComControler.goGuide ()
    local guide, ctner, guideState = nil, nil, nil;
    
    if (PlayerData.guideNotEnd()) then
        guide = FindObject("UIRoot/GuideMain(Clone)");
        ctner = GetGameObject(guide.transform, "Container");
        
        if (nil ~= ctner) then
            local function pcallFunc ()
                if (
                    10105 == FBData.GetCurGateId() and FBData.IsPassedGate(10105, 1) or 
                    10201 == FBData.GetCurGateId() and FBData.IsPassedGate(10201, 1) or 
                    10203 == FBData.GetCurGateId() and FBData.IsPassedGate(10203, 1)
                ) then
                    guideState = 0;
		            LuaCallManager:invokeCall(function () 
		                Facade:sendNotification(MVCConst.GUIDE_NEXT, {[1] = 0}, guideState);
		            end, 0.5);
--                    else
--                        guideState = 0;
--		                LuaCallManager:invokeCall(function () 
--		                    Facade:sendNotification(MVCConst.GUIDE_NEXT, {[1] = 0}, guideState);
--		                end, 0.5);
                end
            end
            if (pcall(pcallFunc)) then
                    
            end
        end
    end
end