--[[
-- Desc: Ϊ
-- Author: kenny
-- Date: 2016
--]]
BaseAction = class()
 
function BaseAction:ctor()
	self.skillId = nil							-- ID
	self.actionId = nil							-- ΨһΪID
	self.indexId = nil							-- ǰķֽID
	self.actionType = nil					-- Ϊ
	self.actionExtra = nil					-- Ϊչ
	self.beginCond = {0, 0}				-- Լʼʱ, {0, 0}Ϊʼ
	self.endCond = {0, 0}					-- Լʱ, endCond[1]==0ʱʾʱendCond[2]ΪlastTime
	self.actionMasterType = 0			-- Ϊ
	self.isGroup = false						-- ΪǷȺ
	self.isClone = false						-- ΪǷ¡
	self.actionMaster = {}					-- ΪID
	self.scaleSize = 1.0						-- Ϊű
	self.startPositionType = 0			-- Ĭû; 1: ԣ 2: ԣ 3: Զ
	self.startPosition = TranPosition("0, 0, 0")
	self.aimPositionType = 0				-- Ĭû; 1: ԣ 2: ԣ 3: Զ
	self.aimPosition = TranPosition("0, 0, 0")
	
	self.began = false						-- ʼ״̬
	self.busy = false							-- æµ״̬
	self.ended = false						-- ״̬
	self.beginTime = 0						-- ʵʵĿʼʱ
	self.endTime = 0							-- ʵʵĽʱ
	self.beginParent = nil					-- ʼĸaction
	self.endParent = nil						-- ĸaction
	self.children = nil							-- Ϊaction
	
	self.camp = Camp.Neutrality		-- ĬӪ(Server)
	self.teamSide = TeamSide.Left	-- Ĭվλ(Client)
	self.otherSide = 3-self.teamSide	-- һ
	self.onlyIdList = {}						-- ΪΨһID
	self.actorList = nil						-- ߼
	self.actionObjectList = nil			-- Renderer
	self.viewParent = nil					-- UIRoot
	self.custom = false						-- ǷԶ
	self.destIndexId = 0						-- ĿindexId, Ĭself
	self.onlyIdList = {}						-- ΪΨһID
	self.skillOnlyIds = {}						-- ǰӢ
	self.isActorEnd = false					-- رAction
end

-- жǷΪ
function BaseAction:isActionMasterType()
	if IsMember(self.actionMasterType, ActionMasterType) then
		return true
	end
	return false
end

-- ΪΨһID
function BaseAction:addOnlyId(onlyId)
	if not IsEmpty(onlyId) then
		table.insert(self.onlyIdList, onlyId)
	end
end

function BaseAction:getActionId()
	return self.actionId
end
function BaseAction:setActionId(actionId)
	self.actionId = actionId
end

function BaseAction:getIndexId()
	return self.indexId
end
function BaseAction:setIndexId(indexId)
	self.indexId = indexId
end

function BaseAction:getBeginParent()
	return self.beginParent
end
function BaseAction:setBeginParent(beginParent)
	self.beginParent = beginParent
end

function BaseAction:getEndParent()
	return self.endParent
end
function BaseAction:setEndParent(endParent)
	self.endParent = endParent
end

function BaseAction:getChildren()
	return self.children
end
function BaseAction:addChild(indexId)
	if not indexId then return end
	if not self.children then
		self.children = List:new()
	end
	self.children:add(indexId)
end

function BaseAction:getBeginCondition()
	return self.beginCond
end
function BaseAction:setBeginCondition(c1, c2)
	if not IsNumber(c1) or not IsNumber(c2) then
		return
	end
	self.beginCond = {c1, c2}
end

function BaseAction:getEndCondition()
	return self.endCond
end
function BaseAction:setEndCondition(c1, c2)
	if not IsNumber(c1) or not IsNumber(c2) then
		return
	end
	self.endCond = {c1, c2}
end

function BaseAction:getBeginTime()
	return self.beginTime
end
function BaseAction:setBeginTime(time)
	self.beginTime = time
end

function BaseAction:getEndTime()
	return self.endTime
end
function BaseAction:setEndTime(time)
	self.endTime = time or Time.timeSinceLevelLoad -- Time.time
end

function BaseAction:getDeltaTime()
	return self.endTime - self.beginTime
end

function BaseAction:isBegan()
    return self.began
end

function BaseAction:isBusy()
    return self.busy
end

function BaseAction:isEnded()
    return self.ended
end

-- ʼ
function BaseAction:onBegin()
	self.began = true
	local time = Time.timeSinceLevelLoad -- Time.time
	self:setBeginTime(time)
--	plog("Action["..self.camp.."]["..self.actionId.."] ["..self.indexId.."] onBegin => "..time)

	-- ԼܷǶΪ
	if self.actionMasterType == ActionMasterType.EnemyHeros then
		self.startPosition.x = -self.startPosition.x
	end
	-- ʼΪ
	FightControler.initActionActorList(self)

	-- ʼλ:Ҫ
	self:initPosition()
end

-- ִ
function BaseAction:doAction()
	self.busy = true
end

-- 
function BaseAction:onEnd()
	self.ended = true
	local time = Time.timeSinceLevelLoad -- Time.time
	self:setEndTime(time)
--	plog("Action["..self.camp.."]["..self.actionId.."] ["..self.indexId.."] onEnd => "..time)
end

-- ж
function BaseAction:onSequence()
end

function BaseAction:getActors()
	return self.actorList
end
function BaseAction:addActor(actor)
	if IsEmpty(actor) then
		return
	end
	if IsEmpty(self.actorList) then
		self.actorList = List.new()
	end
	self.actorList:add(actor)
end

function BaseAction:getActionObjects()
	return self.actionObjectList
end
function BaseAction:addActionObject(object)
	if self.actionObjectList == nil then
		self.actionObjectList = List.new()
	end
	self.actionObjectList:add(object)
end

-- ʼʼλãҪдķ(overwrite)
function BaseAction:initPosition()
	if self.actionType == ActionType.ActorCtrl then
		return
	end

	if self.startPositionType == PositionType.Custom then
		local standType = math.abs(tonumber(self.startPosition.x) or StandType.HeroArea)
		local destAeraPosDic = GeneratePositions(standType, self.teamSide, #self.skillOnlyIds)
	
		local posIndex = tonumber(self.startPosition.y) or 0
		if self.startPosition.y == 0 then
			posIndex = 1
		end
		if not posIndex or posIndex < 1 or posIndex > CountTable(destAeraPosDic) then
			posIndex = 1
		end
		local destPos = destAeraPosDic[posIndex]
		if destPos ~= nil then
			self.startPosition.x = destPos.x
			self.startPosition.y = destPos.y
		end
	end

	if self.aimPositionType == PositionType.Custom then
		local standType = math.abs(tonumber(self.aimPosition.x) or StandType.HeroArea)
		local destAeraPosDic = GeneratePositions(standType, self.teamSide, #self.skillOnlyIds)
	
		local posIndex = tonumber(self.aimPosition.y) or 0
		if self.aimPosition.y == 0 then
			posIndex = 1
		end
		if not posIndex or posIndex < 1 or posIndex > CountTable(destAeraPosDic) then
			posIndex = 1
		end
		local destPos = destAeraPosDic[posIndex]
		if destPos ~= nil then
			self.aimPosition.x = destPos.x
			self.aimPosition.y = destPos.y
		end
	end
end

function BaseAction:getPositionRandom()
	local curPos = Vector3.zero
	if self.actionObjectList and self.actionObjectList.size > 0 then
		local body = RandomMember(self.actionObjectList)
		if body ~= nil and body.transform ~= nil then
			curPos = body.transform.localPosition or Vector3.zero
		end
	end
	return curPos
end

function BaseAction:getPositionRelative(object, deltaPos)
	local deltaPos = deltaPos or Vector3.zero
	local ret = deltaPos
	if typeofClass(object, Actor) then				-- Actor class
		ret = object:getPosition() + deltaPos
	elseif object and object.transform then		-- GameObject
		ret = object.transform.localPosition + deltaPos
	end
	return ret
end

-- GameObject
function BaseAction:scaleObjectSize(renderer)
	if not renderer then return end
	if self.scaleSize > 0 and self.scaleSize ~= 1 then
		renderer.transform.localScale = Vector3(self.scaleSize, self.scaleSize, self.scaleSize)
	end
end

-- ParticleObject
function BaseAction:scaleParticleSize(objcet)
	if not objcet then return end
	if self.scaleSize > 0 and self.scaleSize ~= 1 then
		local aps = objcet:GetComponent(AidParticleScaler.GetClassType())
		if aps ~= nil then
			aps:ScaleParticleSize(self.scaleSize)
		end
	end
end
