BaseHero = class()
 
function BaseHero:ctor()
end

function BaseHero:init()
	self.heroObj = nil
	self.prefabName = nil
	self.quality = nil
    self.heroId = nil;
end

function BaseHero:createHero(prefabHero)
	self.heroObj = CreateObject(Util.LoadPrefab(prefabHero, AssetBundleInfo.assetBundles))
	self:refreshHero()
	return self.heroObj
end

function BaseHero:refreshHero(notName)
	if not self.heroObj then return end
	if not notName then
		self.heroObj.name = self.prefabName or "NoName"
	end
	ViewUtil.sortLayerOrder(self.heroObj, LayerName.UI)
	if not IsEmptyString(self.prefabName) then
		local spr = GetPathComponent(self.heroObj.transform, "Sprite", "UISprite")
		spr.spriteName = self.prefabName
		--增加战力显示 by iorinie
		local fightNumObj = nil;
		local fightNum = nil;
		fightNumObj = GetGameObject(self.heroObj.transform, "FightNum");
		if (nil ~= fightNumObj) then
			fightNum = GetComponent(fightNumObj.transform, "UILabel")
		end
		if nil ~= fightNum and self.heroId ~= nil and self.level ~= nil and self.wiseup ~= nil and self.strengthen ~= nil then
			fightNum.text = LogicUtil.getShowNum(HeroDataProxy.getHeroAbility(self.heroId, self.level, self.wiseup, self.strengthen))
		end
	end
	if self.quality ~= nil then
		self.quality = tonumber(self.quality) or 0
		if self.quality > 0 and self.quality < 7 then
			local spr = GetComponent(self.heroObj.transform, "UIButton")
			spr.normalSprite = "class"..self.quality
		end
	end
end

--[[
    ÉèÖÃÓ¢ÐÛµÄÊý¾Ý
    _hCfg HeroCfg
    _heroId number
]]
function BaseHero:setData (_hCfg, _heroId)
    self.prefabName = HeroDataProxy.getHeroAtlasName(_hCfg);
    self.quality = HeroDataProxy.getHeroQuality(_hCfg, _lvl, _wiseup, _stnthn);
    self.heroId = _heroId;
end

function IsAHero(obj)
	if obj and obj.name ~= nil and
		obj.name ~= "NoName" and
		obj.name ~= "NoUsed" and
		obj.name ~= "Empty"
	then
		return true
	end
	return false
end
