local _class = {}
function class(_super)
	local class_type = {}
	class_type.ctor = false
	class_type._super = _super
	class_type.new = function(...) 
		local obj = {}
		do
			local create
			create = function(c, ...)
				if c._super then
					create(c._super, ...)
				end
				if c.ctor then
					c.ctor(obj, ...)
				end
			end
			create(class_type, ...)
		end
		local meta = {__index = _class[class_type], cls_type = class_type}
		setmetatable(obj, meta)
		obj.super = _class[_super]
		return obj
	end

	local vtbl = {}
	_class[class_type] = vtbl
 
	setmetatable(class_type, {__newindex =
		function(t, k, v)
			vtbl[k] = v
		end
		, cls_type = _super
	})
 
	if _super then
		setmetatable(vtbl, {__index =
			function(t, k)
				local ret = _class[_super][k]
				vtbl[k] = ret
				return ret
			end
		})
	end

	return class_type
end

function getClass()
	return _class
end

 -- 基类
BaseObject = class()

function BaseObject:ctor()	-- 定义 BaseClass 的构造函数
	--logDebug("Object ctor")
end

function BaseObject:toString()
	--logDebug("[Object toString]")
end
