--[[
-- Desc: 视图基类
-- Author: kenny
-- Date: 2016
--]]
BaseView = class()
        
function BaseView:ctor()
	self.root = ViewUtil.getRootView()		-- UIRoot
	self.name = nil										-- ModuleName
	self.showShade = true							-- 显示阴影遮挡, 默认遮挡
	self.shadeOpacity = false					-- 设置阴影不透明, 默认透明
end

function BaseView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
end

function BaseView:Start(data)
	self:initData(data)
end

function BaseView:OnFocus(preMod)
end

function BaseView:initPanel()
end

function BaseView:initData(data)
end

function BaseView:closeView(openLastView)
	ViewUtil.closeView(self.name, openLastView)
end
