
Config = {
    const_type = "type";
}

local this = Config;

local g_filenames = {
	[1] = "Configs/skills.json",
	[2] = "Configs/actions.json",
	[3] = "Configs/positions.json",
	[4] = "Configs/fb.json",
	[5] = "Configs/heros.json",
	[6] = "Configs/hero_level.json",    --英雄升级强化表
	[7] = "Configs/gates.json",
	[8] = "Configs/open_conditions.json",
	[9] = "Configs/props.json",
    [10] = "Configs/heroStory.json",
    [11] = "Configs/languages.json",
    [12] = "Configs/random_names.json",
    [13] = "Configs/gameConfig.json",
    [14] = "Configs/gameDrop.json",
    [15] = "Configs/Achievement.json",
    [16] = "Configs/npc_boss.json",
    [17] = "Configs/explore_produce.json",
    [18] = "Configs/explore_prop.json",
    [19] = "Configs/explore_map.json",
    [20] = "Configs/equips.json",
    [21] = "Configs/payment.json"
}

local g_skills_data = DecodeJsonFile(g_filenames[1])
local g_actions_data = DecodeJsonFile(g_filenames[2])
local g_positions_data = DecodeJsonFile(g_filenames[3])
local g_fb_data = DecodeJsonFile(g_filenames[4])
local g_heros_data = DecodeJsonFile(g_filenames[5])
local g_heroLvlup_data = DecodeJsonFile(g_filenames[6]);
local g_gates_data = DecodeJsonFile(g_filenames[7])
local g_conditions_data = DecodeJsonFile(g_filenames[8])
local g_props_data = DecodeJsonFile(g_filenames[9])
local g_heroStory_data = DecodeJsonFile(g_filenames[10])
local g_languages_data = DecodeJsonFile(g_filenames[11])
local g_names_data = DecodeJsonFile(g_filenames[12])
local g_heroCfg_data = DecodeJsonFile(g_filenames[13])
local g_heroDrop_data = DecodeJsonFile(g_filenames[14])
local g_Achievement_data = DecodeJsonFile(g_filenames[15])
local g_boss_data = DecodeJsonFile(g_filenames[16])
local g_exploreProduce_data = DecodeJsonFile(g_filenames[17])
local g_exploreProp_data = DecodeJsonFile(g_filenames[18])
local g_exploreMap_data = DecodeJsonFile(g_filenames[19]);
local g_equips_data = DecodeJsonFile(g_filenames[20])
local g_payment_data = DecodeJsonFile(g_filenames[21])

local g_heroLvlSub_lvlup = {};--处理后的升级子表
local g_heroLvlSub_lvlupWake = {};--处理后的觉醒子表
local g_heroLvlSub_strong = {};--处理后的强化子表
local g_heroLvlSub_weapon = {};--处理后的神兵子表

-- 获取技能表
function Config.getSkillsData(loadAgain)
	if loadAgain then
		g_skills_data = DecodeJsonFile(g_filenames[1])
	end
	return g_skills_data
end

-- 获取行为表
function Config.getActionsData(loadAgain)
	if loadAgain then
		g_actions_data = DecodeJsonFile(g_filenames[2])
	end
	return g_actions_data
end
 
-- 获取位置表
function Config.getPositionsData(loadAgain)
	if loadAgain then
		g_positions_data = DecodeJsonFile(g_filenames[3])
	end
	return g_positions_data
end

-- 获取副本表
function Config.getFBData(loadAgain)
	if loadAgain then
		g_fb_data = DecodeJsonFile(g_filenames[4])
	end
	return g_fb_data
end

-- 获取英雄表
function Config.getHerosData(loadAgain)
	if loadAgain then
		g_heros_data = DecodeJsonFile(g_filenames[5])
	end
	return g_heros_data
end

-- 获取英雄升级表
function Config.getHeroLvlupData(loadAgain)
	if loadAgain then
		g_heroLvlup_data = DecodeJsonFile(g_filenames[6])
	end
	return g_heroLvlup_data
end

--获取英雄升级子表--升级表
--[[

]]
function Config.getHeroLvlupSubLvlup (loadAgain)
    local superTab = Config.getHeroLvlupData(loadAgain);
    local cnt = 0;

    for k, v in pairs(g_heroLvlSub_lvlup) do
        cnt = cnt + 1;
    end

    if (loadAgain or cnt <= 0) then
        g_heroLvlSub_lvlup = Config.getHeroLvlupSubByTp(superTab, 1);
    end
    
    return g_heroLvlSub_lvlup;
end

--获取英雄升级子表--强化表
--[[

]]
function Config.getHeroLvlupSubStrong (loadAgain)
    local superTab = Config.getHeroLvlupData(loadAgain);
    local cnt = 0;
    
    for k, v in pairs(g_heroLvlSub_strong) do
        cnt = cnt + 1;
    end
    
    if (loadAgain or cnt <= 0) then
        g_heroLvlSub_strong = Config.getHeroLvlupSubByTp(superTab, 2);
    end
    
    return g_heroLvlSub_strong;
end

--获取英雄升级子表--觉醒表
--[[

]]
function Config.getHeroLvlupSubWake (loadAgain)
    local superTab = Config.getHeroLvlupData(loadAgain);
    local cnt = 0;

    for k, v in pairs(g_heroLvlSub_lvlupWake) do
        cnt = cnt + 1;
    end

    if (loadAgain or cnt <= 0) then
        g_heroLvlSub_lvlupWake = Config.getHeroLvlupSubByTp(superTab, 3);
    end

    return g_heroLvlSub_lvlupWake;
end

--根据类型获取英雄升级子表
function Config.getHeroLvlupSubByTp (superTab, _tp)
    local returnData = {};
    local cnt, sum = 0, 0;
    _tp = _tp or 1;

    for k, v in pairs(superTab) do
        if (#v > 0) then
            cnt = cnt + 1;
            --包含多个table
            for i = 1, #v do
                if (tonumber(_tp) == tonumber(v[i][this.const_type])) then
                    returnData[k .. ""] = v[i];
                end
            end
        elseif (tonumber(_tp) == tonumber(v[this.const_type])) then
            sum = sum + 1;
            returnData[k .. ""] = v;
        end 
    end
    
    return returnData;
end

-- 获取关卡表
function Config.getGatesData(loadAgain)
	if loadAgain then
		g_gates_data = DecodeJsonFile(g_filenames[7])
	end
	return g_gates_data
end

-- 获取出战开启条件表
function Config.getConditionsData(loadAgain)
	if loadAgain then
		g_conditions_data = DecodeJsonFile(g_filenames[8])
	end
	return g_conditions_data
end

-- 获取道具表
function Config.getPropsData(loadAgain)
	if loadAgain then
		g_props_data = DecodeJsonFile(g_filenames[9])
	end
	return g_props_data
end

-- 获取英雄传奇表
function Config.getHeroStoryData(loadAgain)
	if loadAgain then
		g_heroStory_data = DecodeJsonFile(g_filenames[10])
        HeroStoryProxy.setIsInitKeys(false);
	end
    
	return g_heroStory_data;
end

-- 获取国际化语言表
function Config.getLangData(loadAgain)
	if loadAgain then
		g_languages_data = DecodeJsonFile(g_filenames[11])
	end
	return g_languages_data
end

-- 获取角色名表
function Config.getNameData(loadAgain)
	if loadAgain then
		g_names_data = DecodeJsonFile(g_filenames[12])
	end
	return g_names_data
end

--[[
    获取游戏配置表
]]
function Config.getGameCfgData (loadAgain)
    if loadAgain then
		g_heroCfg_data = DecodeJsonFile(g_filenames[13])
	end
	return g_heroCfg_data
end

--[[
    获取游戏掉落表
]]
function Config.getGameDropData (loadAgain)
    if loadAgain then
		g_heroDrop_data = DecodeJsonFile(g_filenames[14])
	end
	return g_heroDrop_data
end

--[[
    获取成就配置表
]]
function Config.getAchievementData (loadAgain)
    if loadAgain then
        g_Achievement_data = DecodeJsonFile(g_filenames[15]);
    end

    return g_Achievement_data;
end

-- 获取npc_boss表
function Config.getBossData(loadAgain)
    if loadAgain then
		g_boss_data = DecodeJsonFile(g_filenames[16])
	end
	return g_boss_data
end

--[[
    探险产出表
]]
function Config.getExploreProduceData (loadAgain)
    if loadAgain then
		g_exploreProduce_data = DecodeJsonFile(g_filenames[17])
	end
	return g_exploreProduce_data
end

--[[
    探险道具表
]]
function Config.getExplorePropData (loadAgain)
    if loadAgain then
		g_exploreProp_data = DecodeJsonFile(g_filenames[18])
	end
	return g_exploreProp_data
end

--[[
    探险地图表
]]
function Config.getExploreMapData (loadAgain)
    if loadAgain then
		g_exploreMap_data = DecodeJsonFile(g_filenames[19])
	end
	return g_exploreMap_data
end

-- 获取装备表
function Config.getEquipsData(loadAgain)
    if loadAgain then
        g_equips_data = DecodeJsonFile(g_filenames[20])
    end
    return g_equips_data
end

-- 获取充值表
function Config.getPaymentData(loadAgain)
    if loadAgain then
        g_payment_data = DecodeJsonFile(g_filenames[21])
    end
    return g_payment_data
end