--[[
-- 层级管理
--]]

--	eg: by kenny
-- object.layer = LayerMask.NameToLayer(CameraLayer.Default)
CameraLayer = {
	Default = "Default",							-- 默认层
	UI = "UI",											-- UI层
    NGUI = "NGUI",								-- NGUI层
	UIChild = "UIChild",							-- UIChild层
	GameMask = "GameMask",			-- 新手屏蔽层
	UIGuide = "UIGuide",						-- 新手UI层
	GameTop = "GameTop",					-- 游戏顶层
}

function GetCameraLayer(cameraLayer)
	local layer = CameraLayer.Default
	if IsMemberKey(cameraLayer, CameraLayer) then
		layer = cameraLayer
	end
	return LayerMask.NameToLayer(layer)
end
function SetCameraLayer(go, cameraLayer, recursion)
	if go == nil then return end
	local layer = GetCameraLayer(cameraLayer)
	go.layer = layer
	if recursion then
		local tran = go.transform
		for i = tran.childCount - 1, 0, -1 do
			local child = tran:GetChild(i)
			local childGo = child.gameObject
			childGo.layer = layer
			SetCameraLayer(childGo, cameraLayer, recursion)
		end
	end
end

-- eg:
--	spineRenderer = object:GetComponent(MeshRenderer.GetClassType())
-- spineRenderer.sortingLayerName = LayerName.Actor
-- spineRenderer.sortingOrder = 0
LayerName = {
	Default =				"Default",					-- 默认层
	Background =		"Background",			-- 背景层
    Shadow =			"Shadow",				-- 阴影层
    EffectBehind =		"EffectBehind",		-- 后特效层
    Actor =				"Actor",					-- 角色层
    EffectFront =		"EffectFront",			-- 前特效层
	UI =						"UI",							-- UI层
	Broadcast =			"Broadcast",				-- 广播层
	Dialog =				"Dialog",					-- 弹窗层
	Top =					"Top",						-- 置顶层
}

--function GetLayerOrder(layerOrder, teamSide, object)
--	local root = GameObject.Find("UIRoot")
--	local ret = -math.abs(layerOrder)
--	local count = 0
--	if object~=nil then
--		local father = object.transform.parent
--		while father~=nil and father~=root do
--			count = count + father.transform.localPosition.z
--			father = father.transform.parent
--		end
--	end
--	ret = ret - count
--	if teamSide~=nil and teamSide==TeamSide.Right then
--		ret = -ret
--	end
--	return ret
--end

--[[
	所有添加的层，需要在这里定义
	2016-6-30 20:35:33 library
]]
GameLayers = {
	Nothing = -2,
	Everything = -1,
	Default = 0,
	TransparentFX = 1,
	IgnorRaycast = 2,
	Water = 4,
	UI = 5,
	NGUI = 8,
	UIChild = 9,
	GameMask = 10,
	UIGuide = 11
}