--成就数据解析类
--2016-9-29 17:58:43 library

local const_showTp = "#show_type";
local const_achivDesc = "#desc_honor";
local const_achivRwd = "#desc_reward";
local const_achivTarget = "target";
local const_achivProps = "prop_ids";
local const_achivEqus = "equi_id";

AchievementDataProxy = {

}

local this = AchievementDataProxy;

--[[
    获取成就的描述
    _cfg 
    return string 成就的描述
]]
function AchievementDataProxy.getAchivDesc (_cfg)
    local desc = "";

    if (_cfg) then
        desc = _cfg[const_achivDesc];
    end

    desc = desc or "";

    return desc;
end


--[[
    获取成就的奖励
    _cfg
    return string 成就的奖励
]]
function AchievementDataProxy.getAchivReward (_cfg)
    local rwd = "";

    if (_cfg) then
        rwd = _cfg[const_achivRwd];
    end

    rwd = rwd or "";

    return rwd;
end

--[[
    获取成就的目标
    _cfg
    return number 
]]
function AchievementDataProxy.getAchivTarget (_cfg)
    local target = 0;

    if (_cfg) then
        target = tonumber(_cfg[const_achivTarget]);
    end

    target = target or 0;

    return target;
end

--[[
    获取成就的显示类型
    _cfg 成就配置数据
    return number 显示类型
]]
function AchievementDataProxy.getAchivShowTp (_cfg)
    local tp = 0;

    if (nil ~= _cfg) then
        tp = tonumber(_cfg[const_showTp]);
    end

    return tp;
end

--[[
    获取成就的道具配置
    _cfg 成就配置数据
    return string 道具配置
]]
function AchievementDataProxy.getAchivProps (_cfg)
    local props = "0";

    if (nil ~= _cfg) then
        props = _cfg[const_achivProps];
    end

    return props;
end

--[[
    获取成就的装备配置
    _cfg 成就配置数据
    return string 装备配置
]]
function AchievementDataProxy.getAchivEqus (_cfg)
    local equs = "0";

    if (nil ~= _cfg) then
        equs = _cfg[const_achivEqus];
    end

    return equs;
end

--[[
    根据ID取成就的配置数据
    _id number 成就ID
    return Cfg 成就配置数据
]]
function AchievementDataProxy.getAchivCfgById (_id)
    local fileData = Config.getAchievementData();
    local cfg = nil;
    
    for k, v in pairs(fileData) do
        if (tonumber(k) == tonumber(_id)) then
            cfg = v;
            break ;
        end
    end
    
    return cfg;
end

--[[
    根据成就ID，取该成就的相同显示类型的下一级成就信息
    _id 成就ID
    return {honorId, HonorCfg}
]]
function AchievementDataProxy.getShowAchivCfg (_id)
    local honorId, tarCfg = nil, nil;
    local fileData = Config.getAchievementData();
    local curCfg = this.getAchivCfgById(_id);
    local showTp = this.getAchivShowTp(curCfg);
    
    for k, v in pairs(fileData) do
        if (this.getAchivShowTp(v) == tonumber(showTp)) then
            if (this.getAchivTarget(v) > this.getAchivTarget(curCfg) and (nil == tarCfg or this.getAchivTarget(tarCfg) > this.getAchivTarget(v))) then
                honorId = tonumber(k);
                tarCfg = v;
            end
        end
    end
    if (nil == tarCfg) then
        honorId = _id;
        tarCfg = curCfg;
    end
    return {honorId, tarCfg};
end