require "Game/Common/Tools/Cookie"

DataManager = { 

};

local this = DataManager;

DataManager.G_ = "g_";
 


--[[
新版本后不操作磁盘 ， 只访问内存

/*本地缓存数据,g_前缀为全局数据定义常量, 模块缓存以模块名为前缀*/
/// <summary>
/// 本地缓存字符串数据
/// </summary>
/// <param name="key">键名</param>
/// <param name="value">数据值</param>
/// <param name="saveTime">保存多长时间(毫秒</param>
]]

function DataManager.cacheString(key, v, saveTime)

    Cookie.set(key .. Global.sharding, v, saveTime > 0 and (Global.serverTime + saveTime) or 0);
end

--[[
/// 本地猎取字符串数据
/// </summary>
/// <param name="key">键名</param>
/// <param name="defaultValue">默认数据值</param>
/// <param name="expireValue">是否返回过期数据</param>
]]
function DataManager.getCacheString(key, defaultValue, expireValue)

	defaultValue = defaultValue or nil;

	expireValue = expireValue or false;

    return Cookie.get(key .. Global.sharding, defaultValue, expireValue, Global.serverTime);
end

--删除基础类型缓存
function DataManager.deleteString(key)

    Cookie.deleteString(key .. Global.sharding);
end


--[[

新版本后不操作磁盘 ， 只访问内存

/// 本地缓存指定类型数据
/// </summary>
/// <param name="key">键名</param>
/// <param name="value">数据值</param>
/// <param name="saveTime">保存多长时间(毫秒</param>
]]
function DataManager.cache(key, data, saveTime)

	saveTime = saveTime or 0;

	Cookie.saveData(key .. Global.sharding, data, saveTime > 0 and (Global.serverTime + saveTime) or 0);

end   

--[[

新版本后不操作磁盘 ， 只访问内存

/// 本地猎取指定类型数据
/// </summary>
/// <param name="key">键名</param>
/// <param name="expireValue">是否返回过期数据</param>
/// <returns></returns>
]]

function DataManager.getCache(key, expireValue)
	return Cookie.getData(key .. Global.sharding, expireValue, Global.serverTime);
end

--删除对象缓存
function DataManager.deleteData(key)

    Cookie.deleteData(key .. Global.sharding);
end

--清缓存
function DataManager.clearCache()

    Cookie.clearCache();
end
