--探险地图数据类
--2016-7-23 16:55:01 library

local cfgNPCName = "name";
local const_explore_BuJiAddTime = "Explore_BuJiAddTime";
local const_mapName = "#map_name";
local const_supply = "supply";
local const_mappoins = "map_poins";
local const_propid = "prop_id";
local const_propSecond = "prop_second";

local pointsPosAround = {
    {-2, 0}, {-1, -1}, {-1, 0}, {-1, 1},
    {0, -2}, {0, -1}, {0, 1}, {0, 2},
    {1, -1}, {1, 0}, {1, 1}, {2, 0},
};
ExploreMapDataProxy = {
    maxSupply = 5;
}

local this = ExploreMapDataProxy;

--[[
    取指定点的状态
    _data 全地图数据 ArcMapMainData.activationMap
    _x number [0, 30]
    _y number [0, 39]
    return number 0，未探索；1，已探索
]]
function ExploreMapDataProxy.getPointStatus (_data, _x, _y)
    local tarData, rtn = nil, nil;

    tarData = _data[_y + 1] or 0;
    rtn = Bit.getLogicStatus(tarData, 31 - _x);--ios平台，可注释该行代码id001
--    rtn = BitUtil.getLogicStatus(tarData, 31 - _x);
    rtn = (nil == rtn) and 0 or (rtn and 1 or 0);

    return rtn;
end


--[[
    设置指定点的状态
    _data 全地图数据 ArcMapMainData.activationMap
    _x number [0, 30]
    _y number [0, 39]
    _status number 0，未探索；1，已探索
]]
function ExploreMapDataProxy.setPointStatus (_data, _x, _y, _status)
    local tarData = nil;
    
    tarData = _data[_y + 1];
    _status = _status or 0;
    _status = (1 == _status) and true or false;

    if (nil ~= tarData) then
        _data[_y + 1] = Bit.setLogicStatus(tarData, 31 - _x, _status);--ios平台，可注释该行代码id001
--        _data[_y + 1] = BitUtil.setLogicStatus(tarData, 31 - _x, _status);
    end
end

--[[
    设置指定点的显示区域，即其周围的12个位置都设为可见
    _data List<int>
    _x number
    _y number
]]
function ExploreMapDataProxy.setShowAreaOfPoint (_data, _x, _y)
    local tarPosList = nil;
    
    tarPosList = this.getShowPosList(_x, _y);
    
    for i = 1, tarPosList.size do
        if (0 == this.getPointStatus(_data, tarPosList[i].x, tarPosList[i].y)) then
            this.setPointStatus(_data, tarPosList[i].x, tarPosList[i].y, 1);
        end
    end
end

--[[
    取指定点的资源
    _data 全地图中的特殊资源数据，存在ExploreView.holeMapRscData中
    return table;
]]
function ExploreMapDataProxy.getPointRsc (_data, _x, _y)
    local rtn = nil;

    rtn = _data[_x .. "_" .. _y];
    
    return rtn;
end

--[[
    取遗迹的信息
    _lvl number 遗迹的等级
    return string 遗迹的配置信息
]]
function ExploreMapDataProxy.getNPCCfgByLvl (_lvl)
    local npcCfg = {};

    return npcCfg;
end

--[[
    取遗迹的名字
    _cfg number 遗迹的配置信息
    return string 遗迹的名字
]]
function ExploreMapDataProxy.getNPCName (_cfg)
    local cName = "";

    cName = _cfg[cfgNPCName];

    if (nil == cName) then
        cName = "";
    end

    return cName;
end

--[[
    设置玩家数据
    _teams ArcMapMainData.teams
    _tData ArcTeamMapData
    return number 0，已有数据；1，新增数据
]]
function ExploreMapDataProxy.setTeamData (_teams, _tData)
    local tmpData = nil;
    local newMark = 1;

    for i = 1, #_teams do
        tmpData = _teams[i];
        if (tmpData.teamId == _tData.teamId) then
            tmpData.position = _tData.position;
            newMark = 0;
            break ;
        end
    end

    if (1 == newMark) then
        table.insert(_teams, _tData);
    end

    return newMark;
end

--[[
    设置特殊点的数据
    _specialPoint ArcMapMainData.specialPoint
    _ampData ArcMapPoinData
    _tp number 0，数据不存在，则丢弃数据；1，数据不存在，数据追加到最后；2，数据存在，giftId为0，则删除表中的数据
]]
function ExploreMapDataProxy.setSpecialPointData (_specialPoint, _ampData, _tp)
    local tmpData = nil;
    local isFind = false;
    local curIdx = 0;

    _tp = _tp or 0;
    for i = 1, #_specialPoint do
        tmpData = _specialPoint[i];
        if (tmpData.x == _ampData.x and tmpData.y == _ampData.y) then
            tmpData.status = _ampData.status;
            tmpData.giftId = _ampData.giftId;
            tmpData.second = _ampData.second;
            isFind = true;
            curIdx = i;
            break ;
        end
    end
    if (2 == _tp and isFind and 0 == _ampData.giftId) then
        table.remove(_specialPoint, curIdx);
    elseif (1 == _tp and not isFind) then
        table.insert(_specialPoint, _ampData);
    end
end

--[[
    移除特殊资源点的数据
    _specialPoint ArcMapMainData.specialPoint
    _pData ArcMapPoinData
]]
function ExploreMapDataProxy.removeSpecialPointData (_specialPoint, _pData)
    local pData = nil;

    for i = 1, #_specialPoint do
        pData = _specialPoint[i];
        if (pData.x == _pData.x and pData.y == _pData.y) then
            table.remove(_specialPoint, i);
            break ;
        end
    end
end

--[[
    取未探索的地形数量
    _data ArcMapMainData.activationMap
    return number 未探索的数量
]]
function ExploreMapDataProxy.getUnSearchPointCnt (_data)
    local val, isTrue, cnt = nil, false, 0;

    for i = 1, #_data do
        val = _data[i];
        if (0 ~= val) then
            for i = 1, 31 do
                isTrue = Bit.getLogicStatus(val, i);--ios平台，可注释该行代码id001
--                isTrue = BitUtil.getLogicStatus(val, i);
                if (not isTrue) then
                    cnt = cnt + 1;
                end
            end
        end
    end

    return cnt;
end

--[[
    取罗盘需要指向的最近的资源点的位置
    _data table 其中元素是ArcMapPoinData
    _teams table 其中元素是ArcTeamMapData
    _myPoint Vector3 我的位置
    _specialId number 特殊资源的ID，0代表所有的资源
    return Vector3 最近的资源点的位置
]]
function ExploreMapDataProxy.getCompassPoint (_data, _teams, _myPoint, _specialId)
    local tarVec = nil;
    local perData, tmpVec, tmpPos, team = nil, nil, nil;
    local isTake, len, tmpLen = false, -1, 0;

    _myPoint = _myPoint or Vector3.New(0, 0, 0);
    tarVec = Vector3.New(-1, 0, 0);
    
    for i = 1, #_data do
        isTake = false;
        perData = _data[i];
        if (_specialId == perData.giftId) then
            tmpLen = math.pow(perData.x - _myPoint.x, 2) + math.pow(perData.y - _myPoint.y, 2);
            if (-1 == len or tmpLen < len) then
                for i = 1, #_teams do
                    team = _teams[i];
                    if (perData.x == team.position.x and perData.y == team.position.y) then
                        isTake = true;
                        break ;
                    end
                end
                if (not isTake) then
                    len = tmpLen;
                    tarVec.x = perData.x;
                    tarVec.y = perData.y;
                end
            end
        end
    end
    
    return tarVec;
end

--[[
    挂机过程中，某种道具每秒可获得的数量
    _pid number 道具ID
    return number 数量
]]
function ExploreMapDataProxy.getPropGetNumPerSecond (_pid)
    local num = 1;

    return num;
end

--[[
    某种道具的挂机可获得的上限
    _pid number 道具ID
    return number 数量
]]
function ExploreMapDataProxy.getPropGetMaxCnt (_pid)
    local num = 100;

    return num;
end

--[[
    领取单个某种道具消耗的补给
    _pid number 道具ID
    return number 数量
]]
function ExploreMapDataProxy.getPropCostPerSecond (_pid)
    local cost = 1;

    return cost;
end

--[[
    根据地图等级取地图名称
]]
function ExploreMapDataProxy.getMapNameByLvl (_lvl)
    local mapName, cfg, val = "", nil, nil;

    cfg = Config.getExploreMapData();
    val = LogicUtil.getJsonConfigVal(cfg, _lvl);
    if (nil ~= val) then
        mapName = val[const_mapName];
    end
    mapName = mapName or "";

    return mapName;
end

--[[
    判断当前点是否应该显示
    _data 全地图数据 ArcMapMainData.activationMap
    _x number [0, 30]
    _y number [0, 39]
    _status number 0，不显示；1，显示
]]
function ExploreMapDataProxy.isCurPointShow (_data, _x, _y)
    local relPosList = nil;
    local isShow = 0;
    
    if (1 == ExploreMapDataProxy.getPointStatus(_data, _x, _y)) then
        isShow = 1;
    end
    
    if (0 == isShow) then
        relPosList = this.getShowPosList(_x, _y);
        
        for i = 1, relPosList.size do
            isShow = ExploreMapDataProxy.getPointStatus(_data, relPosList[i].x, relPosList[i].y);
            
            if (1 == isShow) then
                break ;
            end
        end
    end
    
    return isShow;
end

--[[
    根据当前点的位置，获取周围需要设置为可见的点
    _x number
    _y number
    return List<table>
]]
function ExploreMapDataProxy.getShowPosList (_x, _y)
    local showPosList, showTab, tmpPos = List.new(), nil, nil;
    local muSize = ExploreConstant.getMapCntSize();
    
    for i = 1, #pointsPosAround do
        tmpPos = Vector2.New(_x + pointsPosAround[i][1], _y + pointsPosAround[i][2]);
        
        if (tmpPos.x >= 0 and tmpPos.x < muSize.x and tmpPos.y >= 0 and tmpPos.y < muSize.y) then
            --有效的坐标位置
            showPosList:add(tmpPos);
        end
    end
    
    return showPosList;
end

--[[
    考古指定点的资源所需要消耗的时间
    _data ArcMapMainData
    _vec Vector3
    return number 秒数
]]
function ExploreMapDataProxy.getRescTime (_data, _vec)
    local ampData = nil;--ArcMapPoinData
    local time = 0;--秒

    for i = 1, #_data.specialPoin do
        ampData = _data.specialPoin[i];
        if (ampData.x == _vec.x and ampData.y == _vec.y) then
            time = ampData.second;
            break ;
        end
    end

    return time;
end

--[[
    由于前后台时间存在差异，所以前台在配置的时间基础上加多1秒
]]
function ExploreMapDataProxy.getBuJiAddTime ()
    local times = 59;

    times = tonumber(GameCfgDataProxy.getGameCfgDataByKey(const_explore_BuJiAddTime));
    times = times or 59;
    times = times + 1;

    return times;
end

--[[
    获取探索地图上指定点需要消耗的支援
    _mapId number 地图ID
    _pos Vector3 位置信息
    _npcStatus number NPC状态
    return 消耗的支援
]]
function ExploreMapDataProxy.getRescSupply (_mapId, _pos, _npcStatus)
    local mapCfg, propCfg = nil, nil;
    local mapVal, propVal = nil, nil;
    local mapPoints, propSupply = nil, 0;
    local position = 0;
    local mapTerrain = 0;
    local mapSquCnt = ExploreConstant.getMapCntSize();
    local supply = 0;
    
    mapCfg = Config.getExploreMapData();
    propCfg = Config.getExplorePropData();
    
    position = _pos.x * mapSquCnt.y + _pos.y + 1;
    mapVal = LogicUtil.getJsonConfigVal(mapCfg, _mapId);
    mapPoints = mapVal[const_mappoins];
    mapTerrain = string.sub(mapPoints, position, position);
    mapTerrain = tonumber(mapTerrain) or 0;
    supply = this.getPropJsonConfigSupply(propCfg, mapTerrain);
    supply = supply or 0;
    supply = supply * math.pow(2, _npcStatus);
    
    return supply;
end

--[[
    根据地形取消耗的支援
    propCfg Config.getExplorePropData()的返回值
    mapTerrain number 地形ID
]]
function ExploreMapDataProxy.getPropJsonConfigSupply (propCfg, mapTerrain)
    local perVal = nil;
    local supply = 0;
    
    if (propCfg) then
        for k, v in pairs(propCfg) do
            perVal = v;
            if (tonumber(k) == mapTerrain and perVal) then
                for i = 1, #perVal do
                    supply = perVal[i][const_supply];
                    break ;
                end
            end
        end
    end
    
    supply = tonumber(supply);
    supply = supply or 0;
    
    return supply;
end

--[[
    获取地图上可以生成的所有资源
    _mapId number 地图ID
]]
function ExploreMapDataProxy.getMapRsrcs(_mapId)
    local mapCfg, propCfg = nil, nil;
    local mapVal, propVal = nil, nil;
    local mapPoint = nil;
    local mapTp, perStr = Map.new(), "";
    local propTp = Map.new();
    local orderList = List.new();
    
    mapCfg = Config.getExploreMapData();
    propCfg = Config.getExplorePropData();
    mapVal = LogicUtil.getJsonConfigVal(mapCfg, _mapId);
    mapPoint = mapVal[const_mappoins];

    for i = 1, #mapPoint do
        perStr = string.sub(mapPoint, i, i);
        if (nil == mapTp[tonumber(perStr)]) then
            mapTp:put(tonumber(perStr), tonumber(perStr));
        end
    end
    
    for i = 1, #mapTp.__keyList do
        local val = mapTp:value(mapTp:key(i));
        local valList = nil;
        
        valList = ExploreMapDataProxy.getPropVal(propCfg, val, const_propid);
        for j = 1, #valList do
            if (not propTp:value(valList[j])) then
                propTp:put(tonumber(valList[j]), tonumber(valList[j]));
            end
        end
    end

    for i = 1, #propTp.__keyList do
        orderList:add(propTp:value(propTp:key(i)));
    end

    for i = 1, orderList.size do
        for j = i + 1, orderList.size do
            if (orderList[i] > orderList[j]) then
                local tmp = orderList[i];
                orderList[i] = orderList[j];
                orderList[j] = tmp;
            end
        end
    end
    
    return orderList;
end

--[[

]]
function ExploreMapDataProxy.getPropVal (_propCfg, _key, _title)
    local rtnList = List.new();
    
    if (_propCfg[tostring(_key)]) then
        for k, v in pairs(_propCfg[tostring(_key)]) do
            rtnList:add(v[_title]);
        end
    end

    return rtnList;
end

--[[
    获取NPC重置消耗的血钻
    return number
]]
function ExploreMapDataProxy.getNPCResetCost ()
    local cost = 100;

    return cost;
end

--[[
    _maxNpcLvl number 最大NPC等级
    return number 最大的地图等级
]]
function ExploreMapDataProxy.getMapLvlByNPCLvl (_maxNpcLvl)
    local maxMapLvl = 10;

    return maxMapLvl;
end

--[[
    设置特殊资源点的时间，仅设置未探索的点的时间
    _mainData ArcMapMainData
    _list List<table> {x, y, giftId}
    return nil
]]
function ExploreMapDataProxy.setPointTime (_mainData, _list)
    local ampData = nil;--ArcMapPoinData
    local status = nil;--number
    local cfgTmp, costTime = nil, 0;
    
    _list = _list or List.new();
    local function isInList(_x, _y)
        local isIn = false;
        local tmp = nil;

        for i = 1, _list.size do
            tmp = _list[i];
            if (tmp[1] == _x and tmp[2] == _y) then
                isIn = true;
                break ;
            end
        end

        return isIn;
    end

    for i = 1, #_mainData.specialPoin do
        ampData = _mainData.specialPoin[i];
        status = this.getPointStatus(_mainData.activationMap, ampData.x, ampData.y);
        if (ExploreDefine.SqaureType.UnSearch == status or isInList(ampData.x, ampData.y)) then
            cfgTmp = this.getExplorePropCfg(ampData.giftId);
            costTime = GameCfgDataProxy.getCfgVal(cfgTmp, const_propSecond);
            costTime = tonumber(costTime) or 0;
            if (0 ~= costTime) then
                ampData.second = costTime;
            end
        end
    end
end

--[[
    取特殊资源点的挖掘时间
    _specialPoin table<ArcMapPoinData>
    _pos Vector3 坐标
    return number 挖掘时间
]]
function ExploreMapDataProxy.getPointTime (_specialPoin, _pos)
    local digTime = 0;
    local ampData = nil;

    if (_specialPoin and _pos) then
        for i = 1, #_specialPoin do
            ampData = _specialPoin[i];
            if (ampData.x == _pos.x and ampData.y == _pos.y) then
                digTime = ampData.second;
                break ;
            end
        end
    end

    digTime = digTime or 0;

    return digTime;
end

--[[
    根据地形ID、道具ID取消耗配置（explore_prop.json）
    _propId number 道具ID
    return 消耗配置
]]
function ExploreMapDataProxy.getExplorePropCfg (_propId)
    local costCfg = nil;
    local propFile = Config.getExplorePropData();
    local propsInfo, propTmp, pid = nil, nil, nil;
    
    for k, v in pairs(propFile) do
        propsInfo = v;
        if (nil ~= propsInfo) then
            for i = 1, #propsInfo do
                propTmp = propsInfo[i];
                pid = GameCfgDataProxy.getCfgVal(propTmp, const_propid);
                if (_propId == pid) then
                    costCfg = propTmp;
                    break ;
                end
            end
        end
    end
    
    return costCfg;
end