--[[
-- Desc: 副本数据
-- Author: kenny
-- Date: 2016
--]]
require "Game/Common/Config"

FBData = {}

local const_openTips = "通关 {1} 后开放";
local const_FirOpen = "1-5";
local const_SecOpen = "2-2";
local const_ThiOpen = "2-5";
local const_FouthOpen = "3-5";

local this = FBData
local guideMaxHouseId = 5;
local guideMaxLvl = 3;

this.OpenData = {
    FirOpen = {10105, string.gsub(const_openTips, "{1}", const_FirOpen)}, 
    SecOpen = {10202, string.gsub(const_openTips, "{1}", const_SecOpen)}, 
    ThiOpen = {10205, string.gsub(const_openTips, "{1}", const_ThiOpen)},
    FouthOpen = {10305, string.gsub(const_openTips, "{1}", const_FouthOpen)}
};


this.maxChapterNum = 54
this.lastGateIdRPC = 10101
this.curChapterId = 1					-- 范围: 1 ~ n
this.curHardLevel = 1					-- 范围: 1 ~ 3
this.curHouseId = 1						-- 范围: 1 ~ 5
this.lastChapterId = 1					-- 范围: 1 ~ n
this.lastHardLevel = 1					-- 范围: 1 ~ 3
this.lastHouseId = 1					-- 范围: 1 ~ 5
this.lastHardLevelRPC = 1			-- 服务器的难度
this.selHardLevel = 1					-- 记录之前选中的难度
this.rewardsCount = 1					-- 宝箱奖励个数
this.lastSelectedChapterId = 0	-- 小红点
this.curHangUpGate = {}				-- 当前挂机关卡

this.curDataList = {}
this.rpcTimeList = {}
this.cfgTimeList = {}
this.totalTimeList = {}
this.lastTimeList = {}
this.countTime = 0
this.totalTime = 0
this.fbsData = Config.getFBData()
this.gatesData = Config.getGatesData()

function FBData.New(data)
	this.Init(data)
	if not Global.openGuide then
		for k, v in pairs(this.OpenData) do
			v[1] = 10100
		end
	end
	return this
end

function FBData.Init(data)
	if not IsEmptyTable(data) then
		local dungeons = data.dungeons
		if IsEmptyTable(dungeons) then
			return
		end
		this.data = data
        this.guideInitData();
        this.guideUseData();

		local curFBInfo = dungeons.gateInfo
--		local curFB = dungeons.curDungeons
		local fbOthers = dungeons.dungeonsList

		this.SetCurChapterId(this.GetChapterId(curFBInfo.gateId))
		local fbId = FBData.GetChapterIdRPC(curFBInfo.gateId)
		local curGateLevel = dungeons.curGateLevel
		this.curHardLevel = FBData.CheckHardLevel(fbId, curGateLevel)
		local hardLevel = tonumber(curFBInfo.curLevel) or 1			-- 注意后台大小写
		this.lastHardLevel = FBData.CheckHardLevel(fbId, hardLevel)
		this.SetLastHardLevelRPC(hardLevel)
		this.SetCurHouseId(this.GetHouseId(curFBInfo.gateId))

--		plog("#hardLevel = ", hardLevel)
--		plog("#this.curHardLevel = ", this.curHardLevel)
--		plog("#this.lastHardLevel = ", this.lastHardLevel)
		
		local maxChapter = this.GetCurChapterId()
		local maxLevel = this.GetCurHardLevel()
		local maxHouse = this.GetCurHouseId()
--		plog("maxChapter = ", maxChapter)
--		plog("maxLevel = ", maxLevel)
--		plog("maxHouse = ", maxHouse)
		if not IsEmptyTable(fbOthers) then
			for _, char in pairs(fbOthers) do
				local chapter = FBData.GetChapterIdByRPC(char.dungeonsId)
				local hardLevel = tonumber(char.curLeveL) or 1		-- 注意后台大小写
				local houseId = tonumber(this.GetHouseId(char.curIndex))
--				plog("$dungeonsId = ", char.dungeonsId)
--				plog("$curLeveL = ", char.curLeveL)
--				plog("$curIndex = ", char.curIndex)
				if chapter >= maxChapter then
					maxChapter = chapter
					maxLevel = hardLevel
					maxHouse = houseId
				end
			end
		end
		this.lastChapterId = maxChapter
		this.lastHardLevel = maxLevel
		this.lastHouseId = maxHouse

		if this.curChapterId > this.lastChapterId then
			this.curChapterId = this.lastChapterId
		end

		local newGate = FBData.IsPassedGate(this.GetGateId(this.lastChapterId, this.lastHouseId), 1)
		if newGate and this.lastHouseId == 5 then -- FBData.GetLastHouseId()
			FBData.IncLastChapterId()
		end
		
--		plog("FBData.GetCurChapterIdRPC() = ", FBData.GetCurChapterIdRPC())
--		plog("FBData.GetLastHardLevelRPC() = ", FBData.GetLastHardLevelRPC())
		FBData.InsertPastedFB(FBData.GetCurChapterIdRPC(), FBData.GetLastHardLevelRPC())
		FBData.SetHangUpGate()

--		plog("@[FBData] curGateId = ", curFBInfo.gateId)
--		plog("@[FBData] curChapterId = ", FBData.GetCurChapterId())
--		plog("@[FBData] curHardLevel = ", FBData.GetCurHardLevel())
--		plog("@[FBData] curHouseId = ", FBData.GetCurHouseId())
--		plog("@[FBData] lastChapterId = ", this.lastChapterId)
--		plog("@[FBData] lastHardLevel = ", this.lastHardLevel)
--		plog("@[FBData] lastHouseId = ", this.lastHouseId)
	end
end

function FBData.IncLastHardLevel()
	this.lastHardLevel = this.lastHardLevel+ 1
end

function FBData.InsertPastedFB(chapterIdRPC, lastHardLevel)
	local curFB = {}
	curFB.dungeonsId = chapterIdRPC
	curFB.curLeveL = lastHardLevel

	local isExist = false
	local dungeons = this.data.dungeons
	local fbOthers = dungeons.dungeonsList
	for i = #fbOthers, 1, -1 do
		local fb = fbOthers[i]
		if tostring(fb.dungeonsId) == tostring(curFB.dungeonsId) then
			isExist = true
			fb.curLeveL = curFB.curLeveL
		end
	end
	if not isExist then
		table.insert(fbOthers, curFB)
	end
end

function FBData.GetLastGateIdRPC()
	return this.lastGateIdRPC
end
function FBData.SetLastGateIdRPC(gateId)
	this.lastGateIdRPC = tonumber(gateId)
end

function FBData.GetGateTitle(chapterId, houseId)
	return tostring(chapterId)..'-'..tostring(houseId)
end

function FBData.GetCurGateTitle()
	local hu = FBData.GetHangUpGate()
	return tostring(hu.chapterId)..'-'..tostring(hu.houseId)
end

function FBData.GetCurChapterId()
	return this.curChapterId
end
function FBData.SetCurChapterId(num)
	if this.curChapterId < num then
		this.SetLastHardLevelRPC(1)
		this.SetLastHouseId(1)
	end
	this.curChapterId = num
	if this.lastChapterId < this.curChapterId then
		this.lastChapterId = this.curChapterId
	end
	if this.curChapterId > this.lastSelectedChapterId then
		this.lastSelectedChapterId = this.curChapterId
	end
	if this.curChapterId == this.lastChapterId then
		FBData.showChapterTips(false)
	end
end

function FBData.showChapterTips(tips)
	PlayerData.playerData.status.chapter = tips and true or false
	Facade:sendNotification(MVCConst.SHOWREDICON, {})
end

function FBData.IncChapterId(chapterId)
	chapterId = tonumber(chapterId) or this.curChapterId
	this.SetCurChapterId(chapterId + 1)
	this.SetCurHardLevel(1)
	this.SetCurHouseId(1)
end
function FBData.DecChapterId(chapterId)
	chapterId = tonumber(chapterId) or this.curChapterId
	local curChapterId = chapterId - 1
	if curChapterId < 1  then
		curChapterId = 1
	end
	this.SetCurChapterId(curChapterId)
	this.SetCurHardLevel2(3)
	this.SetCurHouseId(0)
	this.SetLastHouseId(5)
end

function FBData.IncLastChapterId()
	local nextChapterId = this.lastChapterId + 1
	local fbId = FBData.GetChapterIdRPC2(nextChapterId)
	if TeamData.GetPower() >= FBData.GetChapterPower(fbId) then
		this.SetLastChapterId(nextChapterId)
		this.lastHardLevel = 1
		this.lastHouseId = 1
		FBData.showChapterTips(true)
	end
end
function FBData.DecLastChapterId()
	local lastChapterId = this.lastChapterId - 1
	if lastChapterId < 1  then
		lastChapterId = 1
	end
	this.SetLastChapterId(lastChapterId)
	this.SetLastHardLevel2(3)
	this.lastHouseId = 5
end

function FBData.GetCurChapterIdRPC()
	return this.curChapterId + 100
end

function FBData.GetLastChapterIdRPC()
	return this.lastChapterId + 100
end

function FBData.GetChapterIdByRPC(chapterId)
	local fbId = tonumber(chapterId) or 0
	local  cid = fbId - 100
	if cid < 1 then cid = 1 end
	return cid
end

function FBData.GetLastSelectedChapterId()
	return this.lastSelectedChapterId
end

function FBData.GetLastChapterId()
	return this.lastChapterId
end
function FBData.SetLastChapterId(num)
	local id = tonumber(num) or 1
	if id > this.lastChapterId then
		this.lastChapterId = id
	end
end

function FBData.CheckHardLevel(fbId, hardLevel)
	local ret = 1
	local hl = tonumber(hardLevel)
	local chapter = Config.getFBData()[tostring(fbId)]
	if IsEmptyTable(chapter) then
		error("副本章节找不到: 副本ID[%s]", fbId)
		return ret
	end
	local gateInfo = this.gatesData[tostring(fbId.."01")]
	local max_level = #gateInfo -- chapter["max_level"] 避免可能配错
	if not max_level or max_level < 1 or max_level > 3 then
		error("副本章节最大难度配置出错: 副本ID[%s]", fbId)
		return ret
	end
	if hl < 1 then
		ret = 1
	elseif hl > max_level then
		ret = max_level
	else
		ret = hl
	end
	return ret
end

function FBData.GetMaxHardLevel(fbId)
	local ret = 1
	local chapter = Config.getFBData()[tostring(fbId)]
	if IsEmptyTable(chapter) then
		error("副本章节找不到: 副本ID[%s]", fbId)
		return ret
	end
	local gateInfo = this.gatesData[tostring(fbId.."01")]
	local max_level = #gateInfo -- chapter["max_level"] or 1 避免配错
	if max_level < 1 then
		max_level = 1
	elseif max_level > 3 then
		max_level = 3
	end
	ret = max_level
	return ret
end

function FBData.GetCurHardLevel()
	return this.curHardLevel
end
function FBData.SetCurHardLevel(lvl)
	local hl = tonumber(lvl)
	if not hl or hl < 1 or hl > 3 then
		hl = 1
	end
	this.curHardLevel = hl
end
function FBData.SetCurHardLevel2(lvl)
	local fbId = FBData.GetCurChapterIdRPC()
	local maxLevel = FBData.GetMaxHardLevel(fbId)
	local hl = tonumber(lvl) or 1
	if hl < 1 then hl = 1 end
	if hl > maxLevel then hl = maxLevel end
	this.curHardLevel = hl
end

function FBData.GetSelectedHardLevel()
	return this.selHardLevel
end
function FBData.SetSelectedHardLevel(lvl)
	local hl = tonumber(lvl)
	if not hl or hl < 1 or hl > 3 then
		hl = 1
	end
	this.selHardLevel = hl
end

function FBData.GetLastHardLevel()
	return this.lastHardLevel
end
function FBData.SetLastHardLevel(lvl)
	this.lastHardLevel = tonumber(lvl) or 1
end
function FBData.SetLastHardLevel2(lvl)
	local fbId = FBData.GetLastChapterIdRPC()
	local maxLevel = FBData.GetMaxHardLevel(fbId)
	local hl = tonumber(lvl) or 1
	if hl < 1 then hl = 1 end
	if hl > maxLevel then hl = maxLevel end
	this.lastHardLevel = hl
end

function FBData.GetLastHardLevelRPC()
	return this.lastHardLevelRPC
end
function FBData.SetLastHardLevelRPC(lvl)
	this.lastHardLevelRPC = tonumber(lvl) or 1
end

function FBData.GetHardLevelRPC(fbId)
	fbId = tonumber(fbId) or 0
	if fbId == this.GetCurChapterIdRPC() then
		return this.GetLastHardLevelRPC()
	end

	local data = this.data
	if not IsEmptyTable(data) then
		local dungeons = data.dungeons
		if not IsEmptyTable(dungeons) then
			local fbOthers = dungeons.dungeonsList
			if not IsEmptyTable(fbOthers) then
				for _, char in pairs(fbOthers) do
					local chapter = tonumber(char.dungeonsId)
					local hardLevel = tonumber(char.curLeveL) or 1				-- 注意后台大小写
					if fbId == chapter then
--					plog("@chapter = %s, fbId = %s, hardLevel= %s", chapter, fbId, hardLevel)
						return hardLevel
					end
				end
			end
		end
	end
	return 0
end

function FBData.GetCurHouseId()
	return this.curHouseId
end
function FBData.SetCurHouseId(index)
	local min = 0
	local hid = tonumber(index) or min
	if hid < min then hid = min end
	if hid > 5 then hid = 5 end
	this.curHouseId = hid
	if this.lastHouseId < this.curHouseId then
		this.lastHouseId = this.curHouseId
	end
end

function FBData.GetLastHouseId()
	local retId = this.lastHouseId
	if this.curHardLevel < this.lastHardLevel then
		retId = 5
	elseif this.curHardLevel > this.lastHardLevel then
		retId = 0
	end
	return retId
end
function FBData.SetLastHouseId(index)
	this.lastHouseId = tonumber(index) or 1
end

function FBData.GetHouseIdRPC(fbId)
	fbId = tonumber(fbId) or 0
	if fbId == this.GetCurChapterIdRPC() then
		return this.GetLastHouseId()
	end

	local data = this.data
	if not IsEmptyTable(data) then
		local dungeons = data.dungeons
		if not IsEmptyTable(dungeons) then
			local fbOthers = dungeons.dungeonsList
			if not IsEmptyTable(fbOthers) then
				for _, char in pairs(fbOthers) do
					local chapter = tonumber(char.dungeonsId)
					local houseId = tonumber(this.GetHouseId(char.curIndex))
					if fbId == chapter then
--						plog("##chapter = %s, fbId = %s, houseId= %s", chapter, fbId, houseId)
						return houseId
					end
				end
			end
		end
	end
	return 0
end

function FBData.UpdateRPCInfo(chapterId, lastHardLevel, lastHouseId)
	chapterId = tonumber(chapterId)
	lastHardLevel = tonumber(lastHardLevel)
	lastHouseId = tonumber(lastHouseId)
	
--	plog("$$chapterId = %d, lastHardLevel = %d, chapterId = %d", chapterId, lastHardLevel, lastHouseId)
	local data = this.data
	if not IsEmptyTable(data) then
		local dungeons = data.dungeons
		if not IsEmptyTable(dungeons) then
			local fbOthers = dungeons.dungeonsList
			if not IsEmptyTable(fbOthers) then
				local fbId = FBData.GetChapterIdRPC2(chapterId)
				for _, char in pairs(fbOthers) do
					local chapter = tonumber(char.dungeonsId)
					local hardLevel = tonumber(char.curLeveL) or 1		-- 注意后台大小写
					local houseId = tonumber(this.GetHouseId(char.curIndex))
					if fbId == chapter then
						if lastHardLevel ~= nil then
							char.curLeveL = lastHardLevel
						end
						if lastHouseId ~= nil then
							char.curIndex = FBData.GetGateId(chapterId, lastHouseId)
						end
					end
				end
			end
		end
	end
end

function FBData.GetHangUpGate()
	return this.curHangUpGate
end
function FBData.SetHangUpGate()
	if this.curHouseId == 0 then
		return
	end
	this.curHangUpGate["chapterId"] = this.curChapterId
	this.curHangUpGate["chapterId2"] = this.lastChapterId
	this.curHangUpGate["chapterIdRPC"] = this.GetChapterIdRPC2(this.curChapterId)
	this.curHangUpGate["hardLevel"] = this.curHardLevel
	this.curHangUpGate["hardLevel2"] = this.lastHardLevel
	this.curHangUpGate["hardLevelRPC"] = this.lastHardLevelRPC
	this.curHangUpGate["houseId"] = this.curHouseId
	this.curHangUpGate["houseId2"] = this.lastHouseId
	this.curHangUpGate["isPassed"] = this.IsPassedGate(this.GetGateId(this.curChapterId, this.curHouseId), this.curHardLevel)
end

function FBData.ResetHangUpGate()
	local hu = FBData.GetHangUpGate()
	FBData.SetCurChapterId(hu.chapterId)
	FBData.SetLastChapterId(hu.chapterId2)
	FBData.SetCurHardLevel(hu.hardLevel)
	FBData.SetLastHardLevel(hu.hardLevel2)
	FBData.SetLastHardLevelRPC(hu.hardLevelRPC)
	FBData.SetCurHouseId(hu.houseId)
	FBData.SetLastHouseId(hu.houseId2)
end

function FBData.GetCurDataList()
	return this.curDataList
end
function FBData.SetCurDataList(dataList)
	this.curDataList = CopyTable(dataList)
end

function FBData.GetRewardsCount()
	return this.rewardsCount
end
function FBData.SetRewardsCount(chestObj, count)
	local num = tonumber(count) or 0
	if num < 0 then num = 0 end
	this.rewardsCount = num
	chestObj.text = num.."/3"
end

--function FBData.IsPassedCurGate()
--	if this.GetCurChapterId() <= this.GetLastChapterId() then
--		if this.GetCurHardLevel() < this.GetLastHardLevelRPC() then -- 需要未校验的RPCHardLevel
--			return true
--		elseif this.GetCurHardLevel() == this.GetLastHardLevelRPC() then
--			if this.GetCurHouseId() < this.GetLastHouseId() then
--				return true
--			end
--		end
--	end
--	return false
--end
function FBData.IsPassedCurGate()
	local hu = FBData.GetHangUpGate()
	if hu.chapterId <= this.GetLastChapterId() then
		if hu.hardLevel < hu.hardLevelRPC then -- 需要未校验的RPCHardLevel
			return true
		elseif hu.hardLevel == hu.hardLevelRPC then
			if hu.houseId < hu.houseId2 then
				return true
			end
		end
	end
	return false
end

----<summary>检查是否通过指定关卡(最后两个参数可选，默认为当前章节)</summary>
----<param name="gateId">关卡ID</param>
----<param name="hardLevel">难度值</param>
----<param name="lastHardLevelRPC">服务器难度值</param>
----<param name="lastHouseId">最新关卡下标(1~5)</param>
--function FBData.IsPassedGate(gateId, hardLevel, lastHardLevelRPC, lastHouseId)
--	lastHardLevelRPC = tonumber(lastHardLevelRPC) or this.GetLastHardLevelRPC()
--	lastHouseId = tonumber(lastHouseId) or this.GetLastHouseId()
--	local fbId = FBData.GetChapterIdRPC(gateId)
--	local lastHardLevelRPC2 = FBData.GetHardLevelRPC(fbId)
--	local lastHouseId2 = FBData.GetHouseIdRPC(fbId)

----	plog("@@[%s] chapterId = %d, LastChapterId = %d", gateId, this.GetChapterId(gateId), this.GetLastChapterId())
----	plog("@@[%s] hardLevel = %d, lastHardLevelRPC = %d, lastHardLevelRPC2 = %d", gateId, hardLevel, lastHardLevelRPC, lastHardLevelRPC2)
----	plog("@@[%s] houseId = %d, lastHouseId = %d, lastHouseId2 = %d", gateId, this.GetHouseId(gateId), lastHouseId, lastHouseId2)

--	if this.GetChapterId(gateId) <= this.GetLastChapterId() then
--		if tonumber(hardLevel) < lastHardLevelRPC then
--			return true
--		elseif tonumber(hardLevel) == lastHardLevelRPC then
--			if this.GetHouseId(gateId) < lastHouseId then
--				return true
--			end
--		end
--	end
--	return false
--end

--<summary>检查是否通过指定关卡(最后两个参数可选，默认为当前章节)</summary>
--<param name="gateId">关卡ID</param>
--<param name="hardLevel">难度值</param>
function FBData.IsPassedGate(gateId, hardLevel)
	local fbId = FBData.GetChapterIdRPC(gateId)
	local lastHardLevelRPC = FBData.GetHardLevelRPC(fbId)
	local lastHouseId = FBData.GetHouseIdRPC(fbId)
	local houseId = this.GetHouseId(gateId)

	if this.GetChapterId(gateId) <= this.GetLastChapterId() then
		if tonumber(hardLevel) < lastHardLevelRPC then
			return true
		elseif tonumber(hardLevel) == lastHardLevelRPC then
			if houseId < lastHouseId then
				return true
			end
		end
	end
	return false
end

--<summary>检查是否通过指定章节(最后两个参数可选，默认为当前章节)</summary>
--<param name="chapterId">章节ID</param>
--<param name="lastHardLevelRPC">服务器难度值</param>
--<param name="lastHouseId">最新关卡下标(1~5)</param>
function FBData.IsPassedChapter(chapterId, lastHardLevelRPC, lastHouseId)
	for id = 1, 5 do
		local gateId = FBData.GetGateIdRPC(chapterId, id)
--		if not FBData.IsPassedGate(gateId, 1, lastHardLevelRPC, lastHouseId) then
		if not FBData.IsPassedGate(gateId, 1) then
			return false
		end
	end
	return true
end

function FBData.GetCurChapterPower()
	local fbId = this.GetCurChapterIdRPC()
	return this.GetChapterPower(fbId)
end

function FBData.GetChapterPower(fbId)
	local power = 0
	local fbData = this.fbsData[tostring(fbId)]
	if not IsEmptyTable(fbData) then
		power = tonumber(fbData["power_condition"]) or 0
	end
	return power
end

function FBData.GetGateName(gateId, hardLevel)
	local gates = this.gatesData[tostring(gateId)]
	if not IsEmpty(gates) then
		if gates.gate_level ~= nil then
			ViewUtil.showMsg("关卡表导出异常Array")
		else
			for _, gate in pairs(gates) do
				if tonumber(gate.gate_level) == tonumber(hardLevel) then
					return gate.gate_name
				end
			end
		end
	end
	return " "
end

function FBData.GetCurGateName()
	return this.GetGateName(FBData.GetCurGateId(), this.curHardLevel)
end

function FBData.GetCurGateGold()
	local ret = 0
	local gates = this.gatesData[tostring(this.GetCurGateId())]
	if not IsEmptyTable(gates) then
		for _, gate in pairs(gates) do
			if tonumber(gate.gate_level) == tonumber(this.curHardLevel) then
				local num = tonumber(gate["second_gold"]) or 0
				if num > 0 then
					ret = num
				end
			end
		end
	end
	return ret
end

function FBData.GetGateGold(chapterId, hardLevel, houseId)
	local ret = 0
	local gateId = this.GetGateIdRPC(chapterId, houseId)
	local gates = this.gatesData[tostring(gateId)]
	if not IsEmptyTable(gates) then
		for _, gate in pairs(gates) do
			if tonumber(gate.gate_level) == tonumber(hardLevel) then
				local num = tonumber(gate["second_gold"]) or 0
				if num > 0 then
					ret = num
				end
			end
		end
	end
	return ret
end

function FBData.GetCurGateExp()
	local ret = 0
	local gates = this.gatesData[tostring(this.GetCurGateId())]
	if not IsEmptyTable(gates) then
		for _, gate in pairs(gates) do
			if tonumber(gate.gate_level) == tonumber(this.curHardLevel) then
				local num = tonumber(gate["second_exp"]) or 0
				if num > 0 then
					ret = num
				end
			end
		end
	end
	return ret
end
function FBData.GetGateExp(chapterId, hardLevel, houseId)
	local ret = 0
	local gateId = this.GetGateIdRPC(chapterId, houseId)
	local gates = this.gatesData[tostring(gateId)]
	if not IsEmptyTable(gates) then
		for _, gate in pairs(gates) do
			if tonumber(gate.gate_level) == tonumber(hardLevel) then
				local num = tonumber(gate["second_exp"]) or 0
				if num > 0 then
					ret = num
				end
			end
		end
	end
	return ret
end

function FBData.GetGateIdRPC(chapterId, houseId)
	local lvl = chapterId * 100 + 10000
	local idx = houseId % 100
	local gateId = lvl + idx
	return gateId
end

function FBData.GetGateId(chapterId, houseId)
	local lvl = chapterId*100 + 10000
	local idx = houseId % 100
	local gateId = lvl + idx
	return gateId
end

function FBData.GetCurGateId()
--	return this.GetGateIdRPC(this.curChapterId, this.curHouseId)
	local hu = FBData.GetHangUpGate()
	return this.GetGateIdRPC(hu.chapterId, hu.houseId)
end

function FBData.GetFBStory(fbId)
	local gates = this.gatesData[tostring(fbId)]
	for _, gate in pairs(gates) do
		if tonumber(gate.gate_level) == tonumber(this.curHardLevel) then
			return gate["#gate_story"]
		end
	end
	return "空"
end

function FBData.GetChapterId(gateId)
	gateId = tonumber(gateId) or 0
	if gateId < 10000 then
		error("[GetChapterId] It's not gateId!")
		return 1
	end
	local num = gateId - 10000
	local chapterId = GetIntPart(num / 100)
	return chapterId
end

function FBData.GetChapterIdRPC(gateId)
	gateId = tonumber(gateId) or 0
	if gateId < 10000 then
		error("[GetChapterIdRPC] It's not gateId!")
		return 1
	end
	local fbId = GetIntPart(gateId / 100)
	return fbId
end

function FBData.GetChapterIdRPC2(chapterId)
	chapterId = tonumber(chapterId) or 0
	return chapterId + 100
end

function FBData.GetHouseId(gateId)
	gateId = tonumber(gateId) or 0
	if gateId < 10000 then
		return 1
	end
	local num = gateId - 10000
	local houseId = num % 100
	return houseId
end

function FBData.IncCurHouseId()
	if FBData.IsPassedCurGate() then
		this.curHouseId = this.curHouseId + 1
		if this.curHouseId > 5 then this.curHouseId = 5 end
		if this.curHouseId > this.lastHouseId then
			this.lastHouseId = this.curHouseId
		end
	end
end

function FBData.GetPreHouseId()
	this.curHouseId = this.curHouseId - 1
	if this.curHouseId < 1 then
		this.curHouseId = 1
	end
end

function FBData.GetChapterName(fbId)
	local fbInfo = Config.getFBData()[tostring(fbId)]
	if IsEmpty(fbInfo) then return "NULL" end
	return fbInfo.dungeons_name
end

function FBData.GetCurChapterName()
	return this.GetChapterName(this.GetCurChapterIdRPC())
end

function FBData.InitTimeList(dataList, curGateLevel)
	if IsEmptyTable(dataList) then return end
	local saveData = FBData.LoadData()
	if not IsEmptyTable(saveData) then
		this.totalTime = tonumber(saveData.CT) or 0
		if this.totalTime < 0 then this.totalTime = 0 end
	end
	for _, info in pairs(dataList) do
		local gateId = tonumber(info.gateId)
		local fbId = this.GetChapterIdRPC(gateId)
--		plog("@fbId = ", fbId, ", gateId = ", gateId, ", curLevel = ", info.curLevel, ", curGateLevel = ", curGateLevel)
--		local hardLevel = this.CheckHardLevel(fbId, info.curLevel)
		local hardLevel = this.CheckHardLevel(fbId, curGateLevel)
		local rewards = split(info.boxAwards, ",")
		local count = CountTable(rewards)
		local sumCount = tonumber(info.totalBoxCount) or 0
		if gateId then
			local gateTime = tonumber(info.gateSecond) or 0
			local boxTime = tonumber(info.boxSecond) or 0
--			plog("1.gateId = ", gateId, ", hardLevel = ", hardLevel, ", gateTime = ", gateTime, ", boxTime = ", boxTime)

			if IsEmptyTable(this.rpcTimeList[gateId]) then
				this.rpcTimeList[gateId] = {}
			end
			this.rpcTimeList[gateId][hardLevel] = {gt = gateTime, bt = boxTime}
			
			local gateInfo = this.gatesData[tostring(gateId)] or {}
			for _, info in pairs(gateInfo) do
				if tonumber(info.gate_level) == hardLevel then
					local _gt = tonumber(info["gate_lock_time"]) or 0
					local _ft = tonumber(info["box_first_time"]) or 0
					local _bt = tonumber(info["box_other_time"]) or 0
--					plog("gateId =  %s, _gt = %d, _ft = %d, _bt = %d", gateId, _gt, _ft, _bt)
					if _gt == 0 or _ft == 0 or _bt == 0 then
						error("关卡/宝箱倒计时为零, 关卡ID: %s", gateId)
					end
					if IsEmptyTable(this.cfgTimeList[gateId]) then
						this.cfgTimeList[gateId] = {}
					end
					this.cfgTimeList[gateId][hardLevel] = {gt = _gt, bt = _bt, ft = _ft}
				end
			end
			
			if not IsEmptyTable(this.cfgTimeList[gateId]) then
				local info = this.cfgTimeList[gateId][hardLevel]
				if not IsEmptyTable(info) then
					local gt = tonumber(info.gt) or 0
					local bt = tonumber(info.bt) or 0
					local ft = tonumber(info.ft) or 0
					local isPassed = this.IsPassedGate(gateId, hardLevel)
					gateTime = gt - gateTime
--					plog("GateId = %d, SumCount = %d", gateId, sumCount)
					if sumCount > 0 then
						boxTime =  bt - boxTime
--						plog("Gained >> %s, bt = %d, ft = %d, boxTime = %d", gateId, bt, ft, boxTime)
					else
						boxTime =  ft - boxTime
--						plog("NotGained >> %s, bt = %d, ft = %d, boxTime = %d", gateId, bt, ft, boxTime)
					end
				end
			end

			if gateTime < 0 then gateTime = 0 end
			if boxTime < 0 then boxTime = 0 end
			
			if IsEmptyTable(this.totalTimeList[gateId]) then
				this.totalTimeList[gateId] = {}
			end
			this.totalTimeList[gateId][hardLevel] = {gt = gateTime, bt = boxTime}
			
			if IsEmptyTable(this.lastTimeList[gateId]) then
				this.lastTimeList[gateId] = {}
			end
			this.lastTimeList[gateId][hardLevel] = {gt = gateTime, bt = boxTime}
--			plog("2.gateId = ", gateId, ", hardLevel = ", hardLevel, ", gateTime = ", gateTime, ", boxTime = ", boxTime)
		end
	end
	
--	plog(this.rpcTimeList, "this.rpcTimeList")
--	plog(this.cfgTimeList, "this.cfgTimeList")
--	plog(this.totalTimeList, "this.totalTimeList")
--	plog(this.lastTimeList, "this.lastTimeList")
end

function FBData.GetCfgGateTime()
	local hu = FBData.GetHangUpGate()
	local gateId = FBData.GetGateId(hu.chapterId, hu.houseId)
	local hardLevel = hu.hardLevel
	for id, body in pairs(this.cfgTimeList) do
		if tonumber(id) == gateId then
			if not IsEmptyTable(body[hardLevel]) then
				return tonumber(body[hardLevel].gt) or 0
			end
		end
	end
	return 0
end

function FBData.GetCfgBoxTime()
	local hu = FBData.GetHangUpGate()
	local gateId = FBData.GetGateId(hu.chapterId, hu.houseId)
	local hardLevel = hu.hardLevel
	for id, body in pairs(this.cfgTimeList) do
		if tonumber(id) == gateId then
			if not IsEmptyTable(body[hardLevel]) then
				return tonumber(body[hardLevel].bt) or 0
			end
		end
	end
	return 0
end

function FBData.GetCfgFirstBoxTime()
	local hu = FBData.GetHangUpGate()
	local gateId = FBData.GetGateId(hu.chapterId, hu.houseId)
	local hardLevel = hu.hardLevel
	for id, body in pairs(this.cfgTimeList) do
		if tonumber(id) == gateId then
			if not IsEmptyTable(body[hardLevel]) then
				return tonumber(body[hardLevel].ft) or 0
			end
		end
	end
	return 0
end

function FBData.GetRpcGateTime()
	local hu = FBData.GetHangUpGate()
	local gateId = FBData.GetGateId(hu.chapterId, hu.houseId)
	local hardLevel = hu.hardLevel
	for id, body in pairs(this.totalTimeList) do
		if tonumber(id) == gateId then
			if not IsEmptyTable(body[hardLevel]) then
				return tonumber(body[hardLevel].gt) or 0
			end
		end
	end
	return 0
end

function FBData.GetRpcBoxTime()
	local hu = FBData.GetHangUpGate()
	local gateId = FBData.GetGateId(hu.chapterId, hu.houseId)
	local hardLevel = hu.hardLevel
	for id, body in pairs(this.totalTimeList) do
		if tonumber(id) == gateId then
			if not IsEmptyTable(body[hardLevel]) then
				return tonumber(body[hardLevel].bt) or 0
			end
		end
	end
	return 0
end

function FBData.GetHangGateTime()
	local hu = FBData.GetHangUpGate()
	local gateId = FBData.GetGateId(hu.chapterId, hu.houseId)
	local hardLevel = hu.hardLevel
	for id, body in pairs(this.lastTimeList) do
		if tonumber(id) == gateId then
			if not IsEmptyTable(body[hardLevel]) then
				return tonumber(body[hardLevel].gt) or 0
			end
		end
	end
	return 0
end
function FBData.SetHangGateTime(time)
	local hu = FBData.GetHangUpGate()
	local gateId = FBData.GetGateId(hu.chapterId, hu.houseId)
	local hardLevel = hu.hardLevel
	local _time = tonumber(time) or 0
	if _time < 0 then _time = 0 end
	if IsEmptyTable(this.lastTimeList[gateId]) then
		this.lastTimeList[gateId] = {}
	end
	if IsEmptyTable(this.lastTimeList[gateId][hardLevel]) then
		this.lastTimeList[gateId][hardLevel] = {gt = 0, bt = 0}
	end
	this.lastTimeList[gateId][hardLevel].gt = _time
end

function FBData.GetHangBoxTime()
	local hu = FBData.GetHangUpGate()
	local gateId = FBData.GetGateId(hu.chapterId, hu.houseId)
	local hardLevel = hu.hardLevel
	for id, body in pairs(this.lastTimeList) do
		if tonumber(id) == gateId then
			if not IsEmptyTable(body[hardLevel]) then
				return tonumber(body[hardLevel].bt) or 0
			end
		end
	end
	return 0
end
function FBData.SetHangBoxTime(time)
	local hu = FBData.GetHangUpGate()
	local gateId = FBData.GetGateId(hu.chapterId, hu.houseId)
	local hardLevel = hu.hardLevel
	local _time = tonumber(time) or 0
	if _time < 0 then _time = 0 end
	if IsEmptyTable(this.lastTimeList[gateId]) then
		this.lastTimeList[gateId] = {}
	end
	if IsEmptyTable(this.lastTimeList[gateId][hardLevel]) then
		this.lastTimeList[gateId][hardLevel] = {gt = 0, bt = 0}
	end
	this.lastTimeList[gateId][hardLevel].bt = _time
end

function FBData.GetHangTimeProcess()
	local gt = FBData.GetHangGateTime()
	local gtRpc = FBData.GetCfgGateTime()
	local bt = FBData.GetHangBoxTime()
	local btRpc = FBData.GetCfgGateTime()
--	plog("$$gt = %d, gtRpc = %d, bt = %d, btRpc = %d", gt, gtRpc, bt, btRpc)
	local gtRate = 1
	if gtRpc > 0 then
		gtRate = 1 - gt/gtRpc
	end
	local btRate = 1
	if btRpc > 0 then
		btRate = 1 - bt/btRpc
	end
	if gtRate < 0 then gtRate = 0 end
	if gtRate > 1 then gtRate = 1 end
	if btRate < 0 then btRate = 0 end
	if btRate > 1 then btRate = 1 end
	return gtRate, btRate
end

function FBData.LoadData()
	local data = DecodeJsonFile(GateDataPath)
	return data
end

function FBData.SaveData()
	this.totalTime = this.totalTime + (Time.timeSinceLevelLoad - this.countTime)
	this.countTime = Time.timeSinceLevelLoad
	EncodeJsonFile(GateDataPath, {CT = this.totalTime})
end

function FBData.checkPower(fbId, notMsg)
	local needPower = 0
	if not fbId then
		needPower = FBData.GetCurChapterPower()
	else
		needPower = FBData.GetChapterPower(fbId)
	end
	plog("-->CheckPower[%d], NeedPower[%d]", TeamData.GetPower(), needPower)
	if TeamData.GetPower() < needPower then
		if not notMsg then
			local msg = string.format("战力不足,所需战力:%d", needPower)
			ViewUtil.showMsg(msg)
		end
		return false
	end
	return true
end

--[[
    初始化新手引导需要的数据
    2016-11-16 14:12:24 library
]]
function FBData.guideInitData ()
    this.guideCurChapterId = 101;--当前章节
    this.guideCurHouseId = 10101;--当前关卡
    this.guideCurHardLvl = 1;--当前难度
    this.guideChaptersMap = Map.new();--开启的章节中每一章的最大通关关卡、难度信息
end

--[[
    新手引导使用的数据，引导结束后，就不再同步数据
    add by library 2016-11-16 12:00:11 同步新手引导用到的副本数据
]]
function FBData.guideUseData ()
    local tdata = this.data.dungeons;
    local tdData = nil;--TeamDungeonsData
    local chapterInfoTmp = nil;
    
    if (not PlayerData.guideNotEnd()) then
        --新手引导结束，不再同步数据
        return ;
    end
	
    this.guideCurChapterId = tdata.curDungeons.dungeonsId;
    this.guideCurHouseId = tdata.gateInfo.gateId;
    this.guideCurHardLvl = tdata.curGateLevel;
    
    --存储每一章的最大通关关卡、难度信息
    for i = 1, #tdata.dungeonsList do
        tdData = tdata.dungeonsList[i];
        chapterInfoTmp = this.guideChapterMaxHouseAndLvl(tdData.dungeonsId, tdData.curIndex, tdData.curLeveL);
        if (chapterInfoTmp) then
            if (this.guideChaptersMap:containsKey(tdData.dungeonsId)) then
                this.guideChaptersMap:remove(tdData.dungeonsId);
            end
            this.guideChaptersMap:put(tdData.dungeonsId, chapterInfoTmp);
        end
    end
    
    --存储当前挂机章节的最大通关关卡、难度信息
    chapterInfoTmp = this.guideChapterMaxHouseAndLvl(tdata.curDungeons.dungeonsId, tdata.curDungeons.curIndex, tdata.curDungeons.curLeveL);
    if (chapterInfoTmp) then
        if (this.guideChaptersMap:containsKey(tdata.curDungeons.dungeonsId)) then
            this.guideChaptersMap:remove(tdata.curDungeons.dungeonsId);
        end
        this.guideChaptersMap:put(tdata.curDungeons.dungeonsId, chapterInfoTmp);
    end
--    for i = 1, this.guideChaptersMap:size() do
--        plog(this.guideChaptersMap:value(this.guideChaptersMap:key(i)));
--    end
end

--[[
    某章节的最大通关关卡、难度信息，未有通关关卡时，返回nil
    add by library 2016-11-16 12:00:02 同步新手引导用到的副本数据
    _dungeonsId number 101
    _curIndex number 10101或1
    _curLevel number 1
    return table {id = ..., idx = ..., lvl = ...}
]]
function FBData.guideChapterMaxHouseAndLvl (_dungeonsId, _curIndex, _curLevel)
--	plog("_dungeonsId = %s, _curIndex = %s, _curLevel = %s", tostring(_dungeonsId), tostring(_curIndex), tostring(_curLevel))
    local chapterInfoTmp = nil;
    local houseIdTmp, lvlTmp = nil, nil;
    
	-- 修复注销账号，重新登录不了问题， by kenny at 2016/12/6
	if _curIndex == nil then
		_curIndex = 0
	end

    houseIdTmp = GetIntPart(_curIndex % 100);
    lvlTmp = _curLevel;
    houseIdTmp = houseIdTmp - 1;
    
    if (houseIdTmp < 1) then
        houseIdTmp = guideMaxHouseId;
        lvlTmp = lvlTmp - 1;
    end

    houseIdTmp = 100 * _dungeonsId + houseIdTmp;
    if (lvlTmp > 0) then
        chapterInfoTmp = {id = _dungeonsId, idx = houseIdTmp, lvl = lvlTmp};
    end
    
    return chapterInfoTmp;
end

--[[
    设置挂机的章节、关卡、难度信息
    add by library 2016-11-16 11:59:49 同步新手引导用到的副本数据
    _dungeonsId number 101
    _curIndex number 10101或1
    _curLevel number 1
]]
function FBData.guideSetCurHangHouseInfo (_dungeonsId, _curIndex, _curLevel)
    if (not PlayerData.guideNotEnd()) then
        --新手引导结束，不再同步数据
        return ;
    end
    this.guideCurChapterId = _dungeonsId;--当前章节
    this.guideCurHouseId = _curIndex;--当前关卡
    this.guideCurHardLvl = _curLevel;--当前难度
end

--[[
    设置挂机的章节的最大通关关卡、难度信息
    _tdd TeamDungeonsData
]]
function FBData.guideCurChapterMaxHouseAndLvl (_tdd)
    local curLvlTmp, maxHouseIdTmp = 0, 0;
    local tidTmp, mapVal = nil, nil;
    
    if (not PlayerData.guideNotEnd()) then
        --新手引导结束，不再同步数据
        return ;
    end
    
    if (_tdd) then
        for i = 1, #_tdd.infoDataList do
            tidTmp = _tdd.infoDataList[i];
            if (_tdd.curGateLevel and tidTmp.curLevel > _tdd.curGateLevel) then
                if (tidTmp.gateId > maxHouseIdTmp) then
                    maxHouseIdTmp = tidTmp.gateId;
                end
            end
        end
        
        if (0 ~= maxHouseIdTmp) then
            --当前难度有通过的关卡
            mapVal = {id = _tdd.dungeonsId, idx = maxHouseIdTmp, lvl = _tdd.curGateLevel};
        elseif (_tdd.curGateLevel > 1) then
            --仅上一难度的所有关卡都通过了
            mapVal = {id = _tdd.dungeonsId, idx = _tdd.dungeonsId * 100 + guideMaxHouseId, lvl = _tdd.curGateLevel - 1};
        end

        if (mapVal) then
            if (this.guideChaptersMap:containsKey(_tdd.dungeonsId)) then
                this.guideChaptersMap:remove(_tdd.dungeonsId);
            end
            this.guideChaptersMap:put(_tdd.dungeonsId, mapVal);
        end
    end
end

--[[
    当前挂机关卡
    return number
]]
function FBData.guideGetCurGateId ()
    return this.guideCurHouseId;
end

--[[
    当前挂机难度
    return number
]]
function FBData.guideGetCurHardLvl ()
    return this.guideCurHardLvl;
end

--[[
    判断当前难度的关卡是否通过
    _houseId number 关卡ID 10101
    _hardLvl number 难度 1
    return boolean 
]]
function FBData.guideIsPassedGate (_houseId, _hardLvl)
    local chapterIdTmp, houseIdTmp, hardLvlTmp = nil, nil, nil;
    local chapterInfoTmp, isPassTmp = nil, false;
    
    _houseId = tonumber(_houseId) or 1;
    _hardLvl = tonumber(_hardLvl) or 1;
    houseIdTmp = _houseId;
    hardLvlTmp = _hardLvl;
    chapterIdTmp = GetIntPart(houseIdTmp / 100);
    chapterInfoTmp = this.guideChaptersMap:value(chapterIdTmp);
    
    if (chapterInfoTmp) then
        if (hardLvlTmp < chapterInfoTmp.lvl or hardLvlTmp == chapterInfoTmp.lvl and houseIdTmp <= chapterInfoTmp.idx) then
            isPassTmp = true;
        end
    end
    
    return isPassTmp;
end

--[[
    测试使用，显示副本信息
    add by library 2016-11-16 11:59:56 同步新手引导用到的副本数据
]]
function FBData.libShowData ()
    local tdata = this.data.dungeons;
    error("data.curGateLevel__" .. tdata.curGateLevel);
    
    error("data.curDungeons__dungeonsId__" .. tdata.curDungeons.dungeonsId .. "_curLeveL_" .. tdata.curDungeons.curLeveL .. "_curIndex_" .. tdata.curDungeons.curIndex .. "_curGateLevel_" .. tdata.curDungeons.curGateLevel);

    error("data.gateInfo__gateId__" .. tdata.gateInfo.gateId .. "_curLevel_" .. tdata.gateInfo.curLevel .. "_boxAwards_" .. tdata.gateInfo.boxAwards .. "_boxSecond_" .. tdata.gateInfo.boxSecond .. "_gateSecond_" .. tdata.gateInfo.gateSecond .. "_totalBoxCount_" .. tdata.gateInfo.totalBoxCount);

    error("----------------------------dungeonsList start");
    for i = 1, #tdata.dungeonsList do
        local tmp = tdata.dungeonsList[i];
        error(i .. "__dungeonsId__" .. tmp.dungeonsId .. "_curLeveL_" .. tmp.curLeveL .. "_curIndex_" .. tmp.curIndex .. "_curGateLevel_" .. tmp.curGateLevel);
    end
    error("----------------------------dungeonsList end");
end

function FBData.GetChestTimeProcess(_tp)
	local gt = FBData.GetHangBoxTime()

	local gtRpc = nil
	if _tp == 0 then
		gtRpc = FBData.GetCfgFirstBoxTime()
	elseif _tp ==1 then
		gtRpc = FBData.GetCfgBoxTime()
	end

	local gtRate = 1
	if gtRpc > 0 then
		gtRate = 1 - gt/gtRpc
	end

	if gtRate < 0 then gtRate = 0 end
	if gtRate > 1 then gtRate = 1 end

	return gtRate
end