--游戏配置数据类
--2016-8-29 11:15:31 library

local const_cfgKey = "key";
local const_cfgVal = "value";
local const_cfgRemark = "remark";
local const_cfgUnlock = "#unlock"
local const_drop_drop_id = "drop_id";
local const_drop_drop_type = "drop_type";
local const_drop_prop_id = "prop_id";
local const_drop_min_num = "min_num";
local const_drop_max_num = "max_num";
local const_drop_probaility = "probaility";
local const_drop_remark = "remark";

local const_luckyPumpOfGold = "Team_Hero_Call_Gold";
local const_luckyPumpOfDiamond = "Team_Hero_Call_Diamonds";
local const_maxHeroNumPerTeam = "Max_Hero_Count";
local const_heroCallRefreshTime = "Team_Hero_Call_Time";

local const_luckRecruitPieceCost_1 = "Team_Hero_Exchange_Blue_Piece";
local const_luckRecruitPieceCost_2 = "Team_Hero_Exchange_Blue_Piece";
local const_luckRecruitPieceCost_3 = "Team_Hero_Exchange_Blue_Piece";
local const_luckRecruitPieceCost_4 = "Team_Hero_Exchange_Violet_Piece";
local const_luckRecruitPieceCost_5 = "Team_Hero_Exchange_Golden_Piece";
local const_luckRecruitPieceCost_6 = "Team_Hero_Exchange_GoldenFlash_Piece";

local const_pieceNumOfFireHero_1 = "Team_Hero_fire_White_Piece";
local const_pieceNumOfFireHero_2 = "Team_Hero_fire_Green_Piece";
local const_pieceNumOfFireHero_3 = "Team_Hero_fire_Blue_Piece";
local const_pieceNumOfFireHero_4 = "Team_Hero_fire_Violet_Piece";
local const_pieceNumOfFireHero_5 = "Team_Hero_fire_Golden_Piece";
local const_pieceNumOfFireHero_6 = "Team_Hero_fire_GoldenFlash_Piece";

local heroCallRefreshTime = nil;

local effectStatus = 1
local bgmName = nil
local broadcast = ""

GameCfgDataProxy = {

};

local this = GameCfgDataProxy;

--[[
    根据key值取gameConfig表中的value值
    _key string
    return string gameConfig表中的value值
]]
function GameCfgDataProxy.getGameCfgDataByKey (_key)
    local valStr = "";
    local gCfgData = Config.getGameCfgData();

    if (nil ~= _key) then
        for k, v in pairs(gCfgData) do
            if (tostring(v[const_cfgKey]) == tostring(_key)) then
                valStr = tostring(v[const_cfgVal]);
                break ;
            end
        end
    end
    
    valStr = valStr or "";

    return valStr;
end

--[[
    根据key值取gameConfig表中的unlock值
    _key string
    return string gameConfig表中的unlock值
]]
function GameCfgDataProxy.getGameCfgUnlockByKey (_key)
    local valStr = "";
    local gCfgData = Config.getGameCfgData();

    if (nil ~= _key) then
        for k, v in pairs(gCfgData) do
            if (tostring(v[const_cfgKey]) == tostring(_key)) then
                valStr = tostring(v[const_cfgUnlock]);
                break ;
            end
        end
    end
    
    valStr = valStr or "";

    return valStr;
end

--[[
    根据英雄配置ID，取解雇可获得的时空碎片数量
    _heroId number 英雄的配置ID 
    return number 可获得的时空碎片数量
]]
function GameCfgDataProxy.getPieceNumByFireHero (_heroId)
    local pieceNum = 1;
    local keyStr = "";
    local heroCfg, heroQua = nil, 1;

    heroCfg = HeroDataProxy.getHeroCfgById(_heroId);
    heroQua = tonumber(HeroDataProxy.getHeroQuality(heroCfg)) or 1;

    if (1 == heroQua) then
        keyStr = const_pieceNumOfFireHero_1;
    elseif (2 == heroQua) then
        keyStr = const_pieceNumOfFireHero_2;
    elseif (3 == heroQua) then
        keyStr = const_pieceNumOfFireHero_3;
    elseif (4 == heroQua) then
        keyStr = const_pieceNumOfFireHero_4;
    elseif (5 == heroQua) then
        keyStr = const_pieceNumOfFireHero_5;
    elseif (6 == heroQua) then
        keyStr = const_pieceNumOfFireHero_6;
    end

    pieceNum = tonumber(GameCfgDataProxy.getGameCfgDataByKey(keyStr)) or 1;
    
    return pieceNum;
end

--[[
    根据英雄的品质，获取招募消耗的时空碎片数量
    _quality number 英雄的品质
    return number 需消耗的时空碎片数量
]]
function GameCfgDataProxy.getLuckRecruitPieceCost (_quality)
    local cost = 1;
    local keyStr = "";

    _quality = tonumber(_quality) or 1;
    if (1 == _quality) then
        keyStr = const_luckRecruitPieceCost_1;
    elseif (2 == _quality) then
        keyStr = const_luckRecruitPieceCost_2;
    elseif (3 == _quality) then
        keyStr = const_luckRecruitPieceCost_3;
    elseif (4 == _quality) then
        keyStr = const_luckRecruitPieceCost_4;
    elseif (5 == _quality) then
        keyStr = const_luckRecruitPieceCost_5;
    elseif (6 == _quality) then
        keyStr = const_luckRecruitPieceCost_6;
    end

    cost = tonumber(GameCfgDataProxy.getGameCfgDataByKey(keyStr)) or 1;

    return cost;
end

--[[
    根据召唤类型，获得召唤消耗的货币数量
    _tp number 召唤类型 1，金币；2，钻石；3，活动
    return number 消耗的货币数量
]]
function GameCfgDataProxy.getLuckyPickupCostByType (_tp)
    local costMny, keyStr = 0, nil;
    local gCfgData = Config.getGameCfgData();
    
    _tp = _tp or 0;
    if (1 == _tp) then
        keyStr = const_luckyPumpOfGold;
    elseif (2 == _tp) then
        keyStr = const_luckyPumpOfDiamond;
    end

    if (nil ~= keyStr) then
        costMny = tonumber(GameCfgDataProxy.getGameCfgDataByKey(keyStr));
    end
    costMny = costMny or 0;
    return costMny;
end

--[[
    根据key取gameDrop.json中的行数据
    _key string "key"
    return table 
]]
function GameCfgDataProxy.getDropValueByName (_key)
    local cfgVal, dropVal = nil, {};
    local gCfgData, gDropData = Config.getGameCfgData(), Config.getGameDropData();

    for k, v in pairs(gCfgData) do
        if (_key == v[const_cfgKey]) then
            cfgVal = v[const_cfgVal];
            break ;
        end
    end
    
    if (nil ~= cfgVal) then
        for k, v in pairs(gDropData) do
            if (tonumber(cfgVal) == tonumber(v[const_drop_drop_id])) then
                table.insert(dropVal, v);
            end
        end
    end

    return dropVal;
end

--[[
    取drop_id
    _dropData gameDrop.json中的行
    return string
]]
function GameCfgDataProxy.getDropId (_dropData)
    local dropId = nil;

    if (nil ~= _dropData) then
        dropId = _dropData[const_drop_drop_id];
    end

    dropId = dropId or "";

    return dropId;
end

--[[
    取drop_type
    _dropData gameDrop.json中的行
    return string
]]
function GameCfgDataProxy.getDropType (_dropData)
    local dropType = nil;

    if (nil ~= _dropData) then
        dropType = _dropData[const_drop_drop_type];
    end

    dropType = dropType or "";

    return dropType;
end

--[[
    取prop_id
    _dropData gameDrop.json中的行
    return string
]]
function GameCfgDataProxy.getPropId (_dropData)
    local dropPropId = nil;

    if (nil ~= _dropData) then
        dropPropId = _dropData[const_drop_prop_id];
    end

    dropPropId = dropPropId or "";

    return dropPropId;
end

--[[
    取min_num
    _dropData gameDrop.json中的行
    return string
]]
function GameCfgDataProxy.getMinNum (_dropData)
    local dropMinNum = nil;

    if (nil ~= _dropData) then
        dropMinNum = _dropData[const_drop_min_num];
    end

    dropMinNum = dropMinNum or "";

    return dropMinNum;
end

--[[
    取max_num
    _dropData gameDrop.json中的行
    return string
]]
function GameCfgDataProxy.getMaxNum (_dropData)
    local dropMaxNum = nil;

    if (nil ~= _dropData) then
        dropMaxNum = _dropData[const_drop_max_num];
    end

    dropMaxNum = dropMaxNum or "";

    return dropMaxNum;
end

--[[
    获取每个玩家英雄背包中可存放的最大英雄数量
    return number 数量最大值
]]
function GameCfgDataProxy.getMaxHeroNumPerTeam ()
    local num = 1;

    num = tonumber(this.getGameCfgDataByKey(const_maxHeroNumPerTeam));

    num = num or 1;
    return num;
end

--[[
    获取召唤模块的祭坛招募的刷新时间
]]
function GameCfgDataProxy.getHeroCallRefreshTime (reLogin)
    local time = 0;

    if (reLogin or (nil == heroCallRefreshTime)) then
        time = tonumber(GameCfgDataProxy.getGameCfgDataByKey(const_heroCallRefreshTime));
        time = time or 0;
        heroCallRefreshTime = time;
    end

    return heroCallRefreshTime;
end

function GameCfgDataProxy:SetEffectStatus(_val)
    effectStatus = tonumber(_val)
end

function GameCfgDataProxy.GetEffectStatus()
    return effectStatus
end

function GameCfgDataProxy:SetBgmName(name)
    bgmName = name
end

function GameCfgDataProxy.GetBgmName()
    return bgmName
end

function GameCfgDataProxy.SetBroadcast(_brocastStr)
    broadcast = _brocastStr
end

function GameCfgDataProxy.GetBroadcast()
    return broadcast
end

--[[
    根据_key取_cfg中的val
    _cfg cfg
    _key key
    return _cfg中的val
]]
function GameCfgDataProxy.getCfgVal (_cfg, _key)
    local val = nil;

    if (_cfg) then
        val = _cfg[_key];
    end

    return val;
end