--英雄相关数据处理
--2016-6-23 19:30:41 library

local const_quaOne = "白色";
local const_quaTwo = "绿色";
local const_quaThree = "蓝色";
local const_quaFour = "紫色";
local const_quaFive = "金色";
local const_quaSix = "闪金";

local const_heroNameDef = "英雄";
local const_heroCfgQuaKey = "quality";
local const_heroCfgAtlasKey = "#prefab_name";
local const_heroCfgNameKey = "hero_name";
local const_heroPower = "power";
local const_heroGrown = "grown";
local const_heroXG = "xg";
local const_heroWZ = "wz";
local const_heroSB = "sb";
local const_heroFY = "fy";
local const_heroContent = "#content";
local const_heroDesc = "#desc";

local const_heroLvlupKey = "exp";
local const_heroWakeupKey = "gold";
local const_heroStrongPercent = "probility";
local const_heroStrongProps = "props";

local const_lvl_show = "#lv_show";
local const_wise_show = "#wise_show";

HeroDataProxy = {
    _allHeroNum = 0;
    const_basepower = "base_power";
    maxStrongLvl = 30;
    maxWakeLvl = 5;
    heroQua = {const_quaOne, const_quaTwo, const_quaThree, const_quaFour, const_quaFive, const_quaSix};
    const_MaxHeroId = 20000;
    const_MaxSysHeroId = 2;
    newHeroList = List.new();
};

local this = HeroDataProxy;

--[[
    所有的英雄数目
    return number
]]
function HeroDataProxy.allHeroNum ()
    if (0 == this._allHeroNum) then
        for k, v in pairs(Config.getHerosData()) do
            if (tonumber(k) < this.const_MaxHeroId and tonumber(k) > this.const_MaxSysHeroId) then
                this._allHeroNum = this._allHeroNum + 1;
            end
        end
    end

    return this._allHeroNum;
end


--[[
    同步英雄数据
    _data PushHeroData
    return nil
]]
function HeroDataProxy.csistHeros (_data)
    local hData, localData = nil, nil;
    local hList = List.new();
    
    for i = 1, #_data.heroList do
        hData = _data.heroList[i];
        localData = TeamData.getMyHeroDataById(hData.id);
        
        if ("ADD" == _data.status) then
            --新增
            if (nil == localData) then
                this.addMyHero(hData);
                hList:add(hData);
            else
                ViewUtil.showMsg("id重复");
                error("id:" .. hData.id .. "|heroId: " .. hData.heroId);
            end
        elseif ("DEL" == _data.status) then
            --删除
            if (nil ~= localData) then
                this.removeMyHero(hData.id);
            end
        elseif ("REP" == _data.status) then
            --替换
            if (nil ~= localData) then
                this.addMyHero(hData);
            end
        end
    end
    
    if (hList:getSize() > 0) then
        if (1 == hList:getSize() and not HeroDataProxy.isEverGet(hList[1])) then
            this.newHeroList:add(hList[1]);
            ViewUtil.showNewHeros();
        else
            for i = 1, hList:getSize() do
                if (not HeroDataProxy.isEverGet(hList[i])) then
                    this.newHeroList:add(hList[i]);
                end
            end
            --显示获得的英雄
            ViewUtil.ShowHeros(hList);
        end
        --同步已获得英雄列表
        for i = 1, hList:getSize() do
            if (not HeroDataProxy.isEverGet(hList[i])) then
                TeamData.setAlreadyGotHeros({hList[i].heroId});
            end
        end
    end
end

--[[
    添加我的英雄数据
    _hData HeroData
    return nil
]]
function HeroDataProxy.addMyHero (_hData)
    local localData = TeamData.getMyHeroDataById(_hData.id);
    
    if (nil ~= localData) then
        this.removeMyHero(_hData.id);
    end
    
    table.insert(PlayerData.playerData.team.heros, _hData);
end

--[[
    删除我的英雄数据
    _id number
    return nil
]]
function HeroDataProxy.removeMyHero (_id)
    for i = 1, #PlayerData.playerData.team.heros do
        if (_id == PlayerData.playerData.team.heros[i].id) then
            table.remove(PlayerData.playerData.team.heros, i);
            break ;
        end
    end
end

--[[
    获取指定英雄的配置表
    _heroId 英雄配置ID
    return table
]]
function HeroDataProxy.getHeroCfgById(_heroId)
    local rtn = nil;

    for k, v in pairs(Config.getHerosData()) do
        if (tonumber(_heroId) == tonumber(k)) then
            rtn = v;
            break ;
        end
    end
    
    return rtn;
end

--[[
    获取英雄的品质
    _heroCfg
    return number
]]
function HeroDataProxy.getHeroQuality (_heroCfg)
    local rtn = 1;

    if (nil ~= _heroCfg) then
        rtn = tonumber(_heroCfg[const_heroCfgQuaKey]);
    end

    rtn = rtn or 1;

    return rtn;
end

--[[
    获取英雄的图集名称
    _heroCfg
    return string
]]
function HeroDataProxy.getHeroAtlasName(_heroCfg)
    local rtn = "";

    if (nil ~= _heroCfg) then
        rtn = tostring(_heroCfg[const_heroCfgAtlasKey]);
    end

    rtn = rtn or "";

    return rtn;
end

--[[
    获取英雄的中文名
    _heroCfg
    return string
]]
function HeroDataProxy.getHeroName(_heroCfg)
    local rtn = "";

    if (nil ~= _heroCfg) then
        rtn = tostring(_heroCfg[const_heroCfgNameKey]);
    end

    rtn = rtn or const_heroNameDef;

    return rtn;
end

--[[
    或取英雄的基础战力
    _heroCfg
    return number
]]
function HeroDataProxy.getHeroBasePower (_heroCfg)
    local basePower = 0;

    if (nil ~= _heroCfg) then
        basePower = tonumber(_heroCfg[const_heroPower]);
    end

    basePower = basePower or 0;

    return basePower;
end

--[[
    获取英雄的成长值
    _hCfg
    return number
]]
function HeroDataProxy.getHeroGrown (_hCfg)
    local grow = 0;

    if (nil ~= _hCfg) then
        grow = tonumber(_hCfg[const_heroGrown]);
    end
    grow = grow or 0;

    return grow;
end

--[[
    取英雄的先攻
    _hCfg HeroCfg
    return number
]]
function HeroDataProxy.getHeroXG (_hCfg)
    local xg = 0;

    xg = _hCfg[const_heroXG];
    xg = xg or 0;

    return xg;
end

--[[
    取英雄的王者
    _hCfg HeroCfg
    return number
]]
function HeroDataProxy.getHeroWZ (_hCfg)
    local wz = 0;

    wz = _hCfg[const_heroWZ];
    wz = wz or 0;

    return wz;
end

--[[
    取英雄的防御
    _hCfg HeroCfg
    return number
]]
function HeroDataProxy.getHeroFY (_hCfg)
    local fy = 0;

    fy = _hCfg[const_heroFY];
    fy = fy or 0;

    return fy;
end

--[[
    取英雄的闪避
    _hCfg HeroCfg
    return number
]]
function HeroDataProxy.getHeroSB (_hCfg)
    local sb = 0;

    sb = _hCfg[const_heroSB];
    sb = sb or 0;

    return sb;
end

--[[
    取英雄的desc
    return string 
]]
function HeroDataProxy.getHeroDesc (_hCfg)
    local str = "";

    if (nil ~= _hCfg) then
        str = _hCfg[const_heroDesc];
    end
    str = str or "";

    return str;
end

--[[
    取英雄的content
    return string 
]]
function HeroDataProxy.getHeroContent (_hCfg)
    local str = "";

    if (nil ~= _hCfg) then
        str = _hCfg[const_heroContent];
    end
    str = str or "";

    return str;
end

--[[
    计算英雄的能力值
    _heroId number 英雄ID
    _lvl number 英雄等级
    _wiseup number 英雄觉醒
    _stnthn number 强化
    return number 能力值
]]
function HeroDataProxy.getHeroAbility (_heroId, _lvl, _wiseup, _stnthn)
    local ablty = 0;
    local stnAbility, baseAbility, lvlAbility, wakeAbility, growAbility = 0, 0, 0, 0, 0;
    local heroCfg = this.getHeroCfgById(_heroId);
    
    baseAbility = this.getHeroBasePower(heroCfg);
    lvlAbility = this.getHeroLvlPower(_lvl);
    wakeAbility = this.getHeroWakePower(_wiseup);
    stnAbility = this.getHeroStrongPower(_stnthn);
    growAbility = this.getHeroGrown(heroCfg);
    
    --战斗力 = ( 1 + 强化值 / 100 ) * ( 初始战斗力 + ( 等级战斗力 + 觉醒战斗力 ) * 成长值 )
    ablty = (1 + stnAbility / 100) * (baseAbility + (lvlAbility + wakeAbility) * growAbility / 100);
    ablty = GetIntPart(ablty);

    return ablty;
end

--[[
    计算英雄升级消耗的经验
    _tarLvl 目标等级
    return number 消耗的经验
]]
function HeroDataProxy.getHeroLvlDeltaExp (_tarLvl)
    local needExp = 0;

    _tarLvl = _tarLvl or 1;

    needExp = HeroDataProxy.getHeroLvlExp(_tarLvl);
    needExp = (needExp >= 0) and needExp or 0;

    return needExp;
end

--[[
    获取指定等级的经验
    _lvl 等级
    return number 对应的经验
]]
function HeroDataProxy.getHeroLvlExp(_lvl)
    local exp, expTab = 0, nil;
    local heroLvlupData = Config.getHeroLvlupSubLvlup();

    expTab = heroLvlupData[_lvl .. ""];

    if (nil ~= expTab) then
        exp = expTab[const_heroLvlupKey];
    end
    exp = exp or 0;

    return exp;
end

--[[
    获取指定觉醒等级金币
    _wakeup number 觉醒等级
    return number 金币
]]
function HeroDataProxy.getHeroWakeupGold(_wakeup)
    local gold = 0;

    gold = tonumber(Config.getHeroLvlupSubWake()[_wakeup .. ""][const_heroWakeupKey]);
    
    gold = gold or 0;

    return gold;
end

--[[
    计算英雄强化消耗的经验
    _curSrtn 当前强化等级
    _tarSrtn 目标强化等级
    return 消耗的经验
]]
function HeroDataProxy.getHeroItsfyDeltaExp (_curSrtn, _tarSrtn)
    local needExp = 0;

    _curSrtn = _curSrtn or 1;
    _tarSrtn = _curSrtn or _curSrtn;

    return needExp;
end

--[[
    解雇获得的碎片数量
    hId number
    return number
]]
function HeroDataProxy.getHeroPiecs (hId)
    local pieceNum = 0;

    return pieceNum;
end

--[[
    取英雄的升级等级对应的能力值
    _lvl number 升级等级
    return number 能力值
]]
function HeroDataProxy.getHeroLvlPower (_lvl)
    local lvlAbility = 0;

    _lvl = _lvl or 0;
    lvlAbility = Config.getHeroLvlupSubLvlup()["" .. _lvl][this.const_basepower];
    lvlAbility = lvlAbility or 0;

    return lvlAbility;
end

--[[
    取英雄的强化等级对应的能力值
    _strongLvl number 强化等级
    return number 能力值
]]
function HeroDataProxy.getHeroStrongPower (_strongLvl)
    local strongAbility = 0;

    _strongLvl = _strongLvl or 0;
    strongAbility = Config.getHeroLvlupSubStrong()["" .. _strongLvl][this.const_basepower];
    strongAbility = strongAbility or 0;

    return strongAbility;
end

--[[
    取英雄的觉醒等级对应的能力值
    _wakeLvl number 觉醒等级
    return number 能力值
]]
function HeroDataProxy.getHeroWakePower (_wakeLvl)
    local wakeAbility = 0;
    local subWake, lvlVal = nil, nil;
    
    _wakeLvl = _wakeLvl or 0;
    subWake = Config.getHeroLvlupSubWake();
    if (subWake) then
        lvlVal = Config.getHeroLvlupSubWake()["" .. _wakeLvl];
        if (nil ~= lvlVal) then
            wakeAbility = lvlVal[this.const_basepower];
        end
    end
--    wakeAbility = Config.getHeroLvlupSubWake()["" .. _wakeLvl][this.const_basepower];
    wakeAbility = wakeAbility or 0;

    return wakeAbility;
end

--[[
    取英雄的强化等级对应的基础强化成功率
    _lvl
    return number 强化成功率
]]
function HeroDataProxy.getHeroStrongPer (_lvl)
    local per = 0;

    _lvl = _lvl or 0;

    per = tonumber(Config.getHeroLvlupSubStrong()["" .. _lvl][const_heroStrongPercent]);
    per = per or 0;

    return per;
end

--[[
    取英雄的强化等级对应消耗的道具
    _lvl number 
    return List
]]
function HeroDataProxy.getHeroStrongProps (_lvl)
    local propsList, propsStr = List.new(), "";
    local perProp, tmpTab, tmpList = nil, nil, List.new();
    local tmpObj = nil;

    tmpObj = Config.getHeroLvlupSubStrong()["" .. _lvl];

    if (nil ~= tmpObj) then
        propsStr = tmpObj[const_heroStrongProps];
    end
    propsStr = propsStr or "";
    --二级分隔符,，暂未使用更高级的分隔符
    tmpTab = StrSplit(propsStr, ",");
    
    if (nil ~= tmpTab) then
        for i = 1, #tmpTab do
            local fTab, strTmp = {}, "";
            --一级分隔符:
            if ("" ~= Trim(tmpTab[i])) then
                fTab = StrSplit(tmpTab[i], ":");--fTab[1]，道具ID；fTab[2]，道具数量
                if (2 == #fTab) then
                    propsList:add(fTab);
                end
            end
        end
    end

    return propsList;
end

--[[
    是否获得过该英雄
    _hData HeroData
    return boolean true，获得过；false，未获得过
]]
function HeroDataProxy.isEverGet (_hData)
    local everGet = false;

    for i = 1, TeamData.gotHeros:getSize() do
        if (tonumber(TeamData.gotHeros[i]) and tonumber(TeamData.gotHeros[i]) == tonumber(_hData.heroId)) then
            everGet = true;
            break ;
        end
    end

    return everGet;
end

--[[
    获取英雄的显示等级
    _lvl number 等级
    _wiseup number 觉醒等级
    return string 显示等级
]]
function HeroDataProxy.getHeroShowLvl (_lvl, _wiseup)
    local showLvl = 0;
    local allLvlData, curData = nil, nil;
    local nextLvlWiseup = -1;

    _lvl = _lvl or 1;
    _wiseup = _wiseup or 0;
    nextLvlWiseup = HeroDataProxy.getHeroWiseByLvl(_lvl + 1);

    allLvlData = Config.getHeroLvlupSubLvlup();
    curData = allLvlData["" .. _lvl];
    if (nil ~= curData) then
        showLvl = curData[const_lvl_show];
    end

    if (30 == showLvl) then
        if (_wiseup == nextLvlWiseup) then
            showLvl = "1";
        end
    end
    showLvl = showLvl .. "";

    return showLvl;
end

--[[
    根据英雄的lvl判断觉醒等级
    _lvl number 
    return number 觉醒等级
]]
function HeroDataProxy.getHeroWiseByLvl (_lvl)
    local wiseup = -1;
    local allLvlData, curData = nil, nil;

    _lvl = _lvl or 1;
    allLvlData = Config.getHeroLvlupSubLvlup();
    curData = allLvlData["" .. _lvl];
    if (nil ~= curData) then
        wiseup = tonumber(curData[const_wise_show]);
        wiseup = wiseup or -1;
    end

    return wiseup;
end

--[[
    根据英雄的觉醒等级，消耗的道具
    _wiseup number 觉醒等级
    return List
]]
function HeroDataProxy.getHeroWiseupProps (_wiseup)
    local propsList, propsStr = List.new(), "";
    local perProp, tmpTab, tmpList = nil, nil, List.new();

    _wiseup = _wiseup or 0;
    propsStr = Config.getHeroLvlupSubWake()["" .. (_wiseup + 1)][const_heroStrongProps];
    propsStr = propsStr or "";
    --二级分隔符,，暂未使用更高级的分隔符
    tmpTab = StrSplit(propsStr, ",");
    
    for i = 1, #tmpTab do
        local fTab, strTmp = {}, "";
        --一级分隔符:
        if ("" ~= Trim(tmpTab[i])) then
            fTab = StrSplit(tmpTab[i], ":");--fTab[1]，道具ID；fTab[2]，道具数量
            if (2 == #fTab) then
                propsList:add(fTab);
            end
        end
    end
    
    return propsList;
end