--英雄传奇数据类
--2016-7-14 14:44:41 library

local const_defOpenTime = "每周一、六、日";
local const_openTimeTitle = "day_limit";
local const_storyDescTitle = "#desc";
local const_storyTitleTitle = "#card_name";
local const_rwdShow = "#preview";
local const_resetCost = "diamond_cost";

HeroStoryProxy = {
    keys = {};
    level_perCard = 5;
    isInitKeys = false;
    dailyChgeCnt = 2;
};

local this = HeroStoryProxy;

--[[
    是否已经初始化keys
]]
function HeroStoryProxy.getIsInitKeys ()
    return this.isInitKeys;
end

--[[

]]
function HeroStoryProxy.setIsInitKeys (_isInit)
    _isInit = _isInit or false;

    this.isInitKeys = _isInit;
end

--[[
    取出所有的keys
]]
function HeroStoryProxy.initHeroStoryCfgKeys ()
    if (not this.isInitKeys) then
        for k, v in pairs(Config.getHeroStoryData()) do
            if (tonumber(k)) then
                table.insert(this.keys, k);
            end
        end
        this.sortKeys();
        this.isInitKeys = true;
    end
end

--[[
    对keys排序
]]
function HeroStoryProxy.sortKeys ()
    local tmpI, tmpJ = nil, nil;
    
    for i = 1, #this.keys do
        for j = i + 1, #this.keys do
            if (this.keys[i] > this.keys[j]) then
                tmpJ = table.remove(this.keys, j);
                tmpI = table.remove(this.keys, i);
                table.insert(this.keys, i, tmpJ);
                table.insert(this.keys, j, tmpI);
            end
        end
    end
end

--[[

]]
function HeroStoryProxy.getOpenTimeWord (_cfg)
    local openTimeStr = "";

    _cfg = _cfg or {};
    openTimeStr = _cfg[const_openTimeTitle];
    openTimeStr = openTimeStr or const_defOpenTime;

    return openTimeStr;
end

--[[

]]
function HeroStoryProxy.getStoryDesc (_cfg)
    local storyDesc = "";

    _cfg = _cfg or {};
    storyDesc = _cfg[const_storyDescTitle];
    storyDesc = storyDesc or "";

    return storyDesc;
end

--[[

]]
function HeroStoryProxy.getStoryTitle (_cfg)
    local storyTitle = "";

    _cfg = _cfg or {};
    storyTitle = _cfg[const_storyTitleTitle];
    storyTitle = storyTitle or "";

    return storyTitle;
end

--[[
    根据索引获取Id
    _idx number 索引
    return number RoadId
]]
function HeroStoryProxy.getHeroStroyIdByIdx (_idx)
    local id = 1;

    id = this.keys[_idx];
    id = tonumber(id) or 1;

    return id;
end

--[[
    根据ID取对应的配置数据
    _id number
    return cfg
]]
function HeroStoryProxy.getHeroStoryCfgById (_id)
    local cfg = nil;

    _id = tonumber(_id) or 1;
    cfg = Config.getHeroStoryData()[_id .. ""];
    cfg = cfg or {};

    return cfg;
end

--[[
    根据索引取英雄传奇的数据
    逻辑存在问题 2016-12-7 21:13:52 library
    _idx number 
    return HeroRoadCfg
]]
function HeroStoryProxy.getHeroStoryCfgByIdx (_idx)
    local hrData, hKey = nil, 0;--HeroRoadCfg number

    hKey = this.keys[_idx];
    hrData = this.getHeroStoryCfgById(hKey);
    hrData = hrData or {};

    return hrData;
end

--[[
    英雄传说中的配置行数
]]
function HeroStoryProxy.getHeroStoryCnt ()
    local cnt = 0 ;

    cnt = #this.keys;
    cnt = cnt or 0;

    return cnt;
end

--[[
    根据id取roadId
]]
function HeroStoryProxy.getRoadIdById (_id)
    local roadId = 1001;

    _id = tonumber(_id) or 1;
    roadId = _id + 1000;
    roadId = roadId or 1001;

    return roadId;
end

--[[
    取预览奖励
    _cfg HeroStoryCfg
    return string
]]
function HeroStoryProxy.getShowRwd (_cfg)
    local rwd = "";

    rwd = _cfg[const_rwdShow];
    rwd = tostring(rwd) or "";

    return rwd;
end

--[[
    获取关卡重置需要消耗的钻石
    _id number 关卡ID
    return number 消耗的钻石
]]
function HeroStoryProxy.getResetCostMny (_id)
    local cfg = nil;
    local cost = 0;

    cfg = this.getHeroStoryCfgById(_id);
    cost = cfg[const_resetCost];
    cost = tonumber(cost) or 0;

    return cost;
end