--玩家基础数据，登陆后立即初始化
--2016-6-23 12:05:34 library

PlayerData = {
    playerData = nil;--TeamLoadData
    sysDate = 0;--登陆时的系统时间
    adjustTime = 0;--登陆游戏时的游戏运行时间
};

local this = PlayerData;
local _RoleTeamId = 0

function PlayerData.GetRoleTeamId()
	return _RoleTeamId
end

function PlayerData.SetRoleTeamId(teamId)
	_RoleTeamId = tonumber(teamId) or 0
end

function PlayerData.setMyExp(_exp)
    local myExp = 0;

    myExp = this.playerData.team.teamMoney.exp;
    myExp = myExp - _exp;
    myExp = (myExp >= 0) and myExp or 0;

    this.playerData.team.teamMoney.exp = myExp;
end

--[[
    初始化玩家的数据
    _pData TeamLoadData
    return nil;
]]
function PlayerData.initPlayerData (_pData)
    this.playerData = _pData;
end

--[[
    获取玩家的金币
    return number
]]
function PlayerData.getMyGold ()
    local myGod = this.playerData.team.teamMoney.gold;

    return myGod;
end

--[[
    获取玩家的经验
    return number
]]
function PlayerData.getMyExp ()
    local myGod = this.playerData.team.teamMoney.exp;

    return myGod;
end

--[[
    获取玩家的钻石
    return number
]]
function PlayerData.getMyDiamond ()
    local myGod = this.playerData.team.teamMoney.diamonds;

    return myGod;
end

--[[
    获取我的友情点
    return number
]]
function PlayerData.getMyFriendMny ()
    local num = this.playerData.team.teamMoney.friend;

    num = num or 0;

    return num;
end

function PlayerData.getHeroList()
	return this.playerData.team.heros
end

--<summary>保存登录数据</summary>
function PlayerData.getLoginData()
	return this.loginData
end
function PlayerData.setLoginData(p1, p2, p3, p4)
	if Global.isSDKLogin then
		this.loginData = {
			packageId = tonumber(p1),
			token = tostring(p2),
			uid = tostring(p3),
			exInfo = tostring(p4),
		}
	else
		this.loginData = {
--            userId = "10069",
--			key = "4DDB22F4465CF3AAB483CB3246D04694",
--			timestamp = "1482293365822",
			userId = tostring(p1),
			key = tostring(p2),
			timestamp = tostring(p3),
		}
	end
end

function PlayerData.getLoginAccount()
	return this.loginAccount
end
function PlayerData.setLoginAccount(account, pwd)
	this.loginAccount = {
		acc = account,
		pwd = pwd,
	}
	this.saveAccount()
end

-- for login by kenny
function PlayerData.loadAccount()
	local account = DecodeJsonFile(UserDataPath)
	return account
end
function PlayerData.saveAccount()
	if not IsEmptyTable(this.loginAccount) then
		EncodeJsonFile(UserDataPath, this.loginAccount)
	end
end

-- 0:female 1:male
function PlayerData.getSex()
	if not this.sex then
		local src = DecodeJsonFile(UserDataPath)
		this.sex = tonumber(src.sex) or 0
	end
	return this.sex
end
function PlayerData.setSex(sex)
	this.sex = sex or 0
	EncodeJsonFile(UserDataPath, {sex = this.sex})
end

function PlayerData.GetMailIds()
	local src = DecodeJsonFile(UserDataPath)
	return (src.mailIds or {})
end
function PlayerData.SetMailIds(tbl)
	EncodeJsonFile(UserDataPath, {mailIds = tbl})
end

--[[
    获取新手引导的当前步骤
]]
function PlayerData.getMyGuideStep ()
    local guideStep = 0;

    guideStep = this.playerData.team.helpIndex;
    
    return guideStep;
end

--[[
    设置我的新手引导步骤
]]
function PlayerData.setMyGuideStep (_step)
    local mapData, buf = Map.new(), nil;
--    error("curStep__" .. _step);
    this.playerData.team.helpIndex = _step;
    mapData:put("step", _step);
    buf = Network.reqParamEncode(mapData);
    NetManager:SendData(this, buf, ServerID.Guide_Save, nil, doNthFunc, "", doNthFunc);
end

--[[
    判断新手引导是否结束
]]
function PlayerData.guideNotEnd ()
    local notEnd = false;
    -- plog("GuideNotEnd = %d", this.getMyGuideStep());

	if Global.openGuide then
		notEnd = this.getMyGuideStep() < GuideStep.getFinalGuideStep();
	end
    return notEnd;
end



--[[
    货币数据更新
    _mnyData TeamMoneyData
]]
function PlayerData.mnyChge (_mnyData)
	if this.playerData ~= nil then
		this.playerData.team.teamMoney = _mnyData;
	end
end

--[[
    系统时间维护
    _defData DefaultData bigNum，系统时间毫秒数
]]
function PlayerData.sysDateSyn (_defData)
    this.sysDate = _defData.bigNum;
    this.adjustTime = GetIntPart(Time.time * 1000);
end

--[[
    获取当前的系统时间--毫秒数
    return number 毫秒数
]]
function PlayerData.getCurSysTime ()
    local unityRunTime = GetIntPart(Time.time * 1000);
    local realTime = this.sysDate + unityRunTime - this.adjustTime;
    
    return realTime;
end

--[[
    获取当前的系统时间串
    _realTime number 毫秒数
    return string 标准化时间串
]]
function PlayerData.getCurTimeStr (_realTime)
    local realTime = GetIntPart(_realTime / 1000);
    local timeStr = "";
    local year, month, day, hour, minute, second, week = 0, 0, 0, 0, 0, 0, 0;

    timeStr = os.date("%Y/%m/%d %H:%M:%S", realTime);
    year = os.date("%Y", realTime);
    month = os.date("%m", realTime);
    day = os.date("%d", realTime);
    hour = os.date("%H", realTime);
    minute = os.date("%M", realTime);
    second = os.date("%S", realTime);
    week = os.date("%w", realTime);

    return {timeStr, tonumber(year), tonumber(month), tonumber(day), tonumber(hour), tonumber(minute), tonumber(second), tonumber(week)};
end

--[[
    获取某年某月有多少天
    _year number 年份
    _month number 月份
    return number 天数
]]
function PlayerData.getTotalDaysOfMonth (_year, _month)
    local days = 0;
    local year = tonumber(_year);
    local month = tonumber(_month) + 1;

    if (13 == tonumber(month)) then
        month = 1;
        year = year + 1;
    end

    days = tonumber(os.date("%d", os.time({year = year, month = month, day = 0})));

    return days;
end

function PlayerData.GetRefuseFriendNotice()
	local ret = (this.playerData.gameConfig.friend) and true or false
	return ret
end
function PlayerData.SetRefuseFriendNotice(refuse)
	this.playerData.gameConfig.friend = refuse and true or false
end