--技能数据处理
--2016-7-7 16:04:14 library

local const_skill_icon = "#skill_icon";
local const_description = "description";
local const_heroSkills = "skill_id";
local const_skillTitle = "#title";
local const_needHeroId = "hero_id";
local const_skillLimitValue = "limit_value";

SkillDataProxy = {

};

local this = SkillDataProxy;

--[[
    取技能配置数据
    _name string 技能key
    _cfg Cfg 技能配置
]]

--[[

]]
function SkillDataProxy.getSkillValByKey (_name, _cfg)
    local val = nil;

    if (nil ~= _cfg) then
        val = _cfg[_name];
    end

    return val;
end

--[[
    取技能配置数据
    _id number 技能ID
]]
function SkillDataProxy.getSkillCfgById (_id)
    local allSkills, skillCfg = nil, nil;

    allSkills = Config.getSkillsData();

    for k, v in pairs(allSkills) do
        if (tonumber(k) == tonumber(_id)) then
            skillCfg = v;
            break ;
        end
    end

    if (nil == skillCfg) then
        skillCfg = {};
    end

    return skillCfg;
end

--[[
    技能名称
    sCfg
    return string
]]
function SkillDataProxy.getSkillName (sCfg)
    local desc = "";

    if (nil ~= sCfg) then
        desc = sCfg[const_skillTitle];
    end

    return desc;
end

--[[
    技能描述信息
    sCfg
    return string
]]
function SkillDataProxy.getSkillDesc (sCfg)
    local desc = "";

    if (nil ~= sCfg) then
        desc = sCfg[const_description];
    end

    return desc;
end

--[[
    技能图标
    sCfg
    return string
]]
function SkillDataProxy.getSkillIcon (sCfg)
    local icon = "";
    
    if (nil ~= sCfg) then
        icon = sCfg[const_skill_icon];
    end
    
    icon = icon or "";

    return icon;
end

--[[
    英雄的技能数据
    _hCfg
    return table
]]
function SkillDataProxy.getHeroSkills (_hCfg)
    local skills = nil;
    
    if (nil ~= _hCfg) then
        skills = _hCfg[const_heroSkills];
    end

    skills = skills or "";
    skills = StrSplit(skills, ":");
    TrimTable(skills);

    return skills;
end

--[[
    技能的限制条件的值
    _hCfg
    return string
]]
function SkillDataProxy.getHeroLimitVal (_hCfg)
    local limitVal = "0";
    
    if (nil ~= _hCfg) then
        limitVal = _hCfg[const_skillLimitValue];
    end
    
    limitVal = limitVal or "0";

    return limitVal;
end

--[[
    判断是否是组合技能
    _sId number 技能ID
    return string 组合技需要的英雄串，不是组合技时，为""
]]
function SkillDataProxy.getComboSkillHeros (_sId)
    local hStr = "";
    local sCfg = nil;
    local hIds = nil;

    sCfg = SkillDataProxy.getSkillCfgById(_sId);
    
    if (nil ~= sCfg) then
        hIds = sCfg[const_needHeroId];
        if (tostring(hIds) and "0" ~= tostring(hIds)) then
            hStr = tostring(hIds);
        end
    end

    return hStr;
end