--玩家的阵容相关数据

TeamData = {}

local this = TeamData
this.data = {}
this.team = {}
this.curPageIndex = nil
this.maxRoleHeroId = 10
this.camp = {}
this.gotHeros = nil

function TeamData.New(data)
	this.data = data
	this.team = {}
	this.gotHeros = List.new()
	this.Init(data.team)
	return this
end

function TeamData.Init(teamData)
	if IsEmpty(teamData) then return end
	this.team = teamData
	this.camp = {}
	this.curPageIndex = nil
	this.maxRoleHeroId = 10
end

function TeamData.GetData()
	return this.data
end

function TeamData.GetTeam()
	return this.team
end

function TeamData.GetRoleName()
	if not this.team then return "Default" end
	return this.team.teamName
end

function TeamData.GetRoleLogo()
	local herosConf = Config.getHerosData()
	local data = herosConf[tostring(this.team.logo)] or {}
	local name = data["#prefab_name"]
	return name
end

function TeamData.GetRoleEquiList()
	return this.team.equi.equiList
end

function TeamData.getRoleEqui(id)
	for i=1,#this.team.equi.equiList do
		if this.team.equi.equiList[i].equId==tonumber(id) then 
			return this.team.equi.equiList[i];
		end
	end
	return nil;
end

function TeamData.putRoleEqui(equ)
	local ne = #this.team.equi.equiList +1;
	this.team.equi.equiList[ne] = equ;
end

function TeamData.GetGold()
	if not this.team or not this.team.teamMoney then return 0 end
	return this.team.teamMoney.gold
end
function TeamData.SetGold(num)
	local num = tonumber(num) or 0
	if num > 0 then this.team.teamMoney.gold = num end
end
function TeamData.AddGold(num)
	local num = tonumber(num) or 0
	if num > 0 then
		this.team.teamMoney.gold = this.team.teamMoney.gold + num
	end
end

function TeamData.GetExp()
	if not this.team or not this.team.teamMoney then return 0 end
	return this.team.teamMoney.exp
end
function TeamData.SetExp(num)
	local num = tonumber(num) or 0
	if num > 0 then this.team.teamMoney.exp = num end
end
function TeamData.AddExp(num)
	local num = tonumber(num) or 0
	if num > 0 then
		this.team.teamMoney.exp = this.team.teamMoney.exp + num
	end
end

function TeamData.GetGem()
	if not this.team or not this.team.teamMoney then return 0 end
	return this.team.teamMoney.diamonds
end
function TeamData.SetGem(num)
	local num = tonumber(num) or 0
	if num > 0 then this.team.teamMoney.diamonds = num end
end
function TeamData.AddGem(num)
	local num = tonumber(num) or 0
	if num > 0 then
		this.team.teamMoney.diamonds = this.team.teamMoney.diamonds + num
	end
end

function TeamData.GetFriendPoints()
	return this.team.teamMoney.friend
end
function TeamData.SetFriendPoints(num)
	local num = tonumber(num) or 0
	if num > 0 then this.team.teamMoney.friend = num end
end

function TeamData.GetPower()
	return TeamData.getMyCurTotalAbility()
end

function TeamData.GetAllHeros()
	return this.team.heros
end

function TeamData.GetAllHerosNoRole()
	local ret = {}
	for _, hero in pairs(this.team.heros) do
		if tonumber(hero.heroId) > TeamData.maxRoleHeroId then
			table.insert(ret, hero)
		end
	end
	return ret
end

function TeamData.GetRestHeros()
	local retheros = {}
	local allHeros = TeamData.GetAllHerosNoRole()
	local curPage = TeamData.GetCurPageIndex()
	local fightHeros = TeamData.GetCampByIndex(curPage)
--	plog(fightHeros, "fightHeros, curPage = "..curPage)
	for _, hero in pairs(allHeros) do
		local isOn = false
		for _, onlyId in pairs(fightHeros) do
			if tonumber(hero.id) == tonumber(onlyId) then
				isOn = true
				break
			end
		end
		if not isOn then
			table.insert(retheros, hero)
		end
	end
	return retheros
end

function TeamData.GetRoleHero()
	for _, hero in pairs(this.team.heros) do
		if tonumber(hero.heroId) <= TeamData.maxRoleHeroId then
			return hero
		end
	end
	return this.team.heros[1] or {}
end

function TeamData.GetHerosByOnlyIds(onlyIds)
	local heros = {}
	local onlyIds = split(onlyIds, ",")
	if IsEmpty(onlyIds) then return heros end
	local herosInfo = this.GetAllHeros()
	if not IsEmpty(herosInfo) then
		local count = CountTable(herosInfo)
		for i = 1, count do
			local is, idx = IsMember(tostring(herosInfo[i].id), onlyIds)
			if is then
				heros[idx] = herosInfo[i]
			end
		end
	end
	return heros
end

function TeamData.GetHerosByIndex(pageId)
	local ret = {}
	pageId = tonumber(pageId) or 1
	local list = this.team.heroIndexs
	if not IsEmpty(list) then
		for _, data in pairs(list) do
			if pageId == data.index then
				local heros = this.GetHerosByOnlyIds(data.heroIds)
				ret = heros
				break
			end
		end
	end
	do
		local existRole = false
		if not IsEmpty(ret) then
			for _, hero in pairs(ret) do
				if tonumber(hero.heroId) <= TeamData.maxRoleHeroId then
					existRole = true
					break
				end
			end
		end
		if not existRole then
			local role = TeamData.GetRoleHero()
			table.insert(ret, role)
		end
	end
	return ret
end

function TeamData.GetCampByIndex(pageId)
	local ret = {}
	local curCamp = this.camp[tonumber(pageId)]
	if not IsEmptyTable(curCamp) then
		ret = CopyTable(curCamp)
	else
		local _heros = TeamData.GetHeroOnlyIds(pageId)
		TeamData.SetCampByIndex(pageId, split(_heros.heroIds, ","))
	end
	return ret
end
function TeamData.SetCampByIndex(pageId, onlyIds)
	local _heros = TeamData.GetHeroOnlyIds(pageId)
--	plog(_heros, "_heros: " .. pageId)
	if not IsEmptyTable(onlyIds) then
		this.camp[tonumber(pageId)] = onlyIds
		
		local heroIndexs = ""
		for _, id in ipairs(onlyIds) do
			if id and tonumber(id) > 0 then
				if IsEmpty(heroIndexs) then
					heroIndexs = id
				else
					heroIndexs = heroIndexs .. "," .. id
				end
			end
		end
		if not IsEmptyTable(_heros) and _heros.heroIds ~= heroIndexs then
			_heros.heroIds = heroIndexs
		end
	end
end
function TeamData.DelCampOnlyId(pageId, onlyId)
	local camp = this.camp[tonumber(pageId)]
	local onlyId = tostring(onlyId)
	if not IsEmptyTable(camp) and onlyId ~= nil then
		local ism, key = IsMember(onlyId, camp)
		if ism then
			table.remove(camp, key)
		end
	end
end

function TeamData.GetCurPageIndex()
	if not this.curPageIndex then
		local curIndex = this.team.curInedx
		if not curIndex or curIndex < 1 or curIndex > 5 then
			curIndex = 1
		end
		this.curPageIndex = curIndex
	end
	return this.curPageIndex
end
function TeamData.SetCurPageIndex(index)
	if not index or index < 1 or index > 5 then
		index = 1
	end
	if this.curPageIndex ~= index then
		this.curPageIndex = index
	end
end

function TeamData.GetHeroOnlyIds(pageId)
	if not pageId then return nil end
	local list = this.team.heroIndexs
	if not IsEmpty(list) then
		for _, heros in ipairs(list) do
			if tonumber(pageId) == tonumber(heros.index) then
				return heros
			end
		end
	end
end
function TeamData.SetHeroOnlyIds(pageId, onlyIds)
	if not pageId or not onlyIds then return end
	local list = this.team.heroIndexs
	if not IsEmpty(list) then
		for _, heros in ipairs(list) do
			if tonumber(pageId) == tonumber(heros.index) then
				heros.heroIds = onlyIds
			end
		end
	end
end

-- 是否已招募
function TeamData.IsRecruitedHero(heroId)
	if IsEmpty(heroId) then
		return false
	end
	local heros = PlayerData.getHeroList()
	for i = 1, #heros do
		local hero = heros[i]
		if tostring(heroId) == tostring(hero.heroId) then
			return true
		end
	end
	return false
end

-- 是否已上阵
function TeamData.IsFightHero(heroId)
	if IsEmpty(heroId) then
		return false
	end
	local pageId = TeamData.GetCurPageIndex()
	local heros = TeamData.GetHerosByIndex(pageId)
	for i = 1, #heros do
		local hero = heros[i]
		if tostring(heroId) == tostring(hero.heroId) then
			return true, hero.id
		end
	end
	return false
end

function TeamData.IsJoinedLeague()
	local leagueId = tonumber(this.team.leagueId) or 0
	if leagueId > 0 then
		return true
	end
	return false
end

function TeamData.SetLeagueId(id)
	this.team.leagueId = tonumber(id) or 0
end

function TeamData.SetLeagueName(name)
	this.team.leagueName = name or ""
end

function TeamData.GetLeagueName()
	return this.team.leagueName
end

-- function TeamData.SetLeagueBadgeLevel(id)
-- 	this.team.leagueLogoLevel = tonumber(id) or 0
-- end

function TeamData.GetLeagueBadgeLevel()
	return this.team.leagueLogoLevel
end

--<summary>更新英雄共享数据</summary>
function TeamData.updateHeroInfo(heroClass)
	local heros = PlayerData.playerData.team.heros
	for i = 1, #heros do
		local hero = heros[i]
		if tostring(heroClass.onlyId) == tostring(hero.id) then
			hero.level = heroClass.level or 0
			hero.wiseup = heroClass.wiseup or 0
			hero.strengthen = heroClass.strengthen or 0
			hero.soldiers = heroClass.soldiers or 0
			hero.power = HeroDataProxy.getHeroAbility(hero.heroId, hero.level, hero.wiseup, hero.strengthen)
			-- hero:init(heroClass)
			-- hero:refreshHero()
			break
		end
	end
end

--<summary>更新英雄真实数据</summary>
function TeamData.updateGridHeros(gridObj, heroClass)
	if gridObj == nil then return end
	local tran = gridObj.transform
	for i = 0, tran.childCount - 1 do
		local child = tran:GetChild(i)
		local lb = GetComponent(child, "LuaBehaviour")
		if lb then
			local hero = lb.sourceLuaObj
			if IsEmptyTable(heroClass) then
				hero:refresh()
			else
				if tostring(hero.onlyId) == tostring(heroClass.onlyId) then
--					hero.level = heroClass.level or 0
--					hero.wiseup = heroClass.wiseup or 0
--					hero.strengthen = heroClass.strengthen or 0
--					hero.soldiers = heroClass.soldiers or 0
--					hero.power = HeroDataProxy.getHeroAbility(hero.heroId, hero.level, hero.wiseup, hero.strengthen)
					hero:init(heroClass)
					hero:refreshHero()
					break
				end
			end
		end
	end
end

--[[
    获取我的所有英雄的数据
    return table HeroData
]]
function TeamData.getMyHeros ()
    local myHeros = nil;
    
    if (nil ~= PlayerData.playerData and nil ~= PlayerData.playerData.team) then
        myHeros = PlayerData.playerData.team.heros;
    end

    if (nil == myHeros) then
        myHeros = {};
    end

    return myHeros;
end

--[[
    获取玩家的单个英雄数据
    _id 英雄唯一ID
    return HeroData
]]
function TeamData.getMyHeroDataById (_id)
    local hData = nil;--HeroData

    for i = 1, #PlayerData.playerData.team.heros do
        hData = PlayerData.playerData.team.heros[i];
        
        if (_id == hData.id) then
            break ;
        else
            hData = nil;
        end
    end

    return hData;
end

--[[
    获取当前阵容的英雄id串
    return string
]]
function TeamData.getMyCurTeamHeros ()
    local curHeros, curHeroTab = ",", nil;
    
    curHeroTab = TeamData.GetHerosByIndex(TeamData.GetCurPageIndex());

    for k, v in pairs(curHeroTab) do
        if (v and v.id) then
            curHeros = curHeros .. v.id .. ",";
        end
    end

    curHeros = curHeros or ",";
    
    return curHeros;
end


--[[
    计算当前阵容的总战力
]]
function TeamData.getMyCurTotalAbility ()
    local perAbility, totalAbility = 0, 0;
	local heros = TeamData.GetCampByIndex(TeamData.GetCurPageIndex())
	if IsEmptyTable(heros) then
		local heroIds = TeamData.getMyCurTeamHeros();
		heros = StrSplit(heroIds, ",");
	end
    local hData = nil;
	if not IsEmpty(heros) then
		for i = 1, #heros do
			if ("" ~= Trim(heros[i])) then
				hData = TeamData.getMyHeroDataById(tonumber(heros[i]));
				if (nil ~= hData) then
					perAbility = HeroDataProxy.getHeroAbility(hData.heroId, hData.level, hData.wiseup, hData.strengthen);
					totalAbility = totalAbility + perAbility;
				end
			end
		end
	end
    totalAbility = totalAbility + PlayerData.playerData.team.teamAbility.power;
    totalAbility = totalAbility or 1;
    return totalAbility;
end

function TeamData.GetCurRolePower()
    local perAbility, totalAbility = 0, 0;
	local heros = TeamData.GetCampByIndex(TeamData.GetCurPageIndex())
	if IsEmptyTable(heros) then
		local heroIds = TeamData.getMyCurTeamHeros(); -- onlyIds
		heros = StrSplit(heroIds, ",");
	end
    local hData = nil;
	if not IsEmpty(heros) then
		for i = 1, #heros do
			local heroId = tonumber(heros[i]) or 0
			if heroId > 0 then
				hData = TeamData.getMyHeroDataById(heroId);
				if not IsEmptyTable(hData) and tonumber(hData.heroId) <= TeamData.maxRoleHeroId then
					perAbility = HeroDataProxy.getHeroAbility(hData.heroId, hData.level, hData.wiseup, hData.strengthen);
					totalAbility = totalAbility + perAbility;
				end
			end
		end
	end
--    totalAbility = totalAbility + PlayerData.playerData.team.teamAbility.power;
    totalAbility = totalAbility or 1;
    return totalAbility;
end

--[[
    初始化已经获得的英雄数据
    _heroList List<HeroId>
]]
function TeamData.setAlreadyGotHeros (_heroList)
    _heroList = _heroList or List.new();
    
    for i = 1, #_heroList do
        this.gotHeros:add(_heroList[i]);
    end
end

--[[
    获取主角的数据
    return HeroData
]]
function TeamData.getMyRoleHeroData ()
    local myHeros = TeamData.getMyHeros();
    local hData = nil;

    for i = 1, #myHeros do 
        hData = myHeros[i];
        if (1 == hData.heroId or 2 == hData.heroId) then
            break ;
        end
        hData = nil;
    end

    return hData;
end
