
Event = require 'events'
require "Third/pbc/protobuf"

local print_r = require "Third/sproto/print_r"
local protobuf = require "protobuf"

Network = {}
local this = Network

-- local net_addrs = {
-- 	[1] = "121.10.118.25",		-- 外网(内测)
-- --	[1] = "121.10.118.9",		-- 外网(审核)
-- 	[2] = "192.168.10.69",		-- 内网测试
-- --	[2] = "192.168.12.82",		-- 本地测试
-- }
-- local  g_addr = net_addrs[1]
-- local  g_port = 8038

this.goPK = false;
this.isConnected = false

function Network.Start()
	-- if not Global.isRelease then
	-- 	g_addr = net_addrs[2]
	-- end
 --    GameDefine.ServerIp = tostring(g_addr)
 --    GameDefine.ServerPort = tonumber(g_port)

	if not Global.isLocal then
		ProtoRegister.register()
		ViewUtil.openView(ModuleName.LOGIN)
	else
		ViewUtil.openView(ModuleName.FIGHT, false, function()
			FightControler.readyBattle()
		end)
	end
end

function Network.Connect(callback)
	if not callback then
		callback = function(state) end
	end
	NetManager:connect(callback)
end

function Network.Disconnect()
	NetManager:disconnect()
end

function Network.DoConnect(callback)
	Network.Disconnect()
	DelayCall(function() Network.Connect(callback) end, 0.5)
end

function Network.CombindReqString(msgList)
	local retStr = ""
	if not IsEmpty(msgList) then
		for _, msg in pairs(msgList) do
			local str = tostring(msg) or ""
			if string.len(retStr) == 0 then
				retStr = str
			else
				retStr = retStr .. 'Ω' .. str
			end
		end
	end
	return retStr
end

--[[
-- SendMoData -> 发送MoData格式的网络数据
-- serverId -> 协议号Id
-- msgList -> msg参数列表, 如 {p1, p2, p3}
-- callback -> 服务器返回的回调函数 (回调参数有两个: session 和自定义参数params)
-- params -> 自定义回调参数params
--]]
function Network.SendMoData(serverId, msgList, callback, params)
	if not IsMember(serverId, ServerID) then return end
	local _callback = callback or this.OnCallbackData
	local _params = params or {}
	local msgData = this.CombindReqString(msgList)
	local mo = {
		msg = msgData
	}
	local buffer = GetProtoBuffer("MoData", mo)
	NetManager:SendData(this, buffer, serverId, nil, _callback, _params, function() end)
end

-- 获取订单号
function Network.GetBuyOrderId (_price, _callBack)
    local msgData, bytesArr = Map.new(), nil;

    msgData:put("price", _price);
    bytesArr = this.reqParamEncode(msgData);
    NetManager:SendData(this, bytesArr, ServerID.GetBuyOrderId, nil, function (session, params) 
            local mo = GetProtoTable("DefaultData", session);
            _callBack(mo.bigNum);
        end, "", function() end)
end

-- 玩家副本
function Network.ReqPlayerFB()
	this.SendMoData(ServerID.PlayerFB)
end

-- 请求战斗FB
function Network.ReqFightFB()
	this.SendMoData(ServerID.Fight)
end

-- 竞技场PK
function Network.ReqArenaPK(rivalRank, rivalTeamId, ownRank)
	local mo = {rivalRank, rivalTeamId, ownRank}
	this.SendMoData(ServerID.ArenaPK, mo)
end

-- 大乱斗PK
function Network.ReqWorldBattlePK(index)
	local mo = {index}
	this.SendMoData(ServerID.WBPK, mo)
end

-- 背包数据
function Network.ReqPropInfo()
	this.SendMoData(ServerID.PropGetAllItem)
end

-- 探险
function Network.ReqExploreCvt ()
    local msgData, bytesArr = Map.new(), nil;

    bytesArr = this.reqParamEncode(msgData);
	NetManager:SendData(this, bytesArr, ServerID.ExploreEty, nil, doNthFunc, "", function() end)
end

--[[
    曾经获得的英雄数据
]]
function Network.ReqGotHeroInfo ()
    local msgData, bytesArr = Map.new(), nil;

    bytesArr = this.reqParamEncode(msgData);
	NetManager:SendData(this, bytesArr, ServerID.Hero_AlreadyGot, nil, this.OnCallbackData, "", function() end)
end

--[[
    获取系统时间
]]
function Network.ReqGetSysDate ()
    local msgData, bytesArr = Map.new(), nil;

    bytesArr = this.reqParamEncode(msgData);
	NetManager:SendData(this, bytesArr, ServerID.SysDateSyn, nil, this.OnCallbackData, "", function() end)
end

--[[

]]
function Network.ReqActInfo ()
    local msgData, bytesArr = Map.new(), nil;

    bytesArr = this.reqParamEncode(msgData);
	NetManager:SendData(this, bytesArr, ServerID.Act_AllData, nil, this.OnCallbackData, "", function() end)
end

-- 请求进入军团战界面
function Network.ReqLeaguePVP()
    this.SendMoData(ServerID.LeaguePVP_Ety)
end

-- 请求参战军团战精英赛
function Network.ReqLeaguePVPJoin()
    this.SendMoData(ServerID.LeaguePVPJoin)
end

-------------------------------------------------------- 华丽的分割线 --------------------------------------------------------
-- 广播回调 Broadcast
function Network.OnCallback(session)
	local serviceId = tonumber(session.serviceId)
	plog("[OnCallbackBroadcast] serviceId = %d", serviceId)
	
	if serviceId == ServerID.LostConn then
		Network.isConnected = false
		ViewUtil.CreateLostBoard(1)
	elseif serviceId == ServerID.PKFight then
        this.goPK = true;
		local mo = GetProtoTable("BattleData", session)
		ViewUtil.goto(ModuleName.FIGHT, false, function(openParam)
            Network.goPK = false;
			FightControler.accept(openParam.mo)
		end, {mo = mo})

    elseif (ServerID.NewHero == serviceId) then
        local data = GetProtoTable("PushHeroData", session);        
        HeroDataProxy.csistHeros(data);

	elseif (ServerID.PropChge == serviceId) then
		local mo = GetProtoTable("PushPropData", session);
		PropDataProxy.propChge(mo);
        
    elseif (ServerID.ExploreEtrPanel == serviceId) then
        local mo = GetProtoTable("ArcTeamData", session);        
        Facade:sendNotification(MVCConst.INITDATA_EXPLORE, {[1] = mo, [2] = ExploreDefine.ExploreEtyType.ExploreEtrPanel});

    elseif (ServerID.ExploreMapPanel == serviceId) then
        local mo = GetProtoTable("ArcMapMainData", session);
        local ctl = ModuleManager.GetCtrl(ModuleName.EXPLORE);
        ctl.initViewData(mo, ExploreDefine.ExploreEtyType.ExploreMapPanel);
        --Facade:sendNotification(MVCConst.INITDATA_EXPLORE, {[1] = mo, [2] = ExploreDefine.ExploreEtyType.ExploreMapPanel});

    elseif (ServerID.ExplorePushPlayersMove == serviceId) then
        --探险玩家移动
        local mData = GetProtoTable("PushArcMapPoinData", session);
        Facade:sendNotification(MVCConst.EXPLORE_SYNPLAYERSDATA, {mData});

    elseif (ServerID.ExplorePushRemovePlayer == serviceId) then
        --探险移除玩家
        local mo = GetProtoTable("DefaultData", session);
        Facade:sendNotification(MVCConst.EXPLORE_REMOVEPLAYER, {teamId = mo.bigNum});

    elseif (ServerID.ExplorePushSpecialResource == serviceId) then
        --探险特殊资源推包
        local mo = GetProtoTable("PushArcMapPoinEndData", session);
        Facade:sendNotification(MVCConst.EXPLORE_LASTFIVESQUARE, {mo.poins});

    elseif (ServerID.ExplorePushNPCLvl == serviceId) then
        --探险NPC等级变动包
        local def = GetProtoTable("DefaultData", session);
        Facade:sendNotification(MVCConst.EXPLORE_NPCLVLCHANGE, {def});

    elseif (ServerID.MnyChge == serviceId) then
        --货币变动
        local mnyData = GetProtoTable("TeamMoneyData", session);
        PlayerData.mnyChge(mnyData);
        Facade:sendNotification(MVCConst.UPDATE_MNY, 7);

    elseif serviceId == ServerID.EquipChange then
        -- 武具变动
        local mo = GetProtoTable("EquiInfoData", session)
		-- plog(mo, "motree")
  --       Facade:sendNotification(MVCConst.UPDATE_WEAPON, {mo});
        TeamData.putRoleEqui(mo);

		
    elseif (ServerID.Team_BodyAbility == serviceId) then
        --四维及非英雄本身攻防的同步
        local teamAbilityData = nil;
        teamAbilityData = GetProtoTable("TeamAbilityData", session);
        PlayerData.playerData.team.teamAbility = teamAbilityData;
--		plog("####Update Power = "..TeamData.getMyCurTotalAbility())

    elseif (ServerID.ActNewData == serviceId) then
        this.ReqActInfo();

    elseif serviceId == ServerID.NewAchievement then
        local ts = GetProtoTable("TeamStatusData", session)
        if ts.friend then
            PlayerData.playerData.status.friend = true;
        end 
        if ts.honor then
            PlayerData.playerData.status.honor = true
        end
		Facade:sendNotification(MVCConst.SHOWREDICON, {})
    elseif serviceId == ServerID.NewMail then
        PlayerData.playerData.status.mail = true
        Facade:sendNotification(MVCConst.SHOWREDICON, {})
    elseif serviceId == ServerID.GameTip then
        local df = GetProtoTable("DefaultData", session)
        GameCfgDataProxy.SetBroadcast(df.msg)
        local ctrl = ModuleManager.GetCtrl(ModuleName.COM)
        ctrl.view:showGameTip()
    elseif serviceId == ServerID.LeagueApplyAgree then
        local mo = GetProtoTable("DefaultData", session)
        TeamData.SetLeagueId(mo.msg)
    elseif serviceId == ServerID.LeaguePVEAdd then
        local mo = GetProtoTable("LeagueHuntNPCTeamData", session)
        local ctl = ModuleManager.GetCtrl(ModuleName.LeaguePVEMap)
        ctl.view:AddTeam(mo)
    elseif serviceId == ServerID.LeaguePVERmv then
        local mo = GetProtoTable("LeagueHuntNPCTeamData", session)
        local ctl = ModuleManager.GetCtrl(ModuleName.LeaguePVEMap)
        ctl.view:RmvTeam(mo)
    elseif serviceId == ServerID.LeaguePVEBossLife then
        local mo = GetProtoTable("PushLeagueHuntBossBloodData", session)
        local ctl = ModuleManager.GetCtrl(ModuleName.LeaguePVEMap)
        ctl.view:UpdateLife(mo)
    elseif serviceId == ServerID.LeaguePVP then
        local mo = GetProtoTable("LeagueFightDefaultMainData", session)
        ViewUtil.goto(ModuleName.LeaguePVP, false, function(openParam)
            LeaguePVPControler.accept(mo)
        end, {})
    elseif serviceId == ServerID.LeaguePVPPre then
        local mo = GetProtoTable("LeagueFightPreelectionMainData", session)
        ViewUtil.goto(ModuleName.LeaguePVPPre, false, function(openParam)
            LeaguePVPPreControler.accept(mo)
        end, {})
    elseif serviceId == ServerID.LeaguePVPFinal then
        local mo = GetProtoTable("LeagueFightFinalMainData", session)
        ViewUtil.goto(ModuleName.LeaguePVPFinal, false, function(openParam)
            LeaguePVPFinalControler.accept(mo)
        end, {})
    elseif serviceId == ServerID.LeaguePVPMatched then
        local mo = GetProtoTable("DefaultData", session)
        -- Facade:sendNotification(MVCConst.LEAGUEPVP_MATCHED, {mo})
        this.ReqLeaguePVP()
    elseif serviceId == ServerID.LeaguePVPReadyFight then
        local mo = GetProtoTable("LeagueFightBattleMainData", session)
        ViewUtil.goto(ModuleName.LeaguePVPReadyFight, false, function(openParam)
            LeaguePVPReadyFightControler.accept(mo)
        end, {})
    elseif serviceId == ServerID.LeaguePVPFighting then
        local mo = GetProtoTable("LeagueFightBattlePKMainData", session)
        ViewUtil.goto(ModuleName.LeaguePVPFighting, false, function(openParam)
            LeaguePVPFightingControler.accept(mo)
        end, {})
    elseif serviceId == ServerID.LeaguePVPRFChoose then
        local mo = GetProtoTable("LeagueFightBattleTeamDataPush", session)
        local ctl = ModuleManager.GetCtrl(ModuleName.LeaguePVPReadyFight)
        ctl.view:ChooseUpdate(mo)
    elseif serviceId == ServerID.LeaguePVPFightingPositionChange then
        local mo = GetProtoTable("LeagueFightBattleTeamPositionData", session)
        local ctl = ModuleManager.GetCtrl(ModuleName.LeaguePVPFighting)
        ctl.view:PositionUpdate(mo)
    elseif serviceId == ServerID.LeaguePVPFightingChestChange then
        local mo = GetProtoTable("DefaultData", session)
        local ctl = ModuleManager.GetCtrl(ModuleName.LeaguePVPFighting)
        ctl.view:SetChestFalse(mo.code)
	end
end

-- 一对一网络协议回调
function Network.OnCallbackData(session, params)
	local serviceId = tonumber(session.serviceId)
	
    if ServerID.PropGetAllItem == serviceId then
		local mo = GetProtoTable("TeamPagMainData", session)
		PropDataProxy.setMyProps(mo);
    elseif (ServerID.Hero_AlreadyGot == serviceId) then
        local mo = GetProtoTable("HeroBooksData", session);
        TeamData.gotHeros:clear();
        TeamData.setAlreadyGotHeros(mo.heros);

    elseif (ServerID.SysDateSyn == serviceId) then
        local mo = GetProtoTable("DefaultData", session);
        PlayerData.sysDateSyn(mo);
    elseif (ServerID.Act_AllData == serviceId) then
        local mo = GetProtoTable("GameActiveMain", session);
        ActDataProxy.setActData(mo);
        Facade:sendNotification(MVCConst.ACT_CHANGE);
    end

end

-- 联网成功
function Network.ConnectSucceed()
--	ViewUtil.openView(ModuleName.GM)
end

--Socket消息--
function Network.OnSocket(key, data)
    plog("-->OnSocket: [%f], [%s]", key, data);
    Event.Brocast(tostring(key), data);
end

-- 当连接建立时
function Network.OnConnect()
    plog("-->Game Server connected!!");
end

-- 异常断线
function Network.OnException()
    NetManager:SendConnect();
   	error("OnException------->>>>");
end

-- 连接中断，或者被踢掉
function Network.OnDisconnect()
    error("OnDisconnect------->>>>");
end

-- 登录返回
function Network.OnLogin(buffer)
	if TestProtoType == ProtocalType.BINARY then
		this.TestLoginBinary(buffer);
	end
	if TestProtoType == ProtocalType.PB_LUA then
		this.TestLoginPblua(buffer);
	end
	if TestProtoType == ProtocalType.PBC then
		this.TestLoginPbc(buffer);
	end
	if TestProtoType == ProtocalType.SPROTO then
		this.TestLoginSproto(buffer);
	end
	----------------------------------------------------
    --createPanel("Message"); --Lua里创建面板
    local ctrl = CtrlManager.GetCtrl(CtrlName.Message);
    if ctrl ~= nil then
        ctrl:Awake();
    end
end

-- 二进制登录
function Network.TestLoginBinary(buffer)
	local protocal = buffer:ReadByte();
	local str = buffer:ReadString();
	log('二进制登录TestLoginBinary: protocal:>'..protocal..' str:>'..str);
end

-- PBLUA登录
function Network.TestLoginPblua(buffer)
	local protocal = buffer:ReadByte();
	local data = buffer:ReadBuffer();

   --[[ local msg = login_pb.LoginResponse();
    log('PBLUA登录-TestLoginPblua: protocal:>  --------------------------------------------------------------------Start');
    msg:ParseFromString(data);
	log('PBLUA登录-TestLoginPblua: protocal:>'..protocal..' msg:>'..msg.id);
    ]]
end

-- PBC登录
function Network.TestLoginPbc(buffer)
	local protocal = buffer:ReadByte();
	local data = buffer:ReadBuffer();

    local path = Util.DataPath.."lua/Third/pbc/addressbook.pb";

    local addr = io.open(path, "rb")
    local buffer = addr:read "*a"
    addr:close()
    protobuf.register(buffer)
    local decode = protobuf.decode("tutorial.Person" , data)

    print(decode.name)
    print(decode.id)
    for _,v in ipairs(decode.phone) do
        print("\t"..v.number, v.type)
    end
	log('PBC登录 TestLoginPbc: protocal:>'..protocal);
end

-- SPROTO登录
function Network.TestLoginSproto(buffer)
	local protocal = buffer:ReadByte();
	local code = buffer:ReadBuffer();

    local sp = sproto.parse [[
    .Person {
        name 0 : string
        id 1 : integer
        email 2 : string

        .PhoneNumber {
            number 0 : string
            type 1 : integer
        }

        phone 3 : *PhoneNumber
    }

    .AddressBook {
        person 0 : *Person(id)
        others 1 : *Person
    }
    ]]
    local addr = sp:decode("AddressBook", code)
    print_r(addr)
	log('SPROTO登录 TestLoginSproto: protocal:>'..protocal);
end

-- 卸载网络监听
function Network.Unload()
    Event.RemoveListener(Connect);
    --Event.RemoveListener(Login);
    --Event.RemoveListener(Exception);
    --Event.RemoveListener(Disconnect);
    warn('Unload Network...');
end

--[[
    封装前端传给后端的协议数据
    ！
    由于第一步初始封装之后的数据是使用“Ω”连接的字符串，且后台解析数据时严格依赖
    各拼接字符子串的顺序，所以要求_map必须是严格的显示的key-value的键值对，value必
    须可转换成有效的string类型，且顺序要按照后台解析的顺序存放。
    违反了Map的无序规则，比较异类，请注意。
    ！
    _map 参数表
    return []byte 字节数组
]]
function Network.reqParamEncode(_map)
    local paramStr, sendMsg, keys, buffer = "", nil, nil, nil;

    if (nil ~= _map) then
        keys = _map:keys();
        for i = 1, #keys do
            if (1 ~= i) then
                paramStr = paramStr .. "Ω";
            end
            paramStr = paramStr .. tostring(_map:value(_map:key(i)));
        end
    end
--    error("--Network.reqParamEncode--" .. paramStr);
    sendMsg = {
		msg = paramStr;
	}
	buffer = protobuf.encode("com.ftkj.proto.MoData", sendMsg);
    buffer = Util.getLuaBufferData(buffer);
    return buffer;
end