 
--[[

/// <summary>
/// 网络事件监听组件
/// </summary>

]]
NetListener = class();

function NetListener:ctor()    
    --所有的网络监听器
    self.listeners = Map.new();
end
 
--[[
	/// <summary>
	/// 添加模块关注的网络协议服务
	/// </summary>
	/// <param name="service">协议</param>
	/// <param name="callBack">回调函数,SessionCallBack类型,参数SessionData</param>
]]
function NetListener:AddNetListenter(serviceid, callBack)
    if callBack == nil then
        warn("NetListener.AddNetListenter(),监听网络服务没有回调函数");
        return;
    end    
     
    self:RemoveNetListenter(serviceid); -- 删除先前的
 
    NetManager:AddListener(serviceid, callBack);
 
    self.listeners:put(serviceid, callBack);
end

--[[
	/// <summary>
	/// 删除单个网络服务监听
	/// </summary>
	/// <param name="service">服务类型</param>
]]
function NetListener:RemoveNetListenter(serviceid)
    if self.listeners:containsKey(serviceid) then
                    
        local cb = self.listeners[serviceid];

        NetManager:RemoveListener(serviceid, cb);

        self.listeners:remove(serviceid);
    end
end

--[[
	/// <summary>
	/// 删除所有网络服务
	/// </summary>
]]
function NetListener:RemoveAllNetListenter()
	local kys = self.listeners:keys();
	for i, v in pairs(kys) do
        local cb = self.listeners[v];
        NetManager:RemoveListener(v, cb);
    end
    self.listeners:clear();
end
