--[[
-- Desc: 简易音乐和音效
-- Author: kenny
-- Date: 2016/10/29
--]]
SimpleAudio = {}

local this = SimpleAudio
this.crnt = nil;

--<summary>播放音乐</summary>
--<param name="name">不带后缀文件名</param>
--<param name="mute">是否静音</param>
function SimpleAudio.PlayMusic(name, mute, transform, tp)
	if AudioConst.GetBgmStatus() ~= 1 then
		return
	end
	name = tostring(name)
	mute = mute and true or false
    tp = tonumber(tp) or 2
	if name ~= nil then
		if (nil ~= this.crnt) then
			LuaCallManager:cancelInvokeCall(this.crnt);
		end
		--延迟调用，减缓打开模块时的卡顿时间
        --2017-2-14 10:16:52 library
		this.crnt = LuaCallManager:invokeCall(
			function () 
				SoundManager:PlayMusic(name, mute, transform, AssetBundleInfo.assetSounds, tp);
				this.crnt = nil;
			end, 1);
		--SoundManager:PlayMusic(name, mute, transform, AssetBundleInfo.assetSounds);
	end
end

--<summary>暂停音乐</summary>
function SimpleAudio.PauseMusic()
	SoundManager:PauseMusic()
end

--<summary>停止音乐</summary>
--<param name="cbFunc">Lua方法回调</param>
function SimpleAudio.StopMusic(cbFunc)
	cbFunc = cbFunc or function() end
	SoundManager:StopMusic(cbFunc)
end

--<summary>播放音效</summary>
--<param name="name">不带后缀文件名</param>
--<param name="transform">全局位置</param>
--<param name="volume">音量</param>
--<param name="cbFunc">Lua方法回调</param>
function SimpleAudio.PlayEffect(name, transform, volume, cbFunc, tp)
	if AudioConst.GetEffectStatus() ~= 1 then
		return
	end
	name = tostring(name)
	volume = tonumber(volume) or 1
	cbFunc = cbFunc or function() end
    tp = tonumber(tp) or 2;
	if name ~= nil then
		SoundManager:PlayEffectNew(name, transform, volume, cbFunc, AssetBundleInfo.assetSounds, tp)
	end
end

--<summary>停止音效</summary>
--<param name="name">不带后缀文件名</param>
function SimpleAudio.StopEffect(name)
	name = tostring(name)
	if name ~= nil then
		SoundManager:StopEffect(name)
	end
end

--<summary>停止所有音效</summary>
function SimpleAudio.StopAllEffect()
	SoundManager:StopAllEffect()
end
