--活动道具逻辑类
--2016-11-22 00:00:00 iorinie

local const_propBG = "propsBG";

ActPropShow = class();

--[[

]]
function ActPropShow:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.bg = nil;
    self.sprite = nil;
    self.number = nil;

    self.propId = 0;
    self.pCfg = nil;
    self.num = 0;
    self.id = 0;--道具唯一ID，使用道具时需要传该参数

    self.showTips = true;--控制tips显示
    self.tips = nil;--TipsProp
end

--[[

]]
function ActPropShow:Awake (_go, _pId, _num)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.propId = _pId;
    if tonumber(self.propId) < 10000 then
        self.pCfg = PropDataProxy.getPropCfgById(self.propId);
    else
        self.pCfg = HeroDataProxy.getHeroCfgById(self.propId)
    end
    self.num = (tonumber(_num) or 0);
end

--[[

]]
function ActPropShow:Start (_showTips)
    _showTips = (nil == _showTips or _showTips) and true or false;

    self.showTips = _showTips;
    self:initPanel();
    self:initListener();
end

--[[

]]
function ActPropShow:initPanel ()
    local str = "";
    -- local sprComps = nil
    -- local bgComps = nil

    self.sprite = GetGameObject(self.transform, "Sprite");
    self.bg = GetGameObject(self.transform, "BG");
    self.number = GetGameObject(self.transform, "Num");

    if (self.num > 1) then
        str = self.num .. "";
    end
    
    if tonumber(self.propId) < 10000 then
        GetComponent(self.bg, "UISprite").spriteName = const_propBG;
        GetComponent(self.sprite, "UISprite").spriteName = "" .. self.propId;
    else
        local sprComps = self.sprite.transform:GetComponents(UISprite.GetClassType()) --userdata类型

        for i = 0, sprComps.Length - 1 do
            if sprComps[i].atlas.name == "Props" then
                sprComps[i].enabled = false
            elseif sprComps[i].atlas.name == "Actors" then
                sprComps[i].spriteName = HeroDataProxy.getHeroAtlasName(self.pCfg)
                sprComps[i].enabled = true
            end
        end
    	-- local sprProp = GetComponent(self.sprite, "UISprite")
    	-- if sprProp.atlas.name == "Props" then
    	-- 	DestroyObject(sprProp, 0)
    	-- end
    	-- local sprActor = GetComponent(self.sprite, "UISprite")
     --    sprActor.spriteName = HeroDataProxy.getHeroAtlasName(self.pCfg)
     --    sprActor.enabled = true

        local bgComps = self.bg.transform:GetComponents(UISprite.GetClassType()) --userdata类型

        for i = 0, bgComps.Length - 1 do
            if bgComps[i].atlas.name == "Props" then
                bgComps[i].enabled = false
            elseif bgComps[i].atlas.name == "UIAtlas1" then
                bgComps[i].spriteName = "class"..HeroDataProxy.getHeroQuality(self.pCfg)
                bgComps[i].enabled = true
            end
        end
     --    local bgProp = GetComponent(self.bg, "UISprite")
    	-- if bgProp.atlas.name == "Props" then
    	-- 	DestroyObject(bgProp, 0)
    	-- end
    	-- local bgAtlas = GetComponent(self.bg, "UISprite")
     --    bgAtlas.spriteName = "class"..HeroDataProxy.getHeroQuality(self.pCfg)
     --    bgAtlas.enabled = true
    end
    GetComponent(self.number, "UILabel").text = str;
end

--[[

]]
function ActPropShow:initListener ()
    if (self.showTips) then
        UIEventListener.Get(self.gameObject).onPress = function (_go, _isPress) self:showPropTips(_go, _isPress); end
    end
end

--[[

]]
function ActPropShow:showPropTips (_go, _isPress)
    if (_isPress) then
        local pTipsGO = CreateObject(Util.LoadPrefab("UI/TipsProp", AssetBundleInfo.assetBundles));
--        local superWPos, superLPos = self.transform.position, self.transform.localPosition;
--        local superSPos = Camera.main:WorldToScreenPoint(superWPos);
--        local cSPos = Vector3.New(superSPos.x + 50, superSPos.y + 50, superSPos.z);
--        local cWPos = Camera.main:ScreenToWorldPoint(cSPos);
        local uiRoot = ViewUtil.getRootView();
        local mousePos = Input.mousePosition;
        local mouseToWorldPos = Camera.main:ScreenToWorldPoint(mousePos);
        local worldToLocPos = self.transform:InverseTransformPoint(mouseToWorldPos);
        local realLocPos = Vector3.New((worldToLocPos.x + 180)/self.transform.localScale.x, (worldToLocPos.y + 90)/self.transform.localScale.y, worldToLocPos.z);
        local cWPos = self.transform:TransformPoint(realLocPos);
        local lcWPos = nil;
        
        if tonumber(self.propId) < 10000 then
            GetPathComponent(pTipsGO.transform, "pName", "UILabel").text = PropDataProxy.getPropName(self.pCfg);
            GetPathComponent(pTipsGO.transform, "pDesc", "UILabel").text = PropDataProxy.getPropDesc(self.pCfg);
        else
            GetPathComponent(pTipsGO.transform, "pName", "UILabel").text = HeroDataProxy.getHeroName(self.pCfg);
            GetPathComponent(pTipsGO.transform, "pDesc", "UILabel").text = HeroDataProxy.getHeroDesc(self.pCfg);
        end
        HangObject(pTipsGO, uiRoot);
        lcWPos = uiRoot.transform:InverseTransformPoint(cWPos);
        if (lcWPos.x + 180 > ViewManager.realWidth / 2) then
            lcWPos.x = lcWPos.x - (lcWPos.x + 180 - ViewManager.realWidth / 2);
        end
        if (lcWPos.y + 90 > ViewManager.realHeight / 2) then
            lcWPos.y = lcWPos.y - (lcWPos.y + 90 - ViewManager.realHeight / 2);
        end
        pTipsGO.transform.localPosition = lcWPos;
        self.tips = pTipsGO;

        ViewUtil.sortLayerOrder(pTipsGO, LayerName.Top);
    else
        if (nil ~= self.tips) then
            DestroyObject(self.tips);
            self.tips = nil;
        end
    end
end

--[[

]]
function ActPropShow:setNum (_num)
    local str = "";
    
    self.num = tonumber(_num) or 0;
    if (self.num > 1) then
        str = self.num .. "";
    end

    GetComponent(self.number, "UILabel").text = str;
end

--[[

]]
function ActPropShow:setData (_pId, _num)
    self.propId = _pId;
    self.pCfg = PropDataProxy.getPropCfgById(self.propId);
    
    GetComponent(self.sprite, "UISprite").spriteName = "" .. self.propId;
    self:setNum(_num);
end

--[[

]]
function ActPropShow:setNumText (_numStr)
    _numStr = _numStr or "";
    GetComponent(self.number, "UILabel").text = _numStr;
end