--通用的二次确认框
--2016-7-13 14:35:47 library

ComCfmPanel = class();

--[[

]]
function ComCfmPanel:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.cfmWords = "";
    self.okWords = "";
    self.cancelWords = "";

    self.okFunc = nil;
    self.cancelFunc = nil;
end

--[[
    _go GameObject
]]
function ComCfmPanel:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self:initPanel();
end

--[[

]]
function ComCfmPanel:initPanel ()
    self.text = GetGameObject(self.transform, "MainPanel/text");
    self.closeBtn = GetGameObject(self.transform, "MainPanel/CloseBtn");
    self.okBtn = GetGameObject(self.transform, "MainPanel/OkBtn");
    self.okText = GetGameObject(self.okBtn.transform, "Text");
    self.cancelBtn = GetGameObject(self.transform, "MainPanel/CancelBtn");
    self.cancelText = GetGameObject(self.cancelBtn.transform, "Text");
end

--[[
    二次确认的初始化信息
    _cfmWords string 确认内容
    _okFunc function 确认按钮事件
    _cancelFunc function 取消按钮事件
    _okWords string 确认按钮内容
    _cancelWords string 取消按钮内容
    return nil
]]
function ComCfmPanel:initInfo (_cfmWords, _okFunc, _cancelFunc, _okWords, _cancelWords)
    self.cfmWords = _cfmWords or "";
    self.okFunc = _okFunc;
    self.cancelFunc = _cancelFunc;
    self.okWords = _okWords or "";
    self.cancelWords = _cancelWords or "";


    self:addInfos();
end

--[[
    我的二次确认框信息
]]
function ComCfmPanel:addInfos ()
    GetComponent(self.text, "UILabel").text = self.cfmWords;
    if ("" ~= self.okWords) then
        GetComponent(self.okText, "UILabel").text = self.okWords;
    end
    if ("" ~= self.cancelWords) then
        GetComponent(self.cancelText, "UILabel").text = self.cancelWords;
    end

    ViewUtil.AddButtonClickEvent(self.okBtn, function () 
        if (nil ~= self.okFunc) then
            self.okFunc();
        end
        self:closePanel();
    end, true);
    ViewUtil.AddButtonClickEvent(self.cancelBtn, function () 
        if (nil ~= self.cancelFunc) then
            self.cancelFunc();
        end
        self:closePanel();
    end, true);
    ViewUtil.AddButtonClickEvent(self.closeBtn, function () 
        if (nil ~= self.cancelFunc) then
            self.cancelFunc();
        end
        self:closePanel();
    end, true);
end

--[[

]]
function ComCfmPanel:setTxt (_txt)
    self.cfmWords = _txt or "";
    GetComponent(self.text, "UILabel").text = self.cfmWords;
end

--[[
    关闭面板
]]
function ComCfmPanel:closePanel ()
    DestroyObject(self.gameObject);
end
