--通用排行榜
--2016-10-31 11:15:06

local const_rank = "排行榜";
local const_desc = "每日21点更新排行榜，并发放排名奖励";

local const_maxRankNum = 50;

ComPlayerRankListPane = class();

--[[

]]
function ComPlayerRankListPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;
end

--[[

]]
function ComPlayerRankListPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.rankData = nil;
    self.rankListData = nil;
    self.callBackFunc = nil;

    self:initPanel();
    self:initWords();
    self:initListener();
end

--[[

]]
function ComPlayerRankListPane:initPanel ()
    self.closeBtn = GetGameObject(self.transform, "closeBtn");
    self.title = GetGameObject(self.transform, "title");
    self.desc = GetGameObject(self.transform, "desc");
    self.sv = GetGameObject(self.transform, "ScrollView");
    self.grid = GetGameObject(self.sv.transform, "Panel/Grid");

    self.playerBarBase = GetGameObject(self.grid.transform, "PlayerBarBase");
end

--[[

]]
function ComPlayerRankListPane:initWords ()
    GetComponent(self.title, "UILabel").text = const_rank;
    GetComponent(self.desc, "UILabel").text = const_desc;

end

--[[

]]
function ComPlayerRankListPane:initListener ()
    UIEventListener.Get(self.closeBtn).onClick = function () 
        if (nil ~= self.callBackFunc) then
            self.callBackFunc();
        end
        DestroyObject(self.gameObject);
    end
end

--[[

]]
function ComPlayerRankListPane:setData (_data, _func)
    self.rankData = _data;
    self.callBackFunc = _func;

    self:sortRankData();
    self:addHeroBars();
end

--[[

]]
function ComPlayerRankListPane:sortRankData ()
    self.rankListData = List.new();

    for i = 1, #self.rankData do
        self.rankListData:add(self.rankData[i]);
    end

    for i = 1, self.rankListData.size do
        for j = i + 1, self.rankListData.size do
            if (self.rankListData[i].rank > self.rankListData[j].rank) then
                local tmp = self.rankListData[i];
                self.rankListData[i] = self.rankListData[j];
                self.rankListData[j] = tmp;
            end
        end
    end
end

--[[

]]
function ComPlayerRankListPane:addHeroBars ()
    local barTmp, dataTmp, rankRow = nil, nil, nil;
    
    for i = 1, #self.rankListData do
        --排行榜最多显示50个人
        if (i <= const_maxRankNum) then
            barTmp = CreateObject(self.playerBarBase);
            dataTmp = self.rankListData[i];
            rankRow = ComPlayerRankRow.new();
            rankRow:Awake(barTmp);
            rankRow:setData(dataTmp.rank, dataTmp.logo, dataTmp.name, dataTmp.power);
            PanelManager:BindPanelScript(rankRow, barTmp, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
            HangObject(barTmp, self.grid);
            barTmp:SetActive(true);
        else
            break ;
        end
    end
    
    ResetScrollView(self.sv);
    ResetGrid(self.grid);
end