--通用商城英雄条
--2016-10-31 16:10:06 library

local const_buyCfm = "兑换 {1} 个 {2}，需要消耗{3}";
local const_buy = "购 买";
local const_notEnough = "不足";
local const_buySuccess = "购买成功";

local const_class = "class";

local const_suipian = 1061;
local const_xunzhang = 1062;


ComShopHeroRow = class();

--[[

]]
function ComShopHeroRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;
end

--[[

]]
function ComShopHeroRow:Awake (_go, _parentLua)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.parentLua = _parentLua;

    self.heroId = 0;
    self.suipianNum = 0;
    self.xunzhangNum = 0;
    self.cfg = nil;

    self.heroBG = GetGameObject(self.transform, "Hero/BG");
    self.heroSprite = GetGameObject(self.transform, "Hero/Sprite");
    self.heroName = GetGameObject(self.transform, "heroName");
    self.cost_suipian = GetGameObject(self.transform, "cost_suipian");
    self.cost_xunzhang = GetGameObject(self.transform, "cost_xunzhang");
    self.buyBtn = GetGameObject(self.transform, "buyBtn");

    self:initPanel();
    self:initListener();
end

--[[

]]
function ComShopHeroRow:initPanel ()
    GetPathComponent(self.buyBtn.transform, "Label", "UILabel").text = const_buy;
end

--[[

]]
function ComShopHeroRow:initListener ()
    UIEventListener.Get(self.buyBtn).onClick = function () self:buyFunc(); end;
end

--[[

]]
function ComShopHeroRow:buyFunc ()
    local propCfg = PropDataProxy.getPropCfgById(const_suipian);
    local costPropStr, cfmword = "", "";

    if (self.suipianNum > 0) then
        costPropStr = costPropStr .. PropDataProxy.getPropName(propCfg) .. "*" .. self.suipianNum;
    end
    propCfg = PropDataProxy.getPropCfgById(const_xunzhang);
    if (self.xunzhangNum > 0) then
        if (self.suipianNum > 0) then
            costPropStr = costPropStr .. "," .. PropDataProxy.getPropName(propCfg) .. "*" .. self.xunzhangNum;
        else
            costPropStr = PropDataProxy.getPropName(propCfg) .. "*" .. self.xunzhangNum;
        end
    end
    cfmword = string.gsub(const_buyCfm, "{1}", 1);
    cfmword = string.gsub(cfmword, "{2}", HeroDataProxy.getHeroName(self.cfg));
    cfmword = string.gsub(cfmword, "{3}", costPropStr);

    local okFunc, cancelFunc, numChgeFunc = function (_num) 
        local buf, mapData, myMny = nil, Map.new(), 0;
        
        mapData:put("propId", self.heroId);
        mapData:put("num", _num);
        buf = Network.reqParamEncode(mapData);
        
        myMny = PropDataProxy.getPropNumByPropId(const_suipian);
        if (tonumber(_num) * tonumber(self.suipianNum) > myMny) then
            ViewUtil.showMsg(PropDataProxy.getPropName(PropDataProxy.getPropCfgById(cost_suipian)) .. const_notEnough);
            return ;
        end
        myMny = PropDataProxy.getPropNumByPropId(const_xunzhang);
        if (tonumber(_num) * tonumber(self.xunzhangNum) > myMny) then
            ViewUtil.showMsg(PropDataProxy.getPropName(PropDataProxy.getPropCfgById(const_xunzhang)) .. const_notEnough);
            return ;
        end
        NetManager:SendData({}, buf, ServerID.ShopPkBuy, nil, function (sd) self:afterBuyProp(sd); end, nil, doNthFunc);
    end,
    doNthFunc,
    function (_num)
        local costPropStrTmp = "";
        local pCfg = PropDataProxy.getPropCfgById(const_suipian);
        
        if (self.suipianNum > 0) then
            costPropStrTmp = PropDataProxy.getPropName(pCfg) .. "*" .. (self.suipianNum * _num);
        end
        
        pCfg = PropDataProxy.getPropCfgById(const_xunzhang);
        if (self.xunzhangNum > 0) then
            if (self.suipianNum > 0) then
                costPropStrTmp = costPropStrTmp .. "," .. PropDataProxy.getPropName(pCfg) .. "*" .. (self.xunzhangNum * _num);
            else
                costPropStrTmp = PropDataProxy.getPropName(pCfg) .. "*" .. (self.xunzhangNum * _num);
            end
        end
        
        cfmword = string.gsub(const_buyCfm, "{1}", _num);
        cfmword = string.gsub(cfmword, "{2}", HeroDataProxy.getHeroName(HeroDataProxy.getHeroCfgById(self.heroId)));
        cfmword = string.gsub(cfmword, "{3}", costPropStrTmp);
        
        return cfmword;
    end

    ViewUtil.comNumChgePanel(cfmword, okFunc, cancelFunc, numChgeFunc);
end

--[[

]]
function ComShopHeroRow:afterBuyProp (sd)
    local sd = GetProtoTable("DefaultData", sd);

    if (0 ~= sd.code) then
        ViewUtil.showMsg(GetWord(sd.code));
        return ;
    end
    ViewUtil.showMsg(const_buySuccess);
    LuaCallManager:invokeCall(function () 
        self.parentLua:showMyMny();
    end, 1);
end

--[[

]]
function ComShopHeroRow:setData (_heroId, _suipianNum, _xunzhangNum)
    self.heroId = _heroId;
    self.suipianNum = _suipianNum;
    self.xunzhangNum = _xunzhangNum;
    self.cfg = HeroDataProxy.getHeroCfgById(self.heroId);

    self:showHeros();
end

--[[

]]
function ComShopHeroRow:showHeros ()
    GetComponent(self.heroBG, "UISprite").spriteName = const_class .. HeroDataProxy.getHeroQuality(self.cfg);
    GetComponent(self.heroSprite, "UISprite").spriteName = HeroDataProxy.getHeroAtlasName(self.cfg);
    GetComponent(self.heroName, "UILabel").text = HeroDataProxy.getHeroName(self.cfg);
    GetComponent(self.cost_suipian, "UILabel").text = self.suipianNum .. "";
    GetComponent(self.cost_xunzhang, "UILabel").text = self.xunzhangNum .. "";
end