--数量增减框
--2016-8-5 11:17:22 library

local const_preName = "NumChgePane";
local const_delayTime = 0.5;

NumChgePanel = class();

--[[

]]
function NumChgePanel:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.rdcBtn = nil;
    self.addBtn = nil;
    self.numText = nil;

    self.callback = nil;

    self.curNum = 0;
    self.maxNum = 99;
    self.coroutineList = List.new();

    self.addMark = 0;
    self.timer = Timer.New(function () self:timerAdd(); end, 0.3, 9999);
end

--[[

]]
function NumChgePanel:Awake (_cb)
    local prefab = Util.LoadPrefab("UI/" .. const_preName, AssetBundleInfo.assetBundles);

    self.gameObject = CreateObject(prefab);
    self.transform = self.gameObject.transform;

    self.callback = _cb or function ( ... ) end;

    self:initPanel();
    self:initListener();
end

--[[

]]
function NumChgePanel:initPanel ()
    self.rdcBtn = GetGameObject(self.transform, "rdcBtn");
    self.addBtn = GetGameObject(self.transform, "addBtn");
    self.numText = GetGameObject(self.transform, "numText");

    GetComponent(self.numText, "UILabel").text = "1";
    self.curNum = 1;
end

--[[

]]
function NumChgePanel:initListener ()
    UIEventListener.Get(self.rdcBtn).onPress = function (_go, _isPress) self:rdcPressFunc(_go, _isPress); end;
    UIEventListener.Get(self.addBtn).onPress = function (_go, _isPress) self:addPressFunc(_go, _isPress); end;
end

--[[

]]
function NumChgePanel:rdcPressFunc (_go, _isPress)
    if (_isPress) then
        self:numChge(-1);
        self.addMark = 1;
        local coroutine = LuaCallManager:invokeCall(function () 
            if (nil ~= self.timer) then
                self.timer:Start(); 
            end
        end, const_delayTime);
        self.coroutineList:add(coroutine);
    else
        self:clearCoroutine();
        self.addMark = 0;
        self.timer:Stop();
    end
end

--[[

]]
function NumChgePanel:addPressFunc (_go, _isPress)
    if (_isPress) then
        self:numChge(1);
        self.addMark = 2;
        local coroutine = LuaCallManager:invokeCall(function () 
            if (nil ~= self.timer) then
                self.timer:Start(); 
            end
        end, const_delayTime);
        self.coroutineList:add(coroutine);
    else
        self:clearCoroutine();
        self.addMark = 0;
        self.timer:Stop();
    end
end

--[[

]]
function NumChgePanel:numChge (_cnt)
    _cnt = _cnt or 0;
    
    self.curNum = self.curNum + _cnt;
    if (self.curNum < 1) then
        self.curNum = 1;
    end
    GetComponent(self.numText, "UILabel").text = "" .. self.curNum;

    if (nil ~= self.callback) then
        self.callback(self.curNum);
    end
end

--[[

]]
function NumChgePanel:timerAdd ()
    local numStep = 0;

    if (1 == self.addMark) then
        numStep = -1;
    elseif (2 == self.addMark) then
        numStep = 1;
    end

    self:numChge(numStep);
end

--[[

]]
function NumChgePanel:OnDestroy ()
    DestroyObject(self.gameObject);

    self.gameObject = nil;
    self.transform = nil;

    if (nil ~= self.timer) then
        self.timer:Stop();
        self.timer = nil;
    end
end

--[[

]]
function NumChgePanel:clearCoroutine ()
    for i = 1, self.coroutineList:getSize() do
        LuaCallManager:cancelInvokeCall(self.coroutineList[i]);
    end

    self.coroutineList:clear();
end