--道具逻辑类
--2016-7-9 15:04:24 library

local const_propBG = "propsBG";

PropShowItem = class();

--[[

]]
function PropShowItem:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.bg = nil;
    self.sprite = nil;
    self.number = nil;

    self.propId = 0;
    self.pCfg = nil;
    self.num = 0;
    self.id = 0;--道具唯一ID，使用道具时需要传该参数

    self.showTips = true;--控制tips显示
    self.tips = nil;--TipsProp
end

--[[

]]
function PropShowItem:Awake (_go, _pId, _num)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.propId = _pId;
    self.pCfg = PropDataProxy.getPropCfgById(self.propId);
    self.num = (tonumber(_num) or 0);
end

--[[

]]
function PropShowItem:Start (_showTips)
    _showTips = (nil == _showTips or _showTips) and true or false;

    self.showTips = _showTips;
    self:initPanel();
    self:initListener();
end

--[[

]]
function PropShowItem:initPanel ()
    local str = "";

    self.bg = GetGameObject(self.transform, "BG");
    self.sprite = GetGameObject(self.transform, "Sprite");
    self.number = GetGameObject(self.transform, "Num");

    if (self.num > 1) then
        str = self.num .. "";
    end
    
    GetComponent(self.bg, "UISprite").spriteName = const_propBG;
    GetComponent(self.sprite, "UISprite").spriteName = "" .. self.propId;
    GetComponent(self.number, "UILabel").text = str;
end

--[[

]]
function PropShowItem:initListener ()
    if (self.showTips) then
        UIEventListener.Get(self.gameObject).onPress = function (_go, _isPress) self:showPropTips(_go, _isPress); end
    end
end

--[[

]]
function PropShowItem:showPropTips (_go, _isPress)
    if (_isPress) then
        local pTipsGO = CreateObject(Util.LoadPrefab("UI/TipsProp", AssetBundleInfo.assetBundles));
        local uiRoot = ViewUtil.getRootView();
        local mousePos = Input.mousePosition;
        local mouseToWorldPos = Camera.main:ScreenToWorldPoint(mousePos);
        local worldToLocPos = uiRoot.transform:InverseTransformPoint(mouseToWorldPos);
        local realLocPos = Vector3.New(worldToLocPos.x + 180, worldToLocPos.y + 90, worldToLocPos.z);
        local cWPos = uiRoot.transform:TransformPoint(realLocPos);
        local lcWPos = nil;
        
        GetPathComponent(pTipsGO.transform, "pName", "UILabel").text = PropDataProxy.getPropName(self.pCfg);
        GetPathComponent(pTipsGO.transform, "pDesc", "UILabel").text = PropDataProxy.getPropDesc(self.pCfg);
        
        HangObject(pTipsGO, uiRoot);

        lcWPos = uiRoot.transform:InverseTransformPoint(cWPos);
        if (lcWPos.x + 180 > ViewManager.realWidth / 2) then
            lcWPos.x = lcWPos.x - (lcWPos.x + 180 - ViewManager.realWidth / 2);
        end
        if (lcWPos.y + 90 > ViewManager.realHeight / 2) then
            lcWPos.y = lcWPos.y - (lcWPos.y + 90 - ViewManager.realHeight / 2);
        end
        pTipsGO.transform.localPosition = lcWPos;
        self.tips = pTipsGO;

        ViewUtil.sortLayerOrder(pTipsGO, LayerName.Top);
    else
        if (nil ~= self.tips) then
            DestroyObject(self.tips);
            self.tips = nil;
        end
    end
end

--[[

]]
function PropShowItem:setNum (_num)
    local str = "";
    
    self.num = tonumber(_num) or 0;
    if (self.num > 1) then
        str = self.num .. "";
    end

    GetComponent(self.number, "UILabel").text = str;
end

--[[

]]
function PropShowItem:setData (_pId, _num)
    self.propId = _pId;
    self.pCfg = PropDataProxy.getPropCfgById(self.propId);
    
    GetComponent(self.sprite, "UISprite").spriteName = "" .. self.propId;
    self:setNum(_num);
end

--[[

]]
function PropShowItem:setNumText (_numStr)
    _numStr = _numStr or "";
    GetComponent(self.number, "UILabel").text = _numStr;
end