TipsClass = class(BaseHero)

function TipsClass:ctor()
	self.heroObj = nil
	self.onlyId = 0					-- 唯一ID
	self.heroId = 0					-- 英雄ID
	self.prefabName = nil
	self.quality = nil
	self.heroName = nil
	self.placeId = 0
	self.data = nil
	self.propAtk = 0
	self.propDef = 0
	self.propDodge = 0
	self.propKing = 0
	self.level = 0
	self.wiseup = 0
	self.strengthen = 0
	self.soldiers = 0
end

function TipsClass:init(data, heroId)
	if IsEmptyTable(data) then return end
	self.data = CopyTable(data)
	self.onlyId = tostring(data.id)
	self.heroId = tostring(heroId)

	local herosConf = Config.getHerosData()
	local conf = herosConf[self.heroId]
	self.conf = conf
	if IsEmptyTable(conf) then
		return
	end
	self.prefabName = conf["#prefab_name"]
	self.quality = conf["quality"]
	self.heroName = conf["hero_name"] or "NoName"
	self.skillIds = split(conf["skill_id"], ",")
	self.propAtk = tonumber(conf["xg"]) or 0					-- 先攻
	self.propDef = tonumber(conf["fy"]) or 0					-- 防御
	self.propDodge = tonumber(conf["sb"])	 or 0				-- 闪避
	self.propKing = tonumber(conf["wz"]	) or 0				-- 王者
	self.level = tonumber(data.level) or 1							-- 等级
	self.wiseup = tonumber(data.wiseup) or 0					-- 觉醒
	self.strengthen = tonumber(data.strengthen) or 0		-- 强化
end

function TipsClass:getData()
	return self.data
end

function TipsClass:createHero()
	local hero = self.super.createHero(self, "UI/Hero")
	ViewUtil.addDragScrollView(hero)
	self.heroObj = hero
	return hero
end

function TipsClass:createSkillHero()
	local hero = self.super.createHero(self, "UI/ItemSkillHero")
	ViewUtil.addDragScrollView(hero)
	ViewUtil.sortLayerOrder(hero, LayerName.UI)
	self.heroObj = hero
	local state = GetGameObject(hero.transform, "State")
	local title = GetPathComponent(state.transform, "Title", "UILabel")
	local name = GetPathComponent(state.transform, "Name", "UILabel")
	local recruit = TeamData.IsRecruitedHero(self.heroId)
	if recruit then
		local isOn = TeamData.IsFightHero(self.heroId)
		if isOn then
			title.text = "已上阵 1"
			Util.EnableButton(state, ButtonState.Pressed, false)
		else
			title.text = "未上阵"
			Util.EnableButton(state, ButtonState.Disabled, false)
		end
	else
		title.text = "未招募"
		Util.EnableButton(state, ButtonState.Normal, false)
	end
	name.text = self.heroName.."\nX1"

	return hero
end
