--探险
--2016-7-22 14:18:50 library

require "Game/Explore/Logic/ExploreConstant"
require "Game/Explore/Logic/ExploreDefine"
require "Game/Explore/Logic/ExplorePrefabMgr"
require "Game/Explore/View/ExploreBGMgr"
require "Game/Explore/View/ExploreCompassPanel"
require "Game/Explore/View/ExploreDecorateMgr"
require "Game/Explore/View/ExploreGetRwdRow"
require "Game/Explore/View/ExploreMapUnitMgr"
require "Game/Explore/View/ExploreMineDetailPanel"
require "Game/Explore/View/ExploreMyPropRow"
require "Game/Explore/View/ExplorePlayersMgr"
require "Game/Explore/View/ExplorePlayerRow"
require "Game/Explore/View/ExploreRwdPanel"
require "Game/Explore/View/ExploreSelectPropPanel"
require "Game/Explore/View/ExploreSltMapPane"
require "Game/Explore/View/ExploreSquareMgr"
require "Game/Explore/View/ExploreSquRow"
require "Game/Explore/View/ExploreView"
require "Game/Explore/View/MapUnitPanel"


ExploreControler = {
    gameObject = nil;
    transform = nil;
    exploreView = nil;
    updatePlayerList = nil;--需要使用计时器的玩家列表，存的是teamId

    cortList = List.new();
};

local this = ExploreControler;

--[[

]]
function ExploreControler.New ()
    return this;
end

--[[

]]
function ExploreControler.OnCreate (_go, _name)
    this.gameObject = _go;
    this.transform = this.gameObject.transform;

    this.exploreView = ExploreView.new();
    this.exploreView:Awake(this.gameObject, this);
    this.exploreView:initPanel();
    this.view = this.exploreView;
    this.name = _name;

    this.updatePlayerList = List.new();

    UpdateHelper.addUpdate(this.Update);
    this.callBaseData();
end

--[[
    处理计时器
]]
function ExploreControler.Update ()
    this.view:Update();
end

--[[
    同步updatePlayerList
    _tab Table 存的是teamId
    _tp number 0，加入列表；1，从列表中移除
]]
function ExploreControler.synUpdatePlayerList (_tab, _tp)
    local tid, tmpTab = nil, {};

    _tp = _tp or 0;
    _tab = _tab or {};
    for i = 1, #_tab do
        tid = _tab[i];

        if (0 == _tp) then
            if (this.updatePlayerList and not this.updatePlayerList:contains(tid)) then
                this.updatePlayerList:add(tid);
            end
        end
        
        if (1 == _tp) then
            this.updatePlayerList:remove(tid);
            if (tid ~= PlayerData.GetRoleTeamId()) then
                table.insert(tmpTab, tid);
            end
        end
    end
    
    if (1 == _tp) then
        this.view:refreshSquShow(tmpTab);
    end
end

--[[

]]
function ExploreControler.callBaseData ()
    Network.ReqExploreCvt();
end

--[[

]]
function ExploreControler.initViewData (_data, _tp)
    if (_tp ~= ExploreDefine.ExploreEtyType.ExploreResetMapPanel) then
        this.exploreView:initData(_data, _tp);
    else
        this.destroyOldMap();
        this.exploreView:initData(_data, ExploreDefine.ExploreEtyType.ExploreMapPanel);
    end
end

--[[

]]
function ExploreControler.destroyOldMap ()
    if (this.view) then
        this.view:resetMap();
    end
    this.resetMap();
end

--[[

]]
function ExploreControler.getViewActivationData ()
    return this.exploreView.mapMainData.activationMap;
end

--[[

]]
function ExploreControler.getWholeMapRscData ()
    return this.exploreView.wholeMapRscData;
end

--[[
    更新View中的数据--玩家信息
]]
--function ExploreControler.updatePlayerData ( ... )

--end

--[[

]]
function ExploreControler.listNotificationInterests ()
    local list = {
        MVCConst.INITDATA_EXPLORE,
        MVCConst.EXPLORE_REMOVEPLAYER,
        MVCConst.EXPLORE_MOVEPLAYERS,
        --[[MVCConst.EXPLORE_SETPOSTIONDATA,]]
        MVCConst.EXPLORE_SYNPLAYERSDATA,
        MVCConst.EXPLORE_SLTPROPCHANGE,
        MVCConst.EXPLORE_LASTFIVESQUARE,
        MVCConst.EXPLORE_NPCLVLCHANGE,
        MVCConst.EXPLORE_RESETMAPCENTER,
    };

    return unpack(list);
end

--[[

]]
function ExploreControler.handleNotification (note)
    local nName = note:getName();
    local nBody = note:getBody();
    local nType = note:getType();
    
    if (MVCConst.INITDATA_EXPLORE == nName) then
        --进入主界面，初始化数据
        this.initViewData(nBody[1], nBody[2]);
    elseif (MVCConst.EXPLORE_REMOVEPLAYER == nName) then
        --移除玩家
        local rmvTeamId = nil;

        rmvTeamId = nBody.teamId;

        this.view:removePlayer(rmvTeamId);
    elseif (MVCConst.EXPLORE_MOVEPLAYERS == nName) then
        local listTmp = List.new();
        --DOWN library 2016-9-9 14:39:03 将玩家移动到正确的地图单元，不牵涉数据同步，仅为玩家位置的展示更新
        for i = 1, #nBody do
            listTmp:add(nBody[i]);
        end
        
        this.view.mapUnitMgr:dealTarPlayers(listTmp);
    --[[elseif (MVCConst.EXPLORE_SETPOSTIONDATA == nName) then
        --未用到
        this.setPostionData(nBody);]]
    elseif (MVCConst.EXPLORE_SYNPLAYERSDATA == nName) then
        --玩家移动或挖掘
        local sData = nBody;--PushArcMapPoinData
        
        this.setPostionData(sData);
    elseif (MVCConst.EXPLORE_SLTPROPCHANGE == nName) then
        --选择要查找的遗迹，更新罗盘显示
        local propId = nBody[1];

        this.view:setCompassProp(propId);
    elseif (MVCConst.EXPLORE_LASTFIVESQUARE == nName) then
        --探险特殊资源，推包
        local endData = nBody[1];--PushArcMapPoinEndData

        this.view:setSquDataFromPushSpecialRsc(endData);
    elseif (MVCConst.EXPLORE_NPCLVLCHANGE == nName) then
        --NPC信息变动，推包
        local def = nBody[1];--DefaultData
        
        this.view:synNPCLvl(def.code);
    elseif (MVCConst.EXPLORE_RESETMAPCENTER == nName) then
        local tmpCort = LuaCallManager:invokeCall(function () 
            this.view.mapUnitMgr:ctlCurSVPosToMidScreen();
        end, 0.2);
        this.addToCortList(tmpCort);
    end
end

--[[
    设置位置等数据 ArcMapPoinData status, giftId, second
    _tab table 里面存放的是ArcTeamMapData
    _tp number 0，需要同步显示玩家的位置；1，仅同步数据
    return nil
]]
function ExploreControler.setPostionData (_tab, _tp)
    local pData = nil;--ArcTeamMapData
    local teamList = List.new();
    local status = 0;
    
    _tab = _tab or {};
    _tp = _tp or 0;
    for i = 1, #_tab do
        pData = _tab[i];
        --2016-10-19 20:51:50 library 非挖掘状态，是为玩家位置移动
        if (ExploreDefine.SqaureType.Diging ~= pData.position.status) then
            this.view:setSquDataAfterMove(pData);
        else
            if (PlayerData.GetRoleTeamId() == pData.teamId) then
                this.view:setSquDataDiging(pData);
            else
                pData.position.status = ExploreDefine.SqaureType.Searched;
                this.view:setSquDataAfterMove(pData);

                local cortTmp = LuaCallManager:invokeCall(function () 
                    pData.position.status = ExploreDefine.SqaureType.Diging;
                    this.view:setSquDataDiging(pData, 2);
                end, ExploreDefine.const_moveTime);
                this.addToCortList(cortTmp);
            end
        end

        if (0 == _tp) then
            --DOWN library 2016-9-8 20:34:13 同步显示玩家的位置、倒计时、洛阳铲、帐篷状态
            teamList:add(pData);
        end
    end
    
    if (teamList:getSize() > 0) then
        this.view.mapUnitMgr:dealTarPlayers(teamList, 1);

        local tmpTab = {};

        for i = 1, teamList.size do 
            table.insert(tmpTab, teamList[i].teamId);
        end
        local cortTmp = LuaCallManager:invokeCall(function () 
            this.synUpdatePlayerList(tmpTab);
        end, ExploreDefine.const_moveTime);
        this.addToCortList(cortTmp);
    end
end

--[[
    not use
    comment by library 2017-2-27 12:18:39
]]
--function ExploreControler.sortAllGO ()
--    ViewManager.SortOrder(this.gameObject);
--end

--[[

]]
function ExploreControler.getMyPos ()
    local myPos = Vector3.zero;
    local myHero = nil;--ExplorePlayerRow;
    local pos = nil;
    
    myHero = this.view.playersMgr.myHero;
    if (nil ~= myHero and nil ~= myHero.heroInfoData) then
        pos = myHero.heroInfoData.position;
        
        if (nil ~= pos) then
            myPos = Vector3.New(pos.x, pos.y, 0);
        end
    end
    
    return myPos;
end

--[[

]]
function ExploreControler.resetMap ()
    this.updatePlayerList:clear();
end

--[[
    简易引导
]]
function ExploreControler.showEasyGuide ()
    if (this.view and this.view.mapMainData and this.view.mapMainData.team) then
        if (this.view.mapMainData.team.npcLeveL > 0 and this.view.mapMainData.team.npcStatus > 0) then
            local easyGuideVal = SimpleCache.getCacheVal(SimpleCache.simpleCacheExplore, 2);
            
            if (0 == easyGuideVal) then
                SimpleCache.setCache(SimpleCache.simpleCacheExplore, 1, 2);
                ViewUtil.showEasyGuide(ConstantNames.EasyGuide_Explore);
            end
        end
    end
end

--[[

]]
function ExploreControler.OnDestroy ()
    this.cleanCortList();
    UpdateHelper.removeUpdate(this.Update);
    this.updatePlayerList = nil;
    this.gameObject = nil;
    this.transform = nil;
    this.exploreView = nil;
    this.view = nil;
end

--[[
    将Coroutine添加到this.cortList
    _cort Coroutine
    return nil
]]
function ExploreControler.addToCortList (_cort)
    local maxSize = 10000;

    if (this.cortList.size > maxSize) then
        this.cortList:clear();
    end
    if (nil ~= _cort) then
        this.cortList:add(_cort);
    end
end

--[[
    模块销毁后，清空cortList
]]
function ExploreControler.cleanCortList ()
    local cortTmp = nil;

    for i = 1, this.cortList.size do 
        cortTmp = this.cortList[i];
        LuaCallManager:cancelInvokeCall(cortTmp);
    end

    this.cortList:clear();
end