--罗盘面板
--2016-9-18 10:44:04 library

local const_all = "全 部";
local const_noResource = "没有找到资源";

ExploreCompassPanel = class();

function ExploreCompassPanel:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.rscId = ExploreDefine.explorePropMinId;--资源类型
    self.curVal = 0;--当前的z轴旋转角度
    self.run = false;--控制指南针的持续移动
    self.isRunning = false;
end

--[[

]]
function ExploreCompassPanel:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.pointer = GetGameObject(self.transform, "pointer");
    self.sltPropBtn = GetGameObject(self.transform, "sltPropBtn");
    self.sltPanel = GetGameObject(self.transform, "SltPanel");

    self:setSltPropBtnLabel();
    self:initListener();
end

function ExploreCompassPanel:initListener()
    ViewUtil.AddClickEvent(self.sltPropBtn, function ()
        local luaBhvi, spPanel = nil, nil;
        local ctl = ModuleManager.GetCtrl(ModuleName.EXPLORE);

        self.sltPanel:SetActive(true);
        luaBhvi = GetComponent(self.sltPanel, "LuaBehaviour");
        if (nil ~= luaBhvi) then
            spPanel = luaBhvi.sourceLuaObj;
        end

        if (nil == spPanel) then
            spPanel = ExploreSelectPropPanel.new();
            spPanel:Awake(self.sltPanel);
            PanelManager:BindPanelScript(spPanel, self.sltPanel, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        end

        spPanel:showAllSltProps(self.rscId);
        ctl.exploreView.sltMapPanel:SetActive(false);
        ViewUtil.sortLayerOrder(self.sltPanel);
        if (PlayerData.guideNotEnd()) then
			Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
		end
    end)
end

--[[

]]
function ExploreCompassPanel:setPropId (_propId)
    _propId = _propId or ExploreDefine.explorePropMinId;
    self.rscId = _propId;

    self:setSltPropBtnLabel();
end

--[[
    设置罗盘指针指示的资源的资源名称
]]
function ExploreCompassPanel:setSltPropBtnLabel ()
    local label = GetPathComponent(self.sltPropBtn.transform, "sltPropLabel", "UILabel");
    local pCfg = nil;
    local name = "";

    pCfg = PropDataProxy.getPropCfgById(self.rscId);
    name = PropDataProxy.getPropName(pCfg);
    label.text = name;
end

--[[
    根据我的位置，设置罗盘指针的指向
    _myPos Vector3 我的位置
    _tarPos Vector3 目标位置
    return null
]]
function ExploreCompassPanel:drawPanel (_myPos, _tarPos)
    local rslt = nil;
    local delta = 0;
    
    _myPos = _myPos or Vector3.New(10, 0, 0);
    _tarPos = _tarPos or Vector3.New(-1, 0, 0);
    rslt = _tarPos - _myPos;

    zVal = Vector3.Dot(Vector3.right.normalized, rslt.normalized);
    zVal = math.acos(zVal) * 180 / math.pi;
    
    if (rslt.y < 0) then
        zVal = -zVal;
    end
    
    if (-1 == _tarPos.x) then
        --没有找到资源
        self.run = true;
        self:keepNiddleRunning();
        return ;
    end

    if (self.curVal ~= zVal) then
        self.curVal = zVal;
        self.run = false;
        iTween.Stop(self.pointer);
        self.isRunning = false;
        iTween.RotateTo(self.pointer, iTween.Hash(
            "z", zVal,
            "time", 0.1,
			"easeType", iTween.EaseType.linear
        ));
    end
end

--[[
    _tp number
]]
function ExploreCompassPanel:keepNiddleRunning (_tp)
    local nextVal = 0;

    _tp = _tp or -1;
    _tp = _tp * -1;
    nextVal = self.curVal - 180 * _tp;
    
    if (self.run) then
        if (not self.isRunning) then
            self.isRunning = true;
            iTween.RotateTo(self.pointer, iTween.Hash(
                "z", nextVal,
                "time", 1,
			    "easeType", iTween.EaseType.linear,
                "oncomplete", function () 
                        self.isRunning = false;
                        self.curVal = nextVal;
                        self:keepNiddleRunning(_tp);
                    end
            ));
        end
    else
        return ;
    end
end