--地图单元管理器
--2016-7-26 18:26:17 library

ExploreMapUnitMgr = class();

--[[

]]
function ExploreMapUnitMgr:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.uiExtWrapContent = nil;
    self.muInMemoryList = nil;

    self.ctl = nil;
    self.isUIExtWrapContnetStarted = true;
end

--[[

]]
function ExploreMapUnitMgr:Awake (_go, _ctl)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.ctl = _ctl;
    
    self.muInMemoryList = List.new();
end

--[[

]]
function ExploreMapUnitMgr:Start ()
    
end

--[[

]]
function ExploreMapUnitMgr:initPanel ()
    local unitMap, mapUnitSize = ExploreConstant.getUnitMap(), ExploreConstant.getMapUnitSize();
    local myPos = self.ctl.getMyPos();
    
    self.uiExtWrapContent = GetComponent(self.gameObject, "UIExtWrapContent");
    
    self.uiExtWrapContent.itemHorizontalSize = unitMap.x;
    self.uiExtWrapContent.itemVerticalSize = unitMap.y;
    self.uiExtWrapContent.minHorizontalIndex = 0;
    self.uiExtWrapContent.maxHorizontalIndex = mapUnitSize.x - 1;
    self.uiExtWrapContent.minVerticalIndex = 0;
    self.uiExtWrapContent.maxVerticalIndex = mapUnitSize.y - 1;

    --2017-3-6 15:12:23 library
    --下面四项设置，是解决每个移动单元的锚点不在中心点，导致每次地图单元移动触发的条件有误的问题
    self.uiExtWrapContent.horizontalRightMoveDis = -480;
    self.uiExtWrapContent.horizontalLeftMoveDis = 320;
    self.uiExtWrapContent.verticalRightMoveDis = -480;
    self.uiExtWrapContent.verticalLeftMoveDis = 320;

    self.uiExtWrapContent.enabled = true;
    if (not self.isUIExtWrapContnetStarted) then
        self.isUIExtWrapContnetStarted = true;
        self.uiExtWrapContent:Start();
    end
    
    self.uiExtWrapContent.onInitializeItem = function (_go, _idx, _realHIndex, _realVIndex) 
        local muPanel, goTmp = nil, nil;
        
        muPanel = self:getMuPanelByGO(_go);
        
        if (nil == muPanel) then
            muPanel = MapUnitPanel.new();
            muPanel:Awake(_go, _idx, self.ctl);
            self.muInMemoryList:add(muPanel);
        end
        
        muPanel:initData(_realHIndex, _realVIndex);
    end
    
    self:ctlCurSVPosToMidScreen();
end

--[[

]]
function ExploreMapUnitMgr:ctlCurSVPosToMidScreen (_tp)
    local svTrans = self.transform.parent.parent;
    local pl = GetComponent(svTrans, "UIPanel");--UIPanel
    
    _tp = _tp or 0;
    
    svTrans.localPosition = Vector3.New(-320, -320, 0);
    pl.clipOffset = Vector2.New(320, 320);
    self:setMyPosToMidScreen();
end

--[[
    移动ScrollView，使我处在屏幕中心
]]
function ExploreMapUnitMgr:setMyPosToMidScreen ()
    local svTrans = self.transform.parent.parent;
    local posTmp = svTrans.localPosition;
    local sv = GetComponent(svTrans, "UIScrollView");--UIScrollView
    local pl = GetComponent(svTrans, "UIPanel");--UIPanel
    local vec4 = pl.baseClipRegion;
    local mapSqu = ExploreConstant.getMapSqu();
    local mapVec = ExploreConstant.getMapCntSize();
    local xCnt, yCnt = vec4.z / mapSqu.x, vec4.w / mapSqu.y;
    local xMaxCnt, yMaxCnt = mapVec.x - xCnt, mapVec.y - yCnt;
    local myPos = self.ctl.getMyPos();
    local xMoveCnt, yMoveCnt = myPos.x - GetIntPart(xCnt / 2), myPos.y - GetIntPart(yCnt / 2);
    local lastX, lastY = 0, 0;
    
    xMoveCnt = (xMoveCnt > 0) and xMoveCnt or 0;
    yMoveCnt = (yMoveCnt > 0) and yMoveCnt or 0;
    xMoveCnt = (xMoveCnt > xMaxCnt) and xMaxCnt or xMoveCnt;
    yMoveCnt = (yMoveCnt > yMaxCnt) and yMaxCnt or yMoveCnt;
    lastX = -mapSqu.x * xMoveCnt + posTmp.x;
    lastY = -mapSqu.y * yMoveCnt + posTmp.y;

    sv:MoveRelative(Vector3.New(-mapSqu.x * xMoveCnt, -mapSqu.y * yMoveCnt, 0));
    local cortTmp = LuaCallManager:invokeCall(function () 
        if (pl and pl.clipOffset) then
            pl.clipOffset = Vector2.New(pl.clipOffset.x - 0.005, pl.clipOffset.y - 0.005);
        end
    end, 0.1);
    local cortFTmp = LuaCallManager:invokeCall(function () 
        if (pl and pl.clipOffset) then
            pl.clipOffset = Vector2.New(pl.clipOffset.x + 0.005, pl.clipOffset.y + 0.005);
        end
    end, 0.2);
    self.ctl.addToCortList(cortTmp);
    self.ctl.addToCortList(cortFTmp);
    
    if (PlayerData.guideNotEnd()) then
        local cortSTmp = LuaCallManager:invokeCall(function () 
            local muPName = "";
            
            if (self.ctl.view and self.ctl.view.playersMgr and self.ctl.view.playersMgr.myHero) then
                muPName = self.ctl.view.playersMgr.myHero.transform.parent.name;
            end

            Facade:sendNotification(MVCConst.GUIDE_NEXT, {[2] = muPName, [3] = "Player_" .. PlayerData.GetRoleTeamId()});
        end, 0.3);
        self.ctl.addToCortList(cortSTmp);
    end
end

--[[
    移除指定的玩家
    _tId number 
    return nil
]]
function ExploreMapUnitMgr:removePlayer (_tId)
    local muTmp = nil;

    for i = 1, self.muInMemoryList:getSize() do
        muTmp = self.muInMemoryList[i];
        if (nil ~= muTmp) then
            muTmp:removePlayer(_tId);
        end
    end
end

--[[
    处理指定玩家的位置
    _tabList List
    _tp number 0,_tabList的类型是id 1,_tabList的类型是ArcTeamMapData
]]
function ExploreMapUnitMgr:dealTarPlayers (_tabList, _tp)
    local muTmp = nil;--MapUnitPanel
    
    for i = 1, self.muInMemoryList:getSize() do
        muTmp = self.muInMemoryList[i];
        if (nil ~= muTmp) then
            muTmp:dealNPCAndHeros(_tabList, _tp);
        end
    end
end

--[[
    将指定位置的方块，设置为可见
    _list List<table> table:{x, y}
]]
function ExploreMapUnitMgr:showTarPosSqu (_list)
    local pos, muPane, squRow = nil, nil, nil;

    _list = _list or List.new();
    for m = 1, _list.size do
        for i = 1, self.muInMemoryList.size do
            muPane = self.muInMemoryList[i];
            for j = 1, muPane.squareMgr.squList.size do
                squRow = muPane.squareMgr.squList[j];
                if (_list[m].x == squRow.posVec.x and _list[m].y == squRow.posVec.y) then
                    squRow:setShow();
                end
            end
        end
    end
end

--[[
    设置指定位置的方块的道具，并绘制显示
    _list List<table> table:{x, y, giftId}
]]
function ExploreMapUnitMgr:setSquGiftId (_list)
    local pos, muPane, squRow, info = nil, nil, nil, nil;

    _list = _list or List.new();
    for m = 1, _list.size do
        info = _list[m];
        for i = 1, self.muInMemoryList.size do
            muPane = self.muInMemoryList[i];
            for j = 1, muPane.squareMgr.squList.size do
                squRow = muPane.squareMgr.squList[j];
                if (_list[m].x == squRow.posVec.x and _list[m].y == squRow.posVec.y) then
                    squRow:setRsrcId(info[3]);
                end
            end
        end
    end
end

--[[
    将我周围的四个方格的BG换成提示BG
    _myHeroData ArcTeamMapData
]]
function ExploreMapUnitMgr:showAroundSqureLight (_myHeroData)
    local pos, muPane, squRow = nil, nil, nil;
    local mapTmp = ExploreConstant.getMapCntSize();
    
    pos = _myHeroData.position;

    for i = 1, self.muInMemoryList.size do
        muPane = self.muInMemoryList[i];
        for j = 1, muPane.squareMgr.squList.size do
            squRow = muPane.squareMgr.squList[j];
            if (
                1 == math.abs(pos.x - squRow.posVec.x) + math.abs(pos.y - squRow.posVec.y) and
                squRow.posVec.x < mapTmp.x and
                squRow.posVec.y < mapTmp.y
            ) then
                squRow:showSqureLight();
            end
        end
    end
end

--[[
    取self.muInMemoryList中的MapUnitPanel实例
    _go GameObject
]]
function ExploreMapUnitMgr:getMuPanelByGO (_go)
    local muPane = nil;--MapUnitPanel

    for i = 1, self.muInMemoryList.size do
        muPane = self.muInMemoryList[i];
        if (muPane and muPane.gameObject.name == _go.name) then
            break ;
        else
            muPane = nil;
        end
    end

    return muPane;
end

--[[

]]
function ExploreMapUnitMgr:resetMap ()
    local muPane = nil;--MapUnitPanel
    
    self.uiExtWrapContent.enabled = false;
    self.isUIExtWrapContnetStarted = false;
    
    if (nil ~= self.muInMemoryList) then
        self.muInMemoryList:clear();
    end
end

--[[

]]
function ExploreMapUnitMgr:OnDestory ()
    if (nil ~= self.muInMemoryList) then
        self.muInMemoryList:clear();
    end
end
