--我的详细信息面板
--2016-9-20 16:33:35 library

local const_curNPCLvl = "起义等级Lv.";
local const_beatNPCWord = "打击起义";
local const_resetNPCWord = "招 安";
local const_myTeamWord = "考古阵容";
local const_noNPCToBeat = "没有起义可以镇压";
local const_noNPCToReset = "不需要招安";
local const_resetSuccess = "招安成功";
local const_resetCfmWord = "招安需要消耗血钻：{1}";
local const_noDiamond = "血钻不足";

ExploreMineDetailPanel = class();

--[[

]]
function ExploreMineDetailPanel:ctor ()
    self.gameObject = nil;
    self.transform = nil;
    
    self.mapLvlVal = 1;--地图等级

    self.team = {npcLeveL = 0};--ArcMapMainData.team

    -- self.QiyiAnmt = nil
end

--[[

]]
function ExploreMineDetailPanel:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.npcLvl = GetGameObject(self.transform.parent, "TopInfo/UpBG/Title");
    self.mapLvl = GetGameObject(self.transform.parent, "TopInfo/CommonUpBG/MapLvl");
    self.beatNPC = GetGameObject(self.transform, "beatNPC");
    self.beatNPCText = GetGameObject(self.beatNPC.transform, "text");
    self.resetNPC = GetGameObject(self.transform, "resetNPC");
    self.resetNPCText = GetGameObject(self.resetNPC.transform, "text");
    self.myTeam = GetGameObject(self.transform, "myTeam");
    self.myTeamText = GetGameObject(self.myTeam.transform, "text");
    self.qiyiTip = GetGameObject(self.transform.parent, "MyPropRow/QiyiTip");
    self.bujiInfoWord = GetPathComponent(self.transform.parent, "MyPropRow/BuJiInfo/BuJiInfoWord", "UILabel");

    GetComponent(self.beatNPCText, "UILabel").text = const_beatNPCWord;
    GetComponent(self.resetNPCText, "UILabel").text = const_resetNPCWord;
    GetComponent(self.myTeamText, "UILabel").text = const_myTeamWord;

    self:initListener();
    self:setNPCLvl();
end

--[[

]]
function ExploreMineDetailPanel:setNPCLvl ()
    local curLvl = 0;
    local btnShow = false;

    if (nil ~= self.team and nil ~= self.team.npcLeveL) then
        curLvl = self.team.npcLeveL;
    end

    GetComponent(self.npcLvl, "UILabel").text = const_curNPCLvl .. curLvl;
    GetPathComponent(self.mapLvl.transform, "Name", "UILabel").text = ExploreMapDataProxy.getMapNameByLvl(self.mapLvlVal);
    GetPathComponent(self.mapLvl.transform, "Lvl", "UILabel").text = "Lv." .. self.mapLvlVal;
    
    if (curLvl > 0 and self.team.npcStatus > 0) then
        btnShow = true;
        -- self:addQiyiAnmt()
        self.qiyiTip:SetActive(true)
        self.bujiInfoWord.gradientTop = CreateColor(255, 0, 0, 255)
        self.bujiInfoWord.gradientBottom = CreateColor(255, 0, 0, 255)
    end
    self.beatNPC:SetActive(btnShow);
    self.resetNPC:SetActive(btnShow);
end

--[[

]]
function ExploreMineDetailPanel:initListener ()
    ViewUtil.AddClickEvent(self.beatNPC, function () self:beatNPCClick(); end)
    ViewUtil.AddClickEvent(self.resetNPC, function () self:resetNPCClick(); end)
    ViewUtil.AddClickEvent(self.myTeam, function () self:myTeamClick(); end)
end

--[[

]]
function ExploreMineDetailPanel:initData (_data, _mapLvlVal)
    self.team = _data;
    self.mapLvlVal = _mapLvlVal or 1;
    
    self:setNPCLvl();
end

--[[

]]
function ExploreMineDetailPanel:beatNPCClick ()
    local map, buf = Map.new(), nil;
    
    if (0 >= self.team.npcLeveL) then
        ViewUtil.showMsg(const_noNPCToBeat);
        return ;
    end

    buf = Network.reqParamEncode(map);
    NetManager:SendData(self, buf, ServerID.ExploreChallenge, nil, function (sd) self:pkNPCHandle(sd); end, "", doNthFunc);

    -- if self.QiyiAnmt ~= nil then
        -- DestroyObject(self.QiyiAnmt)
        self.qiyiTip:SetActive(false)
        self.bujiInfoWord.gradientTop = CreateColor(255, 255, 255, 255)
        self.bujiInfoWord.gradientBottom = CreateColor(255, 255, 255, 255)
    -- end
end

--[[

]]
function ExploreMineDetailPanel:resetNPCClick ()
    local map, buf = Map.new(), nil;
    local myMny = PlayerData.getMyDiamond();
    local costMny = ExploreMapDataProxy.getNPCResetCost();

    if (0 >= self.team.npcLeveL or 0 == self.team.npcStatus) then
        ViewUtil.showMsg(const_noNPCToReset);
        return ;
    end

    if (myMny < costMny) then
        ViewUtil.showMsg(const_noDiamond);
        return ;
    end

    local function resetFunc () 
        buf = Network.reqParamEncode(map);
        NetManager:SendData(self, buf, ServerID.ExploreResetStandup, nil, function (sd) self:resetNPCHandle(sd); end, "", doNthFunc);
    end

    ViewUtil.comCfmPanel(string.gsub(const_resetCfmWord, "{1}", costMny), function () resetFunc();end, doNthFunc);
end

--[[

]]
function ExploreMineDetailPanel:pkNPCHandle (_sd)
    local def = GetProtoTable("DefaultData", _sd);

    if (0 == def.code) then
        self.team.npcLeveL = self.team.npcLeveL + 1;
        self.team.npcStatus = 0;
        self:setNPCLvl();
    end
end

--[[
    _session
]]
function ExploreMineDetailPanel:resetNPCHandle (_session)
    local def = GetProtoTable("DefaultData", _session);
    local ctl = ModuleManager.GetCtrl(ModuleName.EXPLORE);

    if (0 ~= def.code) then
        ViewUtil.showMsg(GetWord(def.code));
        return ;
    end
    ViewUtil.showMsg(const_resetSuccess);
    self.team.npcLeveL = 1;
    self.team.npcStatus = 0;

    self:setNPCLvl();

    -- if self.QiyiAnmt ~= nil then
        -- DestroyObject(self.QiyiAnmt)
        self.qiyiTip:SetActive(false)
        self.bujiInfoWord.gradientTop = CreateColor(255, 255, 255, 255)
        self.bujiInfoWord.gradientBottom = CreateColor(255, 255, 255, 255)
    -- end

    if (ctl and ctl.view and ctl.view.playersMgr and ctl.view.playersMgr.myHero) then
        ctl.view.playersMgr.myHero:removeQiYiAnmt();
    end
end

--[[

]]
function ExploreMineDetailPanel:myTeamClick ()
    ViewUtil.openView(ModuleName.FC, false, function () 
        ModuleManager.GetCtrl(ModuleName.FC).setPreModuleName(ModuleName.EXPLORE);
    end);
end

--增加打击起义动画，已经移至ExplorePlayerRow。 by iorinie
-- function ExploreMineDetailPanel:addQiyiAnmt ()
--     local sourceLayer, sourceOrder = nil, 0;

--     local exploreCtrl = ModuleManager.GetCtrl(ModuleName.EXPLORE)
--     local player = exploreCtrl.view.playersMgr.myHero.gameObject
--     local zhangPengParent = GetGameObject(player.transform, "BG")

--     self.QiyiAnmt = CreateObject(Util.LoadPrefab("Effects/Explore/Explore_QiYiAnmt"));
--     HangObject(self.QiyiAnmt, zhangPengParent);
--     self.QiyiAnmt.transform.localPosition = Vector3.New(0, 25, 0)
--     self.QiyiAnmt.transform.localScale = Vector3.New(1.5, 1.5, 1)

--     sourceLayer = GetPathComponent(zhangPengParent.transform, "Explore_HongZhangPengAnmt/Container/zhpeng/zhpeng", "SpriteRenderer").sortingLayerName;
--     sourceOrder = GetPathComponent(zhangPengParent.transform, "Explore_HongZhangPengAnmt/Container/zhpeng/zhpeng", "SpriteRenderer").sortingOrder;
--     ViewUtil.setAnmtSortingLayerOrder(self.QiyiAnmt, sourceLayer, sourceOrder);
-- end