--玩家类
--2016-7-28 15:07:18 library

local const_myPlayerAnmtName = "Effects/Explore/Explore_HongZhangPengAnmt";
local const_otherPlayerAnmtName = "Effects/Explore/Explore_LvZhangPengAnmt";
local const_playerSpriteName = "ZhangPeng";
local const_luoYangchanSName = "LuoYangChan";
local const_emptySquare = "alpha";

ExplorePlayerRow = class();

--[[

]]
function ExplorePlayerRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.heroInfoData = nil;--ArcTeamMapData
    self.bg = nil;
    self.muPane = nil;--MapUnitPanel;
    self.playerAnmtName = cosnt_otherPlayerAnmtName;--玩家帐篷动画的名称
    self.playerAnmt = nil;--帐篷动画

    self.luoYangchan = nil;--洛阳铲
    self.timeBar = nil;--倒计时

    self.isMoving = false;--移动中
    self.isDiging = false;--挖掘中
    self.isGeting = false;--正在领奖
end

--[[

]]
function ExplorePlayerRow:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.bg = GetGameObject(self.transform, "BG");
    GetComponent(self.bg, "UISprite").enabled = false;
    self:initPanel();

    self.isShow = true;
end

--[[

]]
function ExplorePlayerRow:initPanel ()

end

--[[

]]
function ExplorePlayerRow:setData (_data)
    self.heroInfoData = _data;
    
    if (self.heroInfoData.teamId == PlayerData.GetRoleTeamId()) then
        self.playerAnmtName = const_myPlayerAnmtName;
    else
        self.playerAnmtName = const_otherPlayerAnmtName;
    end
end

--[[
    绘制玩家，并放入对应的地图单元中
    _muPane MapUnitPanel 地图单元
    _vector2 Vector2 地图单元的起始坐标
]]
function ExplorePlayerRow:drawRow (_muPane, _vector2)
    local lPos = nil;
    local squSize = ExploreConstant.getMapSqu();

    self.muPane = _muPane;
    HangObject(self.gameObject, _muPane);
    lPos = self:playerPosWholeToLocal(_vector2);
    self.transform.localPosition = Vector3.New(lPos.x * squSize.x, lPos.y * squSize.y, 0);
    
    self:SetGOActive(true);
    self:showLuoYangchan();
    self:showTime();
--    ViewManager.SortOrder(self.gameObject);
end

--[[
    驻扎，即玩家离开地图，不在地图显示
]]
function ExplorePlayerRow:removeFromMap ()
    self.gameObject:SetActive(false);
    self.isShow = false;

    DestroyObject(self.gameObject);
end

--[[
    _vector2 地图单元的全局相对坐标
    return Vector2 玩家相对地图单元的坐标
]]
function ExplorePlayerRow:playerPosWholeToLocal (_vector2)
    local lPos = Vector2.New();
    local unitMapSize = ExploreConstant.getUnitSize();
    local mapReal = Vector2.New();

    mapReal.x = _vector2.x * unitMapSize.x;
    mapReal.y = _vector2.y * unitMapSize.y;
    
    lPos.x = self.heroInfoData.position.x - mapReal.x;
    lPos.y = self.heroInfoData.position.y - mapReal.y;
    
    return lPos;
end

--[[

]]
function ExplorePlayerRow:SetGOActive (_isShow)
    _isShow = (nil == _isShow) and true or _isShow;
    self.gameObject:SetActive(_isShow);
end

--[[
    仅显示移动效果
    _deltaX number X方向的单位移动距离
    _deltaY number Y方向的单位移动距离
    _tId number 需要移动的teamId
]]
function ExplorePlayerRow:moveEffec (_deltaX, _deltaY, _tId)
    local vec = ExploreConstant.getMapSqu();
    
    if (0 ~= _deltaX or 0 ~= _deltaY) then
        local ctl = ModuleManager.GetCtrl(ModuleName.EXPLORE);
        if (ctl) then
            ctl.view:setMapContainerSVEnabled(false);
        end
        iTween.MoveTo(self.gameObject, iTween.Hash(
            "x", self.transform.localPosition.x + _deltaX * vec.x,
            "y", self.transform.localPosition.y + _deltaY * vec.y,
            "islocal", true,
            "time", ExploreDefine.const_moveTime,
            "oncomplete", function () 
                local ctl = ModuleManager.GetCtrl(ModuleName.EXPLORE);
                if (ctl) then
                    ctl.view:setMapContainerSVEnabled(true);
                end
                Facade:sendNotification(MVCConst.EXPLORE_MOVEPLAYERS, {_tId}); 
            end
        ));
    end
end

--[[
    显示洛阳铲
]]
function ExplorePlayerRow:showLuoYangchan ()
    if (2 == self.heroInfoData.position.status and self.heroInfoData.position.second > 0) then
        local parentOrder, parentLayer = 0, nil;
        
        parentOrder = GetComponent(self.transform.parent, "UIPanel").sortingOrder;
        parentLayer = GetComponent(self.transform.parent, "UIPanel").sortingLayerName;
        
        if (nil == self.luoYangchan) then
            self.luoYangchan = ExplorePrefabMgr.getLuoYangchan();
            self.luoYangchan.name = "LuoYangChan_" .. Time.time;
            HangObject(self.luoYangchan, self.gameObject);
        end
        
        self.luoYangchan.transform.localPosition = Vector3.New(44, 48, 0);
        self.luoYangchan.transform.localScale = Vector3.New(0.8, 0.8, 1);
            
        ViewUtil.setAnmtSortingLayerOrder(self.luoYangchan, parentLayer, parentOrder);
    else
        if (nil ~= self.luoYangchan) then
            DestroyObject(self.luoYangchan);
        end
        self.luoYangchan = nil;
    end
    
    if (0 == self.heroInfoData.position.giftId or ExploreDefine.SqaureType.Diging == self.heroInfoData.position.status) then
        --TODO library 2016-9-9 18:13:33 帐篷是否破旧
--        GetPathComponent(self.luoYangchan.transform, "BG", "UISprite").spriteName = const_luoYangchanSName;
    else
--        GetPathComponent(self.luoYangchan.transform, "BG", "UISprite").spriteName = "";
    end
--    if (self.heroInfoData.position.lootCount < 6 and self.heroInfoData.position.lootCount > 0 and  self.heroInfoData.position.giftId > 0) then
--        --可以被掠夺的显示
--        GetPathComponent(self.gameObject.transform, "BG", "UISprite").spriteName = const_playerSpriteName;
--    else

--    end
end

--[[
    显示倒计时
]]
function ExplorePlayerRow:showTime ()
    local ctl = nil;
    local sourceOrder = 0;
    
    self:addPlayerAnmt();
    ctl = ModuleManager.GetCtrl(ModuleName.EXPLORE);
    if (nil == self.timeBar) then
        self.timeBar = ExplorePrefabMgr.getTimeBar();
        self.timeBar.name = "TimeBar";
        HangObject(self.timeBar, self.gameObject);
        self.timeBar.transform.localPosition = Vector3.New(40, 10, 0);
    end
    sourceOrder = GetComponent(self.transform.parent, "UIPanel").sortingOrder;
    GetComponent(self.timeBar.transform, "UIPanel").sortingOrder = sourceOrder;
    if (self.heroInfoData.position.second > 0) then
        --挖掘中，显示倒计时
        GetPathComponent(self.timeBar.transform, "msg", "UILabel").text = LogicUtil.getCountTimeStr(self.heroInfoData.position.second * 1000);
        --DOWN library 2016-9-9 11:24:15 将定时器注册到controler的update中
        ctl.synUpdatePlayerList({self.heroInfoData.teamId});
        self.timeBar:SetActive(true);
        self.isDiging = true;
        self.bg:SetActive(false);
        
    else
        self.timeBar:SetActive(false);
        self.bg:SetActive(true);
    end
    
    if (self.heroInfoData.position.second <= 0 and
        ExploreDefine.BaseGiftId < self.heroInfoData.position.giftId and 
        false == self.isGeting
    ) then
        --我的挖掘倒计时结束，自动领奖
        if (PlayerData.GetRoleTeamId() == self.heroInfoData.teamId) then
            --我自己，自动领奖
            if (ExploreDefine.SqaureType.Diging == self.heroInfoData.position.status) then
                local mapData, buf = Map.new(), nil;

                self.isDiging = false;
                buf = Network.reqParamEncode(mapData);
                NetManager:SendData(self, buf, ServerID.ExploreGetRwd, nil, function (sd) self:getRwdHandle(sd); end, "", doNthFunc);
                self.isGeting = true;
                local cortTmp = LuaCallManager:invokeCall(function () 
                    self.isGeting = false;
                end, 5);
                ctl.addToCortList(cortTmp);
            end
        else
            --其他玩家，不自动领奖，仅删除资源，并更新界面
            local mpData = {};--ArcMapPoinData
            local listTmp = List.new();
                
            mpData.x = self.heroInfoData.position.x;
            mpData.y = self.heroInfoData.position.y;
            listTmp:add({mpData.x, mpData.y});

            --删除特殊资源数据
            ExploreMapDataProxy.removeSpecialPointData(ctl.view.mapMainData.specialPoin, mpData);
            ctl.view:removeWholeMapRscData(listTmp);
            --当前玩家的数据
            self.heroInfoData.position.status = 1;
            self.heroInfoData.position.giftId = 0;
            self.heroInfoData.position.second = 0;
            --当前玩家显示
            self:showLuoYangchan();
            self:showTime();
            --对应方格的显示
            self:setMySquShow();
        end
    end
end

--[[

]]
function ExplorePlayerRow:getRwdHandle (_sd)
    local ctl = nil;
    local mpData = GetProtoTable("ArcMapPoinData", _sd);
    local remainTime = 0;

    if (-1 == mpData.status) then
        remainTime = mpData.second;
    end
    
    mpData.x = self.heroInfoData.position.x;
    mpData.y = self.heroInfoData.position.y;
    ctl = ModuleManager.GetCtrl(ModuleName.EXPLORE);
    
    if (remainTime > 0) then
        --倒计时未结束，同步时间
        self.heroInfoData.position.second = remainTime;
        --玩家信息显示
        self:showLuoYangchan();
        self:showTime();
        --倒计时
        ctl.synUpdatePlayerList({self.heroInfoData.teamId});
        self.isGeting = false;
    else
        local listTmp = List.new();
        
        listTmp:add({mpData.x, mpData.y});
        --删除特殊资源数据
        ExploreMapDataProxy.removeSpecialPointData(ctl.view.mapMainData.specialPoin, mpData);
        ctl.view:removeWholeMapRscData(listTmp);
        --当前玩家的数据
        self.heroInfoData.position.status = 1;
        self.heroInfoData.position.giftId = 0;
        self.heroInfoData.position.second = 0;
        self.isGeting = false;
        --当前玩家显示
        self:showLuoYangchan();
        self:showTime();
        --对应方格的显示
        self:setMySquShow();
    end
end

--[[
    领奖成功后，设置对应的方格的显示
]]
function ExplorePlayerRow:setMySquShow ()
    local squRow = nil;
    
    if (self.muPane and self.muPane.squareMgr) then
        squRow = self.muPane.squareMgr:getMySquareByPos(Vector2.New(self.heroInfoData.position.x, self.heroInfoData.position.y));
    end

    if (nil ~= squRow) then
        squRow:noteAfterGetRwd();
    end
end

--[[

]]
function ExplorePlayerRow:addPlayerAnmt ()
    local sourceLayer, sourceOrder = nil, 0;

    if (nil == self.playerAnmt or self.playerAnmt.name ~= self.playerAnmtName) then
        if (nil ~= self.playerAnmt) then
            DestroyObject(self.playerAnmt);
            self.playerAnmt = nil;
        end
        self.playerAnmt = CreateObject(Util.LoadPrefab(self.playerAnmtName, AssetBundleInfo.assetBundles));
        self.playerAnmt.name = self.playerAnmtName;
        HangObject(self.playerAnmt, self.bg);
    end
    
    sourceLayer = GetComponent(self.transform.parent, "UIPanel").sortingLayerName;
    sourceOrder = GetComponent(self.transform.parent, "UIPanel").sortingOrder + 1;
    ViewUtil.setAnmtSortingLayerOrder(self.playerAnmt, sourceLayer, sourceOrder);

    --增加起义动画 by iorinie
    local exploreCtrl = ModuleManager.GetCtrl(ModuleName.EXPLORE)
    local emdp = exploreCtrl.view.emdpObj --ExploreMineDetailPanel

    if (emdp.team.npcLeveL > 0 and emdp.team.npcStatus > 0) then
        self:addQiyiAnmt(sourceLayer, sourceOrder)
    end
end

--[[

]]
function ExplorePlayerRow:OnDestory ()

end

--起义动画 by iorinie
function ExplorePlayerRow:addQiyiAnmt (_sourceLayer, _sourceOrder)
    if (nil == self.QiyiAnmt) then
        self.QiyiAnmt = CreateObject(Util.LoadPrefab("Effects/Explore/Explore_QiYiAnmt", AssetBundleInfo.assetBundles));
        HangObject(self.QiyiAnmt, self.bg);
        self.QiyiAnmt.transform.localPosition = Vector3.New(0, 25, 0)
        self.QiyiAnmt.transform.localScale = Vector3.New(1.5, 1.5, 1)

        ViewUtil.setAnmtSortingLayerOrder(self.QiyiAnmt, _sourceLayer, _sourceOrder);
    end
end

--[[

]]
function ExplorePlayerRow:removeQiYiAnmt ()
    if (nil ~= self.QiyiAnmt) then
        DestroyObject(self.QiyiAnmt);
    end
end