--整张地图的所有玩家的管理器
--2016-7-25 11:28:39 library

ExplorePlayersMgr = class();

--[[

]]
function ExplorePlayersMgr:ctor ()
    self.gameObject = nil;
    self.transform = nil;
    
    self.muMgr = nil;
    self.ctl = nil;

    self.heroData = nil;
    self.playersList = List.new();--所有地图单元的玩家 List<ExplorePlayerRow>
    self.myHero = nil;--我自己 ExplorePlayerRow
end

--[[

]]
function ExplorePlayersMgr:Awake (_go, _muMgr, _ctl)
    self.gameObject = _go;
    self.muMgr = _muMgr;
    self.transform = self.gameObject.transform;
    self.ctl = _ctl;
end

--[[
    初始化所有玩家的数据
]]
function ExplorePlayersMgr:initData (_data)
    local heroTmp, playerRow = nil, nil;

    self.heroData = _data;
    self.playersList = List.new();
    
    for i = 1, #self.heroData do
        playerRow = ExplorePlayerRow.new();
        heroTmp = ExplorePrefabMgr.getHero();
        heroTmp.name = "Player_" .. self.heroData[i].teamId;
        heroTmp:SetActive(false);
        playerRow:Awake(heroTmp);
        
        playerRow:setData(self.heroData[i]);
        
        self.playersList:add(playerRow);
        
        HangObject(heroTmp, self.ctl.exploreView.mapContainer);

        if (self.heroData[i].teamId == PlayerData.GetRoleTeamId()) then
            self.myHero = playerRow;
        end
    end
    
    if (nil == self.myHero) then
        error("宝藏-地图-没有当前玩家的信息");
    end
end

--[[
    添加新的ExplorePlayerRow到self.playersList
    _tabList List 存放的是ArcTeamMapData
]]
function ExplorePlayersMgr:addPlayer (_tabList)
    local mData, tmpRow, heroTmp = nil, nil, nil;
    local isNew = true;

    for i = 1, #_tabList do
        mData = _tabList[i];
        isNew = true;

        for j = 1, #self.playersList do
            tmpRow = self.playersList[i];
            if (tmpRow.heroInfoData.teamId == mData.teamId) then
                isNew = false;
                break ;
            end
        end

        if (isNew) then
            tmpRow = ExplorePlayerRow.new();
            heroTmp = ExplorePrefabMgr.getHero();
            heroTmp.name = "Player_" .. mData.teamId;
            heroTmp:SetActive(false);
            tmpRow:Awake(heroTmp);
        
            tmpRow:setData(mData);
        
            self.playersList:add(tmpRow);
        
            HangObject(heroTmp, self.ctl.exploreView.mapContainer);
            --GetComponent(heroTmp, "BoxCollider2D").enabled = false;
            if (mData.teamId == PlayerData.GetRoleTeamId()) then
                self.myHero = playerRow;
            end
        end
    end
end

--[[
    绘制指定起点的地图单元的玩家
    _vector2 Vector2 地图单元的坐标原点
    _playerList table 存放地图单元的玩家的列表
    _tabList table 存放需要特殊处理的玩家数据List<ArcTeamMapData>，为空表示处理所有玩家
    _tp number 0,_tabList的类型是id 1,_tabList的类型是ArcTeamMapData
    _muPane MapUnitPanel 地图单元
]]
function ExplorePlayersMgr:drawUnitPlayers (_vector2, _playerList, _muPane, _tabList, _tp)
    local unitSize = ExploreConstant.getUnitSize();
    local realMinX, realMaxX, realMinY, realMaxY = 0, 0, 0, 0;
    local playerRow = nil;
    
    _tabList = _tabList or List.new();
    realMinX = _vector2.x * unitSize.x;
    realMaxX = _vector2.x * unitSize.x + unitSize.x - 1;
    realMinY = _vector2.y * unitSize.y;
    realMaxY = _vector2.y * unitSize.y + unitSize.y - 1;
    _tp = _tp or 0;
    
    for i = 1, self.playersList:getSize() do
        playerRow = self.playersList[i];
        
        local tmpData = nil;--ArcTeamMapData
        local squ = nil;
        if (1 == _tp) then
            for j = 1, #_tabList do
                if (_tabList[j].teamId == playerRow.heroInfoData.teamId) then
                    tmpData = _tabList[j]
                    break ;
                end
            end
        end
        
        if (tmpData) then
            playerRow.heroInfoData = tmpData;
        end
        
        if (
            (#_tabList <= 0 or self:isInList(playerRow.heroInfoData.teamId, _tabList, _tp)) and
            playerRow.heroInfoData.position.x >= realMinX and playerRow.heroInfoData.position.x <= realMaxX and
            playerRow.heroInfoData.position.y >= realMinY and playerRow.heroInfoData.position.y <= realMaxY 
        ) then
            --属于当前地图单元，绘制并存入地图单元
            if (tmpData and ExploreDefine.SqaureType.Diging ~= tmpData.position.status) then
                squ = _muPane.squareMgr:getMySquareByPos(Vector2.New(tmpData.position.x, tmpData.position.y));
                if (ExploreDefine.SqaureType.UnSearch == squ.status) then
                    squ:otherShowChange(playerRow, _muPane, _vector2);
                else
                    playerRow:drawRow(_muPane, _vector2);
                end
            else
                playerRow:drawRow(_muPane, _vector2);
            end
            _playerList:add(playerRow);
        end
    end
end

--[[
    修改考古中的玩家的显示
    _tabList List 存放的是teamId
]]
function ExplorePlayersMgr:drawDigingRow (_tabList)
    local playerRow = nil;

    for i = 1, self.playersList:getSize() do
        playerRow = self.playersList[i];
        
        if (#_tabList <= 0 or self:isInList(playerRow.heroInfoData.teamId, _tabList)) then
            playerRow:showLuoYangchan();
            playerRow:showTime();
        end
    end
end

--[[
    移除指定的玩家
    _tId number 
    return nil
]]
function ExplorePlayersMgr:removePlayer (_tId)
    local playerRow = nil;

    for i = 1, self.playersList:getSize() do
        playerRow = self.playersList[i];

        if (nil ~= playerRow and _tId == playerRow.heroInfoData.teamId) then
            self.playersList:removeAt(i);
            playerRow:removeFromMap();
            break ;
        end
    end
end

--[[
    判断玩家是否在指定的列表中
    _tid number 玩家的teamId
    _list 玩家列表
    _tp number 
    return boolean
]]
function ExplorePlayersMgr:isInList (_tid, _list, _tp)
    local isIn = false;

    _list = _list or List.new();
    _tp = _tp or 0;

    for i = 1, #_list do
        if ((0 == _tp and _tid == _list[i]) or (1 == _tp and _tid == _list[i].teamId)) then
            isIn = true;
            break ;
        end
    end

    return isIn;
end

--[[

]]
function ExplorePlayersMgr:resetMap ()
    self.myHero = nil;
    
    for i = 1, self.playersList.size do
        if (self.playersList[i] and self.playersList[i].gameObject) then
            DestroyObject(self.playersList[i].gameObject);
        end
    end
    self.playersList:clear();
end

--[[

]]
function ExplorePlayersMgr:OnDestroy ()

end
