--选择遗迹面板
--2016-9-19 11:33:05 library

--local const_all = "全 部";

ExploreSelectPropPanel = class();

--[[

]]
function ExploreSelectPropPanel:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.curSlt = -1;

    self.condList = List.new();
end

--[[

]]
function ExploreSelectPropPanel:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self:initPanel();
end

--[[

]]
function ExploreSelectPropPanel:initPanel ()
    self.btnExit = GetGameObject(self.transform, "BtnExit");
    self.scrollView = GetGameObject(self.transform, "ScrollView");
    self.iconCorrect = GetGameObject(self.transform, "ScrollView/condContainer/IconCorrect");
    self.condContainer = GetGameObject(self.transform, "ScrollView/condContainer");
    self.condBase = GetGameObject(self.transform, "ScrollView/condContainer/CondBase");

    self.grid = GetComponent(self.condContainer, "UIGrid");
    
    self.condList:add(self.condBase);
end

--[[
    显示所有可选择的道具
]]
function ExploreSelectPropPanel:showAllSltProps (_slt)
    local cond, propCfg = nil, nil;
    local luaBhvi, tab = nil, nil;
    local cnt, preCondListLen = 1, self.condList:getSize();
    local propList, tabStr = nil, nil;
    local ctl = ModuleManager.GetCtrl(ModuleName.EXPLORE);
    
    _slt = _slt or 0;
    self.curSlt = _slt;
    propList = ExploreMapDataProxy.getMapRsrcs(ctl.view.mapMainData.mapLevel);
    
    for i = 1, propList.size do
        propCfg = PropDataProxy.getPropCfgById(propList[i]);
        cnt = cnt + 1;
        if (cnt > preCondListLen) then
            cond = CreateObject(self.condBase);
            cond:SetActive(true);
            HangObject(cond, self.condContainer);
            self.condList:add(cond);
        else
            cond = self.condList[cnt];
            cond:SetActive(true);
        end

        cond.name = "cond_" .. propList[i];
        GetPathComponent(cond.transform, "Sprite/Label", "UILabel").text = PropDataProxy.getPropName(propCfg);

        tab = nil;
        luaBhvi = GetComponent(cond, "LuaBehaviour");
        
        if (nil ~= luaBhvi) then
            tab = luaBhvi.sourceLuaObj;
        end
        if (nil == tab) then
            PanelManager:BindPanelScript({propList[i]}, cond, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        else
            tab[1] = propList[i];
        end

        if (
            (0 == self.curSlt and propList[i] == ExploreDefine.explorePropMinId) or 
            propList[i] == self.curSlt
        ) then
            self.curSlt = propList[i];
            HangObject(self.iconCorrect, cond);
        end
    end

    for i = cnt + 1, preCondListLen do
        cond = self.condList[i];
        cond:SetActive(false);
    end

    ResetScrollView(self.scrollView);
    ResetGrid(self.condContainer);

    self:addListener();
end

--[[

]]
function ExploreSelectPropPanel:addListener ()
    local condTmp, luaBhvi, tab = nil, nil, nil;

    for i = 1, self.condList:getSize() do
        condTmp = self.condList[i];
        ViewUtil.AddClickEvent(condTmp, function (obj) 
            HangObject(self.iconCorrect, obj);
            
            luaBhvi = GetComponent(obj, "LuaBehaviour");
            if (nil ~= luaBhvi) then
                tab = luaBhvi.sourceLuaObj;
                if (nil ~= tab) then
                    Facade:sendNotification(MVCConst.EXPLORE_SLTPROPCHANGE, tab);
                end
            end
            self:hidePanel(false);
            if (PlayerData.guideNotEnd()) then
			    Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
		    end
        end)
    end

    ViewUtil.AddClickEvent(self.btnExit, function () self:hidePanel(false); end)
end

--[[
    _isHide boolean
]]
function ExploreSelectPropPanel:hidePanel (_isHide)
    self.gameObject:SetActive(_isHide);
    HangObject(self.iconCorrect, self.condContainer);
end