--选择地图面板
--2016-11-1 20:12:49 library

local const_mapWord = "{1}级地图";

ExploreSltMapPane = class();

--[[

]]
function ExploreSltMapPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.maxMapLvl = 0;
    self.barList = List.new();
end

--[[

]]
function ExploreSltMapPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.closeBtn = GetGameObject(self.transform, "closeBtn");
    self.sv = GetGameObject(self.transform, "ScrollView");
    self.grid = GetGameObject(self.sv.transform, "Panel/Grid");
    self.baseBar = GetGameObject(self.grid.transform, "BaseBar");

    self:initPanel();
    self:initListener();
end

--[[

]]
function ExploreSltMapPane:initPanel ()
    
end

--[[

]]
function ExploreSltMapPane:initListener ()
    ViewUtil.AddClickEvent(self.closeBtn, function () self.gameObject:SetActive(false); end)
end

--[[

]]
function ExploreSltMapPane:setData (_maxMapLvl, _curLvl)
    self.maxMapLvl = _maxMapLvl - 6; --暂时屏蔽4级以上地图 by iorinie
    self.curLvl = _curLvl;

    self:showMapBar();
end

--[[

]]
function ExploreSltMapPane:showMapBar ()
    local tmpBar, sltBtn = nil, nil;

    for i = 1, #self.barList do
        tmpBar = self.barList[i];
        HangObject(tmpBar, self.gameObject);
        tmpBar:SetActive(false);
        DestroyObject(tmpBar);
    end
    self.barList:clear();
    for i = 1, self.maxMapLvl do
        tmpBar = CreateObject(self.baseBar);
        tmpBar:SetActive(true);
        tmpBar.name = i;
        HangObject(tmpBar, self.grid);
        sltBtn = GetGameObject(tmpBar.gameObject.transform, "sltBtn");
        GetPathComponent(tmpBar.transform, "Label", "UILabel").text = string.gsub(const_mapWord, "{1}", i);
        if (self.curLvl == i) then
            GetComponent(sltBtn, "UISprite").enabled = true; 
        else
            GetComponent(sltBtn, "UISprite").enabled = false; 
        end
        
        if (i ~= ExploreControler.view.mapMainData.mapLevel) then
            ViewUtil.AddClickEvent(tmpBar, function(_go) self:sltMap(_go); end)
        end
        self.barList:add(tmpBar);
    end
    ResetScrollView(self.sv);
    ResetGrid(self.grid);
end

--[[

]]
function ExploreSltMapPane:sltMap (_go)
    local curGo = _go;
    local mapLv = tonumber(curGo.name);
    local mapData, buf = Map.new(), nil;

    mapData:put("mapLvl", mapLv);
    buf = Network.reqParamEncode(mapData);
    NetManager:SendData(self, buf, ServerID.ExploreSltMap, nil, function (sd) self:dealMapData(sd); end, nil, doNthFunc);
    self.gameObject:SetActive(false);
end

--[[

]]
function ExploreSltMapPane:dealMapData (sd)
--    local mo = GetProtoTable("ArcMapMainData", sd);

--    Facade:sendNotification(MVCConst.INITDATA_EXPLORE, {[1] = mo, [2] = ExploreDefine.ExploreEtyType.ExploreResetMapPanel});
    --删除本模块，重新进入模块
    ViewManager.CloseModule(ModuleName.EXPLORE, false);
    ViewUtil.goto(ModuleName.EXPLORE, false);
end