--遮挡方块
--2016-7-25 18:03:51 library
--移动与挖掘接口合并 2016-11-30 16:34:17 library

local const_boundSquBG = "boundSquBG";
local const_mapSquBG = "mapBG";
local const_squBGBaseName = "squBG_";
local const_squBGName = "squBG_1";
local const_squareSpriteName = "DanYuanGe";
local const_luoYangchanSName = "LuoYangChan";
local const_PropItem = "PropItem";
local const_emptySquare = "alpha";
local const_guideSquName = "guideSqu";

local const_wangYuanJingAnmt = "Effects/Explore/Explore_LuoYangChanAnmt";

local const_pointToFar = "非相邻点不能探索";
local const_noRob = "不能掠夺该玩家的资源";
local const_diging = "正在挖掘中";
local const_moving = "移动等待中";
local const_digingFail = "条件不满足，挖掘失败";
local const_movingFail = "条件不满足，移动失败";
local const_moveError = "本次操作需要消耗补给：{1}，补给不足！";
local const_moveCfm = "本次操作需要消耗补给：{1}";
local const_digCfm = "本次操作需要消耗时间：{1}";

ExploreSquRow = class();

--[[

]]
function ExploreSquRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.bg = nil;
    self.status = 0;--方格被探索状态
    self.rscId = 0;--资源ID
    self.posVec = nil;--整张地图中的位置
    self.localPosVec = nil;--地图单元中的相对位置
    self.showStatus = 0;--方格的迷雾状态 0，迷雾；1，显示
    self.lightCorut = nil;--方格变亮的Coroutine
    self.wangYuanJingAnmt = nil;--望远镜动画

    self.propSqu = nil;--可见格子中显示的道具

    self.mgr = nil;--ExploreSquareMgr
end

--[[

]]
function ExploreSquRow:Awake (_go, _mgr)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.mgr = _mgr;
end

--[[

]]
function ExploreSquRow:Start ()
    self:initPanel();
end

--[[

]]
function ExploreSquRow:initPanel ()
    self.bg = GetGameObject(self.transform, "BG");

    ViewUtil.AddClickEvent(self.gameObject, function () self:clickSqu(); end)
end

--[[
    _id number 资源ID
    _vector2 Vector2 整张地图的相对位置
    _lVec2 Vector2 地图单元中的相对位置
]]
function ExploreSquRow:setData (_status, _id, _vector2, _lVec2)
    self.status = _status;
    self.rscId = _id;
    self.posVec = _vector2;
    self.localPosVec = _lVec2;

    if (self.status > ExploreDefine.SqaureType.UnSearch) then
        self.showStatus = 1;
    else
        self.showStatus = ExploreMapDataProxy.getPointStatus(self.mgr.ctl.view.showSqurInfoList, self.posVec.x, self.posVec.y);
    end
end

--[[

]]
function ExploreSquRow:drawSquare ()
    local mapSqu = ExploreConstant.getMapSqu();
    
    self:cleanLightCort();
    --似乎没有必要，MapUnit对象中的方格位置不会被移动
    --2017-3-3 12:12:25 library
    --[[if (self.gameObject and self.gameObject.transform) then
        self.gameObject.transform.localPosition = Vector3.New(self.localPosVec.x * mapSqu.x, self.localPosVec.y * mapSqu.y, 0);
    end]]

    GetComponent(self.bg, "UISprite").spriteName = const_emptySquare;
    self:SetRowActive(true);
    if (ExploreDefine.SqaureType.UnSearch == self.status) then
        if (0 == self.showStatus) then
            --显示黑框
            GetComponent(self.bg, "UISprite").spriteName = const_squareSpriteName;
            self:clearPropSqu();
        elseif (self.rscId > ExploreDefine.BaseGiftId) then
            --可见、有道具，显示道具背景及道具
            self:showPropSqu();
            local cost = ExploreMapDataProxy.getRescSupply(self.mgr.ctl.view.mapMainData.mapId, self.posVec, 0);
            if (cost < 1) then 
                cost = 1;
            elseif (cost > ExploreMapDataProxy.maxSupply) then
                cost = ExploreMapDataProxy.maxSupply;
            end
            local sName = const_squBGBaseName .. cost;
            GetComponent(self.bg, "UISprite").spriteName = sName;
        else
            --可见，没有道具，显示砖
            local cost = ExploreMapDataProxy.getRescSupply(self.mgr.ctl.view.mapMainData.mapId, self.posVec, 0);
            if (cost < 1) then 
                cost = 1;
            elseif (cost > ExploreMapDataProxy.maxSupply) then
                cost = ExploreMapDataProxy.maxSupply;
            end
            local sName = const_squBGBaseName .. cost;
            GetComponent(self.bg, "UISprite").spriteName = sName;
            self:clearPropSqu();
        end
    elseif (self.rscId > ExploreDefine.BaseGiftId and self:checkPlayerRunTime() > 0) then
        --已探索、有道具，显示道具
        self:showPropSqu();
        GetComponent(self.bg, "UISprite").spriteName = const_mapSquBG;
    else
        --已探索、没有道具，显示地图背景图
        GetComponent(self.bg, "UISprite").spriteName = const_mapSquBG;
        self:clearPropSqu();
    end

    local mapTmp = ExploreConstant.getMapCntSize();
    if (self.posVec.x >= mapTmp.x or self.posVec.y >= mapTmp.y) then
        --地图边界
        GetComponent(self.bg, "UISprite").spriteName = const_boundSquBG;
    end
end

--[[

]]
function ExploreSquRow:checkPlayerRunTime ()
    local playerTime, len= 1, 0;
    local epRow = nil;--ExplorePlayerRow;

    len = self.mgr.ctl.view.playersMgr.playersList.size;
    for i = 1, len do
        epRow = self.mgr.ctl.view.playersMgr.playersList[i];
        if (epRow.heroInfoData.position.x == self.posVec.x and epRow.heroInfoData.position.y == self.posVec.y) then
            playerTime = epRow.heroInfoData.position.second;
            break;
        end
    end

    return playerTime;
end

--[[

]]
function ExploreSquRow:showPropSqu ()
    local sprite;

    if (nil == self.propSqu) then
        self.propSqu = CreateObject(GetGameObject(self.transform, "BG"));
        self.propSqu.name = "RowProp";
        HangObject(self.propSqu, self.transform);
        self.propSqu.transform.localPosition = GetGameObject(self.transform, "BG").transform.localPosition;
        self.propSqu.transform.localScale = Vector3.New(0.7, 0.7, 1)
    end

    sprite = GetComponent(self.propSqu, "UISprite");
    sprite.depth = sprite.depth + 1;
    sprite.spriteName = "" .. self.rscId;
end

--[[
    将方块设置为可见
]]
function ExploreSquRow:setShow ()
    self.showStatus = 1;
    
    self:drawSquare();
end

--[[
    探索或考古
    return nil
]]
function ExploreSquRow:clickSqu ()
    local bufData, mapData = nil, Map.new();
    local sId = 0;
    local myHeroRow, myHeroData, playersList, otherData = nil, nil, nil, nil;
    local isOtherPos = false;
    local moveDirec = 0;
    local deltaX, deltaY = 0, 0;
    
    playersList = self.mgr.ctl.view.playersMgr.heroData;
    myHeroRow = self.mgr.ctl.view.playersMgr.myHero;

    if (nil == myHeroRow) then
        return ;
    end

    myHeroData = self.mgr.ctl.view.playersMgr.myHero.heroInfoData;

    if (nil == myHeroData) then
        return ;
    end
    
    if (myHeroRow.isDiging) then
        ViewUtil.showMsg(const_diging);
        return ;
    end
    if (myHeroRow.isMoving) then
        return ;
    end
    
    --其他玩家的帐篷点
    for i = 1, #playersList do
        otherData = playersList[i];
        if (otherData.teamId ~= PlayerData.GetRoleTeamId()) then
            if (otherData.position.x == self.posVec.x and otherData.position.y == self.posVec.y) then
                if (self:isCanRob(otherData)) then
                    mapData:put("fightTeamId", otherData.teamId);
                    bufData = Network.reqParamEncode(mapData);
                    --TODO library 2016-9-8 18:01:32 抢夺玩家资源 如何同步数据
                    sId = ServerID.ExploreRobResource;
                    NetManager:SendData(self, bufData, sId, nil, doNthFunc, "", doNthFunc);
                else
                    ViewUtil.showMsg(const_noRob);
                end
                isOtherPos = true;
                break ;
            end
        end
    end

    if (isOtherPos) then
        return ;
    end
        
    --我的帐篷在当前位置
    if (myHeroData.position.x == self.posVec.x and myHeroData.position.y == self.posVec.y) then
        return ;
    end

    local mapTmp = ExploreConstant.getMapCntSize();
    
    if (
        not (
            math.abs(myHeroData.position.x - self.posVec.x) == 1 and math.abs(myHeroData.position.y - self.posVec.y) == 0 or 
            math.abs(myHeroData.position.x - self.posVec.x) == 0 and math.abs(myHeroData.position.y - self.posVec.y) == 1
        ) or
        self.posVec.x >= mapTmp.x or 
        self.posVec.y >= mapTmp.y
    ) then
        --非相邻点不能移动 2016-10-24 19:57:56 library
        --我的位置周围四个位置显示闪亮动画
        self:showAroundSqureLight(myHeroData);
        return ;
    end

    if (myHeroData.position.x == self.posVec.x) then
        if (myHeroData.position.y > self.posVec.y) then
            --下移
            moveDirec = 1;
            deltaX = 0;
            deltaY = -1;
        else
            --上移
            moveDirec = 2;
            deltaX = 0;
            deltaY = 1;
        end
    else
        if (myHeroData.position.x > self.posVec.x) then
            --左移
            moveDirec = 3;
            deltaX = -1;
            deltaY = 0;
        else
            --右移
            moveDirec = 4;
            deltaX = 1;
            deltaY = 0;
        end
    end
    --相邻点，移动
    local function moveFunc () 
        local cost = ExploreMapDataProxy.getRescSupply(self.mgr.ctl.view.mapMainData.mapId, self.posVec, self.mgr.ctl.view.mapMainData.team.npcStatus);
        
        if (ExploreDefine.SqaureType.UnSearch ~= self.status) then
            cost = 0;
        end

        mapData:add("moveDirec", moveDirec);
        bufData = Network.reqParamEncode(mapData);
        myHeroRow.isMoving = true;
        sId = ServerID.ExplorePlayersMove;
        NetManager:SendData(self, bufData, sId, nil, function (sd) self:moveHandle(sd); end, "", doNthFunc);
        self.mgr.ctl.view.mapMainData.team.supply = self.mgr.ctl.view.mapMainData.team.supply - cost;
        self.mgr.ctl.view:drawMyPropRow();
    end
    local digTime = ExploreMapDataProxy.getRescTime(self.mgr.ctl.view.mapMainData, self.posVec);
    local supplyCost = ExploreMapDataProxy.getRescSupply(self.mgr.ctl.view.mapMainData.mapId, self.posVec, self.mgr.ctl.view.mapMainData.team.npcStatus);
    
    if (ExploreDefine.SqaureType.UnSearch ~= self.status) then
        supplyCost = 0;
        digTime = 0;
    end
    
    if (supplyCost > self.mgr.ctl.view.mapMainData.team.supply) then
        ViewUtil.showMsg(string.gsub(const_moveError, "{1}", supplyCost));
        return ;
    elseif (ExploreDefine.digCfmTime <= digTime) then
        ViewUtil.comCfmPanel(string.gsub(const_digCfm, "{1}", LogicUtil.getCountTimeStr(digTime * 1000)), moveFunc);
    else
        moveFunc();
    end
end

--[[
    接收到领奖成功通知后的处理
]]
function ExploreSquRow:noteAfterGetRwd ()
    local tmpGift = self.rscId;
    local pItem, psi = nil, nil;

    --修改数据，显示界面及动画
    --当前对象的数据
    self.status = 1;
    self.rscId = 0;
    --界面显示
    GetComponent(self.bg, "UISprite").spriteName = const_mapSquBG;
    self:drawSquare();
    --物品掉落动画
    pItem = ExplorePrefabMgr.getExploreRsrcs();
    HangObject(pItem, self.gameObject);
    psi = PropShowItem.new();
    psi:Awake(pItem, tmpGift, 1);
    psi:Start();
    ViewUtil.sortLayerOrder(pItem, LayerName.UI);
    ViewUtil.showItem(pItem);
end

--[[
    
]]
function ExploreSquRow:moveHandle (sd)
    local defData = nil;--ArcMapPoinData
    local myHeroRow = nil;--ExplorePlayerRow
    local mData = nil;--ArcTeamMapData
    local ctl = nil;
    
    defData = GetProtoTable("ArcMapPoinData", sd);
    ctl = self.mgr.ctl;
    myHeroRow = ctl.view.playersMgr.myHero;
    
    if (0 > defData.status) then
        ViewUtil.showMsg(const_movingFail);
        if (nil ~= myHeroRow) then
            myHeroRow.isMoving = false;
        end
        return ;
    end
    
    defData.status = ExploreDefine.SqaureType.Searched;
    defData.second = ExploreMapDataProxy.getPointTime(ctl.view.mapMainData.specialPoin, self.posVec);
    
    --同步数据，移动图标，修改图标的显示
    if (nil ~= myHeroRow) then
        myHeroRow.heroInfoData.position = defData;
        mData = {position = defData, teamId = PlayerData.GetRoleTeamId()};
        ctl.view:setSquDataAfterMove(mData);
        if (ExploreDefine.SqaureType.UnSearch == self.status) then
            self.status = ExploreDefine.SqaureType.Searched;
            self:showWangYuanJingAnmt();
            ctl.view:setMapContainerSVEnabled(false);
            local cortTmp = LuaCallManager:invokeCall(function () 
                Facade:sendNotification(MVCConst.EXPLORE_MOVEPLAYERS, {PlayerData.GetRoleTeamId()});
                self:drawSquare();
                self:cleanWangYuanJingAnmt();
                myHeroRow.isMoving = false;
                ctl.view:setMapContainerSVEnabled(true);
                if (self.rscId > ExploreDefine.BaseGiftId) then
                    self:realDigHandle(defData);
                end
            end, ExploreDefine.const_moveTime - 0.2);
            ctl.addToCortList(cortTmp);
        else
            self.status = ExploreDefine.SqaureType.Searched;
            Facade:sendNotification(MVCConst.EXPLORE_MOVEPLAYERS, {PlayerData.GetRoleTeamId()}); 
            self:drawSquare();
            myHeroRow.isMoving = false;
            if (self.rscId > ExploreDefine.BaseGiftId) then
                --不会执行，因为移动资源后，会自动挖掘
                self:digResource();
            end
        end
    end
end

--[[

]]
function ExploreSquRow:digResource ()
    --考古
    local function digCfm () 
        local sId, mapData, bufData = nil, Map.new(), nil;
        local myHeroRow = nil;--ExplorePlayerRow
    
        myHeroRow = self.mgr.ctl.view.playersMgr.myHero;
        sId = ServerID.ExploreDigProps;
        bufData = Network.reqParamEncode(mapData);
        myHeroRow.isDiging = true;
        
        NetManager:SendData(self, bufData, sId, nil, function (sd) self:digHandle(sd); end, "", doNthFunc);
    end

    digCfm();
end

--[[

]]
function ExploreSquRow:showWangYuanJingAnmt ()
    local luoyangchanTmp, dirt = nil, nil;
    local lycSR, dirtSR = nil, nil;
    local parentOrder, parentLayer = 0, LayerName.UI;

    self.wangYuanJingAnmt = CreateObject(Util.LoadPrefab(const_wangYuanJingAnmt, AssetBundleInfo.assetBundles));
    HangObject(self.wangYuanJingAnmt, self.gameObject);
    self.wangYuanJingAnmt.transform.localPosition = Vector3.New(46, 40, 0);
    parentLayer = GetComponent(self.mgr.muPanel.transform, "UIPanel").sortingLayerName;
    parentOrder = GetComponent(self.mgr.muPanel.transform, "UIPanel").sortingOrder;
    ViewUtil.setAnmtSortingLayerOrder(self.wangYuanJingAnmt, parentLayer, parentOrder + 1);
end

--[[

]]
function ExploreSquRow:cleanWangYuanJingAnmt ()
    if (self.wangYuanJingAnmt) then
        DestroyObject(self.wangYuanJingAnmt);
        self.wangYuanJingAnmt = nil;
    end
end

--[[
    移动后，清除砖
]]
function ExploreSquRow:clearPropSqu ()
    if (self.propSqu) then
        DestroyObject(self.propSqu);
        self.propSqu = nil;
    end
end

--[[

]]
function ExploreSquRow:realDigHandle (_ampData)
    local mpData = _ampData;
    local tmData = {teamId = PlayerData.GetRoleTeamId(), position = mpData};
    
    tmData.position.status = ExploreDefine.SqaureType.Diging;
    self.mgr.ctl.view.playersMgr.myHero.isDiging = false;
    
    if (-1 == mpData.status) then
        ViewUtil.showMsg(const_digingFail);
        return ;
    end
    self.status = ExploreDefine.SqaureType.Diging;
    
    --添加洛阳铲
    if (nil ~= self.mgr.ctl.view.playersMgr.myHero) then
        --同步数据，直接赋值
        self.mgr.ctl.view:setSquDataDiging(tmData);
        self.mgr.ctl.view.playersMgr.myHero:showLuoYangchan();
        self.mgr.ctl.view.playersMgr.myHero:showTime();
    end
end

--[[
    考古
    sd session 
]]
function ExploreSquRow:digHandle (sd)
    local mpData = GetProtoTable("ArcMapPoinData", sd);
    local tmData = {teamId = PlayerData.GetRoleTeamId(), position = mpData};
    
    self.mgr.ctl.view.playersMgr.myHero.isDiging = false;
    
    if (-1 == mpData.status) then
        ViewUtil.showMsg(const_digingFail);
        return ;
    end
    self.status = ExploreDefine.SqaureType.Diging;
    
    --添加洛阳铲
    if (nil ~= self.mgr.ctl.view.playersMgr.myHero) then
        --同步数据，直接赋值
        self.mgr.ctl.view:setSquDataDiging(tmData);
        self.mgr.ctl.view.playersMgr.myHero:showLuoYangchan();
        self.mgr.ctl.view.playersMgr.myHero:showTime();
    end
end

--[[
    设置可见
]]
function ExploreSquRow:SetRowActive (_isShow)
    self.bg:SetActive(_isShow);
end

--[[
    判断是否可以掠夺玩家的资源
    _otherData ArcMapPoinData 被掠夺的玩家数据
    return boolean true，可掠夺；false，不可掠夺
]]
function ExploreSquRow:isCanRob (_otherData)
    local canRob = false;
    
    if (_otherData.position.lootCount < 6 and _otherData.position.lootCount > 0) then
        canRob = true;
    end

    return canRob;
end

--[[
    _myHeroData ArcTeamMapData
]]
function ExploreSquRow:showAroundSqureLight (_myHeroData)
    self.mgr.ctl.view.mapUnitMgr:showAroundSqureLight(_myHeroData);
end

--[[
    添加方块的变亮效果，持续2秒
]]
function ExploreSquRow:showSqureLight ()
    local epr, playerData = nil, nil;--ExplorePlayerRow, ArcTeamMapData
    local isShow = true;
    local ctl = ModuleManager.GetCtrl(ModuleName.EXPLORE);

    for i = 1, self.mgr.ctl.view.playersMgr.playersList.size do
        epr = self.mgr.ctl.view.playersMgr.playersList[i];
        playerData = epr.heroInfoData;
        if (playerData.position.x == self.posVec.x and playerData.position.y == self.posVec.y) then
            isShow = false;
            break ;
        end
    end

    if (not isShow) then
        return ;
    end

    GetComponent(self.bg, "UISprite").spriteName = const_guideSquName;
    self:cleanLightCort();
    self.lightCorut = LuaCallManager:invokeCall(function ()
        self:drawSquare();
    end, 2);
    ctl.addToCortList(self.lightCorut);
end

--[[
    清空方块变亮的coroutine
]]
function ExploreSquRow:cleanLightCort ()
    if (self.lightCorut) then
        LuaCallManager:cancelInvokeCall(self.lightCorut);
    end
    self.lightCorut = nil;
end

--[[

]]
function ExploreSquRow:otherShowChange (_playerRow, _muPane, _vector2)
    local ctl = ModuleManager.GetCtrl(ModuleName.EXPLORE);
    self.status = ExploreDefine.SqaureType.Searched;
    self:showWangYuanJingAnmt();
    local cortTmp = LuaCallManager:invokeCall(function () 
        self:cleanWangYuanJingAnmt();
        self:drawSquare();
        _playerRow:drawRow(_muPane, _vector2);
    end, ExploreDefine.const_moveTime - 0.2);
    ctl.addToCortList(cortTmp);
end

--[[

]]
function ExploreSquRow:setRsrcId (_giftId)
    self.rscId = _giftId;

    self:drawSquare();
end

--[[

]]
function ExploreSquRow:OnDestroy ()
    self.transform = nil;
    self.gameObject = nil;
    self.mgr = nil;
end
