--地图单元的遮挡单元格、资源管理
--2016-7-25 11:29:25 library

local const_ExploreSquareName = "ExploreSquare";

ExploreSquareMgr = class();

--[[

]]
function ExploreSquareMgr:ctor ()
    self.gameObject = nil;
    self.transform = nil;
    
    self.muPanel = nil;
    self.baseVec = nil;--地图单元的相对坐标
    self.ctl = nil;

    self.squList = List.new();--存储ExploreSquRow
    self.infoList = List.new();--是否已探索信息及资源信息：{ExploreDefine.SqaureType, 资源ID}
end

--[[

]]
function ExploreSquareMgr:Awake (_mapUnitPanel, _ctl)
    self.muPanel = _mapUnitPanel;
    self.gameObject = self.muPanel.gameObject;
    self.transform = self.gameObject.transform;
    self.ctl = _ctl;
end

--[[

]]
function ExploreSquareMgr:initData (_vector2)
    self.baseVec = _vector2;
end

--[[
    将是否探索、资源信息存入infoList
    return nil
]]
function ExploreSquareMgr:dealInfoList ()
    local unitSize = ExploreConstant.getUnitSize();
    local xSize, ySize = unitSize.x, unitSize.y;
    local xMapUnit, yMapUnit, xMap, yMap = 0, 0, 0, 0;
    local isNew, status = false, ExploreDefine.SqaureType.UnSearch;
    local posRscInfo, giftId = nil, 0;
    
    if (self.infoList:getSize() <= 0) then
        isNew = true;
    end
    
    --infoList sequence: screen left to screen right, screen bottom to screen top
    for j = 0, ySize - 1 do
        for i = 0, xSize - 1 do
            xMapUnit = i;--地图单元中的相对坐标
            yMapUnit = j;
            xMap = xMapUnit + self.baseVec.x * xSize;--整张地图中的真实坐标
            yMap = yMapUnit + self.baseVec.y * ySize;
            status = ExploreMapDataProxy.getPointStatus(self.ctl.getViewActivationData(), xMap, yMap);
            giftId = 0;

            --资源信息
            posRscInfo = ExploreMapDataProxy.getPointRsc(self.ctl.getWholeMapRscData(), xMap, yMap);
            
            if (nil ~= posRscInfo and nil ~= posRscInfo.giftId) then
                giftId = posRscInfo.giftId;
            end
            
            --是否探索信息
            if (isNew) then
                self.infoList:add({status, giftId});
            else
                self.infoList[j * ySize + i + 1] = {};
                self.infoList[j * ySize + i + 1][1] = status;
                self.infoList[j * ySize + i + 1][2] = giftId;
            end
        end
    end
end

--[[

]]
function ExploreSquareMgr:drawPanel ()
    local unitSize = ExploreConstant.getUnitSize();
    local infoIdx, squIdx, showCnt = 0, 1, 0;
    local squ, squRow, luaBhvi = nil, nil, nil;
    local squListLen, infoListLen = self.squList:getSize(), self.infoList:getSize();
    local showX, showY, realX, realY = 0, 0, 0, 0;
    local childNameStr = const_ExploreSquareName;
    
    for i = 1, infoListLen do
        showX = (i - 1) % unitSize.x;
        showY = GetIntPart((i - 1) / unitSize.x);
        realX = showX + unitSize.x * self.baseVec.x;
        realY = showY + unitSize.y * self.baseVec.y;

        showCnt = showCnt + 1;
        if (showCnt > squListLen) then
            squ = self.transform:Find(childNameStr .. (1 == i and "" or ("_" .. (i - 1)))).gameObject;
            squRow = ExploreSquRow.new();
            squRow:Awake(squ, self);
            squRow:Start();

            self.squList:add(squRow);
        else
            squRow = self.squList[showCnt];
        end
        squRow:setData(self.infoList[i][1], self.infoList[i][2], Vector2.New(realX, realY), Vector2.New(showX, showY));
        squRow:drawSquare();
    end
end

--[[
    根据坐标取我的资源
]]
function ExploreSquareMgr:getMySquareByPos (_vec2)
    local squRow = nil;

    for i = 1, self.squList:getSize() do
        squRow = self.squList[i];
        if (squRow.posVec.x == _vec2.x and squRow.posVec.y == _vec2.y) then
            break ;
        end
        squRow = nil;
    end

    return squRow;
end

--[[

]]
function ExploreSquareMgr:resetMap ()

end

--[[

]]
function ExploreSquareMgr:OnDestroy ()
    local esRow = nil;

    for i = 1, self.squList:getSize() do
        esRow = self.squList[i];
        esRow:OnDestroy();
    end
    esRow = nil;

    self.ctl = nil;
    self.muPanel = nil;
    self.infoList = nil;
end
