--探险
--2016-7-22 14:19:01 library

local const_noteNum = 5;
local const_nextMapWord = "传送门";
local const_choseToGet = "可选择以下其中一种领取";
local const_newProps = "地图上出现了新资源，快去看看吧";

ExploreView = class();

--[[

]]
function ExploreView:ctor ()
    self.gameObject = nil;
    self.transform = nil;
    
    self.tp = 0;--当前显示的界面：0，入口；1，地图

    self.arcTeamData = nil;--ArcTeamData 显示领奖面板
    self.mapMainData = nil;--ArcMapMainData 显示地图
    self.showSqurInfoList = List.new();--List<int32>()，可见的方格信息
    self.wholeMapRscData = Map.new();--地图的资源数据

    --管理器：玩家、地图
    self.playersMgr = ExplorePlayersMgr.new();
    self.mapUnitMgr = ExploreMapUnitMgr.new();

    self.myPropRow = nil;
    --self.rwdPanel = nil;
    self.mapContainer = nil;
    self.uiExtWrapContentGO = nil;
    self.uiExtWrapContent = nil;

    self.ctl = nil;
end

--[[

]]
function ExploreView:Awake (_go, _ctl)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.ctl = _ctl;
    self.preTime = -1;
end

--[[
    更新计时器
]]
function ExploreView:Update ()
    local tid, tData, removeList, changeList, isFind, isRemove = nil, nil, {}, List.new(), false, false;
    local luaBhvi, rwdPanel = nil, nil;
    local deltaTimes = 0;

    if (-1 == self.preTime) then
        return ;
    end

    deltaTimes = Time.time - self.preTime;
    self.preTime = Time.time;
    
    for i = 1, #self.ctl.updatePlayerList do
        tid = self.ctl.updatePlayerList[i];
        for j = 1, #self.mapMainData.teams do
            tData = self.mapMainData.teams[j];
            if (tid == tData.teamId) then
                isFind = true;
--                if (ExploreDefine.SqaureType.Diging == tData.position.status) then
                    --正在挖掘
                    tData.position.second = tData.position.second - deltaTimes;
                    if (tData.position.second <= 0) then
                        --修改该玩家的状态显示，记录需要移除的玩家
                        isRemove = true;
                    end
                    changeList:add(tid);
--                end
                break ;
            end
        end

        if (isRemove or not isFind) then
            table.insert(removeList, tid);
        end
    end

    if (#removeList > 0) then
        --移除已经走完倒计时的玩家
        self.ctl.synUpdatePlayerList(removeList, 1);
    end

    if (#changeList > 0) then
        --改变玩家的显示
        self.playersMgr:drawDigingRow(changeList);
    end

    --领奖面板更新
    --[[if (nil ~= self.rwdPanel) then
        luaBhvi = GetComponent(self.rwdPanel, "LuaBehaviour");
        if (nil ~= luaBhvi) then
            rwdPanel = luaBhvi.sourceLuaObj;
            if (nil ~= rwdPanel) then
                rwdPanel:Update();
            end
        end
    end]]

    --更新我的道具面板
    local atData, buJiTime = nil, ExploreMapDataProxy.getBuJiAddTime();
    if (0 == self.tp) then
        atData = self.arcTeamData;
    else
        atData = self.mapMainData.team;
    end
    if (nil ~= atData) then
        if (atData.supplySecond < buJiTime) then
            atData.supplySecond = atData.supplySecond + deltaTimes;
        end
        if (atData.supplySecond >= buJiTime and atData.supply < atData.maxSupply) then
            atData.supplySecond = atData.supplySecond - ExploreMapDataProxy.getBuJiAddTime();
            atData.supply = atData.supply + 1;
            self:drawMyPropRow();
        end
    end
end

--[[

]]
function ExploreView:initPanel ()
    self.mapContainer = GetGameObject(self.transform, "MapContainer");
    self.uiExtWrapContentGO = GetGameObject(self.mapContainer.transform, "Panel/UIExtWrapContent");
    self.uiExtWrapContent = GetComponent(self.uiExtWrapContentGO, "UIExpWrapContent");

    self.myPropRow = GetGameObject(self.transform, "MyPropRow");
    self.upBGTitle = GetGameObject(self.transform, "TopInfo/UpBG/Title");
    self.compass = GetGameObject(self.transform, "Compass");
    
    --self.rwdPanel = GetGameObject(self.transform, "RwdPanel");
    self.mineDetailPanel = GetGameObject(self.transform, "mineDetailPanel");

    self.nextMapBtn = GetGameObject(self.transform, "mineDetailPanel/nextMapBtn");
    GetPathComponent(self.nextMapBtn.transform, "Label", "UILabel").text = const_nextMapWord;
    self.sltMapPanel = GetGameObject(self.transform, "sltMapPanel");

    self.mapLvl = GetGameObject(self.transform, "TopInfo/CommonUpBG/MapLvl");
end

--[[
    设置ScrollView是否可以滚动
    _isEnabled boolean
]]
function ExploreView:setMapContainerSVEnabled (_isEnabled)
    _isEnabled = _isEnabled or false;
    GetComponent(self.mapContainer, "UIScrollView").enabled = _isEnabled;
end

--[[

]]
function ExploreView:initData (_data, _tp)
    self.tp = _tp;
    
    self.mapUnitMgr:Awake(self.uiExtWrapContentGO, self.ctl);
    self.playersMgr:Awake(self.mapContainer, self.mapUnitMgr, self.ctl);

    if (ExploreDefine.ExploreEtyType.ExploreEtrPanel == _tp) then
        self.arcTeamData = _data;
    elseif (ExploreDefine.ExploreEtyType.ExploreMapPanel == _tp) then
        self.mapMainData = _data;
        ExploreMapDataProxy.setPointTime(self.mapMainData);
    end
    
    self:drawMyPropRow();
    
    if (ExploreDefine.ExploreEtyType.ExploreEtrPanel == self.tp) then
        --self:initRwdPanel();
    end
    
    if (ExploreDefine.ExploreEtyType.ExploreMapPanel == self.tp) then
        self:initShowMapData();
        self:initWholeMapRscData();
        self:initNPCAndHeroData();
        self:initMap();
    end
    
    self.preTime = Time.time;

    if AudioConst.GetBgmName() ~= "explore" then
        SimpleAudio.StopMusic(doNthFunc)
        SimpleAudio.PlayMusic("explore")
        AudioConst.SetBgmName("explore")
    end
end

--[[
    打印数据
]]
function ExploreView:showData ()
--    local tmp = nil;
--    for i = 1, #self.mapMainData.activationMap do
--        error(i .. "----------" .. self.mapMainData.activationMap[i]);
--    end

--    for i = 1, #self.mapMainData.specialPoin do
--        tmp = self.mapMainData.specialPoin[i];
--        if (tmp.second > 0) then
--            error(tmp.x .. "|" .. tmp.y .. "|" .. tmp.giftId .. "|" .. tmp.second .. "|" .. tmp.status);
--        end
--    end
end

--[[
    _isShow boolean
]]
function ExploreView:setNextMapBtnShow (_isShow)
    self.nextMapBtn:SetActive(_isShow);
end

--[[
    绘制ExploreMyPropRow的面板信息
]]
function ExploreView:drawMyPropRow ()
    local myPropRow, luaBhvi = nil, nil;

    luaBhvi = GetComponent(self.myPropRow, "LuaBehaviour");
    if (nil ~= luaBhvi) then
        myPropRow = luaBhvi.sourceLuaObj;
    end
    
    if (nil == myPropRow) then
        myPropRow = ExploreMyPropRow.new();
        myPropRow:Awake(self.myPropRow);
        PanelManager:BindPanelScript(myPropRow, self.myPropRow, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end

    if (ExploreDefine.ExploreEtyType.ExploreEtrPanel == self.tp) then
        myPropRow:setData(self.arcTeamData);
--        myPropRow:showBuJi(self.arcTeamData.supply, self.arcTeamData.maxSupply);
--        myPropRow:showZhiYuan(self.arcTeamData.npcLeveL, self.arcTeamData.maxNpcLevel);
        self.myPropRow.transform.localPosition = Vector3.New(-272, 443, 0);
        GetComponent(self.upBGTitle, "UILabel").text = const_choseToGet;

        self.mapLvl:SetActive(false);
    else
        myPropRow:setData(self.mapMainData.team);
--        myPropRow:showBuJi(self.mapMainData.team.supply, self.mapMainData.team.maxSupply);
--        myPropRow:showZhiYuan(self.mapMainData.team.npcLeveL, self.mapMainData.team.maxNpcLevel);
        self.myPropRow.transform.localPosition = Vector3.New(-272, 420, 0);
        
        self.mapLvl:SetActive(true);
    end
end

--[[

]]
function ExploreView:initRwdPanel ()
    --[[local rwdLuaPanel, luaBhvi = nil, nil;
    
    self.mapContainer:SetActive(false);
    self.compass:SetActive(false);
    self.mineDetailPanel:SetActive(false);
    self.rwdPanel:SetActive(true);
    self:setNextMapBtnShow(false);
    
    luaBhvi = GetComponent(self.rwdPanel, "LuaBehaviour");
    
    if (nil ~= luaBhvi) then
        rwdLuaPanel = luaBhvi.sourceLuaObj;
    end
    
    if (nil == rwdLuaPanel) then
        rwdLuaPanel = ExploreRwdPanel.new();
        rwdLuaPanel:Awake(self.rwdPanel, self.ctl);
        PanelManager:BindPanelScript(rwdLuaPanel, self.rwdPanel, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        rwdLuaPanel:Start();
    end
    
    rwdLuaPanel:setData(self.arcTeamData);]]
end

--[[

]]
function ExploreView:setMapMainData (_data)
    self.mapMainData = _data;
    self:initWholeMapRscData();
    self:initNPCAndHeroData();

    self:initMap();
end

--[[
    根据初始激活信息，更新可视地图信息
    return nil
]]
function ExploreView:initShowMapData ()
    local curState, isShow = nil, nil;
    local muSize = ExploreConstant.getMapCntSize();
    
    self.showSqurInfoList:clear();
    
    for i = 1, #self.mapMainData.activationMap do
        self.showSqurInfoList:add(self.mapMainData.activationMap[i]);
    end
    
    for i = 0, #self.mapMainData.activationMap - 1 do 
        for j = 0, muSize.x - 1 do
            isShow = 0;
            curState = ExploreMapDataProxy.getPointStatus(self.mapMainData.activationMap, j, i);
            
            if (0 == curState) then
                --当前位置是否可显示
                isShow = ExploreMapDataProxy.isCurPointShow(self.mapMainData.activationMap, j, i);
                
                if (1 == isShow) then
                    --将当前位置设置为显示状态
                    ExploreMapDataProxy.setPointStatus(self.showSqurInfoList, j, i, 1);
                end
            end
        end
    end
end

--[[
    将地图的特殊资源信息存入Map表，方便查找、更新及维护
    表中存放
    key:位置信息;
    value:单元格状态、单元格里的资源、时间
    return nil
]]
function ExploreView:initWholeMapRscData ()
    local baseVal, keyTmp, posTab = nil, nil, nil;
    
    self.wholeMapRscData:clear();
    for i = 1, #self.mapMainData.specialPoin do
        baseVal = self.mapMainData.specialPoin[i];
        keyTmp = baseVal.x .. "_" .. baseVal.y;
        posTab = {status = baseVal.status, giftId = baseVal.giftId, second = baseVal.second};
        self.wholeMapRscData:put(keyTmp, posTab);
    end
end

--[[
    移除self.wholeMapRscData中指定的特殊资源信息
    _list List<table> {x, y};
]]
function ExploreView:removeWholeMapRscData (_list)
    local tmp = nil;

    _list = _list or List.new();
    for i = 1, #_list do
        tmp = _list[i];
        if (nil ~= self.wholeMapRscData[tmp[1] .. "_" .. tmp[2]]) then
            self.wholeMapRscData:remove(tmp[1] .. "_" .. tmp[2]);
        end
    end
end

--[[

]]
function ExploreView:initNPCAndHeroData ()
    local pos = nil;
    
    self.playersMgr:initData(self.mapMainData.teams);
    --将玩家的当前位置设置为已探索
    for i = 1,#self.mapMainData.teams do
        pos = self.mapMainData.teams[i].position;
        ExploreMapDataProxy.setPointStatus(self.mapMainData.activationMap, pos.x, pos.y, 1);
    end
end

--[[
    动态地图创建
    return nil
]]
function ExploreView:initMap ()
    self.compass.transform.localPosition = Vector3.New(220, 422, 0);
    
    self.mapContainer:SetActive(true);
    self.compass:SetActive(true);
    self.mineDetailPanel:SetActive(true);
    --self.rwdPanel:SetActive(false);

    self:initCompass();
    self:isShowNextMapBtn();
    self:initMineDetailPanel();
    --[[local cortTmp = LuaCallManager:invokeCall(function () 
        self.mapUnitMgr:initPanel();
    end, 0.05);
    self.ctl.addToCortList(cortTmp);]]
    self.mapUnitMgr:initPanel();
end

--[[
    初始化罗盘
    return nil
]]
function ExploreView:initCompass ()
    local luaBhvi, ecPanel = nil, nil;
    local myPos, tarPos = nil, nil;
    
    luaBhvi = GetComponent(self.compass, "LuaBehaviour");
    
    if (nil ~= luaBhvi) then
        ecPanel = luaBhvi.sourceLuaObj;
    end
    
    if (nil == ecPanel) then
        ecPanel = ExploreCompassPanel.new();
        ecPanel:Awake(self.compass);
        PanelManager:BindPanelScript(ecPanel, self.compass, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end
    
    self:drawExploreCompassPanel();
end

--[[
    是否显示传送门按钮
]]
function ExploreView:isShowNextMapBtn ()
    local unSearchedSquareCnt = 0;

    unSearchedSquareCnt = ExploreMapDataProxy.getUnSearchPointCnt(self.showSqurInfoList);
    
    if (unSearchedSquareCnt <= const_noteNum) then
        --剩余未探索方块不大于5个，显示传送门按钮
        self:setNextMapBtnShow(true);
        ViewUtil.AddClickEvent(self.nextMapBtn, function () self:goNextMap(); end);
    else
        self:setNextMapBtnShow(false);
    end
end

--[[
    
]]
function ExploreView:initMineDetailPanel ()
    local luaBhvi, mdPanel = nil, nil;
    
    luaBhvi = GetComponent(self.mineDetailPanel, "LuaBehaviour");
    
    if (nil ~=  luaBhvi) then
        mdPanel = luaBhvi.sourceLuaObj;
    end
    
    if (nil == mdPanel) then
        mdPanel = ExploreMineDetailPanel.new();
        mdPanel:Awake(self.mineDetailPanel);
        PanelManager:BindPanelScript(mdPanel, self.mineDetailPanel, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end
    
    mdPanel:initData(self.mapMainData.team, self.mapMainData.mapLevel);
    local cortTmp = LuaCallManager:invokeCall(function () 
        self.ctl.showEasyGuide();
    end, 0.5);
    self.ctl.addToCortList(cortTmp);
    self.emdpObj = mdPanel;
end

--[[
    同步我的NPC等级数据
    _lvl number npc等级
]]
function ExploreView:synNPCLvl (_lvl)
    self.mapMainData.team.npcLeveL = _lvl;
    self.mapMainData.team.npcStatus = 1;

    self:initMineDetailPanel();
end

--[[
    从传送门进入下一张地图
]]
function ExploreView:goNextMap ()
    local luaBhvi, smPane = nil, nil;

    self.sltMapPanel:SetActive(true);
    luaBhvi = GetComponent(self.sltMapPanel, "LuaBehaviour");
    if (nil ~= luaBhvi) then
        smPane = luaBhvi.sourceLuaObj;
    end

    if (nil == smPane) then
        smPane = ExploreSltMapPane.new();
        smPane:Awake(self.sltMapPanel);
        PanelManager:BindPanelScript(smPane, self.sltMapPanel, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end
    smPane:setData(ExploreMapDataProxy.getMapLvlByNPCLvl(self.mapMainData.team.maxNpcLevel), self.mapMainData.mapLevel);
    self.sltMapPanel:SetActive(true);
    GetGameObject(self.compass.transform, "SltPanel"):SetActive(false);
end

--[[
    
]]
function ExploreView:drawExploreCompassPanel ()
    local luaBhvi, ecPanel = nil, nil;
    local myPos, tarPos = nil, nil;
    
    luaBhvi = GetComponent(self.compass, "LuaBehaviour");
    
    if (nil ~= luaBhvi) then
        ecPanel = luaBhvi.sourceLuaObj;
    end
    
    if (nil ~= ecPanel) then
        myPos = Vector3.New(self.playersMgr.myHero.heroInfoData.position.x, self.playersMgr.myHero.heroInfoData.position.y, 0);
        tarPos = ExploreMapDataProxy.getCompassPoint(self.mapMainData.specialPoin, self.mapMainData.teams, myPos, ecPanel.rscId);
        ecPanel:drawPanel(myPos, tarPos);
    end
end

--[[
    移除指定的玩家
    _tId number 
    return nil
]]
function ExploreView:removePlayer (_tId)
    local tData, giftData = nil, nil;
    --移除玩家列表中的数据
    for i = 1, #self.mapMainData.teams do
        if (_tId == self.mapMainData.teams[i].teamId) then
            tData = self.mapMainData.teams[i];
            table.remove(self.mapMainData.teams, i);
            break;
        end
    end

    --特殊资源信息数据移除
    if (nil ~= tData) then
        for i = 1, #self.mapMainData.specialPoin do
            giftData = self.mapMainData.specialPoin[i];
            if (giftData.x == tData.x and giftData.y == tData.y) then
                table.remove(self.mapMainData.specialPoin, i);
                break ;
            end
            giftData = nil;
        end
        if (nil ~= self.wholeMapRscData[tData.x .. "_" .. tData.y]) then
            self.wholeMapRscData:remove(tData.x .. "_" .. tData.y);
        end
    end
    self.mapUnitMgr:removePlayer(_tId);
    self.playersMgr:removePlayer(_tId);
end

--[[
    移动后，同步ArcMapMainData中的数据
    _mData ArcTeamMapData
]]
function ExploreView:setSquDataAfterMove (_mData)
    local pos = _mData.position;
    local status = pos.status;
    local newMark = 0;
    local tmpList = List.new();
    local unsearchSquNum = 0;

    if (ExploreDefine.SqaureType.UnSearch ~= status) then
        --1，已探索
        status = ExploreDefine.SqaureType.Searched;
    end
    --设置地图方格的激活状态数据
    ExploreMapDataProxy.setPointStatus(self.mapMainData.activationMap, pos.x, pos.y, status);
    --设置地图方格的迷雾数据
    ExploreMapDataProxy.setShowAreaOfPoint(self.showSqurInfoList, pos.x, pos.y);
    --修改ArcMapMainData.teams中的数据
    newMark = ExploreMapDataProxy.setTeamData(self.mapMainData.teams, _mData);
    --修改ArcMapMainData.specialPoin中的数据
    ExploreMapDataProxy.setSpecialPointData(self.mapMainData.specialPoin, _mData.position);

    if (1 == newMark) then
        --新玩家，需要添加玩家数据到ExplorePlayersMgr.playersList
        tmpList:add(_mData);
        self.playersMgr:addPlayer(tmpList);
    end
    self:isShowNextMapBtn();

    --更新罗盘
    self:drawExploreCompassPanel();
    --设置周围的12个点可见
    self:setSquShowAroundPoint(pos.x, pos.y);
end

--[[
    挖掘中，同步ArcMapMainData中的方格数据
    _mData ArcTeamMapData
    _tp number 2，需要修改ArcMapMainData.specialPoin中的数据，当_mData.position.giftId不为0时，删除self.mapMainData.specialPoin中的数据
]]
function ExploreView:setSquDataDiging (_mData, _tp)
    local newMark = 0;
    local tmpList = List.new();
    local pos = _mData.position;

    _tp = _tp or 0;

    --修改ArcMapMainData.teams中的数据
    newMark = ExploreMapDataProxy.setTeamData(self.mapMainData.teams, _mData);
    --修改ArcMapMainData.specialPoin中的数据
    ExploreMapDataProxy.setSpecialPointData(self.mapMainData.specialPoin, _mData.position, _tp);
    
    if (2 == _tp) then
        local listTmp = List.new();
        listTmp:add({_mData.position.x, _mData.position.y});
        self:removeWholeMapRscData(listTmp);
    end

    --设置地图方格的迷雾数据
    ExploreMapDataProxy.setShowAreaOfPoint(self.showSqurInfoList, pos.x, pos.y);

    if (1 == newMark) then
        --新玩家，需要添加玩家数据到ExplorePlayersMgr.playersList
        tmpList:add(_mData);
        self.playersMgr:addPlayer(tmpList);
    end
    self:isShowNextMapBtn();
    --设置周围的12个点可见
    self:setSquShowAroundPoint(pos.x, pos.y);
end

--[[
    后台推特殊资源数据包处理
    _data PushArcMapPoinEndData
]]
function ExploreView:setSquDataFromPushSpecialRsc (_data)
    local ampData = nil;
    local atmData = nil;
    local list = List.new();

    ViewUtil.showMsg(const_newProps);
    
    for i = 1, #_data do
        ampData = _data[i];
        --设置地图方格的状态数据
--        ExploreMapDataProxy.setPointStatus(self.mapMainData.activationMap, ampData.x, ampData.y, ExploreDefine.SqaureType.Searched);
        --修改ArcMapMainData.specialPoin中的数据
        ExploreMapDataProxy.setSpecialPointData(self.mapMainData.specialPoin, ampData, 1);
        list:add({ampData.x, ampData.y, ampData.giftId});
    end
    
    self:isShowNextMapBtn();
    --设置时间
    ExploreMapDataProxy.setPointTime(self.mapMainData, list);
    self:initWholeMapRscData();
    --修改已生成的方格的显示
    self.mapUnitMgr:setSquGiftId(list);
end

--[[
    设置罗盘的道具ID
    _propId number 道具ID
]]
function ExploreView:setCompassProp (_propId)
    local luaBhvi, cPanel = nil, nil;

    luaBhvi = GetComponent(self.compass, "LuaBehaviour");
    if (nil ~= luaBhvi) then
        cPanel = luaBhvi.sourceLuaObj;
        if (nil ~= cPanel) then
            cPanel:setPropId(_propId);
            self:drawExploreCompassPanel();
        end
    end
end

--[[
    设置指定点周围的方格可见 TODO
    _x number
    _y number 
]]
function ExploreView:setSquShowAroundPoint (_x, _y)
    local showSquPosList = nil;
    
    showSquPosList = ExploreMapDataProxy.getShowPosList(_x, _y);
    self.mapUnitMgr:showTarPosSqu(showSquPosList);
end

--[[
    修改倒计时结束时，其他玩家的Square显示
]]
function ExploreView:refreshSquShow (_tab)
    local tab, tmpTab, list = _tab, nil, List.new();
    local atmData = nil;

    tab = tab or {};
    
    for i = 1, #tab do
        for j = 1, #self.mapMainData.teams do
            if (tab[i] == self.mapMainData.teams[i].teamId) then
                list:add({x = self.mapMainData.teams[i].position.x, y = self.mapMainData.teams[i].position.y});
                break ;
            end
        end
    end

    self.mapUnitMgr:showTarPosSqu(list);
end

--[[

]]
function ExploreView:resetMap ()
    self.preTime = -1;
    
    self.wholeMapRscData:clear();
    self.playersMgr:resetMap();
    self.mapUnitMgr:resetMap();
end

--[[

]]
function ExploreView:OnDestroy ()
    self.ctl = nil;
    self.transform = nil;
    self.gameObject = nil;
end
