--地图单元格
--2016-7-23 11:04:59 library

MapUnitPanel = class();

--[[

]]
function MapUnitPanel:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.ctl = nil;
    self.baseVec = nil;--地图单元的相对坐标

    --对象管理器ExploreSquRow
    self.squareMgr = ExploreSquareMgr.new();
    self.curPlayersList = List.new();--当前地图单元的玩家，方便管理

    self.idx = nil;
end

--[[

]]
function MapUnitPanel:Awake (_go, _idx, _ctl)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.idx = _idx;
    self.ctl = _ctl;

    self:initPanel();
end

--[[

]]
function MapUnitPanel:initPanel ()
    --self.playerContainer = GetGameObject(self.transform, "PlayerContainer");
    
    self.squareMgr:Awake(self, self.ctl);
end

--[[

]]
function MapUnitPanel:initData (_baseX, _baseY)
    self.baseVec = Vector2.zero;
    self.baseVec.x = _baseX;
    self.baseVec.y = _baseY;
    
    self:drawMap();
end

--[[
    地图单元绘制
]]
function MapUnitPanel:drawMap ()
    self:dealSquares();
    self:dealNPCAndHeros();
end

--[[
    绘制遮挡单元格及宝藏
]]
function MapUnitPanel:dealSquares ()
    self.squareMgr:initData(self.baseVec);
    self.squareMgr:dealInfoList();
    self.squareMgr:drawPanel();
end

--[[
    添加玩家
    _tabList List
    _tp number 0,_tabList的类型是id 1,_tabList的类型是ArcTeamMapData
    return nil
]]
function MapUnitPanel:dealNPCAndHeros (_tabList, _tp)
    local npcAndHeros = nil;

    _tabList = _tabList or List.new();

    --先移除旧的玩家数据
    for i = self.curPlayersList:getSize(), 1, -1 do
        npcAndHeros = self.curPlayersList[i];
        if (#_tabList <= 0 or self:isInList(npcAndHeros.heroInfoData.teamId, _tabList, _tp)) then
            if (nil ~= npcAndHeros and nil ~=  npcAndHeros.transform and nil ~= npcAndHeros.transform.parent and nil ~= npcAndHeros.transform.parent.gameObject
            and self.gameObject == npcAndHeros.transform.parent.gameObject) then
                npcAndHeros:SetGOActive(false);
            end
            self.curPlayersList:removeAt(i);
        end
    end
    
    --添加新的玩家数据
    self.ctl.exploreView.playersMgr:drawUnitPlayers(self.baseVec, self.curPlayersList, self, _tabList, _tp);
end

--[[
    判断玩家是否在指定的列表中
    _tid number 玩家的teamId
    _list 玩家列表
    return boolean
]]
function MapUnitPanel:isInList (_tid, _list, _tp)
    local isIn = false;

    _list = _list or List.new();
    _tp = _tp or 0;

    for i = 1, #_list do
        if (0 == _tp and _tid == _list[i] or 1 == _tp and _tid == _list[i].teamId) then
            isIn = true;
            break ;
        end
    end

    return isIn;
end

--[[
    移除指定的玩家，MapUnitPanel对象仅持有引用，所以清除引用即可
    _tId number 
    return nil
]]
function MapUnitPanel:removePlayer (_tId)
    local playerRow = nil;

    for i = 1, self.curPlayersList:getSize() do
        playerRow = self.curPlayersList[i];
        if (nil ~= playerRow) then
            if (playerRow.heroInfoData.teamId == _tId) then
                self.curPlayersList:removeAt(i);
                break ;
            end
        end
    end
end

--[[

]]
function MapUnitPanel:resetMap ()

end