require "Game/FB/View/FBView"
 
FBControler = {}

local this = FBControler
this.countTimes = 0

function FBControler.New()
	return this
end

function FBControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = FBView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function FBControler.Awake()
end

function FBControler.Start()
	this.view:Start()
end

function FBControler.Update()
	this.view:Update()
	local times = GetIntPart(Time.timeSinceLevelLoad / 10)
	if times > this.countTimes then
		this.countTimes = times
		FBData.SaveData()
	end
end

function FBControler:OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function FBControler.initListener()
end

function FBControler.listNotificationInterests()
    local list = {MVCConst.UPDATE_FB, MVCConst.SHOWREDICON}
    return unpack(list)
end

function FBControler.handleNotification(notification)
    local nName = notification:getName()
    local nBody = notification:getBody()
    if nName == MVCConst.UPDATE_FB then
		this.view:slideTabGate(FBData:GetCurHouseId(), true)
	elseif nName == MVCConst.SHOWREDICON then
		this.view:showHintPoint()
	end
end

function FBControler.request()
	local chapterId = FBData.GetCurChapterIdRPC()
	local hardLevel = FBData.GetCurHardLevel()
--	plog("[RequestFB] chapterId = %s, hardLevel = %s", chapterId, hardLevel)
	Network.SendMoData(ServerID.FB, {chapterId, hardLevel}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("TeamDungeonsData", session)
        --add by library 2016-11-16 17:54:32 ޸ĵǰ½ڵͨѶ
        FBData.guideCurChapterMaxHouseAndLvl(mo);
        this.accept(mo)
	end, {})
end

function FBControler.accept(data)
    ViewUtil.initData(this, data)
    this.goGuide();
    this.goEasyGuide();
end

--[[
    ԶǿжϣжϸǷҪָĴ
    ȡԶжϵĲ裬ȡҪָʱɵĸ
    ǿжʱȡжʱĴ裬ȡҪָʱɵĸ
]]
function FBControler.goGuide ()
    local guide, ctner, guideState = nil, nil, nil;
    local curStep = PlayerData.getMyGuideStep();
     if (PlayerData.guideNotEnd()) then
         guide = FindObject("UIRoot/GuideMain(Clone)");
         ctner = GetGameObject(guide.transform, "Container");
         if (nil ~= ctner) then
             local function pcallFunc ()
--                error("FB__" .. curStep .. "__"  .. FBData.GetCurGateId() .. "__" .. tostring(FBData.IsPassedGate(FBData.GetCurGateId(), 1)));
                 if (
                     (
                        10103 == FBData.GetCurGateId() and FBData.IsPassedGate(10103, 1) or 
                        10104 == FBData.GetCurGateId() and not FBData.IsPassedGate(10104, 1)) and 220 == curStep  or 
--                     (
--                        10104 == FBData.GetCurGateId() and FBData.IsPassedGate(10104, 1) or 
--                        10105 == FBData.GetCurGateId() and not FBData.IsPassedGate(10105, 1)) and 231 == curStep  or 
                     (
                        10105 == FBData.GetCurGateId() and FBData.IsPassedGate(10105, 1) or 
                        10201 == FBData.GetCurGateId() and not FBData.IsPassedGate(10201, 1)) and 310 == curStep or 
                     (
                        10202 == FBData.GetCurGateId() and FBData.IsPassedGate(10202, 1) or 
                        10203 == FBData.GetCurGateId() and not FBData.IsPassedGate(10203, 1)) and 381 == curStep or 
                     (
                        10205 == FBData.GetCurGateId() and FBData.IsPassedGate(10205, 1) or 
                        10301 == FBData.GetCurGateId() and not FBData.IsPassedGate(10301, 1)) and 441 == curStep or 
                     (
                        10305 == FBData.GetCurGateId() and FBData.IsPassedGate(10305, 1) or 
                        10401 == FBData.GetCurGateId() and not FBData.IsPassedGate(10401, 1)) and 490 == curStep
                 ) then
                     guideState = 0;
		             LuaCallManager:invokeCall(function () 
		                 Facade:sendNotification(MVCConst.GUIDE_NEXT, {[1] = 0}, guideState);
		             end, 0.5);
                 end
             end
             if (pcall(pcallFunc)) then

             end
         end
     end
end

--[[
    10705-111305-2֮
]]
function FBControler.goEasyGuide ()
    if (10505 == FBData.GetCurGateId() and FBData.IsPassedGate(10505, 1) and 0 == SimpleCache.getCacheVal(SimpleCache.simpleCacheFBMidCard, 2)) then
        SimpleCache.setCache(SimpleCache.simpleCacheFBMidCard, 1, 2);
        ViewUtil.showEasyGuide(ConstantNames.EasyGuide_FBMidCard);
    end

    if (11005 == FBData.GetCurGateId() and FBData.IsPassedGate(11005, 2) and 0 == SimpleCache.getCacheVal(SimpleCache.simpleCacheFBHardCard, 2)) then
        SimpleCache.setCache(SimpleCache.simpleCacheFBHardCard, 1, 2);
        ViewUtil.showEasyGuide(ConstantNames.EasyGuide_FBHardCard);
    end
end