--[[
-- Desc: 
-- Author: kenny
-- Date: 2016
--]]
AlphaAction = class(BaseAction)

function AlphaAction:ctor(isShow)
	self.isShow = isShow
end

function AlphaAction:onBegin()
	self.super.onBegin(self)
	self:doAction()
end

function AlphaAction:onEnd()
	self.super.onEnd(self)
end

function AlphaAction:doAction()
    self.super.doAction(self)
	
    local sp = 1
    local ep = 0
    if self.isShow then
		sp = 0
		ep = 1
    end

    iTween.ValueTo(self.viewParent.gameObject, iTween.Hash(
		"from", sp,
		"to", ep,
		"time", self.lastTime,
		"easeType", iTween.EaseType.linear,
		"onupdate", self.onupdate,
		"luaobj", self))
end

function AlphaAction.onupdate(luaObj , value)
	if not luaObj.getActors then
		return
	end
	local targets = luaObj:getActors()
	if targets ~= nil then
		for i = 1, targets.size do
			local target = targets[i]
			if typeofClass(target, Actor) then
				target:showAlpha(value)
			end
		end
	end
end
