--[[
-- Desc: 
-- Author: kenny
-- Date: 2016
--]]
AnimationAction = class(BaseAction)

function AnimationAction:ctor()
end

function AnimationAction:onBegin()
	if self.lastTime <= 0 and self.endCond[1] <= 0 then
		self.lastTime = 4
		self.endCond[2] = self.lastTime
		self.isActorEnd = true
	end
	self.super.onBegin(self)
	-- ΪָΪһ
	local indexId = self.actionMaster[1] or "0"
	local actMaps = FightControler.getActionManager()
	local action = actMaps:getActionByIndexId(self.actionId, self.camp, self.round, indexId) -- ﲻself.teamSide
	if action ~= nil then
		local actorList = action:getActors()
		if not IsEmpty(actorList) then
			for _, actor in ipairs(actorList) do
				self:addActor(actor)
			end
		end
	end
	self:doAction()
end

function AnimationAction:onEnd()
	self.super.onEnd(self)

	local actorList = self:getActors()
    if not IsEmpty(actorList) then
		for _, actor in ipairs(actorList) do
			if actor.loopCount > 0 then
				actor:playAnimationWithAction(AnimationName.IDLE, self)
			end
		end
	end
end

function AnimationAction:playActor(actor)
--	plog("playActor Animation = %s", self.actionExtra)
	if not IsEmpty(self.actionExtra) then
		actor:playAnimationWithAction(tostring(self.actionExtra), self)
		if self.actionExtra == AnimationName.HIT then
			actor:showColorRed()
			iTween.ShakePosition(UICamera.currentCamera.gameObject, Vector3.New(0.05, 0.05, 0), 0.2)
		end
	else
		actor:playAnimationWithAction(AnimationName.IDLE, self)
	end
end

function AnimationAction:doAction()
	self.super.doAction(self)
	
	local actorList = self:getActors()
--	plog(actorList, "Animation->actorList = "..self.actionExtra)
    if not IsEmpty(actorList) then
		for _, actor in ipairs(actorList) do
			local target = actor:getActorObject()
			self:addActionObject(target)
			self:scaleObjectSize(target)
			self:playActor(actor)
			self:onSequence(actor, actor.savePos)
		end
	end
end

-- ж
function AnimationAction:onSequence(actor, srcPos)
	local lastTime = self.lastTime
	if lastTime <= 0 then
		return
	end

	if IsMember(self.aimPositionType, PositionType) then
		local aimPosX = self.aimPosition.x
		local aimPosY = self.aimPosition.y
		if self.aimPositionType == PositionType.Relative then
			local deltaPos = Vector3(aimPosX, aimPosY, 0)
			local pos = self:getPositionRelative(actor, deltaPos)
			aimPosX = pos.x
			aimPosY = pos.y
		end
		local target = actor:getActorObject()
		if self.actionMasterType == ActionMasterType.EnemyHeros then -- 
			local function onComplete(luaobj, params)
				local target = params[1]
				local srcPos = params[2]
				local lastTime = params[3]
				iTween.MoveTo(target, iTween.Hash(
					"position", Vector3(srcPos.x, srcPos.y, target.transform.localPosition.z),
					"islocal", true,
					"time", lastTime,
					"easeType", iTween.EaseType.linear))
			end
			local cbFunc = onComplete
			local cbParams = {[1] = target, [2] = srcPos, [3] = lastTime}
			iTween.MoveTo(target, iTween.Hash(
				"position", Vector3(aimPosX, aimPosY, target.transform.localPosition.z),
				"islocal", true,
				"time", lastTime,
				"easeType", iTween.EaseType.linear,
				"oncomplete", cbFunc,
				"oncompleteparams", cbParams))
		else
			iTween.MoveTo(target, iTween.Hash(
				"position", Vector3(aimPosX, aimPosY, target.transform.localPosition.z),
				"islocal", true,
				"time", lastTime,
				"easeType", iTween.EaseType.linear))
		end
	end
end

function AnimationAction:destroy()
--    if not IsEmpty(self.actorList) then
--		for _, actor in ipairs(self.actorList) do
--			FightControler.removeActor(self.actionId, self.teamSide, self.indexId, actor.onlyId)
--		end
--	end
end
