--[[
-- Desc: 
-- Author: kenny
-- Date: 2016
--]]
BlackScreenAction = class(BaseAction)

 function BlackScreenAction:ctor()
	self.root = ViewUtil.getRootView()
	self.viewParent = FightControler.getViewParent()
end

function BlackScreenAction:onBegin()
	self.super.onBegin(self)
	self:doAction()
end

function BlackScreenAction:onEnd()
	self.super.onEnd(self)
end

function BlackScreenAction:doAction()
    self.super.doAction(self)
	local blackPrefab = GameObject.Instantiate(Util.LoadPrefab("Effects/BlackScreen", AssetBundleInfo.assetBundles))
	HangObject(blackPrefab, self.viewParent)
--	blackPrefab.transform.parent = self.viewParent
--	blackPrefab.transform.localPosition = Vector3.zero
--	blackPrefab.transform.localRotation = Quaternion.Euler(Vector3.zero)
--	blackPrefab.transform.localScale = Vector3.one
	self.blackPrefab = blackPrefab
	self.blackSprite = GetPathComponent(self.blackPrefab.transform , "Panel/Sprite", "UISprite")
	self.blackSprite:SetAnchor(self.root.transform)

    iTween.ValueTo(self.viewParent.gameObject,
		iTween.Hash(
			"from", 1,
			"to", 0,
			"time", self.lastTime,
			"easeType", iTween.EaseType.linear,
			"onupdate", self.onupdate,
			"luaobj", self))
end

function BlackScreenAction.onupdate(luaObj , value)
	if not luaObj.getActors then
		return
	end
	if value == 0 then
		if luaObj.blackPrefab ~= nil then
			GameObject.Destroy(luaObj.blackPrefab)
		end
	end
--	local targets = luaObj:getActors()
--	if targets ~= nil then
--		for i = 1, targets.size do
--			local target = targets[i]
--			if typeofClass(target, Actor) then
--				target:showAlpha(value)
--			end
--		end
--	end
end
