--[[
-- Desc: 控制
-- Author: kenny
-- Date: 2016
--]]
ControlActorAction = class(BaseAction)

function ControlActorAction:ctor()
	self.actorList = {}
end

function ControlActorAction:onBegin()
	self.super.onBegin(self)

	local extra = tonumber(self.actionExtra)
	if extra == ActorCtrlExtra.Create then
		self.actorList = self:createActorList()

	elseif extra == ActorCtrlExtra.Remove then
		self:removeByIndexId(self.skillId, self.teamSide, self.destIndexId, self.onlyIdList)
	end

	self:doAction()
end

function ControlActorAction:onEnd()
	self.super.onEnd(self)

--    if not IsEmpty(self.actorList) then
--		for _, actor in ipairs(self.actorList) do
--			actor:playAnimation(AnimationName.IDLE)
--		end
--	end
end

function ControlActorAction:doAction()
	self.super.doAction(self)

    if not IsEmpty(self.actorList) then
		for _, actor in ipairs(self.actorList) do
			local body = actor:getActorObject()
			self:addActionObject(body)
			self:scaleObjectSize(body)
			self:onSequence(body)
		end
	end
end

-- 序列动画
function ControlActorAction:onSequence(target)
	local lastTime = self.lastTime
	if lastTime <= 0 then
		return
	end
-- 控制类型不做序列动画
--	if IsMember(self.aimPositionType, PositionType) then
--		iTween.MoveTo(target,
--			iTween.Hash(
--				"position", Vector3(self.aimPosition.x, self.aimPosition.y, target.transform.localPosition.z),
--				"islocal", true,
--				"time", lastTime,
--				"easeType", iTween.EaseType.linear))
--	end
end

function ControlActorAction:createActorList()
	local retActors = {}
	if not self:isActionMasterType() then
		return retActors
	end

	for idx = 1, #self.onlyIdList do
		local onlyId = self.onlyIdList[idx]
		if onlyId ~= nil then
			local startPos = Vector3(self.startPosition.x, self.startPosition.y, 0)
			local beginPos = startPos
			if self.startPositionType == PositionType.Relative then
				local actor = FightControler.getActorByOnlyId(0, self.teamSide, 0, onlyId)
				if actor ~= nil then
					startPos = self:getPositionRelative(actor, startPos)
				end
				beginPos = Vector3(startPos.x, startPos.y, 0)

			elseif self.startPositionType == PositionType.Custom then
				local standType = math.abs(tonumber(startPos.x) or StandType.HeroArea)
				local destAeraPosDic = GeneratePositions(standType, self.teamSide, #self.skillOnlyIds)
--				plog(destAeraPosDic, "出战位置，类型 = "..standType)
	
				local posIndex = tonumber(startPos.y) or 0
				if startPos.y == 0 then
					posIndex = idx
				end
				if not posIndex or posIndex < 1 or posIndex > CountTable(destAeraPosDic) then
					posIndex = 1
				end
				local destPos = destAeraPosDic[posIndex]
				if destPos ~= nil then
					startPos.x = destPos.x
					startPos.y = destPos.y
				end
				beginPos = Vector3(startPos.x, startPos.y, 0)
			end
			
--			plog("#ControlActorAction mapId = %s", FightControler.getActorMapId(self.skillId, self.teamSide, self.indexId, onlyId))
			local actor = FightControler.createActor(self.skillId, self.teamSide, self.indexId, onlyId, beginPos)
			if actor ~= nil then
				table.insert(retActors, idx, actor)
			end
		end
	end
	return retActors
end

function ControlActorAction:removeByIndexId(skillId, teamSide, indexId, onlyIdList)
	if not IsEmpty(onlyIdList) then
		for _, onlyId in ipairs(onlyIdList) do
			if onlyId ~= nil then
				FightControler.removeActor(skillId, teamSide, indexId, onlyId)
				FightControler.getActionManager():insertNewAction(ActionType.ActorEffect, ActorEffectExtra.Show, self)
			end
		end
	end
end

-- overwrite
function ControlActorAction:initPosition()
end
