--[[
-- Desc: Ʈ
-- Author: kenny
-- Date: 2016
--]]
ShowNumberAction = class(BaseAction)

function ShowNumberAction:ctor()
	self.root = ViewUtil.getRootView()
	self.fightObj = FightControler.gameObject
	self.prefab = Util.LoadPrefab("Fonts/FightText", AssetBundleInfo.assetBundles)
end

function ShowNumberAction:onBegin()
	self.endCond[2] = 1.2 -- self.endCond[2] * 2/3
	self.lastTime = 1.2 -- self.endCond[2] * 2/3
	self.super.onBegin(self)
	self:doAction()
end

function ShowNumberAction:createFightText(num, posX, posY)
	if not num or num == 0 then
		return
	end
	local fightText = CreateObject(self.prefab)
	HangObject(fightText, this.fightObj)
	local words = GetPathComponent(fightText.transform, "Word" , "MeshWord")
	if num < 0 then
		words.text = tostring(num)
		words.color1 = CreateColor(255, 84, 84, 128)
		words.color2 = CreateColor(255, 0, 0, 255)
	elseif num > 0 then
		words.text = "+"..tostring(num)
		words.color1 = CreateColor(90, 255, 90, 128)
		words.color2 = CreateColor(60, 255, 0, 255)
	end
	
	fightText.transform.parent = FightControler.getViewParent()
	fightText.transform.localPosition = Vector3(posX, posY, 0)
	fightText.transform.localRotation = Quaternion.Euler(Vector3.zero)
	fightText.transform.localScale = self.prefab.transform.localScale

	return fightText
end

function ShowNumberAction:createFightWord(isHert, num, posX, posY)
	if not num then
		return nil
	end

	local wordObj = CreateWord(0, "Fonts/FightText", AssetBundleInfo.assetBundles, this.fightObj)
	wordObj.transform.localPosition = Vector3(posX, posY, 0)
	local word = GetComponent(wordObj.transform, "MeshWord")
	if type(num) == "string" then
		word.text = num
	elseif isHert == true then
		word.text = "-" .. math.abs(tonumber(num))
		word.color1 = CreateColor(255, 0, 0, 255)
		word.color2 = CreateColor(255, 0, 0, 255)
	else
		word.text = "+" .. math.abs(tonumber(num))
		word.color1 = CreateColor(60, 255, 0, 255)
		word.color2 = CreateColor(60, 255, 0, 255)
	end

	return wordObj
end

function ShowNumberAction:doAction()
	self.super.doAction(self)
	
	local showValue = 0
	local damage = 0
	local restoration = 0
	damage = math.abs(self.damage)				-- ˺ֵ
	restoration = math.abs(self.restoration)		-- ֵָ
	
	local posX = 200
	local posY = 200
	local extra = tonumber(self.actionExtra)
	local isHert = false
	if self.teamSide == TeamSide.Left then
		posX = -posX
	elseif self.teamSide == TeamSide.Right then
		posX = posX
	end
	if extra == FightNumExtra.Hert then
		showValue = damage
		isHert = true
	elseif extra == FightNumExtra.Retrieve then
		showValue = restoration
	elseif extra == FightNumExtra.Miss then
		showValue = "m"
	end
--	plog("@skillId = %s, indexId = %d, damage = %d, restoration = %d, dodge = %s, actionExtra = %s, showValue = %s", self.skillId, self.indexId, self.damage, self.restoration, tostring(self.dodge), self.actionExtra, showValue)
	
	if showValue ~= nil then
		local hertNum = self:createFightWord(isHert, showValue, posX, posY)
		if hertNum ~= nil then
			local function complete()
    			Object.Destroy(hertNum.gameObject)
			end
			iTween.MoveTo(hertNum.gameObject, iTween.Hash(
				"position", Vector3(posX, posY + 80, hertNum.transform.localPosition.z),
				"islocal", true,
				"time", self.lastTime,
				"easeType", iTween.EaseType.easeOutCubic,
				"oncomplete", complete))
		end
	end
end

function ShowNumberAction:onEnd()
    self.super.onEnd(self)
end