--[[
-- Desc: 枚举
-- Author: kenny
-- Date: 2016
--]]
require "Game/Fight/Logic/ActionManager"
require "Game/Fight/Logic/Action/EffectAction"
require "Game/Fight/Logic/Action/ReadyAction"
require "Game/Fight/Logic/Action/DelayAction"
require "Game/Fight/Logic/Action/AnimationAction"
require "Game/Fight/Logic/Action/ControlActorAction"
require "Game/Fight/Logic/Action/AlphaAction"
require "Game/Fight/Logic/Action/ShowNumberAction"
require "Game/Fight/Logic/Action/ScaleActorAction"
require "Game/Fight/Logic/Action/BlackScreenAction"


----------------------------------------------------------------
-- 行为基本类型
ActionType =
{
	"SkillEffect",				-- 1: 技能特效
	"AnimationCtrl",		-- 2: 动作控制
	"BoneAttach",			-- 3: 骨骼附加: 特效、武器
	"ActorEffect",			-- 4: 角色效果: 虚化、隐身、缩放
	"ActorCtrl",				-- 5: 角色控制: 创建、删除、控制
	"HertNum",				-- 6: 伤害飘字: 受伤、回血
	"Special",					-- 7: 特殊行为: 延迟、黑屏
}
ActionType = EnumGenerator(ActionType)

-- 阵营
Camp =
{
	"Teammate",			-- 1: 队友
	"Enemy",					-- 2: 敌人
	"Neutrality",				-- 3: 中立
}
Camp = EnumGenerator(Camp)

-- 队列
TeamSide = 
{
	"Left",
	"Right"
}
TeamSide = EnumGenerator(TeamSide)

-- 行为主体类型
ActionMasterType = 
{
	"SkillHeros",				-- 1: 技能英雄
	"NoSkillHeros",		-- 2: 非技能英雄
	"TeammateHeros",	-- 3: 友方所有英雄
	"EnemyHeros",		-- 4: 敌方所有英雄
}
ActionMasterType = EnumGenerator(ActionMasterType)

-- 位置类型
PositionType = 
{
	"Relative",				-- 1: 相对
	"Absolute",				-- 2: 绝对
	"Custom",				-- 3: 自定义
}
PositionType = EnumGenerator(PositionType)

-- 站位类型
StandType =
{
	"HeroArea",				-- 1: 英雄区域
	"CloneArea",			-- 2: 克隆区域
}
StandType = EnumGenerator(StandType)

-- 创建与删除
ActorCtrlExtra =
{
	"Create",					-- 1: 创建
	"Remove",				-- 2: 删除
}
ActorCtrlExtra = EnumGenerator(ActorCtrlExtra)

-- 角色效果
ActorEffectExtra =
{
	"Hide",
	"Show",
	"Scale"
}
ActorEffectExtra = EnumGenerator(ActorEffectExtra)

-- 伤害飘字
FightNumExtra =
{
	"Hert",					-- 1: 对方伤害
	"Retrieve",			-- 2: 己方回复
	"Miss",					-- 3: 闪避
}
FightNumExtra = EnumGenerator(FightNumExtra)
