
FightConfigDataChecker = {
    
}; 

local this = FightConfigDataChecker;

--异常数据重置

--来自通用											
--2、分解ID必填，否则报错“分解ID未填”，此条命令按“延迟”处理														
--3、行为类型必填，否则报错“行为类型未填”，此条命令按“延迟”处理														
--4、特效/动作ID必填，否则报错“特效/行为ID未填”，此条命令按“延迟”处理	
--5、开始时机必填，否则报错“行为ID未填”，此条命令跳过不运行，以此分解ID为依赖的其他分解行为全部跳过不运行					
--6、持续时间必填，否则报错“行为ID未填”，否则报错“行为ID未填”，此条命令跳过不运行，以此分解ID为依赖的其他分解行为全部跳过不运行	
--8、如果持续时间不为“-1”，且结束时机非空，则结束时机不生效，按照持续时间生效，并报错“持续时间不为-1，结束时间必须为空”		
--9、行为主体类型为非空时，行为主体不可为空，否则报错“行为主体未填”，此条命令按“延迟”处理									
--10、位置类型非空时，位置不可为空，否则报错“位置未填”，此条命令按“延迟”处理		
--11、当行为主体类型为空时，位置类型不可以是“相对坐标”，否则报错“该行为无行为主体，相对坐标无法找到”，此条命令，按“延迟”处理														

--来自特效
--3、当行为主体类型为空时，开始位置必须为“绝对坐标”或“己方技能布阵配置”，否则报错“特效出现位置异常”，此条命令，按“延迟”处理	
--4、当行为主体类型为空且开始位置为“绝对坐标”时，结束位置必须为“绝对坐标”或空，否则报错“结束位置异常”，此条命令，按“延迟”处理
--5、当行为主体类型为空且开始位置为“己方技能布阵配置”时，结束位置必须为空，否则报错“结束位置异常”，此条命令，按“延迟”处理	
--7、当行为主体类型为非空时，开始位置类型必为“相对坐标”，否则报错“特效有行为主体，但无出现位置”，此条命令，按“延迟”处理		
--8、当行为类型为非空且开始位置类型为“己方技能布阵配置”时，则报错“特效行为下，行为主体非空时，位置不可设置为己方技能布阵配置”，此条命令，按“延迟”处理

--来自动作
--1、主体类型必填，所有行为主体类型都可填，否则报错“行为类型未填”，此条命令按“延迟”处理		
--2、行为主体必填，所有行为主体都可填，否则报错“行为主体未填”，此条命令按“延迟”处理											
--3、开始位置类型必须为空，否则报错“开始位置异常”，此条命令，按“延迟”处理	
--4、结束位置类型必须为“绝对坐标”或“相对坐标”，否则报错“结束位置异常”，此条命令，按“延迟”处理

--来自骨骼特效
--1、行为主体类型必填，不可为“群体”或空，否则报错“行为主体类型异常”，此条命令按“延迟”处理
--2、行为主体必填，格式为“英雄ID,骨骼ID”型异常”，否则报错“行为主体异常”，此条命令按“延迟”处理
--3、开始位置类型、开始位置、结束位置类型、结束位置均必须为空，否则报错“位置异常”，此条命令按“延迟”处理

--来自人物效果
--1、行为主体类型必填，不可为空，否则报错“行为主体类型异常”，此条命令按“延迟”处理											
--2、行为主体必填，所有行为主体都可填，否则报错“行为主体未填”，此条命令按“延迟”处理											
--3、开始位置类型、开始位置、结束位置类型、结束位置均必须为空，否则报错“位置异常”，此条命令按“延迟”处理														
--来自控制人物
--1、行为主体类型必填，不可为空，否则报错“行为主体类型异常”，此条命令按“延迟”处理														
--2、行为主体必填，所有行为主体都可填，否则报错“行为主体未填”，此条命令按“延迟”处理														
--3、当特效/动作ID为“复制人物”时，开始位置类型与开始位置必填，否则报错“开始位置异常”，此条命令按“延迟”处理														
--4、当特效/动作ID为“复制人物”时，结束位置类型与开始位置必空，否则报错“结束位置异常”，此条命令按“延迟”处理														
--5、当特效/动作ID为“复制人物”且行为主体类型为“群体”时，开始位置类型可填“相对坐标”或“己方技能布阵配置”，否则报错“开始位置异常”，此条命令按“延迟”处理														
--6、当特效/动作ID为“复制人物”且行为主体类型不为“群体”时，开始位置类型可填“相对坐标”或“绝对坐标”，否则报错“开始位置异常”，此条命令按“延迟”处理														
--7、当特效/动作ID为“删除人物”时，开始位置类型、开始位置、结束位置类型、结束位置均必须为空，否则报错“位置异常”，此条命令按“延迟”处理	

--来自伤害飘字
--1、行为主体类型必空，否则报错“行为主体类型异常”，此条命令按“延迟”处理														
--2、行为主体必空，否则报错“行为主体异常”，此条命令按“延迟”处理														
--3、开始位置类型与开始位置必填，且必须为“绝对坐标”，否则报错“开始位置异常”，此条命令按“延迟”处理							
--4、结束位置类型可填“绝对坐标”或空，否则报错“开始位置异常”，此条命令按“延迟”处理														
--来自特殊
--1、行为主体类型、行为主体必空，否则报错“行为主体类型异常”，此条命令按“延迟”处理											
--2、开始位置类型、开始位置、结束位置类型、结束位置均必须为空，否则报错“位置异常”，此条命令按“延迟”处理													



function FightConfigDataChecker.checkExceptionData(configRowData)

--	if (not IsNilOrEmpty(configRowData.lastTime) and tonumber(configRowData.lastTime) ~= -1) and not IsNilOrEmpty(configRowData.overTime) then
--		error("error:持续时间不为-1，结束时间必须为空");
--	end	

--	if IsNilOrEmpty(configRowData.indexId) then
--		error("error:分解id 没有配！！！！！！！！！！！！！！！！！！！！！！！！");
--		configRowData.indexId = 0;
--		configRowData.actionType = 7;
--		configRowData.actionExtra = 1;
--		return true;
--	end	

--	if IsNilOrEmpty(configRowData.actionType) then
--		error("error:行为类型 没有配！！！！！！！！！！！！！！！！！！！！！！！！");
--		configRowData.actionType = 7;
--		configRowData.actionExtra = 1;
--		return true;
--	end

--	if IsNilOrEmpty(configRowData.actionExtra) then
--		error("error:特效/动作ID 没有配！！！！！！！！！！！！！！！！！！！！！！！！");
--		configRowData.actionType = 7;
--		configRowData.actionExtra = 1;
--		return true;
--	end	

--	if (not IsNilOrEmpty(configRowData.actionMasterType) and tonumber(configRowData.actionMasterType) ~= 0) and (IsNilOrEmpty(configRowData.actionMaster)) then
--		error("error:行为主体类型为非空时，行为主体不可为空");
--		configRowData.actionType = 7;
--		configRowData.actionExtra = 1;
--		return true;
--	end	

--	if (not IsNilOrEmpty(configRowData.startPositionType) and tonumber(configRowData.startPositionType) ~= 0) and IsNilOrEmpty(configRowData.startPosition) then
--		error("error:位置类型非空时，位置不可为空");
--		configRowData.actionType = 7;
--		configRowData.actionExtra = 1;
--		return true;
--	end	

--	if (IsNilOrEmpty(configRowData.actionMasterType) or tonumber(configRowData.actionMasterType) == 0) and (not IsNilOrEmpty(configRowData.startPositionType) and tonumber(configRowData.startPositionType) == 1) then
--		error("error:当行为主体类型为空时，位置类型不可以是“相对坐标”，否则报错“该行为无行为主体，相对坐标无法找到”");
--		configRowData.actionType = 7;
--		configRowData.actionExtra = 1;
--		return true;
--	end


	------特效的数据纠错
--	if tonumber(configRowData.actionType) == 1 then

--		if (IsNilOrEmpty(configRowData.actionMasterType) and tonumber(configRowData.actionMasterType) == 0) and not (tonumber(configRowData.startPositionType) == 2 or tonumber(configRowData.startPositionType) == 4) then
--			error("当行为主体类型为空时，开始位置必须为“绝对坐标”或“己方技能布阵配置”，否则报错“特效出现位置异常”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end

--		if (IsNilOrEmpty(configRowData.actionMasterType) and tonumber(configRowData.actionMasterType) == 0) and tonumber(configRowData.startPositionType) == 2 and not (IsNilOrEmpty(configRowData.aimPositionType) or tonumber(configRowData.aimPositionType) == 2) then
--			error("当行为主体类型为空且开始位置为“绝对坐标”时，结束位置必须为“绝对坐标”或空，否则报错“结束位置异常”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	

--		if (IsNilOrEmpty(configRowData.actionMasterType) and tonumber(configRowData.actionMasterType) == 0) and tonumber(configRowData.startPositionType) == 4 and not IsNilOrEmpty(configRowData.aimPositionType) then
--			error("当行为主体类型为空且开始位置为“己方技能布阵配置”时，结束位置必须为空，否则报错“结束位置异常”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end

--		if not (IsNilOrEmpty(configRowData.actionMasterType) or tonumber(configRowData.actionMasterType) == 0) and tonumber(configRowData.startPositionType) ~= 1 then
--			error("当行为主体类型为非空时，开始位置类型必为“相对坐标”，否则报错“特效有行为主体，但无出现位置”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end

--		if not (IsNilOrEmpty(configRowData.actionMasterType) or tonumber(configRowData.actionMasterType) == 0) and tonumber(configRowData.startPositionType) == 4 then 
--			error("当行为类型为非空且开始位置类型为“己方技能布阵配置”时，则报错“特效行为下，行为主体非空时，位置不可设置为己方技能布阵配置”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	
--	end	

	------动作的数据纠错
--	if tonumber(configRowData.actionType) == 2 then
--		if IsNilOrEmpty(configRowData.actionMasterType) or tonumber(configRowData.actionMasterType) == 0 then
--			error("主体类型必填，所有行为主体类型都可填，否则报错“行为类型未填”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end

--		if IsNilOrEmpty(configRowData.actionMaster) then
--			error("行为主体必填，所有行为主体都可填，否则报错“行为主体未填”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	

--		if not IsNilOrEmpty(configRowData.startPositionType) and tonumber(configRowData.startPositionType) ~= 0 then
--			error("开始位置类型必须为空，否则报错“开始位置异常”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end

--		if IsNilOrEmpty(configRowData.aimPositionType) or tonumber(configRowData.aimPositionType) == 0 or (tonumber(configRowData.aimPositionType) ~= 1 and tonumber(configRowData.aimPositionType) ~= 2) then
--			error("结束位置类型必须为“绝对坐标”或“相对坐标”，否则报错“结束位置异常”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	
--	end	

--	--骨骼特效纠错
--	if tonumber(configRowData.actionType) == 3 then
--		if IsNilOrEmpty(configRowData.actionMasterType) or tonumber(configRowData.actionMasterType) == 0 or tonumber(configRowData.actionMasterType) == 1 then

--			error("行为主体类型必填，不可为“群体”或空，否则报错“行为主体类型异常”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	

--		if IsNilOrEmpty(configRowData.actionMaster) or string.find(configRowData.actionMaster , ",") == nil then

--			error("行为主体必填，格式为“英雄ID,骨骼ID”型异常”，否则报错“行为主体异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end

--		if (not IsNilOrEmpty(configRowData.startPositionType) and tonumber(configRowData.startPositionType) ~= 0) 
--		or (not IsNilOrEmpty(configRowData.startPosition)) or (not IsNilOrEmpty(configRowData.aimPositionType) and tonumber(configRowData.aimPositionType) ~= 0) 
--		or (not IsNilOrEmpty(configRowData.aimPosition)) then

--			error("开始位置类型、开始位置、结束位置类型、结束位置均必须为空，否则报错“位置异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end
--	end

--	--人物效果纠错
--	if tonumber(configRowData.actionType) == 4 then
--		if IsNilOrEmpty(configRowData.actionMasterType) or tonumber(configRowData.actionMasterType) == 0 then

--			error("行为主体类型必填，不可为空，否则报错“行为主体类型异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	

--		if IsNilOrEmpty(configRowData.actionMaster) then
--			error("行为主体必填，所有行为主体都可填，否则报错“行为主体未填”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end

--		if (not IsNilOrEmpty(configRowData.startPositionType) and tonumber(configRowData.startPositionType) ~= 0) 
--		or (not IsNilOrEmpty(configRowData.startPosition)) or (not IsNilOrEmpty(configRowData.aimPositionType) and tonumber(configRowData.aimPositionType) ~= 0) 
--		or (not IsNilOrEmpty(configRowData.aimPosition)) then

--			error("开始位置类型、开始位置、结束位置类型、结束位置均必须为空，否则报错“位置异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end
--	end 

--	--控制人物纠错
--	if tonumber(configRowData.actionType) == 5 then

--		if IsNilOrEmpty(configRowData.actionMasterType) or tonumber(configRowData.actionMasterType) == 0 then

--			error("行为主体类型必填，不可为空，否则报错“行为主体类型异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	

--		if IsNilOrEmpty(configRowData.actionMaster) then
--			error("行为主体必填，所有行为主体都可填，否则报错“行为主体未填”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end

--		if (tonumber(configRowData.actionType) == 5 and tonumber(configRowData.actionExtra) == 1) 
--			and ((IsNilOrEmpty(configRowData.startPositionType) or tonumber(configRowData.startPositionType) == 0)
--			or IsNilOrEmpty(configRowData.startPosition))
--			then
--			error("当特效/动作ID为“复制人物”时，开始位置类型与开始位置必填，否则报错“开始位置异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	

--		if (tonumber(configRowData.actionType) == 5 and tonumber(configRowData.actionExtra) == 1) 
--			and not ((IsNilOrEmpty(configRowData.aimPositionType) or tonumber(configRowData.aimPositionType) == 0))
--			then
--			error("当特效/动作ID为“复制人物”时，结束位置类型必空，否则报错“结束位置异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end

--		if (tonumber(configRowData.actionType) == 5 and tonumber(configRowData.actionExtra) == 1 and tonumber(configRowData.actionMasterType) == 1) and
--		 	(tonumber(configRowData.startPositionType) ~= 1 and tonumber(configRowData.startPositionType) ~= 3)
--			then
--			error("当特效/动作ID为“复制人物”且行为主体类型为“群体”时，开始位置类型可填“相对坐标”或“己方技能布阵配置”，否则报错“开始位置异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	

--		if (tonumber(configRowData.actionType) == 5 and tonumber(configRowData.actionExtra) == 1 and tonumber(configRowData.actionMasterType) ~= 1) and
--			(tonumber(configRowData.startPositionType) ~= 1 and tonumber(configRowData.startPositionType) ~= 2)
--			then
--			error("当特效动作ID为“复制人物”且行为主体类型不为“群体”时，开始位置类型可填“相对坐标”或“绝对坐标”，否则报错“开始位置异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	

--		if (tonumber(configRowData.actionType) == 5 and tonumber(configRowData.actionExtra) == 2) and
--			(
--			 not (IsNilOrEmpty(configRowData.startPositionType) or tonumber(configRowData.startPositionType) == 0)
--			 or
--			 not (IsNilOrEmpty(configRowData.aimtPositionType) or tonumber(configRowData.aimtPositionType) == 0)
--			 or 
--			 not IsNilOrEmpty(configRowData.startPosition)
--			 or 
--			 not IsNilOrEmpty(configRowData.aimPosition)
--			) then

--			error("当特效/动作ID为“删除人物”时，开始位置类型、开始位置、结束位置类型、结束位置均必须为空，否则报错“位置异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	
--	end	

--	--伤害飘字纠错
--	if tonumber(configRowData.actionType) == 6 then

--		if not IsNilOrEmpty(configRowData.actionMasterType) and tonumber(configRowData.actionMasterType) ~= 0 then
--			error("行为主体类型必空，否则报错“行为主体类型异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end

--		if not IsNilOrEmpty(configRowData.actionMaster) then
--			error("行为主体必空，否则报错“行为主体异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end


--		if IsNilOrEmpty(configRowData.startPositionType) or IsNilOrEmpty(configRowData.startPosition) or tonumber(configRowData.startPositionType) == 0 or tonumber(configRowData.startPositionType) ~= 2 then
--				error("开始位置类型与开始位置必填，且必须为“绝对坐标”，否则报错“开始位置异常”");
--				configRowData.actionType = 7;
--				configRowData.actionExtra = 1;
--				return true;

--		end	

--		if not (IsNilOrEmpty(configRowData.aimPositionType) or tonumber(configRowData.aimPositionType) == 0 or tonumber(configRowData.aimPositionType) == 2) then
--			error("结束位置类型可填“绝对坐标”或空，否则报错“开始位置异常”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	
--	end	

--	--特殊纠错
--	if tonumber(configRowData.actionType) == 7 then

--		if (not IsNilOrEmpty(configRowData.actionMasterType) and tonumber(configRowData.actionMasterType) ~= 0)
--		or (not IsNilOrEmpty(configRowData.actionMaster)) then
--			error("行为主体类型、行为主体必空，否则报错“行为主体类型异常”");
--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end	

--		if (not IsNilOrEmpty(configRowData.startPositionType) and tonumber(configRowData.startPositionType) ~= 0) 
--		or (not IsNilOrEmpty(configRowData.startPosition)) or (not IsNilOrEmpty(configRowData.aimPositionType) and tonumber(configRowData.aimPositionType) ~= 0) 
--		or (not IsNilOrEmpty(configRowData.aimPosition)) then

--			error("开始位置类型、开始位置、结束位置类型、结束位置均必须为空，否则报错“位置异常”");

--			configRowData.actionType = 7;
--			configRowData.actionExtra = 1;
--			return true;
--		end
--	end	

--	if IsNilOrEmpty(configRowData.startTime) then
--		error("开始时间 没有配！！！！！！！！！！！！！！！！！！！！！！！！");
--		return false;
--	end	

--	if IsNilOrEmpty(configRowData.lastTime) then
--		error("持续时间 没有配！！！！！！！！！！！！！！！！！！！！！！！！");
--		return false;
--	end	

	return true;
end	

