--[[
-- Desc: սͼ
-- Author: kenny
-- Date: 2016
--]]
FightView = class(BaseView)

function FightView:ctor(o)
end

function FightView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.heroTotalHP = 0
	self.heroCurHP = 0
	self.enemyTotalHP = 0
	self.enemyCurHP = 0
	self:initPanel()

	if AudioConst.GetBgmName() ~= "fight" then
		SimpleAudio.StopMusic(doNthFunc)
		SimpleAudio.PlayMusic("fight")
		AudioConst.SetBgmName("fight")
	end
end

function FightView:Start(data)
	self:initData(data)
end

function FightView:initPanel()
--	self.sceneBg = Object.Instantiate(Util.LoadPrefab("Scenes/Scene02"))
--	self.sceneBg.transform.parent = self.root.transform
--	self.sceneBg.transform.localPosition = Vector3(0, 0, 0)
--	self.sceneBg.transform.localRotation = Quaternion.identity
--	self.sceneBg.transform.localScale = Vector3.one
 	self.top = GetPathComponent(self.transform, "Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
		
-- 	local bg = GetPathComponent(self.sceneBg.transform, "Center/Background", "UISprite")
-- 	bg:SetDimensions(ViewManager.realWidth, ViewManager.realHeight)
 	self.readyGo = GetGameObject(self.transform, "Top/Panel/ReadyGo")
	self.btnBack = GetGameObject(self.transform, "Bottom/Panel/BtnBack")
	self.heroInfo = GetPathComponent(self.transform, "Top/Panel/HeroInfo", "UIWidget")
 	self.heroName = GetPathComponent(self.heroInfo.transform, "RoleName", "UILabel")
 	self.heroHpBar = GetPathComponent(self.heroInfo.transform, "hpBar", "UISlider")
 	self.heroPower = GetPathComponent(self.heroInfo.transform, "hpBar/power", "UILabel")
	self.heroAtkNum = GetPathComponent(self.heroInfo.transform, "atkNum", "UILabel")
	self.heroDefNum = GetPathComponent(self.heroInfo.transform, "defNum", "UILabel")
	self.heroDodgeNum = GetPathComponent(self.heroInfo.transform, "dodgeNum", "UILabel")
	self.heroKingNum = GetPathComponent(self.heroInfo.transform, "kingNum", "UILabel")

	self.enemyInfo = GetPathComponent(self.transform, "Top/Panel/EnemyInfo", "UIWidget")
 	self.enemyName = GetPathComponent(self.enemyInfo.transform, "RoleName", "UILabel")
 	self.enemyHpBar = GetPathComponent(self.enemyInfo.transform, "hpBar", "UISlider")
 	self.enemyPower = GetPathComponent(self.enemyInfo.transform, "hpBar/power", "UILabel")
	self.enemyAtkNum = GetPathComponent(self.enemyInfo.transform, "atkNum", "UILabel")
	self.enemyDefNum = GetPathComponent(self.enemyInfo.transform, "defNum", "UILabel")
	self.enemyDodgeNum = GetPathComponent(self.enemyInfo.transform, "dodgeNum", "UILabel")
	self.enemyKingNum = GetPathComponent(self.enemyInfo.transform, "kingNum", "UILabel")
	
 	self.roundInfo = GetPathComponent(self.transform, "Top/Panel/RoundInfo", "UIWidget")
	self.roundNum = GetPathComponent(self.roundInfo.transform, "RoundNum/Word", "MeshWord")
	self.gateTitle = GetPathComponent(self.roundInfo.transform, "GateTitle", "UILabel")
		
-- 	self.bottom = GetPathComponent(self.transform, "Bottom", "UIWidget")
--	self.heroInfo:SetAnchor(self.root.transform)
--	self.enemyInfo:SetAnchor(self.root.transform)
--	self.roundInfo:SetAnchor(self.root.transform)
--	self.bottom:SetAnchor(self.root.transform)

    local function doClick(obj)
		if obj == self.btnBack then
			ModuleManager.GetCtrl(ModuleName.FIGHT).gameOver()
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)

    if (PlayerData.guideNotEnd()) then
        self.btnBack:SetActive(false);
    else
        self.btnBack:SetActive(true);
    end
end

function FightView:updateRound(round)
	local str = tostring(round)
	if round < 10 then
		str = '0'..str
	end
	self.roundNum.text = str
end

function FightView:updateHP(teamSide, hertNum, extra)
	teamSide = tonumber(teamSide)
	hertNum = math.abs(tonumber(hertNum)) or 0
	extra = tonumber(extra)
--	plog("[updateHP] teamSide = %d, hertNum = %d, extra = %d", teamSide, hertNum, extra)
	if teamSide == TeamSide.Left then
		if extra == FightNumExtra.Retrieve then
			self.heroCurHP = self.heroCurHP + hertNum
		else
			self.heroCurHP = self.heroCurHP - hertNum
		end
		if self.heroCurHP < 0 then
			self.heroCurHP = 0
		end
--		if self.heroCurHP > self.heroTotalHP then
--			self.heroCurHP = self.heroTotalHP
--		end
		self.heroHpBar.value = self.heroCurHP/self.heroTotalHP
		self.heroPower.text = self.heroCurHP
	else
		if extra == FightNumExtra.Retrieve then
			self.enemyCurHP = self.enemyCurHP + hertNum
		else
			self.enemyCurHP = self.enemyCurHP - hertNum
		end
		if self.enemyCurHP < 0 then
			self.enemyCurHP = 0
		end
--		if self.enemyCurHP > self.enemyTotalHP then
--			self.enemyCurHP = self.enemyTotalHP
--		end
		self.enemyHpBar.value = self.enemyCurHP/self.enemyTotalHP
		self.enemyPower.text = self.enemyCurHP
	end
--	plog("self.heroTotalHP = %d" , self.heroTotalHP)
--	plog("self.enemyTotalHP = %d" , self.enemyTotalHP)
--	plog("self.heroCurHP = %d" , self.heroCurHP)
--	plog("self.enemyCurHP = %d" , self.enemyCurHP)
--	plog("self.heroHpBar.value = %d" , self.heroHpBar.value)
--	plog("self.enemyHpBar.value = %d" , self.enemyHpBar.value)
end

function FightView:initData(battleData)
	if IsEmpty(battleData) then return end
	self.gateTitle.text = FBData.GetCurGateTitle(FBData.GetCurGateId())
	self.heroName.text = battleData.homeTeam.teamName
	self.heroHpBar.value = 1
	self.heroAtkNum.text = battleData.homeTeam.teamAbility.xg
	self.heroDefNum.text = battleData.homeTeam.teamAbility.fy
	self.heroDodgeNum.text = battleData.homeTeam.teamAbility.sb
	self.heroKingNum.text = battleData.homeTeam.teamAbility.wz
	
	self.enemyName.text = battleData.awayTeam.teamName
	self.enemyHpBar.value = 1
	self.enemyAtkNum.text = battleData.awayTeam.teamAbility.xg
	self.enemyDefNum.text = battleData.awayTeam.teamAbility.fy
	self.enemyDodgeNum.text = battleData.awayTeam.teamAbility.sb
	self.enemyKingNum.text = battleData.awayTeam.teamAbility.wz

	self.heroTotalHP = battleData.homeTeam.teamAbility.power
	self.heroCurHP = self.heroTotalHP
	self.enemyTotalHP = battleData.awayTeam.teamAbility.power
	self.enemyCurHP = self.enemyTotalHP

	self.heroPower.text = self.heroCurHP
	self.enemyPower.text = self.enemyCurHP
end
