require "Game/FightCamp/View/FightCampView"
 
FightCampControler = {}

local this = FightCampControler
this.preModuleName = nil;

function FightCampControler.New()
	return this
end

function FightCampControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = FightCampView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()

--	UpdateHelper.addUpdate(this.Update)
end

function FightCampControler.Awake()
end

function FightCampControler.Start()
	this.view:Start()
end

function FightCampControler.Update()
	this.view.Update()
end

function FightCampControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.view:OnDestroy()
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function FightCampControler.initListener()
end

function FightCampControler.listNotificationInterests()
    local list = {MVCConst.HERO_CHANGE}
    return unpack(list)
end

function FightCampControler.handleNotification(notification)
--    local notifyName = notification:getName()
--    local notifyBody = notification:getBody()
--	if notifyName == MVCConst.ON_OPENED_MODULE then
--	end
end

function FightCampControler.accept(data)
	ViewUtil.initData(this, data)
end

function FightCampControler.changeHero(heroClass, extra)
	this.view:changeHero(heroClass, extra)
end

function FightCampControler.reqCallback(session)
	local serviceId = tonumber(session.serviceId)
	plog("[ReqCallback] serviceId = %d", serviceId)
	if serviceId == ServerID.CampConfirm then
--		local mo = GetProtoTable("TeamHeroIndexData", session)
--		plog(">>>>>>>>>>>>>>index = %d", mo.index)
	--self.herosMap
	end
end

-- 通知后台选择英雄页, 无回包
function FightCampControler.notifyCampSelect(pageId)
--	plog("通知后台阵容页 = %d", pageId)
	Network.SendMoData(ServerID.CampSelectPage, {pageId})
end

function FightCampControler.notifyCampConfirm(onlyIds)
	Network.SendMoData(ServerID.CampConfirm, {onlyIds}, this.reqCallback)
end

--[[
    设置之前模块名
    _name string 
]]
function FightCampControler.setPreModuleName (_name)
    this.preModuleName = _name;
end