
FightCampView = class(BaseView)

local s_adjusting = false
local badgeInfo = {{1, 0, 0, 0, 6000000}, {1, 1, 0, 0, 9000000}, {1, 1, 1, 0, 15000000}, {1, 1, 1, 1, 21000000}, {2, 1, 1, 1, 24000000}, {2, 2, 1, 1, 30000000}, {2, 2, 2, 1, 45000000}, {2, 2, 2, 2, 60000000}, {3, 2, 2, 2, 90000000}, {3, 2, 2, 3, 0}}

function FightCampView:ctor()
end

function FightCampView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.herosData = Config.getHerosData()
	self.skillsData = Config.getSkillsData()
	self.skillAmount = 0
	self.curSkillIds = {}
	self.pageViews = nil
	self.pageObjList = {}
	self.scvObjList = {}
	self.maxPageNum = 5
	-- self.maxPlaceNum = 25
	self.maxPlaceNum = tonumber(GameCfgDataProxy.getGameCfgDataByKey("Hero_Count_"..(FBData.GetLastChapterId() + 100))) or 5 --后面需要根据是否购买月卡调整 by iorinie
	self.unlockLbl = GameCfgDataProxy.getGameCfgUnlockByKey("Hero_Count_"..(FBData.GetLastChapterId() + 100))
	self.prePageId = 1
	self.curPageId = 1
	self.curPlaceId = 0
	self.selectedHero = nil
	self.herosMap = Map.new()
	self.herosAmount = {0, 0, 0, 0, 0}
	self.herosPositions = {}
	self.heroObjs = {{}, {}, {}, {}, {}}
	self.heroClasses = {{}, {}, {}, {}, {}}
	self.startDragId = nil
	self.endDragId = nil
	s_adjusting = false
	self:initPanel()
	self:initData()
end

function FightCampView:OnFocus()
	self.curPageId = TeamData.GetCurPageIndex()
	local lastModule = ViewUtil.getLastModule(self.name)
	if lastModule == ModuleName.HC and s_adjusting then
		self:showAdjustingView(true)
	else
		s_adjusting = false
		self:showAdjustingView(false)
	end
    
	self.fightValue.text = tostring(LogicUtil.getShowNum(TeamData.GetPower()))
	local scvObj = self.scvObjList[self.curPageId]
	if scvObj ~= nil and self.herosAmount[self.curPageId] <= 15 then
		ResetScrollView(scvObj)
	end
	self:updateHerosPropValue()
end

function FightCampView:Start()
end

function FightCampView:LostFocus()
	if s_adjusting then
		self:showAdjustingView(false)
		self:resetHero()
		self:confirm()
	end
	self:resetSelectedHero()
end

function FightCampView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
		
	local topPath = "Mode/Top/Panel"
 	self.fightValue = GetPathComponent(self.transform, topPath.."/FightValue", "MeshWord")

	local centerPath = "Mode/Center/Panel"
	self.centerObj = GetGameObject(self.transform, centerPath)
	self.valueObj = GetGameObject(self.transform, "Mode/Center")
		
	local bottomPath = "Mode/Bottom/Panel"
 	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")
    self.btnAdjustContainer = GetGameObject(self.transform, bottomPath.."/BtnAdjustContainer");
 	self.btnAdjust = GetGameObject(self.transform, bottomPath.."/BtnAdjustContainer/BtnAdjust")
 	self.btnChange = GetGameObject(self.transform, bottomPath.."/BtnChange")
 	self.btnDown = GetGameObject(self.transform, bottomPath.."/BtnDown")
    self.btnConfirmContainer = GetGameObject(self.transform, bottomPath.."/BtnConfirmContainer");
 	self.btnConfirm = GetGameObject(self.transform, bottomPath.."/BtnConfirmContainer/BtnConfirm")
	self.btnAdjustContainer:SetActive(true)
	self.btnChange:SetActive(false)
	self.btnDown:SetActive(false)
	self.btnConfirmContainer:SetActive(false)

	self.btnUpgrade = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/btnUpgrade")
	self.btnIntensify = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/btnIntensify")
	self.btnSkills = {}
	self.btnSkills[1] = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/Skill1")
	self.btnSkills[2] = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/Skill2")
	self.btnSkills[3] = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/Skill3")
	self.btnSkills[4] = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/Skill4")
	self.btnSkills[5] = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/Skill5")
	self.sprSkills = {}
	for i = 1, 5 do
		self.sprSkills[i] = GetComponent(self.btnSkills[i].transform, "UIButton")
		self.sprSkills[i].normalSprite = "alpha"
	end
	
	self.probNum = GetPathComponent(self.transform, bottomPath.."/PropBG/SkillProb/ProbNum", "UILabel")
	self.probProgress = GetPathComponent(self.transform, bottomPath.."/PropBG/SkillProb", "UIProgressBar")
	self.probNum.text = "0%"
	self.probProgress.value = 0
	
	self.prop = {}
	for i = 1, 4 do
		self.prop[i] = GetPathComponent(self.transform, bottomPath.."/PropBG/Prop"..i, "UILabel")
		self.prop[i].text = 0
	end

	local pointPath = bottomPath.."/PropBG/PagePoints"
	self.pagePoint = GetGameObject(self.transform, pointPath.."/Point")
	self.pagePoints = {}
	for i = 1, self.maxPageNum do
		self.pagePoints[i] = GetGameObject(self.transform, pointPath.."/Point"..i)
	end
	HangObject(self.pagePoint, self.pagePoints[self.curPageId])

	self.skillTitle = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroSkill", "UILabel")
	self.skillHead = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroSkill/Title", "UILabel")
	self.heroName = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroName", "UILabel")
	self.heroLvl = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroLvl", "UILabel")
	self.heroWiseup = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroWiseup", "UILabel")
	self.heroIntensify = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroIntensify", "UILabel")
	self.heroFightValue = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroFightValue", "UILabel")

	self.propAtk = GetPathComponent(self.transform, bottomPath.."/PropBG/Prop1", "UILabel")
	self.propDef = GetPathComponent(self.transform, bottomPath.."/PropBG/Prop2", "UILabel")
	self.propDodge = GetPathComponent(self.transform, bottomPath.."/PropBG/Prop3", "UILabel")
	self.propKing = GetPathComponent(self.transform, bottomPath.."/PropBG/Prop4", "UILabel")

	self.descContent = GetPathComponent(self.transform, bottomPath.."/Description/Content", "UILabel")
	self.descProp1 = GetPathComponent(self.transform, bottomPath.."/Description/Prop1", "UILabel")
	self.descProp2 = GetPathComponent(self.transform, bottomPath.."/Description/Prop2", "UILabel")
	self.descProp3 = GetPathComponent(self.transform, bottomPath.."/Description/Prop3", "UILabel")
	self.descProp4 = GetPathComponent(self.transform, bottomPath.."/Description/Prop4", "UILabel")
	
	self.heroName.text = "0"
	self.heroLvl.text = ""..0
	self.heroWiseup.text = "0"
	self.heroIntensify.text = "0"
	self.heroFightValue.text = "0"

	self.skillTitle.text = "无"
	self.descContent.text = " "
	self.descProp1.text = "0"
	self.descProp2.text = "0"
	self.descProp3.text = "0"
	self.descProp4.text = "0"
	
    local function doClick(obj)
		if obj == self.btnBack then -- 返回
            local ctl = ModuleManager.GetCtrl(ModuleName.FC);
			if s_adjusting then
				self:showAdjustingView(false)
				self:confirm()
			end
            if (nil == ctl.preModuleName or "" == ctl.preModuleName or not IsMember(ctl.preModuleName, ModuleName)) then
                ViewUtil.openView(ModuleName.HERO);
            else
                ViewUtil.openView(ctl.preModuleName);
                ctl.preModuleName = nil;
            end

            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end

		elseif obj == self.btnAdjust then -- 调整英雄
			s_adjusting = true
			self:showAdjustingView(true)
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {[2] = TeamData.GetCurPageIndex()});
            end

		elseif obj == self.btnChange then -- 更换英雄
			if self.selectedHero ~= nil then
				local tbl = self.heroClasses[self.curPageId][self.curPlaceId]
				if tbl.heroId and tonumber(tbl.heroId) <= TeamData.maxRoleHeroId then
					ViewUtil.showMsg("主角不能更换")
					return
				end
				ViewUtil.openView(ModuleName.HC, true, function()
					local ctrl = ModuleManager.GetCtrl(ModuleName.HC)
					local onlyIds = self:getHeroOnlyIds(self.curPageId)
--					ctrl.view:showHeros(onlyIds)
					ctrl.view:addExtra({flag = 0})
				end)
			else
				ViewUtil.showMsg("未选中英雄")
			end

		elseif obj == self.btnDown then -- 下阵
			if self.selectedHero ~= nil then
				local tbl = self.heroClasses[self.curPageId][self.curPlaceId]
				if tbl.heroId and tonumber(tbl.heroId) <= TeamData.maxRoleHeroId then
					ViewUtil.showMsg("主角不能下阵")
					return
				end

				DestroyObject(self.selectedHero)
				TeamData.DelCampOnlyId(self.curPageId, tbl.onlyId)
				self.heroObjs[self.curPageId][self.curPlaceId] = nil
				self.heroClasses[self.curPageId][self.curPlaceId] = nil
				self:moveForward()
				self:resetSelectedHero()
				self:recountHeroAmount()
				self:updateOnlyIds()
				self:checkInstead()
				self:confirm()
			else
				ViewUtil.showMsg("未选中英雄")
			end

		elseif obj == self.btnConfirm then -- 确认
			s_adjusting = false
			self:showAdjustingView(false)
			self:confirm()
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end

		elseif obj == self.btnUpgrade then -- 升级
			-- 直接传方法执行会有一部分变量没赋值，导致显示异常？原因未确定 by iorinie
			ViewUtil.openView(ModuleName.HU, false, function(args)
			end)

		elseif obj == self.btnIntensify then -- 强化
			ViewUtil.openView(ModuleName.HU, false, function(args)
				local ctrl = ModuleManager.GetCtrl(ModuleName.HU)
				ctrl.slideTab(2)
			end)
		end
    end
	ViewUtil.AddClickEvent(self.btnUpgrade, doClick)
	ViewUtil.AddClickEvent(self.btnIntensify, doClick)
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnAdjust, doClick)
	ViewUtil.AddClickEvent(self.btnChange, doClick)
	ViewUtil.AddClickEvent(self.btnDown, doClick)
	ViewUtil.AddClickEvent(self.btnConfirm, doClick)
	
    local function doClickSkills(obj)
		local function _selected(index)
			if index <= self.skillAmount then
				self:selectSkillBoard(obj)
				local skillId = self.curSkillIds[index]
				local skillInfo = self.skillsData[tostring(skillId)]
				self.skillTitle.text = skillInfo[g_skills_file_title] or "无"
				self.descContent.text = skillInfo.description
				local heroIds = split(skillInfo[g_skills_hero_id], ":")
				if #heroIds > 1 then
					self.skillHead.text = "合体技"
				else
					self.skillHead.text = "个人技"
				end
			end
		end
		for i = 1, 5 do
			if obj == 	self.btnSkills[i] then
				_selected(i)
			end
		end
	end
	local function onPressSkills(tbl)
		if IsEmpty(tbl) then return end
		local go = tbl.obj
		local isPress = tbl.isPress
		local skillId = self.curSkillIds[tbl.idx]
        ViewUtil.showSkillTipsEvent(go, isPress, skillId)
		ViewUtil.showHerosTips(go, skillId, isPress)
	end
	for i, btn in pairs(	self.btnSkills) do
		UIEventListener.Get(btn).onPress = doClickSkills
		ViewUtil.AddEventTrigger(btn, EventConst.onPress, onPressSkills, {isPress = true, obj = btn, idx = i})
		ViewUtil.AddEventTrigger(btn, EventConst.onRelease, onPressSkills, {isPress = false, obj = btn, idx = i})
	end
	
	self:initPageViews()
end

function FightCampView:getEmptyPlaceId()
	local objs = self.heroObjs[self.curPageId]
	for i = 1, self.maxPlaceNum do
		local obj = objs[i]
		if obj ~= nil and obj.name ~= nil and obj.name == "NoName" then
			return i
		end
	end
	return nil
end

function FightCampView:checkInstead()
	for i = 1, self.maxPlaceNum do
		local curPlaceId = i
		local placeObj = self:getPlaceObj(self.curPageId, curPlaceId)
		local children = ObtainChildren(placeObj)
		if IsEmpty(children) then
			local placeObj = self:getPlaceObj(self.curPageId, curPlaceId)
			local heroClass = HeroClass.new()
			heroClass:init(nil, curPlaceId)
			local hero = heroClass:createHeroInstead() -- 可上阵
			local function _onClick(obj)
				self:onClickInstead(obj, heroClass)
			end
			local function _onPress(obj)
				self:resetSelectedHero()
			end
			ViewUtil.AddClickEvent(hero, _onClick)
			UIEventListener.Get(hero).onPress = _onPress
			HangObject(hero, placeObj)
			self.heroObjs[self.curPageId][curPlaceId] = hero
			self.heroClasses[self.curPageId][curPlaceId] = heroClass
			self:addEventTriggers(hero, heroClass)
		end
	end
end

function FightCampView:moveForward()
	local objs = self.heroObjs[self.curPageId]
	local clses = self.heroClasses[self.curPageId]
	for i = self.curPlaceId + 1, self.maxPlaceNum do
		local obj = objs[i]
		local cls = clses[i]
		if IsAHero(obj) then
				local pid = i - 1
				local dest = objs[pid]
				local cls2 = clses[pid]
				if not IsAHero(dest) then
					local placeObj = self:getPlaceObj(self.curPageId, pid)
					DestroyChildren(placeObj)
					objs[pid] = obj
					clses[pid] = cls
					objs[i] = nil
					clses[i] = nil
					
					local heroClass = self.heroClasses[self.curPageId][pid]
					heroClass:setPlaceId(pid)
					HangObject(obj, placeObj)
				end
		end
	end
	return nil
end

-- 检查是否存在新英雄
function FightCampView:checkHeros() --这个方法应该是没有在用了 by iorinie
	self:updateGridHeros()

	for pid = 1, 5 do
		local myHeros = TeamData.GetHerosByIndex(pid)
		local scvObj = self.scvObjList[pid]
		local gridObj = GetGameObject(scvObj.transform, "Panel/Grid")
		local tran = gridObj.transform
		gridObj:SetActive(false)

		for i = tran.childCount - 1, 0, -1 do
			local placeObj = tran:GetChild(i)
			local children = ObtainChildren(placeObj)
			local child = children[1]
			if child ~= nil then
				local obj = child.gameObject
				if IsAHero(obj) then
					local lb = GetComponent(obj.transform, "LuaBehaviour")
					if lb then
						local heroClass = lb.sourceLuaObj
						local onlyId = heroClass.onlyId
						local placeId = heroClass.placeId
						local isMine = false

						for j = 1, #myHeros do
							local mine = myHeros[j]
							if tostring(onlyId) == tostring(mine.id) then
								isMine = true
								break
							end
						end
						if not isMine then
							self:createInsteadHero(pid, i+1)
							self.herosAmount[pid] = self.herosAmount[pid] - 1
							DestroyObject(obj)
						end
					end
				end
			end
		end

		for m = 1, #myHeros do
			local src = myHeros[m]
			local isExist = false
			for n = tran.childCount - 1, 0, -1 do
				local placeObj = tran:GetChild(n)
				local children = ObtainChildren(placeObj)
				local child = children[1]
				if child ~= nil then
					local obj = child.gameObject
					if IsAHero(obj) then
						local lb = GetComponent(obj.transform, "LuaBehaviour")
						local heroClass = lb.sourceLuaObj
						local onlyId = heroClass.onlyId
						if tostring(onlyId) == tostring(src.id) then
							isExist = true
							break
						end
					end
				end
			end
			if not isExist then
				for i = 0, tran.childCount - 1 do
					local placeObj = tran:GetChild(i)
					local children = ObtainChildren(placeObj)
					local child = children[1]
					if child ~= nil then
						local obj = child.gameObject
						if not IsAHero(obj) then
							DestroyChildren(placeObj)

							local data = src
							local heroClass = HeroClass.new()
							heroClass:init(data, i)
							local hero = heroClass:createHero()
							ViewUtil.addDragScrollView(hero, self.scvPage)
							local function _onClick(obj)
								self:doClickHero(obj, heroClass)
							end
							ViewUtil.AddClickEvent(hero, _onClick)
							self:addEventTriggers(hero, heroClass)
			
							HangObject(hero, placeObj)
							self.heroObjs[pid][i+1] = hero
							self.heroClasses[pid][i+1] = heroClass
							break
						end
					end
				end
			end
		end
		
		gridObj:SetActive(true)
	end
end

function FightCampView:updateGridHeros(heroClass) --这个方法应该是没有在用了 by iorinie
	for pageId = 1, #self.pageObjList do
		local pageObj = self.pageObjList[pageId]
		for i = 1, self.maxPlaceNum do
			local placeObj = self:getPlaceObj(pageId, i)
			local children = ObtainChildren(placeObj)
			local child = children[1]
			if child ~= nil then
					local hero = self.heroClasses[pageId][i]
					if IsEmptyTable(heroClass) then
						hero:refresh()
					else
						if tostring(hero.onlyId) == tostring(heroClass.onlyId) then
							hero:init(heroClass, i)
							hero:refreshHero()
							break
						end
				end
			end
		end
	end
end

function FightCampView:scrollCB()
	if not s_adjusting then
		-- 重新置顶
		local scvObj = self.scvObjList[self.curPageId]
		if scvObj ~= nil then
			ResetScrollView(scvObj)
		end
	end

	self:resetSelectedHero()
	TeamData.SetCurPageIndex(self.curPageId)
	self:initHerosPos()
	self:updateHerosPropValue()
end

function FightCampView:initPageViews()
	self.pageViews = CreateObject(Util.LoadPrefab("UI/PageViews", AssetBundleInfo.assetBundles))
	if not self.pageViews then return end
	ViewUtil.sortLayerOrder(self.pageViews, LayerName.UI)
	HangObject(self.pageViews, self.centerObj)

	local scrollPanel = GetGameObject(self.pageViews.transform, "ScrollPanel")
	ViewUtil.adaptUISize(scrollPanel, true, 30, 400, 0, 0)
	self.scvPage = GetComponent(scrollPanel.transform, "UIScrollView")

	local tablePath = "ScrollPanel/GridTable"
	local gridTable = GetPathComponent(self.pageViews.transform, tablePath, "UIGrid")
	gridTable:Reposition()

	self.centerOnChild = GetComponent(gridTable.transform, "UICenterOnChild")
	local function _onCenterCB(args) -- 翻页回调
		local pageId = self:getPageId(self.centerOnChild.centeredObject)
		if pageId and pageId ~= self.curPageId then
			self.curPageId = pageId
			HangObject(self.pagePoint, self.pagePoints[self.curPageId])
			self:scrollCB()
		end
	end
	self.centerOnChild.onFinished = DelegateFactory.SpringPanel_OnFinished(_onCenterCB, {})
	
	local function _callback(args)
		local event = args.eventType
		if event == EventConst.onPress then
			self.prePageId = self:getPageId(self.centerOnChild.centeredObject)
			self:resetSelectedHero()
		end
	end

	local function _onDragStart(tbl)
		if s_adjusting and not IsAHero(tbl.obj) then return end
		self:startDragDirection()
	end
	local function _onDragEnd(tbl)
		self:initHerosPos()
		if s_adjusting and not IsAHero(tbl.obj) then return end
		self:endDragDirection()
	end

	for i = 1, self.maxPageNum do
		local pageObj = GetGameObject(self.pageViews.transform, tablePath.."/Page"..i)
		ViewUtil.adaptUISize(pageObj, true, 30, 400, 0, 0)
		self.pageObjList[i] = pageObj

		local scvBG = GetGameObject(pageObj.transform, "ScrollViewBG")
		ViewUtil.adaptUISize(scvBG, false, 30, 400, 16, 16)
		local scvObj = GetGameObject(scvBG.transform, "ScrollView")
		ViewUtil.adaptUISize(scvObj, false, 100, 400, 24, 24)
		self.scvObjList[i] = scvObj
		local gridObj = GetGameObject(scvObj.transform, "Panel/Grid")
		for n = 1, self.maxPlaceNum do
			local placeObj = CreateObject(Util.LoadPrefab("UI/HeroPlace", AssetBundleInfo.assetBundles))
			placeObj.name = "Place"..n
			HangObject(placeObj, gridObj)
		end
		--英雄上限后添加上限提示框 by iorinie
		local hero = CreateObject(Util.LoadPrefab("UI/HeroInstead", AssetBundleInfo.assetBundles))
		hero.name = "NumLimit"
		if self.unlockLbl ~= "" then
			GetPathComponent(hero.transform, "Can", "UILabel").text = self.unlockLbl
		else
			GetPathComponent(hero.transform, "Can", "UILabel").text = "已达上限"
		end
		HangObject(hero, gridObj)
		
		ViewUtil.AddEventTrigger(pageObj, EventConst.onDragStart, _onDragStart, {obj = pageObj})
		ViewUtil.AddEventTrigger(pageObj, EventConst.onDragEnd, _onDragEnd, {obj = pageObj})
		ViewUtil.AddEventTrigger(pageObj, EventConst.onPress, _callback, {eventType=EventConst.onPress, index=i})
	end
end

function FightCampView:startDragDirection()
	if not s_adjusting then
		local isLR, _ = self:GetDirection()
		if isLR then
			self:scrollDragPages(true)
			self:scrollDragHeros(false)
		else
			self:scrollDragPages(false)
			self:scrollDragHeros(true)
		end
	end
end

function FightCampView:endDragDirection()
	local isLR, toLeft = self:GetDirection()
	if not s_adjusting then
		self:scrollDragPages(true)
		self:scrollDragHeros(true)
		if isLR then
			local function _onupdate(luaObj, value)
				if not luaObj.preVal then
					luaObj.preVal = value
				else
					local deltaVal = math.abs(math.abs(value) - math.abs(luaObj.preVal))
					luaObj.preVal = value
					if toLeft then
						self.scrollView:MoveRelative(Vector3.New(-deltaVal, 0, 0))
					else
						self.scrollView:MoveRelative(Vector3.New(deltaVal, 0, 0))
					end
				end
			end
			if not self.isDraging then
				local pageId = self.curPageId
				if toLeft then
					pageId = pageId + 1
				else
					pageId = pageId - 1
				end
				if pageId < 1 or pageId > 5 then
					ViewUtil.showMsg("已滑到边缘")
				elseif pageId >= 1 and pageId <= 5 then
					self.isDraging = true
					local num = 1
					if not toLeft then
						num = -1
					end
					-- 回调通知
					iTween.ValueTo(self.pageViews, iTween.Hash(
						"from", 0,
						"to", 640 * num,
						"time", 0.2,
						"easeType", iTween.EaseType.linear,
						"onupdate", _onupdate,
						"oncomplete", function()
							self.curPageId = pageId
							FightCampControler.notifyCampSelect(self.curPageId)
							HangObject(self.pagePoint, self.pagePoints[self.curPageId])
							self:scrollCB()
							self.preVal = nil
							self.isDraging = false

							-- 默认选中第一个
							self:doClickHero(self.heroObjs[self.curPageId][1], self.heroClasses[self.curPageId][1])
						end,
						"luaobj", self))
				end
			end
		end
	end
end

function FightCampView:GetDirection()
	local isLR = false
	local toLeft = false
	local touch = UICamera.currentTouch
	if touch then
		local delta = touch.totalDelta
		if math.abs(delta.x) > math.abs(delta.y) then
			isLR = true
			if delta.x < 0 then
				toLeft = true
			end
		end
	end
	return isLR, toLeft
end

function FightCampView:addEventTriggers(hero, heroClass)
	local function _onDragStart(tbl)
		if not s_adjusting or not IsAHero(tbl.obj) then return end
		self:startDragDirection()
        self:doClickHero(hero, heroClass)
		self:onDragStart(tbl)
	end
	local function _onDrag(tbl)
		if not s_adjusting or not IsAHero(tbl.obj) then return end
		self:onDrag(tbl)
	end
	local function _onDragEnd(tbl)
		self:initHerosPos()
		if s_adjusting and not IsAHero(tbl.obj) then
			local isLR, _ = self:GetDirection()
			if isLR then
				ViewUtil.showMsg("请退出\"调整阵容\"")
			end
			return
		end
		self:endDragDirection()
		self:onDragEnd(tbl)
	end
	ViewUtil.AddEventTrigger(hero, EventConst.onDragStart, _onDragStart, {obj = hero})
	ViewUtil.AddEventTrigger(hero, EventConst.onDrag, _onDrag, {obj = hero})
	ViewUtil.AddEventTrigger(hero, EventConst.onDragEnd, _onDragEnd, {obj = hero})
end
	
function FightCampView:removeAllHeros()
	for m = 1, self.maxPageNum do
		for n = 1, self.maxPlaceNum do
			local placeObj = self:getPlaceObj(m, n)
			DestroyChildren(placeObj)
		end
	end
end

function FightCampView:initData()
	self:removeAllHeros()
	self.curPageId = TeamData.GetCurPageIndex()
	HangObject(self.pagePoint, self.pagePoints[self.curPageId])
	
	for pid = 1, self.maxPageNum do
		local childPath = "ScrollPanel/GridTable/Page"..pid.."/ScrollViewBG/ScrollView"
		local scvObj = GetGameObject(self.pageViews.transform, childPath)
		local scv = GetPathComponent(self.pageViews.transform, childPath, "UIScrollView")
		local gridChild = GetGameObject(scvObj.transform, "Panel/Grid")
		local herosInfo = TeamData.GetHerosByIndex(pid)
		local count = CountTable(herosInfo)
		if count > 0 then
			self.herosAmount[pid] = count
		end

		for c = 1, count do
			local data = herosInfo[c]
			local heroClass = HeroClass.new()
			heroClass:init(data, c)
			local hero = heroClass:createHero()
			ViewUtil.addDragScrollView(hero, self.scvPage)
			local function _onClick(obj)
				self:doClickHero(obj, heroClass)
			end
			ViewUtil.AddClickEvent(hero, _onClick)
			self:addEventTriggers(hero, heroClass)

			local placeObj = GetGameObject(gridChild.transform, "Place"..heroClass.placeId)
			HangObject(hero, placeObj)
			self.heroObjs[pid][heroClass.placeId] = hero
			self.heroClasses[pid][heroClass.placeId] = heroClass
		end

		local maxHeroPlace = self.maxPlaceNum -- - 1
		if count < maxHeroPlace then
			for n = count + 1, maxHeroPlace do
				self:createInsteadHero(pid, n)
			end
		end
		do
			local onlyIds = self:getHeroOnlyIds(pid)
			TeamData.SetCampByIndex(pid, split(onlyIds, ","))
		end
		do
			local cond = maxHeroPlace + 1
			local placeObj = self:getPlaceObj(pid, cond)
			if placeObj ~= nil then
				local heroClass = HeroClass.new()
				heroClass:init(nil, cond)
				local hero = heroClass:createHeroCond("21-5")
				ViewUtil.addDragScrollView(hero, self.scvPage)
				BindLuaScript(heroClass, hero)
				HangObject(hero, placeObj)
			end
		end
		ResetScrollView(scvObj)
	end

	-- 默认选中第一个
	self:doClickHero(self.heroObjs[self.curPageId][1], self.heroClasses[self.curPageId][1])

	self.scrollView = GetPathComponent(self.pageViews.transform, "ScrollPanel", "UIScrollView")
	self.scrollView:MoveRelative(Vector3.New(-640 * (self.curPageId - 1), 0, 0))
	self.coroutine = DelayCall(function()
		self:initHerosPos()
		self:updateHerosPropValue()
	end, 1.0)
end

function FightCampView:initHerosPos()
	for pid = 1, self.maxPageNum do
		local childPath = "ScrollPanel/GridTable/Page"..pid.."/ScrollViewBG/ScrollView"
		local scvObj = GetGameObject(self.pageViews.transform, childPath)
		local gridChild = GetGameObject(scvObj.transform, "Panel/Grid")
		local poses = {}
		for i = 1, self.maxPlaceNum do
			local placeObj = GetGameObject(gridChild.transform, "Place"..i)
			local pos = Util.WorldToScreen(placeObj.transform.position)
			poses[i] = Vector2.New(pos.x, pos.y)
		end
		self.herosPositions[pid] = poses
	end
end

function FightCampView:onClickInstead(obj, heroClass)
	if not obj then return end
	self.curPlaceId = heroClass.placeId
	ViewUtil.openView(ModuleName.HC, true, function()
		local ctrl = ModuleManager.GetCtrl(ModuleName.HC)
		local onlyIds = self:getHeroOnlyIds(self.curPageId)
		ctrl.view:addExtra({flag = 1})
	end)
    if (PlayerData.guideNotEnd()) then
        Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
    end
end

function FightCampView:createInsteadHero(pid, placeId)
	local placeObj = self:getPlaceObj(pid, placeId)
	local heroClass = HeroClass.new()
	heroClass:init(nil, placeId)
	local hero = heroClass:createHeroInstead() -- 可上阵
	ViewUtil.addDragScrollView(hero, self.scvPage)
	local function _onClick2(obj)
		self:onClickInstead(obj, heroClass)
	end
	local function _onPress(obj)
		self:resetSelectedHero()
	end
	ViewUtil.AddClickEvent(hero, _onClick2)
	UIEventListener.Get(hero).onPress = _onPress
	HangObject(hero, placeObj)

	self.heroObjs[pid][heroClass.placeId] = hero
	self.heroClasses[pid][heroClass.placeId] = heroClass
	self:recountHeroAmount()
	self:addEventTriggers(hero, heroClass)
end

function FightCampView:scrollPageView(pageId)
	if self.scrollView ~= nil then
		local deltaId = pageId - self.curPageId
		if deltaId ~= 0 then
			self.scrollView:MoveAbsolute(Vector3.New(-640 * deltaId, 0, 0))
		end
	end
end

function FightCampView:onDragStart(tbl)
	if not s_adjusting then return end
	local obj = tbl.obj
	if IsEmpty(obj) then return end

	ViewUtil.disableDragScrollView(obj)
	local depth = GetMaxWidgetDepth(self.gameObject) + 1
	SortUIWidgetDepth(obj, depth, false)
end

function FightCampView:onDragEnd(tbl)
	if not s_adjusting then return end
	local obj = tbl.obj
	if IsEmpty(obj) then return end
	if not self.endDragId then return end

	ViewUtil.enableDragScrollView(obj)
	self.curPlaceId = self.endDragId
	local placeObj = self:getPlaceObj(self.curPageId, self.curPlaceId)
	obj.transform.parent = placeObj.transform
	
	iTween.MoveTo(obj, iTween.Hash(
		"position", Vector3.zero,
		"islocal", true,
		"time", 0.2,
		"easeType", iTween.EaseType.linear))

	self.startDragId = nil
	self.endDragId = nil
end

function FightCampView:onDrag(tbl)
	if not s_adjusting then return end

	local obj = tbl.obj
	if IsEmpty(obj) then return end
	local poses = self.herosPositions[self.curPageId]
	if IsEmpty(poses) then return end

	local curPos = UICamera.currentTouch.pos
	obj.transform.position = Util.ScreenToWorld(Vector3.New(curPos.x, curPos.y, 0))
    local heroClass0 = nil;
    for libI = 1, #self.heroObjs[self.curPageId] do
        if (obj == self.heroObjs[self.curPageId][libI]) then
            heroClass0 = self.heroClasses[self.curPageId][libI];
            break ;
        end
    end
	if not self.startDragId then
		self.startDragId = heroClass0:getPlaceId()
		self.endDragId = self.startDragId
	end
	local startDragId = self.startDragId
	local endDragId = self.endDragId
	local minDistance = -1
	local curPos = UICamera.currentTouch.pos
	local count = self.herosAmount[self.curPageId]

	for i, obj in pairs(self.heroObjs[self.curPageId]) do
		if i <= count then
			local distance = math.abs(Vector2.Distance(curPos, poses[i]))
			if obj ~= nil then
				if minDistance == -1 or distance < minDistance then
					minDistance = distance
					endDragId = i
					self.endDragId = i
				end
			end
		end
	end

	if startDragId ~= endDragId then
		local inc = (startDragId < endDragId) and 1 or -1

		for m = startDragId + inc, endDragId, inc do
			local dt = m - inc
			if m ~= startDragId then
				local placeObj = self:getPlaceObj(self.curPageId, dt)
				local heroObj = self.heroObjs[self.curPageId][m]
				if heroObj ~= nil then
					local heroClass = self.heroClasses[self.curPageId][m]
					heroClass:setPlaceId(dt)

					heroObj.transform.parent = placeObj.transform

					ExchangeTable(self.heroObjs[self.curPageId], m, dt)
					ExchangeTable(self.heroClasses[self.curPageId], m, dt)
                    
					iTween.MoveTo(heroObj, iTween.Hash(
						"position", Vector3.zero,
						"islocal", true,
						"time", 0.2,
						"easeType", iTween.EaseType.linear)
					)
				end
			end
		end

		heroClass0:setPlaceId(endDragId)
	end
	self.startDragId = endDragId
end

function FightCampView:updateOnlyIds()
	local onlyIds = self:getHeroOnlyIds(self.curPageId)
	TeamData.SetHeroOnlyIds(self.curPageId, onlyIds)
	TeamData.SetCampByIndex(self.curPageId, split(onlyIds, ","))
	self:updateHerosPropValue()
    
	return onlyIds
end

function FightCampView:confirm()
	local onlyIds = self:updateOnlyIds()
	FightCampControler.notifyCampConfirm(onlyIds)
	self.fightValue.text = tostring(LogicUtil.getShowNum(TeamData.GetPower()))
end

function FightCampView:getPageId(obj)
	if obj ~= nil then
		for i = 1, self.maxPageNum do
			if obj == self.pageObjList[i] then
				return i
			end
		end
	end
	return 1
end

function FightCampView:doClickHero(obj, heroClass)
	if not obj then return end
	self:selectHeroBoard(obj)
    
	self.curPlaceId = heroClass.placeId
    
	if not IsEmpty(heroClass.data) then
		if IsEmptyString(heroClass.heroName) then
			ViewUtil.showMsg("该英雄数据出错!")
			return
		end
        if (1 ~= tonumber(heroClass.heroId) and 2 ~= tonumber(heroClass.heroId)) then
		    self.heroName.text = tostring(heroClass.heroName)
        else
            self.heroName.text = PlayerData.playerData.team.teamName;
        end
		self.heroLvl.text = ""..HeroDataProxy.getHeroShowLvl(heroClass.level, heroClass.wiseup);
		self.heroWiseup.text = tostring(heroClass.wiseup)
		self.heroIntensify.text = tostring(heroClass.strengthen)
		self.heroFightValue.text = HeroDataProxy.getHeroAbility(heroClass.heroId, heroClass.level, heroClass.wiseup, heroClass.strengthen)
		
		local skillIds = split(heroClass.skillIds[1], ":")
		self.skillAmount = #skillIds
		self.curSkillIds = {}
		if self.skillAmount > 0 then
			for i = 1, 5 do
				if i <= #skillIds then
					local skillId = tostring(skillIds[i])
					local skillInfo = self.skillsData[skillId]
					if IsEmpty(skillInfo) then
--						ViewUtil.showMsg(string.format("技能配置出错: %s", skillId))
						error("技能配置出错: %s", skillId)
					else
						self.curSkillIds[i] = skillId
						self.sprSkills[i].normalSprite = skillInfo[g_skills_file_skill_icon]
						if i == 1 then
							self:selectSkillBoard(self.btnSkills[1])
							self.skillTitle.text = skillInfo[g_skills_file_title] or "无"
							self.descContent.text = skillInfo.description
							self.descProp1.text = heroClass.propAtk
							self.descProp2.text = heroClass.propDef
							self.descProp3.text = heroClass.propDodge
							self.descProp4.text = heroClass.propKing
							local heroIds = split(skillInfo[g_skills_hero_id], ":")
							if #heroIds > 1 then
								self.skillHead.text = "合体技"
							else
								self.skillHead.text = "个人技"
							end
						end
					end
				else
					self.sprSkills[i].normalSprite = "alpha"
				end
			end
		else
			self.skillTitle.text = "无"
			self.descContent.text = " "
			self.descProp1.text = "0"
			self.descProp2.text = "0"
			self.descProp3.text = "0"
			self.descProp4.text = "0"
			for i = 1, 5 do
				self.sprSkills[i].normalSprite = "alpha"
			end
			if self.selectBoard2 ~= nil then
				self.selectBoard2:SetActive(false)
			end
		end
	end
end

function FightCampView:shakeHero(play)
	local pageObj = self.pageObjList[self.curPageId]
	local gridObj = GetGameObject(pageObj.transform, "ScrollViewBG/ScrollView/Panel/Grid")
	local anims = GetComponentsInChildren(gridObj.transform, Animation.GetClassType())
	for i = 0, anims.Length - 1 do
		local anim = anims[i]
		if play then
			anim.wrapMode = WrapMode.Loop
		else
			anim.wrapMode = WrapMode.Once
		end
		anim:Play("ShakeHero")
	end
end

function FightCampView:resetHero()
	local pageObj = self.pageObjList[self.curPageId]
	local gridObj = GetGameObject(pageObj.transform, "ScrollViewBG/ScrollView/Panel/Grid")
	local anims = GetComponentsInChildren(gridObj.transform, Animation.GetClassType())
	for i = 0, anims.Length - 1 do
		local anim = anims[i]
		local obj = anim.transform.gameObject
		ResetObject(obj)
	end
end

function FightCampView:getPlaceObj(pageId, placeId)
	local childPath = "ScrollPanel/GridTable/Page"..pageId.."/ScrollViewBG/ScrollView"
	local scvObj = GetGameObject(self.pageViews.transform, childPath)
	local gridChild = GetGameObject(scvObj.transform, "Panel/Grid")
	local placeObj = GetGameObject(gridChild.transform, "Place"..placeId)
	return placeObj
end

function FightCampView:getHeroObj(pageId, placeId)
	local list = self.heroObjs[pageId]
	for i, obj in pairs(list) do
		local hc = self.heroClasses[pageId][i]
		if placeId == hc:getPlaceId() then
			return obj
		end
	end
end

-- 获取阵容唯一ID字串
function FightCampView:getHeroOnlyIds(pageId)
	local onlyIds = ""
	for i = 1, self.maxPlaceNum do
		local placeObj = self:getPlaceObj(pageId, i)
		local tran = placeObj.transform
		for j = 0, tran.childCount - 1 do
			local child = tran:GetChild(j)
			local hc = self.heroClasses[pageId][i]
			if hc and hc.onlyId and tonumber(hc.onlyId) > 0 then
				if IsEmpty(onlyIds) then
					onlyIds = hc.onlyId
				else
					onlyIds = onlyIds..","..hc.onlyId
				end
			end
		end
	end
	return onlyIds
end

function FightCampView:updateHerosPropValue()
	self.fightValue.text = tostring(LogicUtil.getShowNum(TeamData.GetPower()))
    Facade:sendNotification(MVCConst.UPDATE_MNY, 0)

	local propAtk = 0
	local propDef = 0
	local propDodge = 0
	local propKing = 0
	local probNum = 0
	local heroCount = 0
	local countedList = {}
	local skillsList = {}
	for i = 1, self.maxPlaceNum do
		local placeObj = self:getPlaceObj(self.curPageId, i)
		local tran = placeObj.transform
		for j = 0, tran.childCount - 1 do
			local child = tran:GetChild(j)
			local hc = self.heroClasses[self.curPageId][i]
			if hc and hc.onlyId and tonumber(hc.onlyId) > 0 then
				heroCount = heroCount + 1
				propAtk = propAtk + hc.propAtk
				propDef = propDef + hc.propDef
				propDodge = propDodge + hc.propDodge
				propKing = propKing + hc.propKing
				
				local skillIds = split(hc.skillIds[1], ":")
				local amount = #skillIds
				for i = 1, #skillIds do
					local skillId = tostring(skillIds[i])
					local skillInfo = self.skillsData[skillId] or {}
					if IsEmptyTable(skillInfo) then
						error("配置表里无此技能: %s", skillId)
					end
					local skillHeroIds = split(skillInfo[g_skills_hero_id], ":")
					local probability = tonumber(skillInfo.probability) or 0
                    if ("0" == SkillDataProxy.getHeroLimitVal(skillInfo)) then--非条件触发
					    if #skillHeroIds > 1 then -- 合体技
						    local isAllOn = true
						    local _onlyIds = {}
						    for i = 1, #skillHeroIds do
							    local heroId = skillHeroIds[i]
							    local isOn, onlyId = TeamData.IsFightHero(heroId)
							    if not isOn then
								    isAllOn = false
								    break
							    else
								    table.insert(_onlyIds, onlyId)
							    end
						    end
						    local isNoCounted = true
						    if not IsEmptyTable(skillsList[skillId]) then
							    isNoCounted = false
							    for i = 1, #_onlyIds do
								    local onlyId = _onlyIds[i]
								    if not IsMember(onlyId, skillsList[skillId]) then
									    isNoCounted = true
									    break
								    end
							    end
						    end
						    if isAllOn and isNoCounted then
							    if IsEmptyTable(skillsList[skillId]) then skillsList[skillId] = {} end
							    AttachListTable(skillsList[skillId], _onlyIds)

							    if probability > 0 and probability < 10000 then -- 10000是普攻
								    probNum = probNum + probability/10000
							    end
						    end
					    else
						    if probability > 0 and probability < 10000 then -- 10000是普攻
							    probNum = probNum + probability/10000
						    end
					    end
                    end

					if tonumber(skillInfo.effect_id) == 100 then
						local siwei = split(skillInfo.effect_value, ":")
						local xg = tonumber(siwei[1]) or 0
						local wz = tonumber(siwei[2]) or 0
						local sb = tonumber(siwei[3]) or 0
						local fy = tonumber(siwei[4]) or 0
						local skills = skillInfo[g_skills_hero_id]
						local skillHeroIds = split(skills, ":")
						if #skillHeroIds > 1 then -- 合体技
							local isAllOn = true
							for i = 1, #skillHeroIds do
								local heroId = skillHeroIds[i]
								local isOn = TeamData.IsFightHero(heroId)
								if not isOn then
									isAllOn = false
									break
								end
							end
							if isAllOn then
								propAtk = propAtk + xg
								propDef = propDef + fy
								propDodge = propDodge + sb
								propKing = propKing + wz
							end
--						else -- 单体，后台已计入
--							propAtk = propAtk + xg
--							propDef = propDef + fy
--							propDodge = propDodge + sb
--							propKing = propKing + wz
						end
					end
				end
			end
		end
	end
	local badgeLevel = TeamData.GetLeagueBadgeLevel()
	-- local badgeLevel = LeagueData.GetLeagueBadgeLevel()
	if badgeLevel ~= 0 then
		propAtk = propAtk + badgeInfo[badgeLevel][1]
		propDef = propDef + badgeInfo[badgeLevel][2]
		propDodge = propDodge + badgeInfo[badgeLevel][3]
		propKing = propKing + badgeInfo[badgeLevel][4]
	end

	self.propAtk.text = propAtk
	self.propDef.text = propDef
	self.propDodge.text = propDodge
	self.propKing.text = propKing
	
	if probNum < 0 then probNum = 0 end
	if probNum > 1 then probNum = 1 end
	self.probNum.text = tostring(probNum*100).."%"
	self.probProgress.value = probNum
end

function FightCampView:recountHeroAmount()
	local objs = self.heroObjs[self.curPageId]
	local count = 0
	for i = 1, self.maxPlaceNum do
		if IsAHero(objs[i]) then
			count = count + 1
		end
	end
	self.herosAmount[self.curPageId] = count
end

-- 更换英雄
function FightCampView:changeHero(heroClass, extra)
	local data = heroClass.data
	if not data then return end
	extra = extra or {}
	if extra.flag == 1 then
		self.curPlaceId = self:getEmptyPlaceId() or self.curPlaceId -- 新需求
	end
	local placeObj = self:getPlaceObj(self.curPageId, self.curPlaceId)
	if placeObj ~= nil then
		local hc = HeroClass.new()
		hc:init(data, self.curPlaceId)
		local hero = hc:createHero()
		ViewUtil.addDragScrollView(hero, self.scvPage)
		local function _onClick(obj)
			self:doClickHero(obj, hc)
		end
		ViewUtil.AddClickEvent(hero, _onClick)
		DestroyChildren(placeObj)
		HangObject(hero, placeObj)
		self:shakeHero(s_adjusting)
		self:resetSelectedHero()
		self:doClickHero(hero, hc)

		self.heroObjs[self.curPageId][hc.placeId] = hero
		self.heroClasses[self.curPageId][hc.placeId] = hc
		self:recountHeroAmount()
		self:addEventTriggers(hero, hc)
	end
	self:confirm()
end

function FightCampView:showAdjustingView(isShow)
	if isShow then
		self.btnAdjustContainer:SetActive(false)
		self.btnChange:SetActive(true)
		self.btnDown:SetActive(true)
		self.btnConfirmContainer:SetActive(true)
		self:shakeHero(true)
	else
		self.btnAdjustContainer:SetActive(true)
		self.btnChange:SetActive(false)
		self.btnDown:SetActive(false)
		self.btnConfirmContainer:SetActive(false)
		self:shakeHero(false)
	end

	if isShow then
		self:scrollDragPages(false)
	else
		self:scrollDragPages(true)
	end
end

function FightCampView:resetSelectedHero()
	self.selectedHero = nil
	DestroyObject(self.selectBoard)
	self.selectBoard = nil
	DestroyObject(self.selectBoard2)
	self.selectBoard2 = nil
	
	self.skillAmount = 0
	for i = 1, 5 do
		self.sprSkills[i] = GetComponent(self.btnSkills[i].transform, "UIButton")
		self.sprSkills[i].normalSprite = "alpha"
	end
	self.heroName.text = "选择英雄"
	self.skillTitle.text = " "
	self.heroLvl.text = ""..0
	self.heroWiseup.text = 0
	self.heroIntensify.text = 0
	self.heroFightValue.text = 0
	self.descContent.text = " "
	self.descProp1.text = 0
	self.descProp2.text = 0
	self.descProp3.text = 0
	self.descProp4.text = 0
end

function FightCampView:selectHeroBoard(obj)
	if not obj then return end
	if not IsAHero(obj) then return end
	if not self.selectBoard then
		self.selectBoard = CreateObject(Util.LoadPrefab("UI/SelectedHeroBoard", AssetBundleInfo.assetBundles))
		ViewUtil.sortLayerOrder(self.selectBoard, LayerName.UI)
	end
	HangObject(self.selectBoard, obj)
	self.selectBoard.transform.localPosition = Vector3.New(0, 4, 0)
	self.selectedHero = obj
end

function FightCampView:selectSkillBoard(obj)
	if not obj then return end
	if not self.selectBoard2 then
		self.selectBoard2 = CreateObject(Util.LoadPrefab("UI/SelectedSkillBoard", AssetBundleInfo.assetBundles))
		ViewUtil.sortLayerOrder(self.selectBoard2, LayerName.UI)
	end
	self.selectBoard2:SetActive(true)
	HangObject(self.selectBoard2, obj)
end

function FightCampView:scrollDragPages(sw)
	sw = false
	for pageId = 1, #self.pageObjList do
		local pageObj = self.pageObjList[pageId] -- GetGameObject(self.pageViews.transform, "ScrollPanel/GridTable/Page"..pageId)
		if sw then
			ViewUtil.enableDragScrollView(pageObj, self.scvPage)
		else
			ViewUtil.disableDragScrollView(pageObj, self.scvPage)
		end
		for i = 1, self.maxPlaceNum do
			local placeObj = self:getPlaceObj(pageId, i)
			local children = ObtainChildren(placeObj)
			for _, child in pairs(children) do
				if sw then
					ViewUtil.enableDragScrollView(child, self.scvPage)
				else
					ViewUtil.disableDragScrollView(child, self.scvPage)
				end
			end
		end
	end
end

function FightCampView:scrollDragHeros(sw)
	for pageId = 1, #self.pageObjList do
		local pageObj = self.pageObjList[pageId] -- GetGameObject(self.pageViews.transform, "ScrollPanel/GridTable/Page"..pageId)
		local scvObj = GetComponent(self.scvObjList[pageId].transform, "UIScrollView")
		if sw then
			ViewUtil.enableDragScrollView(pageObj, scvObj)
		else
			ViewUtil.disableDragScrollView(pageObj, scvObj)
		end
		for i = 1, self.maxPlaceNum do
			local placeObj = self:getPlaceObj(pageId, i)
			local children = ObtainChildren(placeObj)
			for _, child in pairs(children) do
				if sw then
					ViewUtil.enableDragScrollView(child, scvObj)
				else
					ViewUtil.disableDragScrollView(child, scvObj)
				end
			end
		end
	end
end

function FightCampView:Update()
end

function FightCampView:OnDestroy()
	CancelDelayCall(self.coroutine)
end
