require "Game/FightFailure/View/FightFailureView"
 
FightFailureControler = {}

local this = FightFailureControler

function FightFailureControler.New()
	return this
end

function FightFailureControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = FightFailureView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function FightFailureControler.Awake()
end

function FightFailureControler.Start()
	this.view:Start(this.data)
end

function FightFailureControler.Update()
end

function FightFailureControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function FightFailureControler.initListener()
end

function FightFailureControler.listNotificationInterests()
    local list = {MVCConst.ON_CLOSE}
    return unpack(list)
end

function FightFailureControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
	if notification:getName() == MVCConst.ON_CLOSE then
		ViewUtil.closeView(notification:getBody().mod)
	end
end

function FightFailureControler.accept(data)
	ViewUtil.initData(this, data)
end
