require "Game/FightVictory/View/FightVictoryView"
 
FightVictoryControler = {}

local this = FightVictoryControler

function FightVictoryControler.New()
	return this
end

function FightVictoryControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = FightVictoryView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function FightVictoryControler.Awake()
end

function FightVictoryControler.Start()
	this.view:Start(this.data)
end

function FightVictoryControler.Update()
end

function FightVictoryControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function FightVictoryControler.initListener()
end

function FightVictoryControler.listNotificationInterests()
    local list = {MVCConst.ON_CLOSE}
    return unpack(list)
end

function FightVictoryControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
	if notification:getName() == MVCConst.ON_CLOSE then
		ViewUtil.closeView(notification:getBody().mod)
	end
end

function FightVictoryControler.accept(data)
	ViewUtil.initData(this, data)
end
