
FightVictoryView = class(BaseView)

 function FightVictoryView:ctor()
	self.shadeOpacity = true
end

function FightVictoryView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
	SimpleAudio.StopMusic(doNthFunc)
	SimpleAudio.PlayMusic("victory")
end

function FightVictoryView:Start(data)
	self:initData(data)
end

function FightVictoryView:OnFocus()
	if Application.isMobilePlatform then -- UMeng
		GA.FinishLevel(FBData.GetCurGateTitle())
	end

    local function doClick(obj)
		local rewards = FightControler.rewards
		if IsEmptyTable(rewards) then
			ViewUtil.closeAllViews()

			SimpleAudio.PlayMusic("main")
			AudioConst.SetBgmName("main")

			ViewUtil.openLastView(function()
                --modify by library, for guide 2016-12-1 16:23:35
                if (ModuleName.FB == ViewManager.lastModule) then
				    Facade:sendNotification(MVCConst.UPDATE_FB, {})
				elseif (ModuleName.LeaguePVPFighting == ViewManager.lastModule) then
					Network.ReqLeaguePVPJoin()
                end

                ViewUtil.showNewHeros();
                if (PlayerData.guideNotEnd()) then
	                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
                end
			end)
		else
			local prefabName = nil
			local existItem = false
			for i = 1, #rewards do
				local reward = rewards[i]
				local propId = tostring(reward.propId)
				if propId == "1001" then			-- 经验
				elseif propId == "1002" then		-- 金币
				elseif propId == "1003" then		-- 钻石
				elseif propId == "1004" then		-- 战力
				else
					existItem = true
				end
			end
			
			if existItem then
				prefabName = "UI/FightOverAwards"
			else
				prefabName = "UI/FightOverAwards2"
			end
			local awards = CreateObjectByPath(prefabName, AssetBundleInfo.assetBundles)
			local mode = GetGameObject(awards.transform, "Mode")
			local shade = ViewUtil.CreateShadeView(function()
				ViewUtil.closeAllViews()
				ViewUtil.openLastView(function()
                    --modify by library, for guide 2016-12-1 16:23:35
                    if (ModuleName.FB == ViewManager.lastModule) then
					    Facade:sendNotification(MVCConst.UPDATE_FB, {})
					elseif (ModuleName.LeaguePVPFighting == ViewManager.lastModule) then
						Network.ReqLeaguePVPJoin()
                    end
                    ViewUtil.showNewHeros();
                    if (PlayerData.guideNotEnd()) then
	                    Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
                    end
				end)
			end)
			HangObject(shade, awards)
			HangObject(awards, self.gameObject)
			ViewUtil.sortLayerOrder(awards, LayerName.Top)
			mode.transform.localScale = Vector3.New(0, 0, 0)
			iTween.ScaleTo(mode, Vector3.New(1, 1, 1), 0.8)

			local centerPath = "Mode/Center/Panel"
			local scvBG = GetGameObject(awards.transform, centerPath.."/ScrollViewBG")
			local scvObj = GetGameObject(scvBG.transform, "ScrollView")
			local gridObj = GetGameObject(scvObj.transform, "Panel/Grid")
			local btnClose = GetGameObject(awards.transform, centerPath.."/BtnClose")
			local btnGain = GetGameObject(awards.transform, centerPath.."/BtnGain")
			local gridObj2 = GetGameObject(awards.transform, centerPath.."/Grid")
			local expObj = GetGameObject(awards.transform, centerPath.."/Grid/ExpNum")
			local expNum = GetComponent(expObj.transform, "UILabel")
			local goldObj = GetGameObject(awards.transform, centerPath.."/Grid/GoldNum")
			local goldNum = GetComponent(goldObj.transform, "UILabel")
			local gemObj = GetGameObject(awards.transform, centerPath.."/Grid/GemNum")		
			local gemNum = GetComponent(gemObj.transform, "UILabel")	
			local powerObj = GetGameObject(awards.transform, centerPath.."/Grid/PowerNum")
			local powerNum = GetComponent(powerObj.transform, "UILabel")
			local exp = 0
			local gold = 0
			local gem = 0
			local power = 0;
			
			local function _doClose(obj)
				ViewUtil.closeAllViews()

				SimpleAudio.PlayMusic("main")
				AudioConst.SetBgmName("main")

				ViewUtil.openLastView(function()
                    --modify by library, for guide 2016-12-1 16:23:35
                    if (ModuleName.FB == ViewManager.lastModule) then
					    Facade:sendNotification(MVCConst.UPDATE_FB, {})
                    end
                    ViewUtil.showNewHeros();
                    if (521 == PlayerData.getMyGuideStep()) then
                        Facade:sendNotification(MVCConst.GUIDE_NEXT);
                    end
				end)
			end
			-- UIEventListener.Get(btnClose).onClick = _doClose
			-- UIEventListener.Get(btnGain).onClick = _doClose
			ViewUtil.AddClickEvent(btnClose, _doClose)
			ViewUtil.AddClickEvent(btnGain, _doClose)

			for i = 1, #rewards do
				local reward = rewards[i]
--				plog(reward, "rewardtree")
				local propId = tostring(reward.propId)
				local num = tonumber(reward.num) or 0
				if propId == "1001" then			-- 经验
					exp = exp + num
				elseif propId == "1002" then		-- 金币
					gold = gold + num
				elseif propId == "1003" then		-- 钻石
					gem = gem + num
				elseif propId == "1004" then		-- 战力
					power = power + num
				else
					ViewUtil.CreateDropItem(propId, num, gridObj)
				end
			end
			if exp > 0 then
				expObj:SetActive(true)
				expNum.text = "+" .. exp
			else
				expObj:SetActive(false)
			end
			if gold > 0 then
				goldObj:SetActive(true)
				goldNum.text = "+" .. gold
			else
				goldObj:SetActive(false)
			end
			if gem > 0 then
				gemObj:SetActive(true)
				gemNum.text = "+" .. gem
			else
				gemObj:SetActive(false)
			end
			if power > 0 then
				powerObj:SetActive(true)
				powerNum.text = "+" .. power
			else
				powerObj:SetActive(false)
			end
			ResetGrid(gridObj)
			ResetGrid(gridObj2)
		end
    end
	
	local shade = GetGameObject(self.transform, "ShadeView")
	if shade ~= nil then
		self.shade = GetGameObject(shade.transform, "Panel/Collider")
		if self.shade ~= nil then
			-- UIEventListener.Get(self.shade).onClick = doClick
			ViewUtil.AddClickEvent(self.shade, doClick)
		end
	end
end

function FightVictoryView:initPanel()
	local lastModule = ViewUtil.getLastModule(self.name)
	if lastModule == ModuleName.FB then
		if FBData.GetLastHouseId() == 5 then
			FBData.IncLastHardLevel()
			FBData.InsertPastedFB(FBData.GetCurChapterIdRPC(), FBData.GetLastHardLevel())
			FBData.IncLastChapterId()
		end
	end
end

function FightVictoryView:initData(data)
	if IsEmpty(data) then return end
end
