require "Game/Friend/View/FriendView"
 
FriendControler = {}

local this = FriendControler

function FriendControler.New()
	return this
end

function FriendControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = FriendView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function FriendControler.Awake()
end

function FriendControler.Start()
end

function FriendControler.Update()
	this.view:Update()
end

function FriendControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function FriendControler.initListener()
end

function FriendControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function FriendControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function FriendControler.request()
	Network.SendMoData(ServerID.FriendMain, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("FriendMainData", session)
		this.accept(mo)
	end, {})
end

function FriendControler.accept(data)
	ViewUtil.initData(this, data)
end
