
FriendView = class(BaseView)

 function FriendView:ctor()
end  

function FriendView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.isDeleting = false
	self.herosConf = Config.getHerosData()
	self:initPanel()
end

function FriendView:Start(data)
end

function FriendView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)

	local topPath = "Mode/Top/Panel"
	self.btnShop = GetGameObject(self.transform, topPath.."/InfoBoard/BtnShop")			-- 友情商店
	self.friendPointsLbl = GetPathComponent(self.transform, topPath.."/InfoBoard/FriendPoints", "UILabel")
	self.friendAmount = GetPathComponent(self.transform, topPath.."/InfoBoard/FriendAmounts", "UILabel")
	self.btnNotice = GetGameObject(self.transform, topPath.."/InfoBoard/BtnNotice")
	self.dayAmountLbl = GetPathComponent(self.transform, topPath.."/InfoBoard/Tips1/num", "UILabel")
	
	local centerPath = "Mode/Center/Panel"
	self.scvBG = GetGameObject(self.transform, centerPath.."/ScrollViewBG")
	self.scvObj = GetGameObject(self.scvBG.transform, "ScrollView")
	self.gridObj = GetGameObject(self.scvObj.transform, "Panel/Grid")
	self.grid = GetPathComponent(self.scvObj.transform, "Panel/Grid", "UIGrid")

	ViewUtil.adaptUISize(self.scvBG, true, 200, 100, 0, 0)
	ViewUtil.adaptUISize(self.scvObj, false, 200, 100, 0, 0)

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")
	self.btnSearch = GetGameObject(self.transform, bottomPath.."/BtnSearch")
	self.btnDelete = GetGameObject(self.transform, bottomPath.."/BtnDelete")		-- 删除好友
	self.titleDelete = GetPathComponent(self.btnDelete.transform, "Title", "UILabel")

    local function doClick(obj)
		if obj == self.btnBack then
			ViewUtil.openView(ModuleName.MAIN)
		elseif obj == self.btnSearch then
			self:createFriendSearch()
		elseif obj == self.btnNotice then
			ViewUtil.openView(ModuleName.FriendNotice, true)
		elseif obj == self.btnShop then
			ViewUtil.goto(ModuleName.SHOP, false, function(args)
				local shop = ModuleManager.GetCtrl(ModuleName.SHOP)
				shop.view:showSellProps(1)
			end)
		elseif obj == self.btnDelete then
			self:updateInfo(not self.isDeleting)
--			local function _callback(session)
--				DestroyObject(self.selectedBar)
--				self.selectedBar = nil
--				ResetGrid(self.gridObj)
--			end
--			if self.selectedBar ~= nil then
--				local lb = GetComponent(self.selectedBar.transform, "LuaBehaviour")
--				local info = lb.sourceLuaObj
--				Network.SendMoData(ServerID.FriendDelete, {info.friendTeamId}, _callback)
--			else
--				ViewUtil.showMsg("请选中好友")
--			end
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnSearch).onClick = doClick
	-- UIEventListener.Get(self.btnNotice).onClick = doClick
	-- UIEventListener.Get(self.btnShop).onClick = doClick
	-- UIEventListener.Get(self.btnDelete).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnSearch, doClick)
	ViewUtil.AddClickEvent(self.btnNotice, doClick)
	ViewUtil.AddClickEvent(self.btnShop, doClick)
	ViewUtil.AddClickEvent(self.btnDelete, doClick)

	ViewUtil.AddEventTrigger(self.scvBG, EventConst.onPress, function()
		self.selectedBar = nil
		local list = self.grid:GetChildList()
		for i = 0, list.Count - 1 do
			local child = list[i]
			local barSpr = GetComponent(child, "UISprite")
			local selectedFG = GetGameObject(child, "SelectedFG")
--			barSpr.color = CreateColor(255, 255, 255, 255)
			selectedFG:SetActive(false)
		end
	end)
end

function FriendView:updateInfo(state)
	self.isDeleting = state
	if self.isDeleting then
		self.titleDelete.text = "退出删除"
	else
		self.titleDelete.text = "删除好友"
	end
	
	local tran = self.gridObj.transform
	for i = 0, tran.childCount - 1 do
		local child = tran:GetChild(i)
		local btnHello = GetGameObject(child, "BtnHello")
		local titleHello = GetPathComponent(btnHello.transform, "Title", "UILabel")
		local lb = GetComponent(child.transform, "LuaBehaviour")
		local cls = lb.sourceLuaObj
		if self.isDeleting then
			titleHello.text = "删除"
			Util.EnableButton(btnHello, ButtonState.Normal, true)
		else
			titleHello.text = "问好"
			Util.EnableButton(btnHello, ButtonState.Normal, true)
			
			for j = 1, #self.friends do
				local info = self.friends[j]
				if info.friendTeamId == cls.friendTeamId then
					local gift = info.giftStatus or 0
					if gift > 0 then
						Util.EnableButton(btnHello, ButtonState.Disabled, false)
					end
					break
				end
			end
		end
	end
end

function FriendView:createFriendSearch()
	local searchBoard = CreateObjectByPath("UI/FriendSearch", AssetBundleInfo.assetBundles)
	HangObject(ViewUtil.CreateShadeView(), searchBoard)
	HangObject(searchBoard, self.gameObject)
	ViewUtil.sortLayerOrder(searchBoard, LayerName.Dialog)

	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	local btnBack = GetGameObject(searchBoard.transform, centerPath.."/BG/BtnBack")
	local btnSearch = GetGameObject(searchBoard.transform, centerPath.."/BtnSearch")
	local inputSprite = GetPathComponent(searchBoard.transform, centerPath.."/InputSearch", "UIInput")

	local scvBG = GetGameObject(searchBoard.transform, centerPath.."/ScrollViewBG")
	local scvObj = GetGameObject(scvBG.transform, "ScrollView")
	local gridObj = GetGameObject(scvObj.transform, "Panel/Grid")

	ViewUtil.adaptUISize(scvBG, true, 180, 100, 0, 0)
	ViewUtil.adaptUISize(scvObj, false, 180, 100, 16, 16)
	
	local bottomPath = "Mode/Bottom/Panel"
	local btnChange = GetGameObject(searchBoard.transform, bottomPath.."/BtnChange")

	self:initFriendSearchList(gridObj, scvObj)

    local function doClick(obj)
		if obj == btnBack then
			FriendControler.request()
			DestroyObject(searchBoard)
		elseif obj == btnSearch then
			local input = inputSprite.value
			if IsEmptyString(input) then
				ViewUtil.showMsg("请输入好友名称")
			elseif string.lower(input) == string.lower(TeamData.GetRoleName()) then
				ViewUtil.showMsg("不能查找自己")
			else
				DestroyChildren(gridObj)
				Network.SendMoData(ServerID.FriendExactSearch, {input}, function(session)
					local serviceId = tonumber(session.serviceId)
					local mo = GetProtoTable("SeachFriendData", session)
					self:resetFriendSearchList(gridObj, {mo})
--					plog("gridObj.transform.childCount = ", gridObj.transform.childCount)
					if gridObj.transform.childCount == 0 then
						ViewUtil.showMsg("好友不存在")
					end
				end)
			end
		elseif obj == btnChange then
			local function _callback(session)
				self:resetFriendSearch(gridObj, session, nil)
			end
			Network.SendMoData(ServerID.FriendChange, {}, _callback)
		end
    end
	-- UIEventListener.Get(btnBack).onClick = doClick
	-- UIEventListener.Get(btnChange).onClick = doClick
	-- UIEventListener.Get(btnSearch).onClick = doClick
	ViewUtil.AddClickEvent(btnBack, doClick)
	ViewUtil.AddClickEvent(btnChange, doClick)
	ViewUtil.AddClickEvent(btnSearch, doClick)
end

function FriendView:OnFocus()
	FriendControler.request()
end

function FriendView:resetFriendSearchList(gridObj, friends)
	DestroyChildren(gridObj)
	if IsEmpty(friends) then return end
	for i = 1, #friends do
		local friend = friends[i] or {}
		local friendId = friend.friendTeamId
		local name = tostring(friend.friendName)
		local power = tonumber(friend.power) or 0
		local status = tostring(friend.status)
		plog("@FriendSearch name = %s, RoleName = %s, Status = %s", name, TeamData.GetRoleName(), status)
		if not IsEmptyString(name) and string.lower(name) ~= string.lower(TeamData.GetRoleName()) then
			local bar = CreateObjectByPath("UI/BarFriendSearch", AssetBundleInfo.assetBundles)
			HangObject(bar, gridObj)
			local btnAddFriend = GetGameObject(bar.transform, "BtnAddFriend")
			BindLuaScript(friend, btnAddFriend)
--			plog("friend.friendLogo = ", tostring(friend.friendLogo))
			local head = GetGameObject(bar.transform, "Head")
			local conf = self.herosConf[tostring(friend.friendLogo)]
			if not IsEmptyTable(conf) then
				local baseHero = BaseHero.new()
				baseHero:setData(conf)
				local item = baseHero:createHero("UI/Hero")
				HangObject(item, head)
			end

			local lblName = GetPathComponent(bar.transform, "Name", "UILabel")
			local lblPower = GetPathComponent(bar.transform, "FightValue", "UILabel")
			lblName.text = name
			lblPower.text = power
		
			local lblTitle = GetPathComponent(bar.transform, "BtnAddFriend/Title", "UILabel")
			if status == "Default" then -- 可加好友
				Util.EnableButton(btnAddFriend, ButtonState.Normal, true)
				lblTitle.text = GetWord("FriendAdd")
			elseif status == "Apply" then -- 已申请
				Util.EnableButton(btnAddFriend, ButtonState.Pressed, false)
				lblTitle.text = GetWord("FriendApplyed")
			elseif status == "Friend" then -- 已成好友
				Util.EnableButton(btnAddFriend, ButtonState.Disabled, false)
				lblTitle.text = GetWord("FriendAdded")
			end
			local function _doClick(obj)
				local lb = GetComponent(obj.transform, "LuaBehaviour")
				local cls = lb.sourceLuaObj
				local function _callback(session)
					local mo = GetProtoTable("DefaultData", session)
					if mo.code == 0 then
						Util.EnableButton(btnAddFriend, ButtonState.Pressed, false)
						lblTitle.text = GetWord("FriendApplyed")
					else
						ViewUtil.showMsg(GetWord(tostring(mo.code)))
					end
				end
				Network.SendMoData(ServerID.FriendAdd, {cls.friendTeamId}, _callback)
			end
			-- UIEventListener.Get(btnAddFriend).onClick = _doClick
			ViewUtil.AddClickEvent(btnAddFriend, _doClick)
		end
	end
	ResetGrid(gridObj)
end

function FriendView:resetFriendSearch(gridObj, session, params)
	local serviceId = tonumber(session.serviceId)
	local mo = GetProtoTable("SeachFriendMainData", session)
	local friends = mo.friends or {}
	self:resetFriendSearchList(gridObj, friends)
end

function FriendView:initFriendSearchList(gridObj, scvObj)
	local function _callback(session, params)
		self:resetFriendSearch(gridObj, session, params)
		ResetScrollView(scvObj)
	end
	Network.SendMoData(ServerID.FriendSearchList, {}, _callback)
end

function FriendView:initFriendList(friends)
	DestroyChildren(self.gridObj)
	if IsEmpty(friends) then return end
	self.selectedBar = nil

	for i = 1, #friends do
		local info = friends[i]
		local bar = CreateObjectByPath("UI/BarFriend", AssetBundleInfo.assetBundles)
		bar.name = tostring(info.friendName)
		HangObject(bar, self.gridObj)
		BindLuaScript(info, bar)
		local heroes = {}
		local head = GetGameObject(bar.transform, "Head")
		local conf = self.herosConf[tostring(info.logo)]
		if not IsEmptyTable(conf) then
			local baseHero = BaseHero.new()
			baseHero:setData(conf)
			local item = baseHero:createHero("UI/Hero")
			HangObject(item, head)
			heroes[i] = item
		end
		local lblName = GetPathComponent(bar.transform, "Name", "UILabel")
		lblName.text = info.friendName
--		local lblPower = GetPathComponent(bar.transform, "FightValue", "UILabel")
--		lblPower.text = info.power
		local lblOnline = GetPathComponent(bar.transform, "Online", "UILabel")
		if info.isOline then
			lblOnline.text = "在线"
			lblOnline.gradientTop = CreateColor(255, 216, 0, 255)
			lblOnline.gradientBottom = CreateColor(255, 216, 0, 255)
		else
			lblOnline.text = "不在线"
			lblOnline.gradientTop = CreateColor(218, 218, 218, 255)
			lblOnline.gradientBottom = CreateColor(218, 218, 218, 255)
		end
		
		local btnFight = GetGameObject(bar.transform, "BtnFight")
		local btnHello = GetGameObject(bar.transform, "BtnHello")
		local function _doClick(obj)
			if obj == bar then
				local list = self.grid:GetChildList()
				for i = 0, list.Count - 1 do
					local child = list[i]
--					local barSpr = GetComponent(child, "UISprite")
					local selectedFG = GetGameObject(child, "SelectedFG")
					if child == obj.transform then
						if not selectedFG.activeSelf then
--							barSpr.color = CreateColor(255, 190, 0, 255)
							selectedFG:SetActive(false)
							self.selectedBar = obj
						else
--							barSpr.color = CreateColor(255, 255, 255, 255)
							selectedFG:SetActive(false)
							self.selectedBar = nil
						end
					else
--						barSpr.color = CreateColor(255, 255, 255, 255)
						selectedFG:SetActive(false)
					end
				end

			elseif obj == btnFight then
				Network.SendMoData(ServerID.FriendFight, {info.friendTeamId})

			elseif obj == btnHello then
				if not self.isDeleting then
					local function _callback(session)
						local mo = GetProtoTable("DefaultData", session)
						if mo.code ~= 0 then
							Util.EnableButton(btnHello, ButtonState.Normal, true)
						end
						-- FriendControler.request() --问好后不进行页面刷新操作，删除好友后好友数量不更新。 by iorinie
					end
					self.friendPoints = self.friendPoints + 10
					self.friendPointsLbl.text = self.friendPoints
					self.dayAmountLbl.text = self.dayAmount + 10
					ViewUtil.showMsg("已赠送")
					Util.EnableButton(btnHello, ButtonState.Disabled, false)
					Network.SendMoData(ServerID.FriendGiveGift, {info.friendTeamId}, _callback)
				else
					self.selectedBar = bar
					if self.selectedBar ~= nil then
						local lb = GetComponent(self.selectedBar.transform, "LuaBehaviour")
						local info = lb.sourceLuaObj
						local name = info.friendName or " "
						ViewUtil.comCfmPanel("确定删除好友? "..name, function()
							local function _callback(session)
								DestroyObject(self.selectedBar)
								self.selectedBar = nil
								ResetGrid(self.gridObj)
							end
							self.friendAmount.text = (self.friendNum - 1).."/20"
							Network.SendMoData(ServerID.FriendDelete, {info.friendTeamId}, _callback)
						end)
					end
				end

			elseif obj == heroes[i] then
				local teamInfoPane = CreateObject(Util.LoadPrefab("UI/FriendHeroInfo", AssetBundleInfo.assetBundles))
				local shade = ViewUtil.CreateShadeView()
				HangObject(shade, teamInfoPane)
				local ctiPane = nil;
				ctiPane = FriendHeroInfoView.new();
				ctiPane:Awake(teamInfoPane);
				ctiPane:setTeamId(info.friendTeamId);
				ctiPane:request()
				PanelManager:BindPanelScript(ctiPane, teamInfoPane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
				HangObject(teamInfoPane, ViewUtil.getRootView());
				ViewUtil.sortLayerOrder(teamInfoPane, LayerName.Top);
			end
		end
		-- UIEventListener.Get(bar).onClick = _doClick
		-- UIEventListener.Get(btnFight).onClick = _doClick
		-- UIEventListener.Get(btnHello).onClick = _doClick
		ViewUtil.AddClickEvent(bar, _doClick)
		ViewUtil.AddClickEvent(btnFight, _doClick)
		ViewUtil.AddClickEvent(btnHello, _doClick)
		ViewUtil.AddClickEvent(btnHello, _doClick)
		ViewUtil.AddClickEvent(heroes[i], _doClick)

		local gift = info.giftStatus or 0
		if gift > 0 then
			Util.EnableButton(btnHello, ButtonState.Disabled, false)
		end
    end

	ResetGrid(self.gridObj)
end

function FriendView:initData(data)
	if IsEmpty(data) then return end
	local friends = data.friends
	self.dayAmount = data.dayAmount
	self.friendNum = CountTable(friends)
	self.friendPoints = TeamData.GetFriendPoints()
	self.friendPointsLbl.text = self.friendPoints
	self.dayAmountLbl.text = self.dayAmount
	self.friendAmount.text = self.friendNum.."/20"
	self.friends = friends

	self:updateInfo(false)
	self:initFriendList(friends)
	if self.friendNum > 0 then
		self.btnDelete:SetActive(true)
	else
		self.btnDelete:SetActive(false)
	end
	ResetScrollView(self.scvObj)
end
