--新手引导Controler
--2016-8-15 09:50:30 library

require "Game/Guide/Logic/GuideConst"
require "Game/Guide/Logic/GuideStep"
require "Game/Guide/View/GuideView"

GuideControler = {

}

local this = GuideControler;

--[[

]]
function GuideControler.New ()
    return this;
end

--[[

]]
function GuideControler.OnCreate (_go, _name)
    this.gameObject = _go;
    this.transform = this.gameObject.transform;
    this.view = GuideView.new();
    this.view.name = _name;
    this.view:Awake(this.gameObject, this);
    GuideControler.showCurModule(false);
    this.view:startGuide(PlayerData.getMyGuideStep());
    this.root = ViewUtil.getRootView();
    
    HangObject(this.view, this.root);
end

--[[

]]
function GuideControler.listNotificationInterests ()
    local notes = {
        MVCConst.GUIDE_NEXT,
        MVCConst.GUIDE_SAVEGUIDE,
        MVCConst.GUIDE_SHOWGUIDE
    };
    return unpack(notes);
end

--[[

]]
function GuideControler.handleNotification (notes)
    local nName = notes:getName();
    local nBody = notes:getBody();
    local nType = notes:getType();
    local fromPK = 0;
    local nextStep, isGoNext = nil, false;
    
    if (MVCConst.GUIDE_SHOWGUIDE == nName) then
        this.showCurModule(nBody[1]);
    elseif (MVCConst.GUIDE_SAVEGUIDE == nName) then
        if (2 == this.view.curTab[2].saveType) then
            PlayerData.setMyGuideStep(this.view.curTab[2].bStep);
        end
    elseif (MVCConst.GUIDE_NEXT == nName) then
        if (nil ~= nType) then
            this.view.curState = nType;
        end
        
        if (2 == this.view.curState) then
            pcall(function () this.view:goResume(); end);
            LuaCallManager:invokeCall(function () 
                ViewUtil.closeView(ModuleName.GUIDE);
            end, 0.5);
        elseif (1 == this.view.curState) then
            pcall(function () this.view:goResume(); end);
            this.showCurModule(false);
        else 
            nextStep = GuideStep.getNextTab(this.view.curTab[2].bStep, this.view.curTab[2].sStep);
            isGoNext = this.view:checkGoNext(nextStep[2].bStep, nextStep[2].sStep);
            
            if (not isGoNext) then
                --等待触发新手
                this.view.curState = 1;
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
                return ;
            end
            
            this.view.curState = 0;
            this.showCurModule(true);
            this.view:getNextGuideTab();
            
            if (nil ~= nBody) then
                if (nil ~= nBody[1]) then
                    fromPK = nBody[1];
                end
                
                if (nil ~= nBody[2] and this.view.curTab[2] and this.view.curTab[2].path) then
                    this.view.curTab[2].path = string.gsub(this.view.curTab[2].path, "{1}", nBody[2]);
                end
                if (nil ~= nBody[3] and this.view.curTab[2] and this.view.curTab[2].path) then
                    this.view.curTab[2].path = string.gsub(this.view.curTab[2].path, "{2}", nBody[3]);
                end
            end

            this.view:initListener();
            this.view:goNext(this.view.curTab, fromPK);
        end
    end
end

--[[
    
]]
function GuideControler.setPathParams (_guideInfo)
    if (_guideInfo and _guideInfo.path) then
        if (GuideConst.GuideWordInfo.const_74 == _guideInfo.path) then
            _guideInfo.path = string.gsub(_guideInfo.path, "{1}", TeamData.GetCurPageIndex());
        end
    end
end

--[[

]]
function GuideControler.showCurModule (_isShow)
    this.view.container:SetActive(_isShow);
end

--[[

]]
function GuideControler.isGuideShowing ()
    local isShowing = false;
    
    pcall(function () 
        if (this.view and this.view.container and this.view.container.activeInHierarchy) then
            isShowing = true;
        end
    end);

    return isShowing;
end

--[[

]]
function GuideControler.callViewGoResume ()
    if (this.view) then
        pcall(function ()
            this.view:goResume(0);
        end);
    end
end

--[[

]]
function GuideControler.OnDestroy ()
    this.gameObject = nil;
    this.view = nil;
end