--新手引导View
--30步之前的引导需要特殊处理
--2016-8-15 09:48:31 library

local const_goNextWord = "点击屏幕继续";

GuideView = class(BaseView);

--[[

]]
function GuideView:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.curTab = nil;
    self.curGO = nil;
    self.preLayer = nil;
    self.preTrans = nil;
    self.coroutine = nil;
    self.ctl = nil;

    self.cnt = 0;
    self.curState = 0;

    self.laterShowList = List.new();
end

--[[

]]
function GuideView:Awake (_go, _ctl)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.ctl = _ctl;

    self.showShade = false;
	self.shadeOpacity = false;

    self:initPanel();
    self:initListener();
end

--[[

]]
function GuideView:initPanel ()
    self.container = GetGameObject(self.transform, "Container");
    self.npcPanel = GetGameObject(self.transform, "Container/NPCPanel");
    self.playerPanel = GetGameObject(self.transform, "Container/PlayerPanel");
    self.playerIcon = GetGameObject(self.playerPanel.transform, "PlayerIcon");
    self.talkPanel = GetGameObject(self.transform, "Container/TalkPanel");
    self.guideWord = GetGameObject(self.talkPanel.transform, "guideWord");
    self.guideLabel = GetComponent(self.guideWord, "UILabel");
    self.handPanel = GetGameObject(self.transform, "Container/handPanel");
    self.tips = GetGameObject(self.talkPanel.transform, "tips");
    self.goContainer = GetGameObject(self.transform, "Container/goContainer");
    self.hands = GetGameObject(self.handPanel.transform, "hands");
    self.circles = GetGameObject(self.handPanel.transform, "circles");

    self.typerEffect = GetComponent(self.guideWord, "TypewriterEffect");
    
    GetComponent(self.tips, "UILabel").text = const_goNextWord;
	GetComponent(self.playerIcon, "UISprite").spriteName = TeamData.GetRoleLogo()
end

--[[

]]
function GuideView:initListener (_isNext)
    _isNext = ((true == _isNext or nil == _isNext) and true or false);
    
    if (_isNext) then
        ViewUtil.AddClickEvent(self.container, function ()
            if (nil ~= self.coroutine or ViewManager.isExistView(ModuleName.LOAD)) then
                return ;
            end
            Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
        end)
    else
        ViewUtil.AddClickEvent(self.container, function () end)
    end
end

--[[

]]
function GuideView:startGuide (_curStep)
    local nextStep, isGoNext = nil, true;
    
    nextStep = GuideStep.getNextTab(_curStep, -1);

    if (not nextStep) then
        return ;
    end

    isGoNext = self:checkGoNext(nextStep[2].bStep, nextStep[2].sStep);
    
    if (isGoNext) then
        self.curTab = nextStep;
    else
        --等待触发新手
        self.curTab = {[2] = {bStep = _curStep, sStep = -1}};
        LuaCallManager:invokeCall(function () 
            self.curState = 1;
            Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
        end, 0.15);
        return ;
    end
    
    if (nil ~= nextStep) then
        self:dealGuide(self.curTab);
    else
        error("---------------------nextStep is nil");
        LuaCallManager:invokeCall(function () 
            self.curState = 1;
            Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
        end, 0.15);
    end
end

--[[
    新手自动中断，判断副本是否满足需要恢复的大步骤的条件
    即，自动中断时步骤取需要恢复的大步骤，副本取需要恢复时完成的副本
]]
function GuideView:checkGoNext (_bStep, _sStep)
    local isGoNext = true;
--    error(_bStep .. "__" .. _sStep .. "__" .. FBData.GetCurGateId() .. "__" .. tostring(FBData.IsPassedGate(FBData.GetCurGateId(), 1)));
--    if (240 == _bStep) then
--        if (10104 == FBData.GetCurGateId() and FBData.IsPassedGate(10104, 1) or 10105 == FBData.GetCurGateId() and not FBData.IsPassedGate(10105, 1)) then
--            isGoNext = true;
--        else
--            isGoNext = false;
--        end
    if (230 == _bStep) then
        if (10103 == FBData.GetCurGateId() and FBData.IsPassedGate(10103, 1) or 10104 == FBData.GetCurGateId() and not FBData.IsPassedGate(10104, 1)) then
            isGoNext = true;
        else
            isGoNext = false;
        end
    elseif (330 == _bStep) then
        if (10105 == FBData.GetCurGateId() and FBData.IsPassedGate(10105, 1) or 10201 == FBData.GetCurGateId() and not FBData.IsPassedGate(10201, 1)) then
            isGoNext = true;
        else
            isGoNext = false;
        end
    elseif (390 == _bStep) then
        if (10202 == FBData.GetCurGateId() and FBData.IsPassedGate(10202, 1) or 10203 == FBData.GetCurGateId() and not FBData.IsPassedGate(10203, 1)) then
            isGoNext = true;
        else
            isGoNext = false;
        end
    elseif (450 == _bStep) then
        if (10205 == FBData.GetCurGateId() and FBData.IsPassedGate(10205, 1) or 10301 == FBData.GetCurGateId() and not FBData.IsPassedGate(10301, 1)) then
            isGoNext = true;
        else
            isGoNext = false;
        end
    elseif (500 == _bStep) then
        if (10305 == FBData.GetCurGateId() and FBData.IsPassedGate(10305, 1) or 10401 == FBData.GetCurGateId() and not FBData.IsPassedGate(10401, 1)) then
            isGoNext = true;
        else
            isGoNext = false;
        end
    end
    return isGoNext;
end

--[[

]]
function GuideView:dealGuide (_curTab)
    self:goNext(_curTab);
end

--[[
    _nextStep
]]
function GuideView:goNext (_nextStep, _fromPK)
    local idx, stepTmp = 0, nil;
    local isNeedModule = "";
    local saveStep = 0;

    if (nil ~= self.coroutine) then
        return ;
    end

    _fromPK = _fromPK or 0;
    idx = _nextStep[1];
    stepTmp = _nextStep[2];
    self.curState = stepTmp.endType;

    pcall(function (_fromPK) self:goResume(_fromPK); end, _fromPK);
    self:curSenceChge(stepTmp);

    --关键步骤保存
    saveStep = stepTmp.bStep - 1;
--    if (1 == stepTmp.saveType or 2 == stepTmp.saveType) then
    if (1 == stepTmp.saveType) then
        saveStep = stepTmp.bStep;
    end
    if (PlayerData.getMyGuideStep() < saveStep) then
        PlayerData.setMyGuideStep(saveStep);
    end
    
    self:typeDrawShow(stepTmp.tp);
    ModuleManager.GetCtrl(ModuleName.GUIDE).showCurModule(true);
    if (GuideConst.GuideType.NPC == stepTmp.tp) then
        self:goNPC(stepTmp);
    elseif (GuideConst.GuideType.Player == stepTmp.tp) then
        self:goPlayer(stepTmp);
    elseif (GuideConst.GuideType.MouseGuide == stepTmp.tp) then
        self:goMouseGuide(stepTmp);
    elseif (GuideConst.GuideType.TimeShow == stepTmp.tp) then
        self:goTimeShow(stepTmp);
    end
end

--[[

]]
function GuideView:curSenceChge (_step)
    local mName, curOpen = "", false;

    mName = _step.mName;

    if ("" ~= mName) then
        curOpen = ViewManager.isExistView(mName);
        if (not curOpen) then
            LuaCallManager:invokeCall(function () 
                ViewUtil.openView(mName, false);
            end, 0.25);
        end
    end
end

--[[

]]
function GuideView:goNPC (stepTmp)
    self.typerEffect.enabled = false;
    self.guideLabel.text = "";
--    self.typerEffect.enabled = true;
    self.guideLabel.text = stepTmp.word;
    ViewManager.GuideSortDepth(self.container);
end

--[[

]]
function GuideView:goPlayer (stepTmp)
    self.typerEffect.enabled = false;
    self.guideLabel.text = "";
--    self.typerEffect.enabled = true;
    self.guideLabel.text = stepTmp.word;
    ViewManager.GuideSortDepth(self.container);
end

--[[

]]
function GuideView:goMouseGuide (stepTmp)
--    error(stepTmp.path);
    self.cnt = 0;
    self:initListener(false);
    self:showLaterShowList(false);
    self.ctl.setPathParams(stepTmp);
    self:getPathGO("UIRoot/" .. stepTmp.path);
end

--[[

]]
function GuideView:goTimeShow (stepTmp)
    self:initListener(false);
    self:goMouseGuide(stepTmp);
    if ("" ~= stepTmp.word) then
        self:goNPC(stepTmp);
    else
        self:typeDrawShow(GuideConst.GuideType.MouseGuide);
    end
    
    
    self.coroutine = LuaCallManager:invokeCall(function ()
        self.coroutine = nil;
        self:initListener();
    end, 0 == stepTmp.time and 0.1 or stepTmp.time);
end

--[[

]]
function GuideView:getPathGO (_path)
    self.curGO = GameObject.Find(_path);
    self.cnt = self.cnt + 1;
    if (self.cnt < 20) then
        if (nil == self.curGO) then
            LuaCallManager:invokeCall(function ()
                self:getPathGO(_path);
            end, 0.25);
        else
            self:doPathGO(self.curGO);
        end
    else
        --手动设置新手到最后一步。目的是跳过新手
--        PlayerData.setMyGuideStep(GuideStep.getFinalGuideStep());
--        ViewUtil.closeView(ModuleName.GUIDE, false);
    end
end

--[[

]]
function GuideView:doPathGO (_go)
    local collider, size, height = nil, nil, 0;
    local goTransPos = nil;

    self:showLaterShowList(true);
    self.preTrans = _go.transform.parent;
    _go:SetActive(false);
    _go.transform.parent = self.goContainer.transform;
    self.preLayer = _go.layer;
    self:chgeLayer(_go.transform, GameLayers.UIGuide);
    _go:SetActive(true);
    goTransPos = _go.transform.localPosition;
    collider = GetComponent(_go, "BoxCollider2D");
    
    if (nil ~= collider) then
        size = collider.size;
        height = size.y * 0.5;
        if (height > 100) then
            height = 100;
        end
    end
    self.hands.transform.localPosition = Vector3.New(goTransPos.x + 10, goTransPos.y + height, goTransPos.z);
    self.circles.transform.localPosition = Vector3.New(goTransPos.x, goTransPos.y, goTransPos.z);
    ViewManager.GuideSortDepth(self.container);
end

--[[

]]
function GuideView:chgeLayer (_trans, _layer)
    local childCnt, tmpTran = _trans.childCount, nil;

    _trans.gameObject.layer = _layer;
    
    for i = 0, childCnt - 1 do
        tmpTran = _trans:GetChild(i);
        if (nil ~= tmpTran) then
            self:chgeLayer(tmpTran, _layer);
        end
    end
end

--[[

]]
function GuideView:typeDrawShow (_tp)
    if (GuideConst.GuideType.NPC == _tp) then
        self.npcPanel:SetActive(true);
        self.playerPanel:SetActive(false);
        self.talkPanel:SetActive(true);
        self.handPanel:SetActive(false);
    elseif (GuideConst.GuideType.Player == _tp) then
        self.npcPanel:SetActive(false);
        self.playerPanel:SetActive(true);
        self.talkPanel:SetActive(true);
        self.handPanel:SetActive(false);
    elseif (GuideConst.GuideType.MouseGuide == _tp) then
        self.npcPanel:SetActive(false);
        self.playerPanel:SetActive(false);
        self.talkPanel:SetActive(false);
        self.handPanel:SetActive(true);
    elseif (GuideConst.GuideType.TimeShow == _tp) then
        self.npcPanel:SetActive(true);
        self.playerPanel:SetActive(false);
        self.talkPanel:SetActive(true);
        self.handPanel:SetActive(true);
    else
        self.npcPanel:SetActive(false);
        self.playerPanel:SetActive(false);
        self.talkPanel:SetActive(false);
        self.handPanel:SetActive(false);
    end
end

--[[

]]
function GuideView:showLaterShowList (_isShow)
    _isShow = _isShow or false;
    if (not _isShow) then
        if (self.npcPanel.activeInHierarchy) then
            self.laterShowList:add(self.npcPanel);
            self.npcPanel:SetActive(false);
        end
        if (self.playerPanel.activeInHierarchy) then
            self.laterShowList:add(self.playerPanel);
            self.playerPanel:SetActive(false);
        end
        if (self.talkPanel.activeInHierarchy) then
            self.laterShowList:add(self.talkPanel);
            self.talkPanel:SetActive(false);
        end
        if (self.handPanel.activeInHierarchy) then
            self.laterShowList:add(self.handPanel);
            self.handPanel:SetActive(false);
        end
    else
        for i = 1, self.laterShowList:getSize() do
            self.laterShowList[i]:SetActive(true);
        end
        self.laterShowList:clear();
    end
end

--[[

]]
function GuideView:goResume (_fromPK)
    if (nil ~= self.curGO and nil ~= self.preTrans) then
        self.curGO:SetActive(false);
        if (1 ~= _fromPK) then
            self.curGO:SetActive(false);
            self:chgeLayer(self.curGO.transform, self.preLayer);

            if (nil ~= self.preTrans and nil ~= self.curGO.transform) then
                self.curGO.transform.parent = self.preTrans;
				ViewUtil.sortLayerOrder(self.curGO, self.preLayer);
            end
            self.curGO:SetActive(true);
	        ViewManager.SortDepth(self.curGO);
            
            if ViewUtil.boardLost ~= nil then
		        ViewManager.SortDepthOnly(ViewUtil.boardLost, nil, 100)
	        end
        else
            DestroyObject(self.curGO);
        end
        self.curGO = nil;
    elseif (nil ~= self.curGO) then
        self.curGO:SetActive(false);
        self.curGO = nil;
    end
    LuaCallManager:invokeCall(function () 
        local comCtl = ModuleManager.GetCtrl(ModuleName.COM);
        if (comCtl and comCtl.view) then
            comCtl.view:sortBottomBtnDepth();
        end
    end, 0.1);
end

function GuideView:getNextGuideTab ()
    self.curTab = GuideStep.getNextTab(self.curTab[2].bStep, self.curTab[2].sStep);
--    error(self.curTab[2].bStep .. "__" .. self.curTab[2].sStep);
end