require "Game/MyHero/View/HeroClass"
 
HeroChangeView = class(BaseView)

local g_heroList = {}		-- onlyId

 function HeroChangeView:ctor()
	self.sortCond = 0			-- 0:ȫ, 6:, 5:ɫ, 4:ɫ, 3:ɫ, 2:ɫ, 1:ɫ
	self.sortType = 0			-- 0:Ʒ, 1:ս, 2:, 3:ȼ, 4:
    self.heroList = List.new()
end  

function HeroChangeView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.selectBoard = nil
	self.extra = nil
	self:initPanel()
end

function HeroChangeView:OnFocus0(preMod) -- 
	self:checkHeros()
	if preMod ~= ModuleName.SC then
		self:sortHeroList(0, 0, true)
	else
		self:sortHeroList(nil, nil, true)
	end
end

function HeroChangeView:OnFocus(lastModule)
	if not self.isInited then
		self.isInited = true
		self:initData()
		self:showHeros()
	end	
	ResetScrollView(self.scvObj)
end

function HeroChangeView:Start(data)
end

function HeroChangeView:LostFocus()
--	local lastModule = ViewUtil.getLastModule(self.name)
--	if lastModule == ModuleName.FC then
--		local view = ModuleManager.GetCtrl(lastModule).view
--		if view then
--			view:LostFocus()
--		end
--	end
end

function HeroChangeView:resetData()
	local lastModule = ViewUtil.getLastModule(self.name)
	local myHeros = nil
	if lastModule == ModuleName.FC then
		myHeros = TeamData.GetRestHeros()
	else
		myHeros = TeamData.GetAllHerosNoRole()
	end

    self.heroList:clear()
	for _, hero in ipairs(myHeros) do
		local cls = HeroClass.new()
		cls:init(hero)
		self.heroList:add(cls)
--		plog("[1]prefabName = ", cls.prefabName, ", quality = ", cls.quality, ", size = ", self.heroList.size)
	end
end

function HeroChangeView:initData()
	self:resetData()
	self:sortHeroList(0, 0, true)
end

function HeroChangeView:showHeros()
	local function _doClickHero(obj)
		self:doClickHero(obj)
	end
    
	local rowNum = math.abs(GetIntPart(self.heroList.size/5 + (self.heroList.size%5 > 0 and 1 or 0)))
    self.wrap.minIndex = -rowNum + 1
    self.wrap.maxIndex = 0
    self.wrap.enabled = true

    self.wrap.onInitializeItem = function(go, index, realIndex)
--		plog("go = ", go, ", index = ", index, ", realIndex = ", realIndex, ",  minIndex = ",  self.wrap.minIndex, ",  maxIndex = ",  self.wrap.maxIndex)
		if rowNum < index + 1 then
			for i = 1, 5 do
				local hero = GetGameObject(go.transform, "Hero"..i)
				hero:SetActive(false)
			end
		else
			local beginIdx = math.abs(realIndex) * 5
			for i = 1, 5 do
				local hero = GetGameObject(go.transform, "Hero"..i)
				local cls = self.heroList[beginIdx + i]
				if cls ~= nil then
--					plog("[3]prefabName = ", cls.prefabName, ", quality = ", cls.quality, ", size = ", self.heroList.size)
					local data = cls.data 
					hero:SetActive(true)
					local lb = GetComponent(hero.transform, "LuaBehaviour")
					if not lb then
						local heroClass = HeroClass.new()
						heroClass:bindHeroObj(hero)
						heroClass:init(data)
						heroClass:refreshHero(true)
						BindLuaScript(heroClass, hero)
						ViewUtil.AddClickEvent(hero, _doClickHero)
					else
						local heroClass = lb.sourceLuaObj
						heroClass:init(data)
						heroClass:refreshHero(true)
					end
				else
					hero:SetActive(false)
				end
			end
		end
    end

	self.herosAmount = self.heroList.size
	self.heroNum.text = self.herosAmount
end

-- ǷӢ
function HeroChangeView:checkHeros()
	TeamData.updateGridHeros(self.gridObj)
	self.gridObj:SetActive(false)
	local function _doClickHero(obj)
		self:doClickHero(obj)
	end

	local myHeros = nil	
	local lastModule = ViewUtil.getLastModule(self.name)
	if lastModule == ModuleName.FC then
		myHeros = TeamData.GetRestHeros()
	else
		myHeros = TeamData.GetAllHerosNoRole()
	end
	local tran = self.gridObj.transform

	for i = tran.childCount - 1, 0, -1 do
		local child = tran:GetChild(i)
		local obj = child.gameObject
		local lb = GetComponent(obj.transform, "LuaBehaviour")
		obj:SetActive(false)
		if IsAHero(obj) then
			if lb then
				local heroClass = lb.sourceLuaObj
				local onlyId = heroClass.onlyId
				local isMine = false
				for j = 1, #myHeros do
					local mine = myHeros[j]
					if tostring(onlyId) == tostring(mine.id) then
						isMine = true
						obj:SetActive(true)
						break
					end
				end
				if not isMine then
					for i, v in ipairs(self.heroList) do
						if v.onlyId == heroClass.onlyId then
							self.heroList:removeAt(i)
						end
					end
				end
			end
		end
	end

	for m = 1, #myHeros do
		local src = myHeros[m]
		local isExist = false
		for n = tran.childCount - 1, 0, -1 do
			local child = tran:GetChild(n)
			local obj = child.gameObject
			local lb = GetComponent(obj.transform, "LuaBehaviour")
			local heroClass = lb.sourceLuaObj
			local onlyId = heroClass.onlyId
			if tostring(onlyId) == tostring(src.id) then
				isExist = true
				break
			end
		end
		if not isExist then
			local info = src
			local heroClass = HeroClass.new()
			heroClass:init(info)
			self.heroList:add(heroClass)
			local hero = heroClass:createHero()
			HangObject(hero, self.gridObj)
			BindLuaScript(heroClass, hero)
			ViewUtil.AddClickEvent(hero, _doClickHero)
		end
	end
	
	self.herosAmount = CountTable(myHeros)
	self.heroNum.text = self.herosAmount

	ResetGrid(self.gridObj)
	self.gridObj:SetActive(true)
	ResetScrollView(self.scvObj)
end

function HeroChangeView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"
	self.scvBG = GetGameObject(self.transform, topPath.."/HeroListBG")
	self.scvObj = GetGameObject(self.transform, topPath.."/HeroListBG/ScrollView")
	self.scvBGSpr = GetComponent(self.scvBG.transform, "UISprite")
	self.gridObj = GetGameObject(self.scvObj.transform, "Grid")
	self.grid = GetPathComponent(self.scvObj.transform, "Grid", "UIGrid")
	self.heroNum = GetPathComponent(self.transform, topPath.."/ChangeAmount", "UILabel")
	
	self.wrap = GetComponent(self.gridObj.transform, "UIWrapContent")
	self.wrap.enabled = false
	
	ViewUtil.adaptUISize(self.scvBG, true, 40, 100, 20, 20)
	ViewUtil.adaptUISize(self.scvObj, false, 120, 100, 20, 20)

	local bottomPath = "Mode/Bottom/Panel"
 	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")
 	self.btnSort = GetGameObject(self.transform, bottomPath.."/BtnSort")

    local function doClick(obj)
		if obj == self.btnBack then
			self:closeView(true)
		elseif obj == self.btnSort then
			ViewUtil.openView(ModuleName.SC, true,  function()
				Facade:sendNotification(MVCConst.HERO_SORTCHOSEOPEN, {[1] = ModuleName.HC, [2] = LogicUtil.quaToShowType(self.sortCond)}, nil)
            end, nil)
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnSort).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnSort, doClick)
end

function HeroChangeView:isSameCond(hCfg)
    local isType = false;

    if (self.sortCond >= 0 and self.sortCond <= 6) then
        if (0 == self.sortCond) then
            isType = true;
        else
            isType = (self.sortCond == tonumber(HeroDataProxy.getHeroQuality(hCfg)));
        end
    end

    return isType;
end

function HeroChangeView:sortHeroList0(sortArea, sortIndex, force) -- 
	local sortCond = self.sortCond
	local sortType =self.sortType
	if sortArea ~= nil then
		if sortArea == 0 then
			sortCond = tonumber(sortIndex) or 0
		else
			sortType = tonumber(sortIndex) or 0
		end
	end
--	plog("sortCond = %d, sortType = %d", sortCond, sortType)

	local isSortCond = false
	local isSortType = false
	if self.sortCond ~= sortCond then
		self.sortCond = sortCond
		isSortCond = true
	end
	if self.sortType ~= sortType then
		self.sortType = sortType
		isSortType = true
	end

	if isSortCond or force then
		for i = 1, self.heroList.size do
			local hero = self.heroList[i].heroObj
			if self:isSameCond(self.heroList[i].conf) then
				NGUITools.SetActive(hero, true)
			else
				NGUITools.SetActive(hero, false)
			end
		end
		ResetGrid(self.gridObj)
	end

	if isSortType or force then
		self:sortGridByType(self.sortType)
	end
end

function HeroChangeView:sortHeroList(sortArea, sortIndex, force)
	local sortCond = self.sortCond
	local sortType =self.sortType
	if sortArea ~= nil then
		if sortArea == 0 then
			sortCond = tonumber(sortIndex) or 0
		else
			sortType = tonumber(sortIndex) or 0
		end
	end
--	plog("sortCond = %d, sortType = %d", sortCond, sortType)

	local isSorting = false
	if self.sortCond ~= sortCond or self.sortType ~= sortType then
		self.sortCond = sortCond
		self.sortType = sortType
		isSorting = true
	end

	if isSorting or force then
		self:resetData()
		for i = self.heroList.size, 1, -1 do
			if not self:isSameCond(self.heroList[i].conf) then
				self.heroList:removeAt(i)
			end
		end
	end

	if isSorting or force then
		self:sortGridByType(self.sortType)
	end
end

function HeroChangeView:sortHeroListNow(sortArea, sortIndex, force)
	self:sortHeroList(sortArea, sortIndex, force)
	self:showHeros()
	self.wrap:SortBasedOnScrollMovement()
end

function HeroChangeView:sortGridByType0(sortType)
	SortUIGrid(self.gridObj, function(tran1, tran2)
		local lb1 = GetComponent(tran1, "LuaBehaviour");
		local lb2 = GetComponent(tran2, "LuaBehaviour");
		if lb1 ~= nil and lb2 ~= nil then
			local cls1 = lb1.sourceLuaObj
			local cls2 = lb2.sourceLuaObj
			if sortType == 0 then
				if cls1.quality < cls2.quality then
					return 1
				elseif cls1.quality == cls2.quality then
					if tran1.name > tran2.name then
						return 1
					end
				end
			elseif sortType == 1 then
				local power1 = HeroDataProxy.getHeroAbility(cls1.heroId, cls1.level, cls1.wiseup, cls1.strengthen)
				local power2 = HeroDataProxy.getHeroAbility(cls2.heroId, cls2.level, cls2.wiseup, cls2.strengthen)
				if power1 < power2 then
					return 1
				end
			elseif sortType == 2 then
				if cls1.wiseup < cls2.wiseup then
					return 1
				end
			elseif sortType == 3 then
				if cls1.level < cls2.level then
					return 1
				end
			end
		end
		return 0
	end)
end

function HeroChangeView:sortGridByType(sortType)
	local function compFunc(cls1, cls2)
		if cls1 ~= nil and cls2 ~= nil then
			if sortType == 0 then
				if cls1.quality < cls2.quality then
					return true
				elseif cls1.quality == cls2.quality then
					if cls1.prefabName > cls2.prefabName then
						return true
					end
				end
			elseif sortType == 1 then
				local power1 = HeroDataProxy.getHeroAbility(cls1.heroId, cls1.level, cls1.wiseup, cls1.strengthen)
				local power2 = HeroDataProxy.getHeroAbility(cls2.heroId, cls2.level, cls2.wiseup, cls2.strengthen)
				if power1 < power2 then
					return true
				end
			elseif sortType == 2 then
				if cls1.wiseup < cls2.wiseup then
					return true
				end
			elseif sortType == 3 then
				if cls1.level < cls2.level then
					return true
				end
			end
		end
		return false
	end
	SortFunc(self.heroList, compFunc)
end

function HeroChangeView:selectHeroBoard(obj)
	if not obj then return end
	if self.selectBoard ~= nil then
		DestroyObject(self.selectBoard)
	end
	self.selectBoard = CreateObject(Util.LoadPrefab("UI/SelectedHeroBoard", AssetBundleInfo.assetBundles))
	ViewUtil.sortLayerOrder(self.selectBoard, LayerName.UI)
	HangObject(self.selectBoard, obj)
	self.selectBoard.transform.localPosition = Vector3.New(0, 4, 0)
	self.selectedHero = obj
end

function HeroChangeView:addExtra(extra)
	if IsEmpty(extra) then return end
	if IsEmpty(self.extra) then
		self.extra = {}
	end
	for key, val in pairs(extra) do
		self.extra[key] = val
	end
end

function HeroChangeView:showHeros0(hideList)
--	hideList = split(hideList, ",")
--	self.hideList = hideList -- ֹһβˢ
--	local lastModule = ViewUtil.getLastModule(self.name)
--	if lastModule == ModuleName.FC then
--		self.heroNum.text = self.herosAmount - CountTable(self.hideList) + 1
--	else
--		self.heroNum.text = self.herosAmount
--	end
--	local tran = self.gridObj.transform
--	if tran.childCount <= 0 then return end
--	for i = 0, tran.childCount - 1 do
--		local child = tran:GetChild(i)
----		child.gameObject:SetActive(true)
--        local lb = GetComponent(child, "LuaBehaviour")
--		if lb then
--			local hc = lb.sourceLuaObj
--			if IsMember(tostring(hc.onlyId), hideList) then
--				child.gameObject:SetActive(false)
--			end
--		end
--	end
--	self.hideList = nil
--	ResetGrid(self.gridObj)
end

--[[
    ָӢ
]]
function HeroChangeView:hideHeros (_tab)
--    local luaBhvi, hClass = nil, nil;

--    for i = 1, #_tab do
--        for j = 1, self.heroList:getSize() do
--            luaBhvi = GetComponent(self.heroList[j].heroObj, "LuaBehaviour");
--            if (nil ~= luaBhvi) then
--                hClass = luaBhvi.sourceLuaObj;
--                if (nil ~= hClass) then
--                    if (tonumber(_tab[i]) == tonumber(hClass.onlyId)) then
--                        self.heroList[j].heroObj:SetActive(false);
--                        break ;
--                    end
--                end
--            end
--        end
--    end
--	ResetGrid(self.gridObj)

	local hClass = nil
	for i = 1, #_tab do
		for j = self.heroList.size, 1, -1 do
			hClass = self.heroList[j]
			 if tonumber(_tab[i]) == tonumber(hClass.onlyId) then
				self.heroList:removeAt(j)
			 end
		end
	end
	self.wrap:SortBasedOnScrollMovement()
end

function HeroChangeView:doClickHero(obj)
	if not obj then return end
--	self:selectHeroBoard(obj)

	local lb = GetComponent(obj.transform, "LuaBehaviour")
	local heroClass = lb.sourceLuaObj
	local lastModule = ViewUtil.getLastModule(self.name)
	if lastModule ~= nil then
		local ctrl = ModuleManager.GetCtrl(lastModule)
		if ctrl then ctrl.changeHero(heroClass, self.extra) end
	end
	self:closeView(true)
    if (PlayerData.guideNotEnd()) then
        Facade:sendNotification(MVCConst.GUIDE_SAVEGUIDE, {});
        Facade:sendNotification(MVCConst.GUIDE_NEXT, {[2] = TeamData.GetCurPageIndex()});
    end
end
