require "Game/HeroGuide/View/HeroGuideHerosRow"
require "Game/HeroGuide/View/HeroGuideView"
require "Game/HeroGuide/View/HeroGuidePerHero"
 
HeroGuideControler = {}

local this = HeroGuideControler

function HeroGuideControler.New()
	return this
end

function HeroGuideControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = HeroGuideView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function HeroGuideControler.Awake()

end

function HeroGuideControler.Start()
	this.view:Start(this.data)
end

function HeroGuideControler.Update()
end

function HeroGuideControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function HeroGuideControler.initListener()
end

function HeroGuideControler.listNotificationInterests()
    local list = {
        MVCConst.ON_RECV_DATA,
        MVCConst.HERO_SORTCHOSENOTE,
        MVCConst.REFRESHPANE
    }
    return unpack(list)
end

function HeroGuideControler.handleNotification(note)
    local nName, nBody, nType, isChge = nil, nil, nil, false;

    nName = note:getName();
    nBody = note:getBody();
    nType = note:getType();

    if (MVCConst.HERO_SORTCHOSENOTE == nName) then
        if (0 == nBody[1]) then
            --显示类型
            if (this.view.showType ~= nBody[2]) then
                isChge = true;
                this.view.showType = nBody[2];
            end
        else
            --排序类型
            if (this.view.sortType ~= nBody[2]) then
                isChge = true;
                this.view.sortType = nBody[2];
            end
        end

        if (isChge) then
            ResetScrollView(this.view.scv);
            LuaCallManager:invokeCall(function () 
                this.view:sortHeroDataList(this.view.sortType);
                this.view:addHerosToSclView(1);
                this.view.uiWrapContent:SortBasedOnScrollMovement();
                this.view:refreshScv();
            end, 0.2);
        end
    elseif (MVCConst.REFRESHPANE == nName) then
        if (nBody[1] == ModuleName.TJ) then
            this.view:refreshPane();
        end
    end
end

function HeroGuideControler.accept(data)
	ViewUtil.initData(this, data)
end
