--单行英雄
--动态填充英雄数据，提高性能
--2016-8-20 10:51:43 library

HeroGuideHerosRow = class();

function HeroGuideHerosRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;
end

--[[

]]
function HeroGuideHerosRow:Awake (_go, _goSprite)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.goSprite = _goSprite;--遮挡层

    self.heroGOList = List.new();--英雄GO List<GameObject>
    self.heroDataList = List.new();--英雄数据 List<{heroId, heroCfg}>

    self:initPanel();
end

--[[

]]
function HeroGuideHerosRow:initPanel ()
    local heroTmp = nil;

    for i = 1, 5 do
        heroTmp = GetGameObject(self.transform, "Hero_" .. (i - 1));
        self.heroGOList:add(heroTmp);
    end
end

--[[
    设置数据
    _list List<>
]]
function HeroGuideHerosRow:setData (_list)
    _list = _list or List.new();
    self.heroDataList = _list;
    
    self:showHerosNoLua();
end

--[[

]]
function HeroGuideHerosRow:showHerosNoLua ()
    local heroTmp, heroDataTmp, len = nil, nil, 0;

    len = self.heroDataList.size;
    
    if (len > self.heroGOList.size) then
        len = self.heroGOList.size;
    end

    for i = 1, len do
        heroTmp = self.heroGOList[i];
        heroTmp:SetActive(true);
        heroDataTmp = self.heroDataList[i];

        self:setPerHeroData(heroTmp, heroDataTmp[1], heroDataTmp[2]);
    end

    for i = len + 1, self.heroGOList.size do
        self.heroGOList[i]:SetActive(false);
    end
end

--[[

]]
function HeroGuideHerosRow:setPerHeroData (_go, _hId, _hCfg)
    local heroBGTmp = GetGameObject(_go.transform, "BG");
    local heroSpriteTmp = GetGameObject(_go.transform, "Sprite");

    GetComponent(heroBGTmp, "UISprite").spriteName = "class" .. HeroDataProxy.getHeroQuality(_hCfg);
    GetComponent(heroSpriteTmp, "UISprite").spriteName = HeroDataProxy.getHeroAtlasName(_hCfg);
    GetComponent(_go, "UIButton").normalSprite = "class" .. HeroDataProxy.getHeroQuality(_hCfg);

    ViewUtil.AddClickEvent(_go, function () 
        HeroPropControler.accept(_hCfg);
        ViewUtil.openView(ModuleName.HP, true);
    end);

    local tab = {heroId = _hId};
    local maskTmp = GetGameObject(_go.transform, "Hero_Mask");
    
    if (not HeroDataProxy.isEverGet(tab)) then
        if (nil == maskTmp) then
            maskTmp = CreateObject(self.goSprite);
            maskTmp.name = "Hero_Mask";
            GetComponent(maskTmp, "UISprite").width = 105;
            GetComponent(maskTmp, "UISprite").height = 105;
            maskTmp:SetActive(true);
            HangObject(maskTmp, _go);
            ViewManager.SortDepth(_go);
        end
    else
        if (nil ~= maskTmp) then
            DestroyObject(maskTmp);
        end
    end
end

--[[

]]
function HeroGuideHerosRow:showHeros ()
    local heroTmp, heroDataTmp, len = nil, nil, 0;
    local luaBhvi, perHero = nil, nil;

    len = self.heroDataList.size;
    
    if (len > self.heroGOList.size) then
        len = self.heroGOList.size;
    end
    
    for i = 1, len do
        perHero = nil;
        heroTmp = self.heroGOList[i];
        heroTmp:SetActive(true);
        heroDataTmp = self.heroDataList[i];
        luaBhvi = GetComponent(heroTmp, "LuaBehaviour");
        if (luaBhvi) then
            perHero = luaBhvi.sourceLuaObj;
        end

        if (nil == perHero) then
            perHero = HeroGuidePerHero.new();
            perHero:Awake(heroTmp, self.goSprite);
            PanelManager:BindPanelScript(perHero, heroTmp, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        end

        perHero:setData(heroDataTmp[1], heroDataTmp[2]);
    end

    for i = len + 1, self.heroGOList.size do
        self.heroGOList[i]:SetActive(false);
    end
end