
local baseVector = Vector3.New(-218, -72, 0);
local baseWid = 110;
local baseHei = 112;
local COLNUM = 5;

HeroGuideView = class(BaseView)

function HeroGuideView:ctor()
end  

function HeroGuideView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
    
    self.scvBasePos = nil;--Vector3，ScrollView第一次初始化后的localPosition
    self.panelClipOffset = nil;--Vector2，ScrollView的UIPanel第一次初始化后的clipOffset
    self.sortType = 0;--排序类型
    self.showType = 0;--显示类型
    self.heroDataList = List.new();--英雄数据列表，List<{heroId, heroCfg}>
    self.sltHeroDataList = List.new();--排序后的英雄数据列表，List<{heroId, heroCfg}>

    self.heroListBG = nil;
    self.scv = nil;
    self.goSprite = nil;

	self.selectBoard = nil
    self.heroNumGO = nil;

	self:initPanel();
end

function HeroGuideView:Start(data)
	self:initData(data)
end

function HeroGuideView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)

	local topPath = "Mode/Top/Panel"
    self.heroNumGO = GetGameObject(self.transform, topPath .. "/SliceBG/Num")
	self.heroNum = GetComponent(self.heroNumGO, "UILabel")
	
	local bottomPath = "Mode/Bottom/Panel/";
    local heroListBGPath = "Mode/Top/Panel/HeroListBG";
	local scvPath = "Mode/Top/Panel/HeroListBG/";

-- 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
-- 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
--	self.top:SetAnchor(self.root.transform)
--	self.bottom:SetAnchor(self.root.transform)
    
    self.heroListBG = GetGameObject(self.transform, heroListBGPath);
    self.goSprite = GetGameObject(self.heroListBG.transform, "GOSprite");
    self.goSprite:SetActive(false);
	
	self.scv = GetGameObject(self.transform, heroListBGPath .. "/ScrollView");
	self.wrapContent = GetGameObject(self.transform, heroListBGPath .. "/ScrollView/WrapContent");
    self.uiWrapContent = GetComponent(self.wrapContent.transform, "UIWrapContent");
    self.wrapGrid = GetComponent(self.wrapContent.transform, "UIGrid");

	ViewUtil.adaptUISize(self.heroListBG, true, 40, 80, 20, 20)
	ViewUtil.adaptUISize(self.scv, false, 60, 150, 20, 20)

 	self.btnBack = GetGameObject(self.transform, bottomPath.."BtnBack")
 	self.btnSort = GetGameObject(self.transform, bottomPath.."BtnSort")

    local function doClick(obj)
		if obj == self.btnBack then
			self:closeView(true)
		elseif obj == self.btnSort then
			ViewUtil.openView(ModuleName.SC, true, 
                function () 
                    Facade:sendNotification(MVCConst.HERO_SORTCHOSEOPEN, {[1] = ModuleName.TJ, [2] = LogicUtil.quaToShowType(self.showType)}, nil);
                end, nil
            );
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnSort).onClick = doClick
    ViewUtil.AddClickEvent(self.btnBack, doClick)
    ViewUtil.AddClickEvent(self.btnSort, doClick)
    
    self:initAllHeros();
    self:sortHeroDataList(self.sortType);
    self:addHerosToSclView();
    self:showHeroNum();
end

--[[
    生成所有英雄的数据，放到列表中
    return nil
]]
function HeroGuideView:initAllHeros ()
    local hCfg, hero, heroData = nil, nil, nil;

    self.heroDataList:clear();
    hero, heroData = nil, nil;

    for k, v in pairs(Config.getHerosData()) do
        hCfg = v;
        
        if (
            "" ~= HeroDataProxy.getHeroAtlasName(hCfg) and 
            tonumber(k) < HeroDataProxy.const_MaxHeroId and 
            1 ~= tonumber(k) and
            2 ~= tonumber(k)
            ) then
            heroData = {tonumber(k), hCfg};
            self.heroDataList:add(heroData);
        end
    end
end

--[[
    _tp number 0，默认排序；
    return nil
]]
function HeroGuideView:sortHeroDataList (_tp)
    local heroDataFir, heroDataSec, hCfgFir, hCfgSec = nil, nil, nil, nil;

    _tp = _tp or 0;
    self.sortType = _tp;
    for i = 1, self.heroDataList:getSize() do
        heroDataFir = self.heroDataList[i];
        hCfgFir = heroDataFir[2];
        for j = i + 1, self.heroDataList:getSize() do
            heroDataSec = self.heroDataList[j];
            hCfgSec = heroDataSec[2];

            if (0 == _tp) then
                if (HeroDataProxy.getHeroQuality(hCfgFir) < HeroDataProxy.getHeroQuality(hCfgSec)) then
                    self.heroDataList[i] = heroDataSec;
                    self.heroDataList[j] = heroDataFir;
                    heroDataFir = heroDataSec;
                    hCfgFir = hCfgSec;
                end
            end
        end
    end
end

--[[
    添加要显示的英雄到ScrollView
    return nil
]]
function HeroGuideView:addHerosToSclView (_tp)
    local isType, heroDataTmp, cnt = false, nil, 0;
    
    _tp = _tp or 0;

    self:sortHeroDataList(self.sortType);
    self:setSltHeroDataList();
    
    self.uiWrapContent.minIndex = 1 - math.ceil(self.sltHeroDataList.size / COLNUM);
    self.uiWrapContent.maxIndex = 0;
    self.uiWrapContent.enabled = true;

    self.uiWrapContent.onInitializeItem = function (_go, _index, _realIndex)
        self:showHeros(_go, _realIndex);
    end

	ResetScrollView(self.scv)
    if (0 == _tp) then
        local lPos = self.scv.transform.localPosition;
        local coSet = GetComponent(self.scv, "UIPanel").clipOffset;
        self.scvBasePos = Vector3.New(0, lPos.y, lPos.z);
        self.panelClipOffset = Vector2.New(coSet.x, coSet.y);
    end
end

--[[

]]
function HeroGuideView:showHeros (_go, _realIndex)
    local luaBhvi, hRows, idx, len = nil, nil, 0, 0;
    local listTmp = List.new();

    luaBhvi = GetComponent(_go.transform, "LuaBehaviour");
    
    if (luaBhvi) then
        hRows = luaBhvi.sourceLuaObj;
    end

    if (null == hRows) then
        hRows = HeroGuideHerosRow.new();
        hRows:Awake(_go, self.goSprite);
        PanelManager:BindPanelScript(hRows, _go, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end

    len = self.sltHeroDataList.size;
    idx = self.uiWrapContent.maxIndex - 1 * _realIndex + 1;
    
    for i = 1, COLNUM do
        if ((idx - 1) * COLNUM + i <= len) then
            listTmp:add(self.sltHeroDataList[(idx - 1) * COLNUM + i]);
        else
            break ;
        end
    end
    hRows:setData(listTmp);
end

--[[
    设置筛选数据
]]
function HeroGuideView:setSltHeroDataList ()
    local hDataTmp, len, isType = nil, 0, false;

    self.sltHeroDataList:clear();
    len = self.heroDataList.size;

    for i = 1, len do
        hDataTmp = self.heroDataList[i];
        isType = self:isSameType(hDataTmp[2]);
        
        if (isType) then
            self.sltHeroDataList:add(hDataTmp);
        end
    end
end

--[[
    判断是否是需要显示的类型
]]
function HeroGuideView:isSameType (_hCfg)
    local isType = false;

    if (self.showType >= 0 and self.showType <= 6) then
        if (0 == self.showType) then
            isType = true;
        else
            isType = (self.showType == tonumber(HeroDataProxy.getHeroQuality(_hCfg)));
        end
    end

    return isType;
end

--[[
    显示英雄详细
    return nil
]]
function HeroGuideView:showHeroNum ()
    self.heroNum.text = #TeamData.gotHeros .. "/" .. HeroDataProxy.allHeroNum()
end

function HeroGuideView:initData(data)
	
end

--[[
    刷新面板
]]
function HeroGuideView:refreshPane ()
    self:showHeroNum();
    self:refreshHeroMasks();
end

--[[

]]
function HeroGuideView:refreshHeroMasks ()
    local rowLua = nil;

    for i = 1, #self.heroDataList do
        rowLua = self.heroDataList[i];
--        rowLua:drawMask();
    end
end

--[[

]]
function HeroGuideView:refreshScv ()
    local pane = nil;

    pane = GetComponent(self.scv, "UIPanel");
    self.scv.transform.localPosition = self.scvBasePos;
    pane.clipOffset = self.panelClipOffset;

    LuaCallManager:invokeCall(function () 
        pane.clipOffset = Vector2.New(0, pane.clipOffset.y - 0.005);
    end, 0.05);
    LuaCallManager:invokeCall(function () 
        pane.clipOffset = Vector2.New(0, pane.clipOffset.y + 0.005);
    end, 0.1);
end