HeroInfo = class(BaseHero)
 
function HeroInfo:ctor()
	self.prefabName = nil
	self.quality = nil
end

function HeroInfo:init(heroClass)
	self.onlyId = tonumber(heroClass.onlyId)
	self.heroId = tostring(heroClass.heroId)
	self.prefabName = heroClass.prefabName
	self.quality = tonumber(heroClass.quality)
	self.name = heroClass.heroName or "无名氏"
	self.level1 = heroClass.level or 0
	self.level2 = heroClass.level or 0
	self.wiseup1 = heroClass.wiseup or 0
	self.wiseup2 = heroClass.wiseup or 0
	self.strengthen1 = heroClass.strengthen or 0
	self.strengthen2 = heroClass.strengthen or 0
	self.soldiers1 = heroClass.soldiers or 0
	self.soldiers2 = heroClass.soldiers or 0
	self.power1 = HeroDataProxy.getHeroAbility(self.heroId, self.level1, self.wiseup1, self.strengthen1)
	self.power2 = HeroDataProxy.getHeroAbility(self.heroId, self.level1, self.wiseup1, self.strengthen1)
end

function HeroInfo:createHeroInfo()
	self.obj = CreateObjectByPath("UI/HeroInheritInfo", AssetBundleInfo.assetBundles)
	self.lblName = GetPathComponent(self.obj.transform, "HeroName", "UILabel")
	self.lblLevel = GetPathComponent(self.obj.transform, "Level", "UILabel")
	self.fightVal1 = GetPathComponent(self.obj.transform, "PropBG/FightVal/Val1", "UILabel")
	self.fightVal2 = GetPathComponent(self.obj.transform, "PropBG/FightVal/Val2", "UILabel")
	self.wiseupObj1 = GetPathComponent(self.obj.transform, "PropBG/Wiseup/Val1", "UILabel")
	self.wiseupObj2 = GetPathComponent(self.obj.transform, "PropBG/Wiseup/Val2", "UILabel")
	self.strengthenObj1 = GetPathComponent(self.obj.transform, "PropBG/Strengthen/Val1", "UILabel")
	self.strengthenObj2 = GetPathComponent(self.obj.transform, "PropBG/Strengthen/Val2", "UILabel")
	self.soldiersObj1 = GetPathComponent(self.obj.transform, "PropBG/Soldiers/Val1", "UILabel")
	self.soldiersObj2 = GetPathComponent(self.obj.transform, "PropBG/Soldiers/Val2", "UILabel")
	self.heroPlace = GetGameObject(self.obj.transform, "HeroPlace")
	
	local obj = self:createHero()
	HangObject(obj, self.heroPlace)
	ViewUtil.sortLayerOrder(self.obj, LayerName.UI)
	self:resetData()

	return self.obj
end

function HeroInfo:resetData()
	self.lblName.text = self.name
	self.lblLevel.text = "LV "..HeroDataProxy.getHeroShowLvl(self.level1, self.wiseup1) ..">>"..HeroDataProxy.getHeroShowLvl(self.level2, self.wiseup2)
	self.wiseupObj1.text = tostring(self.wiseup1).."/5"
	self.strengthenObj1.text = tostring(self.strengthen1).."/30"
	self.soldiersObj1.text = self.soldiers1
	self.fightVal1.text = self.power1

	self.wiseupObj2.text = tostring(self.wiseup2) .. "/5"
	self.strengthenObj2.text = tostring(self.strengthen2).."/30"
	self.soldiersObj2.text = self.soldiers2
	self.fightVal2.text = self.power2
end

function HeroInfo:initByHeroInfo(heroInfo)
	if not IsEmptyTable(heroInfo) then
		self.level2 = heroInfo.level1
		self.wiseup2 = heroInfo.wiseup1
		self.strengthen2 = heroInfo.strengthen1
		self.soldiers2 = heroInfo.soldiers1
		self.power2 = HeroDataProxy.getHeroAbility(self.heroId, self.level2, self.wiseup2, self.strengthen2)
	end
	self:resetData()
end

function HeroInfo:inverseData()
	self.level1, self.level2 = SwitchData(self.level1, self.level2)
	self.wiseup1, self.wiseup2 = SwitchData(self.wiseup1, self.wiseup2)
	self.strengthen1, self.strengthen2 = SwitchData(self.strengthen1, self.strengthen2)
	self.soldiers1, self.soldiers2 = SwitchData(self.soldiers1, self.soldiers2)
	self.power1, self.power2 = SwitchData(self.power1, self.power2)
	self:resetData()

	local heroClass = {}
	heroClass.onlyId = self.onlyId
	heroClass.heroId = self.heroId
	heroClass.level = self.level1 or 0
	heroClass.wiseup = self.wiseup1 or 0
	heroClass.strengthen = self.strengthen1 or 0
	heroClass.soldiers = self.soldiers1 or 0
	heroClass.power  = self.power1 or 0
	TeamData.updateHeroInfo(heroClass)
end

function HeroInfo:createHero()
	local hero = self.super.createHero(self, "UI/Hero")
	ViewUtil.addDragScrollView(hero)
	return hero
end
