require "Game/HeroInherit/View/HeroInfo"

HeroInheritView = class(BaseView)

--local cost_num = { 10, 20, 50, 100, 200, 300 }
local cost_num = { 0, 5, 10, 30, 100, 200 }
local const_costMny = "本次转换需要消耗 {1} 血钻，确定要转换吗？";
local const_lackOfMny = "血钻不足";

 function HeroInheritView:ctor()
end  

function HeroInheritView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
    self.noShowHeros = {};
	self:initPanel()
end

function HeroInheritView:Start(data)
	self:initData(data)
end

function HeroInheritView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
 	local topPath = "Mode/Top/Panel"
 	self.btnChange = GetGameObject(self.transform, topPath.."/SpriteBG/BtnChange")
 	self.btnInherit = GetGameObject(self.transform, topPath.."/SpriteBG/BtnInherit")
 	self.propBG1 = GetGameObject(self.transform, topPath.."/SpriteBG/PropBG1")
 	self.propBG2 = GetGameObject(self.transform, topPath.."/SpriteBG/PropBG2")
	self.noSelTitle1 = GetGameObject(self.transform, topPath.."/SpriteBG/NoSelTitle1")
	self.noSelTitle2 = GetGameObject(self.transform, topPath.."/SpriteBG/NoSelTitle2")
	
 	self.lblChange = GetPathComponent(self.transform, topPath.."/SpriteBG/BtnChange/Title", "UILabel")
 	self.lblInherit = GetPathComponent(self.transform, topPath.."/SpriteBG/BtnInherit/Title", "UILabel")
	self.lblChange.text = "继承英雄"
	self.lblInherit.text = "继承英雄"

	local bottomPath = "Mode/Bottom/Panel"
 	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")
 	self.btnConfirm = GetGameObject(self.transform, bottomPath.."/BtnConfirm")
	self.btnConfirm:SetActive(false)
	self.gemCost = GetPathComponent(self.transform, bottomPath.."/GemCost", "UILabel")
	self.gemCost.text = 0

    local function doClick(obj)
		if obj == self.btnBack then
--			self:closeView(true)
			ViewUtil.openView(ModuleName.HERO)
		elseif obj == self.btnChange then
			ViewUtil.openView(ModuleName.HC, true, function()
                local ctrl = ModuleManager.GetCtrl(ModuleName.HC)
				ctrl.view:showHeros()
				ctrl.view:addExtra({sw = 1})
                ctrl.view:hideHeros(self:getSltHeros());
			end)
		elseif obj == self.btnInherit then
			ViewUtil.openView(ModuleName.HC, true, function()
                local ctrl = ModuleManager.GetCtrl(ModuleName.HC)
				ctrl.view:showHeros()
				ctrl.view:addExtra({sw = 2})
                ctrl.view:hideHeros(self:getSltHeros());
			end)
		elseif obj == self.btnConfirm then
			if IsEmpty(self.hero1) or IsEmpty(self.hero2) then
				ViewUtil.showMsg("请选择英雄")
				return
			end

            local function cfmFunc()
			    Network.SendMoData(ServerID.HeroChange, {self.hero1.onlyId, self.hero2.onlyId}, function(session, params)
				    local serviceId = tonumber(session.serviceId)
				    local mo = GetProtoTable("DefaultData", session)
				    if mo.code == 0 then
					    ViewUtil.showMsg("转换成功")
					    self.hero1:inverseData()
					    self.hero2:inverseData()
				    else
					    ViewUtil.showMsg("转换失败")
				    end
			    end)
            end
            if (tonumber(self.gemCost.text) > PlayerData.getMyDiamond()) then
                ViewUtil.showMsg(const_lackOfMny);
                return ;
            end
            ViewUtil.comCfmPanel(string.gsub(const_costMny, "{1}", self.gemCost.text), cfmFunc);
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnChange).onClick = doClick
	-- UIEventListener.Get(self.btnInherit).onClick = doClick
	-- UIEventListener.Get(self.btnConfirm).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnChange, doClick)
	ViewUtil.AddClickEvent(self.btnInherit, doClick)
	ViewUtil.AddClickEvent(self.btnConfirm, doClick)
end

function HeroInheritView:initData(data)
	if IsEmpty(data) then return end
end

function HeroInheritView:changeHero(heroClass, extra)
	local hi = HeroInfo.new()
	hi:init(heroClass)
	hi:createHeroInfo()
	if extra and extra.sw == 1 then
		if self.hero1 then
			DestroyObject(self.hero1.obj)
			self.hero1 = nil
		end
		self.hero1 = hi
		self.heroName1 = self.hero1.prefabName
		self.heroQuality1 = self.hero1.quality
		HangObject(self.hero1.obj, self.propBG1)
		self.noSelTitle1:SetActive(false)
		self.lblChange.text = "更换"
	else
		if self.hero2 then
			DestroyObject(self.hero2.obj)
			self.hero2 = nil
		end
		self.hero2 = hi
		self.heroName2 = self.hero2.prefabName
		self.heroQuality2 = self.hero2.quality
		HangObject(self.hero2.obj, self.propBG2)
		self.noSelTitle2:SetActive(false)
		self.lblInherit.text = "更换"
	end
	if self.hero1 and self.hero2 then
		self.btnConfirm:SetActive(true)
		self.hero1:initByHeroInfo(self.hero2)
		self.hero2:initByHeroInfo(self.hero1)
		local maxQuality = self.hero1.quality
		if maxQuality < self.hero2.quality then
			maxQuality = self.hero2.quality
		end
		self.gemCost.text = cost_num[maxQuality] or 0
	end
end

--[[
    获取已经选择的英雄ID
    return table {}--onlyIds
]]
function HeroInheritView:getSltHeros ()
    local tab = {};

    if (not IsEmpty(self.hero1)) then
        table.insert(tab, self.hero1.onlyId);
    end
    if (not IsEmpty(self.hero2)) then
        table.insert(tab, self.hero2.onlyId);
    end
    
    return tab;
end