
HeroPropView = class(BaseView)

 function HeroPropView:ctor()
end  

function HeroPropView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.skillAmount = 1
	self.skillsData = Config.getSkillsData()
    self.data = nil;
end

function HeroPropView:Start(data)
	self:setData(data);
	self:initPanel();
    self:initData();
end

function HeroPropView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
    self.topGO = GetGameObject(self.transform, "Mode/Top");
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top"
	self.heroSprite = GetGameObject(self.transform, topPath.."/Panel1/HeroSprite")
	self.prop1 = GetPathComponent(self.transform, topPath.."/Panel1/PropBG/Prop1", "UILabel")
	self.prop2 = GetPathComponent(self.transform, topPath.."/Panel1/PropBG/Prop2", "UILabel")
	self.prop3 = GetPathComponent(self.transform, topPath.."/Panel1/PropBG/Prop3", "UILabel")
	self.prop4 = GetPathComponent(self.transform, topPath.."/Panel1/PropBG/Prop4", "UILabel")

	self.heroName = GetPathComponent(self.transform, topPath .. "/Panel1/heroBG/BG/HeroName", "UILabel")
	
    self.heroLabel = GetPathComponent(self.transform, topPath .. "/Panel1/heroBG/BG/Label", "UILabel");
    self.fragment = GetGameObject(self.transform, topPath .. "/Panel1/heroBG/BG/Fragment");
	self.descContent = GetPathComponent(self.transform, topPath.."/Panel2/DescBG/DescContent", "UILabel")
    self.descDetail = GetPathComponent(self.transform, topPath.."/Panel2/DescBG/DescDetail", "UILabel");

	self.btnSkills = {}
	self.btnSkills[1] = GetGameObject(self.transform, topPath.."/Panel2/SkillBoardBG/Skill1")
	self.btnSkills[2] = GetGameObject(self.transform, topPath.."/Panel2/SkillBoardBG/Skill2")
	self.btnSkills[3] = GetGameObject(self.transform, topPath.."/Panel2/SkillBoardBG/Skill3")
	self.btnSkills[4] = GetGameObject(self.transform, topPath.."/Panel2/SkillBoardBG/Skill4")
	self.btnSkills[5] = GetGameObject(self.transform, topPath.."/Panel2/SkillBoardBG/Skill5")

    self.fragment:SetActive(false);
	self.sprSkills = {}
    
	for i = 1, 5 do
        local skillSprite, sName = nil, "";
		self.sprSkills[i] = GetComponent(self.btnSkills[i].transform, "UIButton")
		self.sprSkills[i].normalSprite = "alpha";
        
        skillSprite = GetPathComponent(self.btnSkills[i].transform, "Sprite", "UISprite");
        
        if (i <= #self.skillIds) then
            sName = SkillDataProxy.getSkillIcon(SkillDataProxy.getSkillCfgById(self.skillIds[i]));
        end
        
        skillSprite.spriteName = sName;
	end
	
	local bottomPath = "Mode/Bottom/Panel"
 	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")
 	self.btnChange = GetGameObject(self.transform, bottomPath.."/BtnChange")
    self.btnChange:SetActive(false);

    local function doClick(obj)
		if obj == self.btnBack then
            if (HeroDataProxy.newHeroList.size < 1) then
                local ctlTmp = ModuleManager.GetCtrl(ModuleName.HP);
			    self:closeView(ctlTmp.openBefore)
                ctlTmp.openBefore = true;
                if (ctlTmp.openProp) then
                    ViewUtil.openView(ModuleName.PROP, true);
                    ctlTmp.openProp = false;
                end
            else
                ViewUtil.showNewHeros();
            end
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
		elseif obj == self.btnChange then
            ViewUtil.openView(ModuleName.EQUIP, true)
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnChange).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnChange, doClick)

    local function doClickSkills(obj)
		local function _selected(index)
			if index <= self.skillAmount then
				self:selectSkillBoard(obj)
			end
		end
		for i = 1, 5 do
			if obj == self.btnSkills[i] then
				_selected(i)
			end
		end
	end
	local function onPressSkills(tbl)
		if IsEmpty(tbl) then return end
		local go = tbl.obj
		local isPress = tbl.isPress
		local skillId = self.skillIds[tbl.idx]
        ViewUtil.showSkillTipsEvent(go, isPress, skillId)
		ViewUtil.showHerosTips(go, skillId, isPress)
	end
	for i, btn in pairs(self.btnSkills) do
		UIEventListener.Get(btn).onPress = doClickSkills
		ViewUtil.AddEventTrigger(btn, EventConst.onPress, onPressSkills, {isPress = true, obj = btn, idx = i})
		ViewUtil.AddEventTrigger(btn, EventConst.onRelease, onPressSkills, {isPress = false, obj = btn, idx = i})
        
--        if (nil ~= self.skillIds[i]) then
--            ViewUtil.showSkillTips(self.skillIds[i], btn);
--        end
	end
end

function HeroPropView:selectSkillBoard(obj)
	if not obj then return end
	if not self.selectBoard2 then
		self.selectBoard2 = CreateObject(Util.LoadPrefab("UI/SelectedSkillBoard", AssetBundleInfo.assetBundles))
		ViewUtil.sortLayerOrder(self.selectBoard2, LayerName.UI)
	end
	HangObject(self.selectBoard2, obj)
end

--[[
    data HeroCfg
]]
function HeroPropView:setData (data)
    self.data = data;
	self.skillIds = SkillDataProxy.getHeroSkills(self.data);
    self.skillAmount = #self.skillIds;
end

function HeroPropView:initData()
	if IsEmpty(self.data) then return end
	self.heroName.text = HeroDataProxy.getHeroName(self.data);
	self.prop1.text = HeroDataProxy.getHeroXG(self.data);
	self.prop2.text = HeroDataProxy.getHeroFY(self.data);
	self.prop3.text = HeroDataProxy.getHeroSB(self.data);
	self.prop4.text = HeroDataProxy.getHeroWZ(self.data);
	
    self.heroLabel.text = HeroDataProxy.heroQua[HeroDataProxy.getHeroQuality(self.data)];
	self.descContent.text = HeroDataProxy.getHeroDesc(self.data);
    self.descDetail.text = HeroDataProxy.getHeroContent(self.data);
    GetComponent(self.heroSprite, "UISprite").spriteName = HeroDataProxy.getHeroAtlasName(self.data);
    
	for i = 1, 5 do
		if i <= self.skillAmount then
			local skillId = tostring(self.skillIds[i])
			local skillInfo = self.skillsData[skillId]
			self.sprSkills[i].normalSprite = SkillDataProxy.getSkillIcon(skillInfo);
            
			if i == 1 then
				self:selectSkillBoard(self.btnSkills[1])
			end
		else
			self.sprSkills[i].normalSprite = "alpha"
		end
	end
    --只显示静态图片，不显示动态图片
--	self.prefabName = HeroDataProxy.getHeroAtlasName(self.data);
--	if IsEmpty(self.prefabName) then
--		ViewUtil.showMsg("英雄名没配置")
--	end
--	local prefab = CreateActorPrefab(self.prefabName)
--	if not prefab then
--		ViewUtil.showMsg("骨骼动画找不到英雄名："..self.prefabName)
--	end
--	local actor = CreateObject(prefab)
--	if actor then
--        GetComponent(self.heroSprite, "UI2DSprite").enabled = false;
--		HangObject(actor, self.heroSprite)
--		actor.transform.localScale = Vector3.New(2, 2, 0)
--		ViewUtil.sortLayerOrder(actor, LayerName.UI)

--        self.body = GetComponentInChildren(actor.transform, Spine.Unity.SkeletonAnimation.GetClassType());
--		self.skeletonAnimation = self.body:GetComponent(Spine.Unity.SkeletonAnimation.GetClassType())
--		Util.StopSpineAnimation(self.skeletonAnimation)
--		self.skeletonAnimation.loop = true
--		self.skeletonAnimation.AnimationName = AnimationName.IDLE
--	end
end
