--英雄传奇Controler类
--2016-7-13 10:46:02 library  
require "Game/HeroStory/View/HeroStoryCardItem"
require "Game/HeroStory/View/HeroStoryRwd"
require "Game/HeroStory/View/HeroStorySubItem"
require "Game/HeroStory/View/HeroStoryView"

local const_resetCostMny = "重置次数需要消耗 {1} 钻石，是否确定重置";
local const_resetErr = "今日剩余次数不为零，不能重置";
local const_resetSuccess = "重置成功";
local const_lackOfDiamond = "血钻不足";

HeroStoryControler = {
    gameObject = nil;
    transform = nil;
    heroStoryView = nil;
    luaBehaviour = nil;

    root = nil;
    isBtnChallenge = false;
    curId = 0;
};

local this = HeroStoryControler;

--[[

]]
function HeroStoryControler.New ()
    return this;
end

--[[

]]
function HeroStoryControler.OnCreate (_go, _name)
    this.gameObject = _go;
    this.transform = this.gameObject.transform;
    this.heroStoryView = HeroStoryView.new();
    this.heroStoryView.name = _name;
    this.luaBehaviour = GetComponent(this.gameObject, "LuaBehaviour");
    this.root = ViewUtil.getRootView();
    this.view = this.heroStoryView;
    this.heroStoryView:Awake(_go);

    HeroStoryProxy.initHeroStoryCfgKeys();
    HangObject(this.heroStoryView, this.root);
    this.request();
end

--[[

]]
function HeroStoryControler.initViewData (_data)
    this.heroStoryView:initData(_data);
    this.heroStoryView:Start();
    this.initListener();
    this.initPanel();
end

--[[

]]
function HeroStoryControler.initListener ()
    ViewUtil.AddButtonClickEvent(this.heroStoryView.backBtn, this.closeView, true);
    ViewUtil.AddButtonClickEvent(this.heroStoryView.resetBtn, this.resetHandle, true);
end

--[[

]]
function HeroStoryControler.initPanel ()
    local hsCardItem, itemTmp = nil, nil;
    
    for i = 1, this.heroStoryView.cardList:getSize() do
        itemTmp = this.heroStoryView.cardList[i];
        hsCardItem = HeroStoryCardItem.new();
        hsCardItem:Awake(itemTmp);
        PanelManager:BindPanelScript(hsCardItem, itemTmp, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end
    
    this.heroStoryView.uiWrapContent.minIndex = 1 - HeroStoryProxy.getHeroStoryCnt();
    this.heroStoryView.uiWrapContent.maxIndex = 0;
    this.heroStoryView.uiWrapContent.enabled = true;
    
    this.heroStoryView.uiWrapContent.onInitializeItem = function (_go, _index, _realIndex) 
        this.heroStoryView:OnUpdateSuperItem(_go, _realIndex);
    end
end

--[[

]]
function HeroStoryControler.resetHandle ()
    local mnyCost = 0;
    local roadId = HeroStoryProxy.getRoadIdById(this.view.id);
    local mapData, bufData = Map.new(), nil;
    local hrData = this.view:getHeroRoadData(roadId);
    
    if (hrData.count < HeroStoryProxy.dailyChgeCnt) then 
        ViewUtil.showMsg(const_resetErr);
        return ;
    end
    mapData:put("roadId", roadId);
    bufData = Network.reqParamEncode(mapData);
    mnyCost = HeroStoryProxy.getResetCostMny(this.view.id);
    if (mnyCost > PlayerData.getMyDiamond()) then
        ViewUtil.showMsg(const_lackOfDiamond);
        return ;
    end
    ViewUtil.comCfmPanel(string.gsub(const_resetCostMny, "{1}", mnyCost), function () 
        NetManager:SendData(this, bufData, ServerID.HeroStoryReset, nil, function (sd) this.resetCallBack(sd); end, "", doNthFunc);
    end);
end

--[[
    重置回调
    sd SessionData
    return nil
]]
function HeroStoryControler.resetCallBack (sd)
    local defData = nil;

    defData = GetProtoTable("DefaultData", sd);
    
    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    else
        ViewUtil.showMsg(const_resetSuccess);
        this.heroStoryView:setChgeNum(2);
    end
end

--[[

]]
function HeroStoryControler.closeView ()
    if (0 == this.heroStoryView.tp) then
        ViewUtil.closeView(ModuleName.HEROSTORY, true);
    else
        this.heroStoryView:showPanel(0);
    end
end

--[[
    挑战/扫荡后，同步数据，绘制面板
    _id number
    _lvl number
    _tp number 0，挑战；1，扫荡
    _cnt number 消耗掉的次数
    return nil
]]
function HeroStoryControler.synData (_id, _lvl, _tp, _cnt)
    this.heroStoryView:sysData(_id, _lvl, _tp, _cnt);
end

--[[

]]
function HeroStoryControler.listNotificationInterests ()
    local itsts = {MVCConst.INITDATA_HEROSTORY};

    return unpack(itsts);
end

--[[

]]
function HeroStoryControler.handleNotification (note)
    local nName, nBody, nType;
    
    nName = note:getName();
    nBody = note:getBody();
    nType = note:getType();
    
    if (MVCConst.INITDATA_HEROSTORY == nName) then
        this.initViewData(nBody[1]);
        if (this.isBtnChallenge) then
            if (this.curId > 0) then
                this.view:showPanel(1);
                this.view:subPanelInit(this.curId, HeroStoryProxy.getRoadIdById(this.curId));
            end
        end
        this.isBtnChallenge = false;
    end
end

function HeroStoryControler.request()
	Network.SendMoData(ServerID.HeroStoryEty, {}, function(session, params)
		local mo = GetProtoTable("HeroRoadMainData", session)
		this.accept(mo)
	end, {})
end

function HeroStoryControler.accept(data)
	Facade:sendNotification(MVCConst.INITDATA_HEROSTORY, {[1] = data}, "");
end

--[[

]]
function HeroStoryControler.OnDestroy ()
    this.gameObject = nil;
    this.heroStoryView = nil;
    this.view = nil;
    this.transform = nil;
    this.root = nil;

    if (not this.isBtnChallenge) then
        this.curId = 0;
    end
end
