--关卡类
--2016-7-16 18:28:17 library

local const_openTimeWordSuffix = "开放挑战";
local const_weekWords = {"一", "二", "三", "四", "五", "六", "日"};

HeroStoryCardItem = class();

--[[

]]
function HeroStoryCardItem:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.rwdBtn = nil;
    self.progressTxt = nil;

    self.ctl = nil;
    
    self.id = 0;
    self.hrData = nil;
    self.hrCfg = nil;
end

--[[

]]
function HeroStoryCardItem:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.ctl = ModuleManager.GetCtrl(ModuleName.HEROSTORY);

    self:initPanel();
    self:initListener();
end

--[[

]]
function HeroStoryCardItem:initPanel ()
    self.itemContainer = GetGameObject(self.transform, "ItemContainer");
    self.openTimeWord = GetGameObject(self.transform, "ItemContainer/OpenTimeWord");
    self.playerPic = GetGameObject(self.transform, "ItemContainer/playerPic");
    self.storyDesc = GetGameObject(self.transform, "ItemContainer/StoryDesc");
    self.progressTxt = GetGameObject(self.transform, "ItemContainer/ProgressTxt");
    self.smallName = GetGameObject(self.transform, "ItemContainer/smallName");

    self.rwdBtn = GetGameObject(self.transform, "RwdBtn");
end

--[[

]]
function HeroStoryCardItem:initListener ()
    ViewUtil.AddClickEvent(self.itemContainer, function () 
        local checkOpen = self:checkCardOpen();

        if (not checkOpen) then
            ViewUtil.showMsg(HeroStoryProxy.getOpenTimeWord(self.hrCfg) .. const_openTimeWordSuffix);
            return ;
        end
        self.ctl.heroStoryView:showPanel(1);
        self.ctl.heroStoryView:subPanelInit(self.id, self.hrData.roadId);
        self.ctl.heroStoryView.rwdPanel:SetActive(false);
    end)
    ViewUtil.AddClickEvent(self.rwdBtn, function () 
        self:showRwdPane();
    end)
end

--[[

]]
function HeroStoryCardItem:setRoadInfo (_id, _hrData)
    self.id = _id;
    self.hrData = _hrData;
    self.hrCfg = HeroStoryProxy.getHeroStoryCfgById(_id);
end

--[[

]]
function HeroStoryCardItem:showPanel ()
    GetComponent(self.progressTxt, "UILabel").text = (HeroStoryProxy.dailyChgeCnt - self.hrData.count) .. "/" .. HeroStoryProxy.dailyChgeCnt;
    GetComponent(self.openTimeWord, "UILabel").text = HeroStoryProxy.getOpenTimeWord(self.hrCfg) .. const_openTimeWordSuffix;
    GetComponent(self.storyDesc, "UILabel").text = HeroStoryProxy.getStoryTitle(self.hrCfg);
    GetComponent(self.smallName, "UILabel").text = HeroStoryProxy.getStoryTitle(self.hrCfg);
end

--[[

]]
function HeroStoryCardItem:showRwdPane ()
    local luaBhvi, heroStoryRwd, rwdPanel, rwd, rwdInfo = nil, nil, nil, nil, nil;

    self.rwdPanel = self.ctl.heroStoryView.rwdPanel;
    self.rwdPanel:SetActive(true);
    luaBhvi = GetComponent(self.rwdPanel, "LuaBehaviour");
    if (nil ~= luaBhvi) then
        heroStoryRwd = luaBhvi.sourceLuaObj;
    end
    if (nil == heroStoryRwd) then
        heroStoryRwd = HeroStoryRwd.new();
        heroStoryRwd:Awake(self.rwdPanel);
        PanelManager:BindPanelScript(heroStoryRwd, self.rwdPanel, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end
    rwd = HeroStoryProxy.getShowRwd(self.hrCfg);
    rwdInfo = self:dealRwd(rwd);
    heroStoryRwd:initData(rwdInfo);
    heroStoryRwd:showRwds();
end

--[[

]]
function HeroStoryCardItem:checkCardOpen ()
    local curDay = const_weekWords[PlayerData.getCurTimeStr(PlayerData.getCurSysTime())[8]];
    local isFind = false;

    isFind = (nil ~= string.find(HeroStoryProxy.getOpenTimeWord(self.hrCfg), curDay)) and true or false;

    return isFind;
end

--[[
    解析字符串，返回tab
    _rwd string
    return table etc,{{1030, 1}} {{propId, num}}
]]
function HeroStoryCardItem:dealRwd (_rwd)
    local rwdInfo, perRwd = {}, nil;
    local tmpRwd = LogicUtil.nSplitStrCfgs(_rwd);
    
    if ("string" == type(tmpRwd)) then
        tmpRwd = {tmpRwd};
    end
    for i = 1, #tmpRwd do
        perRwd = {tmpRwd[i], 1};
        table.insert(rwdInfo, perRwd);
    end
    
    return rwdInfo;
end