--难度关卡Item
--2016-7-16 10:37:51 library

local const_lackOfOptunty = "今日剩余次数不足";
--local const_chgeErr = "请先挑战低难度关卡";
--local const_quickGameErr = "请先通关所有难度";
--local const_quickGameSuccess = "经理，扫荡完成，本次扫荡获得了{1}！";
local const_quickGameSuccess = "经理，扫荡完成！";
local const_hardLvls = {"简单", "普通", "困难", "超难", "极限"};
local const_challengeWord = "挑 战";
local const_quickGameWord = "扫 荡";

HeroStorySubItem = class();

--[[

]]
function HeroStorySubItem:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.chgeBtn = nil;

    self.tp = 0;--按钮类型 0，挑战；1，扫荡
    self.id = 0;--关卡ID
    self.lvl = 0;--难度

    self.ctl = nil;
end

--[[

]]
function HeroStorySubItem:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self:initPanel();
end

--[[

]]
function HeroStorySubItem:initPanel ()
    self.chgeBtn = GetGameObject(self.transform, "ChgeBtn");
    self.chgeBtnText = GetGameObject(self.chgeBtn.transform, "ChgeText");
    self.ctl = ModuleManager.GetCtrl(ModuleName.HEROSTORY);
    self.lvlWords = GetGameObject(self.transform, "Lvl/LvlWords");
    self.descText = GetGameObject(self.transform, "descText");
    GetComponent(self.descText, "UILabel").text = "";
    
    ViewUtil.AddButtonClickEvent(self.chgeBtn, function () self:chgeFunc(); end, true);
end

--[[
    当前难度数据初始化
    _id 当前关卡ID
    _lvl 难度
    _tp 0，挑战；1，扫荡
    return nil
]]
function HeroStorySubItem:setData (_id, _lvl, _tp)
    self.id = _id or 0;
    self.lvl = _lvl or 1;
    self.tp = _tp or 0;
end

--[[

]]
function HeroStorySubItem:drawPanel ()
    GetComponent(self.chgeBtnText, "UILabel").text = (0 == self.tp and const_challengeWord or const_quickGameWord);
    GetComponent(self.lvlWords, "UILabel").text = const_hardLvls[self.lvl] or const_hardLvls[0];

    self:setBtnState();
end

--[[

]]
function HeroStorySubItem:setBtnState ()
    local hrData, isClick, state = nil, false, 3;

    hrData = self.ctl.view:getHeroRoadData(HeroStoryProxy.getRoadIdById(self.id));
    
    if (hrData.level >= self.lvl) then
        isClick = true;
        state = 0;
    end

    Util.EnableButton2D(self.chgeBtn, state, isClick);
end

--[[
    
]]
function HeroStorySubItem:chgeFunc ()
    local mapData, bufData  = Map.new(), nil;
    local serviceId = 0;
    local roadId = HeroStoryProxy.getRoadIdById(self.id);
    local hrData = self.ctl.view:getHeroRoadData(roadId);
    
    if (hrData.count >= HeroStoryProxy.dailyChgeCnt) then
        ViewUtil.showMsg(const_lackOfOptunty);
        return ;
    end

    if (0 == self.tp) then
        serviceId = ServerID.HeroStoryChge;
    else
        serviceId = ServerID.HeroStoryQuickGame;
    end

    mapData:put("roadId", HeroStoryProxy.getRoadIdById(self.id));
    mapData:put("level", self.lvl);

    bufData = Network.reqParamEncode(mapData);
    NetManager:SendData(self, bufData, serviceId, nil, function (sd) self:chgeSuccess(sd); end, "", doNthFunc);
end

--[[
    挑战/扫荡成功
    _sd SessionData
    return nil
]]
function HeroStorySubItem:chgeSuccess (_sd)
    local def, tipWords = nil, nil;

    def = GetProtoTable("DefaultData", _sd);
    
    if (0 ~= def.code) then
        ViewUtil.showMsg(GetWord(def.code));
        return ;
    else
        if (1 == self.tp) then
            local rwdInfo, layers = LogicUtil.nSplitStrCfgs(def.msg);
            local rwdsData, tmpRwd = {}, nil;

            if (1 == layers) then
                --1003:31:0, def.msg
                tmpRwd = {rwdInfo[1], rwdInfo[2]};
                table.insert(rwdsData, tmpRwd);
            else
                --1003:31:0,1004:30:0, def.msg
                rwdsData = rwdInfo;
            end
            self.ctl.view:showRwdPane(rwdsData);
        else
            self.ctl.isBtnChallenge = true;
            self.ctl.curId = self.id;
        end
        
        self.ctl.synData(self.id, self.lvl, self.tp, 1);
    end
end

--[[

]]
function HeroStorySubItem:getRwd ()
    local rwdStr = "";

    return rwdStr;
end