--HeroStory基本视图类
--2016-7-13 10:46:37 library

HeroStoryView = class();

--[[

]]
function HeroStoryView:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.scrollView = nil;
    self.uiWrapContent = nil;
    self.cardPane = nil;
    self.subPane = nil;
    self.subBaseItem = nil;
    self.rwdPanel = nil;
    self.resetBtn = nil;
    self.cntText = nil;

    self.backBtn = nil;

    self.heroRoadMainData = nil;--进度数据
    self.cardList = nil;--关卡列表
    self.subPaneList = nil;--子列表

    self.id = -1;
    self.roadId = -1;
    self.mainData = nil;--HeroRoadMainData
end

--[[

]]
function HeroStoryView:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.cardList = List.new();
end

--[[

]]
function HeroStoryView:Start ()
    self:initPanel();
end

--[[
    初始化数据
    _data HeroRoadMainData
    return nil
]]
function HeroStoryView:initData (_data)
    self.mainData = _data;
end

--[[

]]
function HeroStoryView:initPanel ()
    local svBasePane = "MainPanel/CardPanel";
    local svBase = svBasePane .. "/";
    local subBase = "MainPanel/SubPanel";

    self.cardPane = GetGameObject(self.transform, svBasePane);
    self.scrollView = GetGameObject(self.transform, svBase .. "ScrollView");
    self.uiWrapContent = GetPathComponent(self.scrollView.transform, "UIWrapContent", "UIWrapContent");
    self.subPane = GetGameObject(self.transform, subBase);
    self.subSV = GetGameObject(self.subPane.transform, "SubCardPanel/ScrollView");
    self.subGrid = GetGameObject(self.subSV.transform, "Grid");
    self.subBaseItem = GetGameObject(self.subPane.transform, "SubCardPanel/ScrollView/Grid/SubCard");
    self.resetBtn = GetGameObject(self.subPane.transform, "ResetBtn");

    self.backBtn = GetGameObject(self.transform, "MainPanel/BackBtn");
    self.rwdPanel = GetGameObject(self.transform, "MainPanel/RwdPanel");

    self.cntText = GetGameObject(self.subPane.transform, "RemainPKCnt/CntText");

    self.subTitleWord = GetGameObject(self.subPane.transform, "Title/Words");
    self.subIntroWord = GetGameObject(self.subPane.transform, "IntroWords/Text");

    for i = 1, 4 do
        self.cardList:add(GetGameObject(self.scrollView.transform, "UIWrapContent/StoryCard" .. (0 == (i - 1) and "" or (i - 1))));
    end

    self:initSubPane();
    self:showPanel(0);
end

--[[
    初始化难度等级面板
    return nil
]]
function HeroStoryView:initSubPane ()
    local copyItem = nil;
    
    if (nil == self.subPaneList) then
        self.subPaneList = List.new();
        self.subPaneList:add(self.subBaseItem);
        for i = 1, 4 do
            copyItem = CreateObject(self.subBaseItem);
            copyItem.name = "SubCard_" .. i;
            HangObject(copyItem, self.subGrid);
            self.subPaneList:add(copyItem);
        end
    end
end

--[[
    UIWrapContent的onInitializeItem的方法
]]
function HeroStoryView:OnUpdateSuperItem (_go, _realIndex)
    local idx = self.uiWrapContent.maxIndex - _realIndex + 1;
    local id = HeroStoryProxy.getHeroStroyIdByIdx(idx);
    
    self:showPerItem(_go, id);
end

--[[
    显示单个关卡的信息
    _go GameObject 
    _id number
    return null
]]
function HeroStoryView:showPerItem (_go, _id)
    local luaBhvi, cardItem = nil, nil;
    local hrData = nil;--HeroRoadData
    local roadId = HeroStoryProxy.getRoadIdById(_id);
    
    luaBhvi = GetComponent(_go.transform, "LuaBehaviour");
    if (nil ~= luaBhvi) then
        cardItem = luaBhvi.sourceLuaObj;
        if (nil ~= cardItem) then
            hrData = self:getHeroRoadData(roadId);
            cardItem:setRoadInfo(_id, hrData);
            cardItem:showPanel();
        end
    end
end

--[[
    切换面板的显示
    _tp 0，显示关卡面板；1，显示难度面板
    return nil
]]
function HeroStoryView:showPanel (_tp)
    local showCard = false;

    self.tp = _tp or 0;
    showCard = (0 == self.tp) and true or false;

    self.cardPane:SetActive(showCard);
    self.subPane:SetActive(not showCard);

    if (showCard) then
        GetComponent(self.scrollView, "UIScrollView"):Scroll(-0.02);--从二级面板返回时，部分item的事件不响应，稍微滚动后恢复
    end
end

--[[
    难度等级面板数据初始化
    return nil
]]
function HeroStoryView:subPanelInit (_id, _roadId)
    local luaBhvi, subItem, itemTmp = nil, nil, nil;--HeroStorySubItem
    local hrData, hrCfg = nil, nil;--HeroRoadData, Cfg
    
    self.id = _id;
    self.roadId = _roadId;
    hrCfg = HeroStoryProxy.getHeroStoryCfgById(self.id);
    hrData = self:getHeroRoadData(self.roadId);
    
    for i = 1, self.subPaneList:getSize() do
        subItem = nil;
        itemTmp = self.subPaneList[i];
        luaBhvi = GetComponent(itemTmp.transform, "LuaBehaviour");
        if (nil ~= luaBhvi) then
            subItem = luaBhvi.sourceLuaObj;
        end
        
        if (nil == subItem) then
            subItem = HeroStorySubItem.new();
            subItem:Awake(itemTmp);
            PanelManager:BindPanelScript(subItem, itemTmp, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        end
        
        subItem:setData(self.id, i, hrData.level > i and 1 or 0);
        subItem:drawPanel();
    end

    GetComponent(self.subTitleWord, "UILabel").text = HeroStoryProxy.getStoryTitle(hrCfg);
    GetComponent(self.subIntroWord, "UILabel").text = HeroStoryProxy.getStoryDesc(hrCfg);
    GetComponent(self.cntText, "UILabel").text = (HeroStoryProxy.dailyChgeCnt - hrData.count) .. "/2";
end

--[[
    显示关卡的奖励
    _rwdsData table
    return nil
]]
function HeroStoryView:showRwdPane (_rwdsData)
    local luaBhvi, heroStoryRwd = nil, nil;
    local rwdInfo = {};

    self.rwdPanel:SetActive(true);
    luaBhvi = GetComponent(self.rwdPanel, "LuaBehaviour");
    if (nil ~= luaBhvi) then
        heroStoryRwd = luaBhvi.sourceLuaObj;
    end
    if (nil == heroStoryRwd) then
        heroStoryRwd = HeroStoryRwd.new();
        heroStoryRwd:Awake(self.rwdPanel);
        PanelManager:BindPanelScript(heroStoryRwd, self.rwdPanel, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end

    heroStoryRwd:initData(_rwdsData);
    heroStoryRwd:showRwds();
    ViewManager.SortDepthOnly(self.rwdPanel);
end

--[[
    挑战/扫荡后，同步数据，绘制面板
    _id number
    _lvl number
    _tp number 0，挑战；1，扫荡
    _cnt number 消耗掉的次数
    return nil
]]
function HeroStoryView:sysData (_id, _lvl, _tp, _cnt)
    local hrData = nil;

    _tp = _tp or 0;
    _cnt = _cnt or 1;

    hrData = self:getHeroRoadData(HeroStoryProxy.getRoadIdById(_id));
    hrData.count = hrData.count + _cnt;
    
    --重绘相关面板
    self:rePaintPanel(_id);
end

--[[
    重绘面板
    _id number 
    return nil
]]
function HeroStoryView:rePaintPanel (_id)
    self:rePaintSuperPanel(_id);
    self:subPanelInit(_id, HeroStoryProxy.getRoadIdById(_id));
end

--[[
    关卡面板重绘
]]
function HeroStoryView:rePaintSuperPanel (_id)
    local luaBhvi, hsCardItem, cardItem, cardBar = nil, nil, nil, nil;

    for i = 1, self.cardList:getSize() do
        cardBar = self.cardList[i];
        luaBhvi = GetComponent(cardBar, "LuaBehaviour");
        if (nil ~= luaBhvi) then
            hsCardItem = luaBhvi.sourceLuaObj;
            if (nil ~= hsCardItem and _id == hsCardItem.id) then
                hsCardItem:showPanel();
            end
        end
    end
end

--[[
    根据ID取HeroRoadData
    _roadId number
    return HeroRoadData
]]
function HeroStoryView:getHeroRoadData (_roadId)
    local heroRoadData = nil;

    for i = 1, #self.mainData.heroRoadList do
        if (_roadId == self.mainData.heroRoadList[i].roadId) then
            heroRoadData = self.mainData.heroRoadList[i];
        end
    end

    if (nil == heroRoadData) then
        heroRoadData = {roadId = _roadId, count = 0, level = 1};
    end

    return heroRoadData;
end

--[[
    设置挑战次数
    _num number 可挑战次数
    return nil
]]
function HeroStoryView:setChgeNum (_num)
    local roadId = HeroStoryProxy.getRoadIdById(self.id);
    local hrData = self:getHeroRoadData(roadId);

    hrData.count = 0;
    GetComponent(self.cntText, "UILabel").text = _num .. "/2";
end
