--铸神兵面板
--2016-8-12 15:04:43 library

local const_allUpText = "铸神兵";
local const_strongFail = "铸神兵失败";
local const_strongSuc = "铸神兵成功";

HUAllUpPane = class();

--[[

]]
function HUAllUpPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.heroId = nil;
    self.id = 0;
    self.lvl = 0;
    self.callBack = nil;
end

--[[

]]
function HUAllUpPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self:initPanel();
    self:initListener();
end

--[[

]]
function HUAllUpPane:initPanel ()
    self.attLvl = GetGameObject(self.transform, "heroInfoPane/att/sLvlWord");
    self.defenceLvl = GetGameObject(self.transform, "heroInfoPane/defence/sLvlWord");
    self.dodgeLvl = GetGameObject(self.transform, "heroInfoPane/dodge/sLvlWord");
    self.kingLvl = GetGameObject(self.transform, "heroInfoPane/king/sLvlWord");

    self.strongBtn = GetGameObject(self.transform, "strongBtn");
    self.strongBtnText = GetGameObject(self.strongBtn.transform, "text");

    GetComponent(self.strongBtnText, "UILabel").text = const_allUpText;
end

--[[

]]
function HUAllUpPane:initListener ()
    if (0 == self.lvl) then
        -- UIEventListener.Get(self.strongBtn).onClick = function () self:strongHandle(); end
        ViewUtil.AddClickEvent(self.strongBtn, function () self:strongHandle(); end)
    else
        -- UIEventListener.Get(self.strongBtn).onClick = doNthFunc;
        ViewUtil.AddClickEvent(self.strongBtn, doNthFunc)
    end
end

--[[

]]
function HUAllUpPane:strongHandle ()
    local mapData, buf = Map.new(), nil;

    mapData:put("heroId", self.heroId);
    mapData:put("level", 1);

    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.HU_Weapon, ModuleName.HeroUpgrade, function (sd) self:strongCallBack(sd);end, nil, doNthFunc);
end

--[[

]]
function HUAllUpPane:strongCallBack (_sd)
    local defData = nil;

    defData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(const_strongFail);
        return ;
    end
    ViewUtil.showMsg(const_strongSuc);

    self:synData();

    if (nil ~= self.callBack) then
        self.callBack();
    end
end

--[[

]]
function HUAllUpPane:synData ()
    local hData = nil;

    self.lvl = 1;
    hData = TeamData.getMyHeroDataById(self.heroId);

    if (nil ~= hData) then
        hData.weapon = self.lvl;
    end

    self:initListener();
    self:addProp();

    if (nil ~= self.callBack) then
        self.callBack();
    end
end

--[[

]]
function HUAllUpPane:setData (_heroId, _id, _lvl, _callBack)
    self.heroId = _heroId;
    self.id = _id;
    self.lvl = _lvl;
    self.callBack = _callBack;

    self:initAbility();
    self:addProp();
end

--[[

]]
function HUAllUpPane:initAbility ()
    local fouAbi = self:getFouAbi();

    GetComponent(self.attLvl, "UILabel").text = fouAbi[1];
    GetComponent(self.defenceLvl, "UILabel").text = fouAbi[2];
    GetComponent(self.dodgeLvl, "UILabel").text = fouAbi[3];
    GetComponent(self.kingLvl, "UILabel").text = fouAbi[4];
end

--[[

]]
function HUAllUpPane:addProp ()

end

--[[

]]
function HUAllUpPane:getFouAbi ()
    local fouAbi = {1, 1, 1, 1};

    return fouAbi;
end