--强化、铸神兵、觉醒面板的容器 self.gameObject 为Prefab:HeroUpIntensifyPane的一个复制对象
--2016-8-10 14:03:04 library

local const_strgText = "强化";
local const_allUpText = "铸神兵";
local const_wakeup = "觉醒";

local const_tabNormal = "prop_tabNormalBG";
local const_tabChose = "prop_tabChoseBG";

HUIntensifyDetailPane = class(BaseView);

--[[
 
]]
function HUIntensifyDetailPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.strongPane = nil;
    self.allUpPane = nil;
    self.wakeupPane = nil;

    self.luaStrongPane = nil;
    self.luaAllUpPane = nil;
    self.luaWakeupPane = nil;

    self.heroData = nil;
    self.heroId = 0;
    self.curLvl = 0;
    self.curAllUp = 0;
    self.tp = -1;--显示类型 0，强化；1，铸神兵；2，觉醒

    self.synDataFunc = nil;
    self.closeFunc = nil;
end

--[[
 
]]
function HUIntensifyDetailPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self:initPanel();
    self:initListener();
end

--[[
 
]]
function HUIntensifyDetailPane:initPanel ()
    self.closeBtn = GetGameObject(self.transform, "CloseBtn");
    self.strongTab = GetGameObject(self.transform, "tabContainer/strongTab");
    self.strgText = GetGameObject(self.strongTab.transform, "tabText");
    self.allUpTab = GetGameObject(self.transform, "tabContainer/allUpTab");
    self.allUpText = GetGameObject(self.allUpTab.transform, "tabText");

    self.strongPane = GetGameObject(self.transform, "strongPane");
    self.allUpPane = GetGameObject(self.transform, "allUpPane");
    self.wakeupPane = GetGameObject(self.transform, "wakeupPane");
    
    GetComponent(self.strgText, "UILabel").text = const_strgText;
    GetComponent(self.allUpText, "UILabel").text = const_allUpText;

    --审核版本代码
    --2016-8-29 15:09:31 library START
    self.allUpTab:SetActive(false);
    self.strongTab.transform.localPosition = Vector3.New(96, self.strongTab.transform.localPosition.y, 0);
    --END
end

--[[
 
]]
function HUIntensifyDetailPane:initListener ()
    -- UIEventListener.Get(self.closeBtn).onClick = function () self:closePane(); end;
    -- UIEventListener.Get(self.strongTab).onClick = function () self:chgeTab(self.tp); end;
    -- UIEventListener.Get(self.allUpTab).onClick = function () self:chgeTab(self.tp); end;
    ViewUtil.AddClickEvent(self.closeBtn, function () self:closePane(); end)
    ViewUtil.AddClickEvent(self.strongTab, function () self:chgeTab(self.tp); end)
    ViewUtil.AddClickEvent(self.allUpTab, function () self:chgeTab(self.tp); end)
end

--[[

]]
function HUIntensifyDetailPane:closePane ()
    DestroyObject(self.gameObject);

    if (nil ~= self.closeFunc) then
        self.closeFunc();
    end

    if (PlayerData.guideNotEnd()) then
        Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
    end
end

--[[
    _heroData HeroData 英雄数据
    _tp number 显示类型 0，强化；1，铸神兵；2，觉醒
    _synDataFunc function 同步数据回调
    _closeFunc function 关闭面板的回调
]]
function HUIntensifyDetailPane:setData (_heroData, _tp, _synDataFunc, _closeFunc)
    self.heroData = _heroData;
    self.heroId = self.heroData.heroId;
    self.curLvl = self.heroData.strengthen;
    self.curAllUp = self.heroData.weapon;
    self.tp = _tp;

    self.synDataFunc = _synDataFunc;
    self.closeFunc = _closeFunc;

    self:chgeTab(_tp);
end

--[[
    _tp number 0，强化；1，铸神兵
]]
function HUIntensifyDetailPane:chgeTab (_tp)
    local sTxt, auTxt = "", "";

    _tp = _tp or -1;
    self.tp = _tp;
    if (0 == _tp or 2 == _tp) then
        sTxt = const_tabChose;
        auTxt = const_tabNormal;
    elseif (1 == _tp) then
        sTxt = const_tabNormal;
        auTxt = const_tabChose;
    end

    GetComponent(self.strongTab, "UISprite").spriteName = sTxt;
    GetComponent(self.allUpTab, "UISprite").spriteName = auTxt;

    self:showPane(_tp);
end

--[[
    _tp number 0，强化；1，铸神兵；2，觉醒
]]
function HUIntensifyDetailPane:showPane (_tp)
    local showStg, showAuUp, showWakeup = false, false, false;

    if (0 == _tp) then
        showStg = true;
        showAuUp = false;
        showWakeup = false;
    elseif (1 == _tp) then
        showStg = false;
        showAuUp = true;
        showWakeup = false;
    elseif (2 == _tp) then
        showStg = false;
        showAuUp = false;
        showWakeup = true;
    end

    self.strongPane:SetActive(showStg);
    self.allUpPane:SetActive(showAuUp);
    self.wakeupPane:SetActive(showWakeup);

    if (0 == _tp) then
        if (nil == self.luaStrongPane) then
            self.luaStrongPane = HUStrongPane.new();
            self.luaStrongPane:Awake(self.strongPane);
            PanelManager:BindPanelScript(self.luaStrongPane, self.strongPane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        end
        self.luaStrongPane:setData(self.heroId, self.heroData.id, self.curLvl, self.synDataFunc);
    end

    if (1 == _tp) then
        if (nil == self.luaAllUpPane) then
            self.luaAllUpPane = HUAllUpPane.new();
            self.luaAllUpPane:Awake(self.allUpPane);
            PanelManager:BindPanelScript(self.luaAllUpPane, self.allUpPane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        end
        self.luaAllUpPane:setData(self.heroId, self.heroData.id, self.curAllUp, self.synDataFunc);
    end

    if (2 == _tp) then
        self:showWakeupTitle();
        if (nil == self.luaWakeupPane) then
            self.luaWakeupPane = HUWakeupPane.new();
            self.luaWakeupPane:Awake(self.wakeupPane);
            PanelManager:BindPanelScript(self.luaWakeupPane, self.wakeupPane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        end
        self.luaWakeupPane:setData(self.heroId, self.heroData.id, self.heroData.level, self.heroData.wiseup, self.heroData.strengthen, self.synDataFunc, function () self:closePane(); end);
    end
end

--[[
    显示觉醒的标题
]]
function HUIntensifyDetailPane:showWakeupTitle ()
    GetPathComponent(self.transform, "BG/UpBG/Title", "UILabel").text = const_wakeup;
    GetComponent(self.strgText, "UILabel").text = const_wakeup;
end