--英雄强化条目
--2016-6-23 21:03:38 library.

local const_heroQuaPre = "class";

HUIntensifyRow = class();

function HUIntensifyRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.hData = nil;--HeroData
    self.heroCfg = nil;--table

    self.btn = nil;--GameObject
    self.hero = nil;--GameObject
    self.hrSmlUISprt = nil;--UISprite
    self.hrSprt = nil;--GameObject
    self.hrSprtUISprt = nil;--UISprite
    self.rowName = nil;--GameObject
    self.rowNameUILbl = nil;--UILabel
    self.lvlUILbl = nil;--UILabel
    self.fightValueUILbl = nil;--UILabel
    self.bsAblyUILbl = nil;--UILabel
    self.bsExpUILabl = nil;--UILabel

    self.propValueUILbl = nil;--UILabel
end

function HUIntensifyRow:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
end

function HUIntensifyRow:initData (_hData)
    self.hData = _hData;

    self.heroCfg = HeroDataProxy.getHeroCfgById(self.hData.heroId);
    self:initPanel();
end

function HUIntensifyRow:initPanel ()
    self.btn = GetGameObject(self.transform, "Btn").gameObject;
    self.hero = GetGameObject(self.transform, "Hero").gameObject;
    self.hrSmlUISprt = GetComponent(self.hero, "UISprite");
    self.hrSprt = GetGameObject(self.hero.transform, "Sprite");
    self.hrSprtUISprt = GetComponent(self.hrSprt, "UISprite");
    self.rowName = GetGameObject(self.transform, "Name").gameObject;
    self.rowNameUILbl = GetComponent(self.rowName, "UILabel");
    self.lvlUILbl = GetPathComponent(self.transform, "Lvl", "UILabel");
    self.fightValueUILbl = GetPathComponent(self.transform, "FightValue", "UILabel");
    self.bsAblyUILbl = GetPathComponent(self.transform, "Btn/Sprite/Label", "UILabel");
    self.bsExpUILabl = GetPathComponent(self.transform, "Btn/Sprite/LabelExp", "UILabel");
    self.propValue = GetGameObject(self.transform, "PropValue");
    self.propValueUILbl = GetPathComponent(self.transform, "PropValue", "UILabel");
    self.wakeLvl = GetPathComponent(self.transform, "wakeLvl", "UILabel");

    self.hrSmlUISprt.spriteName = const_heroQuaPre .. HeroDataProxy.getHeroQuality(self.heroCfg);
    self.hrSprtUISprt.spriteName = HeroDataProxy.getHeroAtlasName(self.heroCfg);
    
    if (1 ~= self.hData.heroId and 2 ~= self.hData.heroId) then
        self.rowNameUILbl.text = HeroDataProxy.getHeroName(self.heroCfg);
    else
        self.rowNameUILbl.text = PlayerData.playerData.team.teamName;
    end
    self.lvlUILbl.text = "LV" .. HeroDataProxy.getHeroShowLvl(self.hData.level, self.hData.wiseup);
    
    self.propValue:SetActive(false);
    self:changeRowShow();
end

function HUIntensifyRow:Start ()
	-- UIEventListener.Get(self.btn).onClick = function () self:showDetailPane(); end
    ViewUtil.AddClickEvent(self.btn, function () self:showDetailPane(); end)
end

--[[

]]
function HUIntensifyRow:showDetailPane ()
    Facade:sendNotification(MVCConst.HU_INTENSIFY, {[1] = 0, [2] = self});
    if (PlayerData.guideNotEnd()) then
        Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
    end
end

function HUIntensifyRow:doClick ()
	local eff, effName, time, curVal = nil, nil, 0, 0;
    local cost = HeroDataProxy.getHeroLvlDeltaExp(self.hData.level + 1);
    
    if (cost > curVal) then
        effName = "InheritSucces";
        return ;
    else
        effName = "InheritSucces";
    end

    eff = CreateObject(Util.LoadPrefab("Effects/" .. effName, AssetBundleInfo.assetBundles));
	HangObject(eff, self.gameObject)
	time = GetParticleTime(eff)
	if time >= 0 then
		DestroyObject(eff, time)
	end

    local sendMsg = Map.new();
	sendMsg:put("id", self.hData.id);
    sendMsg:put("level", self.hData.level + 1);
	local buffer = Network.reqParamEncode(sendMsg);
	NetManager:SendData(self, buffer, ServerID.HU_Intensify, nil, doNthFunc, "", doNthFunc);

    self:changeData();
    self:changeRowShow();
end

--[[
    修改数据
    return nil
]]
function HUIntensifyRow:changeData()
    self.hData.strengthen = self.hData.strengthen + 1;
end

--[[
    更新数据之后，修改相关显示
    return nil
]]
function HUIntensifyRow:changeRowShow()
    local curAbility, nextAbility = 0, 0;
    local curWakeLvl, totalWakeLvl = 0, 0;

    curAbility = HeroDataProxy.getHeroAbility(self.hData.heroId, self.hData.level, self.hData.wiseup, self.hData.strengthen);
    nextAbility = HeroDataProxy.getHeroStrongPower(self.hData.strengthen);

    self.fightValueUILbl.text = "" .. curAbility;
    self.bsAblyUILbl.text = "+" .. nextAbility .. "%";
    self.bsExpUILabl.text = self.hData.strengthen .. "/" .. HeroDataProxy.maxStrongLvl;

    curWakeLvl = self.hData.wiseup;
    totalWakeLvl = HeroDataProxy.maxWakeLvl;
    self.wakeLvl.text = curWakeLvl .. "/" .. totalWakeLvl;

    ModuleManager.GetCtrl(ModuleName.HU).refreshTotalAbility();
end