--强化面板
--2016-8-11 20:17:23 library

local const_strongLvl = "强化等级";
local const_abilityUp = "战力提升";
local const_strongCfm = "确认强化";
local const_strongPerInfo = "强化成功率 {1}%";
local const_mnyCost = "使用钻石提高成功率";
local const_strongFail = "强化失败";
local const_strongSuccess = "强化成功";
local const_maxLvl = "已经强化至最大等级";
local const_lackOfProp = "道具数量不足";
local const_lackOfMny = "血钻不足";

local const_quaStr = "class";

HUStrongPane = class();

--[[

]]
function HUStrongPane:ctor ()
    self.gameObject = nil;
    self.transform = nil;
end

--[[

]]
function HUStrongPane:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.heroId = nil;
    self.id = 0;
    self.curLvl = nil;
    self.curPer = 0;
    self.basePer = 0;
    self.hCfg = nil;

    self.callBack = nil;

    self.propList = List.new();--强化消耗的道具列表 PropShowItem

    self:initPanel();
    self:initListener();
end

--[[

]]
function HUStrongPane:initPanel ()
    self.hero = GetGameObject(self.transform, "heroInfoPane/Hero");
    self.heroBG = GetGameObject(self.hero.transform, "BG");
    self.heroSprite = GetGameObject(self.hero.transform, "Sprite");

    self.sLvlWord = GetGameObject(self.transform, "heroInfoPane/sLvl/sLvlWord");
    self.scurLvl = GetGameObject(self.transform, "heroInfoPane/sLvl/curLvl");
    self.snextLvl = GetGameObject(self.transform, "heroInfoPane/sLvl/nextLvl");

    self.aLvlWord = GetGameObject(self.transform, "heroInfoPane/abilityAdd/sLvlWord");
    self.acurLvl = GetGameObject(self.transform, "heroInfoPane/abilityAdd/curLvl");
    self.anextLvl = GetGameObject(self.transform, "heroInfoPane/abilityAdd/nextLvl");

    self.mnyNeedInfo = GetGameObject(self.transform, "mnyNeedInfo");
    self.mnyNeedInfoDesc = GetGameObject(self.transform, "mnyNeedInfo/desc");
    self.mnyNeedInfoMny = GetGameObject(self.transform, "mnyNeedInfo/mny");
    
    self.successPercent = GetGameObject(self.transform, "successPercent");
    self.addBtn = GetGameObject(self.transform, "successPercent/addBtn");
    self.rdcBtn = GetGameObject(self.transform, "successPercent/rdcBtn");
    
    self.pctForBG = GetGameObject(self.transform, "successPercent/percentPane/forBG");
    self.pctText = GetGameObject(self.transform, "successPercent/percentPane/text");

    self.propListPane = GetGameObject(self.transform, "propListPane");
    self.propGrid = GetGameObject(self.propListPane.transform, "grid");

    self.strongBtn = GetGameObject(self.transform, "strongBtn");
    self.strongBtnText = GetGameObject(self.strongBtn.transform, "text");
    
    GetComponent(self.mnyNeedInfoDesc, "UILabel").text = const_mnyCost;
    GetComponent(self.sLvlWord, "UILabel").text = const_strongLvl;
    GetComponent(self.aLvlWord, "UILabel").text = const_abilityUp;
    GetComponent(self.strongBtnText, "UILabel").text = const_strongCfm;

--    self.mnyNeedInfo:SetActive(false);
--    self.successPercent:SetActive(false);
end

--[[

]]
function HUStrongPane:initListener ()
    -- UIEventListener.Get(self.addBtn).onClick = function () self:addPercent(1); end;
    -- UIEventListener.Get(self.rdcBtn).onClick = function () self:addPercent(-1); end;
    -- UIEventListener.Get(self.strongBtn).onClick = function () self:strongHandle(); end;
    ViewUtil.AddClickEvent(self.addBtn, function () self:addPercent(1); end)
    ViewUtil.AddClickEvent(self.rdcBtn, function () self:addPercent(-1); end)
    ViewUtil.AddClickEvent(self.strongBtn, function () self:strongHandle(); end)
end

--[[
    _cnt number
]]
function HUStrongPane:addPercent (_cnt)
    _cnt = _cnt or 0;
    self.curPer = self.curPer + _cnt;

    if (self.curPer < 1) then
        self.curPer = 1;
    end

    if (self.curPer > 100) then
        self.curPer = 100;
    end

    if (self.curPer < self.basePer) then
        self.curPer = self.basePer;
    end

    GetComponent(self.pctText, "UILabel").text = string.gsub(const_strongPerInfo, "{1}", self.curPer);
    mnyCost = self:getMnyCost(self.curLvl, self.curPer);
    GetComponent(self.mnyNeedInfoMny, "UILabel").text = "" .. mnyCost;
end

--[[

]]
function HUStrongPane:strongHandle ()
    local mapData, buf = Map.new(), nil;
    local props = HeroDataProxy.getHeroStrongProps(self.curLvl + 1);
    local pNum, isLackOfProp = 0, false;

    Util.EnableButton2D(self.strongBtn, 3, false);

    if (self.curLvl >= HeroDataProxy.maxStrongLvl) then
        ViewUtil.showMsg(const_maxLvl);
        return ;
    end

    if (self.curPer - self.basePer > PlayerData.getMyDiamond()) then
        ViewUtil.showMsg(const_lackOfMny);
        return ;
    end

    for i = 1, #props do
        local pNum = PropDataProxy.getPropNumByPropId(props[i][1]);
        if (pNum < tonumber(props[i][2])) then
            ViewUtil.showMsg(const_lackOfProp);
            isLackOfProp = true;
            break ;
        end
    end

    if (isLackOfProp) then
        return ;
    end

    mapData:put("id", self.id);
--    mapData:put("level", self.curLvl);
    mapData:put("percent", self.curPer - self.basePer);

    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.HU_Intensify, ModuleName.HeroUpgrade, function (sd) self:strongCallBack(sd); end, nil, doNthFunc);
end

--[[

]]
function HUStrongPane:strongCallBack (_sd)
    local defData;

    defData = GetProtoTable("DefaultData", _sd);
    
    if (0 < defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        Util.EnableButton2D(self.strongBtn, 0, true);
        return ;
    end

    if (0 == defData.code) then
        ViewUtil.showMsg(const_strongSuccess);
    else
        ViewUtil.showMsg(const_strongFail);
    end
    
    self.curLvl = tonumber(defData.msg);
    self:synData(1 + defData.code);

    if (nil ~= self.callBack) then
        self.callBack();
    end
    
    Util.EnableButton2D(self.strongBtn, 0, true);

    if (PlayerData.guideNotEnd()) then
        Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
    end
end

--[[
    同步强化数据及显示
    _tp number 0，强化失败；1，强化成功
]]
function HUStrongPane:synData (_tp)
    local hData = nil;

    hData = TeamData.getMyHeroDataById(self.id);

    if (nil ~= hData) then
        hData.strengthen = self.curLvl;
    end

    GetComponent(self.mnyNeedInfoMny, "UILabel").text = "0";
    self.curPer = self:getCurBasePer();
    self.basePer = self.curPer;
    GetComponent(self.pctText, "UILabel").text = string.gsub(const_strongPerInfo, "{1}", self.curPer);

    self:addProp();
    self:panelInfoRefresh();
end

--[[

]]
function HUStrongPane:setData (_heroId, _id, _lvl, _cb)
    self.heroId = _heroId;
    self.id = _id;
    self.curLvl = _lvl;
    self.callBack = _cb;

    self.hCfg = HeroDataProxy.getHeroCfgById(self.heroId);
    self.curPer = self:getCurBasePer();
    self.basePer = self.curPer;
    GetComponent(self.mnyNeedInfoMny, "UILabel").text = "0";
    GetComponent(self.pctText, "UILabel").text = string.gsub(const_strongPerInfo, "{1}", self.curPer);
    GetComponent(self.heroSprite, "UISprite").spriteName = HeroDataProxy.getHeroAtlasName(self.hCfg);
    GetComponent(self.heroBG, "UISprite").spriteName = const_quaStr .. HeroDataProxy.getHeroQuality(self.hCfg);

    self:addProp();
    self:panelInfoRefresh();
end

--[[

]]
function HUStrongPane:panelInfoRefresh ()
    local curStrongPer, nextStrongPer = 0, 0;

    curStrongPer = HeroDataProxy.getHeroStrongPower(self.curLvl);
    if (self.curLvl < HeroDataProxy.maxStrongLvl) then
        nextStrongPer = HeroDataProxy.getHeroStrongPower(self.curLvl + 1);
        GetComponent(self.snextLvl, "UILabel").text = "" .. (self.curLvl + 1);
        GetComponent(self.anextLvl, "UILabel").text = "+" .. nextStrongPer .. "%";
    else
        nextStrongPer = HeroDataProxy.getHeroStrongPower(self.curLvl);
        GetComponent(self.snextLvl, "UILabel").text = "" .. (self.curLvl);
        GetComponent(self.anextLvl, "UILabel").text = "+" .. curStrongPer .. "%";
    end
    
    GetComponent(self.scurLvl, "UILabel").text = "" .. self.curLvl;
    GetComponent(self.acurLvl, "UILabel").text = "+" .. curStrongPer .. "%";
end

--[[
    显示英雄
]]
function HUStrongPane:showHero ()
    local hCfg, hQua, pName = nil, nil, nil;
    local path = "heroInfoPane/Hero/";

    hCfg = HeroDataProxy.getHeroCfgById(self.heroId);
    hQua = HeroDataProxy.getHeroQuality(hCfg);
    pName = HeroDataProxy.getHeroAtlasName(hCfg);

    GetPathComponent(self.transform, path .. "BG", "UISprite").spriteName = "class" .. hQua;
    GetPathComponent(self.transform, path .. "Sprite", "UISprite").spriteName = pName;
end

--[[

]]
function HUStrongPane:getMnyCost (_lvl, _per)
    local mny = 0;
    
    mny = _per - self.basePer;

    return mny;
end

--[[

]]
function HUStrongPane:getCurBasePer ()
    local per = 100;
    
    per = HeroDataProxy.getHeroStrongPer(self.curLvl);
    per = per / 100;

    return per;
end

--[[

]]
function HUStrongPane:addProp ()
    local luaBhvi, spPane = nil, nil;--LuaBehaviour, HUShowPropsPane

    luaBhvi = GetComponent(self.propGrid, "LuaBehaviour");
    if (nil ~= luaBhvi) then
        spPane = luaBhvi.sourceLuaObj;
    end

    if (nil == spPane) then
        spPane = HUShowPropsPane.new();
        spPane:Awake(self.propGrid);
        PanelManager:BindPanelScript(spPane, self.propGrid, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end
    spPane:setData(HeroDataProxy.getHeroStrongProps(self.curLvl + 1));
    ViewUtil.sortLayerOrder(self.propGrid, LayerName.Dialog);
end