
local const_totalAbility = "总战力";

HeroUpgradeView = class(BaseView)

function HeroUpgradeView:ctor()
end  

function HeroUpgradeView:Awake(obj)
    self.gameObject = obj
    self.transform = obj.transform

    self.lvlUpRow = {}
    self.strongRow = {}

    self:initPanel()
end

function HeroUpgradeView:Start()
    self.sw = 1
    self:initData()
end

function HeroUpgradeView:initPanel()
    self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
    self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
    self.top:SetAnchor(self.root.transform)
    self.bottom:SetAnchor(self.root.transform)

    local scvPath = "Mode/Center/Panel/UpgradeIntensify/"
    self.scvBGSpr = GetPathComponent(self.transform, scvPath, "UISprite")
    self.scrollView = GetGameObject(self.transform, scvPath .. "ScrollView");
    self.scv = GetPathComponent(self.transform, scvPath .. "ScrollView", "UIScrollView")
    self.scvPanel = GetPathComponent(self.transform, scvPath .. "ScrollView", "UIPanel")
    -- ViewUtil.adaptScrollViewHeight(self.scvBGSpr, self.scvPanel, 140)

    local topPath = "Mode/Top/Panel/"
    self.btnUpgrade = GetGameObject(self.transform, topPath .. "Upgrade")
    -- 	self.buttonUpgrade = GetComponent(self.btnUpgrade.transform, "UIButton")
    self.btnIntensify = GetGameObject(self.transform, topPath .. "Intensify")
    -- 	self.buttonIntensify = GetComponent(self.btnIntensify.transform, "UIButton")
    self.totalAbilityLabel = GetPathComponent(self.transform, topPath .. "totalAbility", "MeshWord");

    local scPath1 = "UpgradeIntensify/ScrollView/Panel1"
    local scPath2 = "UpgradeIntensify/ScrollView/Panel2"
    local centerPath = "Mode/Center/Panel/"
    self.panelUpgrade = GetGameObject(self.transform, centerPath .. scPath1)
    self.panelIntensify = GetGameObject(self.transform, centerPath .. scPath2)
    self.contentUpgrade = GetGameObject(self.transform, centerPath .. scPath1 .. "/Grid")
    self.contentIntensify = GetGameObject(self.transform, centerPath .. scPath2 .. "/Grid")
    self.gridUpgrade = self.contentUpgrade:GetComponent(UIGrid.GetClassType())
    self.gridIntensify = self.contentIntensify:GetComponent(UIGrid.GetClassType())
    self:slideTab(1)

    local bottomPath = "Mode/Bottom/Panel/"
    self.btnBack = GetGameObject(self.transform, bottomPath .. "BtnBack")

    local function doClick(obj)
        if obj == self.btnUpgrade then
            self:slideTab(1)
        elseif obj == self.btnIntensify then
            self:slideTab(2)
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
        elseif obj == self.btnBack then
            self:closeView(true)
            if (PlayerData.guideNotEnd()) then
                if (FBControler and FBControler.view) then
                    FBControler.view:sortLvlupBtnDepth();
                end
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
        end
    end
    -- UIEventListener.Get(self.btnUpgrade).onClick = doClick
    -- UIEventListener.Get(self.btnIntensify).onClick = doClick
    -- UIEventListener.Get(self.btnBack).onClick = doClick
    ViewUtil.AddClickEvent(self.btnUpgrade, doClick)
    ViewUtil.AddClickEvent(self.btnIntensify, doClick)
    ViewUtil.AddClickEvent(self.btnBack, doClick)

    self:calculateTotalAbility();

    self.bottomPanel = GetGameObject(self.transform, "Mode/Bottom/Panel");
    ViewUtil.sortLayerOrder(self.bottomPanel, LayerName.Dialog);
    self.topPanel = GetGameObject(self.transform, "Mode/Top/Panel");
    ViewUtil.sortLayerOrder(self.topPanel, LayerName.Dialog);
end

--[[
    计算总战力
]]
function HeroUpgradeView:calculateTotalAbility()
    self.totalAbilityLabel.text = "" .. LogicUtil.getShowNum(TeamData.getMyCurTotalAbility());
end

function HeroUpgradeView:slideTab(sw)
    self.sw = sw or 1
    if self.sw == 1 then
        Util.EnableButton(self.btnUpgrade, ButtonState.Disabled, false)
        Util.EnableButton(self.btnIntensify, ButtonState.Normal, true)

        NGUITools.SetActive(self.panelUpgrade, true)
        NGUITools.SetActive(self.panelIntensify, false)
        self:createBars(0);
    else
        Util.EnableButton(self.btnUpgrade, ButtonState.Normal, true)
        Util.EnableButton(self.btnIntensify, ButtonState.Disabled, false)

        NGUITools.SetActive(self.panelUpgrade, false)
        NGUITools.SetActive(self.panelIntensify, true)
        self:createBars(1);
    end
end

--[[
    创建条目
    _tp number 0，升级 1，强化
    return nil
]]
function HeroUpgradeView:createBars(_tp)
    local hData = { };
    local heroIds = "";

    _tp = _tp or 0;
    
    if (
        nil ~= PlayerData.playerData and
        nil ~= PlayerData.playerData.team and
        nil ~= PlayerData.playerData.team.heros and
        #PlayerData.playerData.team.heros > 0
        ) then
        heroIds = TeamData.getMyCurTeamHeros();
        hData = self:getHeroDatasByIds(heroIds);
    end
    self.scrollView:SetActive(false);
    if (0 == _tp) then
        self.contentUpgrade:SetActive(false);
        self:createBarUprade(hData);
        self.contentUpgrade:SetActive(true);
        self.scrollView:SetActive(true);
        self.gridUpgrade.repositionNow = true;
        ResetGrid(self.contentUpgrade);
    else
        self.contentIntensify:SetActive(false);
        self:createBarIntensify(hData);
        self.contentIntensify:SetActive(true);
        self.scrollView:SetActive(true);
        self.gridIntensify.repositionNow = true;
        ResetGrid(self.contentIntensify);
    end

    self.scv:ResetPosition();
end

--[[
    根据ids取英雄数据list
    _ids string 英雄的列表
    return list 英雄数据列表
]]
function HeroUpgradeView:getHeroDatasByIds(_ids)
    _ids = _ids or "";
    local idsList = StrSplit(_ids, ",");
    local herosList = List.new();
    idsList = idsList or { };
    for i = 1, #idsList do
        if ("" ~= Trim(idsList[i])) then
            herosList:add(TeamData.getMyHeroDataById(tonumber(idsList[i])));
        end
    end

    return herosList;
end

--[[
    升级
    _hData 英雄数据
    return nil
]]
function HeroUpgradeView:createBarUprade(_hData)
    local childsCnt = self.contentUpgrade.transform.childCount;
    local go = nil;

    if (childsCnt > 0) then
    	-- 由于按钮置灰功能需要能够取到luRow数据，不能local，因此每次切换到升级界面都走一次下面的if判断创建row。 by iorinie
        -- local luaBhvi, luRow = nil, nil;
        -- for i = childsCnt - 1, 0, -1 do
        --     go = self.contentUpgrade.transform:GetChild(i).gameObject;
        --     luaBhvi = GetComponent(go, "LuaBehaviour");
        --     if (nil ~= luaBhvi) then
        --         luRow = luaBhvi.sourceLuaObj;
        --         if (nil ~= luRow) then
        --             luRow:changeRowShow();
        --         end
        --     end
        -- end
        for i = childsCnt - 1, 0, -1 do
        	go = self.contentUpgrade.transform:GetChild(i).gameObject;
        	DestroyObject(go);
        end
        childsCnt = 0;
    end

    if (nil ~= _hData and #_hData > 0 and childsCnt <= 0) then
        local pfab = Util.LoadPrefab("UI/BarHeroUpgrade", AssetBundleInfo.assetBundles);
        local hData = self:copyData(_hData);
        self:sortData(hData);

        for i = 1, #hData do
            local bar = CreateObject(pfab);
            -- local lvlUpRow = HULvlUpRow.new();
            self.lvlUpRow[i] = HULvlUpRow.new();

            self.lvlUpRow[i]:Awake(bar);
            self.lvlUpRow[i]:initData(hData[i]);
            self.lvlUpRow[i]:Start();
            PanelManager:BindPanelScript(self.lvlUpRow[i], bar, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
            HangObject(bar, self.contentUpgrade);
        end
    end
end

function HeroUpgradeView:createBarIntensify(_hData)
    local childsCnt = self.contentIntensify.transform.childCount;
    local go = nil;

    if (childsCnt > 0) then
        local luaBhvi, iRow = nil, nil;
        for i = childsCnt - 1, 0, -1 do
            go = self.contentIntensify.transform:GetChild(i).gameObject;
            luaBhvi = GetComponent(go, "LuaBehaviour");
            if (nil ~= luaBhvi) then
                iRow = luaBhvi.sourceLuaObj;
                if (nil ~= iRow) then
                    iRow:changeRowShow();
                end
            end
        end
    end

    if (nil ~= _hData and #_hData > 0 and childsCnt <= 0) then
        local pfab = Util.LoadPrefab("UI/BarHeroIntensify", AssetBundleInfo.assetBundles);
        local hData = self:copyData(_hData);
        self:sortData(hData);

        for i = 1, #hData do
            local bar = CreateObject(pfab);
            -- local lvlUpRow = HUIntensifyRow.new();
            self.strongRow[i] = HUIntensifyRow.new();

            HangObject(bar, self.contentIntensify);
            -- lvlUpRow:Awake(bar);
            -- lvlUpRow:initData(hData[i]);
            -- lvlUpRow:Start();
            -- PanelManager:BindPanelScript(lvlUpRow, bar, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
            self.strongRow[i]:Awake(bar);
            self.strongRow[i]:initData(hData[i]);
            self.strongRow[i]:Start();
            PanelManager:BindPanelScript(self.strongRow[i], bar, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        end
    end
end

function HeroUpgradeView:initData()
    -- if IsEmpty(data) then return end
end

--[[
    拷贝并对英雄数据排序
    _hData List<HeroData>
    return List<HeroData>
]]
function HeroUpgradeView:copyData(_hData)
    local hData = List.new();

    if (nil ~= _hData and #_hData > 0) then
        hData:addRange(_hData);
    end

    return hData;
end

--[[
    对英雄数据进行排序
    _hData List<HeroData>
    return List<HeroData>
]]
function HeroUpgradeView:sortData(_hData)
    local curHeros = TeamData.getMyCurTeamHeros();

    curHeros = "," .. curHeros .. ",";

    if (nil == _hData or #_hData < 1) then
        return;
    end

    for i = 1, #_hData do
        if (#_hData >= i + 1) then
            for j = i + 1, #_hData do
                local xFind, yFind, tmp = false, false, nil;
                local x = _hData[i];
                local y = _hData[j];

                xFind =(nil ~= string.find(curHeros, "," .. x.id .. ","));
                yFind =(nil ~= string.find(curHeros, "," .. y.id .. ","));

                if (yFind and not xFind) then
                    tmp = _hData[i];
                    _hData[i] = _hData[j];
                    _hData[j] = tmp;
                end
            end
        end
    end
end

--[[
    显示强化面板
    _tp number 0，显示强化详细面板；1，显示神兵详细面板；2，显示觉醒面板
    _row HUIntensifyRow
]]
function HeroUpgradeView:showStrongPane(_tp, _row)
    local showTp, rowTmp = nil, nil;
    local dPane = nil;
    local prefab, goTmp = nil, nil;
    local sMask = nil;

    showTp = _tp;
    rowTmp = _row;
    prefab = Util.LoadPrefab("UI/HeroUpIntensifyPane", AssetBundleInfo.assetBundles);
    goTmp = CreateObject(prefab);
    sMask = ViewUtil.showScreenMask();

    dPane = HUIntensifyDetailPane.new();
    dPane:Awake(goTmp);
    PanelManager:BindPanelScript(dPane, goTmp, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    dPane:setData(rowTmp.hData, showTp,
        function() 
        	--觉醒成功后刷新界面信息 by iorinie
            local goldNow = PlayerData.getMyGold() - HeroDataProxy.getHeroWakeupGold(rowTmp.hData.wiseup) --此时取得的金币数据尚未更新，需要手动扣除后回传用于判断。 by iorinie
            for i = 1, #self.lvlUpRow do
                if self.lvlUpRow[i] ~= rowTmp then
                    self.lvlUpRow[i]:changeRowShow(0, goldNow);
                else
                    rowTmp:changeRowShow(1);
                end
            end
            --强化成功后刷新界面信息 by iorinie
            for i = 1, #self.strongRow do
            	if self.strongRow[i] == rowTmp then
            		rowTmp:changeRowShow();
            	end
            end
        end,
        function() DestroyObject(sMask); end);
    HangObject(goTmp, self.gameObject);

    ViewUtil.sortLayerOrder(sMask, LayerName.Broadcast);
    ViewUtil.sortLayerOrder(goTmp, LayerName.Dialog);
end