--[[
-- 
--]]
require "Game/League/View/LeagueApplyView"
 
LeagueApplyControler = {}

local this = LeagueApplyControler

function LeagueApplyControler.New()
	return this
end

function LeagueApplyControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeagueApplyView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	this.request()
end

function LeagueApplyControler.Awake()
end

function LeagueApplyControler.Start()
	this.view:Start(this.data)
end

function LeagueApplyControler.Update()
end

function LeagueApplyControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeagueApplyControler.initListener()
end

function LeagueApplyControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeagueApplyControler.handleNotification(notification)
end

function LeagueApplyControler.request()
	Network.SendMoData(ServerID.LeagueApplyList, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("LeagueAllMainData", session)
		this.accept(mo)
	end, {})
end

function LeagueApplyControler.accept(data)
	ViewUtil.initData(this, data)
end
