--[[
-- ϵͳ
--]]
require "Game/League/View/LeagueBadgeView"
 
LeagueBadgeControler = {}

local this = LeagueBadgeControler

function LeagueBadgeControler.New()
	return this
end

function LeagueBadgeControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeagueBadgeView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
    this.request()
end

function LeagueBadgeControler.Awake()
end

function LeagueBadgeControler.Start()
	this.view:Start(this.data)
end

function LeagueBadgeControler.Update()
end

function LeagueBadgeControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeagueBadgeControler.initListener()
end

function LeagueBadgeControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeagueBadgeControler.handleNotification(notification)
end

function LeagueBadgeControler.request()
	Network.SendMoData(ServerID.LeagueMainEnter, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("LeagueMainData", session)
		this.accept(mo)
	end, {})
end

function LeagueBadgeControler.accept(data)
	-- LeagueData.New(data)
	ViewUtil.initData(this, data)
end
