--[[
-- Ѽ
--]]
require "Game/League/View/LeagueJoinedView"
 
LeagueJoinedControler = {}

local this = LeagueJoinedControler

function LeagueJoinedControler.New()
	return this
end

function LeagueJoinedControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeagueJoinedView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	this.request()
end

function LeagueJoinedControler.Awake()
end

function LeagueJoinedControler.Start()
	this.view:Start(this.data)
end

function LeagueJoinedControler.Update()
end

function LeagueJoinedControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeagueJoinedControler.initListener()
end

function LeagueJoinedControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeagueJoinedControler.handleNotification(notification)
end

function LeagueJoinedControler.request()
	Network.SendMoData(ServerID.LeagueMainEnter, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("LeagueMainData", session)
		this.accept(mo)
	end, {})
end

function LeagueJoinedControler.accept(data)
	ViewUtil.initData(this, data)
	LeagueData.New()
	LeagueData.Init(data)
end
