--[[
-- ˳Ա
--]]
require "Game/League/View/LeagueLeaderTransferView"
 
LeagueLeaderTransferControler = {}

local this = LeagueLeaderTransferControler

function LeagueLeaderTransferControler.New()
	return this
end

function LeagueLeaderTransferControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeagueLeaderTransferView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	this.request()
end

function LeagueLeaderTransferControler.Awake()
end

function LeagueLeaderTransferControler.Start()
	this.view:Start(this.data)
end

function LeagueLeaderTransferControler.Update()
end

function LeagueLeaderTransferControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeagueLeaderTransferControler.initListener()
end

function LeagueLeaderTransferControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeagueLeaderTransferControler.handleNotification(notification)
end

function LeagueLeaderTransferControler.request()
	Network.SendMoData(ServerID.LeagueMembers, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("LeagueTeamListMainData", session)
		this.accept(mo)
	end, {})
end

function LeagueLeaderTransferControler.accept(data)
	ViewUtil.initData(this, data)
end
