--[[
-- ˹
--]]
require "Game/League/View/LeagueManagerView"
 
LeagueManagerControler = {}

local this = LeagueManagerControler

function LeagueManagerControler.New()
	return this
end

function LeagueManagerControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeagueManagerView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function LeagueManagerControler.Awake()
end

function LeagueManagerControler.Start()
	this.view:Start(this.data)
end

function LeagueManagerControler.Update()
end

function LeagueManagerControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeagueManagerControler.initListener()
end

function LeagueManagerControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeagueManagerControler.handleNotification(notification)
end

function LeagueManagerControler.accept(data)
	ViewUtil.initData(this, data)
	Facade:sendNotification(MVCConst.OPEN_MODULE, {[1]=ModuleName.LeagueApply})
end

-- ˳/ɢ
function LeagueManagerControler.QuitLeague(isCaptain)
	local function _callback(session)
		local serviceId = tonumber(session.serviceId)
		if serviceId == ServerID.LeagueQuit then
			local mo = GetProtoTable("DefaultData", session)
			if mo.code == 0 then
				if isCaptain then
					ViewUtil.showMsg(GetWord("DissolveSuccess"))
				else
					ViewUtil.showMsg(GetWord("QuitSuccess"))
				end
				TeamData.SetLeagueId(0)
				ViewUtil.goto(ModuleName.LeagueApply)
			else
				ViewUtil.showMsg(GetWord(defData.code))
			end
		end
	end
	Network.SendMoData(ServerID.LeagueQuit, nil, _callback)
end
