--[[
-- ˳Ա
--]]
require "Game/League/View/LeagueMemberView"
 
LeagueMemberControler = {}

local this = LeagueMemberControler

function LeagueMemberControler.New()
	return this
end

function LeagueMemberControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeagueMemberView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	this.request()
end

function LeagueMemberControler.Awake()
end

function LeagueMemberControler.Start()
	this.view:Start(this.data)
end

function LeagueMemberControler.Update()
end

function LeagueMemberControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeagueMemberControler.initListener()
end

function LeagueMemberControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeagueMemberControler.handleNotification(notification)
end

function LeagueMemberControler.request()
	Network.SendMoData(ServerID.LeagueMembers, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("LeagueTeamListMainData", session)
		this.accept(mo)
	end, {})
end

function LeagueMemberControler.accept(data)
	ViewUtil.initData(this, data)
end
