--[[
-- ֪ͨ
--]]
require "Game/League/View/LeagueNoticeView"
 
LeagueNoticeControler = {}

local this = LeagueNoticeControler

function LeagueNoticeControler.New()
	return this
end

function LeagueNoticeControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeagueNoticeView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	this.request()
end

function LeagueNoticeControler.Awake()
end

function LeagueNoticeControler.Start()
	this.view:Start(this.data)
end

function LeagueNoticeControler.Update()
end

function LeagueNoticeControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeagueNoticeControler.initListener()
end

function LeagueNoticeControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeagueNoticeControler.handleNotification(notification)
end

function LeagueNoticeControler.request()
	Network.SendMoData(ServerID.LeagueNotices, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("LeagueNotifyMainData", session)
		this.accept(mo)
	end, {})
end

function LeagueNoticeControler.accept(data)
	ViewUtil.initData(this, data)
end
