--[[
-- PVP
--]]
require "Game/League/View/LeaguePVEView"
require "Game/League/View/LeaguePVERankBoard"
require "Game/League/View/LeaguePVERewardBoard"

LeaguePVEControler = {}

local this = LeaguePVEControler

function LeaguePVEControler.New()
	return this
end

function LeaguePVEControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeaguePVEView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
    this.request()
end

function LeaguePVEControler.Awake()
end

function LeaguePVEControler.Start()
	this.view:Start(this.data)
end

function LeaguePVEControler.Update()
end

function LeaguePVEControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeaguePVEControler.initListener()
end

function LeaguePVEControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeaguePVEControler.handleNotification(notification)
end

function LeaguePVEControler.request()
	Network.SendMoData(ServerID.LeaguePVEHunt, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("DefaultData", session)
		this.accept(mo)
	end, {})
end

function LeaguePVEControler.accept(data)
	ViewUtil.initData(this, data)
end
