--[[
-- PVP
--]]
require "Game/League/View/LeaguePVEMapView"
require "Game/League/View/LeaguePVERankBoard"
require "Game/League/View/LeaguePVERewardBoard"
 
LeaguePVEMapControler = {}

local this = LeaguePVEMapControler

function LeaguePVEMapControler.New()
	return this
end

function LeaguePVEMapControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeaguePVEMapView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
    this.request()
end

function LeaguePVEMapControler.Awake()
end

function LeaguePVEMapControler.Start()
	this.view:Start(this.data)
end

function LeaguePVEMapControler.Update()
end

function LeaguePVEMapControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeaguePVEMapControler.initListener()
end

function LeaguePVEMapControler.listNotificationInterests()
    -- local list = {}
    -- return unpack(list)
end

function LeaguePVEMapControler.handleNotification(notification)
end

function LeaguePVEMapControler.request()
	Network.SendMoData(ServerID.LeaguePVEMap, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("LeagueHuntMainData", session)
		
		this.accept(mo)
	end, {})
end

function LeaguePVEMapControler.accept(data)
	ViewUtil.initData(this, data)
end
