--[[
-- ˸
--]]
require "Game/League/View/LeagueWealView"
 
LeagueWealControler = {}

local this = LeagueWealControler

function LeagueWealControler.New()
	return this
end

function LeagueWealControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LeagueWealView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
    this.request()
end

function LeagueWealControler.Awake()
end

function LeagueWealControler.Start()
	this.view:Start(this.data)
end

function LeagueWealControler.Update()
end

function LeagueWealControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LeagueWealControler.initListener()
end

function LeagueWealControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function LeagueWealControler.handleNotification(notification)
end

function LeagueWealControler.request()
	Network.SendMoData(ServerID.LeagueMainEnter, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("LeagueMainData", session)
		this.accept(mo)
	end, {})
end

function LeagueWealControler.accept(data)
	ViewUtil.initData(this, data.team)
	-- Facade:sendNotification(MVCConst.OPEN_MODULE, {[1]=ModuleName.LeagueApply})
end
