
LeagueBadgeView = class(BaseView)

local const_donateGold = "此次捐献10万资金，消耗 {1} 万金币。";
local const_donateGem = "此次捐献10万资金，消耗 {1} 钻石。";

local badgeInfo = {{1, 0, 0, 0, 6000000}, {1, 1, 0, 0, 9000000}, {1, 1, 1, 0, 15000000}, {1, 1, 1, 1, 21000000}, {2, 1, 1, 1, 24000000}, {2, 2, 1, 1, 30000000}, {2, 2, 2, 1, 45000000}, {2, 2, 2, 2, 60000000}, {3, 2, 2, 2, 90000000}, {3, 2, 2, 3, 0}}

function LeagueBadgeView:ctor()
end  

function LeagueBadgeView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
end

function LeagueBadgeView:Start(data)
	-- self:initData(data)
end

function LeagueBadgeView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	self.progressBar = GetPathComponent(self.transform, centerPath.."/Process", "UIProgressBar")
	self.btnUpgrade = GetGameObject(self.transform, centerPath.."/BtnUpgrade")
	self.btnChange = GetGameObject(self.transform, centerPath.."/BtnChange")
	self.level = GetPathComponent(self.transform, centerPath.."/BadgeLevel", "UILabel")
	self.prop_1Lbl = GetPathComponent(self.transform, centerPath.."/Prop1", "UILabel")
	self.prop_2Lbl = GetPathComponent(self.transform, centerPath.."/Prop2", "UILabel")
	self.prop_3Lbl = GetPathComponent(self.transform, centerPath.."/Prop3", "UILabel")
	self.prop_4Lbl = GetPathComponent(self.transform, centerPath.."/Prop4", "UILabel")
	self.conditionsLbl = GetPathComponent(self.transform, centerPath.."/Conditions", "UILabel")
	self.badgeObj = GetGameObject(self.transform, centerPath.."/Badge")
	self.badgeSpr = GetComponent(self.badgeObj.transform, "UISprite")
	self.btnDonateGold = GetGameObject(self.transform, centerPath.."/DonateGold")
	self.btnDonateGem = GetGameObject(self.transform, centerPath.."/DonateGem")

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)		
		if obj == self.btnBack then
			self:closeView(true)
		elseif obj == self.btnUpgrade then
			if self.fund < badgeInfo[self.badgeLevel][5] then
				ViewUtil.showMsg("军团资金不足！")
				return
			end
			self:BadgeUpgrade()
		elseif obj == self.btnChange then
			self:BadgeChange()
		elseif obj == self.btnDonateGold then
			self:DonateGold()
		elseif obj == self.btnDonateGem then
			self:DonateGem()
		end
    end

	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnUpgrade, doClick)
	ViewUtil.AddClickEvent(self.btnChange, doClick)
	ViewUtil.AddClickEvent(self.btnDonateGold, doClick)
	ViewUtil.AddClickEvent(self.btnDonateGem, doClick)
end

function LeagueBadgeView:initData(data)
	self.badgeLevel = LeagueData.GetLeagueBadgeLevel()
	self.level.text = "Lv."..self.badgeLevel
	self.progressBar.value = self.badgeLevel / 10

	if self.badgeLevel >= 10 then
		Util.EnableButton(self.btnUpgrade, ButtonState.Disabled, false)
	end

	self.prop_1Lbl.text = badgeInfo[self.badgeLevel][1]
	self.prop_2Lbl.text = badgeInfo[self.badgeLevel][2]
	self.prop_3Lbl.text = badgeInfo[self.badgeLevel][3]
	self.prop_4Lbl.text = badgeInfo[self.badgeLevel][4]

	self.fund = LeagueData.GetLeagueFunds()
	if badgeInfo[self.badgeLevel][5] ~= 0 then
		self.conditionsLbl.text = "当前军团资金"..LogicUtil.getShowNum(self.fund).."\n徽章升至下一级还需要资金"..LogicUtil.getShowNum(badgeInfo[self.badgeLevel][5]).."。"
	else
		self.conditionsLbl.text = "当前军团资金"..LogicUtil.getShowNum(self.fund).."\n徽章已升至满级。"
	end
	self.badgeSpr.spriteName = "LeagueBadge_"..LeagueData.GetLeagueBadgeId()
end

function LeagueBadgeView:BadgeUpgrade()
	local function _callback(session)
		local serviceId = tonumber(session.serviceId)
		if serviceId == ServerID.BadgeUpgrade then
			local mo = GetProtoTable("DefaultData", session)
			if mo.code ~= 0 then
				ViewUtil.showMsg(GetWord(mo.code))
        		return ;
			end
			ViewUtil.showMsg("升级成功！")
			local eff = CreateObjectByPath("Effects/UpBadgeSuccess", AssetBundleInfo.assetBundles)
			HangObject(eff, self.badgeObj, 2.0)
			self.badgeLevel = self.badgeLevel + 1
			self.level.text = "Lv."..self.badgeLevel
			self.prop_1Lbl.text = badgeInfo[self.badgeLevel][1]
			self.prop_2Lbl.text = badgeInfo[self.badgeLevel][2]
			self.prop_3Lbl.text = badgeInfo[self.badgeLevel][3]
			self.prop_4Lbl.text = badgeInfo[self.badgeLevel][4]

			self.fund = self.fund - badgeInfo[self.badgeLevel - 1][5]
			if badgeInfo[self.badgeLevel][5] ~= 0 then
				self.conditionsLbl.text = "当前军团资金"..LogicUtil.getShowNum(self.fund).."\n徽章升至下一级还需要资金"..LogicUtil.getShowNum(badgeInfo[self.badgeLevel][5]).."。"
			else
				self.conditionsLbl.text = "当前军团资金"..LogicUtil.getShowNum(self.fund).."\n徽章已升至满级。"
			end
		end
	end
	Network.SendMoData(ServerID.BadgeUpgrade, {}, _callback)
end

function LeagueBadgeView:BadgeChange()
	local dialog = CreateObjectByPath("UI/LeagueBadgeChange", AssetBundleInfo.assetBundles)
	HangObject(ViewUtil.CreateShadeView(), dialog)
	HangObject(dialog, self.gameObject)
	ViewUtil.sortLayerOrder(dialog, LayerName.Dialog)

	local centerPath = "Mode/Center/Panel"
	local uiGrid = GetPathComponent(dialog.transform, centerPath.."/ScrollViewBG/ScrollView/Panel/Grid", "UIGrid")
	-- local slt = GetGameObject(dialog.transform, centerPath.."/Slt")
	
	local bottomPath = "Mode/Bottom/Panel"
	local btnCancel = GetGameObject(dialog.transform, bottomPath.."/BtnCancel")
	local btnConfirm = GetGameObject(dialog.transform, bottomPath.."/BtnConfirm")

    local function doClick(obj)
		if obj == btnCancel then
			self.selectBoard = nil
			self.selectedBadge = nil
			DestroyObject(dialog)
		elseif obj == btnConfirm then
			if self.selectedBadge == nil then
				ViewUtil.showMsg(GetWord("NotSelectBadge"))
				return
			end

			local function _callback(sd)
				local serviceId = tonumber(sd.serviceId)
				if serviceId == ServerID.BadgeIconChange then
					local mo = GetProtoTable("DefaultData", sd)
					if mo.code ~= 0 then
						ViewUtil.showMsg(GetWord(mo.code))
						return
					end
					ViewUtil.showMsg("更换成功！")
					local spr = GetComponent(self.selectedBadge.transform, "UISprite")
					self.badgeSpr.spriteName = spr.spriteName
					self.selectBoard = nil
					self.selectedBadge = nil
					DestroyObject(dialog)
				end
			end

			local mapData, buf = Map.new(), nil;
			local spr = GetComponent(self.selectedBadge.transform, "UISprite")
			local badgeId = tonumber((string.gsub(spr.spriteName, "LeagueBadge_", "", 1)))
			mapData:put("id", badgeId);
			buf = Network.reqParamEncode(mapData);
			NetManager:SendData(self, buf, ServerID.BadgeIconChange, nil, function(sd) _callback(sd) end, nil, doNthFunc)
		end
    end

	ViewUtil.AddClickEvent(btnCancel, doClick)
	ViewUtil.AddClickEvent(btnConfirm, doClick)
	
    local function doClickSelect(obj)
		if not self.selectBoard then
			-- self.selectBoard = CreateObject(slt)
			-- self.selectBoard:SetActive(true)
			-- ViewUtil.sortLayerOrder(self.selectBoard, LayerName.Top)
			self.selectBoard = CreateObject(Util.LoadPrefab("UI/SelectedBadgeBoard", AssetBundleInfo.assetBundles))
			ViewUtil.sortLayerOrder(self.selectBoard, LayerName.Dialog)
		end

		HangObject(self.selectBoard, obj)
		self.selectedBadge = obj
	end
	local list = uiGrid:GetChildList()
	for i = 0, list.Count - 1 do
		ViewUtil.AddClickEvent(list[i].gameObject, doClickSelect)
	end
end

function LeagueBadgeView:DonateGold()
	local function DonateOKFun()
		if TeamData.GetGold() < 100000 then
			ViewUtil.showMsg("金币不足！")
			return
		end

		local mapData, buf = Map.new(), nil;
		mapData:put("type", 1);
		mapData:put("count", 1);
		buf = Network.reqParamEncode(mapData);
		NetManager:SendData(self, buf, ServerID.LeagueDonate, nil, function(sd) self:DonateGoldHandler(sd) end, nil, doNthFunc)
	end

	ViewUtil.comCfmPanel(string.gsub(const_donateGold, "{1}", 10), function () DonateOKFun(); end);
end

function LeagueBadgeView:DonateGoldHandler(sd)
	local serviceId = tonumber(sd.serviceId)
	if serviceId == ServerID.LeagueDonate then
		local mo = GetProtoTable("DefaultData", sd)
		if mo.code ~= 0 then
			if mo.code == 80085 then
				ViewUtil.showMsg("超出每日捐献上限！")
				return
			elseif mo.code == 10004 then
				ViewUtil.showMsg("金币不足！")
				return
			else
				ViewUtil.showMsg(GetWord(defData.code))
        		return;
        	end
		end
		ViewUtil.showMsg("捐献金币成功，获得200贡献度！")
		self.fund = self.fund + 100000
		self.conditionsLbl.text = "当前军团资金"..LogicUtil.getShowNum(self.fund).."\n徽章升至下一级还需要资金"..LogicUtil.getShowNum(badgeInfo[self.badgeLevel][5]).."。"
	end
end

function LeagueBadgeView:DonateGem()
	local function DonateOKFun()
		if TeamData.GetGem() < 10 then
			ViewUtil.showMsg("钻石不足！")
			return
		end

		local mapData, buf = Map.new(), nil;
		mapData:put("type", 2);
		mapData:put("count", 1);
		buf = Network.reqParamEncode(mapData);
		NetManager:SendData(self, buf, ServerID.LeagueDonate, nil, function(sd) self:DonateGemHandler(sd) end, nil, doNthFunc)
	end

	ViewUtil.comCfmPanel(string.gsub(const_donateGem, "{1}", 10), function () DonateOKFun(); end);
end

function LeagueBadgeView:DonateGemHandler(sd)
	local serviceId = tonumber(sd.serviceId)
	if serviceId == ServerID.LeagueDonate then
		local mo = GetProtoTable("DefaultData", sd)
		if mo.code ~= 0 then
			ViewUtil.showMsg(GetWord(defData.code))
        	return ;
		elseif mo.code == 10004 then
			ViewUtil.showMsg("钻石不足！")
			return
		end
		ViewUtil.showMsg("捐献钻石成功！")
		self.fund = self.fund + 100000
		self.conditionsLbl.text = "当前军团资金"..LogicUtil.getShowNum(self.fund).."\n徽章升至下一级还需要资金"..LogicUtil.getShowNum(badgeInfo[self.badgeLevel][5]).."。"
	end
end