
LeagueJoinedView = class(BaseView)

function LeagueJoinedView:ctor()
end  

function LeagueJoinedView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.deltaPos = Vector3.New(10000, 0, 0)
	self:initPanel()
end

function LeagueJoinedView:Start(data)
	-- self:initData(data)
end

function LeagueJoinedView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	self.boardBG = GetGameObject(self.transform, centerPath.."/BoardBG")
	self.leagueName = GetPathComponent(self.boardBG.transform, "LeagueName", "UILabel")
	self.leagueCaptain = GetPathComponent(self.boardBG.transform,"LeagueCaptain", "UILabel")
	self.leagueBadgeLevel = GetPathComponent(self.boardBG.transform, "LeagueBadgeLevel", "UILabel")
	self.leagueFund = GetPathComponent(self.boardBG.transform, "LeagueFund", "UILabel")
	self.leagueFightVal = GetPathComponent(self.boardBG.transform, "LeagueFightVal", "UILabel")
	self.leagueBBObj = GetGameObject(self.boardBG.transform, "LeagueBillBoard")
	self.leagueBBLbl = GetComponent(self.leagueBBObj.transform, "UILabel")
	self.btnEdit = GetGameObject(self.leagueBBObj.transform, "BtnEdit")
	self.editBBObj = GetGameObject(self.boardBG.transform, "EditBillBoard")
	self.sendInput = GetPathComponent(self.editBBObj.transform, "ScrollViewBG", "UIInput")
	--城战时间、围猎时间，暂时取消该显示

	self.button0 = GetGameObject(self.transform, centerPath.."/ButtonBG/Button0")
	self.button1 = GetGameObject(self.transform, centerPath.."/ButtonBG/Button1")
	self.button2 = GetGameObject(self.transform, centerPath.."/ButtonBG/Button2")
	self.button3 = GetGameObject(self.transform, centerPath.."/ButtonBG/Button3")
	self.button4 = GetGameObject(self.transform, centerPath.."/ButtonBG/Button4")
	self.button5 = GetGameObject(self.transform, centerPath.."/ButtonBG/Button5")
	self.button6 = GetGameObject(self.transform, centerPath.."/ButtonBG/Button6")
	self.button7 = GetGameObject(self.transform, centerPath.."/ButtonBG/Button7")
	self.button8 = GetGameObject(self.transform, centerPath.."/ButtonBG/Button8")

	-- ViewUtil.adaptUISize(self.centerBG, true, 76, 56, 0, 0)

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)		
		if obj == self.btnBack then
			ViewUtil.openView(ModuleName.MAIN)
			
		elseif obj == self.button0 then -- »ÕÕÂ
			ViewUtil.openView(ModuleName.LeagueBadge)
		elseif obj == self.button1 then -- ¸£Àû
			ViewUtil.openView(ModuleName.LeagueWeal)
		elseif obj == self.button2 then -- ÒÑ¼ÓÈëÖ÷½çÃæ
			--待增加的模块
		elseif obj == self.button3 then
			ViewUtil.openView(ModuleName.LeaguePVE)
		elseif obj == self.button4 then -- ÁªÃËPVP
			-- Network.ReqLeaguePVP()
		elseif obj == self.button5 then -- ÁªÃË¹ÜÀí
			if LeagueData.IsCaptain() then
				ViewUtil.openView(ModuleName.LeagueManager)
			end
		elseif obj == self.button6 then
			--待增加的模块
		elseif obj == self.button7 then -- ÁªÃËÍ¨Öª
			if LeagueData.IsCaptain() then
				ViewUtil.goto(ModuleName.LeagueNotice, true)
			end
		elseif obj == self.button8 then -- ÁªÃË³ÉÔ±
			ViewUtil.goto(ModuleName.LeagueMember)
		elseif obj == self.btnEdit then
			self:ShiftToEdit()
		end
    end

	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.button0, doClick)
	ViewUtil.AddClickEvent(self.button1, doClick)
	ViewUtil.AddClickEvent(self.button2, doClick)
	ViewUtil.AddClickEvent(self.button3, doClick)
	ViewUtil.AddClickEvent(self.button4, doClick)
	ViewUtil.AddClickEvent(self.button5, doClick)
	ViewUtil.AddClickEvent(self.button6, doClick)
	ViewUtil.AddClickEvent(self.button7, doClick)
	ViewUtil.AddClickEvent(self.button8, doClick)
	ViewUtil.AddClickEvent(self.btnEdit, doClick)
end

function LeagueJoinedView:initData(data)
	if IsEmpty(data) then return end
	
	TeamData.SetLeagueId(data.league.leagueId)
	TeamData.SetLeagueName(data.league.leagueName)
	self.leagueName.text = data.league.leagueName
	self.leagueCaptain.text = data.league.teamName
	self.leagueBadgeLevel.text = data.league.logoLevel
	self.leagueFund.text = data.league.gold
	self.leagueFightVal.text = LogicUtil.getShowNum(data.league.totalPower)
	self.msg = data.league.msg
	self.leagueBBLbl.text = self.msg

	-- GetComponent(self.button0.transform, "UIButton").normalSprite = "LeagueBadge_"..data.league.logoId
	
	LeagueData.SetMyClass(data.team.level)
	if not LeagueData.IsCaptain() then
		local btn7 = GetComponent(self.button7.transform, "UIButton")
		btn7.normalSprite = "lgBG"
		local btn5 = GetComponent(self.button5.transform, "UIButton")
		btn5.normalSprite = "lgBG"
		self.btnEdit:SetActive(false)
	end
end


function LeagueJoinedView:ShiftToEdit()
	self.btnEdit:SetActive(false)
	self.leagueBBObj:SetActive(false)
	self.editBBObj:SetActive(true)

	self.sendInput.value = self.msg

	local blockWords = WordData.GetBlockNames()

	local function _onChange(params)
		local text = self.sendInput.value
		if not IsEmpty(text) then
			local content = text
			for i = 1, #blockWords do
				local idx = Util.FindWord(content, blockWords[i])
				if idx ~= -1 then
					content = Util.ReplaceWord(content, blockWords[i], "*")
				end
			end
			self.sendInput.value = content
		end
	end	
	Util.AddInputChangeEvent(self.sendInput, _onChange, {})

	local btnComfirm = GetGameObject(self.editBBObj.transform, "BtnComfirm")

	local function _doClick(obj)
		if obj == btnComfirm then
			local text = self.sendInput.value
			if IsEmpty(text) then
				text = "暂无军团公告"
			end

			Network.SendMoData(ServerID.LeagueBoardEdit, {text}, function(session, params)
				local serviceId = tonumber(session.serviceId)
				local mo = GetProtoTable("DefaultData", session)
				if mo.code == 0 then
					self.msg = text
					self.leagueBBLbl.text = self.sendInput.value
					self.sendInput.value = ""
					self.btnEdit:SetActive(true)
					self.leagueBBObj:SetActive(true)
					self.editBBObj:SetActive(false)
					ViewUtil.showMsg("修改成功")
				else
					ViewUtil.showMsg("修改失败")
				end
			end, {})
		end
	end
	ViewUtil.AddClickEvent(btnComfirm, _doClick)
end