
LeagueLeaderTransferView = class(BaseView)

function LeagueLeaderTransferView:ctor()
end  

function LeagueLeaderTransferView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform

	self.transferId = nil
	-- self.FrameList = {}
	self.herosConf = Config.getHerosData()

	self:initPanel()
end

function LeagueLeaderTransferView:Start(data)
	-- self:initData(data)
end

function LeagueLeaderTransferView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	self.scvBG = GetGameObject(self.transform, centerPath.."/ScrollViewBG")
	-- self.amounts = GetPathComponent(self.transform, centerPath.."/ScrollViewBG/Amounts", "UILabel")
	self.scvObj = GetGameObject(self.scvBG.transform, "ScrollView")
	self.grid = GetGameObject(self.scvObj.transform, "Panel/Grid")
	self.bar = GetGameObject(self.grid.transform, "LeagueMember")
	self.check = GetGameObject(self.grid.transform, "Check")
	self.btnTransfer = GetGameObject(self.transform, centerPath.."/BtnTransfer")

	-- ViewUtil.adaptUISize(self.scvBG, true, 80, 60, 0, 0)
	-- ViewUtil.adaptUISize(self.scvObj, true, 154, 70, 16, 16)

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)		
		if obj == self.btnBack then
			self:closeView(true)
		elseif obj == self.btnTransfer then
			self:LeaderTransfer()
		end
    end

	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnTransfer, doClick)
end

function LeagueLeaderTransferView:initData(data)
	if IsEmpty(data) then return end

	plog(data.teamListData, "tree")
	local members = data.teamListData
	self.memberNum = #members
	-- self.amounts.text = self.memberNum .. "/50"

	for i = 1, #members do
		local mem = members[i]
		local bar = nil

		if mem.level ~= 5 then
			-- local bar = CreateObjectByPath("UI/LeagueMember")
			bar = CreateObject(self.bar)
			HangObject(bar, self.grid)
			bar:SetActive(true)
			bar.name = mem.teamId

			local name = GetPathComponent(bar.transform, "Name", "UILabel")
			local contribution = GetPathComponent(bar.transform, "Contribution", "UILabel")
			local fightValue = GetPathComponent(bar.transform, "FightValue", "UILabel")
			local lastLogin = GetPathComponent(bar.transform, "LastLogin", "UILabel")
			local frame = GetGameObject(bar.transform, "Frame")
			-- self.FrameList[i] = GetGameObject(bar.transform, "Frame")

			name.text = mem.name
			contribution.text = mem.amount
			fightValue.text = LogicUtil.getShowNum(mem.power)
			lastLogin.text = Date2String(mem.lastTime/1000)

			local heroObj = GetGameObject(bar.transform, "Hero")
			local heroSpr = GetPathComponent(heroObj.transform, "Sprite", "UISprite")
			local conf = self.herosConf[tostring(mem.logoId)] or {}
			local heroName = conf["#prefab_name"]
			heroSpr.spriteName = heroName

			local function callback(obj)
				if obj == frame then
					HangObject(self.check, frame)
					if not self.check.activeSelf then
						self.check:SetActive(true)
					end
					self.transferId = mem.teamId
				end
			end
			ViewUtil.AddClickEvent(frame, callback)
			-- local heroObj = GetGameObject(bar.transform, "Hero")
			-- local function callback(obj)
			-- 	if obj == heroObj then
			-- 		local dialog = CreateObjectByPath("UI/LeagueMemberInfo")
			-- 		HangObject(ViewUtil.CreateShadeView(), dialog)
			-- 		HangObject(dialog, self.gameObject)
			-- 		ViewUtil.sortLayerOrder(dialog, LayerName.Dialog)

			-- 		local topPath = "Mode/Top/Panel"
			-- 		local btnExit = GetGameObject(dialog.transform, topPath.."/BtnExit")

			-- 		local centerPath = "Mode/Center/Panel"
			-- 		local infoNameLbl = GetPathComponent(dialog.transform, centerPath.."/Name", "UILabel")
			-- 		local infoHeroSpr = GetPathComponent(dialog.transform, centerPath.."/Hero/Sprite", "UISprite")
			-- 		local zl = GetPathComponent(dialog.transform, centerPath.."/Prop5", "UILabel")
			-- 		local xg = GetPathComponent(dialog.transform, centerPath.."/Prop1", "UILabel")
			-- 		local fy = GetPathComponent(dialog.transform, centerPath.."/Prop2", "UILabel")
			-- 		local sb = GetPathComponent(dialog.transform, centerPath.."/Prop3", "UILabel")
			-- 		local wz = GetPathComponent(dialog.transform, centerPath.."/Prop4", "UILabel")
			-- 		local infoLeagueLbl = GetPathComponent(dialog.transform, centerPath.."/League", "UILabel")
			-- 		local infoJobLbl = GetPathComponent(dialog.transform, centerPath.."/Job", "UILabel")
			-- 		local infoGridObj = GetGameObject(dialog.transform, centerPath.."/ScrollViewBG/ScrollView/Panel/Grid")
			-- 		local shadow = GetGameObject(infoGridObj.transform, "Shadow")

			-- 		local bottomPath = "Mode/Bottom/Panel"
			-- 		local btnAdd = GetGameObject(dialog.transform, bottomPath.."/BtnAdd")
			-- 		local btnSend = GetGameObject(dialog.transform, bottomPath.."/BtnSend")

			-- 		local function doClick(obj)
			-- 			if obj == btnExit then
			-- 				DestroyObject(dialog)
			-- 			elseif obj == btnAdd then
			-- 				if mem.teamId == PlayerData.GetRoleTeamId() then
			-- 					ViewUtil.showMsg("无法添加自己！")
			-- 					return
			-- 				end
			-- 				local function _callback(session)
			-- 					local mo = GetProtoTable("DefaultData", session)
			-- 					if mo.code == 0 then
			-- 						Util.EnableButton(btnAdd, ButtonState.Pressed, false)
			-- 						lblTitle.text = GetWord("FriendApplyed")
			-- 					else
			-- 						ViewUtil.showMsg(GetWord(tostring(mo.code)))
			-- 					end
			-- 				end
			-- 				Network.SendMoData(ServerID.FriendAdd, {mem.teamId}, _callback)
			-- 			elseif obj == btnSend then
			-- 				if mem.teamId == PlayerData.GetRoleTeamId() then
			-- 					ViewUtil.showMsg("无法给自己发邮件！")
			-- 					return
			-- 				end
			-- 				self:CreateLeagueMailBoard(mem.teamId, mem.name)
			-- 				-- DestroyObject(dialog)
			-- 			end
			-- 		end
			-- 		ViewUtil.AddClickEvent(btnExit, doClick)
			-- 		ViewUtil.AddClickEvent(btnAdd, doClick)
			-- 		ViewUtil.AddClickEvent(btnSend, doClick)

			-- 		Network.SendMoData(ServerID.FriendInfo, {mem.teamId}, function(session, params)
			-- 			local serviceId = tonumber(session.serviceId)
			-- 			local mo = GetProtoTable("TeamInfoData", session)
			-- 			local ability = mo.ability
			-- 			local heroeIds = StrSplit(mo.heroIds, ",")
						
			-- 			infoNameLbl.text = mo.name
			-- 			--头像信息怎么取
			-- 			zl.text = LogicUtil.getShowNum(ability.power)
			-- 			xg.text = ability.xg
			-- 			fy.text = ability.fy
			-- 			sb.text = ability.sb
			-- 			wz.text = ability.wz
			-- 			infoLeagueLbl.text = ""
			-- 			infoJobLbl.text = ""

			-- 			local heroes = {}
			-- 			local rowMax = 5
			-- 			local index = 1
			-- 			local positionX = -195
	  --   				local positionY = 70
			-- 			for i = 1, math.modf(#heroeIds/rowMax + 1) do
			-- 		        for j = 1, rowMax do
			-- 		            if heroeIds[index] ~= nil then
			-- 		                heroes[index] = ViewUtil.CreateFriendHeroes(heroeIds[index], infoGridObj)
			-- 		                heroes[index].transform.localPosition = Vector3.New(positionX, positionY, 0)
			-- 		                heroes[index].transform.localScale = Vector3.New(0.8, 0.8, 0)
			-- 		                GetPathComponent(heroes[index].transform, "", "BoxCollider2D").enabled = false
			-- 		                GetGameObject(heroes[index].transform, "BG"):SetActive(false)

			-- 		                local heroShadow = CreateObject(shadow)
			-- 		                heroShadow:SetActive(true)
			-- 		                HangObject(heroShadow, heroes[index])
			-- 		                heroShadow.transform.localPosition = Vector3.New(0, -35, 0)
			-- 		                GetComponent(heroShadow.transform, "UI2DSprite").depth = GetPathComponent(heroes[index].transform, "Sprite", "UISprite").depth - 1

			-- 		                positionX = positionX + 90
			-- 		                index = index + 1
			-- 		            end
			-- 		        end
	        
			-- 		        local oushu = nil
			-- 		        oushu = math.mod(i, 2)
			-- 		        if tonumber(oushu) ~= 1 then
			-- 		            positionX = -195
			-- 		        else
			-- 		            positionX = -160
			-- 		        end
			-- 		        positionY = positionY - 90
			-- 		    end
			-- 		end, {})
			-- 	end
			-- end
			-- ViewUtil.AddClickEvent(heroObj, callback)
		end
	end
	ResetGrid(self.grid)
	ResetScrollView(self.scvObj)
end

function LeagueLeaderTransferView:LeaderTransfer()
	if self.transferId == nil then
		ViewUtil.showMsg("请选择军团成员后点击！")
		return
	end
	ViewUtil.comCfmPanel("转让军团之后将不可恢复，是否确定要转让？", function ()
		local function _callback(session)
			local mo = GetProtoTable("DefaultData", session)
			if mo.code == 0 then
				ViewUtil.showMsg("军团长转让成功！")
				ViewUtil.goto(ModuleName.LeagueJoined)
			else
				ViewUtil.showMsg(GetWord(tostring(mo.code)))
			end
		end
		Network.SendMoData(ServerID.LeagueTransfer, {self.transferId}, _callback)
	end)
end