
LeagueManagerView = class(BaseView)

function LeagueManagerView:ctor()
end  

function LeagueManagerView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
end

function LeagueManagerView:Start(data)
	self:initData(data)
end

function LeagueManagerView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	self.button1 = GetGameObject(self.transform, centerPath.."/Grid/Button1")
	self.button2 = GetGameObject(self.transform, centerPath.."/Grid/Button2")
	self.button3 = GetGameObject(self.transform, centerPath.."/Grid/Button3")
	self.button4 = GetGameObject(self.transform, centerPath.."/Grid/Button4")

	self.lblQuit = GetPathComponent(self.transform, centerPath.."/Grid/Button4/Tittle", "UILabel")
	if LeagueData.IsCaptain() then
		self.lblQuit.text = GetWord("DissolveLeague")
	else
		self.lblQuit.text = GetWord("QuitLeague")
	end

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)	
		if obj == self.btnBack then
			-- self:closeView(true)
			ViewUtil.goto(ModuleName.LeagueJoined)
		elseif obj == self.button1 then -- ÈëÍÅÏÞÖÆ
			--入团限制，已取消
		elseif obj == self.button2 then -- Èº·¢ÓÊ¼þ
			self:CreateLeagueMailBoard()
		elseif obj == self.button3 then -- ÈÎÃâÖ°Î»
			ViewUtil.goto(ModuleName.LeagueLeaderTransfer)
		elseif obj == self.button4 then -- ÍË³ö/½âÉ¢ÁªÃË
			-- ViewUtil.goto(ModuleName.LeagueMember)
			ViewUtil.comCfmPanel("是否确认解散军团？", function ()
				local isCaptain = LeagueData.IsCaptain()
				LeagueManagerControler.QuitLeague(isCaptain)
			end);
		end
    end

	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.button1, doClick)
	ViewUtil.AddClickEvent(self.button2, doClick)
	ViewUtil.AddClickEvent(self.button3, doClick)
	ViewUtil.AddClickEvent(self.button4, doClick)
end

function LeagueManagerView:initData(data)
	if IsEmpty(data) then return end
end

function LeagueManagerView:CreateLeagueMailBoard()
	local dialog = CreateObjectByPath("UI/LeagueMail")
	local shade = ViewUtil.CreateShadeView()
	HangObject(shade, dialog)
	HangObject(dialog, self.gameObject)
	ViewUtil.sortLayerOrder(dialog, LayerName.Dialog)

	local btnClose = GetGameObject(dialog.transform, "Mode/BtnClose")
	local btnSend = GetGameObject(dialog.transform, "Mode/BtnSend")
	local recverName = GetPathComponent(dialog.transform, "Mode/RecverName", "UILabel")
	local sendInput = GetPathComponent(dialog.transform, "Mode/ScrollViewBG", "UIInput")
	local blockWords = WordData.GetBlockNames()

	recverName.text = "所有军团成员"

	local function _onChange(params)
		local text = sendInput.value
		if not IsEmpty(text) then
			local content = text
			for i = 1, #blockWords do
				local idx = Util.FindWord(content, blockWords[i])
				if idx ~= -1 then
					content = Util.ReplaceWord(content, blockWords[i], "*")
				end
			end
			sendInput.value = content
		end
	end	
	Util.AddInputChangeEvent(sendInput, _onChange, {})

	Network.SendMoData(ServerID.LeagueMembers, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("LeagueTeamListMainData", session)
		
		local memIdList = {}
		for i = 1, #mo.teamListData do
			local mem = mo.teamListData[i]
			if mem.teamId ~= PlayerData.GetRoleTeamId() then
				memIdList[i] = mem.teamId
			end
		end

		local function _doClick(obj)
			if obj == btnClose then
				DestroyObject(dialog)
			elseif obj == btnSend then
				local text = sendInput.value
				if IsEmpty(text) then
					ViewUtil.showMsg("发送内容为空")
					return
				end
				if #mo.teamListData == 1 then
					ViewUtil.showMsg("只有军团长一人，无需发送。")
					return
				end
				for i = 1, #memIdList do
					Network.SendMoData(ServerID.MailSendOut, {memIdList[i], text}, function(session, params)
						local serviceId = tonumber(session.serviceId)
						local mo = GetProtoTable("DefaultData", session)
						if mo.code == 0 then
							recverName.text = " "
							sendInput.value = " "
							ViewUtil.showMsg("发送成功")
						else
							ViewUtil.showMsg("发送失败")
						end
					end, {})
				end
			end
		end

		ViewUtil.AddClickEvent(btnClose, _doClick)
		ViewUtil.AddClickEvent(btnSend, _doClick)
	end, {})
end