
LeagueMemberView = class(BaseView)

function LeagueMemberView:ctor()
end  

function LeagueMemberView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform

	self.herosConf = Config.getHerosData()

	self:initPanel()
end

function LeagueMemberView:Start(data)
	-- self:initData(data)
end

function LeagueMemberView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"
	self.amounts = GetPathComponent(self.transform, topPath.."/Amounts", "UILabel")

	local centerPath = "Mode/Center/Panel"
	self.scvBG = GetGameObject(self.transform, centerPath.."/ScrollViewBG")
	self.scvObj = GetGameObject(self.scvBG.transform, "ScrollView")
	self.grid = GetGameObject(self.scvObj.transform, "Panel/Grid")
	self.bar = GetGameObject(self.grid.transform, "LeagueMember")

	-- ViewUtil.adaptUISize(self.scvBG, true, 80, 60, 0, 0)
	-- ViewUtil.adaptUISize(self.scvObj, true, 154, 70, 16, 16)

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")
	self.btnQuit = GetGameObject(self.transform, bottomPath.."/BtnQuit")
	self.lblQuit = GetPathComponent(self.transform, bottomPath.."/BtnQuit/Tittle", "UILabel")

    local function doClick(obj)		
		if obj == self.btnBack then
			self:closeView(true)
		elseif obj == self.btnQuit then
			local isCaptain = LeagueData.IsCaptain()
			local word = ""
			if isCaptain then
				word = "是否确认解散军团？"
			else
				word = "是否确认退出军团？"
			end

			ViewUtil.comCfmPanel(word, function ()
				LeagueManagerControler.QuitLeague(isCaptain)
			end);
		end
    end

	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnQuit, doClick)
end

function LeagueMemberView:initData(data)
	if IsEmpty(data) then return end

	LeagueData.SetMyClass(data.myLeveL)

	if LeagueData.IsCaptain() then
		-- self.lblQuit.text = GetWord("DissolveLeague")
		self.lblQuit.text = "解散军团"
	else
		-- self.lblQuit.text = GetWord("QuitLeague")
		self.lblQuit.text = "退出军团"
	end

	plog(data.teamListData, "tree")
	local members = data.teamListData
	self.memberNum = #members
	self.amounts.text = self.memberNum .. "/50"
		
	local function _callback(obj)
		ViewUtil.comCfmPanel("是否确认踢出该成员？", function ()
			local function _call(session, tbl)
				local serviceId = tonumber(session.serviceId)
				if serviceId == ServerID.LeagueFire then
					local mo = GetProtoTable("DefaultData", session)
					if mo.code == 0 then
						ViewUtil.showMsg("已踢出军团！")
						local bar = tbl.obj
						if bar ~= nil then
							DestroyObject(bar)
							ResetScrollView(self.scvObj)
							self.memberNum = self.memberNum - 1
							self.amounts.text = self.memberNum .. "/50"
						end
					else
						ViewUtil.showMsg(GetWord(defData.code))
					end
				end
			end
			local lb = GetComponent(obj.transform, "LuaBehaviour")
			if not IsEmpty(lb) then
				local luaClass = lb.sourceLuaObj
				local memId = tonumber(luaClass.mem.teamId) or 0
				if memId and memId > 0 then
					Network.SendMoData(ServerID.LeagueFire, {memId}, _call, {obj = luaClass.obj})
				end
			end
		end);
	end

	for i = 1, #members do
		local mem = members[i]
		local bar = nil
		local job = ""

		if mem.level == 5 then
			bar = self.bar
			job = "军团长"
		else
			bar = CreateObjectByPath("UI/LeagueMember", AssetBundleInfo.assetBundles)
			-- bar = CreateObject(self.bar)
			HangObject(bar, self.grid)
			job = "团员"
		end
		bar.name = mem.teamId

		local btnFire = GetGameObject(bar.transform, "BtnFire")
		-- BindLuaScript({obj = bar, mem = mem}, btnFire)

		if not LeagueData.IsCaptain() then
			-- NGUITools.SetActive(btnFire, false)
			btnFire:SetActive(false)
		else
			if mem.level == LeagueData.GetMyClass() then
				-- NGUITools.SetActive(btnFire, false)
				btnFire:SetActive(false)
			else
				BindLuaScript({obj = bar, mem = mem}, btnFire)
				ViewUtil.AddClickEvent(btnFire, _callback)
			end
		end

		local name = GetPathComponent(bar.transform, "Name", "UILabel")
		local contribution = GetPathComponent(bar.transform, "Contribution", "UILabel")
		local fightValue = GetPathComponent(bar.transform, "FightValue", "UILabel")
		local lastLogin = GetPathComponent(bar.transform, "LastLogin", "UILabel")
		name.text = mem.name.."（"..job.."）"
		contribution.text = mem.amount
		fightValue.text = LogicUtil.getShowNum(mem.power)
		lastLogin.text = Date2String(mem.lastTime/1000)

		local heroObj = GetGameObject(bar.transform, "Hero")
		local heroSpr = GetPathComponent(heroObj.transform, "Sprite", "UISprite")
		local conf = self.herosConf[tostring(mem.logoId)] or {}
		local heroName = conf["#prefab_name"]
		heroSpr.spriteName = heroName

		local function callback(obj)
			if obj == heroObj then
				local dialog = CreateObjectByPath("UI/LeagueMemberInfo")
				HangObject(ViewUtil.CreateShadeView(), dialog)
				HangObject(dialog, self.gameObject)
				ViewUtil.sortLayerOrder(dialog, LayerName.Dialog)

				local topPath = "Mode/Top/Panel"
				local btnExit = GetGameObject(dialog.transform, topPath.."/BtnExit")

				local centerPath = "Mode/Center/Panel"
				local infoNameLbl = GetPathComponent(dialog.transform, centerPath.."/Name", "UILabel")
				local infoHeroSpr = GetPathComponent(dialog.transform, centerPath.."/Hero/Sprite", "UISprite")
				local zl = GetPathComponent(dialog.transform, centerPath.."/Prop5", "UILabel")
				local xg = GetPathComponent(dialog.transform, centerPath.."/Prop1", "UILabel")
				local fy = GetPathComponent(dialog.transform, centerPath.."/Prop2", "UILabel")
				local sb = GetPathComponent(dialog.transform, centerPath.."/Prop3", "UILabel")
				local wz = GetPathComponent(dialog.transform, centerPath.."/Prop4", "UILabel")
				local infoLeagueLbl = GetPathComponent(dialog.transform, centerPath.."/League", "UILabel")
				local infoJobLbl = GetPathComponent(dialog.transform, centerPath.."/Job", "UILabel")
				local infoGridObj = GetGameObject(dialog.transform, centerPath.."/ScrollViewBG/ScrollView/Panel/Grid")
				local shadow = GetGameObject(infoGridObj.transform, "Shadow")

				local bottomPath = "Mode/Bottom/Panel"
				local btnAdd = GetGameObject(dialog.transform, bottomPath.."/BtnAdd")
				local btnSend = GetGameObject(dialog.transform, bottomPath.."/BtnSend")

				local function doClick(obj)
					if obj == btnExit then
						DestroyObject(dialog)
					elseif obj == btnAdd then
						if mem.teamId == PlayerData.GetRoleTeamId() then
							ViewUtil.showMsg("无法添加自己！")
							return
						end
						local function _callback(session)
							local mo = GetProtoTable("DefaultData", session)
							if mo.code == 0 then
								Util.EnableButton(btnAdd, ButtonState.Pressed, false)
								lblTitle.text = GetWord("FriendApplyed")
							else
								ViewUtil.showMsg(GetWord(tostring(mo.code)))
							end
						end
						Network.SendMoData(ServerID.FriendAdd, {mem.teamId}, _callback)
					elseif obj == btnSend then
						if mem.teamId == PlayerData.GetRoleTeamId() then
							ViewUtil.showMsg("无法给自己发邮件！")
							return
						end
						self:CreateLeagueMailBoard(mem.teamId, mem.name)
						-- DestroyObject(dialog)
					end
				end
				ViewUtil.AddClickEvent(btnExit, doClick)
				ViewUtil.AddClickEvent(btnAdd, doClick)
				ViewUtil.AddClickEvent(btnSend, doClick)

				Network.SendMoData(ServerID.FriendInfo, {mem.teamId}, function(session, params)
					local serviceId = tonumber(session.serviceId)
					local mo = GetProtoTable("TeamInfoData", session)
					local ability = mo.ability
					local heroeIds = StrSplit(mo.heroIds, ",")
					
					infoNameLbl.text = mo.name
					--头像信息怎么取
					infoHeroSpr.spriteName = heroName

					zl.text = LogicUtil.getShowNum(ability.power)
					xg.text = ability.xg
					fy.text = ability.fy
					sb.text = ability.sb
					wz.text = ability.wz
					infoLeagueLbl.text = TeamData.GetLeagueName()
					infoJobLbl.text = job

					local heroes = {}
					local rowMax = 5
					local index = 1
					local positionX = -195
    				local positionY = 70
					for i = 1, math.modf(#heroeIds/rowMax + 1) do
				        for j = 1, rowMax do
				            if heroeIds[index] ~= nil then
				                heroes[index] = ViewUtil.CreateFriendHeroes(heroeIds[index], infoGridObj)
				                heroes[index].transform.localPosition = Vector3.New(positionX, positionY, 0)
				                heroes[index].transform.localScale = Vector3.New(0.8, 0.8, 0)
				                GetPathComponent(heroes[index].transform, "", "BoxCollider2D").enabled = false
				                GetGameObject(heroes[index].transform, "BG"):SetActive(false)

				                local heroShadow = CreateObject(shadow)
				                heroShadow:SetActive(true)
				                HangObject(heroShadow, heroes[index])
				                heroShadow.transform.localPosition = Vector3.New(0, -35, 0)
				                GetComponent(heroShadow.transform, "UI2DSprite").depth = GetPathComponent(heroes[index].transform, "Sprite", "UISprite").depth - 1

				                positionX = positionX + 90
				                index = index + 1
				            end
				        end
        
				        local oushu = nil
				        oushu = math.mod(i, 2)
				        if tonumber(oushu) ~= 1 then
				            positionX = -195
				        else
				            positionX = -160
				        end
				        positionY = positionY - 90
				    end
				end, {})
			end
		end
		ViewUtil.AddClickEvent(heroObj, callback)
	end

	ResetGrid(self.grid)
	ResetScrollView(self.scvObj)
end

function LeagueMemberView:CreateLeagueMailBoard(_recvId, _recvName)
	local dialog = CreateObjectByPath("UI/LeagueMail")
	local shade = ViewUtil.CreateShadeView()
	HangObject(shade, dialog)
	HangObject(dialog, self.gameObject)
	ViewUtil.sortLayerOrder(dialog, LayerName.Dialog)

	local btnClose = GetGameObject(dialog.transform, "Mode/BtnClose")
	local btnSend = GetGameObject(dialog.transform, "Mode/BtnSend")
	local recverName = GetPathComponent(dialog.transform, "Mode/RecverName", "UILabel")
	local sendInput = GetPathComponent(dialog.transform, "Mode/ScrollViewBG", "UIInput")
	local blockWords = WordData.GetBlockNames()

	recverName.text = _recvName

	local function _onChange(params)
		local text = sendInput.value
		if not IsEmpty(text) then
			local content = text
			for i = 1, #blockWords do
				local idx = Util.FindWord(content, blockWords[i])
				if idx ~= -1 then
					content = Util.ReplaceWord(content, blockWords[i], "*")
				end
			end
			sendInput.value = content
		end
	end	
	Util.AddInputChangeEvent(sendInput, _onChange, {})

	local function _doClick(obj)
		if obj == btnClose then
			DestroyObject(dialog)
		elseif obj == btnSend then
			local text = sendInput.value
			if IsEmpty(text) then
				ViewUtil.showMsg("发送内容为空")
				return
			end

			Network.SendMoData(ServerID.MailSendOut, {_recvId, text}, function(session, params)
				local serviceId = tonumber(session.serviceId)
				local mo = GetProtoTable("DefaultData", session)
				if mo.code == 0 then
					recverName.text = " "
					sendInput.value = " "
					ViewUtil.showMsg("发送成功")
				else
					ViewUtil.showMsg("发送失败")
				end
			end, {})
		end
	end

	ViewUtil.AddClickEvent(btnClose, _doClick)
	ViewUtil.AddClickEvent(btnSend, _doClick)
end