
LeaguePVEMapView = class(BaseView)

function LeaguePVEMapView:ctor()
	self.gameObject = nil;
    self.transform = nil;
end  

function LeaguePVEMapView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform

	self.bosses = {}
	self.bossTipList = {}
	self.numFightBoss = {}
	self.bossIdList = {}
	self.bossPositionList = {}
	self.slotList = {}
	self.curSlotList = {}
	self.tempPos = nil
	self.bossBloodList = {}
	self.bossLifeList = {}
	self.bossProgressList = {}

	self.herosConf = Config.getHerosData()

	self:initPanel()
end

function LeaguePVEMapView:Start(data)
	-- self:initData(data)
end

function LeaguePVEMapView:initPanel()	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	--版本1
	-- self.bosses[1] = GetGameObject(self.transform, centerPath.."/MapContainer/Map/Panel/MapUnit_6/Square_13/Boss_3")
	-- self.bosses[2] = GetGameObject(self.transform, centerPath.."/MapContainer/Map/Panel/MapUnit_7/Square_13/Boss_2")
	-- self.bosses[3] = GetGameObject(self.transform, centerPath.."/MapContainer/Map/Panel/MapUnit_10/Square_13/Boss_1")

	--版本2
	-- self.boss = GetGameObject(self.transform, centerPath.."/Boss")
	-- self.bossLifeLbl = GetPathComponent(self.boss.transform, "Life", "UILabel")
	-- self.bossKilled = GetGameObject(self.boss.transform, "Killed")
	-- self.slots = GetGameObject(self.transform, centerPath.."/Slots")
	-- for i = 1, 30 do
	-- 	self.slotList[i] = GetGameObject(self.slots.transform, "Slot_"..i)
	-- end
	self.btnRank = GetGameObject(self.transform, centerPath.."/BtnRank")
	self.btnReward = GetGameObject(self.transform, centerPath.."/BtnReward")
	self.btnHunt = GetGameObject(self.transform, centerPath.."/BtnHunt")


	for i = 1, 3 do
		self.bosses[i] = GetGameObject(self.transform, centerPath.."/Boss_"..i)
		self.bossPositionList[i] = self.bosses[i].transform.localPosition

		self.bossLifeList[i] = GetGameObject(self.bosses[i].transform, "Life")
		self.bossProgressList[i] = GetPathComponent(self.bossLifeList[i].transform, "Process", "UIProgressBar")

		self.bossTipList[i] = GetGameObject(self.bosses[i].transform, "Tip")
	end

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")
	self.damage = GetPathComponent(self.transform, bottomPath.."/InfoBG/Damage", "UILabel")
	self.rank = GetPathComponent(self.transform, bottomPath.."/InfoBG/Rank", "UILabel")
	self.count = GetPathComponent(self.transform, bottomPath.."/InfoBG/Count", "UILabel")
	self.btnAddCount = GetGameObject(self.transform, bottomPath.."/InfoBG/AddCount")

    local function doClick(obj)		
		if obj == self.btnBack then
			self:QuitMap()
		elseif obj == self.btnRank then
			self:createRankBoard()
		elseif obj == self.btnReward then
			self:createRewardBoard()
		elseif obj == self.btnAddCount then
			self:CreateAddCountPane()
		--版本1
		-- elseif obj == self.bosses[1] then
		-- 	error("enter 1")
		-- 	Network.SendMoData(ServerID.LeaguePVEFight, {110101})
		-- elseif obj == self.bosses[2] then
		-- 	error("enter 2")
		-- 	Network.SendMoData(ServerID.LeaguePVEFight, {110104})
		-- elseif obj == self.bosses[3] then
		-- 	error("enter 3")
		-- 	Network.SendMoData(ServerID.LeaguePVEFight, {110105})

		--版本2
		-- elseif obj == self.boss then
		-- 	self:EnterSlot()

		elseif obj == self.bosses[1] then
			self:EnterSlot(1)
		elseif obj == self.bosses[2] then
			self:EnterSlot(2)
		elseif obj == self.bosses[3] then
			self:EnterSlot(3)
		end
    end

	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnRank, doClick)
	ViewUtil.AddClickEvent(self.btnReward, doClick)
	ViewUtil.AddClickEvent(self.btnAddCount, doClick)
	--版本1
	-- ViewUtil.AddClickEvent(self.bosses[1], doClick)
	-- ViewUtil.AddClickEvent(self.bosses[2], doClick)
	-- ViewUtil.AddClickEvent(self.bosses[3], doClick)

	--版本2
	-- ViewUtil.AddClickEvent(self.boss, doClick)

	ViewUtil.AddClickEvent(self.bosses[1], doClick)
	ViewUtil.AddClickEvent(self.bosses[2], doClick)
	ViewUtil.AddClickEvent(self.bosses[3], doClick)
end

function LeaguePVEMapView:initData(data)
	if IsEmpty(data) then return end

	if data.status == 2 then
		ViewUtil.openView(ModuleName.LeaguePVE)
	end

	self.huntInfo = data
	self.damage.text = data.player.hurt
	if data.player.rank == -1 then
		self.rank.text = 0
	else
		self.rank.text = data.player.rank
	end
	self.num = 5 - data.player.count
	self.count.text = self.num

	local npcs = data.npcs

	--版本1
	-- for i = 1, #npcs do
	-- 	local info = npcs[i]
	-- 	-- GetComponent(self.bosses[i].transform, "UISprite").spriteName = "????"..info.npcId
	-- 	GetPathComponent(self.bosses[i].transform, "Life", "UILabel").text = info.boold
	-- 	if info.boold == 0 then
	-- 		GetGameObject(self.bosses[i].transform, "Killed"):SetActive(true)
	-- 		error("lastName: "..info.lastName)
	-- 		GetPathComponent(self.bosses[i].transform, "Killed", "UILabel").text = info.lastName
	-- 	end
	-- 	--初始化狩猎情况数据
	-- end

	--版本2
	-- error(npcs[3].npcId)
	-- error(npcs[3].lastName)
	-- self.bossLifeLbl.text = npcs[3].boold
	-- if npcs[3].boold <= 0 then
	-- 	Util.EnableButton(self.boss, ButtonState.Pressed, false)
	-- end
	-- if data.npcs[3].lastName ~= "" then
	-- 	self.bossKilled:SetActive(true)
	-- 	GetComponent(self.bossKilled.transform, "UILabel").text = npcs[3].lastName
	-- end

	for i = 1, #npcs do
		local info = npcs[i]
		local bossLifeLbl = GetPathComponent(self.bosses[i].transform, "Life", "UILabel")
		local bossKilled = GetGameObject(self.bosses[i].transform, "Killed")

		self.bossProgressList[i].value = info.boold / 10000000
		self.bossBloodList[i] = info.boold
		bossLifeLbl.text = info.boold

		self.numFightBoss[i] = info.playerCount
		GetComponent(self.bossTipList[i].transform, "UILabel").text = ""..self.numFightBoss[i]

		if info.boold <= 0 then
			Util.EnableButton(self.bosses[i], ButtonState.Pressed, false)
			self.bossLifeList[i]:SetActive(false)
			self.bossTipList[i]:SetActive(false)
		end
		if info.lastName ~= "" then
			bossKilled:SetActive(true)
			GetComponent(bossKilled.transform, "UILabel").text = info.lastName
		end

		self.bossIdList[i] = info.npcId

		GetPathComponent(self.bosses[i].transform, "Name", "UISprite").spriteName = "League_HuntBoss_"..info.npcId
	end
end

function LeaguePVEMapView:CreateAddCountPane()
	local myGem = PlayerData.getMyDiamond()
	if myGem < 100 then
		ViewUtil.showMsg("血钻数量不足！")
	else
		ViewUtil.comCfmPanel("消耗100血钻购买一次狩猎次数，是否确认购买？", function ()
			Network.SendMoData(ServerID.LeaguePVEHuntAdd, {}, function(session, params)
				local serviceId = tonumber(session.serviceId)
				local mo = GetProtoTable("DefaultData", session)
				if mo.code == 0 then
					self.num = self.num + 1
					self.count.text = self.num
					ViewUtil.showMsg("购买成功！")
				elseif mo.code == 80084 then
					ViewUtil.showMsg("每日可购买狩猎次数5次！")
				else
					ViewUtil.showMsg(GetWord(tostring(mo.code)))
				end
			end, {})
		end)
	end
end

function LeaguePVEMapView:EnterSlot(_bossIdx)
	--版本2
	-- Network.SendMoData(ServerID.LeaguePVEJoin, {110104}, function(session, params)
	-- 	local serviceId = tonumber(session.serviceId)
	-- 	local mo = GetProtoTable("LeagueHuntNPCData", session)
	-- 	if mo.status == 0 then
	-- 		Util.EnableButton(self.boss, ButtonState.Pressed, false)
	-- 		self:ShowSlot(mo.players)
	-- 	else
	-- 		ViewUtil.showMsg("进入失败！")
	-- 	end
	-- end, {})
	Network.SendMoData(ServerID.LeaguePVEJoin, {self.bossIdList[_bossIdx]}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("LeagueHuntNPCData", session)
		if mo.status == 0 then
			Util.EnableButton(self.bosses[_bossIdx], ButtonState.Pressed, false)
			iTween.ScaleTo(self.bosses[_bossIdx], iTween.Hash("scale", Vector3.New(1, 1, 1), "time", 0.4))
			for i = 1, 3 do
				if i ~= _bossIdx and self.bosses[i].transform.localScale ~= Vector3.New(0.5, 0.5, 1) then
					iTween.ScaleTo(self.bosses[i], iTween.Hash("scale", Vector3.New(0.5, 0.5, 1), "time", 0.4))
				end
			end

			if self.curBossIdx ~= nil then
				self.numFightBoss[self.curBossIdx] = self.numFightBoss[self.curBossIdx] - 1
				GetComponent(self.bossTipList[self.curBossIdx].transform, "UILabel").text = ""..self.numFightBoss[self.curBossIdx]
				self:ClearSlotWhenQuit(self.curBossIdx)
			end

			self.numFightBoss[_bossIdx] = self.numFightBoss[_bossIdx] + 1
			GetComponent(self.bossTipList[_bossIdx].transform, "UILabel").text = ""..self.numFightBoss[_bossIdx]
			self.bossTipList[_bossIdx]:SetActive(false)

			if self.curBossIdx ~= nil then
				self.bossTipList[self.curBossIdx]:SetActive(true)
			end

			self:ShowSlot(mo.players, self.bosses[_bossIdx], _bossIdx)
			
			if self.bosses[_bossIdx].transform.localPosition ~= self.bossPositionList[1] then
				Util.EnableButton(self.btnHunt, ButtonState.Pressed, false)
				self.tempPos = self.bosses[_bossIdx].transform.localPosition
				self:AnmtiTween(1)
				self:AnmtiTween(2)
				self:AnmtiTween(3)
				DelayCall(function() Util.EnableButton(self.btnHunt, ButtonState.Normal, true) end, 0.6)
			end

			-- DelayCall(self:ShowSlot(mo.players, self.bosses[_bossIdx], _bossIdx), 1)
			--版本3
			-- local idx = 1
			-- local firstBossIdx = _bossIdx

			-- local function anmtiTween()
			-- 	if idx == 1 then
			-- 		Util.EnableButton(self.btnHunt, ButtonState.Pressed, false)
			-- 		for i = 1, 3 do
			-- 			if self.bossBloodList[i] > 0 and i ~= firstBossIdx then
			-- 				Util.EnableButton(self.bosses[i], ButtonState.Pressed, false)
			-- 			end
			-- 		end
			-- 	end

			-- 	if idx > 3 then
			-- 		Util.EnableButton(self.btnHunt, ButtonState.Normal, true)
			-- 		for i = 1, 3 do
			-- 			if self.bossBloodList[i] > 0 and i ~= firstBossIdx then
			-- 				Util.EnableButton(self.bosses[i], ButtonState.Normal, true)
			-- 			end
			-- 		end
			-- 		return
			-- 	end

			-- 	iTween.MoveTo(self.bosses[_bossIdx], iTween.Hash(
	  --               "position", self.bossPositionList[idx],
	  --               "islocal", true,
	  --               "time", 0.4,
	  --               "easeType", iTween.EaseType.easeOutQuad,
	  --               "oncomplete", function () 
	  --               	idx = idx + 1
	  --               	if firstBossIdx == 1 then
	  --               		_bossIdx = _bossIdx + 1
	  --               	elseif firstBossIdx == 2 then
	  --               		_bossIdx = _bossIdx + 1
	  --               		if _bossIdx > 3 then _bossIdx = 1 end
	  --               	elseif firstBossIdx == 3 then
	  --               		_bossIdx = _bossIdx - 2
	  --               		if _bossIdx < 0 then _bossIdx = 2 end
	  --               	end
	  --                   anmtiTween()
	  --               end
	  --           ))
			-- end
			
			-- if not (firstBossIdx == 1 and self.bosses[1].transform.localPosition == self.bossPositionList[1]) then
			-- 	anmtiTween()
			-- end
		else
			ViewUtil.showMsg("进入失败！")
		end
	end, {})
end

function LeaguePVEMapView:ShowSlot(data, bossObj, bossIdx)
	--版本2
	-- self.slots:SetActive(true)
	-- for i = 1, #data do
	-- 	local info = data[i]
	-- 	GetPathComponent(self.slotList[i].transform, "Label", "UILabel").text = info.teamName
	-- 	GetPathComponent(self.slotList[i].transform, "Sprite", "UISprite").spriteName = info.heroId
	-- end
	-- self.btnHunt:SetActive(true)

	-- local function _callback(obj)
	-- 	if obj == self.btnHunt then
	-- 		Network.SendMoData(ServerID.LeaguePVEFight, {110104})
	-- 	end
	-- end
	-- ViewUtil.AddClickEvent(self.btnHunt, _callback)

	if (self.curBossIdx ~= nil) and (self.bossBloodList[self.curBossIdx] > 0) then
		Util.EnableButton(self.bosses[self.curBossIdx], ButtonState.Normal, true)
	end
	self.curBossIdx = bossIdx

	if self.curSlots ~= nil then
		self.curSlots:SetActive(false)
	end
	self.btnHunt:SetActive(false)

	local slots = GetGameObject(bossObj.transform, "Slots")
	slots:SetActive(true)
	self.curSlots = slots
	
	-- local slotList = {}
	for i = 1, 30 do
		self.slotList[i] = GetGameObject(slots.transform, "Slot_"..i)
	end

	for i = 1, #data do
		local info = data[i]
		GetPathComponent(self.slotList[i].transform, "Label", "UILabel").text = info.teamName
		local conf = self.herosConf[tostring(info.heroId)] or {}
		local heroName = conf["#prefab_name"]
		GetComponent(self.slotList[i].transform, "UISprite").spriteName = heroName

		-- self.numFightBoss[bossIdx] = self.numFightBoss[bossIdx] + 1

		self.curSlotList[i] = info.teamName
	end
	-- GetComponent(self.bossTipList[bossIdx].transform, "UILabel").text = ""..self.numFightBoss[bossIdx]

	self.btnHunt:SetActive(true)

	local function _callback(obj)
		if obj == self.btnHunt then
			if self.count.text == "0" then
				ViewUtil.showMsg("今日挑战次数使用完毕！")
				return
			end
			local function callback(session)
				local mo = GetProtoTable("DefaultData", session)
				if mo.code ~= 0 then
					ViewUtil.showMsg(GetWord(tostring(mo.code)))
				end
			end
			Network.SendMoData(ServerID.LeaguePVEFight, {self.bossIdList[bossIdx]}, callback)
		end
	end
	ViewUtil.AddClickEvent(self.btnHunt, _callback)
end

function LeaguePVEMapView:AnmtiTween(_bossId)
	if self.bossBloodList[_bossId] > 0 then
		Util.EnableButton(self.bosses[_bossId], ButtonState.Pressed, false)
	end

	local moveToPos = nil

	if _bossId == self.curBossIdx then
		moveToPos = self.bossPositionList[1]
	else
		if self.bosses[_bossId].transform.localPosition == self.bossPositionList[1] then
			if self.tempPos == self.bossPositionList[2] then
				moveToPos = self.bossPositionList[3]
			else
				moveToPos = self.bossPositionList[2]
			end
		else
			moveToPos = self.tempPos
		end
	end
	
	iTween.MoveTo(self.bosses[_bossId], iTween.Hash(
	    "position", moveToPos,
	    "islocal", true,
	    "time", 0.4,
	    "easeType", iTween.EaseType.easeOutQuad,
	    "oncomplete", function () 
			if (self.bossBloodList[_bossId] > 0) and (_bossId ~= self.curBossIdx) then
				Util.EnableButton(self.bosses[_bossId], ButtonState.Normal, true)
			end
		end
	))
end

--[[

]]
function LeaguePVEMapView:QuitMap()
	Network.SendMoData(ServerID.LeaguePVEExit, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("DefaultData", session)
		if mo.code == 0 then
			ViewUtil.openView(ModuleName.LeaguePVE)
		else
			ViewUtil.showMsg("退出失败！")
		end
	end, {})
end

function LeaguePVEMapView:createRankBoard()
	local dialog = CreateObjectByPath("UI/LeaguePVERank", AssetBundleInfo.assetBundles)
	HangObject(ViewUtil.CreateShadeView(), dialog)
	HangObject(dialog, self.gameObject)
	ViewUtil.sortLayerOrder(dialog, LayerName.Dialog)

	local boardScr = LeaguePVERankBoard.new()
    PanelManager:BindPanelScript(boardScr, dialog, doNthFunc, doNthFunc, doNthFunc, doNthFunc)
    boardScr:Awake(dialog)
end

function LeaguePVEMapView:createRewardBoard()
	local dialog = CreateObjectByPath("UI/LeaguePVEReward", AssetBundleInfo.assetBundles)
	HangObject(ViewUtil.CreateShadeView(), dialog)
	HangObject(dialog, self.gameObject)
	ViewUtil.sortLayerOrder(dialog, LayerName.Dialog)

	local boardScr = LeaguePVERewardBoard.new()
    PanelManager:BindPanelScript(boardScr, dialog, doNthFunc, doNthFunc, doNthFunc, doNthFunc)
    boardScr:Awake(dialog)
end

function LeaguePVEMapView:UpdateLife(_data)
	local idx = self:FindBossIdxById(_data.index)
	local life = GetGameObject(self.bosses[idx].transform, "Life")
	local process = GetPathComponent(life.transform, "Process", "UIProgressBar")
	process.value = _data.blood / 10000000
	GetComponent(life.transform, "UILabel").text = _data.blood

	if _data.blood <= 0 then
		Util.EnableButton(self.bosses[idx], ButtonState.Pressed, false)
		life:SetActive(false)

		local bossKilled = GetGameObject(self.bosses[idx].transform, "Killed")
		bossKilled:SetActive(true)
		GetComponent(bossKilled.transform, "UILabel").text = _data.killName

		self.btnHunt:SetActive(false)
	end
end

function LeaguePVEMapView:AddTeam(_data)
	local idx = self:FindBossIdxById(_data.npcId)

	if idx == self.curBossIdx then
		local slotId = nil
		for i = 1, #self.curSlotList do
			if self.curSlotList[i] == nil then
				slotId = i
			end
		end
		if slotId == nil then
			slotId = #self.curSlotList + 1
		end
		GetPathComponent(self.slotList[slotId].transform, "Label", "UILabel").text = _data.teamName
		local conf = self.herosConf[tostring(_data.heroId)] or {}
		local heroName = conf["#prefab_name"]
		GetComponent(self.slotList[slotId].transform, "UISprite").spriteName = heroName

		self.curSlotList[slotId] = _data.teamName
	end
	
	self.numFightBoss[idx] = self.numFightBoss[idx] + 1
	GetComponent(self.bossTipList[idx].transform, "UILabel").text = ""..self.numFightBoss[idx]
end

function LeaguePVEMapView:RmvTeam(_data)
	local idx = self:FindBossIdxById(_data.npcId)

	if idx == self.curBossIdx then
		local slotId = nil
		for i = 1, #self.curSlotList do
			if self.curSlotList[i] == _data.teamName then
				slotId = i
			end
		end
		self.curSlotList[slotId] = nil

		-- if _data.teamName ~= TeamData.GetRoleName() then
			GetPathComponent(self.slotList[slotId].transform, "Label", "UILabel").text = ""
			GetComponent(self.slotList[slotId].transform, "UISprite").spriteName = "alpha"
		-- end
	end

	self.numFightBoss[idx] = self.numFightBoss[idx] - 1
	GetComponent(self.bossTipList[idx].transform, "UILabel").text = ""..self.numFightBoss[idx]
end

function LeaguePVEMapView:FindBossIdxById(id)
	-- error("update: "..id)
	local idx = 0

	for i = 1, #self.bossIdList do
		-- error("for: "..self.bossIdList[i])
		if self.bossIdList[i] == id then
			idx = i
			return idx
		end
	end

	return idx
end

function LeaguePVEMapView:ClearSlotWhenQuit(idx)
	local slots = GetGameObject(self.bosses[idx].transform, "Slots")
	for i = 1, 30 do
		if GetPathComponent(slots.transform, "Slot_"..i, "UISprite").spriteName ~= "alpha" then
			GetPathComponent(slots.transform, "Slot_"..i, "UISprite").spriteName = "alpha"
			GetPathComponent(slots.transform, "Slot_"..i.."/Label", "UILabel").text = ""
		end
	end
end