
LeaguePVERankBoard = class();

--[[

]]
function LeaguePVERankBoard:ctor ()
    self.gameObject = nil
    self.transform = nil
end

--[[

]]
function LeaguePVERankBoard:Awake (_go)
    self.gameObject = _go
    self.transform = self.gameObject.transform

    self:initPanel()
    self:request()
end

--[[

]]
function LeaguePVERankBoard:initPanel ()
    local topPath = "Mode/Top/Panel"
    self.btnClose = GetGameObject(self.transform, topPath.."/BtnClose")

    local centerPath = "Mode/Center/Panel"
    self.uiGrid = GetGameObject(self.transform, centerPath.."/ScrollViewBG/ScrollView/Panel/Grid")
    self.rankRow = GetGameObject(self.uiGrid.transform, "RankRow")

    local bottomPath = "Mode/Bottom/Panel"

    local function _callback(obj)
        if obj == self.btnClose then
            DestroyObject(self.gameObject)
        end
    end
    ViewUtil.AddClickEvent(self.btnClose, _callback)
end

--[[

]]
function LeaguePVERankBoard:request ()
    local mapData, buf = nil, nil

    mapData = Map.new()
    buf = Network.reqParamEncode(mapData)

    NetManager:SendData(self, buf, ServerID.LeaguePVERank, nil, function (sd) self:setData(sd) end, nil, doNthFunc)
end

function LeaguePVERankBoard:setData (_sd)
    local lpverMain = GetProtoTable("LeagueHuntHurtMainData", _sd)
    local rankList = lpverMain.hurtList

    --接收的数组按照排名排序，存储头名伤害。
    local maxDamage = rankList[1].hurt

    for i = 1, #rankList do
        local info = rankList[i]

        local tempObj = CreateObject(self.rankRow)
        tempObj:SetActive(true)
        HangObject(tempObj, self.uiGrid)

        -- local conf = self.herosConf[tostring(info.logo)]
        -- GetPathComponent(tempObj.transform, "Hero/Sprite", "UISprite").spriteName = HeroDataProxy.getHeroAtlasName(conf)
        GetPathComponent(tempObj.transform, "Ranking/Label", "UILabel").text = i
        GetPathComponent(tempObj.transform, "Name", "UILabel").text = info.name
        GetPathComponent(tempObj.transform, "Damage", "UILabel").text = info.hurt
        GetPathComponent(tempObj.transform, "Damage/Process", "UIProgressBar").value = info.hurt/maxDamage
    end
    ResetGrid(self.uiGrid)
end