
LeaguePVPFightingView = class(BaseView)

function LeaguePVPFightingView:ctor()
end  

function LeaguePVPFightingView:Awake(obj, ctrl)
	self.gameObject = obj
	self.transform = obj.transform
	self.ctrl = ctrl
	self.canClickMove = true
	self.canClickChest = {}
	self.canClickChest[1] = true
	self.canClickChest[2] = true
	self.canClickChest[3] = true
	self.canClickChest[4] = true
	self.canClickChest[5] = true

	self.mapUnitList = {}
	self.exploreSquareList = {}
	-- self.playerContainerList = {}
	self.enemyObjList = {}
	self.enemyIdx = 1
	self.tempScrList = {}
	self.enemyIdList = {}
	self.allyObjList = {}
	self.allyIdx = 1
	self.allyIdList = {}
	self.chestList = {}
	self.chestPositionList = {}

	self.herosConf = Config.getHerosData()

	self:initPanel()
end

function LeaguePVPFightingView:Start(data)
	-- self:initData(data)
end

function LeaguePVPFightingView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	self.mapContainer = GetGameObject(self.transform, centerPath.."/MapContainer")
	self.extWrapContent = GetGameObject(self.mapContainer.transform, "Panel/UIExtWrapContent")
	self.playerObj = GetGameObject(self.mapContainer.transform, "Panel/Player")
	self.chestList[1] = GetGameObject(self.extWrapContent.transform, "MapUnit_17/SquareContainer/ExploreSquare_3/BG/Chest_1")
	self.chestList[2] = GetGameObject(self.extWrapContent.transform, "MapUnit_13/SquareContainer/ExploreSquare_3/BG/Chest_2")
	self.chestList[3] = GetGameObject(self.extWrapContent.transform, "MapUnit_9/SquareContainer/ExploreSquare_3/BG/Chest_3")
	self.chestList[4] = GetGameObject(self.extWrapContent.transform, "MapUnit_5/SquareContainer/ExploreSquare_3/BG/Chest_4")
	self.chestList[5] = GetGameObject(self.extWrapContent.transform, "MapUnit_1/SquareContainer/ExploreSquare_3/BG/Chest_5")
	self.chestPositionList[1] = Vector2.New(3, 17)
	self.chestPositionList[2] = Vector2.New(3, 13)
	self.chestPositionList[3] = Vector2.New(3, 9)
	self.chestPositionList[4] = Vector2.New(3, 5)
	self.chestPositionList[5] = Vector2.New(3, 1)

	for i = 1, 5 do
		local function callback(obj)
			if obj == self.chestList[i] then
				--版本一
				-- local cES = self.chestList[i].transform.parent.parent
				-- local cMU = cES.parent.parent
				-- local chestWorldPosition = cES.localPosition + cMU.localPosition
				
				-- local pMU = self.player.transform.parent.parent
				-- local playerWorldPosition = self.player.transform.localPosition + pMU.localPosition

				-- error(playerWorldPosition)
				-- error(chestWorldPosition)
				-- if Vector3.Distance(playerWorldPosition, chestWorldPosition) == 1 then

				if Vector2.Distance(self.playerPosition, self.chestPositionList[i]) == 1 then
					if self.canClickChest[i] then
						self.canClickChest[i] = false
						Network.SendMoData(ServerID.LeaguePVPOpenChest, {i}, function(session, params)
							local serviceId = tonumber(session.serviceId)
							local mo = GetProtoTable("DefaultData", session)
							if mo.code == 0 then
								self:SetChestFalse(i)
								ViewUtil.showMsg("打开宝箱！")
							else
								self.canClickChest[i] = true
								ViewUtil.showMsg(GetWord(defData.code))
							end
						end, {})
					end
				else
					ViewUtil.showMsg("请移动至宝箱前开启！")
				end
			end
		end
		ViewUtil.AddClickEvent(self.chestList[i], callback)
	end

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)	
		if obj == self.btnBack then
			-- self:closeView(true)
			Network.ReqLeaguePVP()
		end
    end

	ViewUtil.AddClickEvent(self.btnBack, doClick)
end

function LeaguePVPFightingView:initData(data)
	if IsEmpty(data) then return end

	--初始化地图脚本绑定
	local idx = 1
	local coordinateX = 0
	local coordinateY = 0
	for i = 0, 18 do
		self.mapUnitList[i] = GetGameObject(self.extWrapContent.transform, "MapUnit_"..i)
		-- self.playerContainerList[i] = GetGameObject(self.mapUnitList[i].transform, "PlayerContainer")
		for j = 0, 6 do
			self.exploreSquareList[idx] = GetGameObject(self.mapUnitList[i].transform, "SquareContainer/ExploreSquare_"..j)

			local spriteName = GetPathComponent(self.exploreSquareList[idx].transform, "BG", "UISprite").spriteName
			if spriteName == "mapBG" then
				local tempRow = LeaguePVPFightingRow.new()
				tempRow:Awake(self.exploreSquareList[idx])
				-- 使用下面语句在退出场景销毁资源会导致严重的性能问题
	            -- PanelManager:BindPanelScript(tempRow, self.exploreSquareList[idx], doNthFunc, doNthFunc, doNthFunc, doNthFunc)
	            tempRow:Start()
	            local coordinate = Vector2.New(coordinateX, coordinateY)
	            tempRow:setData(coordinate, self.ctrl)
	        end

	        coordinateX = coordinateX + 1
			idx = idx + 1
		end
		coordinateX = 0
		coordinateY = coordinateY + 1
	end

	--初始化宝箱状态
	for i = 1, #data.boxList do
		local boxIdx = data.boxList[i]
		self:SetChestFalse(boxIdx)
	end

	--初始化所有玩家数据
	for i = 1, #data.teamList do
		local info = data.teamList[i]
		if info.position.teamId == PlayerData.GetRoleTeamId() then
	-- error("my x = "..info.position.x.." y = "..info.position.y)
			self:SetPlayerPosition(info.position.x, info.position.y, info)

			local offset = (9 - info.position.y) * 80
			if offset > 389 then
				offset = 389
			elseif offset < -389 then
				offset = -389
			end
			GetComponent(self.mapContainer.transform, "UIScrollView"):MoveRelative(Vector3.New(0, offset, 0))
		else
			if info.myLeauge then
	-- error("ally x = "..info.position.x.." y = "..info.position.y)
				self:SetAllyPosition(info.position.x, info.position.y, info)
			else
	-- error("enemy x = "..info.position.x.." y = "..info.position.y)
				self:SetEnemyPosition(info.position.x, info.position.y, info)
			end
		end
	end
end

function LeaguePVPFightingView:SetPlayerPosition(_x, _y, _data)
	self.playerPosition = Vector2.New(_x, _y)
	local findX = _x
	local findY = _y
	self.curPlayerContainer = GetGameObject(self.extWrapContent.transform, "MapUnit_"..findY.."/PlayerContainer")
	
	if self.player == nil then
		self.player = CreateObject(self.playerObj)
		self.player:SetActive(true)
		self.player.name = "Player_".._data.position.teamId

		local data = self.herosConf[tostring(_data.heroId)] or {}
		local name = data["#prefab_name"]
		GetComponent(self.player.transform, "UISprite").spriteName = name

		local playerNameLbl = GetPathComponent(self.player.transform, "Label", "UILabel")
		playerNameLbl.text = _data.name
		playerNameLbl.color = CreateColor(0, 255, 97, 255)
	end
	HangObject(self.player, self.curPlayerContainer)
	self.player.transform.localPosition = Vector3.New((-240 + 80 * findX), 0, 0)
end

function LeaguePVPFightingView:SetAllyPosition(_x, _y, _data)
	local allyPosition = Vector2.New(_x, _y)
	local findX = _x
	local findY = _y
	
	local curAllyContainer = GetGameObject(self.extWrapContent.transform, "MapUnit_"..findY.."/PlayerContainer")
	
	self.allyObjList[self.allyIdx] = CreateObject(self.playerObj)
	self.allyObjList[self.allyIdx]:SetActive(true)
	self.allyObjList[self.allyIdx].name = "Ally_".._data.position.teamId

	HangObject(self.allyObjList[self.allyIdx], curAllyContainer)
	self.allyObjList[self.allyIdx].transform.localPosition = Vector3.New((-240 + 80 * findX), 0, 0)

	local data = self.herosConf[tostring(_data.heroId)] or {}
	local name = data["#prefab_name"]
	GetComponent(self.allyObjList[self.allyIdx].transform, "UISprite").spriteName = name

	local allyNameLbl = GetPathComponent(self.allyObjList[self.allyIdx].transform, "Label", "UILabel")
	allyNameLbl.text = _data.name
	allyNameLbl.color = CreateColor(77, 122, 255, 255)

	self.allyIdList[self.allyIdx] = _data.position.teamId
	self.allyIdx = self.allyIdx + 1
end

function LeaguePVPFightingView:SetEnemyPosition(_x, _y, _data)
	local enemyPosition = Vector2.New(6 - _x, _y)
	local findX = _x
	local findY = _y
	local curEnemyContainer = GetGameObject(self.extWrapContent.transform, "MapUnit_"..findY.."/PlayerContainer")
	
	self.enemyObjList[self.enemyIdx] = CreateObject(self.playerObj)
	self.enemyObjList[self.enemyIdx]:SetActive(true)
	self.enemyObjList[self.enemyIdx].name = "Enemy_".._data.position.teamId

	HangObject(self.enemyObjList[self.enemyIdx], curEnemyContainer)
	self.enemyObjList[self.enemyIdx].transform.localPosition = Vector3.New((240 - 80 * findX), 0, 0)

	self.tempScrList[self.enemyIdx] = LeaguePVPFightingEnemy.new()
	self.tempScrList[self.enemyIdx]:Awake(self.enemyObjList[self.enemyIdx])	
	PanelManager:BindPanelScript(self.tempScrList[self.enemyIdx], self.enemyObjList[self.enemyIdx], doNthFunc, doNthFunc, doNthFunc, doNthFunc)
	self.tempScrList[self.enemyIdx]:Start()
	self.tempScrList[self.enemyIdx]:setData(enemyPosition, _data.position.teamId, self.ctrl)

	-- local tempScr = LeaguePVPFightingEnemy.new()
	-- tempScr:Awake(self.enemyObjList[self.enemyIdx])	
	-- PanelManager:BindPanelScript(tempScr, self.enemyObjList[self.enemyIdx], doNthFunc, doNthFunc, doNthFunc, doNthFunc)
	-- tempScr:Start()
	-- tempScr:setData(enemyPosition, _data.position.teamId, self.ctrl)

	local data = self.herosConf[tostring(_data.heroId)] or {}
	local name = data["#prefab_name"]
	GetComponent(self.enemyObjList[self.enemyIdx].transform, "UISprite").spriteName = name

	local allyNameLbl = GetPathComponent(self.enemyObjList[self.enemyIdx].transform, "Label", "UILabel")
	allyNameLbl.text = _data.name

	self.enemyIdList[self.enemyIdx] = _data.position.teamId
	self.enemyIdx = self.enemyIdx + 1
end

function LeaguePVPFightingView:SetChestFalse(idx)
	self.chestList[idx]:SetActive(false)
end

function LeaguePVPFightingView:PositionUpdate(_data)
	if _data.teamId == PlayerData.GetRoleTeamId() then return end

	local curContainer = GetGameObject(self.extWrapContent.transform, "MapUnit_".._data.y.."/PlayerContainer")
	local idx, tp = self:FindAllyOrEnemyById(_data.teamId)
	if tp == 1 then
		HangObject(self.allyObjList[idx], curContainer)
		self.allyObjList[idx].transform.localPosition = Vector3.New((-240 + 80 * _data.x), 0, 0)
	elseif tp == 2 then
		HangObject(self.enemyObjList[idx], curContainer)
		self.enemyObjList[idx].transform.localPosition = Vector3.New((240 - 80 * _data.x), 0, 0)

		local enemyPosition = Vector2.New(6 - _data.x, _data.y)
		self.tempScrList[idx]:UpdatePosVec(enemyPosition)
	end
end

--[[
	tp：1为盟友，2为敌方
]]
function LeaguePVPFightingView:FindAllyOrEnemyById(id)
	for i = 1, #self.allyIdList do
		local idx = nil
		local tp = nil
		if self.allyIdList[i] == id then
			idx = i
			tp = 1
			return idx, tp
		end
	end
	for i = 1, #self.enemyIdList do
		if self.enemyIdList[i] == id then
			idx = i
			tp = 2
			return idx, tp
		end
	end
end