
LeaguePVPFinalView = class(BaseView)

local const_rule = "hello world"

function LeaguePVPFinalView:ctor()
end  

function LeaguePVPFinalView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform

	self.groupList = {}

	self:initPanel()
end

function LeaguePVPFinalView:Start(data)
	-- self:initData(data)
end

function LeaguePVPFinalView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	self.btnRule = GetGameObject(self.transform, centerPath.."/BtnRule")
	self.tip = GetGameObject(self.transform, centerPath.."/Tip")
	self.tipLbl = GetPathComponent(self.tip.transform, "Time", "UILabel")

	for i = 1, 3 do
		self.groupList[i] = GetGameObject(self.transform, centerPath.."/Group_"..i)
	end
	self.btnJoin = GetGameObject(self.transform, centerPath.."/BtnJoin")

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)
		if obj == self.btnBack then
			-- self:closeView(true)
			ViewUtil.goto(ModuleName.LeagueJoined)
		elseif obj == self.btnJoin then
			Network.ReqLeaguePVPJoin()
		elseif obj == self.btnRule then
			self:createRuleBoard()
		end
    end
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnJoin, doClick)
	ViewUtil.AddClickEvent(self.btnRule, doClick)

	self.mainBG = GetGameObject(self.transform, centerPath.."/mainBG")
end

-- function LeaguePVPFinalView:initListener ()
--     UIEventListener.Get(self.btnRule).onPress = function (_go, _isPress) 
--         if (_isPress) then
--             ViewUtil.showCommonTips(self.btnRule, const_rule)
--         else
--             ViewUtil.removeTips()
--         end
--     end
-- end

function LeaguePVPFinalView:initData(data)
	if IsEmpty(data) then return end

	-- error("status = "..data.status)
	-- error("curRound = "..data.curRound)
	-- error("startRound = "..data.startRound)
	if data.status == 0 or data.status ==3 then
		self.btnJoin:SetActive(false)
	end

	if data.status == 0 and data.curRound == 2 then
		self.tip:SetActive(true)
	end

	if data.status == 3 and data.curRound == 2 then
		self.tipLbl.text = "下一轮王者战将于八点二十开始"
		self.tip:SetActive(true)
	end

	-- error("list: "..#data.leagueList)
	for i = 1, #data.leagueList do
		local info = data.leagueList[i]

		local leagueHome = GetGameObject(self.groupList[i].transform, "LeagueHome")
		local leagueHomeLbl = GetComponent(leagueHome.transform, "UILabel")
		local leagueHomeBadgeSpr = GetPathComponent(leagueHome.transform, "Badge", "UISprite")
		local leagueHWin = GetGameObject(leagueHome.transform, "Win")
		local leagueAway = GetGameObject(self.groupList[i].transform, "LeagueAway")
		local leagueAwayLbl = GetComponent(leagueAway.transform, "UILabel")
		local leagueAwayBadgeSpr = GetPathComponent(leagueAway.transform, "Badge", "UISprite")
		local leagueAWin = GetGameObject(leagueAway.transform, "Win")

		leagueHomeLbl.text = info.homeName
		leagueHomeBadgeSpr.spriteName = "LeagueBadge_"..info.homeLogo
		leagueAwayLbl.text = info.awayName
		leagueAwayBadgeSpr.spriteName = "LeagueBadge_"..info.awayLogo

		if info.homeName == TeamData.GetLeagueName() then
			leagueHomeLbl.color = CreateColor(0, 255, 97, 255)
		elseif info.awayName == TeamData.GetLeagueName() then
			leagueAwayLbl.color = CreateColor(0, 255, 97, 255)
		end

		if info.winName ~= "" then
			if info.winName == info.homeName then
				leagueHWin:SetActive(true)
			else
				leagueAWin:SetActive(true)
			end
		end
	end
end

function LeaguePVPFinalView:createRuleBoard()
	local dialog = CreateObjectByPath("UI/LeaguePVPRule")
	HangObject(ViewUtil.CreateShadeView(), dialog)
	HangObject(dialog, self.gameObject)
	ViewUtil.sortLayerOrder(dialog, LayerName.Dialog)

	local centerPath = "Mode/Center/Panel"
	local ruleLbl = GetPathComponent(dialog.transform, centerPath.."/ScrollViewBG/ScrollView/Panel/Label", "UILabel")

	local bottomPath = "Mode/Bottom/Panel"
	local btnExit = GetGameObject(dialog.transform, bottomPath.."/BtnExit")

	local function _callback(obj)
		if obj == btnExit then
			DestroyObject(dialog)
		end
	end

	ViewUtil.AddClickEvent(btnExit, _callback)
end