
LeaguePVPPreView = class(BaseView)

local const_rule = "hello world"

function LeaguePVPPreView:ctor()
end  

function LeaguePVPPreView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform

	self.nextRoundTimeList = {}
	self.nextRoundTimeList[1] = "下一轮战斗将于20:20:00开始"
	self.nextRoundTimeList[2] = "下一轮战斗将于20:40:00开始"
	self.nextRoundTimeList[3] = "预选赛已结束，请等待本周六开赛。"

	self:initPanel()
end

function LeaguePVPPreView:Start(data)
	-- self:initData(data)
end

function LeaguePVPPreView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	self.btnRule = GetGameObject(self.transform, centerPath.."/BtnRule")
	self.gridObj = GetGameObject(self.transform, centerPath.."/ScrollViewBG/ScrollView/Panel/Grid")
	-- self.rankRow = GetGameObject(self.gridObj.transform, "RankRow")
	self.rankRow = GetGameObject(self.transform, centerPath.."/ScrollViewBG/RankRow")
	self.matching = GetGameObject(self.transform, centerPath.."/Matching")
	self.matched = GetGameObject(self.transform, centerPath.."/Matched")
	self.nextRound = GetGameObject(self.transform, centerPath.."/NextRound")
	self.nextRoundLbl = GetPathComponent(self.nextRound.transform, "Time", "UILabel")
	self.leagueMineLbl = GetPathComponent(self.matched.transform, "LeagueMine", "UILabel")
	self.leagueOtherLbl = GetPathComponent(self.matched.transform, "LeagueOther", "UILabel")

	-- self.situation = GetGameObject(self.transform, centerPath.."/Situation")
	-- self.situationLbl = GetPathComponent(self.situation.transform, "Label", "UILabel")
	self.btnJoin = GetGameObject(self.transform, centerPath.."/BtnJoin")
	self.btnJoinLbl = GetPathComponent(self.btnJoin.transform, "Title", "UILabel")

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)
		if obj == self.btnBack then
			-- self:closeView(true)
			ViewUtil.goto(ModuleName.LeagueJoined)
		elseif obj == self.btnJoin then
			Network.ReqLeaguePVPJoin()
		elseif obj == self.btnRule then
			self:createRuleBoard()
		end
    end

	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnJoin, doClick)
	ViewUtil.AddClickEvent(self.btnRule, doClick)
end

-- function LeaguePVPPreView:initListener ()
--     UIEventListener.Get(self.btnRule).onPress = function (_go, _isPress) 
--         if (_isPress) then
--             ViewUtil.showCommonTips(self.btnRule, const_rule)
--         else
--             ViewUtil.removeTips()
--         end
--     end
-- end

function LeaguePVPPreView:initData(data)
	if IsEmpty(data) then return end

	DestroyChildren(self.gridObj)
	for i = 1, #data.rankList do
		local info = data.rankList[i]

		local tempRow = CreateObject(self.rankRow)
		HangObject(tempRow, self.gridObj)
		tempRow:SetActive(true)

		local nameLbl = GetPathComponent(tempRow.transform, "Name", "UILabel")
		local fightValLbl = GetPathComponent(tempRow.transform, "FightVal", "UILabel")
		local rankLbl = GetPathComponent(tempRow.transform, "Rank", "UILabel")
		local pointLbl = GetPathComponent(tempRow.transform, "Point", "UILabel")

		nameLbl.text = info.name
		fightValLbl.text = LogicUtil.getShowNum(info.power)
		rankLbl.text = info.rank
		pointLbl.text = info.amount

		if info.name == TeamData.GetLeagueName() then
			nameLbl.color = CreateColor(0, 255, 97, 255)
			fightValLbl.color = CreateColor(0, 255, 97, 255)
			rankLbl.color = CreateColor(0, 255, 97, 255)
			pointLbl.color = CreateColor(0, 255, 97, 255)
		end
	end
	ResetGrid(self.gridObj)

	if data.status ~= 0 then
		if data.leagueName == "" then
			Util.EnableButton(self.btnJoin, ButtonState.Disabled, false)
			self.btnJoinLbl.text = "已报名"
			self.matching:SetActive(true)
		else
			self:RefreshStatus(data.leagueName)
		end
	else
		Util.EnableButton(self.btnJoin, ButtonState.Disabled, false)
		self.btnJoinLbl.text = "未报名"
	end

	-- error("waitSatus = "..data.waitSatus)
	-- error("round = "..data.round)
	if (data.waitSatus == 3 and data.round == 1) or (data.waitSatus == 0 and data.round == 2) then
		self:ShowNextRound(1)
	elseif (data.waitSatus == 3 and data.round == 2) or (data.waitSatus == 0 and data.round == 3) then
		self:ShowNextRound(2)
	elseif (data.waitSatus == 3 and data.round == 3) then
		self:ShowNextRound(3)
	end

	-- if data.waitSatus == 3 or data.waitSatus == 0 then
	-- 	if data.round < 3 then
	-- 		self.btnJoin:SetActive(false)
	-- 		if data.round == 2 then
	-- 			self.nextRoundLbl.text = self.nextRoundTimeList[1]
	-- 		elseif data.round == 3 then
	-- 			self.nextRoundLbl.text = self.nextRoundTimeList[2]
	-- 		end
	-- 		self.nextRound:SetActive(true)
	-- 		self.matching:SetActive(false)
	-- 		self.matched:SetActive(false)
	-- 	end
	-- end
end

function LeaguePVPPreView:RefreshStatus(data)
	self.nextRound:SetActive(false)
	self.matching:SetActive(false)
	self.matched:SetActive(true)
	self.leagueMineLbl.text = TeamData.GetLeagueName()
	self.leagueOtherLbl.text = data
	self.btnJoinLbl.text = "参战"
	self.btnJoin:SetActive(true)
	Util.EnableButton(self.btnJoin, ButtonState.Normal, true)
end

function LeaguePVPPreView:ShowNextRound(idx)
	self.btnJoin:SetActive(false)
	self.matching:SetActive(false)
	self.matched:SetActive(false)
	self.nextRoundLbl.text = self.nextRoundTimeList[idx]
	self.nextRound:SetActive(true)
end

function LeaguePVPPreView:createRuleBoard()
	local dialog = CreateObjectByPath("UI/LeaguePVPRule")
	HangObject(ViewUtil.CreateShadeView(), dialog)
	HangObject(dialog, self.gameObject)
	ViewUtil.sortLayerOrder(dialog, LayerName.Dialog)

	local centerPath = "Mode/Center/Panel"
	local ruleLbl = GetPathComponent(dialog.transform, centerPath.."/ScrollViewBG/ScrollView/Panel/Label", "UILabel")

	local bottomPath = "Mode/Bottom/Panel"
	local btnExit = GetGameObject(dialog.transform, bottomPath.."/BtnExit")

	local function _callback(obj)
		if obj == btnExit then
			DestroyObject(dialog)
		end
	end

	ViewUtil.AddClickEvent(btnExit, _callback)
end