
LeaguePVPView = class(BaseView)

function LeaguePVPView:ctor()
end  

function LeaguePVPView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
end

function LeaguePVPView:Start(data)
	-- self:initData(data)
end

function LeaguePVPView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	self.board_1 = GetGameObject(self.transform, centerPath.."/Board_1")
	self.lastChampionLbl = GetPathComponent(self.transform, centerPath.."/Board_2/LastChampion", "UILabel")
	self.lastChampionSpr = GetPathComponent(self.transform, centerPath.."/Board_2/LastChampion/Badge", "UISprite")
	self.pvpTimeLbl = GetPathComponent(self.transform, centerPath.."/PVPTime", "UILabel")
	self.pvpTimeTitleLbl = GetPathComponent(self.transform, centerPath.."/PVPTime/Title", "UILabel")
	self.btnRule = GetGameObject(self.transform, centerPath.."/BtnRule")
	self.btnRank = GetGameObject(self.transform, centerPath.."/BtnRank")
	self.btnApply = GetGameObject(self.transform, centerPath.."/BtnApply")
	self.btnApplyLbl = GetPathComponent(self.btnApply.transform, "Title", "UILabel")

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)		
		if obj == self.btnBack then
			-- self:closeView(true)
			ViewUtil.goto(ModuleName.LeagueJoined)
		elseif obj == self.btnRule then
			self:createRuleBoard()
		elseif obj == self.btnApply then
			Network.SendMoData(ServerID.LeaguePVPApply, {}, function(session, params)
				local serviceId = tonumber(session.serviceId)
				local mo = GetProtoTable("DefaultData", session)
				if mo.code == 0 then
					self.btnApplyLbl.text = "已报名"
					Util.EnableButton(self.btnApply, ButtonState.Disabled, false)					
					ViewUtil.showMsg("报名成功")
				else
					ViewUtil.showMsg("报名失败")
				end
			end, {})
		end
    end

	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnRule, doClick)
	ViewUtil.AddClickEvent(self.btnRank, doClick)
	ViewUtil.AddClickEvent(self.btnApply, doClick)

	local propItem = CreateObject(Util.LoadPrefab("UI/PropItem", AssetBundleInfo.assetBundles));
    local propItemShow = PropShowItem.new();
    propItemShow:Awake(propItem, 1069);
    propItemShow:Start(true);
    PanelManager:BindPanelScript(propItemShow, propItem, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    HangObject(propItem, self.board_1);
    ViewUtil.sortLayerOrder(propItem, LayerName.Dialog)
    propItem.transform.localPosition = Vector3.New(0, -4, 0)
end

function LeaguePVPView:initData(data)
	if IsEmpty(data) then return end

	if data.leagueName ~= "" then
		self.lastChampionLbl.text = data.leagueName
		self.lastChampionSpr.spriteName = "LeagueBadge_"..data.leagueLogo
	end
	
	self.time = data.nextTime

	self.pvpTimeLbl.text = Date2String(self.time/1000)

	if LeagueData.IsCaptain() and data.stage == 0 then
		self.btnApply:SetActive(true)
	elseif data.stage == 3 then
		self.btnApply:SetActive(false)
	end

	if data.status == 1 then
		self.pvpTimeTitleLbl.text = "比赛时间"

		if not self.btnApply.activeSelf then
			self.btnApply:SetActive(true)
		end
		self.btnApplyLbl.text = "已报名"
		Util.EnableButton(self.btnApply, ButtonState.Disabled, false)
	elseif data.status == 3 then
		self.btnApply:SetActive(false)
	end
	--取的系统时间，与测试服务器时间可能不一致
	-- local day = tostring(DateTime.Now.DayOfWeek)
	-- local hour = DateTime.Now.Hour
	-- local minute = DateTime.Now.Minute
	-- if day == "Wednesday" and hour == 7 and minute > 30 then
	-- 	self.btnApply:SetActive(false)
	-- end
	local realTime = PlayerData.getCurSysTime()
	local timeInfo = PlayerData.getCurTimeStr(realTime)
	local day = timeInfo[8]
	local hour = timeInfo[5]
	local minute = timeInfo[6]

	if day == 3 and hour == 19 and minute > 29 then
		self.btnApply:SetActive(false)
	end
end

function LeaguePVPView:createRuleBoard()
	local dialog = CreateObjectByPath("UI/LeaguePVPRule")
	HangObject(ViewUtil.CreateShadeView(), dialog)
	HangObject(dialog, self.gameObject)
	ViewUtil.sortLayerOrder(dialog, LayerName.Dialog)

	local centerPath = "Mode/Center/Panel"
	local ruleLbl = GetPathComponent(dialog.transform, centerPath.."/ScrollViewBG/ScrollView/Panel/Label", "UILabel")

	local bottomPath = "Mode/Bottom/Panel"
	local btnExit = GetGameObject(dialog.transform, bottomPath.."/BtnExit")

	local function _callback(obj)
		if obj == btnExit then
			DestroyObject(dialog)
		end
	end

	ViewUtil.AddClickEvent(btnExit, _callback)
end