
LeagueWealView = class(BaseView)

function LeagueWealView:ctor()
end  

function LeagueWealView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
end

function LeagueWealView:Start(data)
	-- self:initData(data)
end

function LeagueWealView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	self.myContriLbl = GetPathComponent(self.transform, centerPath.."/MyContribution", "UILabel")
	self.btnObtain = GetGameObject(self.transform, centerPath.."/BtnObtain")

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)	
		if obj == self.btnBack then
			self:closeView(true)
		elseif obj == self.btnObtain then
			self:GetRwd()
		end
    end

	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnObtain, doClick)
end

function LeagueWealView:initData(data)
	if IsEmpty(data) then return end

	self.amount = data.amount
	self.myContriLbl.text = self.amount
	
	self.btnStatus = data.dayGift
	self:SetButton(self.btnStatus)

	if self.amount < 200 then
		-- ViewUtil.showMsg("贡献值不足，无法领取！")
		Util.EnableButton(self.btnObtain, ButtonState.Disabled, false)
	end
end

function LeagueWealView:SetButton(_status)
	if _status == 1 then
		Util.EnableButton(self.btnObtain, ButtonState.Disabled, false)
	end
end

function LeagueWealView:GetRwd()
	local mapData, buf = Map.new(), nil;
    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.LeagueDailyRewards, nil, function (sd) self:GetRwdHandle(sd); end, nil ,doNthFunc)
end

function LeagueWealView:GetRwdHandle(_sd)
	local defData = nil;
    defData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end
    ViewUtil.showMsg("领取成功！");

    self.amount = self.amount - 200
	self.myContriLbl.text = self.amount

	self.btnStatus = 1
	self:SetButton(self.btnStatus)
end