require "Game/Loading/View/LoadingView"
 
LoadingControler = {}

local this = LoadingControler
this.curServiceId = nil
this.exceptViews = {ModuleName.FIGHT}

function LoadingControler.New()
	return this
end

function LoadingControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = LoadingView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)
	
	this.luaBehaviour = this.transform:GetComponent("LuaBehaviour")
	this.view:Awake(this.gameObject)
    this.initListener()
	
	ViewUtil.sortLayerOrder(this.gameObject, LayerName.Top)
end

function LoadingControler.Awake()
end

function LoadingControler.Start()
	this.view:Start(this.data)
end

function LoadingControler.Update()
end

function LoadingControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.view:OnDestroy()
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function LoadingControler.initListener()
end

function LoadingControler.listNotificationInterests()
    local list = {MVCConst.ON_LOADING, MVCConst.OPEN_MODULE, MVCConst.ON_CLOSE}
    return unpack(list)
end

function LoadingControler.handleNotification(notification)
	local const = notification:getName()
	local body = notification:getBody() or {}
	local mod = body[1]
	local sw = body[2] and true or false
	local cb = body[3] or nil
	local pa = body[4] or nil
	
	if const == MVCConst.ON_LOADING then
        if cb ~= nil then cb(pa) end

	elseif const == MVCConst.OPEN_MODULE then

	elseif const == MVCConst.ON_CLOSE then
	end
end

function LoadingControler.accept(data)
	ViewUtil.initData(data)
end
