
LoadingView = class(BaseView)

 function LoadingView:ctor()
end  

function LoadingView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
end

function LoadingView:Start(data)
	self:initData(data)
	
		plog("LoadingView:Start")
end

function LoadingView:initPanel()
 	self.bgSpr = GetPathComponent(self.transform, "Mode/BG", "UISprite")
 	self.bgSpr:SetDimensions(ViewManager.realWidth*1.3, ViewManager.realHeight)
	self.btnBG = GetGameObject(self.transform, "Mode/Collider")
 	self.boxCollider = GetComponent(self.btnBG.transform, "BoxCollider2D")
	self.boxCollider.size = Vector2.New(ViewManager.realWidth*1.3, ViewManager.realHeight)
end

function LoadingView:initData(data)
	if self.coroutine ~= nil then
		CancelDelayCall(self.coroutine)
	end
	self.coroutine = DelayCall(function()
		ViewUtil.showMsg("连接超时!")
		self:closeView(false)
		EnterControler.Login(true, true)
	end, 10)
end

function LoadingView:OnDestroy()
	CancelDelayCall(self.coroutine)
end

