require "Game/Login/View/EnterView"
 
EnterControler = {}

local this = EnterControler

function EnterControler.New()
	return this
end

function EnterControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = EnterView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function EnterControler.Login(reconnect, openAgain)
	local function _callback(sessionData2)
		Network.isConnected = true
		local data = GetProtoTable("TeamLoadData", sessionData2)
		PlayerData.initPlayerData(data)		-- 初始化玩家数据
		TeamData.New(data)						-- 初始化Team数据
        PropDataProxy.setMyProps(data.pagData.propList);--初始化道具数据
        GameCfgDataProxy.SetBroadcast(data.gameSource.notice)
		FBData.New(data)
		Network.ReqGotHeroInfo();
        Network.ReqGetSysDate();
        Network.ReqActInfo();
		
		Access.submitData(MangoGameData.ENTER_GAME)
		if Application.isMobilePlatform then -- UMeng
			local roleData = TeamData.getMyRoleHeroData()
			GA.SetUserLevel(tonumber(roleData.level) or 0)
		end
        
        -- PlayerData.setMyGuideStep(350);
		GameDefine.EnterGame = true
        --在进入登录界面之前已经初始化了所有需要的动画预设，不再在这里二次初始化
        --2017-2-21 09:59:14 modified by library
		--InitActorObjects()
		DelayCall(function()
			if openAgain then
				ViewUtil.openCurView()
			else
				if (PlayerData.guideNotEnd()) then
					ViewUtil.openView(ModuleName.GUIDE, true, function ()
						ViewUtil.openView(ModuleName.MAIN, true, function()
							ViewUtil.closeView(ModuleName.ENTER)
						end);
					end);
				else
					ViewUtil.openView(ModuleName.MAIN, false, function()
						ViewUtil.closeView(ModuleName.ENTER)
					end);
				end
			end
		end, 0.3)
	end

	local _call =  function (sessionData)
		local mo = GetProtoTable("DefaultData", sessionData)
--        error(mo.bigNum);
		if mo.code == 0 then
			PlayerData.SetRoleTeamId(mo.bigNum)
			this.view:SetServerCache()
			Network.SendMoData(ServerID.PlayerFB, {}, _callback)

		elseif mo.code == 1 then -- 账号验证失败
			ViewUtil.showMsg("账号验证失败")

		elseif mo.code == 2 then -- 新账号
			PlayerData.SetRoleTeamId(mo.bigNum)
			ViewUtil.openView(ModuleName.SR)
		end
	end

-- 内网测试
--	"123321" "123456" "850321"
--	Network.SendMoData(ServerID.Login, {"850321", "123", "123"}, _call) -- UID+MD5+Time

	if reconnect then
		Network.DoConnect(function(state)
			local data = PlayerData.getLoginData()
			if Global.isSDKLogin then
				Network.SendMoData(ServerID.Login, {data.packageId, data.token, data.uid, data.exInfo}, _call)
			else
				Network.SendMoData(ServerID.LoginPC, {data.userId, data.key, data.timestamp}, _call) -- UID+MD5+Time
			end
		end)
	else
		Network.SendMoData(ServerID.PlayerFB, {}, _callback)
	end
end

function EnterControler.Awake()
end

function EnterControler.Start()
	-- if IsEmpty(this.data) then return end

	local uri = ""
	-- type参数 	外网 0，Android混服；1，IOS；3，小米评审
	if Global.isRelease then
		uri = tostring(string.format("http://121.10.118.50:8080/xgame/server/select?type=0", nil, nil, "ftx", "Android"))
	else
		uri = tostring(string.format("http://192.168.10.154:8080/xgame/server/select?type=0", nil, nil, "ftx", "Android"))
	end
	RequestURL(uri, function(data, args)
		local info = cjson.decode(data)
		if IsEmpty(info) then
			ViewUtil.showMsg("无服务器信息!")
			return
		end

		this.data = info
		this.view:Start(this.data)
	end)
end

function EnterControler.Update()
end

function EnterControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function EnterControler.initListener()
end

function EnterControler.listNotificationInterests()
    local list = {}
    return unpack(list)
end

function EnterControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function EnterControler.accept(data)
	ViewUtil.initData(this, data)
end
