
RegisterView = class(BaseView)

 function RegisterView:ctor()
	self.shadeOpacity = true
end  

function RegisterView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
end

function RegisterView:Start(data)
	self:initData(data)
end

function RegisterView:initPanel()
-- 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
-- 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
--	self.top:SetAnchor(self.root.transform)
--	self.bottom:SetAnchor(self.root.transform)

	local bottomPath = "Mode/Top/Panel"
	
	local centerPath = "Mode/Center/Panel"
	self.btnBack = GetGameObject(self.transform, centerPath.."/BtnBack")
	self.account = GetPathComponent(self.transform, centerPath.."/InputAccount", "UIInput")
	self.pwd = GetPathComponent(self.transform, centerPath.."/InputPassword", "UIInput")
 	self.confirm = GetGameObject(self.transform, centerPath.."/BtnConfirm")
	
	local bottomPath = "Mode/Bottom/Panel"

    local function doClick(obj)
		if obj == self.btnBack then
			self:closeView(true)

		elseif obj == self.confirm then
			local account = self.account.value
			local pwd = self.pwd.value
			local uri = tostring(self:GetRegURI(account, pwd))
			RequestURL(uri, function(data, args)
				local info = cjson.decode(data)
				if IsEmptyTable(info) then
					return
				end
				local ret = tonumber(info.ret)
				local msg = tostring(info.msg)
				local userId = info.userId
				local key = info.key
				local timestamp = info.time
				if ret == 0 then
					ViewUtil.showMsg("注册成功")
					PlayerData.setLoginAccount(account, pwd)
					PlayerData.setLoginData(userId, key, timestamp)
					ViewUtil.openView(ModuleName.ENTER)
					self:GetAnnouncementInfo()
					self:GetServerInfo()
				else
					if ret == 2 then
						ViewUtil.showMsg("账号和密码分别不小于4位和6位")
					else
						ViewUtil.showMsg(msg)
					end
				end
			end)
		end
    end
	-- UIEventListener.Get(self.confirm).onClick = doClick
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	ViewUtil.AddClickEvent(self.confirm, doClick)
	ViewUtil.AddClickEvent(self.btnBack, doClick)
end

function RegisterView:GetRegURI(acount, pwd)
	if IsEmpty(acount) or IsEmpty(pwd) then
		ViewUtil.showMsg("账号或密码输入非法")
		return
	end
	local ret = nil
	if Global.isRelease then
		ret = string.format(
			"http://will.aboilgame.com/will/reg?accountName=%s&password=%s&source=%s&system=%s",
			EncodeURI(acount), EncodeURI(pwd), "ftx", "Android")
	else
		ret = string.format(
			"http://192.168.10.177/reg_xgame.php?accountName=%s&password=%s&source=%s&system=%s",
			EncodeURI(acount), EncodeURI(pwd), "ftx", "Android")
	end
	return ret
end

function RegisterView:initData(data)
	if IsEmpty(data) then return end
end

--获取Enter界面需要选服的服务器信息 by iorinie
function RegisterView:GetServerInfo()
	local uri = ""
	if Global.isRelease then
		uri = tostring(string.format("http://121.10.118.50:8080/xgame/server/select?type=0", nil, nil, "ftx", "Android"))
	else
		uri = tostring(string.format("http://192.168.10.154:8080/xgame/server/select?type=0", nil, nil, "ftx", "Android"))
	end
	RequestURL(uri, function(data, args)
	local info = cjson.decode(data)
	if IsEmpty(info) then
		ViewUtil.showMsg("无服务器信息!")
		return
	end

	local ctrl = ModuleManager.GetCtrl(ModuleName.ENTER)
	ctrl.data = info
	ctrl.Start()
	end)
end

--获取全服公告信息 by iorinie
function RegisterView:GetAnnouncementInfo()
	local uri = ""
	if Global.isRelease then
		uri = tostring(string.format("http://121.10.118.50:8080/xgame/server/tips?type=0", nil, nil, "ftx", "Android"))
	else
		uri = tostring(string.format("http://192.168.10.154:8080/xgame/server/tips?type=0", nil, nil, "ftx", "Android"))
	end
	RequestURL(uri, function(data, args)
	local info = cjson.decode(data)
	if IsEmpty(info) then
		ViewUtil.showMsg("无全服公告!")
		return
	end
	local ctrl = ModuleManager.GetCtrl(ModuleName.ENTER)
	ctrl.view:ShowAnnouncement(info)
	end)
end