
SelectRoleView = class(BaseView)

 function SelectRoleView:ctor()
end  

function SelectRoleView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self:initPanel()
end

function SelectRoleView:Start(data)
	self:initData(data)
end

function SelectRoleView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)

	local centerPath = "Mode/Center/Panel"
 	self.leftArrows = GetGameObject(self.transform, centerPath.."/SrcollBG/LeftArrows")
 	self.rightArrows = GetGameObject(self.transform, centerPath.."/SrcollBG/RightArrows")
	self.roleIconSpr = GetPathComponent(self.transform, centerPath.."/SrcollBG/RoleIcon", "UISprite")
	self.roleKind = GetPathComponent(self.transform, centerPath.."/SrcollBG/RoleKind", "UISprite")
	
	local bottomPath = "Mode/Bottom/Panel"
 	self.startConquer = GetGameObject(self.transform, bottomPath.."/StartConquer")
	self.roleName = GetPathComponent(self.transform, bottomPath.."/SelectArea/RoleName", "UIInput")
	self.random = GetGameObject(self.transform, bottomPath.."/SelectArea/Random")
	self:randomName()

	self.sex = 1
	self.roleIconSpr.spriteName = "nanzhujue"

	self.blockWords = WordData.GetBlockNames(true)
	
    local function doClick(obj)
		if obj == self.leftArrows then
			self.sex = 1
			self.roleIconSpr.spriteName = "nanzhujue"
			self.roleKind.spriteName = "w_male"

		elseif obj == self.rightArrows then
			self.sex = 0
			self.roleIconSpr.spriteName = "nvzhujue"
			self.roleKind.spriteName = "w_female"

		elseif obj == self.startConquer then
			local _call =  function (sessionData)
				local mo = GetProtoTable("DefaultData", sessionData)
				if mo.code == 0 then
--					Util.EnableButton(obj, ButtonState.Disabled, false)
--					ViewUtil.showMsg("角色创建成功")
					PlayerData.setSex(self.sex)
					EnterControler.Login()
					self:closeView()
				else
					ViewUtil.showMsg("角色名已存在，请重新输入")
				end
			end
			
			local name = Trim(self.roleName.value)
			if IsEmpty(name) then
				ViewUtil.showMsg("角色名输入有误")
			else
				local name = Trim(self.roleName.value)
				for i = 1, #self.blockWords do
					local idx = Util.FindWord(name, self.blockWords[i])
					if idx ~= -1 then
						ViewUtil.showMsg("角色名输入非法 "..tostring(self.blockWords[i]))
						return
					end
				end
				Network.SendMoData(ServerID.CreateRole, {name, self.sex}, _call)
			end

		elseif obj == self.random then
			self:randomName()
		end
    end
	-- UIEventListener.Get(self.leftArrows).onClick = doClick
	-- UIEventListener.Get(self.rightArrows).onClick = doClick
	-- UIEventListener.Get(self.startConquer).onClick = doClick
	-- UIEventListener.Get(self.random).onClick = doClick
	ViewUtil.AddClickEvent(self.leftArrows, doClick)
	ViewUtil.AddClickEvent(self.rightArrows, doClick)
	ViewUtil.AddClickEvent(self.startConquer, doClick)
	ViewUtil.AddClickEvent(self.random, doClick)
end

function SelectRoleView:randomName()
	local names = Config.getNameData()
	local length = CountTable(names)
	local group = {}
	
	local index = math.random(1, length)
	local group = names[tostring(index)]
	if not IsEmpty(group) then
		local _sex = 1
		if self.sex == 0 then _sex = 2 end
		self.roleName.value = group["family"] .. group["name"][_sex]
	end
end

function SelectRoleView:initData(data)
	if IsEmpty(data) then return end
end
