--抽卡功能
--2016-10-23 14:45:02 library

local const_dailyDesc = "今日已招募次数：";
local const_pumpCostWord = "消耗";
local const_pumpGold = "金币：";
local const_pumpDiamond = "钻石：";
local const_lackOfGold = "金币不足";
local const_lackOfDiamond = "钻石不足";
local const_heroBackSpritePre = "class";
local const_QuaAnmtVal = 5;

local const_cfmWords = "抽{1}次将会消耗{2}{3}";
local const_cfgOne = "一";
local const_cfgTen = "十";
local const_maxHeroNum = "目前可拥有的英雄数量最多为 {1} 个";
local const_dailyCnt = "今日第 {1} 次金币招募，";

local const_sltgoMoveTime = 0.05;
local const_heroGOMoveTime = 0.16;
local const_cardRotateTime = 0.08;
local const_boxParticleSystemPlaytime = 2;
local const_stopAnmtTime = 5;

LuckyBoxPick = class();

--[[

]]
function LuckyBoxPick:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.tp = 0;--显示类型 1，金币；2，钻石
end

--[[

]]
function LuckyBoxPick:Awake (_go, _tp)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    self.tp = _tp;

    self.ctl = ModuleManager.GetCtrl(ModuleName.LUCK);
    self.pickupBtns = List.new();--抽卡按钮List
    self.costLabel = nil;
    self.costNum = nil;
    self.showIdx = 0;--self.heros中的索引
    self.fullScreenPane = nil;--全屏遮挡面板
    self.herosContainer = nil;--英雄容器
    self.herosGOList = List.new();--在浮层显示的英雄GO表
    self.oneCost = nil;
    self.tenCost = nil;
    self.closeBox = nil;
    self.openBox = nil;

    self.shouldPlaying = false;--是否应该播放宝箱动画
    self.isDataBack = false;--抽卡是否回包
    self.isOutOfDate = false;--是否超过通信时间（5秒--const_stopAnmtTime）
    self.boxAnmt = nil;--宝箱动画

    self:initPanel();
end

--[[

]]
function LuckyBoxPick:initPanel ()
    local hero, heroCvtBtn, tmpTabs, pickupBtn = nil, nil, nil, nil;
    local costMny = 0;

    pickupBtn = GetGameObject(self.transform, "oneBtn");
    self.pickupBtns:add(pickupBtn);
    pickupBtn = GetGameObject(self.transform, "tenBtn");
    self.pickupBtns:add(pickupBtn);

    self.oneCost = GetGameObject(self.transform, "oneCost");
    self.tenCost = GetGameObject(self.transform, "tenCost");
    self.closeBox = GetGameObject(self.transform, "closeBox");
    self.openBox = GetGameObject(self.transform, "openBox");
    
    costMny = GameCfgDataProxy.getLuckyPickupCostByType(self.tp);
    GetComponent(self.oneCost, "UILabel").text = costMny .. "";
    GetComponent(self.tenCost, "UILabel").text = 10 * costMny .. "";
    
    if (1 == self.tp) then
        self.dailyNum = GetGameObject(self.transform, "dailyNum");
        self.dailyNum:SetActive(true);
        GetPathComponent(self.dailyNum.transform, "Label", "UILabel").text = const_dailyDesc;
        self.tenCost:SetActive(false);
        self.pickupBtns[2]:SetActive(false);
        self.pickupBtns[1].transform.localPosition = Vector3.New(0, self.pickupBtns[1].transform.localPosition.y, 0);
        self.oneCost.transform.localPosition = Vector3.New(-11, self.tenCost.transform.localPosition.y, 0);
        self:setGoldPickMny();
    end
end

--[[

]]
function LuckyBoxPick:setGoldPickMny ()
    if (1 == self.tp) then
        local mny = self:getGoldPickMny();
        if (mny < 10000) then
            GetComponent(self.oneCost, "UILabel").text = mny .. "";
        else
            GetComponent(self.oneCost, "UILabel").text = LogicUtil.getShowNum(mny) .. "";
        end
        GetComponent(self.dailyNum, "UILabel").text = "" .. (self.ctl.view.data.dayCount);
    end
end

--[[

]]
function LuckyBoxPick:getGoldPickMny ()
    local gold = 0;

    gold = GameCfgDataProxy.getLuckyPickupCostByType(self.tp) * math.pow(2, self.ctl.view.data.dayCount);

    return gold;
end

--[[

]]
function LuckyBoxPick:showPanel ()
    self:showBox(0);
    self:initListener();
end

--[[

]]
function LuckyBoxPick:initListener ()
    local pickupBtn = nil;

    for i = 1, self.pickupBtns:getSize() do
        pickupBtn = self.pickupBtns[i];
        -- UIEventListener.Get(pickupBtn).onClick = function () self:pumpCard(i); end;
        ViewUtil.AddClickEvent(pickupBtn, function () self:pumpCard(i); end)
    end
end

--[[
    抽卡
    _idx number 1，抽一次；2，抽10次
    return nil
]]
function LuckyBoxPick:pumpCard (_idx)
    local myMny, pId, costNum = 0, 0, 0;
    local errMsg = "";
    local myHerosNum = 0;
    
    myHerosNum = #TeamData.getMyHeros();

    if (1 == _idx and myHerosNum >= GameCfgDataProxy.getMaxHeroNumPerTeam() or 
        2 == _idx and myHerosNum > GameCfgDataProxy.getMaxHeroNumPerTeam() - 10
    ) then
        ViewUtil.showMsg(string.gsub(const_maxHeroNum, "{1}", GameCfgDataProxy.getMaxHeroNumPerTeam()));
        return ;
    end

    _idx = _idx or 1;

    if (1 == self.tp) then
        myMny = PlayerData.getMyGold();
    elseif (2 == self.tp) then
        myMny = PlayerData.getMyDiamond();
    end

    costNum = GameCfgDataProxy.getLuckyPickupCostByType(self.tp) * ((2 == _idx) and 10 or 1);
    if (1 == self.tp and 1 == _idx) then
        costNum = self:getGoldPickMny();
    end
    if (myMny < costNum) then
        if (1 == self.tp) then
            errMsg = const_lackOfGold;
        elseif (2 == self.tp) then
            errMsg = const_lackOfDiamond;
        end
        ViewUtil.showMsg(errMsg);
        return ;
    end
    
    local function okFunc ()
        local sendMsg = Map.new();
	    local buffer = nil;
    
        self.ctl = ModuleManager.GetCtrl(ModuleName.LUCK);
        self.ctl.animating = true;
	    sendMsg:put("type", self.tp + (_idx - 1) * 2);--1，金币；2，钻石；3，金币十连抽；4，钻石十连抽
        buffer = Network.reqParamEncode(sendMsg);
        if (1 == self.tp and 1 == _idx) then
            self.ctl.view.data.dayCount = self.ctl.view.data.dayCount + 1;
            self:setGoldPickMny();
        end
        NetManager:SendData(self, buffer, ServerID.Lucky_MnyConvert, nil, function (sd) self:pumpCallBack(sd); end, "", doNthFunc);
        --禁用游戏事件
        ViewUtil.gameEventEnabled(false);
        self:playerBoxPickAnmt();
        SimpleAudio.PlayEffect("lucky")
        self.isDataBack = false;
        LuaCallManager:invokeCall(function () 
            if (not self.isDataBack) then
                self.isOutOfDate = true;
                ViewUtil.gameEventEnabled(true);
                if (self.boxAnmt) then
                    self:cleanBoxPickAnmt();
                    self:showBox(0);
                end
            end
        end, const_stopAnmtTime);
        
        if (PlayerData.guideNotEnd()) then
            Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
        end
    end

    cfmWords = string.gsub(const_cfmWords, "{1}", ((2 == _idx) and const_cfgTen or const_cfgOne));
    cfmWords = string.gsub(cfmWords,"{2}", ((1 == self.tp) and const_pumpGold or const_pumpDiamond));
    cfmWords = string.gsub(cfmWords,"{3}", costNum);
    if (1 == self.tp) then
        cfmWords = string.gsub(const_dailyCnt, "{1}", self.ctl.view.data.dayCount + 1) .. cfmWords;
    end
    ViewUtil.comCfmPanel(cfmWords, okFunc);

    if (PlayerData.guideNotEnd()) then
        Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
    end
end

--[[

]]
function LuckyBoxPick:playerBoxPickAnmt ()
    self:cleanBoxPickAnmt();
    self:showBox(2);

    self.boxAnmt = CreateObject(Util.LoadPrefab("Effects/Common/chouBaoXiang", AssetBundleInfo.assetBundles));
    HangObject(self.boxAnmt, ViewUtil.getRootView());
    ViewUtil.sortLayerOrder(self.boxAnmt, LayerName.Top);
    self.shouldPlaying = true;
    LuaCallManager:invokeCall(function () 
        if (self.isDataBack) then
            self:cleanBoxPickAnmt();
            self:showBox(1);
            self:showPlayerAnimation();
        else
            self.shouldPlaying = false;
        end
    end, const_boxParticleSystemPlaytime);
end

--[[

]]
function LuckyBoxPick:cleanBoxPickAnmt ()
    if (nil ~= self.boxAnmt) then
        DestroyObject(self.boxAnmt);
        self.boxAnmt = nil;
        self.shouldPlaying = false;
    end
end

--[[
    抽卡回调
    _sd session
]]
function LuckyBoxPick:pumpCallBack (_sd)
    local defData = nil;
    
    defData = GetProtoTable("DefaultData", _sd);
    
    self.heros = LogicUtil.splitStrCfgs(defData.msg);
    self:delBadElems();
    self.showIdx = 1;
    self.isDataBack = true;

    if (self.isOutOfDate) then
        --超时，不处理
        self.isOutOfDate = false;
        return ;
    end

    if (not self.shouldPlaying) then
        self:cleanBoxPickAnmt();
        self:showBox(1);
        self:showPlayerAnimation();
    end
end

--[[
    播放显示英雄动画
]]
function LuckyBoxPick:showPlayerAnimation ()
    local hId, hCfg = nil, nil;
    local tmpHeroGO = nil;
    local endPos, beginPos = nil, Vector3.New(300, 600, 0);
    
    if (1 == self.showIdx) then
        self.fullScreenPane = ViewUtil.showScreenMask();
        ViewManager.SortDepth(self.fullScreenPane);
        self.herosContainer = CreateObject(Util.LoadPrefab("UI/PaneContainer", AssetBundleInfo.assetBundles));
        HangObject(self.herosContainer, ViewUtil.getRootView());
        ViewManager.SortDepth(self.herosContainer);
        self:addAllPickedHeros();
    end

    tmpHeroGO = self.herosGOList[self.showIdx];
    tmpHeroGO:SetActive(true);
    endPos = tmpHeroGO.transform.localPosition;
    tmpHeroGO.transform.localPosition = beginPos;
    iTween.MoveTo(tmpHeroGO, iTween.Hash(
        "position", endPos,
        "islocal", true,
        "time", const_heroGOMoveTime,
        "easeType", iTween.EaseType.easeOutQuad,
        "oncomplete", function (_tmpHeroGO) 
            self:addNewHeroMark(self.showIdx);
            self.showIdx = self.showIdx + 1;
            if (self.heros and self.showIdx <= #self.heros) then
                self:showPlayerAnimation();
            else
                ViewUtil.gameEventEnabled(true);
                self.herosGOList:clear();
                ViewUtil.AddClickEvent(self.fullScreenPane, function () 
                    local ctl = ModuleManager.GetCtrl(ModuleName.LUCK);
                    DestroyObject(self.fullScreenPane);
                    DestroyObject(self.herosContainer);
                    HeroDataProxy.newHeroList:clear();
                    ctl.animating = false;
                    self:showBox(0);
--                    if (PlayerData.guideNotEnd()) then
--                        Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
--                    end
                end)
            end
        end
    ));
end

--[[
    清除self.heros中的无效英雄ID
]]
function LuckyBoxPick:delBadElems ()
    local hId, hCfg = nil, nil;
    
    if (nil == self.heros or #self.heros < 1) then
        return ;
    end
    
    for i = #self.heros, 1, -1 do
        hId = self.heros[i][1];
        hCfg = HeroDataProxy.getHeroCfgById(hId);
        
        if (nil == hCfg) then
            table.remove(self.heros, i);
        end
    end
end

--[[

]]
function LuckyBoxPick:addAllPickedHeros ()
    local hId, hCfg, hero = nil, nil, nil;
    local grid = nil;
    
    self.herosGOList:clear();
    grid = GetGameObject(self.herosContainer.transform, "Grid");

    if (nil == self.heros) then
        return ;
    end
    
    for i = 1, #self.heros do
        hCfg = HeroDataProxy.getHeroCfgById(self.heros[i][1]);
        hero = self:getHeroGO(hCfg);
        self.herosGOList:add(hero);
    end
    
    ResetGrid(grid);
    
    for i = 1, self.herosGOList.size do
        self.herosGOList[i]:SetActive(false);
    end
end

--[[
    取英雄图片GO
]]
function LuckyBoxPick:getHeroGO (_hCfg)
    local hero = nil;
    local grid = nil;
    
    grid = GetGameObject(self.herosContainer.transform, "Grid");
    hCfg = _hCfg;
    baseHero = BaseHero.new();
    baseHero:setData(hCfg);
    hero = baseHero:createHero("UI/Hero");
    HangObject(hero, grid);
    ViewUtil.AddClickEvent(hero, function () 
        local ctl = ModuleManager.GetCtrl(ModuleName.LUCK);
        DestroyObject(self.fullScreenPane);
        DestroyObject(self.herosContainer);
        HeroDataProxy.newHeroList:clear();
        ctl.animating = false;
        self:showBox(0);
        if (PlayerData.guideNotEnd()) then
            Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
        end
    end)
    return hero;
end

--[[
    添加新英雄标志
    _idx number
]]
function LuckyBoxPick:addNewHeroMark (_idx)
    local hero, heroId = nil, nil;
    local newObj = nil;
    
    hero = self.herosGOList[_idx];
    heroId = self.heros[_idx][1];
    
    if (not self:isEverGet(heroId)) then
        newObj = CreateObject(Util.LoadPrefab("UI/ui_zhaomu05", AssetBundleInfo.assetBundles));
        HangObject(newObj, hero);
        ViewUtil.sortLayerOrder(hero, LayerName.Top);
    end;
end

--[[

]]
function LuckyBoxPick:isEverGet (_heroId)
    local isGot = true;

    for i = 1, #self.heros do
        if (tonumber(self.heros[i][1]) == tonumber(_heroId) and 1 == tonumber(self.heros[i][2])) then
            isGot = false;
            break ;
        end
    end

    return isGot;
end

--[[
    _idx number
]]
function LuckyBoxPick:showBox (_idx)
    if (0 == _idx) then
        self.openBox:SetActive(false);
        self.closeBox:SetActive(true);
    elseif (1 == _idx) then
        self.openBox:SetActive(true);
        self.closeBox:SetActive(false);
    else 
        self.openBox:SetActive(false);
        self.closeBox:SetActive(false);
    end
end