--兑换英雄 英雄可见 可自行选择兑换 消耗时空碎片
--2016-6-27 10:50:09 library

local const_pieceId = 1061;--时空碎片ID

local const_pumpWord = "招 募";
local const_heroBackSpritePre = "class";
local const_cvtPiece = "我的时空碎片：";
local const_lackOfPiece = "时空碎片不足{1}，招募失败";
local const_convertCfmWord = "招募 {1} 需要消耗 {2} 时空碎片，确认招募吗？";
local const_maxHeroNum = "目前可拥有的英雄数量最多为 {1} 个";

LuckyConvertHero = class();

function LuckyConvertHero:ctor ()
    self.gameObject = nil;
    self.transform = nil;
end

function LuckyConvertHero:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self.heroTabs = List.new();--英雄GO列表

    self.costLabel = nil;
    self.costNum = nil;

    self.heroData = nil;
    self.oriHeroIdTab = nil;

    self:initPanel();
end

--[[
    return nil
]]
function LuckyConvertHero:initPanel ()
    local hero, heroCvtBtn, heroName, heroGot, heroCost, tmpTabs = nil, nil, nil, nil, nil, nil;
    local ctl = nil;
    
    for i = 1, 9 do
        hero = GetGameObject(self.transform, "Hero_" .. (i - 1));
        heroCvtBtn = GetGameObject(self.transform, "heroGet_" .. (i - 1));
        heroName = GetGameObject(self.transform, "heroName_" .. (i - 1));
        heroGot = GetGameObject(self.transform, "heroGot_" .. (i - 1));
        heroCost = GetGameObject(self.transform, "heroCost_" .. (i - 1));
        tmpTabs = {hero, heroCvtBtn, heroName, heroGot, heroCost};
        self.heroTabs:add(tmpTabs);

        GetPathComponent(heroCvtBtn.transform, "word", "UILabel").text = const_pumpWord;
    end

    ctl = ModuleManager.GetCtrl(ModuleName.LUCK);
    self.costLabel = ctl.view.costLabel;
    self.costNum = ctl.view.costNum;

    GetComponent(self.costLabel, "UILabel").text = const_cvtPiece;
    GetComponent(self.costNum, "UILabel").text = PropDataProxy.getPropNumByPropId(const_pieceId);
end

--[[
    _data 英雄数据
    return nil
]]
function LuckyConvertHero:setHeroData (_data)
    self.heroData = _data;

    self:initOriHeroIdTab();
    self:sortHeroData();
    self:showHero();
end

--[[
    初始化原始英雄ID表
]]
function LuckyConvertHero:initOriHeroIdTab ()
    local aeData = nil;--AltarExchangeData

    self.oriHeroIdTab = {};
    for i = 1, #self.heroData.heroList do
        aeData = self.heroData.heroList[i];
        table.insert(self.oriHeroIdTab, aeData.heroId);
    end
end

--[[
    对self.heroData排序，高品质的排在前面
    return nil
]]
function LuckyConvertHero:sortHeroData ()
    local perDataFir, perDataSec, hCfgFir, hCfgSec, hQuaFir, hQuaSec = nil, nil, nil, nil, 1, 1;

    for i = 1, #self.heroData.heroList do
        perDataFir = self.heroData.heroList[i];
        hCfgFir = HeroDataProxy.getHeroCfgById(perDataFir.heroId);
        hQuaFir = HeroDataProxy.getHeroQuality(hCfgFir);
        for j = i + 1, #self.heroData.heroList do
            perDataSec = self.heroData.heroList[j];
            hCfgSec = HeroDataProxy.getHeroCfgById(perDataSec.heroId);
            hQuaSec = HeroDataProxy.getHeroQuality(hCfgSec);
            if (hQuaFir < hQuaSec) then
                --交换位置
                self.heroData.heroList[i] = perDataSec;
                self.heroData.heroList[j] = perDataFir;
                perDataFir = self.heroData.heroList[i];
                hCfgFir = HeroDataProxy.getHeroCfgById(perDataFir.heroId);
                hQuaFir = HeroDataProxy.getHeroQuality(hCfgFir);
            end
        end
    end
end

--[[
    return nil
]]
function LuckyConvertHero:showHero ()
    local hero, heroBtn, heroName, heroGot, heroCost = nil, nil, nil, nil, nil;
    local heroPos = nil;
    local perHData, hCfgData = nil, nil;
    local heroMask, heroMaskSprite = nil, nil;

    for i = 1, self.heroTabs:getSize() do
        hero = self.heroTabs[i][1];
        heroBtn = self.heroTabs[i][2];
        heroName = self.heroTabs[i][3];
        heroGot = self.heroTabs[i][4];
        heroCost = self.heroTabs[i][5];

        perHData = self:getHeroByIdx(i);

        if (nil ~= perHData) then
            hCfgData = HeroDataProxy.getHeroCfgById(perHData.heroId);
            GetPathComponent(hero.transform, "BG", "UISprite").spriteName = const_heroBackSpritePre .. HeroDataProxy.getHeroQuality(hCfgData);
            GetPathComponent(hero.transform, "Sprite", "UISprite").spriteName = HeroDataProxy.getHeroAtlasName(hCfgData);
            GetComponent(hero, "UIButton").normalSprite = const_heroBackSpritePre .. HeroDataProxy.getHeroQuality(hCfgData);
            GetComponent(heroName, "UILabel").text = HeroDataProxy.getHeroName(hCfgData);
            GetComponent(heroCost, "UILabel").text = self:getCostNumById(perHData.heroId);
            
            if (1 == perHData.status) then
                heroGot:SetActive(true);
                heroBtn:SetActive(false);
            else
                heroGot:SetActive(false);
                heroBtn:SetActive(true);
            end

            -- UIEventListener.Get(hero).onClick = function () self:showHeroDetail(i); end;
            -- UIEventListener.Get(heroBtn).onClick = function () self:convertHero(i); end;
            ViewUtil.AddClickEvent(hero, function () self:showHeroDetail(i); end)
            ViewUtil.AddClickEvent(heroBtn, function () self:convertHero(i); end)
        end
    end
end

--[[
    取self.heroData中指定位置的英雄数据
    _idx number
    return AltarExchangeData
]]
function LuckyConvertHero:getHeroByIdx (_idx)
    local tmpData = nil;
    
    tmpData = self.heroData.heroList[_idx];
    return tmpData;
end

--[[
    _idx number
    return nil
]]
function LuckyConvertHero:convertHero (_idx)
    local pNum, costNum = 0, 0;
    local errMsg = "";
    local tmpHero, heroData, heroCfg, heroBtn = nil, nil, nil, nil;
    local realIdx = 1;--未经排序的可招募英雄的顺序
    local cfmWords = "";
    local myHerosNum = 0;

    myHerosNum = #TeamData.getMyHeros();

    if (myHerosNum >= GameCfgDataProxy.getMaxHeroNumPerTeam()) then
        ViewUtil.showMsg(string.gsub(const_maxHeroNum, "{1}", GameCfgDataProxy.getMaxHeroNumPerTeam()));
        return ;
    end

    _idx = _idx or 1;

    pNum = PropDataProxy.getPropNumByPropId(const_pieceId);
    heroData = self:getHeroByIdx(_idx);
    heroCfg = HeroDataProxy.getHeroCfgById(heroData.heroId);
    costNum = self:getCostNumById(heroData.heroId);
    realIdx = self:getHeroRealIdx(heroData.heroId);
    
    if (1 == heroData.status) then
        --已招募
        return ;
    end

    if (pNum < costNum) then
        errMsg = string.gsub(const_lackOfPiece, "{1}", costNum);
        ViewUtil.showMsg(errMsg);
        return ;
    end
    local function callPropConvert()
        local sendMsg = Map.new();
	    sendMsg:put("index", realIdx - 1);
	    local buffer = Network.reqParamEncode(sendMsg);
        NetManager:SendData(self, buffer, ServerID.Lucky_PropConvert, nil, function (sd) self:propConvertHandle(sd, _idx); end, "", doNthFunc);
    end
    cfmWords = string.gsub(const_convertCfmWord,"{1}", HeroDataProxy.getHeroName(heroCfg));
    cfmWords = string.gsub(cfmWords,"{2}", costNum);
    ViewUtil.comCfmPanel(cfmWords, callPropConvert);
end

--[[
    兑换英雄的回调函数
    sd SessionData
    _idx 兑换的英雄的索引
    return nil
]]
function LuckyConvertHero:propConvertHandle (sd, _idx)
    local tmpHero, hero, heroBtn, heroGot = nil, nil, nil, nil;
    local defData, hData = nil, nil;
    
    defData = GetProtoTable("DefaultData", sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end

    tmpHero = CreateObject(self.heroTabs[_idx][1]);
    HangObject(tmpHero, ViewUtil.getRootView());
    tmpHero.transform.position = self.heroTabs[_idx][1].transform.position;
    AnmtUtil.moveToPackage(tmpHero, AnmtUtil.getPackagePos());
    hero = self.heroTabs[_idx][1];
    heroBtn = self.heroTabs[_idx][2];
    heroGot = self.heroTabs[_idx][4];
    hData = self:getHeroByIdx(_idx);
    hData.status = 1;
    heroGot:SetActive(true);
    heroBtn:SetActive(false);

    GetComponent(self.costNum, "UILabel").text = PropDataProxy.getPropNumByPropId(const_pieceId);
end

--[[
    _idx number
    return nil
]]
function LuckyConvertHero:showHeroDetail (_idx)
    local tmpId = nil;
    local tmpData = nil;
    
    tmpData = self.heroData.heroList[_idx];
    tmpId = tmpData.heroId;
    ModuleManager.GetCtrl(ModuleName.HP).data = HeroDataProxy.getHeroCfgById(tmpId);
    ViewUtil.openView(ModuleName.HP, true);
end

--[[
    根据heroId取原始的顺序
    _heroId number 英雄的原始ID
    return number 原始顺序
]]
function LuckyConvertHero:getHeroRealIdx (_heroId)
    local realIdx = 1;

    for i = 1, #self.oriHeroIdTab do
        if (_heroId == self.oriHeroIdTab[i]) then
            realIdx = i;
            break ;
        end
    end
    
    return realIdx;
end

--[[

]]
function LuckyConvertHero:OnDestroy ()
    
end

function LuckyConvertHero:getCostNumById (_heroId)
    local costNum = 0;

    for i = 1, #self.heroData.heroList do
        if (_heroId == self.heroData.heroList[i].heroId) then
            costNum = self.heroData.heroList[i].count;
            break ;
        end
    end

    return costNum;
end