--召唤模块
--2016-10-12 16:45:34 library

local const_refreshWord = "冷却时间：";
local const_moduleTitle = "召 唤";

LuckyView = class(BaseView)

function LuckyView:ctor()
    self.ctl = nil;
end

function LuckyView:Awake(obj, _ctl)
	self.gameObject = obj
	self.transform = self.gameObject.transform
    self.ctl = _ctl;

    self.isCanCall = true;
    
    self.data = nil;
    self.curType = 1;--当前显示的类型。0，招募；1，金币；2，钻石；3，活动
    self.luckyBtnsTab = {};--切换标签表
    self.baseColor = CreateColor(255, 255, 255, 255);
    self.choseColor = CreateColor(225, 200, 150, 255);
    self.curBar = nil;
    self.openTime = 0;--打开View时的Unity运行时间(Time.time)
    self.convertHeroPanel = nil;
    self.goldPanel = nil;
    self.diamondPanel = nil;
    self.panelTabs = {};
    self.costLabel = nil;
    self.costNum = nil;
    self.timeLabel = nil;
    self.timeNum = nil;
    self.title = nil;--模块标题

	self:initPanel();

    if AudioConst.GetBgmName() ~= "main" then
        SimpleAudio.StopMusic(doNthFunc)
        SimpleAudio.PlayMusic("main")
        AudioConst.SetBgmName("main")
    end
end

function LuckyView:Start()
	
end

--[[
    
]]
function LuckyView:Update ()
    local remainTime = 0;

    if (nil == self.data) then
        return ;
    end
    
    remainTime = self.ctl.getRemainTime() + 500;
    
    if (1000 >= remainTime and self.isCanCall) then
        self.isCanCall = false;
        self.ctl.request(1);
    end
    
    if (0 == self.curType) then
        GetComponent(self.timeNum.transform, "UILabel").text = LogicUtil.getCountTimeStr(remainTime);
    end
end

function LuckyView:initPanel()
	local topPath = "Mode/Top/Panel";
    
    self.title = GetGameObject(self.transform, topPath .. "/ModuleTitle/Title");
    self.cvtTab = GetGameObject(self.transform, topPath .. "/sltTab/cvtTab");
    self.goldTab = GetGameObject(self.transform, topPath .. "/sltTab/goldTab");
    self.diamondTab = GetGameObject(self.transform, topPath .. "/sltTab/diamondTab");
    
    self.convertHeroPanel = GetGameObject(self.transform, topPath .. "/convertHeroPanel");
    self.goldPanel = GetGameObject(self.transform, topPath .. "/goldPanel");
    self.diamondPanel = GetGameObject(self.transform, topPath .. "/diamondPanel");

    self.costLabel = GetGameObject(self.transform, topPath .. "/costLabel");
    self.costNum = GetGameObject(self.transform, topPath .. "/costNum");
    self.timeLabel = GetGameObject(self.transform, topPath .. "/timeLabel");
    self.timeNum = GetGameObject(self.transform, topPath .. "/timeNum");
    
    GetComponent(self.timeLabel, "UILabel").text = const_refreshWord;
    GetComponent(self.timeNum, "UILabel").text = "--";
    GetComponent(self.title, "UILabel").text = const_moduleTitle;

    table.insert(self.luckyBtnsTab, self.cvtTab);
    table.insert(self.luckyBtnsTab, self.goldTab);
    table.insert(self.luckyBtnsTab, self.diamondTab);

    table.insert(self.panelTabs, self.convertHeroPanel);
    table.insert(self.panelTabs, self.goldPanel);
    table.insert(self.panelTabs, self.diamondPanel);

    self:luckyBtns();
end

--[[
    设置倒计时是否显示
    _isActive boolean true，限时；false，不显示
]]
function LuckyView:setTimeInfoActive (_isActive)
    _isActive = _isActive or false;

    self.costLabel:SetActive(_isActive);
    self.costNum:SetActive(_isActive);
    self.timeLabel:SetActive(_isActive);
    self.timeNum:SetActive(_isActive);
end

function LuckyView:initData(_data)
    self.data = _data;
    self.openTime = Time.time;

    self:setBtns(self.curType + 1);
    self:setPanels(self.curType + 1);
    self:showHeroPane(self.curType); 
end

--[[

]]
function LuckyView:updateHeroDatas (_data)
    self.data = _data;
    self.openTime = Time.time;
    
    if (0 == self.curType) then
        self:showHeroPane(self.curType);
    end
end

--[[
    添加选择按钮
    return nil
]]
function LuckyView:luckyBtns ()
    local tmpBar = nil;

    for i = 1, #self.luckyBtnsTab do
		tmpBar = self.luckyBtnsTab[i];
        tmpBar.transform.localScale = Vector3.New(0.8, 0.8, 1);

        -- UIEventListener.Get(tmpBar).onClick = function () 
        --     self:setBtns(i);
        --     self:setPanels(i);
        --     self:showHeroPane(i - 1); 
        -- end;
        ViewUtil.AddClickEvent(tmpBar, function () 
            self:setBtns(i);
            self:setPanels(i);
            self:showHeroPane(i - 1); 

            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
        end)
    end
end

--[[
    设置切换标签的显示
    _idx number 切换标签的索引
]]
function LuckyView:setBtns (_idx)
    local tmpBar = nil;

    for i = 1, #self.luckyBtnsTab do
		tmpBar = self.luckyBtnsTab[i];
        
        if (i == _idx) then
            tmpBar.transform.localScale = Vector3.New(1.2, 1.2, 1);
        else
            tmpBar.transform.localScale = Vector3.New(0.8, 0.8, 1);
        end
    end
end

--[[

]]
function LuckyView:setPanels (_idx)
    for i = 1, #self.panelTabs do
        if (i == _idx) then
            self.panelTabs[i]:SetActive(true);
        else
            self.panelTabs[i]:SetActive(false);
        end
    end
end

--[[
    显示英雄招募面板
    _tp 显示类型。0，祭坛招募；1，金币；2，钻石；3，活动招募
]]
function LuckyView:showHeroPane (_tp)
    local sltPanel, luaBhvr, cvtHero = nil, nil, nil;

    _tp = _tp or 0;
    self.curType = _tp;
    if (0 == _tp) then
        sltPanel = self.convertHeroPanel;
    elseif (1 == _tp) then
        sltPanel = self.goldPanel;
    else
        sltPanel = self.diamondPanel;
    end
    
    luaBhvr = GetComponent(sltPanel, "LuaBehaviour");
    if (nil ~= luaBhvr) then
        cvtHero = luaBhvr.sourceLuaObj;
    end

	if (0 == _tp) then
        if (nil == cvtHero) then
		    cvtHero = LuckyConvertHero.new();
		    cvtHero:Awake(sltPanel);
		    PanelManager:BindPanelScript(cvtHero, sltPanel, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        end
		cvtHero:setHeroData(self.data);
        self:setTimeInfoActive(true);
    elseif (1 == _tp or 2 == _tp) then
        if (nil == cvtHero) then
            cvtHero = LuckyBoxPick.new();
            cvtHero:Awake(sltPanel, _tp);
		    PanelManager:BindPanelScript(cvtHero, sltPanel, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        end
        cvtHero:showPanel();
        self:setTimeInfoActive(false);
	end
end