require "Game/Mail/View/MailView"
 
MailControler = {}

local this = MailControler
this.readedMailIds = {}

function MailControler.New()
	return this
end

function MailControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = MailView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	this.request()
end

function MailControler.Awake()
end

function MailControler.Start()
	this.readedMailIds = PlayerData.GetMailIds()
end

function MailControler.Update()
end

function MailControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function MailControler.initListener()
end

function MailControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function MailControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function MailControler.request()
	Network.SendMoData(ServerID.MailRecvList, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("MailMainData", session)
		this.accept(mo)
	end, {})
end

function MailControler.accept(data)
	ViewUtil.initData(this, data)
end
