
local const_getRwdSuccess = "领取成功";
local const_getRwdFail = "当前邮件没有奖励可领";

MailView = class(BaseView)

function MailView:ctor()
end  

function MailView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.deltaPos = Vector3.New(10000, 0, 0)
	self.receivers = {}
    self.allMails = List.new();
    self.allProps = List.new();
	self.senderId = nil
	self.senderName = nil
	self.herosConf = Config.getHerosData()
	self:initPanel()
end

function MailView:Start(data)
end

function MailView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"
	self.tab1 = GetGameObject(self.transform, topPath.."/Tab1")
	self.tab2 = GetGameObject(self.transform, topPath.."/Tab2")
	self.tab3 = GetGameObject(self.transform, topPath.."/Tab3")
	self.tab3.transform.localPosition = self.tab3.transform.localPosition - self.deltaPos
	self.normal = true
	
	self.toggle1 = GetComponent(self.tab1.transform, "UIToggle")
	self.toggle2 = GetComponent(self.tab2.transform, "UIToggle")
	self.toggle3 = GetComponent(self.tab3.transform, "UIToggle")
	
--	self.recvMailTitle = GetPathComponent(self.transform, topPath.."/Content3-1/MailTitle", "UILabel")
	
	local centerPath = "Mode/Center/Panel"
	self.recverName = GetPathComponent(self.transform, centerPath.."/Content2/RecverName", "UILabel")
	self.btnChoose = GetGameObject(self.transform, centerPath.."/Content2/RecverName/BtnChoose")
	self.btnSend = GetGameObject(self.transform, centerPath.."/Content2/BtnSend")

	self.scvBG1 = GetGameObject(self.transform, centerPath.."/Content1/ScrollViewBG")
	self.scvBG2 = GetGameObject(self.transform, centerPath.."/Content2/ScrollViewBG")
	self.scvBG3 = GetGameObject(self.transform, centerPath.."/Content3-2/ScrollViewBG")
	self.btnGridObj = GetGameObject(self.transform, centerPath.."/Content3-2/BG/Grid")
	self.btnReply = GetGameObject(self.btnGridObj.transform, "BtnReply")
	self.btnGain = GetGameObject(self.btnGridObj.transform, "BtnGain")
	self.btnGainTitle = GetPathComponent(self.btnGain.transform, "Title", "UILabel")

	self.scvBG4 = GetGameObject(self.transform, centerPath.."/Content3-3/ScrollViewBG")
	self.scvObj4 = GetGameObject(self.scvBG4.transform, "ScrollView")
	self.grid4 = GetGameObject(self.scvObj4.transform, "Panel/Grid")

	self.scvObj1 = GetGameObject(self.scvBG1.transform, "ScrollView")
	self.scvObj2 = GetGameObject(self.scvBG2.transform, "ScrollView")
	self.scvObj3 = GetGameObject(self.scvBG3.transform, "ScrollView")

	self.grid1 = GetGameObject(self.scvObj1.transform, "Panel/Grid")
	self.grid2 = GetGameObject(self.scvObj2.transform, "Panel/Grid")
	self.grid3 = GetGameObject(self.scvObj3.transform, "Panel/Grid")
	
	self.sendObj = self.scvBG2
	self.sendInput = GetComponent(self.scvBG2.transform, "UIInput")
	self.content2 = GetPathComponent(self.grid2.transform, "InputContent", "UILabel")
	self.content3 = GetPathComponent(self.grid3.transform, "RecvContent", "UILabel")
	
	ViewUtil.adaptUISize(self.scvBG1, true, 120, 80, 16, 16)
	ViewUtil.adaptUISize(self.scvObj1, false, 140, 80, 16, 16)

	ViewUtil.adaptUISize(self.scvBG2, true, 240, 200, 60, 60)
	ViewUtil.adaptUISize(self.scvObj2, false, 260, 200, 80, 80)

	ViewUtil.adaptUISize(self.scvBG3, true, 180, 200, 36, 36)
	ViewUtil.adaptUISize(self.scvObj3, false, 180, 220, 40, 40)

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

	self.blockWords = WordData.GetBlockNames()
		
    local function onChange(params)
		local text = self.sendInput.value
		if not IsEmpty(text) then
			local content = text
			for i = 1, #self.blockWords do
				local idx = Util.FindWord(content, self.blockWords[i])
				if idx ~= -1 then
					content = Util.ReplaceWord(content, self.blockWords[i], "*")
				end
			end
			self.sendInput.value = content
		end
	end	
	Util.AddInputChangeEvent(self.sendInput, onChange, {})
	
    local function doClick(obj)
		if obj == self.btnBack then
			if self.toggle2.value then
				self.toggle1.value = true
			elseif self.toggle3.value then
				self:toggleTab()
			else
				self:closeView(true)
			end

		elseif obj == self.btnChoose then
			Network.SendMoData(ServerID.FriendMain, {}, function(session, params)
				local serviceId = tonumber(session.serviceId)
				local mo = GetProtoTable("FriendMainData", session)
				self:showFriendChoose(mo)
			end, {})

		elseif obj == self.btnSend then
			if IsEmpty(self.receivers) then
				ViewUtil.showMsg("请选择收件人")
				return
			end
			local text = self.sendInput.value
			if IsEmpty(text) then
				ViewUtil.showMsg("发送内容为空")
				return
			end

			for k, v in pairs(self.receivers) do
				Network.SendMoData(ServerID.MailSendOut, {k, text}, function(session, params)
					local serviceId = tonumber(session.serviceId)
					local mo = GetProtoTable("DefaultData", session)
					if mo.code == 0 then
						self.recverName.text = " "
						self.sendInput.value = " "
						self.receivers = {}
						ViewUtil.showMsg("发送成功")
					else
						ViewUtil.showMsg("发送失败")
					end
				end, {})
			end
        elseif (self.btnGain == obj) then
            self:getMailRwd();
		elseif obj == self.btnReply then
			self.toggle2.value = true
			Network.SendMoData(ServerID.MailReply, {self.senderId}, function(session, params) 
				local mo = GetProtoTable("DefaultData", session)
				self.senderName = tostring(mo.msg)
				self.receivers[self.senderId] = {name = self.senderName}
				self:initReceivers()
			end, {})
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnChoose).onClick = doClick
	-- UIEventListener.Get(self.btnSend).onClick = doClick
 --    UIEventListener.Get(self.btnGain).onClick = doClick
 --    UIEventListener.Get(self.btnReply).onClick = doClick
 	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnChoose, doClick)
	ViewUtil.AddClickEvent(self.btnSend, doClick)
    ViewUtil.AddClickEvent(self.btnGain, doClick)
    ViewUtil.AddClickEvent(self.btnReply, doClick)
end

function MailView:initData(data)
	if IsEmpty(data) then return end
	
    self:cleanMails();
	
    PlayerData.playerData.status.mail = false
	Facade:sendNotification(MVCConst.SHOWREDICON, {})

	local mailList = data.mailList
	if IsEmpty(mailList) then return end
    
	local function _readMail(obj)
        self:cleanProps();
		local lb = GetComponent(obj.transform, "LuaBehaviour")
		local mail = lb.sourceLuaObj
		local mailId = tonumber(mail.mailId) or 0
		local teamId = tonumber(mail.teamId) or 0
		self.senderId = teamId
		if teamId == 0 then -- 系统邮件
--            Util.EnableButton2D(self.btnReply, ButtonState.Disabled, false);
			self.btnReply:SetActive(false)
        else
--            Util.EnableButton2D(self.btnReply, ButtonState.Normal, true);
			self.btnReply:SetActive(true)
		end
        self.mailId = mailId
		local status = tonumber(mail.status) or 0
--		plog("mailId = %d, status = %d", mailId, status)
        if status == 2 then
            self.btnGainTitle.text = "已领取"
            Util.EnableButton2D(self.btnGain, ButtonState.Disabled, false);
        else
			self.btnGainTitle.text = "领取"
            Util.EnableButton2D(self.btnGain, ButtonState.Normal, true);
        end
		local amount = #mail.props
		if amount > 0 then
			self.btnGain:SetActive(true)
		else
			self.btnGain:SetActive(false)
		end
		ResetGrid(self.btnGridObj)

		self.content3.text = mail.context or " "

        for i = 1, amount do
            local data = mail.props[i]
			local propId = data.propId
			local num = data.num
			
			local item = ViewUtil.CreateDropItem(propId, num, self.grid4)
--		    local pis = PropShowItem.new();
--            pis:Awake(item, propId, num);
--            pis:Start();
--            PanelManager:BindPanelScript(pis, item, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
--		    local item = CreateObjectByPath("UI/ItemDrop")
--            HangObject(item, self.grid4)

            self.allProps:add(item);
        end
		ResetGrid(self.grid4)

		ResetGrid(self.grid3)
		ResetScrollView(self.scvObj3)

		self:toggleTab()
		if not IsMember(mailId, MailControler.readedMailIds) then
			table.insert(MailControler.readedMailIds, mailId)
			PlayerData.SetMailIds(MailControler.readedMailIds)
		end
		Network.SendMoData(ServerID.MailReading, {mailId}, function(session, params) end, {})
	end
    
	for i = #mailList, 1, -1 do
		local mail = mailList[i]
		if not IsEmpty(mail) then
			local bar = CreateObjectByPath("UI/BarMail", AssetBundleInfo.assetBundles)
			bar.name = "Mail"..i
			HangObject(bar, self.grid1)
			ViewUtil.sortLayerOrder(bar, LayerName.UI)
            self.allMails:add(bar);
			BindLuaScript(mail, bar)
			local title = GetPathComponent(bar.transform, "MailBG/Title", "UILabel")
			local teamId = tonumber(mail.teamId) or 0
			local txt = tostring(mail.title) or " "
			local status = tonumber(mail.status) or 0

			if teamId == 0 then
				title.text = "【系统】"..txt
			else
				title.text = txt
			end

			local content2 = GetPathComponent(bar.transform, "MailBG/Content", "UILabel")
			content2.text = mail.context
			local new = GetGameObject(bar.transform, "MailBG/NewTips")
			local spr = GetPathComponent(bar.transform, "MailBG/NewTips", "UISprite")
			if IsMember(mail.mailId, MailControler.readedMailIds) then
				NGUITools.SetActive(new, false)
				if status == 0 then
					NGUITools.SetActive(new, true)
					spr.spriteName = "mailExtra"
				end
			else
				NGUITools.SetActive(new, true)
				spr.spriteName = "greenBiger"
			end
			ViewUtil.AddClickEvent(bar, _readMail)
		end
	end

	ResetGrid(self.grid1)
	ResetScrollView(self.scvObj1)

	ResetGrid(self.grid2)
	ResetScrollView(self.scvObj2)
end

function MailView:cleanMails ()
    self.allMails:clear();
	DestroyChildren(self.grid1)
	-- DestroyChildren(self.grid2) --不知道为啥初始化数据时要销毁子物体 by iorinie
end

function MailView:cleanProps ()
    for i = #self.allProps, 1, -1 do
        HangObject(self.allProps[i], self.grid4.transform.parent.gameObject);
        self.allProps[i]:SetActive(false);
        DestroyObject(self.allProps[i]);
        self.allProps:removeAt(i);
    end
end

function MailView:toggleTab()
	if not self.normal then
		self.normal = true
		self.tab3.transform.localPosition = self.tab3.transform.localPosition - self.deltaPos
		self.tab1.transform.localPosition = self.tab1.transform.localPosition + self.deltaPos
		self.toggle1.value =  true
	else
		self.normal = false
		self.tab1.transform.localPosition = self.tab1.transform.localPosition - self.deltaPos
		self.tab3.transform.localPosition = self.tab3.transform.localPosition + self.deltaPos
		self.toggle3.value =  true
	end
	
	local children = ObtainChildren(self.grid1)
	for i = 1, #children do
		local bar = children[i]
		local lb = GetComponent(bar.transform, "LuaBehaviour")
		local tbl = lb.sourceLuaObj
		local new = GetGameObject(bar.transform, "MailBG/NewTips")
		if IsMember(tbl.mailId, MailControler.readedMailIds) then
			NGUITools.SetActive(new, false)
		else
			NGUITools.SetActive(new, true)
		end
	end
end

function MailView:initReceivers()
	self.recverName.text = " "
	for k, v in pairs(self.receivers) do
		if not IsEmpty(v) then
			local name = v.name or "NoName"
			if IsEmpty(self.recverName.text) then
				self.recverName.text = name
			else
				self.recverName.text = self.recverName.text .. ","..name
			end
		end
	end
end

function MailView:showFriendChoose(data)
	if IsEmpty(data) then return end

	local choose = CreateObjectByPath("UI/FriendChoose", AssetBundleInfo.assetBundles)
	choose.name = "FriendChoose"
	HangObject(ViewUtil.CreateShadeView(), choose)
	HangObject(choose, self.gameObject)
	ViewUtil.sortLayerOrder(choose, LayerName.Dialog)
	
	local centerPath = "Mode/Center/Panel"
	local scvBG = GetGameObject(choose.transform, centerPath.."/ScrollViewBG")
	local scvObj = GetGameObject(scvBG.transform, "ScrollView")
	local gridObj = GetGameObject(scvObj.transform, "Panel/Grid")
	local grid = GetPathComponent(scvObj.transform, "Panel/Grid", "UIGrid")
	ViewUtil.adaptUISize(scvBG, true, 168, 166, 0, 0)
	ViewUtil.adaptUISize(scvObj, false, 168, 166, 16, 16)

	local btnCancel = GetGameObject(choose.transform, centerPath.."/BtnCancel")
	local btnConfirm = GetGameObject(choose.transform, centerPath.."/BtnConfirm")

    local function doClick(obj)
		if obj == btnCancel then
			DestroyObject(choose)
		elseif obj == btnConfirm then
			self:initReceivers()
			DestroyObject(choose)
		end
    end
	-- UIEventListener.Get(btnCancel).onClick = doClick
	-- UIEventListener.Get(btnConfirm).onClick = doClick
	ViewUtil.AddClickEvent(btnCancel, doClick)
	ViewUtil.AddClickEvent(btnConfirm, doClick)
	
	local friends = data.friends
	if IsEmpty(friends) then
		ViewUtil.showMsg("尚未添加好友")
		return
	end
	
	local wNoSelected = "选择"
	local wSelected = "已选择"

	for i = 1, #friends do
		local info = friends[i]
		local bar = CreateObjectByPath("UI/BarFriendChoose", AssetBundleInfo.assetBundles)
		HangObject(bar, gridObj)

		local head = GetGameObject(bar.transform, "Head")
		local conf = self.herosConf[tostring(info.logo)]
		if not IsEmptyTable(conf) then
			local baseHero = BaseHero.new()
			baseHero:setData(conf)
			local item = baseHero:createHero("UI/Hero")
			HangObject(item, head)
		end

		local fightValue = GetPathComponent(bar.transform, "FightValue", "UILabel")
		fightValue.text = 0
		local friName = GetPathComponent(bar.transform, "Name", "UILabel")
		friName.text = info.friendName
--		plog("friName  = ", info.friendName)
--		plog("info.fightValue  = ", info.fightValue)
		local btnSelect = GetGameObject(bar.transform, "BtnSelect")
		BindLuaScript(info, btnSelect)
		local btnTitle = GetPathComponent(btnSelect.transform, "Title", "UILabel")
		btnTitle.text = wNoSelected
		local function _click(obj)
			local lb = GetComponent(obj, "LuaBehaviour")
			local luaObj = lb.sourceLuaObj
			local recverId = luaObj.friendTeamId
			if not IsMemberKey(recverId, self.receivers) then
				self.receivers[recverId] = {name = luaObj.friendName}
				btnTitle.text = wSelected
				Util.EnableButton(obj, ButtonState.Pressed, true)
			else
				local exist, key = IsMemberKey(recverId, self.receivers)
				if exist then self.receivers[key] = nil end
				btnTitle.text = wNoSelected
				Util.EnableButton(obj, ButtonState.Normal, true)
			end
		end
		-- UIEventListener.Get(btnSelect).onClick = _click
		ViewUtil.AddClickEvent(btnSelect, _click)

		local friendId = info.friendTeamId
		if IsMemberKey(friendId, self.receivers) then
			btnTitle.text = wSelected
			Util.EnableButton(btnSelect, ButtonState.Pressed, true)
		end
	end

	ResetGrid(gridObj)
	ResetScrollView(scvObj)
end

--[[
    领取邮件奖励
]]
function MailView:getMailRwd()
    local mapData, buf = Map.new(), nil;

    if (0 == self.mailId) then
        ViewUtil.showMsg(const_getRwdFail);
        return ;
    end

    mapData:add("id", self.mailId);
    buf = Network.reqParamEncode(mapData);
    NetManager:SendData(self, buf, ServerID.MailRewards, nil, function (sd) self:getRwdSuccess(sd) end, "", doNthFunc);
end

--[[
    领奖成功
]]
function MailView:getRwdSuccess (session)
    local defData = GetProtoTable("DefaultData", session);

    if (0 == defData.code) then
        ViewUtil.showMsg(const_getRwdSuccess);
    else
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end

    self:synData();
end

--[[

]]
function MailView:synData ()
    local perMail, luaBhvi, mail, mData = nil, nil, nil, nil;

    for i = 1, #self.allMails do
        perMail = self.allMails[i];
        luaBhvi = GetComponent(perMail, "LuaBehaviour");
        if (nil ~= luaBhvi) then
            mail = luaBhvi.sourceLuaObj;
            if (nil ~= mail) then
                Util.EnableButton2D(self.btnGain, ButtonState.Disabled, false);
				if mail.mailId == self.mailId then
					mail.status = 1;
				end
                break ;
            end
        end
    end
end
