
MainView = class(BaseView)

 function MainView:ctor()
end  

function MainView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform

	AudioConst.SetEffectStatus(SimpleCache.getCacheVal(SimpleCache.soundBtn))
	AudioConst.SetBgmStatus(SimpleCache.getCacheVal(SimpleCache.soundBG))
	if AudioConst.GetBgmStatus() ~= 1 then
		SimpleAudio.StopMusic(doNthFunc)
	end
	if AudioConst.GetBgmName() ~= "main" then
		SimpleAudio.StopMusic(doNthFunc)
		SimpleAudio.PlayMusic("main")
		AudioConst.SetBgmName("main")
	end
end

function MainView:Start(data)
	self.peopleActive = nil
	self.flag = true

	self:initPanel()
	self:initData(data)
    self:showRedTips();
    
--	DelayCall(function()
--		Access.DoLogout(false, true)
--	end, 5)
end

function MainView:Update()
	self:AniMainContrl()
end

function MainView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
	self.top:SetAnchor(self.root.transform)
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.bottom:SetAnchor(self.root.transform)

	local topPath = "Mode/Top/Panel"
    self.mail = GetGameObject(self.transform, topPath.."/Mail")
    self.mailRedIcon = GetGameObject(self.mail.transform, "redIcon");
    self.signIn = GetGameObject(self.transform, topPath.."/SignIn")
    self.signInRedIcon = GetGameObject(self.signIn.transform, "Animation/redIcon");
    self.monthCard = GetGameObject(self.transform, topPath.."/MonthCard")
    self.monthCard:SetActive(false);
    self.archievement = GetGameObject(self.transform, topPath.."/Archievement")
    self.archiRedIcon = GetGameObject(self.archievement.transform, "redIcon");
    self.setting = GetGameObject(self.transform, topPath.."/Setting")
    self.league = GetGameObject(self.transform, topPath.."/League")
    self.friend = GetGameObject(self.transform, topPath.."/Friend")
 	self.shop = GetGameObject(self.transform, topPath.."/Shop")
 	self.activity = GetGameObject(self.transform, topPath.."/Activity")

    self.friendRedIcon = GetGameObject(self.friend.transform, "Animation/redIcon")
    self.roleName = GetPathComponent(self.transform, topPath.."/RoleName", "UILabel")
	self.fightValue = GetPathComponent(self.transform, topPath.."/FightValue", "MeshWord")

	local clouds = GetPathComponent(self.transform, topPath.."/Clouds", "Animation")
	clouds.wrapMode = WrapMode.Loop
	clouds:Play("Cloud")

	local centerPath = "Mode/Center/Panel"
	self.mainBG = GetGameObject(self.transform, centerPath.."/MainBG")

	local bottomPath = "Mode/Bottom/Panel"
 	self.risk = GetGameObject(self.transform, bottomPath.."/Risk")
	self.context = GetPathComponent(self.transform, bottomPath.."/Context", "UILabel")
    self.role = GetGameObject(self.transform, bottomPath.."/Role")
	self.roleBtn = GetComponent(self.role.transform, "UIButton")

	self.roleBtn.normalSprite = TeamData.GetRoleLogo()
   
	local animationMain = CreateObject(Util.LoadPrefab("Effects/AnimationMain", AssetBundleInfo.assetBundles))
	HangObject(animationMain, self.mainBG)
	animationMain.transform.localPosition = Vector3.New(0, 23, 0)
	ViewUtil.sortLayerOrder(animationMain, LayerName.UI)
	self.people = GetGameObject(animationMain.transform, "people")
	self.skeletonAni = GetPathComponent(self.people.transform, "daojian/body", "SkeletonAnimation")

    local function doClick(obj)
		if obj == self.risk then
			ViewUtil.goto(ModuleName.FB, false, function () 
	            if (PlayerData.getMyGuideStep() < GuideStep.getFinalGuideStep()) then
	                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
	            end
			end)

		elseif obj == self.shop then
			if (FBData.IsPassedGate(FBData.OpenData.FouthOpen[1], 1)) then
			    ViewUtil.goto(ModuleName.SHOP);
            else
                ViewUtil.showMsg(FBData.OpenData.FouthOpen[2]);
            end
		elseif obj == self.activity then
            if (FBData.IsPassedGate(FBData.OpenData.FouthOpen[1], 1)) then
			    ViewUtil.openView(ModuleName.ACT);
            else
                ViewUtil.showMsg(FBData.OpenData.FouthOpen[2]);
            end
        elseif obj == self.mail then
			ViewUtil.goto(ModuleName.MAIL)

        elseif obj == self.signIn then
            if (FBData.IsPassedGate(FBData.OpenData.FouthOpen[1], 1)) then
			    ViewUtil.goto(ModuleName.SIGN)
            else
                ViewUtil.showMsg(FBData.OpenData.FouthOpen[2]);
            end
        elseif obj == self.monthCard then
        	ViewUtil.openView(ModuleName.MONTHCARD, true);

        elseif obj == self.archievement then
            if (FBData.IsPassedGate(FBData.OpenData.FirOpen[1], 1)) then
                ViewUtil.goto(ModuleName.HONOR);
            else
                ViewUtil.showMsg(FBData.OpenData.FirOpen[2]);
            end
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
        elseif obj == self.setting then
            ViewUtil.openView(ModuleName.SETTING, true);

		elseif obj == self.league then
			if TeamData.IsJoinedLeague() then
				ViewUtil.goto(ModuleName.LeagueJoined)
			else
				ViewUtil.goto(ModuleName.LeagueApply)
			end

		elseif obj == self.friend then
            if (FBData.IsPassedGate(FBData.OpenData.FouthOpen[1], 1)) then
			    Network.SendMoData(ServerID.FriendNotice, {}, function(session, params)
				    local mo = GetProtoTable("FriendNotifyMainData", session)
				    if not IsEmptyTable(mo.notifyList) then
					    ViewUtil.openView(ModuleName.FriendNotice, true)
				    else
					    ViewUtil.openView(ModuleName.Friend)
				    end
			    end, {})
            else
                ViewUtil.showMsg(FBData.OpenData.FouthOpen[2]);
            end
		elseif obj == self.role then
            if (FBData.IsPassedGate(FBData.OpenData.FirOpen[1], 1)) then
                ViewUtil.openView(ModuleName.ROLE)
            else
                ViewUtil.showMsg(FBData.OpenData.FirOpen[2]);
            end
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
		end
    end

 	ViewUtil.AddClickEvent(self.risk, doClick)
	ViewUtil.AddClickEvent(self.shop, doClick)
    ViewUtil.AddClickEvent(self.activity, doClick)
	ViewUtil.AddClickEvent(self.mail, doClick)
	ViewUtil.AddClickEvent(self.signIn, doClick)
    ViewUtil.AddClickEvent(self.monthCard, doClick)
    ViewUtil.AddClickEvent(self.archievement, doClick)
    ViewUtil.AddClickEvent(self.setting, doClick)
    ViewUtil.AddClickEvent(self.league, doClick)
    ViewUtil.AddClickEvent(self.friend, doClick)
    ViewUtil.AddClickEvent(self.role, doClick)
end

function MainView:initData(data)
	self.roleName.text = tostring(TeamData.GetRoleName())
	self.fightValue.text = tostring(LogicUtil.getShowNum(TeamData.GetPower()))
	self.context.text =  "章节"..NumToChar(FBData.GetCurChapterId()).." "..FBData.GetGateName(FBData.GetCurGateId(), FBData.GetCurHardLevel())
end

--[[
    红点提示的显示
    数据以PlayerData.playerData.status为准
]]
function MainView:showRedTips ()
	if self.signInRedIcon ~= nil then
		self.signInRedIcon:SetActive(PlayerData.playerData.status.sign);
	end
	if self.friendRedIcon ~= nil then
		self.friendRedIcon:SetActive(PlayerData.playerData.status.friend);
	end
	if self.archiRedIcon ~= nil then
		self.archiRedIcon:SetActive(PlayerData.playerData.status.honor);
	end
	if self.mailRedIcon ~= nil then
		self.mailRedIcon:SetActive(PlayerData.playerData.status.mail);
	end
end

function MainView:AniMainContrl()
	if (nil ~= self.people) then
		self.peopleActive = self.people.activeSelf
	end

	if not self.peopleActive then
		self.flag = true
		return
	end

	if self.flag then
		local skinName = DaojianConst[math.random(1, 82)]
		self.skeletonAni.initialSkinName = skinName
		self.skeletonAni:Initialize(true)
		self.flag = false
	end
end