
MonthCardView = class(BaseView)

function MonthCardView:ctor()
end  

function MonthCardView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	
	self.shadeOpacity = true
	self:initPanel()
end

function MonthCardView:Start(data)
end

function MonthCardView:initPanel()
	-- self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 -- 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	-- self.top:SetAnchor(self.root.transform)
	-- self.bottom:SetAnchor(self.root.transform)

	local topPath = "Mode/Top/Panel"
	
	local centerPath = "Mode/Center/Panel"
	self.vipLeftLbl = GetPathComponent(self.transform, centerPath.."/BG/Label", "UILabel")
	self.btnObtain = GetGameObject(self.transform, centerPath.."/ContentTop/BtnObtain")
	self.btnBuy30 = GetGameObject(self.transform, centerPath.."/ContentBottom/Small/BtnBuy")
	self.btnBuy90 = GetGameObject(self.transform, centerPath.."/ContentBottom/Middle/BtnBuy")
	self.btnBuy180 = GetGameObject(self.transform, centerPath.."/ContentBottom/Big/BtnBuy")

	local bottomPath = "Mode/Bottom/Panel"
	self.btnClose = GetGameObject(self.transform, bottomPath.."/BtnClose")

	local function doClick(obj)
		if obj == self.btnClose then
			ViewManager.CloseModule(ModuleName.MONTHCARD, true);
		elseif obj == self.btnObtain then
			-- self:GetRwd()
			ViewUtil.showMsg("接口尚未开放！")
		elseif obj == self.btnBuy30 then
			-- self:Buy(1)
			ViewUtil.showMsg("接口尚未开放！")
		elseif obj == self.btnBuy90 then
			-- self:Buy(2)
			ViewUtil.showMsg("接口尚未开放！")
		elseif obj == self.btnBuy180 then
			-- self:Buy(3)
			ViewUtil.showMsg("接口尚未开放！")
		end
    end

	ViewUtil.AddClickEvent(self.btnClose, doClick)
	ViewUtil.AddClickEvent(self.btnObtain, doClick)
	ViewUtil.AddClickEvent(self.btnBuy30, doClick)
	ViewUtil.AddClickEvent(self.btnBuy90, doClick)
	ViewUtil.AddClickEvent(self.btnBuy180, doClick)
end

function MonthCardView:initData(data)
	if IsEmpty(data) then return end

	self.days = tonumber(StrSplit(data.msg, ",")[1])
	local status = tonumber(StrSplit(data.msg, ",")[2])

	self.vipLeftLbl.text = "当前剩余月卡天数："..self.days.."天"
	self:SetButton(status)
end

function MonthCardView:SetButton(_status)
	if _status == 1 then
		Util.EnableButton(self.btnObtain, ButtonState.Disabled, false)
	end
end

function MonthCardView:GetRwd()
	local mapData, buf = Map.new(), nil;

    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.MonthCard_Get, nil, function (sd) self:GetRwdHandle(sd); end, nil ,doNthFunc)
end

function MonthCardView:GetRwdHandle(_sd)
	local defData = nil;
    defData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end

    ViewUtil.showMsg("领取成功！");

	local status = 1
    self:SetButton(status)
end

function MonthCardView:Buy(_tp)
	local gemNum = TeamData.GetGem()
	if gemNum >= 100 then
		local mapData, buf = Map.new(), nil;

		mapData:put("type", _tp)
	    buf = Network.reqParamEncode(mapData);

	    NetManager:SendData(self, buf, ServerID.MonthCard_Buy_TEST, nil, function (sd) self:BuyHandle(sd); end, nil ,doNthFunc)
	else
		ViewUtil.showMsg("血钻不足！")
	end
end

function MonthCardView:BuyHandle(_sd)
	local defData = nil;
    defData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end

    ViewUtil.showMsg("购买成功！");

    self.days = tonumber(defData.msg)
    self.vipLeftLbl.text = "当前剩余月卡天数："..self.days.."天"
end