require "Game/MyHero/View/HeroClass"
 
MyHeroView = class(BaseView)

 function MyHeroView:ctor()
	self.sortCond = 0			-- 0:全部, 6:闪金, 5:金色, 4:紫色, 3:蓝色, 2:绿色, 1:白色
	self.sortType = 0			-- 0:品质排序, 1:战力排序, 2:觉醒排序, 3:等级排序, 4:流排排序
	self.heroList = List.new()
end  

function MyHeroView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.skillsData = Config.getSkillsData()
	self.curSkillIds = {}
	self.maxHerosAmount = 300
	self.herosAmount = 0
	self.skillAmount = 0
	self.herosInfo = CopyTable(PlayerData.getHeroList())
	self:initPanel()
end

function MyHeroView:OnFocus0(preMod) -- 弃用
	self:checkHeros()
	if preMod ~= ModuleName.SC then
		self:sortHeroList(0, 0, true)
	else
		self:sortHeroList(nil, nil, true)
	end
end

function MyHeroView:OnFocus(lastModule)
	if not self.isInited then
		self.isInited = true
		self:initData()
		self:showHeros()
	end
	ResetScrollView(self.scvObj)
	
	DelayCall(function()
		-- 默认选中第一个
		local heroObj = GetGameObject(self.gridObj.transform, "Row0/Hero1")
		self:doClickHero(heroObj)
	end, 0.2)
end

function MyHeroView:Start(data)
end

function MyHeroView:LostFocus()
	self:resetSelectedHero()
end

function MyHeroView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"
	self.scvBG = GetGameObject(self.transform, topPath.."/HeroListBG")
	self.scvObj = GetGameObject(self.transform, topPath.."/HeroListBG/ScrollView")
	self.scvBGSpr = GetComponent(self.scvBG.transform, "UISprite")
	self.gridObj = GetGameObject(self.scvObj.transform, "Grid")
	self.grid = GetPathComponent(self.scvObj.transform, "Grid", "UIGrid")
	self.uiGrid = GetComponent(self.gridObj.transform, "UIGrid")
	self.heroNum = GetPathComponent(self.transform, topPath.."/HeroAmount", "UILabel")
	
	self.wrap = GetComponent(self.gridObj.transform, "UIWrapContent")
	self.wrap.enabled = false

	ViewUtil.adaptUISize(self.scvBG, true, 40, 320, 20, 20)
	ViewUtil.adaptUISize(self.scvObj, false, 120, 320, 20, 20)

	local bottomPath = "Mode/Bottom/Panel"
 	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")
 	self.btnSort = GetGameObject(self.transform, bottomPath.."/BtnSort")
	self.btnUpgrade = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/btnUpgrade")
	self.btnIntensify = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/btnIntensify")

	self.btnSkills = {}
	self.btnSkills[1] = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/Skill1")
	self.btnSkills[2] = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/Skill2")
	self.btnSkills[3] = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/Skill3")
	self.btnSkills[4] = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/Skill4")
	self.btnSkills[5] = GetGameObject(self.transform, bottomPath.."/SkillBoardBG/Skill5")
	self.sprSkills = {}
	for i = 1, 5 do
		self.sprSkills[i] = GetComponent(self.btnSkills[i].transform, "UIButton")
		self.sprSkills[i].normalSprite = "alpha"
	end
	
	self.skillTitle = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroSkill", "UILabel")
	self.skillHead = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroSkill/Title", "UILabel")
	self.heroName = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroName", "UILabel")
	self.heroLvl = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroLvl", "UILabel")
	self.heroWiseup = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroWiseup", "UILabel")
	self.heroIntensify = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroIntensify", "UILabel")
	self.heroFightValue = GetPathComponent(self.transform, bottomPath.."/HeroInfo/HeroFightValue", "UILabel")

	self.descContent = GetPathComponent(self.transform, bottomPath.."/Description/Content", "UILabel")
	self.descProp1 = GetPathComponent(self.transform, bottomPath.."/Description/Prop1", "UILabel")
	self.descProp2 = GetPathComponent(self.transform, bottomPath.."/Description/Prop2", "UILabel")
	self.descProp3 = GetPathComponent(self.transform, bottomPath.."/Description/Prop3", "UILabel")
	self.descProp4 = GetPathComponent(self.transform, bottomPath.."/Description/Prop4", "UILabel")
	
	self.heroName.text = "选择英雄"
	self.heroLvl.text = ""..0
	self.heroWiseup.text = 0
	self.heroIntensify.text = 0
	self.heroFightValue.text = 0

	self.skillTitle.text = "无"
	self.descContent.text = " "
	self.descProp1.text = 0
	self.descProp2.text = 0
	self.descProp3.text = 0
	self.descProp4.text = 0

    local function doClick(obj)
		if obj == self.btnBack then
			ViewUtil.openView(ModuleName.HERO)
		elseif obj == self.btnSort then
			ViewUtil.openView(ModuleName.SC, true,  function()
				Facade:sendNotification(MVCConst.HERO_SORTCHOSEOPEN, {[1] = ModuleName.MH, [2] = LogicUtil.quaToShowType(self.sortCond)}, nil)
            end, nil)
		elseif obj == self.btnUpgrade then
			-- 直接传方法执行会有一部分变量没赋值，导致显示异常。 by iorinie
			ViewUtil.openView(ModuleName.HU, false, function(args)
				-- local ctrl = ModuleManager.GetCtrl(ModuleName.HU)
				-- ctrl.slideTab(1)
			end)
		elseif obj == self.btnIntensify then
			ViewUtil.openView(ModuleName.HU, false, function(args)
				local ctrl = ModuleManager.GetCtrl(ModuleName.HU)
				ctrl.slideTab(2)
			end)
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnSort).onClick = doClick
	-- UIEventListener.Get(self.btnUpgrade).onClick = doClick
	-- UIEventListener.Get(self.btnIntensify).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnSort, doClick)
	ViewUtil.AddClickEvent(self.btnUpgrade, doClick)
	ViewUtil.AddClickEvent(self.btnIntensify, doClick)

--    local function doClickSelect(obj)
--		self:selectHeroBoard(obj)
--	end
--	local list = self.uiGrid:GetChildList()
--	for i = 0, list.Count-1 do
--		-- UIEventListener.Get(list[i].gameObject).onClick = doClickSelect
--		ViewUtil.AddClickEvent(list[i].gameObject, doClickSelect)
--	end

    local function doClickSkills(obj)
		local function _selected(index)
			if index <= self.skillAmount then
				self:selectSkillBoard(obj)
				local skillId = self.curSkillIds[index]
				local skillInfo = self.skillsData[tostring(skillId)]
				self.skillTitle.text = skillInfo[g_skills_file_title] or "无"
				self.descContent.text = skillInfo.description
				local heroIds = split(skillInfo[g_skills_hero_id], ":")
				if #heroIds > 1 then
					self.skillHead.text = "合体技"
				else
					self.skillHead.text = "个人技"
				end
			end
		end
		for i = 1, 5 do
			if obj == 	self.btnSkills[i] then
				_selected(i)
			end
		end
	end
	local function onPressSkills(tbl)
		if IsEmpty(tbl) then return end
		local go = tbl.obj
		local isPress = tbl.isPress
		local skillId = self.curSkillIds[tbl.idx]
        ViewUtil.showSkillTipsEvent(go, isPress, skillId)
		ViewUtil.showHerosTips(go, skillId, isPress)
	end
	for i, btn in pairs(	self.btnSkills) do
		UIEventListener.Get(btn).onPress = doClickSkills
		ViewUtil.AddEventTrigger(btn, EventConst.onPress, onPressSkills, {isPress = true, obj = btn, idx = i})
		ViewUtil.AddEventTrigger(btn, EventConst.onRelease, onPressSkills, {isPress = false, obj = btn, idx = i})
	end
end

function MyHeroView:showHeros()
	local function _onPress(obj)
		self:resetSelectedHero()
	end
	local function _doClickHero(obj)
		self:doClickHero(obj)
	end
    
	local rowNum = math.abs(GetIntPart(self.heroList.size/5 + (self.heroList.size%5 > 0 and 1 or 0)))
    self.wrap.minIndex = -rowNum + 1
    self.wrap.maxIndex = 0
    self.wrap.enabled = true

    self.wrap.onInitializeItem = function(go, index, realIndex)
--		plog("go = ", go, ", index = ", index, ", realIndex = ", realIndex, ",  minIndex = ",  self.wrap.minIndex, ",  maxIndex = ",  self.wrap.maxIndex)
		if rowNum < index + 1 then
			for i = 1, 5 do
				local hero = GetGameObject(go.transform, "Hero"..i)
				hero:SetActive(false)
			end
		else
			local beginIdx = math.abs(realIndex) * 5
			for i = 1, 5 do
				local hero = GetGameObject(go.transform, "Hero"..i)
				local cls = self.heroList[beginIdx + i]
				if cls ~= nil then
--					plog("[3]prefabName = ", cls.prefabName, ", quality = ", cls.quality, ", size = ", self.heroList.size)
					local data = cls.data 
					hero:SetActive(true)
					local lb = GetComponent(hero.transform, "LuaBehaviour")
					if not lb then
						local heroClass = HeroClass.new()
						heroClass:bindHeroObj(hero)
						heroClass:init(data)
						heroClass:refreshHero(true)
						BindLuaScript(heroClass, hero)
						ViewUtil.AddClickEvent(hero, _doClickHero)
						UIEventListener.Get(hero).onPress = _onPress
					else
						local heroClass = lb.sourceLuaObj
						heroClass:init(data)
						heroClass:refreshHero(true)
					end
				else
					hero:SetActive(false)
				end
			end
		end
    end

	self.herosAmount = self.heroList.size
	self.heroNum.text = self.herosAmount
end

-- 检查是否存在新英雄
function MyHeroView:checkHeros()
	TeamData.updateGridHeros(self.gridObj)
	self.gridObj:SetActive(false)
	local function _doClickHero(obj)
		self:doClickHero(obj)
	end

	local myHeros = TeamData.getMyHeros()
	local tran = self.gridObj.transform

	for i = tran.childCount - 1, 0, -1 do
		local child = tran:GetChild(i)
		local obj = child.gameObject
		obj:SetActive(false)
		if IsAHero(obj) then
			local lb = GetComponent(obj.transform, "LuaBehaviour")
			if lb then
				local heroClass = lb.sourceLuaObj
				local onlyId = heroClass.onlyId
				local isMine = false
				for j = 1, #myHeros do
					local mine = myHeros[j]
					if tostring(onlyId) == tostring(mine.id) then
						isMine = true
						obj:SetActive(true)
						break
					end
				end
				if not isMine then
					for i, v in ipairs(self.heroList) do
						if v.onlyId == heroClass.onlyId then
							self.heroList:removeAt(i)
						end
					end
				end
			end
		end
	end

	for m = 1, #myHeros do
		local src = myHeros[m]
		local isExist = false
		for n = tran.childCount - 1, 0, -1 do
			local child = tran:GetChild(n)
			local obj = child.gameObject
			local lb = GetComponent(obj.transform, "LuaBehaviour")
			if lb then
				local heroClass = lb.sourceLuaObj
				local onlyId = heroClass.onlyId
				if tostring(onlyId) == tostring(src.id) then
					isExist = true
					break
				end
			end
		end
		if not isExist then
			local info = src
			local heroClass = HeroClass.new()
			heroClass:init(info)
			self.heroList:add(heroClass)
			local hero = heroClass:createHero()
			HangObject(hero, self.gridObj)
			BindLuaScript(heroClass, hero)
			-- UIEventListener.Get(hero).onClick = _doClickHero
			ViewUtil.AddClickEvent(hero, _doClickHero)
		end
	end

	self.herosAmount = CountTable(myHeros)
	self.heroNum.text = self.herosAmount .. "/" .. self.maxHerosAmount
	self:createEmptyHeros()

	ResetGrid(self.gridObj)
	self.gridObj:SetActive(true)
	ResetScrollView(self.scvObj)
end

function MyHeroView:isSameCond(hCfg)
    local isType = false;
    if (self.sortCond >= 0 and self.sortCond <= 6) then
        if (0 == self.sortCond) then
            isType = true;
        else
            isType = (self.sortCond == tonumber(HeroDataProxy.getHeroQuality(hCfg)));
        end
    end
    return isType;
end

function MyHeroView:selectHeroBoard(obj)
	if not obj then return end
	if not self.selectBoard then
		self.selectBoard = CreateObject(Util.LoadPrefab("UI/SelectedHeroBoard", AssetBundleInfo.assetBundles))
		ViewUtil.sortLayerOrder(self.selectBoard, LayerName.UI)
	end
	HangObject(self.selectBoard, obj)
	self.selectBoard.transform.localPosition = Vector3.New(0, 4, 0)
end

function MyHeroView:selectSkillBoard(obj)
	if not obj then return end
	if not self.selectBoard2 then
		self.selectBoard2 = CreateObject(Util.LoadPrefab("UI/SelectedSkillBoard", AssetBundleInfo.assetBundles))
		ViewUtil.sortLayerOrder(self.selectBoard2, LayerName.UI)
	end
	HangObject(self.selectBoard2, obj)
end

function MyHeroView:resetSelectedHero()
	self.selectedHero = nil
	DestroyObject(self.selectBoard)
	self.selectBoard = nil
	DestroyObject(self.selectBoard2)
	self.selectBoard2 = nil
	
	self.skillAmount = 0
	for i = 1, 5 do
		self.sprSkills[i] = GetComponent(self.btnSkills[i].transform, "UIButton")
		self.sprSkills[i].normalSprite = "alpha"
	end
	self.heroName.text = "选择英雄"
	self.skillTitle.text = "无"
	self.heroLvl.text = ""..0
	self.heroWiseup.text = 0
	self.heroIntensify.text = 0
	self.heroFightValue.text = 0
	self.descContent.text = " "
	self.descProp1.text = 0
	self.descProp2.text = 0
	self.descProp3.text = 0
	self.descProp4.text = 0
end

function MyHeroView:sortGridByType0(sortType)
	SortUIGrid(self.gridObj, function(tran1, tran2)
		local lb1 = GetComponent(tran1, "LuaBehaviour");
		local lb2 = GetComponent(tran2, "LuaBehaviour");
		if lb1 ~= nil and lb2 ~= nil then
			local cls1 = lb1.sourceLuaObj
			local cls2 = lb2.sourceLuaObj
			if sortType == 0 then
				if cls1.quality < cls2.quality then
					return 1
				elseif cls1.quality == cls2.quality then
					if tran1.name > tran2.name then
						return 1
					end
				end
			elseif sortType == 1 then
				local power1 = HeroDataProxy.getHeroAbility(cls1.heroId, cls1.level, cls1.wiseup, cls1.strengthen)
				local power2 = HeroDataProxy.getHeroAbility(cls2.heroId, cls2.level, cls2.wiseup, cls2.strengthen)
				if power1 < power2 then
					return 1
				end
			elseif sortType == 2 then
				if cls1.wiseup < cls2.wiseup then
					return 1
				end
			elseif sortType == 3 then
				if cls1.level < cls2.level then
					return 1
				end
			end
		end
		return 0
	end)
	ResetGrid(self.gridObj)
end

function MyHeroView:sortGridByType(sortType)
	local function compFunc(cls1, cls2)
		if cls1 ~= nil and cls2 ~= nil then
			if sortType == 0 then
				if cls1.quality < cls2.quality then
					return true
				elseif cls1.quality == cls2.quality then
					if cls1.prefabName > cls2.prefabName then
						return true
					end
				end
			elseif sortType == 1 then
				local power1 = HeroDataProxy.getHeroAbility(cls1.heroId, cls1.level, cls1.wiseup, cls1.strengthen)
				local power2 = HeroDataProxy.getHeroAbility(cls2.heroId, cls2.level, cls2.wiseup, cls2.strengthen)
				if power1 < power2 then
					return true
				end
			elseif sortType == 2 then
				if cls1.wiseup < cls2.wiseup then
					return true
				end
			elseif sortType == 3 then
				if cls1.level < cls2.level then
					return true
				end
			end
		end
		return false
	end
	SortFunc(self.heroList, compFunc)
end

function MyHeroView:sortHeroList(sortArea, sortIndex, force)
	local sortCond = self.sortCond
	local sortType =self.sortType
	if sortArea ~= nil then
		if sortArea == 0 then
			sortCond = tonumber(sortIndex) or 0
		else
			sortType = tonumber(sortIndex) or 0
		end
	end
--	plog("sortCond = %d, sortType = %d", sortCond, sortType)

	local isSorting = false
	if self.sortCond ~= sortCond or self.sortType ~= sortType then
		self.sortCond = sortCond
		self.sortType = sortType
		isSorting = true
	end

	if isSorting or force then
		self:resetData()
		for i = self.heroList.size, 1, -1 do
			if not self:isSameCond(self.heroList[i].conf) then
				self.heroList:removeAt(i)
			end
		end
	end

	if isSorting or force then
		self:sortGridByType(self.sortType)
	end
end

function MyHeroView:sortHeroListNow(sortArea, sortIndex, force)
	self:sortHeroList(sortArea, sortIndex, force)
	self:showHeros()
	self.wrap:SortBasedOnScrollMovement()
end

function MyHeroView:doClickHero(obj)
	if not obj then return end
	self:selectHeroBoard(obj)
	local lb = GetComponent(obj.transform, "LuaBehaviour")
	local heroClass = lb.sourceLuaObj
    if (1 ~= tonumber(heroClass.heroId) and 2 ~= tonumber(heroClass.heroId)) then
		self.heroName.text = heroClass.heroName
    else
        self.heroName.text = PlayerData.playerData.team.teamName
    end
	self.heroLvl.text = ""..HeroDataProxy.getHeroShowLvl(heroClass.level, heroClass.wiseup)
	self.heroWiseup.text = tostring(heroClass.wiseup)
	self.heroIntensify.text = tostring(heroClass.strengthen)
	self.heroFightValue.text = HeroDataProxy.getHeroAbility(heroClass.heroId, heroClass.level, heroClass.wiseup, heroClass.strengthen)
		
	local skillIds = split(heroClass.skillIds[1], ":")
	self.skillAmount = #skillIds
	self.curSkillIds = {}
	if self.skillAmount > 0 then
		for i = 1, 5 do
			if i <= #skillIds then
				local skillId = tostring(skillIds[i])
				local skillInfo = self.skillsData[skillId]
				if IsEmpty(skillInfo) then
					ViewUtil.showMsg(string.format("技能配置出错: %s", skillId))
				else
					self.curSkillIds[i] = skillId
					self.sprSkills[i].normalSprite = skillInfo[g_skills_file_skill_icon]
					if i == 1 then
						self:selectSkillBoard(self.btnSkills[1])
						self.skillTitle.text = skillInfo[g_skills_file_title] or "无"
						self.descContent.text = skillInfo.description
						self.descProp1.text = heroClass.propAtk
						self.descProp2.text = heroClass.propDef
						self.descProp3.text = heroClass.propDodge
						self.descProp4.text = heroClass.propKing
						local heroIds = split(skillInfo[g_skills_hero_id], ":")
						if #heroIds > 1 then
							self.skillHead.text = "合体技"
						else
							self.skillHead.text = "个人技"
						end
					end
				end
			else
				self.sprSkills[i].normalSprite = "alpha"
			end
		end
	else
		self.skillTitle.text = "无"
		self.descContent.text = " "
		self.descProp1.text = "0"
		self.descProp2.text = "0"
		self.descProp3.text = "0"
		self.descProp4.text = "0"
		for i = 1, 5 do
			self.sprSkills[i].normalSprite = "alpha"
		end
		if self.selectBoard2 ~= nil then
			self.selectBoard2:SetActive(false)
		end
	end
end

function MyHeroView:createEmptyHeros()
	local other = 25 - self.herosAmount
	if other <= 0 then
		other = 5 + math.abs(other % 5)
	end
	for i = 1, other do
		local heroClass = HeroClass.new()
		local hero = heroClass:createHeroEmpty()
		HangObject(hero, self.gridObj)
	end
	ResetGrid(self.gridObj)
end

function MyHeroView:initData0()
	DestroyChildren(self.gridObj)

	self.herosAmount = CountTable(self.herosInfo)
	self.heroNum.text = self.herosAmount.."/"..self.maxHerosAmount
	local function _doClickHero(obj)
		self:doClickHero(obj)
	end
	for i = 1, self.herosAmount do
		local info = self.herosInfo[i]
		local heroClass = HeroClass.new()
		heroClass:init(info, i)
		self.heroList:add(heroClass)
		local hero = heroClass:createHero()
		HangObject(hero, self.gridObj)
		BindLuaScript(heroClass, hero)
		-- UIEventListener.Get(hero).onClick = _doClickHero
		ViewUtil.AddClickEvent(hero, _doClickHero)
	end
	self:sortGridByType(0)
	self:createEmptyHeros()
	ResetScrollView(self.scvObj)
end

function MyHeroView:resetData()
	local lastModule = ViewUtil.getLastModule(self.name)
	local myHeros = TeamData.GetAllHeros()

    self.heroList:clear()
	for _, hero in ipairs(myHeros) do
		local cls = HeroClass.new()
		cls:init(hero)
		self.heroList:add(cls)
--		plog("[1]prefabName = ", cls.prefabName, ", quality = ", cls.quality, ", size = ", self.heroList.size)
	end
end

function MyHeroView:initData()
	self:resetData()
	self:sortHeroList(0, 0, true)
end
