require "Game/PVP/View/PVPView"
 
PVPControler = {}

local this = PVPControler

function PVPControler.New()
	return this
end

function PVPControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = PVPView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	UpdateHelper.addUpdate(this.Update)

	this.request()
end

function PVPControler.Awake()
end

function PVPControler.Start()
end

function PVPControler.Update()
	this.view:Update()
end

function PVPControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function PVPControler.initListener()
end

function PVPControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function PVPControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function PVPControler.getMaxChallengeTimesAR()
	return 10
end

function PVPControler.request()
	Network.SendMoData(ServerID.PVP, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("PVPMainData", session)
		this.accept(mo)
	end, {})
end

function PVPControler.accept(data)
	ViewUtil.initData(this, data)
end
