
PVPView = class(BaseView)

 function PVPView:ctor()
end  

function PVPView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.challengeTimesAR = PVPControler.getMaxChallengeTimesAR()
	self.arTime = 0
	self.wfTime = 0
	self:initPanel()

	if AudioConst.GetBgmName() ~= "main" then
		SimpleAudio.StopMusic(doNthFunc)
		SimpleAudio.PlayMusic("main")
		AudioConst.SetBgmName("main")
	end
end

function PVPView:Start(data)
	self:initData(data)
end

function PVPView:Update()
	self.sumTime = Time.timeSinceLevelLoad
	if not self.preTime or self.preTime <= 0 then
		self.preTime = self.sumTime
	end
	local deltaTime = self.sumTime - self.preTime
	self.preTime = self.sumTime

	self.wfTime = self.wfTime - deltaTime
	self.wfTimeObj.text = Time2String(self.wfTime)
end

function PVPView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)

	local topPath = "Mode/Top/Panel"
	self.gridObj = GetGameObject(self.transform, topPath.."/ScrollBG/ScrollView/Grid")
	self.grid = GetPathComponent(self.transform, topPath.."/ScrollBG/ScrollView/Grid", "UIGrid")

	local scvPath = "Mode/Top/Panel/ScrollBG"
	self.scv = GetGameObject(self.transform, scvPath.."/ScrollView")
	self.scvBGSpr = GetPathComponent(self.transform, scvPath, "UISprite")
	self.scvPanel = GetPathComponent(self.transform, scvPath.."/ScrollView", "UIPanel")
	ViewUtil.adaptScrollViewHeight(self.scvBGSpr, self.scvPanel, 160)
	
	local obj1 = CreateObject(Util.LoadPrefab("UI/BarPVP1", AssetBundleInfo.assetBundles))
	HangObject(obj1, self.gridObj)
	self.btnArena = GetGameObject(obj1.transform, "BarBtn")
	self.arRankObj = GetPathComponent(obj1.transform, "BarBtn/SpriteBG/Rank", "UILabel")
	-- self.arAwardObj = GetPathComponent(obj1.transform, "BarBtn/SpriteBG/Awards", "UILabel")
	self.arCountObj =GetPathComponent(obj1.transform, "BarBtn/SpriteBG/Count", "UILabel")

	local obj2 = CreateObject(Util.LoadPrefab("UI/BarPVP2", AssetBundleInfo.assetBundles))
	HangObject(obj2, self.gridObj)
	ResetGrid(self.gridObj)
	self.btnWF = GetGameObject(obj2.transform, "BarBtn")
	self.wfTimeObj = GetPathComponent(obj2.transform, "BarBtn/SpriteBG/Time", "UILabel")
	self.wfCountObj = GetPathComponent(obj2.transform, "BarBtn/SpriteBG/Count", "UILabel")
	
	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)
		if obj == self.btnBack then
			ViewUtil.openView(ModuleName.MAIN)
		elseif obj == self.btnArena then
            if (FBData.IsPassedGate(FBData.OpenData.ThiOpen[1], 1)) then
                ViewUtil.goto(ModuleName.AR)
			    if (PlayerData.guideNotEnd()) then
				    Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
			    end
            else
                ViewUtil.showMsg(FBData.OpenData.ThiOpen[2]);
            end
		elseif obj == self.btnWF then
            if (FBData.IsPassedGate(FBData.OpenData.FouthOpen[1], 1)) then
                ViewUtil.goto(ModuleName.WB)
			    if (PlayerData.guideNotEnd()) then
				    Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
			    end
            else
                ViewUtil.showMsg(FBData.OpenData.FouthOpen[2]);
            end
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnArena).onClick = doClick
	-- UIEventListener.Get(self.btnWF).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnArena, doClick)
	ViewUtil.AddClickEvent(self.btnWF, doClick)
end

function PVPView:initData(data)
	if IsEmpty(data) then return end
	self.arTime = data.arenaRefreshSecond
	self.wfTime = data.funzionRefreshSecond
	self.arCount = tonumber(data.arenaCount) or 0
	self.wfCount = tonumber(data.funzionCount) or 0
--	if self.wfCount == 0 then
--		ViewUtil.showMsg("剩余次数不足")
--	else
--	end

	self.arRankObj.text = data.arenaRank
	-- self.arAwardObj.text = 0
	self.arCountObj.text = (self.challengeTimesAR - self.arCount) .. "/10"

	self.wfTimeObj.text = self.wfTime
	self.wfCountObj.text = self.wfCount .. "/10"
end
