
PayView = class(BaseView)

function PayView:ctor()
end  

function PayView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	
	self.buys = {}
	self.btnBuys = {}
	self.titles = {}
	self.frees = {}

	self:initPanel()
	self:Request()
end

function PayView:Start(data)
	-- self:initData()
end

function PayView:initPanel()
	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)

	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
	self.scrollViewObj = GetGameObject(self.transform, centerPath.."/ScrollViewBG/ScrollView")
	self.gridObj = GetGameObject(self.scrollViewObj.transform, "Panel/Grid")

	for i = 1, 8 do
		self.buys[i] = GetGameObject(self.gridObj.transform, "Buy_"..i)
		self.btnBuys[i] = GetGameObject(self.buys[i].transform, "BtnObtain")
		self.titles[i] = GetGameObject(self.buys[i].transform, "Title")
		self.frees[i] = GetGameObject(self.buys[i].transform, "GetMore")
	end

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

	local function doClick(obj)
		if obj == self.btnBack then
			self:closeView(true)
		elseif obj == self.btnBuys[1] then
			Access.DoPay(1003, 10, 10, "gName", "gDesc") --参数2单价单位是分
		elseif obj == self.btnBuys[2] then
			Access.DoPay(1003, 10, 60, "gName", "gDesc")
		elseif obj == self.btnBuys[3] then
			Access.DoPay(1003, 10, 300, "gName", "gDesc")
		elseif obj == self.btnBuys[4] then
			Access.DoPay(1003, 10, 880, "gName", "gDesc")
		elseif obj == self.btnBuys[5] then
			Access.DoPay(1003, 10, 1880, "gName", "gDesc")
		elseif obj == self.btnBuys[6] then
			Access.DoPay(1003, 10, 2880, "gName", "gDesc")
		elseif obj == self.btnBuys[7] then
			Access.DoPay(1003, 10, 3880, "gName", "gDesc")
		elseif obj == self.btnBuys[8] then
			Access.DoPay(1003, 10, 6480, "gName", "gDesc")
		end
    end

	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnBuys[1], doClick)
	ViewUtil.AddClickEvent(self.btnBuys[2], doClick)
	ViewUtil.AddClickEvent(self.btnBuys[3], doClick)
	ViewUtil.AddClickEvent(self.btnBuys[4], doClick)
	ViewUtil.AddClickEvent(self.btnBuys[5], doClick)
	ViewUtil.AddClickEvent(self.btnBuys[6], doClick)
	ViewUtil.AddClickEvent(self.btnBuys[7], doClick)
	ViewUtil.AddClickEvent(self.btnBuys[8], doClick)
end

function PayView:Request()
	local mapData, buf = nil, nil;

    mapData = Map.new();
    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.Payment_Ety, nil, function (sd) self:SetData(sd); end, nil, doNthFunc);
end

function PayView:SetData(_sd)
	local existList = {10, 60, 300, 880, 1880, 2880, 3880, 6480}
	local myList = {}
	local payList = {}

	self.payMain = GetProtoTable("DefaultData", _sd)

	if self.payMain.msg ~= "" then
		myList = StrSplit(self.payMain.msg, ",")
	end

	for i = 1, #myList do
		for j = 1, 8 do
			if tonumber(myList[i]) == existList[j] then
				payList[j] = tonumber(myList[i])
			end
		end
	end

	for i = 1, 8 do
		if payList[i] == nil then
			if self.titles[i] ~= nil then
				self.titles[i]:SetActive(true)
			end
		elseif self.frees[i] ~= nil then
			self.titles[i]:SetActive(false)
			self.frees[i]:SetActive(true)
		end
	end
end

-- function PayView:GetRwd(_tp)
-- 	local mapData, buf = nil, nil;

-- 	mapData = Map.new()
-- 	mapData:put("type", _tp);
--     buf = Network.reqParamEncode(mapData);

--     NetManager:SendData(self, buf, ServerID.Payment_Get, nil, function (sd) self:GetRwdHandle(sd); end, nil ,doNthFunc)
-- end

-- function PayView:GetRwdHandle(_sd)
-- 	local defData = nil;
--     defData = GetProtoTable("DefaultData", _sd);

--     if (0 ~= defData.code) then
--         ViewUtil.showMsg(GetWord(defData.code));
--         return ;
--     end

--     ViewUtil.showMsg("购买成功！");
-- end