--道具模块Controler
--2016-7-8 11:59:13 library
require "Game/Prop/View/PropView"
require "Game/Prop/Logic/PropCusData"

local const_tabNormal = "prop_tabNormalBG";
local const_tabSlt = "prop_tabChoseBG";

PropControler = {
    gameObject = nil;
    transform = nil;

    propView = nil;
    root = nil;
}

local this = PropControler;

function PropControler.New()
	return this
end

--[[

]]
function PropControler.OnCreate (_go, name)
    this.gameObject = _go;
    this.transform = this.gameObject.transform;
    this.root = ViewUtil.getRootView();
    this.propView = PropView.new();
	this.propView.name = name
    this.propView:Awake(_go);
    this.propView:Start();
	this.view = this.propView;
    
    HangObject(this.gameObject, this.root);

    this.initListener();
end

--[[

]]
function PropControler.initListener ()
    local tabTmp, len = nil, this.propView.tabList:getSize();
    
    for i = 1, len do
        tabTmp = this.propView.tabList[i];
        UIEventListener.Get(tabTmp).onClick = function ()
            (function (tmp)
                if (tmp ~= this.propView.curIdx) then
                    this.chgeTabShow(tmp);
                end
            end)(i);
        end;
    end
    this.chgeTabShow(1);
    UIEventListener.Get(this.propView.closeBtn).onClick = function () 
        ViewUtil.closeView(ModuleName.PROP, true);
        DestroyObject(this.propView.sMask);
        if (PlayerData.guideNotEnd()) then
            Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
        end
    end;
    
    UIEventListener.Get(this.propView.useBtn).onClick = function () this.propView:useProp(); end;
end

--[[
    改变切换标签的显示
    idx 当前需要显示的索引
    return nil
]]
function PropControler.chgeTabShow (idx)
    local tabTmp, len = nil, this.propView.tabList:getSize();
    
    for i = 1, len do
        tabTmp = this.propView.tabList[i];
        if (i == idx) then
            GetComponent(tabTmp, "UIButton").enabled = false;
            this.propView.curIdx = idx;
            GetPathComponent(tabTmp.transform, "Sprite", "UISprite").spriteName = const_tabSlt;
            this.showMyProp(idx);
        else
            GetComponent(tabTmp, "UIButton").enabled = true;
            GetPathComponent(tabTmp.transform, "Sprite", "UISprite").spriteName = const_tabNormal;
        end
    end
end

--[[
    显示当前类型的背包
    idx number 1，道具；2，英雄培养
    return nil
]]
function PropControler.showMyProp (idx)
    local useProp = nil;

    useProp = PropCusData.new();
    useProp:Awake(idx);
    useProp:Start();
    this.propView:setPCData(useProp);
    this.propView:showProps();
end

--[[

]]
function PropControler.OnDestroy ()
    this.gameObject = nil;
    this.transform = nil;
    this.propView = nil;
end

--[[

]]
function PropControler.listNotificationInterests ()
    local list = {
        MVCConst.SHOP_PROPCHANGE
    };

    return unpack(list);
end

--[[

]]
function PropControler.handNotification (note)
    local nName = note:getName();
    local nBody = note:getBody();
    local nType = note:getType();

    if (MVCConst.PROP_PROPCHANGE) then
        this.showMyProp(this.propView.curIdx);
    end
end
