--背包基本视图类
--2016-7-8 14:36:15 library

local const_propShowBaseNum = 25;
local const_propNumPerLine = 5;

local const_usePropSuccess = "使用成功";
local const_maxHeroNum = "目前可拥有的英雄数量最多为 {1} 个";

PropView = class(BaseView);

function PropView:ctor ()
	self.showShade = true
	self.shadeOpacity = true
    self.gameObject = nil;
    self.transform = nil;

    self.propPrefab = nil;

    self.propTab = nil;
    self.heroTab = nil;
    self.stenTab = nil;
    self.closeBtn = nil;
    self.useBtn = nil;
    self.detailInfoUseTxt = nil;
    self.detailInfoShowTxt = nil;
    self.scrollView = nil;
    self.svPanel = nil;
    self.grid = nil;
    self.sMask = nil;
    self.propSelectIcon = nil;

    self.curIdx = 0;
    self.curPropId = 0;--道具配置ID
    self.curId = 0;--道具唯一ID


    self.tabList = List.new();
    self.propList = List.new();
    self.pcData = nil;--存放当前需要显示的道具基本数据 PropCusData
end

--[[

]]
function PropView:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
end

--[[

]]
function PropView:Start ()
    self:initPanel();
end

--[[

]]
function PropView:initPanel ()
    local topPath = "Top/";
    local centerPath = "Center/";
    local propDetailPath = centerPath .. "PropDetail/";
    
    self.propTab = GetGameObject(self.transform, topPath .. "PropTab");
    self.heroTab = GetGameObject(self.transform, topPath .. "HeroTab");
    self.stenTab = GetGameObject(self.transform, topPath .. "StenTab");
    self.closeBtn = GetGameObject(self.transform, topPath .. "CloseBtn");

    self.useBtn = GetGameObject(self.transform, propDetailPath .. "UseBtn");
    self.detailInfoUseTxt = GetGameObject(self.transform, propDetailPath .. "DetailInfoUseTxt");
    self.detailInfoShowTxt = GetGameObject(self.transform, propDetailPath .. "DetailInfoShowTxt");
    self.detailInfoShowTxt:SetActive(false);
    self.useBtn:SetActive(false);

    self.allPropsGO = GetGameObject(self.transform, centerPath .. "AllProps");
    self.scrollView = GetGameObject(self.transform, centerPath .. "AllProps/ScrollView");
    self.svPanel = GetGameObject(self.scrollView.transform, "Panel");
    self.grid = GetGameObject(self.svPanel.transform, "Grid");
    self.propSelectIcon = GetGameObject(self.transform, centerPath .. "AllProps/propSelectIcon");
    
    self.tabList:add(self.propTab);
    self.tabList:add(self.heroTab);
    self.tabList:add(self.stenTab);
    
    self.propPrefab = Util.LoadPrefab("UI/PropItem", AssetBundleInfo.assetBundles);
end

--[[
    显示当前类型的所有道具
    return nil
]]
function PropView:showProps ()
    local propItem, propItemShow, pData, pCfg, pcData = nil, nil, nil, nil, nil;
    local firProp = nil;

    self:cleanShowProps();
    if (nil == self.pcData) then
        self.propSelectIcon:SetActive(false);
        self:fillScrollViewWithProps();
        return nil;
    end

    pcData = self.pcData;
    
    if (pcData.propsData:getSize() < 1) then
        self.propSelectIcon:SetActive(false);
        self.detailInfoUseTxt:SetActive(false);
        self.detailInfoShowTxt:SetActive(false);
        self.useBtn:SetActive(false);
    end

    for i = 1, pcData.propsData:getSize() do
        pData = pcData.propsData[i];--PropData
        propItem = CreateObject(self.propPrefab);
        propItemShow = PropShowItem.new();
        
        propItemShow:Awake(propItem, pData.propId, pData.num);
        propItemShow.id = pData.id;
        propItemShow:Start(false);
        PanelManager:BindPanelScript(propItemShow, propItem, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
        HangObject(propItem, self.grid);
        self.propList:add(propItem);
        
        -- UIEventListener.Get(propItem).onClick = function (_go) 
        --     local propIdTmp, pCfgTmp, idTmp = nil, nil, nil;
        --     local luaBhvi, pis = nil;
            
        --     luaBhvi = GetComponent(_go, "LuaBehaviour");
        --     if (nil ~= luaBhvi) then
        --         pis = luaBhvi.sourceLuaObj;
        --         propIdTmp = pis.propId;
        --         pCfgTmp = pis.pCfg;
        --         idTmp = pis.id;
        --         self:propClick(propIdTmp, pCfgTmp, idTmp, _go);
        --     end
        -- end;
        ViewUtil.AddClickEvent(propItem, function (_go) 
            local propIdTmp, pCfgTmp, idTmp = nil, nil, nil;
            local luaBhvi, pis = nil;
            
            luaBhvi = GetComponent(_go, "LuaBehaviour");
            if (nil ~= luaBhvi) then
                pis = luaBhvi.sourceLuaObj;
                propIdTmp = pis.propId;
                pCfgTmp = pis.pCfg;
                idTmp = pis.id;
                self:propClick(propIdTmp, pCfgTmp, idTmp, _go);
            end

            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
        end)
        
        if ((0 == self.curPropId and 1 == i) or (self.curId == pData.id)) then
            if (1 == i) then
                firProp = propItem;
            end
            self:propClick(pData.propId, propItemShow.pCfg, pData.id, propItem);
        end
        GetComponent(propItem, "UIPanel").sortingLayerName = LayerName.Dialog;
    end
    self:fillScrollViewWithProps();
end

--[[
    清空显示的道具
    return nil
]]
function PropView:cleanShowProps ()
    local prop = nil;

    self.propSelectIcon.transform.parent = self.allPropsGO.transform;
    for i = 1, self.propList:getSize() do
        prop = self.propList[i];
        DestroyObject(prop);
    end

    self.propList:clear();
    self.curPropId = 0;
end

--[[
    道具详细显示
    _pId number 道具ID
    _pCfg 道具配置
    _id number 道具唯一ID，使用道具时传该参数，而不是_pId
    _go GameObject 当前选中的道具
    return nil
]]
function PropView:propClick (_pId, _pCfg, _id, _go)
    self.curPropId = _pId;
    self.curId = _id;
    
    if (1 == self.curIdx) then
        GetComponent(self.detailInfoUseTxt, "UILabel").text = 
            PropDataProxy.getPropName(_pCfg) .. "\n" .. PropDataProxy.getPropDesc(_pCfg);
        
        self.detailInfoUseTxt:SetActive(true);
        self.detailInfoShowTxt:SetActive(false);
    else
        GetComponent(self.detailInfoShowTxt, "UILabel").text = 
            PropDataProxy.getPropName(_pCfg) .. "\n" .. PropDataProxy.getPropDesc(_pCfg);
        
        self.detailInfoUseTxt:SetActive(false);
        self.detailInfoShowTxt:SetActive(true);
    end
    
    self.useBtn:SetActive(PropDataProxy.isCanUse(_pId, PropDataProxy.getPropType(_pCfg)));
    self.propSelectIcon:SetActive(true);
    HangObject(self.propSelectIcon, _go);
    self.propSelectIcon.transform.localPosition = Vector3.New(0, -1, 0);
end

--[[
    使用道具
    return nil
]]
function PropView:useProp ()
    local sendMap, bufData = Map.new(), nil;
    local myHerosNum = 0;

    myHerosNum = #TeamData.getMyHeros();

    if (myHerosNum >= GameCfgDataProxy.getMaxHeroNumPerTeam() and string.find(PropDataProxy.getAddHeroPropIds(), "," .. PropDataProxy.getMyPropById(self.curId).propId .. ",")) then
        ViewUtil.showMsg(string.gsub(const_maxHeroNum, "{1}", GameCfgDataProxy.getMaxHeroNumPerTeam()));
        return ;
    end

    sendMap:add(1, self.curId);--传道具的流水ID
    bufData = Network.reqParamEncode(sendMap);
    NetManager:SendData(self, bufData, ServerID.PropUseItem, nil, function (sd) self:usePropHandle(sd); end, "", doNthFunc);
end

--[[
    使用道具回调
    sd SessionData
    return nil
]]
function PropView:usePropHandle (sd)
    local def = nil;
    local pIdx = 0;
    
    def = GetProtoTable("DefaultData", sd);
    
    if (0 ~= def.code) then
        ViewUtil.showMsg(GetWord(def.code));
        return ;
    end
    for i = 1, self.pcData.propsData:getSize() do
        if (self.curId == self.pcData.propsData[i].id) then
            pIdx = i;
            break ;
        end
    end
    
    if (
        1007 ~= self.curPropId and
        1008 ~= self.curPropId and
        1009 ~= self.curPropId 
    ) then
        ViewUtil.showMsg(const_usePropSuccess);
    end

    if (0 ~= pIdx) then
        --道具数量处理
        local luaBhvi, psItem = nil, nil;
        luaBhvi = GetComponent(self.propList[pIdx].gameObject, "LuaBehaviour");
        if (nil ~= luaBhvi) then
            psItem = luaBhvi.sourceLuaObj;
            if (nil ~= psItem) then
                if (psItem.num <= 1) then
                    self.pcData.propsData:removeAt(pIdx);
                    self.propSelectIcon.transform.parent = self.allPropsGO.transform;
                    DestroyObject(self.propList[pIdx].gameObject);
                    self.propList:removeAt(pIdx);
                else
                    psItem:setNum(psItem.num - 1);
                end
            end
        end
        if (pIdx > self:getRealPropNum()) then
            pIdx = self:getRealPropNum();
        end
    end
    
    self:resetProp(pIdx);

    if (PlayerData.guideNotEnd()) then
        Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
    end
end

--[[
    删除道具后的处理
    pIdx number 道具的索引
    return nil
]]
function PropView:resetProp (pIdx)
    local luaBhvi, psItem = nil, nil;

    if (0 == pIdx) then
        self.propSelectIcon:SetActive(false);
        self.detailInfoUseTxt:SetActive(false);
        self.useBtn:SetActive(false);
    else
        for i = 1, self.propList:getSize() do
            luaBhvi = GetComponent(self.propList[i].gameObject, "LuaBehaviour");
            if (nil ~= luaBhvi) then
                psItem = luaBhvi.sourceLuaObj;
                if (nil ~= psItem) then
                    psItem:setNum(self.pcData.propsData[i].num);
                    
                    if (i == pIdx) then
                        self:propClick(psItem.propId, psItem.pCfg, psItem.id, psItem.gameObject);
                    end
                end
            end
        end
    end

    self:fillScrollViewWithProps();
end

--[[
    使用空道具图片，填满ScrollView
]]
function PropView:fillScrollViewWithProps ()
    local realPNum, addNum = 0, 0;
    local pGOTmp = nil;

    realPNum = self:getRealPropNum();

    --补全25个道具，或者补全一行5个道具
    if (realPNum < const_propShowBaseNum) then
        addNum = const_propShowBaseNum - self.propList.size;
    elseif (0 ~= realPNum % const_propNumPerLine) then
        addNum = (GetIntPart(realPNum / const_propNumPerLine) + 1) * const_propNumPerLine - self.propList.size;
    elseif (0 == realPNum % const_propNumPerLine) then
        addNum = (realPNum / const_propNumPerLine) * const_propNumPerLine - self.propList.size;
    end
    
    if (addNum > 0) then
        for i = 1, addNum do
            pGOTmp = CreateObject(self.propPrefab);
            GetComponent(pGOTmp, "UIPanel").sortingLayerName = LayerName.Dialog;
            HangObject(pGOTmp, self.grid);
            self.propList:add(pGOTmp);
        end
    elseif (0 > addNum) then
        while (addNum < 0) do
            addNum = addNum + 1;
            DestroyObject(self.propList[self.propList.size]);
            self.propList:removeAt(self.propList.size);
        end
    end
    ResetGrid(self.grid);
    ViewUtil.sortLayerOrder(self.scrollView);
    ViewUtil.sortLayerOrder(self.propSelectIcon);
end

--[[
    设置数据
    _pcData PropCusData
    return nil
]]
function PropView:setPCData (_pcData)
    self.pcData = _pcData;
end

--[[
    真实的道具数量
    return number 道具数量
]]
function PropView:getRealPropNum ()
    local realPNum = 0;

    if (self.pcData and self.pcData.propsData) then
        realPNum = self.pcData.propsData:getSize();
    end

    return realPNum;
end