--主角装备
--2016-11-22 00:00:00 iorinie

--更新选择时的属性显示（武器暂时没有属性）
--初始页面的显示方式，是否显示默认装备

RoleEquipView = class(BaseView)

function RoleEquipView:ctor()
end  

function RoleEquipView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.equipInfo = nil
	self.team = {}
	self.item = {}
	self.skillId = {}
	self.curSkill = ""
	self.curEquipId = nil
	self.prop = {}
	self.propLabel = {}

	self.equipsData = Config.getEquipsData()
	self:initPanel()
end

function RoleEquipView:Start(data)
	self:initData(data)
end

function RoleEquipView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)

	local topPath = "Mode/Top/Panel"
	self.btnPutOn = GetGameObject(self.transform, topPath.."/Info/BtnPutOn")			-- 穿上装备
	-- self.btnPutOnLabel = GetPathComponent(self.btnPutOn.transform, "Animation/Label", "UILabel")
	self.btnPutOnSpr = GetPathComponent(self.btnPutOn.transform, "Animation/TextSprite", "UISprite")
	self.equipNameLbl = GetPathComponent(self.transform, topPath.."/Info/EquipName", "UILabel")
	self.scvBG = GetGameObject(self.transform, topPath.."/ScrollViewBG")
	self.scvObj = GetGameObject(self.scvBG.transform, "ScrollView")
	self.gridObj = GetGameObject(self.scvObj.transform, "Panel/Grid")
	self.grid = GetPathComponent(self.scvObj.transform, "Panel/Grid", "UIGrid")
	self.scrollBar = GetGameObject(self.scvBG.transform, "ScrollBar")

	ViewUtil.adaptUISize(self.scvBG, true, 440, 90, 20, 20)
	ViewUtil.adaptUISize(self.scvObj, false, 460, 90, 20, 20)
	
	local sprStd = GetComponent(self.scvBG.transform, "UISprite")
	local sprFG = GetPathComponent(self.scrollBar.transform, "FG", "UISprite")
	local sprBG = GetPathComponent(self.scrollBar.transform, "BG", "UISprite")
	sprFG.height =  sprStd.height * 0.8
	sprBG.height =  sprStd.height * 0.8

	self.equip = GetGameObject(self.transform, topPath.."/Info/Equip")
	-- self.btnSpr = GetComponent(self.equip.transform, "UIButton")
	self.btnSpr = GetPathComponent(self.equip.transform, "Sprite", "UISprite")

	self.skillDesc = GetGameObject(self.transform, topPath.."/Info/SkillDesc")
	self.skillDescLabel = GetComponent(self.skillDesc.transform, "UILabel")

	self.equipBG = GetPathComponent(self.equip.transform, "BG", "UISprite")
	self.equipBG.color = Color.New(225, 225, 225, 225)

	for i = 1, 4 do
		self.prop[i] = GetGameObject(self.transform, topPath.."/Info/Prop"..i)
		self.propLabel[i] = GetComponent(self.prop[i].transform, "UILabel")
		self.propLabel[i].text = "0"
	end

	DelayCall(function()
      	local equiList = TeamData.GetRoleEquiList()
      	local skillsData = Config.getSkillsData()

      	--List需要优化
      	local weaponList = List:new()
      	local skillinfo = List:new()

      	for k, v in pairs(equiList) do
      		if v.type == 1 then --武器
      			weaponList:add(tostring(v.equId))
      		end
      	end

    	for i = 1, #weaponList do
    		self.item[i] = CreateObjectByPath("UI/ItemDrop", AssetBundleInfo.assetBundles)
			HangObject(self.item[i], self.gridObj)
			GetPathComponent(self.item[i].transform, "Sprite", "UISprite").spriteName = weaponList[i]

			local skillId = {}
			skillId[i] = tostring(self.equipsData[weaponList[i]].skill_id)
      		skillinfo:add(skillsData[skillId[i]])

			local function doClick(obj)
				if obj == self.item[i] then
					self.propLabel[1].text = self.equipsData[weaponList[i]].xg
					self.propLabel[2].text = self.equipsData[weaponList[i]].fy
					self.propLabel[3].text = self.equipsData[weaponList[i]].sb
					self.propLabel[4].text = self.equipsData[weaponList[i]].wz

					if GetPathComponent(obj.transform, "Sprite", "UISprite").spriteName == RoleEquipProxy.GetCurEquip() then
						-- self.btnPutOnLabel.text = "已装备"
						self.btnPutOnSpr.spriteName = "Equipped"
						Util.EnableButton(self.btnPutOn, ButtonState.Disabled, false)
					else
						-- self.btnPutOnLabel.text = "点击装备"
						self.btnPutOnSpr.spriteName = "ClickEquip"
						Util.EnableButton(self.btnPutOn, ButtonState.Normal, true)
					end
					self.curEquipId = tonumber(weaponList[i])
					self.btnSpr.spriteName = weaponList[i]

					self.equipNameLbl.text = self.equipsData[weaponList[i]].equi_name

					if skillinfo ~= nil then
						self.skillDescLabel.text = skillinfo[i].description
						self.curSkill = skillId[i]
					end
				end
			end
			ViewUtil.AddClickEvent(self.item[i], doClick)
		end
		ResetGrid(self.gridObj)
		ResetScrollView(self.scvObj)
	end, 0.2)
	
	local centerPath = "Mode/Center/Panel"

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)
		if obj == self.btnBack then
			self:closeView(true)
		elseif obj == self.btnPutOn then
			if self.btnSpr and self.btnSpr.spriteName ~= "alpha" then
    			local mapData = Map.new()
    			local newEqu = self.curEquipId
    			local oldEqu = RoleEquipProxy.GetCurEquip()
   				mapData:put("equiId", newEqu)
   				mapData:put("oldEquiId", oldEqu)
    			buf = Network.reqParamEncode(mapData)
    			if self.btnSpr.spriteName ~= RoleEquipProxy.GetCurEquip() then
					NetManager:SendData(self, buf, ServerID.Equip_Get, nil, function (sd) self:ChangeEquipHandle(sd,newEqu,oldEqu); end, nil ,doNthFunc)
				else
					ViewUtil.showMsg("已装备，请选择其他装备！")
				end
			else
				ViewUtil.showMsg("请选择装备！")
			end
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnPutOn).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnPutOn, doClick)
end

function RoleEquipView:ChangeEquipHandle(_sd,newEqu,oldEqu)
    local defData = nil;

    defData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return;
    end

	local oequ = TeamData.getRoleEqui(oldEqu);
	oequ.status = 0;
	local nequ = TeamData.getRoleEqui(newEqu);
	nequ.status = 1;

	-- self.btnPutOnLabel.text = "已装备"
	self.btnPutOnSpr.spriteName = "Equipped"
	ViewUtil.showMsg("装备成功！")
end

function RoleEquipView:initData(data)
	if IsEmpty(data) then return end
end