--主角信息
--2016-11-22 00:00:00 iorinie

RoleView = class(BaseView)

function RoleView:ctor()
end  

function RoleView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
    self.hData = nil;
    self.hCfg = nil;

	self.btnEquip = {}
	self.equi = {}

	self.skillsData = Config.getSkillsData()
	self.equipsData = Config.getEquipsData()

	self.selectSkillBoard = nil
	self.btnSkills = {}
	self.skillIds = {"", "", "", "", ""}

	self.defEquipId = ""

	self:GetEquipList()
	self:initPanel()
end

function RoleView:Start()
    self.hData = TeamData.getMyRoleHeroData();
    if (nil ~= self.hData) then
        self.hCfg = HeroDataProxy.getHeroCfgById(self.hData.heroId);
    end
    
    self:initData()
end

function RoleView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)

	local topPath = "Mode/Top/Panel"
	self.rolePanel = GetGameObject(self.transform, topPath.."/RolePanel")
	self.roleIcon = GetPathComponent(self.rolePanel.transform, "RoleSprite", "UISprite")
	self.roleName = GetPathComponent(self.rolePanel.transform, "RoleName", "UILabel")
	self.level = GetPathComponent(self.rolePanel.transform, "Level", "UILabel")
	self.intensify = GetPathComponent(self.rolePanel.transform, "Intensify", "UILabel")
	self.wiseup = GetPathComponent(self.rolePanel.transform, "Wiseup", "UILabel")
	self.fightValue = GetPathComponent(self.rolePanel.transform, "FightValue", "UILabel")
	
	self.prop1 = GetPathComponent(self.rolePanel.transform, "Prop1", "UILabel")
	self.prop2 = GetPathComponent(self.rolePanel.transform, "Prop2", "UILabel")
	self.prop3 = GetPathComponent(self.rolePanel.transform, "Prop3", "UILabel")
	self.prop4 = GetPathComponent(self.rolePanel.transform, "Prop4", "UILabel")

	self:initSkillBoard()

	self.roleName.text = "0"
	self.level.text = "0"
	self.intensify.text = "0"
	self.wiseup.text = "0"
	self.fightValue.text = "0"
	self.prop1.text = "0"
	self.prop2.text = "0"
	self.prop3.text = "0"
	self.prop4.text = "0"

	for i = 1, 4 do
		self.btnEquip[i] = GetGameObject(self.rolePanel.transform, "Equip"..i)
		self.equi[i] = GetComponent(self.btnEquip[i].transform, "UIButton")
		self.equi[i].normalSprite = "alpha"
	end

	self.btnIntensify = GetGameObject(self.rolePanel.transform, "BtnIntensify")		-- 强化
	self.btnUpgrade = GetGameObject(self.rolePanel.transform, "BtnUpgrade")		-- 升级
	self.roleContent = GetPathComponent(self.rolePanel.transform, "RoleContent", "UILabel")

	self.panelProp = GetGameObject(self.transform, topPath.."/PropPanel")	
	self.btnChange = GetGameObject(self.panelProp.transform, "BtnChange")			-- 更换装备
    self.item = GetGameObject(self.panelProp.transform, "item");

	self.equipDetailName = GetPathComponent(self.panelProp.transform, "EquipDetail/DescContent", "UILabel")
    self.equipDetailLbl = GetPathComponent(self.panelProp.transform, "EquipDetail/DescDetail", "UILabel")
    self.equipDetailIcon = GetPathComponent(self.panelProp.transform, "EquipDetail/DescDetail/Icon/Sprite", "UISprite")
    self.skillDetailName = GetPathComponent(self.panelProp.transform, "SkillDetail/DescContent", "UILabel")
    self.skillDetailLbl = GetPathComponent(self.panelProp.transform, "SkillDetail/DescDetail", "UILabel")
    self.skillDetailIcon = GetPathComponent(self.panelProp.transform, "SkillDetail/DescDetail/Icon/Sprite", "UISprite")
	
	ViewUtil.adaptUISize(self.panelProp, true, 580, 80, 20, 20)

	self.roleIcon.spriteName = TeamData.GetRoleLogo()

	local centerPath = "Mode/Center/Panel"

	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")

    local function doClick(obj)
		if obj == self.btnBack then
			ViewUtil.openView(ModuleName.MAIN)
		elseif obj == self.btnUpgrade then
			-- 直接传方法执行会有一部分变量没赋值，导致显示异常。 by iorinie
			ViewUtil.openView(ModuleName.HU, false, function(args)
				local ctrl = ModuleManager.GetCtrl(ModuleName.HU)
				-- ctrl.slideTab(1)
			end)
			-- ViewUtil.openView(ModuleName.HU, false)
		elseif obj == self.btnIntensify then
			ViewUtil.openView(ModuleName.HU, false, function(args)
				local ctrl = ModuleManager.GetCtrl(ModuleName.HU)
				ctrl.slideTab(2)
			end)
		elseif obj == self.btnChange then
            ViewUtil.openView(ModuleName.EQUIP)
		end
    end
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnIntensify, doClick)
	ViewUtil.AddClickEvent(self.btnUpgrade, doClick)
	ViewUtil.AddClickEvent(self.btnChange, doClick)
	
    local function doClickEquip(obj)
		local btnSpr = GetComponent(obj.transform, "UIButton")
		if btnSpr and btnSpr.normalSprite ~= "alpha" then
			--改成有装备的话一开始就选中 by iorinie
			-- if not self.selectBoard then
			-- 	self.selectBoard = CreateObject(Util.LoadPrefab("UI/SelectedEquipBoard"))
			-- 	ViewUtil.sortLayerOrder(self.selectBoard, LayerName.Broadcast)
			-- end
			-- HangObject(self.selectBoard, obj)

			if obj == self.btnEquip[1] then
				self:EquipSelected(1, btnSpr.normalSprite)
				self.btnChange:SetActive(true)
			elseif obj == self.btnEquip[2] then
				self:EquipSelected(2, btnSpr.normalSprite)
				self.btnChange:SetActive(false)
			elseif obj == self.btnEquip[3] then
				self:EquipSelected(3, btnSpr.normalSprite)
				self.btnChange:SetActive(false)
			elseif obj == self.btnEquip[4] then
				self:EquipSelected(4, btnSpr.normalSprite)
				self.btnChange:SetActive(false)
			end
		else
			ViewUtil.showMsg("尚未获得")
		end
    end
	ViewUtil.AddClickEvent(self.btnEquip[1], doClickEquip)
	ViewUtil.AddClickEvent(self.btnEquip[2], doClickEquip)
	ViewUtil.AddClickEvent(self.btnEquip[3], doClickEquip)
	ViewUtil.AddClickEvent(self.btnEquip[4], doClickEquip)

--    self:forCheckVersion();
end

function RoleView:EquipSelected(_index, _id)
	if self.equi[_index].normalSprite == "alpha" then return end

	DestroyObject(self.selectSkillBoard)
	self.selectSkillBoard = nil

	if not self.selectBoard then
		self.selectBoard = CreateObject(Util.LoadPrefab("UI/SelectedEquipBoard", AssetBundleInfo.assetBundles))
		ViewUtil.sortLayerOrder(self.selectBoard, LayerName.Broadcast)
	end
	HangObject(self.selectBoard, self.btnEquip[_index])

	self.equipDetailName.text = self.equipsData[_id].equi_name
	self.equipDetailLbl.text = self.equipsData[_id].desc
	self.equipDetailIcon.spriteName = _id
	self.skillDetailName.text = self.skillsData[tostring(self.equipsData[_id].skill_id)][g_skills_file_title]
    self.skillDetailLbl.text = self.skillsData[tostring(self.equipsData[_id].skill_id)].description
    self.skillDetailIcon.spriteName = self.skillsData[tostring(self.equipsData[_id].skill_id)][g_skills_file_skill_icon]
end

function RoleView:initSkillBoard()
	-- self.curSkillIds = {}
	self.btnSkills[1] = GetGameObject(self.rolePanel.transform, "Equip1/Skill1")
	self.btnSkills[2] = GetGameObject(self.rolePanel.transform, "Equip2/Skill2")
	self.btnSkills[3] = GetGameObject(self.rolePanel.transform, "Equip3/Skill3")
	self.btnSkills[4] = GetGameObject(self.rolePanel.transform, "Equip4/Skill4")

	self.sprSkills = {}
	for i = 1, 4 do
		self.sprSkills[i] = GetComponent(self.btnSkills[i].transform, "UIButton")
		self.sprSkills[i].normalSprite = "alpha"
	end

	if not IsEmpty(self.equiList) then
		self.equipIds = List:new()
		for k, v in ipairs(self.equiList) do
			self.equipIds:add(v.equId)
		end

		for i = 1, #self.equipIds do
			local skillId = self.equipsData[tostring(self.equipIds[i])].skill_id

			if skillId > 300000 and skillId < 300007 then
				if self.defEquipId ~= "" then --账号数据问题导致无默认武器 by iorinie
					local firstSkillId = tostring(self.equipsData[self.defEquipId].skill_id)
					self.sprSkills[1].normalSprite = self.skillsData[firstSkillId][g_skills_file_skill_icon]
					self.skillIds[1] = firstSkillId
				end
			elseif skillId == 300007 then
				self.sprSkills[2].normalSprite = self.skillsData[tostring(skillId)][g_skills_file_skill_icon]
				self.skillIds[2] = tostring(skillId)
			elseif skillId == 300008 then
				self.sprSkills[3].normalSprite = self.skillsData[tostring(skillId)][g_skills_file_skill_icon]
				self.skillIds[3] = tostring(skillId)
			elseif skillId == 300009 then
				self.sprSkills[4].normalSprite = self.skillsData[tostring(skillId)][g_skills_file_skill_icon]
				self.skillIds[4] = tostring(skillId)
			end
		end
	end

	--界面修改后，不需要长按技能的功能 by iorinie
	-- local function onPressSkills(tbl)
	-- 	if IsEmpty(tbl) then return end

	-- 	self.btnChange:SetActive(false)
	-- 	DestroyObject(self.selectBoard)
	-- 	self.selectBoard = nil

	-- 	local go = tbl.obj
	-- 	local isPress = tbl.isPress

	-- 	if go == self.btnSkills[1] then
	-- 		ViewUtil.showSkillTipsEvent(go, isPress, self.skillIds[1])
	-- 		self:SkillSelected(1, self.skillIds[1])
	-- 	elseif go == self.btnSkills[2] then
	-- 		ViewUtil.showSkillTipsEvent(go, isPress, self.skillIds[2])
	-- 		self:SkillSelected(2, self.skillIds[2])
	-- 	elseif go == self.btnSkills[3] then
	-- 		ViewUtil.showSkillTipsEvent(go, isPress, self.skillIds[3])
	-- 		self:SkillSelected(3, self.skillIds[3])
	-- 	elseif go == self.btnSkills[4] then
	-- 		ViewUtil.showSkillTipsEvent(go, isPress, self.skillIds[4])
	-- 		self:SkillSelected(4, self.skillIds[4])
	-- 	end
	-- end
	-- for i, btn in pairs(self.btnSkills) do
	-- 	ViewUtil.AddEventTrigger(btn, EventConst.onPress, onPressSkills, {isPress = true, obj = btn, idx = i})
	-- 	ViewUtil.AddEventTrigger(btn, EventConst.onRelease, onPressSkills, {isPress = false, obj = btn, idx = i})
	-- end
end

function RoleView:SkillSelected(_index, _id)
	if self.sprSkills[_index].normalSprite == "alpha" then return end

	if self.selectSkillBoard == nil then
		self.selectSkillBoard = CreateObject(Util.LoadPrefab("UI/SelectedSkillBoard", AssetBundleInfo.assetBundles))
		ViewUtil.sortLayerOrder(self.selectSkillBoard, LayerName.Broadcast)
	end
	HangObject(self.selectSkillBoard, self.btnSkills[_index])

	self.descContent.text = self.skillsData[_id][g_skills_file_title]
	self.descDetail.text = self.skillsData[_id].description
end

--[[
    审核版本屏蔽
]]
function RoleView:forCheckVersion ()
    self.btnEquip[1]:SetActive(false);
    self.btnEquip[2]:SetActive(false);
    self.btnEquip[3]:SetActive(false);
    self.btnEquip[4]:SetActive(false);
    self.btnChange:SetActive(false);
    self.item:SetActive(false);
end

function RoleView:initData()
--	if IsEmpty(data) then return end
	local totalXg = 0
	local totalFy = 0
	local totalSb = 0
	local totalWz = 0

	if not IsEmptyTable(self.equiList) then
		if self.defEquipId ~= "" then
			self.equi[1].normalSprite = self.defEquipId
			RoleEquipProxy.SetCurEquip(self.defEquipId)
			self:EquipSelected(1, self.equi[1].normalSprite)
			self.btnChange:SetActive(true)
		end

		if not IsEmpty(self.zjList) then
			self.equi[2].normalSprite = self.zjList[1]
			totalXg = totalXg + self.equipsData[self.zjList[1]].xg
			totalFy = totalFy + self.equipsData[self.zjList[1]].fy
			totalSb = totalSb + self.equipsData[self.zjList[1]].sb
			totalWz = totalWz + self.equipsData[self.zjList[1]].wz
		end
		if not IsEmpty(self.hfList) then
			self.equi[3].normalSprite = self.hfList[1]
			totalXg = totalXg + self.equipsData[self.hfList[1]].xg
			totalFy = totalFy + self.equipsData[self.hfList[1]].fy
			totalSb = totalSb + self.equipsData[self.hfList[1]].sb
			totalWz = totalWz + self.equipsData[self.hfList[1]].wz
		end
		if not IsEmpty(self.zqList) then
			self.equi[4].normalSprite = self.zqList[1]
			totalXg = totalXg + self.equipsData[self.zqList[1]].xg
			totalFy = totalFy + self.equipsData[self.zqList[1]].fy
			totalSb = totalSb + self.equipsData[self.zqList[1]].sb
			totalWz = totalWz + self.equipsData[self.zqList[1]].wz
		end
	-- else
	-- 	plog("can't get equip info!!!!!")
	end

	self.prop1.text = "" .. totalXg
	self.prop2.text = "" .. totalFy
	self.prop3.text = "" .. totalSb
	self.prop4.text = "" .. totalWz
	
    if (nil ~= self.hData) then
    	self.roleName.text = ""..TeamData.GetRoleName()
        self.intensify.text = ""..self.hData.strengthen;
        self.level.text = HeroDataProxy.getHeroShowLvl(self.hData.level, self.hData.wiseup);
        self.wiseup.text = ""..(self.hData.wiseup);
        self.fightValue.text = ""..TeamData.GetCurRolePower()

        self.roleContent.text = HeroDataProxy.getHeroContent(self.hCfg)
    end
end

function RoleView:GetEquipList()
	self.equiList = TeamData.GetRoleEquiList()
	if not IsEmpty(self.equiList) then
		for i = 1, #self.equiList do
			if self.equiList[i].type == 1 then
				if self.equiList[i].status == 1 then
					self.defEquipId = tostring(self.equiList[i].equId) or ""
				end
			elseif self.equiList[i].type == 2 then
				self.zjList = List:new()
				self.zjList:add(tostring(self.equiList[i].equId))
			elseif self.equiList[i].type == 3 then
				self.hfList = List:new()
				self.hfList:add(tostring(self.equiList[i].equId))
			elseif self.equiList[i].type == 4 then
				self.zqList = List:new()
				self.zqList:add(tostring(self.equiList[i].equId))
			end
		end
	end
end