--系统设置
--2016-8-5 14:33:58 library

local const_quaAndAnsrText = "问题反馈";
local const_logOutText = "登 出";
local const_bgSoundTitle = "音乐";
local const_btnSoundTitle = "音效";
local const_close = "关";
local const_open = "开";
local const_effect = "着呢";

SettingView = class(BaseView);


function SettingView:ctor(BaseView)

end  

function SettingView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.shadeOpacity = true

    self.closeBtn = nil;
    self.quaAndAnsr = nil;
    self.quaAndAnsrText = nil;
    self.logOut = nil;
    self.logOutText = nil;
    self.bgSound = nil;
    self.bgSoundBtn = nil;
    self.btnSound = nil;
    self.btnSoundBtn = nil;
end

--[[

]]
function SettingView:initSetting ()
    self:initPanel();
    self:initListener();
    self:setInfo();
end

--[[

]]
function SettingView:initPanel ()
    self.closeBtn = GetGameObject(self.transform, "Container/closeBtn");
    self.quaAndAnsr = GetGameObject(self.transform, "Container/quaAndAnsr");
    self.quaAndAnsrText = GetGameObject(self.quaAndAnsr.transform, "text");
    self.logOut = GetGameObject(self.transform, "Container/logOut");
    self.logOutText = GetGameObject(self.logOut.transform, "text");

    self.bgSoundBtn = GetGameObject(self.transform, "Container/sound/bgSound/btn");
    self.bgSoundBg = GetGameObject(self.transform, "Container/sound/bgSound/BG");
    self.btnSoundBtn = GetGameObject(self.transform, "Container/sound/btnSound/btn");
    self.btnSoundBg = GetGameObject(self.transform, "Container/sound/btnSound/BG"); 

    GetComponent(self.quaAndAnsrText, "UILabel").text = const_quaAndAnsrText;
    GetComponent(self.logOutText, "UILabel").text = const_logOutText;
	
	self.checkBox = GetGameObject(self.transform, "Container/CheckBox")
	self.selectFB = GetGameObject(self.transform, "Container/CheckBox/SelectFB")
	self.selectFB:SetActive(not PlayerData.GetRefuseFriendNotice())

end

function SettingView:initListener ()
    -- UIEventListener.Get(self.closeBtn).onClick = function () self:exitSetting(); end
    -- UIEventListener.Get(self.bgSoundBtn).onClick = function () self:setBG(); end
    -- UIEventListener.Get(self.bgSoundBg).onClick = function () self:setBG(); end
    -- UIEventListener.Get(self.btnSoundBtn).onClick = function () self:setBtn(); end
    -- UIEventListener.Get(self.btnSoundBg).onClick = function () self:setBtn(); end
    -- UIEventListener.Get(self.quaAndAnsr).onClick = function () self:qaHandle(); end
    -- UIEventListener.Get(self.logOut).onClick = function () self:logOutHandle(); end
    ViewUtil.AddClickEvent(self.closeBtn, function () self:exitSetting(); end)
    ViewUtil.AddClickEvent(self.bgSoundBtn, function () self:setBG(); end)
    ViewUtil.AddClickEvent(self.bgSoundBg, function () self:setBG(); end)
    ViewUtil.AddClickEvent(self.btnSoundBtn, function () self:setBtn(); end)
    ViewUtil.AddClickEvent(self.btnSoundBg, function () self:setBtn(); end)
    ViewUtil.AddClickEvent(self.quaAndAnsr, function () self:qaHandle(); end)
    ViewUtil.AddClickEvent(self.logOut, function () self:logOutHandle(); end)

	local function doClick(obj)
		if obj == self.checkBox then
			local refuse = not PlayerData.GetRefuseFriendNotice()
			PlayerData.SetRefuseFriendNotice(refuse)
			self.selectFB:SetActive(not refuse)
			if refuse then
				Network.SendMoData(ServerID.FriendReject, {0}) -- 拒绝好友申请
			else
				Network.SendMoData(ServerID.FriendReject, {1}) -- 同意好友申请
			end
		end
	end
	-- UIEventListener.Get(self.checkBox).onClick = doClick
    ViewUtil.AddClickEvent(self.checkBox, doClick)
end

--[[

]]
function SettingView:setInfo ()
    local soundBG, soundBtn = nil, nil;

    soundBG = SimpleCache.getCacheVal(SimpleCache.soundBG);
    soundBtn = SimpleCache.getCacheVal(SimpleCache.soundBtn);

    if ("1" ~= soundBG and "0" ~= soundBG) then
        soundBG = "1";
        SimpleCache.setCache(SimpleCache.soundBG, soundBG);
    end

    if ("1" ~= soundBtn and "0" ~= soundBtn) then
        soundBtn = "1";
        SimpleCache.setCache(SimpleCache.soundBtn, soundBtn);
    end
    
    self:soundBGChge(soundBG);
    self:soundBtnChge(soundBtn);
end

--[[

]]
function SettingView:soundBGChge (_val)
    local trans, newTrans = nil, nil;

    trans = self.bgSoundBtn.transform.localPosition;
    
    if (1 == tonumber(_val)) then
        newTrans = Vector3.New(56, trans.y, trans.z);
    else
        newTrans = Vector3.New(2, trans.y, trans.z);
    end
    
    self.bgSoundBtn.transform.localPosition = newTrans;
end

--[[

]]
function SettingView:soundBtnChge (_val)
    local trans, newTrans = nil, nil;

    trans = self.btnSoundBtn.transform.localPosition;
    
    if (1 == tonumber(_val)) then
        newTrans = Vector3.New(56, trans.y, trans.z);
    else
        newTrans = Vector3.New(2, trans.y, trans.z);
    end
    
    self.btnSoundBtn.transform.localPosition = newTrans;
end

--[[

]]
function SettingView:exitSetting ()
    ViewManager.CloseModule(ModuleName.SETTING, true);
end

--[[

]]
function SettingView:qaHandle ()
    
end

--[[

]]
function SettingView:logOutHandle ()
	Access.DoLogout()
end

--[[

]]
function SettingView:setBG ()
    local soundBG = nil;

    soundBG = SimpleCache.getCacheVal(SimpleCache.soundBG);

    if ("1" == soundBG) then
        soundBG = "0";
    else 
        soundBG = "1";
    end
    
    SimpleCache.setCache(SimpleCache.soundBG, soundBG);
    self:soundBGChge(soundBG);
    self:setBGM(soundBG)
end

function SettingView:setBGM(_val)
    AudioConst.SetBgmStatus(_val)
    if tonumber(_val) ~= 1 then
        SimpleAudio.StopMusic(doNthFunc)
    end

    SimpleAudio.PlayMusic("main")
end
--[[

]]
function SettingView:setBtn ()
    local soundBtn = nil;

    soundBtn = SimpleCache.getCacheVal(SimpleCache.soundBtn);

    if ("1" == soundBtn) then
        soundBtn = "0";
    else
        soundBtn = "1";
    end
    
    SimpleCache.setCache(SimpleCache.soundBtn, soundBtn);
    self:soundBtnChge(soundBtn);
    AudioConst.SetEffectStatus(soundBtn)
end