--商城模块
--2016-8-5 15:25:02 library

require "Game/Shop/View/ShopView"
require "Game/Shop/View/ShopSellRow"

ShopControler = {
    
}

local this = ShopControler;

--[[

]]
function ShopControler.New ()
    return this;
end

--[[

]]
function ShopControler.OnCreate (_go, _name)
    this.gameObject = _go;
    this.transform = this.gameObject.transform;
    this.view = ShopView.new();
    this.view.name = _name;
    this.view:Awake(this.gameObject);
    this.root = ViewUtil.getRootView();
    
    HangObject(this.view, this.root);
    this.request();
end

--[[

]]
function ShopControler.Start ()

end

--[[

]]
function ShopControler.OnDestroy ()
    this.view = nil;
    this.gameObject = nil;
end

--[[
    打开商店
    _tp number 0，钻石商店；1，友情商店
]]
function ShopControler.request (_tp)
    local mapData, buffer, svcId = nil, nil, nil;
    
    _tp = _tp or 0;
    mapData = Map.new();

    buffer = Network.reqParamEncode(mapData);
    
    if (0 == _tp) then
        svcId = ServerID.ShopDiamondEty;
    else
        svcId = ServerID.ShopFriendEty;
    end
    
    NetManager:SendData(this, buffer, svcId, ModuleName.SHOP, function (sd) this.accept(sd, _tp); end, nil, doNthFunc);
end

--[[

]]
function ShopControler.accept (_sessionData, _tp)
    local dataStr, shopData = nil, nil;
    
    ViewUtil.closeLoading();
    
    if (0 == _tp) then
        dataStr = "DiamondsShopMainData";
    else
        dataStr = "FriendShopMainData";
    end
    
    shopData = GetProtoTable(dataStr, _sessionData);
    
    this.view:setData(shopData.propList, _tp);
end

--[[

]]
function ShopControler.listNotificationInterests ()
    local notes = {
        MVCConst.SHOP_BUYPROPNOTI,
        MVCConst.SHOP_OPEN, 
        MVCConst.UPDATE_MNY
    };

    return unpack(notes);
end

--[[

]]
function ShopControler.handleNotification (_note)
    local nName = _note:getName();
    local nBody = _note:getBody();
    local nType = _note:getType();
    
    if (MVCConst.SHOP_BUYPROPNOTI == nName) then
        this.view:buyCfm(nBody[1], nBody[2]);
    elseif (MVCConst.SHOP_OPEN == nName) then
        this.request(nBody[1]);
    elseif (MVCConst.UPDATE_MNY == nName) then
        this.view:refreshFriMny();
    end
end
