--出售商品
--2016-8-5 17:31:52 library

local const_buyBtnText = "购 买";
local const_diamond = "血钻";
local const_friend = "友情点";

ShopSellRow = class();

--[[

]]
function ShopSellRow:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.propName = nil;
    self.propPrice = nil;
    self.propDesc = nil;
    self.buyBtn = nil;
    self.buyBtnLabel = nil;
    self.item = nil;
    self.mnyIcon = nil;
    self.friIcon = nil;

    self.propItem = nil;

    self.propData = nil;
    self.pCfg = nil;
    self.propId = -1;
    self.price = -1;
    self.desc = "";
end

--[[

]]
function ShopSellRow:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;

    self:initPanel();
    self:initListener();
end

--[[

]]
function ShopSellRow:initPanel ()
    self.propName = GetGameObject(self.transform, "propName");
    self.propPrice = GetGameObject(self.transform, "propPrice");
    self.propDesc = GetGameObject(self.transform, "propDesc");
    self.buyBtn = GetGameObject(self.transform, "buyBtn");
    self.buyBtnLabel = GetGameObject(self.buyBtn.transform, "text");
    self.item = GetGameObject(self.transform, "Item");

    self.mnyIcon = GetGameObject(self.transform, "PriceIcon/MnyIcon");
    self.friIcon = GetGameObject(self.transform, "PriceIcon/FriIcon");

    GetComponent(self.buyBtnLabel, "UILabel").text = const_buyBtnText;
end

--[[

]]
function ShopSellRow:initListener ()
    -- UIEventListener.Get(self.buyBtn).onClick = function () self:buyFunc(); end
    ViewUtil.AddClickEvent(self.buyBtn, function () self:buyFunc(); end)
end

--[[

]]
function ShopSellRow:buyFunc ()
    Facade:sendNotification(MVCConst.SHOP_BUYPROPNOTI, {[1] = self.propId, [2] = self.price});
end

--[[

]]
function ShopSellRow:setData (_pData, _tp)
    self.tp = _tp;
    self.propData = _pData;
    self.propId = self.propData.propId;
    self.pCfg = PropDataProxy.getPropCfgById(self.propId);
    self.desc = PropDataProxy.getPropDesc(self.pCfg);

    if (0 == _tp) then
        self.price = self.propData.diamonds;
    else
        self.price = self.propData.friend;
    end

--    self.gameObject:SetActive(true);

    self:drawRow(_tp);
end

--[[

]]
function ShopSellRow:drawRow (_tp)
    local luaBhvi, psItem, pCfg = nil, nil, nil;
    local priceName = "";
    
    if (nil == self.propItem) then
        self.propItem = CreateObject(Util.LoadPrefab("UI/PropItem", AssetBundleInfo.assetBundles));
        GetComponent(self.propItem, "UIPanel").sortingLayerName = LayerName.UI;
        HangObject(self.propItem, self.item);
        self.propItem.transform.localScale = Vector3.New(0.8, 0.8, 1);
        ViewUtil.sortLayerOrder(self.item);
    end

    luaBhvi = GetComponent(self.propItem, "LuaBehaviour");
    if (nil ~= luaBhvi) then
        psItem = luaBhvi.sourceLuaObj;
    end

    if (nil == psItem) then
        psItem = PropShowItem.new();
        psItem:Awake(self.propItem, self.propId, 1);
        psItem:Start();
        PanelManager:BindPanelScript(psItem, self.propItem, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    end

    psItem:setData(self.propId, 1);

    if (0 == _tp) then
        self.mnyIcon:SetActive(true);
        self.friIcon:SetActive(false);
    else
        self.mnyIcon:SetActive(false);
        self.friIcon:SetActive(true);
    end

    pCfg = psItem.pCfg;
    GetComponent(self.propName, "UILabel").text = PropDataProxy.getPropName(pCfg);
    GetComponent(self.propPrice, "UILabel").text = "" .. self.price;
    GetComponent(self.propDesc, "UILabel").text = self.desc;
end

--[[
    _isActive boolean
]]
function ShopSellRow:SetGOActive (_isActive)
    _isActive = _isActive or false;
    self.gameObject:SetActive(_isActive);
end