--商城View
--2016-8-5 15:25:15 library

local const_prop = "道具商店";
local const_fri = "友情商店";
local const_diamond = "血钻";
local const_friend = "友情点";
local const_buyCfm = "购买 {1} 个 {2}，消耗 {3}{4}";
local const_buySuccess = "购买成功";
local const_notEnough = "不足";

local const_btnNormal = "prop_tabNormalBG";
local const_btnSlt = "prop_tabChoseBG";

ShopView = class(BaseView);

--[[

]]
function ShopView:ctor ()
    self.gameObject = nil;
    self.transform = nil;

    self.baseRow = nil;
    self.backBtn = nil;
    self.propBtn = nil;
    self.friBtn = nil;
    self.scrollView = nil;
    self.gridGO = nil;
    self.grid = nil;

    self.tp = -1;--当前商店类型：0，道具商店；1，友情商店

    self.diamondData = nil;
    self.friendData = nil;
    self.rowList = List.new();--待售商品列表
end

--[[

]]
function ShopView:Awake (_go)
    self.gameObject = _go;
    self.transform = self.gameObject.transform;
    
    self:initPanel();
    self:initListener();
end

--[[

]]
function ShopView:initPanel ()
    self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget");
    self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget");
    self.top:SetAnchor(self.root.transform);
	self.bottom:SetAnchor(self.root.transform);

    self.backBtn = GetGameObject(self.transform, "Mode/Bottom/Panel/backBtn");
    self.propBtn = GetGameObject(self.transform, "Mode/Top/Panel/tabContainer/propBtn");
    self.friBtn = GetGameObject(self.transform, "Mode/Top/Panel/tabContainer/friBtn");

    self.myFriMny = GetGameObject(self.transform, "Mode/Bottom/Panel/myFriMny");
    self.friMny = GetGameObject(self.myFriMny.transform, "mny");

    self.scrollView = GetGameObject(self.transform, "Mode/Top/Panel/ScrollView");
    self.gridGO = GetGameObject(self.scrollView.transform, "Grid");
    self.uiGrid = GetComponent(self.gridGO, "UIGrid");
    self.baseRow = GetGameObject(self.scrollView.transform, "SellRow");
    self.baseRow:SetActive(false);
	ViewUtil.adaptUISize(self.scrollView, false, 180, 5, 0, 0)

    GetComponent(self.friMny, "UILabel").text = PlayerData.getMyFriendMny();

--    GetPathComponent(self.propBtn.transform, "text", "UILabel").text = const_prop;
--    GetPathComponent(self.friBtn.transform, "text", "UILabel").text = const_fri;
end

--[[

]]
function ShopView:initListener ()
    -- UIEventListener.Get(self.backBtn).onClick = function () self:backFunc(); end;
    -- UIEventListener.Get(self.propBtn).onClick = function () self:showSellProps(); end;
    -- UIEventListener.Get(self.friBtn).onClick = function () self:showSellProps(1); end;
    ViewUtil.AddClickEvent(self.backBtn, function () self:backFunc(); end)
    ViewUtil.AddClickEvent(self.propBtn, function () self:showSellProps(); end)
    ViewUtil.AddClickEvent(self.friBtn, function () self:showSellProps(1); end)
end

--[[

]]
function ShopView:showSellProps (_tp)
    local needData = nil;

    _tp = _tp or 0;

    if (0 == _tp) then
        needData = self.diamondData;
    else
        needData = self.friendData;
    end
    
    if (nil == needData) then
        Facade:sendNotification(MVCConst.SHOP_OPEN, {[1] = _tp});
    else
        self:chgeTab(_tp);
    end
end

--[[

]]
function ShopView:chgeTab (_tp)
    local propBtnSprite, friendBtnSprite = "", "";
    
    if (_tp == self.tp) then
        return ;
    end

    self.tp = _tp;
    
    if (0 == _tp) then
        propBtnSprite = const_btnSlt;
        friendBtnSprite = const_btnNormal;
        
        GetComponent(self.propBtn, "UIButton").enabled = false;
        GetComponent(self.friBtn, "UIButton").enabled = true;
        self.myFriMny:SetActive(false);
    else
        propBtnSprite = const_btnNormal;
        friendBtnSprite = const_btnSlt;
        
        GetComponent(self.propBtn, "UIButton").enabled = true;
        GetComponent(self.friBtn, "UIButton").enabled = false;
        self.myFriMny:SetActive(true);
    end
    
    GetPathComponent(self.propBtn.transform, "Sprite", "UISprite").spriteName = propBtnSprite;
    GetPathComponent(self.friBtn.transform, "Sprite", "UISprite").spriteName = friendBtnSprite;

    self:drawPanel();
end

--[[

]]
function ShopView:drawPanel ()
    local rowData, sellRow, rowTmp, dataTmp = nil, nil, nil, nil;
    local rowListLen, drawCnt, rowDataCnt = 0, 0, 0;
    local transTmp = nil;

    rowListLen = self.rowList:getSize();
    self.uiGrid.enabled = false;
    self.scrollView:SetActive(false);
    
    if (0 == self.tp) then
        rowData = self.diamondData;
    else
        rowData = self.friendData;
    end
    
    rowDataCnt = #rowData;
    
    --绘制出售商品
    for i = 1, rowDataCnt do
        dataTmp = rowData[i];
        drawCnt = drawCnt + 1;

        if (i > #self.rowList) then
            --rowList中的Row不够用，生成新的Row，存入rowList
            rowTmp = CreateObject(self.baseRow);
            sellRow = ShopSellRow.new();
            sellRow:Awake(rowTmp);
            PanelManager:BindPanelScript(sellRow, rowTmp, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
            self.rowList:add(sellRow);
        else
            sellRow = self.rowList[i];
        end
        sellRow:setData(rowData[i], self.tp);
        sellRow:SetGOActive(true);
        HangObject(sellRow.gameObject, self.gridGO);
    end

    --移出并隐藏rowList中多余的Row
    for i = drawCnt + 1, self.rowList:getSize() do
        sellRow = self.rowList[i];
        HangObject(sellRow.gameObject, self.scrollView.transform.parent.gameObject);
        sellRow:SetGOActive(false);
    end
    
    ResetGrid(self.gridGO);
    self.scrollView:SetActive(true);
    ResetScrollView(self.scrollView);
end

--[[

]]
function ShopView:setData (_data, _tp)
    if (0 == _tp) then
        self.diamondData = _data;
    else
        self.friendData = _data;
    end
    
    self:chgeTab(_tp);
end

--[[

]]
function ShopView:buyCfm (_id, _price)
    local mnyStr, buyCfm, sId = "", "", 0;
    local pCfg = PropDataProxy.getPropCfgById(_id);
    local cncPanel = nil;
        
    if (0 == self.tp) then
        mnyStr = const_diamond;
        sId = ServerID.ShopDiamondBuy;
    else
        mnyStr = const_friend;
        sId = ServerID.ShopFriendBuy;
    end

    buyCfm = string.gsub(const_buyCfm, "{1}", 1);
    buyCfm = string.gsub(buyCfm, "{2}", PropDataProxy.getPropName(pCfg));
    buyCfm = string.gsub(buyCfm, "{3}", _price);
    buyCfm = string.gsub(buyCfm, "{4}", mnyStr);

    local okFunc, cancelFunc, numChgeFunc = function (_num) 
        local buf, mapData, myMny = nil, Map.new(), 0;
        
        mapData:put("propId", _id);
        mapData:put("num", _num);
        buf = Network.reqParamEncode(mapData);
        
        if (0 == self.tp) then
            myMny = PlayerData.getMyDiamond();
        else
            myMny = PlayerData.getMyFriendMny();
        end
        if (tonumber(_num) * tonumber(_price) > myMny) then
            ViewUtil.showMsg(mnyStr .. const_notEnough);
            return ;
        end
        NetManager:SendData({}, buf, sId, ModuleName.SHOP, function (sd) self:afterBuyProp(sd); end, nil, doNthFunc);
    end,
    doNthFunc,
    function (_num)
        buyCfm = string.gsub(const_buyCfm, "{1}", _num);
        buyCfm = string.gsub(buyCfm, "{2}", PropDataProxy.getPropName(pCfg));
        buyCfm = string.gsub(buyCfm, "{3}", _price * _num);
        buyCfm = string.gsub(buyCfm, "{4}", mnyStr);
        
        return buyCfm;
    end

    ViewUtil.comNumChgePanel(buyCfm, okFunc, cancelFunc, numChgeFunc);
end

--[[

]]
function ShopView:afterBuyProp (_sd)
    local defaultData = nil;

    defaultData = GetProtoTable("DefaultData", _sd);

    if (0 ~= defaultData.code) then
        ViewUtil.showMsg(GetWord(defaultData.code));
        return ;
    end

    ViewUtil.showMsg(const_buySuccess);
    GetComponent(self.friMny, "UILabel").text = PlayerData.getMyFriendMny();
end

--[[

]]
function ShopView:backFunc ()
    ViewUtil.closeView(ModuleName.SHOP, true);
end

--[[

]]
function ShopView:refreshFriMny ()
    GetComponent(self.friMny, "UILabel").text = PlayerData.getMyFriendMny();
end