
SignInView = class(BaseView)

local const_notSigned = "签 到";
local const_hasSigned = "已签到";
local const_lackOfSumDays = "累计签到次数不足";
local const_getSuccess = "领取成功";
local const_get = "w_gain";
local const_got = "w_got";

function SignInView:ctor()
end  

function SignInView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.daysCount = 0
	self.days = {}
	self.rewards = {}
    self.goods = {};
    self.data = nil;
    self.btnGet = nil;
    self.curIdx = 0;
	self:initPanel()
end

function SignInView:Start(data)
--	self:initData(data)
end

function SignInView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"

	local centerPath = "Mode/Center/Panel"
		
	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")
	self.btnSignIn = GetGameObject(self.transform, bottomPath.."/SignBG/BtnSignIn")
    self.signSpr = GetPathComponent(self.btnSignIn.transform, "Animation/Sign", "UISprite")
 	self.grid = GetGameObject(self.transform, bottomPath.."/SignBG/Days")
    self.btnGet = GetGameObject(self.transform, bottomPath.."/RewardsBG/Content/Panel/BtnGet");
	self.signAmount = GetPathComponent(self.transform, bottomPath.."/SignBG/SignAmount", "UILabel")

    for i = 1, 5 do
        table.insert(self.goods, GetGameObject(self.transform, bottomPath .. "/RewardsBG/Content/Panel/Grid/Good" .. i));
    end
    --不再显示当月全勤的奖励 2016-10-18 19:29:11 library
	self.btnTabs = {}
    self.tabRedIcons = {}
    local function _onTabs(obj)
		
		for i = 1, 5 do
			if obj == self.btnTabs[i] then
				--显示奖励
                self:showSumSignRwd(i);
                break ;
			end
		end
	end
    
	for i = 1, 5 do
		local btn = GetGameObject(self.transform, bottomPath.."/RewardsBG/Grid/Tab"..i)
		-- UIEventListener.Get(btn).onClick = _onTabs
        ViewUtil.AddClickEvent(btn, _onTabs)
		self.btnTabs[i] = btn
        self.tabRedIcons[i] = GetGameObject(btn.transform, "Animation/redIcon")
	end

    local function doClick(obj)
        if (obj == self.btnGet) then
            self:getSumRwd();
		elseif obj == self.btnBack then
			self:closeView(true)
		elseif obj == self.btnSignIn then
			self:signInToday()
		end
    end

 --    UIEventListener.Get(self.btnGet).onClick = doClick
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnSignIn).onClick = doClick
    ViewUtil.AddClickEvent(self.btnGet, doClick)
    ViewUtil.AddClickEvent(self.btnBack, doClick)
    ViewUtil.AddClickEvent(self.btnSignIn, doClick)

    self:setSignBtnState();
end

--[[

]]
function SignInView:setSignBtnState ()
    local label = GetPathComponent(self.btnSignIn.transform, "Animation/Title", "UILabel");
    local isSign = false;

    isSign = self:checkTadaysSignStatus();

    if (isSign) then
        -- label.text = const_hasSigned; --改为使用图片，不直接修改文本
        self.signSpr.spriteName = "Signed"
        -- Util.EnableButton2D(self.btnSignIn, 3, false);
        Util.EnableButton(self.btnSignIn, ButtonState.Disabled, false);
    else
        -- label.text = const_notSigned;
        self.signSpr.spriteName = "Sign"
    end
end

--[[
    显示累计签到奖励
    _idx 累计签到索引
]]
function SignInView:showSumSignRwd (_idx)
    local rwd = "";
    local layer, tab, rwdTab = 0, nil, {};
    local good = nil;
    
    self.curIdx = _idx;
    rwd = SignInDataProxy.getSumSignRwd(_idx);
    tab, layer = LogicUtil.splitStrCfgs(rwd);
    
    LogicUtil.planishRwd(rwdTab, tab, layer);
    
    for i = 1, #rwdTab do
        if (i <= #self.goods) then
            local luaBhvi, propShowItem = nil, nil;
            
            good = self.goods[i];
            good:SetActive(true);
            luaBhvi = GetComponent(good, "LuaBehaviour");
            if (nil ~= luaBhvi) then
                propShowItem = luaBhvi.sourceLuaObj;
            end
            if (nil == propShowItem) then
                propShowItem = PropShowItem.new();
                PanelManager:BindPanelScript(propShowItem, good, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
            end
            
            propShowItem:Awake(good, rwdTab[i][1], rwdTab[i][2]);
            propShowItem:Start();
        end
    end

    for i = #rwdTab + 1, #self.goods do
        self.goods[i]:SetActive(false);
    end

    local tDays, curDays = self:getSumSignCnts();
    self:checkRwd(tDays, curDays);
end

-- 今日签到
function SignInView:signInToday()
	local function _callback(session)
		local mo = GetProtoTable("DefaultData", session)
        local totalCnt, sumSignCnt = self:getSumSignCnts();
		if mo.code == 0 then
            sumSignCnt = sumSignCnt + 1;
			ViewUtil.showMsg("签到成功，获得普通英雄包*1")
--			Network.ReqSignInWnd()
			SignInControler.request()
		else
			ViewUtil.showMsg("今日已签到")
		end
        self:checkRwd(totalCnt, sumSignCnt);
        self:setSignBtnState();
	end
	Network.SendMoData(ServerID.SignInToday, {}, _callback)
end

function SignInView:initData(data)
	if IsEmpty(data) then return end
    
    self.data = data;
	
    local daysInfo = split(data.msg, ",")
	local rewardsStage = tonumber(data.code) or 0
    self.daysCount = 0;
	if self.daysCount > 0 then
		for i = 1, self.daysCount do
			local day = GetGameObject(self.grid.transform, "Day"..i)
			if day ~= nil then
				local num = tonumber(daysInfo[i])
				if num == 1 then
					local old = GetGameObject(day.transform, "SignIned")
					if not old then
						local signed = CreateObjectByPath("UI/SignIned", AssetBundleInfo.assetBundles)
						signed.name = "SignIned"
						HangObject(signed, day)
					end
				end
			end
		end
	else
		self.daysCount = self:getSumSignCnts();
		self.signedDays = 0
        
		local function _onDays(obj)
			if obj.eType == EventConst.onPress then
				local rwObj = CreateObjectByPath("UI/SignInRewards", AssetBundleInfo.assetBundles)
				HangObject(rwObj, self.days[obj.index])
				local anim = GetPathComponent(rwObj.transform, "Panel/RewardsBG", "Animation")
				anim.wrapMode = WrapMode.Once
				anim:Play("DrawList")
				self.rewards[obj.index] = rwObj
			elseif obj.eType == EventConst.onRelease then
				DestroyObject(self.rewards[obj.index])
			end
		end
        
		for i = 1, 31 do
			local day = GetGameObject(self.grid.transform, "Day"..i)
			if day ~= nil then
				day:SetActive(true);
                self.days[i] = day
                if (tonumber(i) <= tonumber(self.daysCount)) then
				    local wordObj = CreateObjectByPath("UI/SignInDay", AssetBundleInfo.assetBundles)
				    wordObj.name = "SignInDay"
				    local num = GetPathComponent(wordObj.transform, "Num", "UILabel")
				    num.text = i
				    ViewUtil.sortLayerOrder(wordObj, LayerName.UI)
				    HangObject(wordObj, day)

				    local num = tonumber(daysInfo[i])
				    if num == 1 then
						self.signedDays = self.signedDays + 1
					    local signed = CreateObjectByPath("UI/SignIned", AssetBundleInfo.assetBundles)
					    signed.name = "SignIned"
					    HangObject(signed, day)
				    end
                end
			end
		end
		self.signAmount.text = self.signedDays
	end

    local tabIdx = self.data.code + 1;
    tabIdx = (tabIdx > #SignInDataProxy.signInCfg) and #SignInDataProxy.signInCfg or tabIdx;
    self:showSumSignRwd(tabIdx);
    self:chgeTabShow(tabIdx);
    
    local totalCnt, sumSignCnt = self:getSumSignCnts();
    self:checkRwd(totalCnt, sumSignCnt);
    self:setSignBtnState();

    self:showHintPoint()
end

--[[

]]
function SignInView:chgeTabShow (idx)
    GetComponent(self.btnTabs[idx], "UIToggle").value = true;
end

--[[

]]
function SignInView:getSumRwd ()
    local totalDays, sumDays = self:getSumSignCnts();
    local needDays = SignInDataProxy.signInCfg[self.curIdx][2];
    local mapData, buf = Map.new(), nil;
    
    needDays = (0 == needDays) and totalDays or needDays;

    if (needDays > sumDays) then
        ViewUtil.showMsg(const_lackOfSumDays);
        return ;
    end
    
    buf = Network.reqParamEncode(mapData);
    NetManager:SendData(self, buf, ServerID.SignInSumRwd, nil, function (sd) self:getSumRwdSuccess(sd); end, "", doNthFunc)
end

--[[
    判断是否可领取当前的累计领奖
]]
function SignInView:canGetSumRwd ()
    local totalDays, sumDays = self:getSumSignCnts();
    local needDays = 0;
    local canGet = true;

    needDays = SignInDataProxy.signInCfg[self.curIdx][2];
    needDays = (0 == needDays) and totalDays or needDays;

    if (needDays > sumDays) then
        canGet = false;
    end

    return canGet;
end

--[[

]]
function SignInView:getSumRwdSuccess (sd)
    local defData = nil;
    local tabIdx = 0;
    local totalCnt, sumCnt = 0, 0;

    defData = GetProtoTable("DefaultData", sd);
    if (0 ~= defData.code) then
        ViewUtil.showMsg(GetWord(defData.code));
        return ;
    end
    ViewUtil.showMsg(const_getSuccess);
    self.data.code = self.data.code + 1;
    self.data.code = (self.data.code > #SignInDataProxy.signInCfg) and #SignInDataProxy.signInCfg or self.data.code;

    tabIdx = self.data.code + 1;
    tabIdx = (tabIdx > #SignInDataProxy.signInCfg) and #SignInDataProxy.signInCfg or tabIdx;
    self:showSumSignRwd(tabIdx);
    self:chgeTabShow(tabIdx);
    totalCnt, sumCnt = self:getSumSignCnts();
    self:checkRwd(totalCnt, sumCnt);

    self:showHintPoint()
end

--[[
    获取当月总天数、签到总天数
]]
function SignInView:getSumSignCnts ()
    local totalDays, sumDays = 0, 0;
    local tabs = nil;
    local curSysTime = PlayerData.getCurSysTime();
    local tmpTime = PlayerData.getCurTimeStr(curSysTime);
    local tmp, year, month = tmpTime[1], tmpTime[2], tmpTime[3];
    
    if (nil == self.data) then
        return ;
    end
    tabs = StrSplit(self.data.msg, ",");
    for i = 1, #tabs do
        if ("" ~= Trim(tabs[i])) then
            if (1 == tonumber(Trim(tabs[i]))) then
                sumDays = sumDays + 1;
            end
        end
    end
    
    totalDays = PlayerData.getTotalDaysOfMonth(year, month);
    
    return totalDays, sumDays;
end

--[[
    同步签到状态
    _totalCnt number 当月总天数
    _sumCnt number 当前累计签到天数
]]
function SignInView:checkRwd (_totalCnt, _sumCnt)
    local rwdStatus = false;
    local needDays = 0;

    for i = self.data.code + 1, #SignInDataProxy.signInCfg do
        needDays = SignInDataProxy.signInCfg[i][2];
        needDays = (0 == needDays) and _totalCnt or needDays;
        if (_sumCnt >= needDays) then
            rwdStatus = true;
            break ;
        end
    end
    if (self:canGetSumRwd()) then
	    Util.EnableButton(self.btnGet, ButtonState.Normal, true);
    else
        Util.EnableButton(self.btnGet, ButtonState.Disabled, false);
    end
    GetPathComponent(self.btnGet.transform, "Animation/Title", "UISprite").spriteName = const_get;
    --已领取状态标识
    if (self.curIdx <= self.data.code) then
        GetPathComponent(self.btnGet.transform, "Animation/Title", "UISprite").spriteName = const_got;
        Util.EnableButton(self.btnGet, ButtonState.Disabled, false);
    end

    PlayerData.playerData.status.sign = rwdStatus;
    Facade:sendNotification(MVCConst.SHOWREDICON, {});
end

--[[
    判断今天的签到状态
    return boolean true，已签到；false，未签到
]]
function SignInView:checkTadaysSignStatus ()
    local isSign = false;
    local signInfo = nil;
    local dayOfMtn = 0;

    if (nil == self.data) then
        return isSign;
    end

    signInfo = StrSplit(self.data.msg, ",");
    dayOfMtn = PlayerData.getCurTimeStr(PlayerData.getCurSysTime())[4];
    
    isSign = (tonumber(signInfo[dayOfMtn]) == 1) and true or false;

    return isSign;
end

function SignInView:showHintPoint()
    for i = 1, #self.tabRedIcons do
        local totalDays, sumDays = self:getSumSignCnts();
        local needDays = 0;
        local canGet = true;
        needDays = SignInDataProxy.signInCfg[i][2];
        needDays = (0 == needDays) and totalDays or needDays;
        if (needDays > sumDays) then
            canGet = false;
        end

        if (canGet and i >= (self.data.code + 1)) then
            self.tabRedIcons[i]:SetActive(true)
        else
            self.tabRedIcons[i]:SetActive(false)
        end
    end
end