require "Game/SortCond/View/SortCondView"
 
SortCondControler = {}

local this = SortCondControler

function SortCondControler.New()
	return this
end

function SortCondControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = SortCondView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)

	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
end

function SortCondControler.Awake()
end

function SortCondControler.Start()
	this.view:Start(this.data)
end

function SortCondControler.Update()
end

function SortCondControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
end

function SortCondControler.initListener()
end

function SortCondControler.listNotificationInterests()
    local list = {
        MVCConst.ON_RECV_DATA,
        MVCConst.HERO_SORTCHOSEOPEN
    }
    return unpack(list)
end

function SortCondControler.handleNotification(note)
    local nName, nBody, nType = nil, nil, nil;

    nName = note:getName();
    nBody = note:getBody();
    nType = note:getType();

    if (MVCConst.HERO_SORTCHOSEOPEN == nName) then
        this.showSortPane(nBody);
	else
        this.showSortPane(nBody);
    end
end

--[[
    _obj 
    return nil
]]
function SortCondControler.showSortPane (_obj)
    local moduleName, showType, hId = nil, 0, 0;

    moduleName = _obj[1];

    if (ModuleName.TJ == moduleName) then
        showType = _obj[2];
        this.view.btn02:SetActive(false);
        this.view.btn03:SetActive(false);
        this.view.btn04:SetActive(false);
        this.view.btn05.transform.localPosition = this.view.btn02.transform.localPosition;
        this.view:sortTypeShow(showType);
	elseif (ModuleName.HC == moduleName) then
        showType = _obj[2];
--		GetGameObject(this.view.transform, "Mode/Center/Panel/sortCond"):SetActive(false);
        this.view.btn01:SetActive(true);
        this.view.btn02:SetActive(true);
        this.view.btn03:SetActive(true);
        this.view.btn04:SetActive(true);
        this.view.btn05:SetActive(false);
        this.view:sortTypeShow(showType);
	elseif (ModuleName.MH == moduleName) then
        showType = _obj[2];
        this.view.btn01:SetActive(true);
        this.view.btn02:SetActive(true);
        this.view.btn03:SetActive(true);
        this.view.btn04:SetActive(true);
        this.view.btn05:SetActive(false);
        this.view:sortTypeShow(showType);
    end
end

function SortCondControler.accept(data)
	ViewUtil.initData(this, data)
end
