
SpaceView = class(BaseView)

function SpaceView:ctor()
end  

function SpaceView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.fbData = Config.getFBData()
	self.cellH = 120
	self:initPanel()
end

function SpaceView:Start(data)
end

function SpaceView:OnFocus()
	self:initData()
end

function SpaceView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)
	
	local topPath = "Mode/Top/Panel"
	self.topPanel = GetGameObject(self.transform, topPath)

	local centerPath = "Mode/Center/Panel"
	self.scvBG = GetGameObject(self.transform, centerPath.."/ScrollBG")
	self.scvObj = GetGameObject(self.scvBG.transform, "ScrollView")
	self.scv = GetPathComponent(self.scvBG.transform, "ScrollView", "UIScrollView")
	self.gridObj = GetGameObject(self.scvObj.transform, "Panel/Grid")
	self.grid = GetPathComponent(self.scvObj.transform, "Panel/Grid", "UIGrid")
	ViewUtil.adaptUISize(self.scvBG, true, 40, 100, 0, 0)
	ViewUtil.adaptUISize(self.scvObj, false, 40, 100, 0, 0)
	
	local bottomPath = "Mode/Bottom/Panel/"
	self.btnBack = GetGameObject(self.transform, bottomPath.."BtnBack")

    local function _doClick(obj)
		if obj == self.btnBack then
			self:closeView(true)
			if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = _doClick
	ViewUtil.AddClickEvent(self.btnBack, _doClick)
end

function SpaceView:initData(data)
	DestroyChildren(self.gridObj)
	FBData.showChapterTips(false)
	
	local hu = FBData.GetHangUpGate()
	local lastChapter = FBData.GetLastChapterId()
	local cloud = CreateObjectByPath("UI/SpaceCloud", AssetBundleInfo.assetBundles)
	local power = GetPathComponent(cloud.transform, "Panel/Power", "UILabel")
	local curChapter = FBData.GetCurChapterId() -- hu.chapterId
    local function _doClick(obj)
		local key = tonumber(obj.name) - 100
		if key > 0 then
			FBData.SetCurChapterId(key)
			FBData.SetCurHardLevel(1)
			if hu.chapterId == FBData.GetCurChapterId() and hu.hardLevel == FBData.GetCurHardLevel() then
				FBData.SetCurHouseId(hu.houseId)
			else
				FBData.SetCurHouseId(0)
			end
		end
--		local last = FBData.GetLastChapterId()
--		if FBData.checkPower() then
--			if key < last then
--				FBData.SetCurHardLevel2(3)
--			else
--				FBData.SetCurHardLevel(1)
--			end
--			if hu.chapterId == FBData.GetCurChapterId() 
--			and hu.hardLevel == FBData.GetCurHardLevel() then
--				FBData.SetCurHouseId(hu.houseId)
--			else
--				FBData.SetCurHouseId(0)
--			end
--		end
		ViewUtil.goto(ModuleName.FB)
    end

	local extra = 5
	local limit = lastChapter
--	for i = 1, lastChapter do -- ս㲻
--		if not FBData.checkPower(FBData.GetChapterIdRPC2(i)) then
--			extra = extra - (lastChapter - i + 1)
--			break
--		end
--	end
	limit = limit + extra
--	plog("#### lastChapter = %d, extra = %d, limit = %d", lastChapter, extra, limit)
	
	for i = 1, FBData.maxChapterNum do
		if i < limit then
			local fbId = FBData.GetChapterIdRPC2(i)
			local maxLevel = FBData.GetMaxHardLevel(fbId)
			local rpcLevel = FBData.GetHardLevelRPC(fbId)
--			plog("#### fbId = %d, maxLevel = %d, rpcLevel = %d, lastChapter = %d", fbId, maxLevel, rpcLevel, lastChapter)
			local key = tostring(fbId)
			local data = self.fbData[key]
			local char = CreateObject(Util.LoadPrefab("UI/BarChapter", AssetBundleInfo.assetBundles))
			char.name = key
			HangObject(char, self.gridObj)
			-- UIEventListener.Get(char).onClick = _doClick
			ViewUtil.AddClickEvent(char, _doClick)

			local chapter = GetPathComponent(char.transform, "Chapter", "AidImages")
			chapter.text = NumToWord(i)
--			local content = GetPathComponent(char.transform, "Title", "UISprite")
--			content.spriteName = data["#chapterName"]
			local content = GetPathComponent(char.transform, "Title", "UILabel")
			content.text = data["dungeons_name"]

			local stars = {}
			stars[1] = GetGameObject(char.transform, "Grid/Star1")
			stars[2] = GetGameObject(char.transform, "Grid/Star2")
			stars[3] = GetGameObject(char.transform, "Grid/Star3")
			for n = 1, #stars do
				local star = stars[n]
				if n > maxLevel then
					star:SetActive(false)
				else
					star:SetActive(true)
				end
				local starSpr = GetComponent(star.transform, "UISprite")
				if starSpr then
					if n < rpcLevel then
						starSpr.spriteName = "starLight"
					else
						starSpr.spriteName = "starGrey"
					end
				end
			end
			
			if i <= lastChapter then
				power.text = LogicUtil.getShowNum(FBData.GetChapterPower(key + 1))
				HangObject(cloud, char)
				Util.EnableButton2D(char, ButtonState.Normal, true)
				if i == FBData.maxChapterNum then
					DestroyObject(cloud)
				end
				if i == curChapter then
					Util.EnableButton2D(char, ButtonState.Pressed, false)
				end
			else
				Util.EnableButton2D(char, ButtonState.Disabled, false)
			end

			ViewUtil.sortLayerOrder(char, LayerName.UI)
		end
	end
	ViewUtil.sortLayerOrder(self.topPanel, LayerName.UI)
	ResetGrid(self.gridObj)
	ResetScrollView(self.scvObj)
	local deltaY = self.cellH * (curChapter - 1)
	self.scv:MoveRelative(Vector3.New(0, deltaY, 0))
end
