require "Game/WorldBattle/View/WorldBattleView"
 
WorldBattleControler = {}

local this = WorldBattleControler

function WorldBattleControler.New()
	return this
end

function WorldBattleControler.OnCreate(obj, name)
	this.root = ViewUtil.getRootView()
	this.view = WorldBattleView.new()
	this.view.name = name
	this.gameObject = obj
	this.transform = obj.transform
	HangObject(obj, this.root)
	
	this.luaBehaviour = this.transform:GetComponent('LuaBehaviour')
	this.view:Awake(this.gameObject)
    this.initListener()
	UpdateHelper.addUpdate(this.Update)
	this.request()
end

function WorldBattleControler.Awake()
end

function WorldBattleControler.Start()
	this.view:Start()
end

function WorldBattleControler.Update()
	this.view:Update()
end

function WorldBattleControler.OnDestroy()
	UpdateHelper.removeUpdate(this.Update)
	this.root = nil
	this.view = nil
	this.gameObject = nil
	this.transform = nil
	this.luaBehaviour = nil
    this.data = nil;
end

function WorldBattleControler.initListener()
end

function WorldBattleControler.listNotificationInterests()
    local list = {MVCConst.ON_RECV_DATA}
    return unpack(list)
end

function WorldBattleControler.handleNotification(notification)
--	plog("Notification = " .. notification:getName()..", Module = "..notification:getBody().name)
end

function WorldBattleControler.request()
	Network.SendMoData(ServerID.WB, {}, function(session, params)
		local serviceId = tonumber(session.serviceId)
		local mo = GetProtoTable("FunzionMainData", session)
		this.accept(mo)
	end, {})
end

function WorldBattleControler.accept(data)
	ViewUtil.initData(this, data)
end
