local const_rulesInfo = "              规则\n每次挑战胜利都将获得“时空碎片*1”\n1胜：刷新时间内，累计战胜1名玩家将额外获得“时空碎片*2”\n4胜：刷新时间内，累计战胜1名玩家将获得“时空碎片*8”\n10胜：刷新时间内，累计战胜1名玩家将获得“时空碎片*16”\n（每天第1次10胜，将额外获得“王者勋章*2”）";
local const_costMny = "本次刷新需要消耗 {1} 血钻，确定吗？";
local _victoryMsgs = {}
local const_comShopPane = "UI/ComShopPane";

WorldBattleView = class(BaseView)

 function WorldBattleView:ctor()
end  

function WorldBattleView:Awake(obj)
	self.gameObject = obj
	self.transform = obj.transform
	self.refreshSeconds = 0
	self.countVictory = 0
	self:initPanel()
end

function WorldBattleView:Start(data)
end

function WorldBattleView:initPanel()
 	self.top = GetPathComponent(self.transform, "Mode/Top", "UIWidget")
 	self.bottom = GetPathComponent(self.transform, "Mode/Bottom", "UIWidget")
	self.top:SetAnchor(self.root.transform)
	self.bottom:SetAnchor(self.root.transform)

	local topPath = "Mode/Top/Panel"
	self.scvBG = GetGameObject(self.transform, topPath.."/ScrollBG")
	self.scvObj = GetGameObject(self.transform, topPath.."/ScrollBG/ScrollView")
	self.scvBGSpr = GetComponent(self.scvBG.transform, "UISprite")
	self.gridObj = GetGameObject(self.scvObj.transform, "Panel/Grid")
	self.uiGrid = GetComponent(self.gridObj.transform, "UIGrid")
	self.challengeTimes = GetPathComponent(self.transform, topPath.."/InfoBG/ChallengeTimes", "UILabel")
	self.challengeCD = GetPathComponent(self.transform, topPath.."/InfoBG/ChallengeCD", "UILabel")
	self.btnRefresh = GetGameObject(self.transform, topPath.."/InfoBG/BtnRefresh")
	self.btnInfo = GetGameObject(self.transform, topPath.."/InfoBG/BtnInfo")
	self.sprInfo = GetGameObject(self.transform, topPath.."/InfoBG/BtnInfo/Normal")

	ViewUtil.adaptUISize(self.scvBG, true, 140, 162, 20, 20)
	ViewUtil.adaptUISize(self.scvObj, false, 140, 162, 20, 20)
		
	local bottomPath = "Mode/Bottom/Panel"
	self.btnBack = GetGameObject(self.transform, bottomPath.."/BtnBack")
	self.victoryBar = GetGameObject(self.transform, bottomPath.."/VictoryBar")
	self.winBar = GetComponent(self.victoryBar.transform, "UIProgressBar")
    self.btnExchange = GetGameObject(self.transform, bottomPath .. "/BtnExchange");

	self.drawer = CreateObjectByPath("UI/DrawerWF", AssetBundleInfo.assetBundles)
	self.animDrawer = GetComponent(self.drawer.transform, "UIPlayAnimation")
    self.detailContent = GetGameObject(self.drawer.transform, "Panel/Animation/BG/Content");
    GetComponent(self.detailContent, "UILabel").text = const_rulesInfo;
	HangObject(self.drawer, self.sprInfo)
	self.drawer.transform.localPosition = Vector3.New(20, -40, 0)
	ViewUtil.sortLayerOrder(self.drawer, LayerName.UI)

    local function doClick(obj)
		if obj == self.btnBack then
			ViewUtil.openView(ModuleName.PVP)
		elseif obj == self.btnRefresh then
            ViewUtil.comCfmPanel(string.gsub(const_costMny, "{1}", 100), function()
				Network.SendMoData(ServerID.WBRefresh, {}, function(session, params)
--					local serviceId = tonumber(session.serviceId)
--					local mo = GetProtoTable("Funzion_Fight_Refresh_Diamonds ", session)
					WorldBattleControler.request()
				end, {})
			end)
		elseif obj == self.btnInfo then
			self.showTips = (not self.showTips) and true or false
			self.animDrawer:Play(self.showTips)
			
			if (not (GuideControler and GuideControler.isGuideShowing())) then
				self.fullScreenPane = ViewUtil.showScreenMask()
				GetPathComponent(self.fullScreenPane.transform, "BG", "UISprite").spriteName = "alpha"
				ViewUtil.AddClickEvent(self.fullScreenPane, function () 
					self.showTips = (not self.showTips) and true or false
	                self.animDrawer:Play(self.showTips)
	                DestroyObject(self.fullScreenPane);

	                if (PlayerData.guideNotEnd()) then
	                    Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
	                end
	            end)
			end

			if (PlayerData.guideNotEnd()) then
                if (GuideControler and GuideControler.isGuideShowing()) then
			        self.animDrawer:Play(not self.showTips);
                end
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
        elseif (obj == self.btnExchange) then
            self:getShop();
        elseif (obj == self.victoryBar) then
            if (PlayerData.guideNotEnd()) then
                Facade:sendNotification(MVCConst.GUIDE_NEXT, {});
            end
		end
    end
	-- UIEventListener.Get(self.btnBack).onClick = doClick
	-- UIEventListener.Get(self.btnRefresh).onClick = doClick
	-- UIEventListener.Get(self.btnInfo).onClick = doClick
	ViewUtil.AddClickEvent(self.btnBack, doClick)
	ViewUtil.AddClickEvent(self.btnRefresh, doClick)
	ViewUtil.AddClickEvent(self.btnInfo, doClick)
    ViewUtil.AddClickEvent(self.btnExchange, doClick);
    ViewUtil.AddClickEvent(self.victoryBar, doClick);
	
--    local function doDrawer(tbl)
--		if tbl.eType == EventConst.onPress then
--			self.animDrawer:Play(true)
--		elseif tbl.eType == EventConst.onRelease then
--			self.animDrawer:Play(false)
--		end
--	end
--	ViewUtil.AddEventTrigger(self.btnInfo, EventConst.onPress, doDrawer, {eType = EventConst.onPress})
--	ViewUtil.AddEventTrigger(self.btnInfo, EventConst.onRelease, doDrawer, {eType = EventConst.onRelease})
end

--[[

]]
function WorldBattleView:getShop ()
    local mapData, buf = Map.new(), nil;

    buf = Network.reqParamEncode(mapData);

    NetManager:SendData(self, buf, ServerID.ShopPkEty, nil, function (sd) self:shopHandle(sd);end, nil, doNthFunc);
end

--[[

]]
function WorldBattleView:shopHandle (sd)
    local mData = nil;--PVPShopMainData
    local csPane = CreateObject(Util.LoadPrefab(const_comShopPane, AssetBundleInfo.assetBundles));
    local csPaneLua = nil;
    
    mData = GetProtoTable("PVPShopMainData", sd);
	HangObject(ViewUtil.CreateShadeView(function(args)end), csPane)
    HangObject(csPane, self.gameObject);
    csPaneLua = ComShopPane.new();
    csPaneLua:Awake(csPane);
    csPaneLua:setData(mData.propList, doNthFunc, doNthFunc);
    PanelManager:BindPanelScript(csPaneLua, csPane, doNthFunc, doNthFunc, doNthFunc, doNthFunc);
    ViewUtil.sortLayerOrder(csPane, LayerName.Dialog);
end

function WorldBattleView:Update()
	self.sumTime = Time.timeSinceLevelLoad
	if not self.preTime or self.preTime <= 0 then
		self.preTime = self.sumTime
	end
	local deltaTime = self.sumTime - self.preTime
	self.preTime = self.sumTime

	self.refreshSeconds = self.refreshSeconds - deltaTime
	self.challengeCD.text = Time2String(self.refreshSeconds)
end

function WorldBattleView:initData(data)
	if IsEmpty(data) then return end
    DestroyChildren(self.gridObj)
	self.countVictory = 0

	self.fightCount = data.fightCount
	self.refreshSeconds = data.refreshSecond
	self.challengeTimes.text = self.fightCount

	self.rivalList = data.opponentsList
	if IsEmpty(self.rivalList) then return end
    
    local function doClick2(obj)
		if self.fightCount <= 0 then
			ViewUtil.showMsg("挑战次数不足")
			return
		end
		local lb = GetComponent(obj.transform, "LuaBehaviour")
		local tbl = lb.sourceLuaObj
        
		Network.ReqWorldBattlePK(tbl.idx - 1)
        if (PlayerData.guideNotEnd()) then
            Facade:sendNotification(MVCConst.GUIDE_SAVEGUIDE, {});
        end
	end

	local size = CountTable(self.rivalList)
	for i = 1, size do
		local info = self.rivalList[i]
		if info.status == 1 then
--			if TeamData.GetPower() > info.power then
				self.countVictory = self.countVictory + 1
--			end
		end
		if not IsEmptyTable(info) and info.teamId ~= PlayerData.GetRoleTeamId() then
			local obj = CreateObject(Util.LoadPrefab("UI/BarHeroWorldFight", AssetBundleInfo.assetBundles))
			local btn = GetGameObject(obj.transform, "Btn")
			if info.status == 1 then
				Util.EnableButton(btn, ButtonState.Disabled, false)
			end
			BindLuaScript({idx = i}, btn)
            
			ViewUtil.addDragScrollView(obj)
			HangObject(obj, self.gridObj)
			ViewUtil.sortLayerOrder(obj, LayerName.UI)
			local heroName = GetPathComponent(obj.transform, "HeroName", "UILabel")
			heroName.text = self.rivalList[i].teamName
			local fightValue = GetPathComponent(obj.transform, "FightValue", "UILabel")
			fightValue.text = self.rivalList[i].power

			-- UIEventListener.Get(btn).onClick = doClick2
			ViewUtil.AddClickEvent(btn, doClick2)
		end
	end
	
	if self.countVictory == 1 then
		if not _victoryMsgs[self.countVictory] then
--			ViewUtil.showMsg("恭喜你获得了首胜, 奖励已发放邮件!")
		end
	elseif self.countVictory == 4 or self.countVictory == 10 then
		if not _victoryMsgs[self.countVictory] then
--			ViewUtil.showMsg("恭喜你获得了"..self.countVictory.."连胜, 奖励已发放邮件!")
		end
	end
	_victoryMsgs[self.countVictory] = true

--	local winRate = (self.countVictory >= 9 and 10 or self.countVictory) / 10
	local winRate = self.countVictory / 10
	if winRate < 0 then winRate = 0 end
	if winRate > 1 then winRate = 1 end
	self.winBar.value = winRate
	ResetGrid(self.gridObj)
	ResetScrollView(self.scvObj)
end
