local tconcat = table.concat
local tinsert = table.insert
local srep = string.rep
local type = type
local pairs = pairs
local tostring = tostring
local next = next

function print_r(root, tips)
	local title = tips or "NoTittle"
	print("[[---------------------------------- "..title)
	if IsEmpty(root) then
		print("----------------------------------]]\n")
		return
	end
	local cache = { [root] = "." }
	local function deal(t, space, name)
		local temp = {}
		for k, v in pairs(t) do
			local key = tostring(k)
			if cache[v] then
				tinsert(temp, "+" .. key .. " [" .. tostring(v) .. "]")
			elseif type(v) == "table" then
				local new_key = name .. "." .. key
				cache[v] = new_key
				tinsert(temp, "+" .. key .. deal(v, space .. (next(t, k) and "|" or " " ) .. srep(" ", #key), new_key))
			else
				if string.find(tips, "tree") ~= nil then
					if type(v) ~= "string" then
						tinsert(temp, "+" .. key .. " [" .. tostring(v) .. "]")
					else
						tinsert(temp, "+" .. key .. " [" .. "type: string" .. "]")
					end
				else
					tinsert(temp, "+" .. key .. " [" .. tostring(v) .. "]")
				end
			end
		end
		return tconcat(temp, "\n" .. space)
	end
	print("\n"..deal(root, "", ""))
	print("----------------------------------]]\n")
end